/**
 * vis-timeline and vis-graph2d
 * https://visjs.github.io/vis-timeline/
 *
 * Create a fully customizable, interactive timeline with items and ranges.
 *
 * @version 7.7.1
 * @date    2023-03-21T17:19:12.331Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
import t from"moment";import{isDataViewLike as e,DataSet as n,createNewDataPipeFrom as o,DataView as r}from"vis-data/peer/esm/vis-data.js";var s="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function a(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var l={},h={get exports(){return l},set exports(t){l=t}},u=function(t){return t&&t.Math==Math&&t},c=u("object"==typeof globalThis&&globalThis)||u("object"==typeof window&&window)||u("object"==typeof self&&self)||u("object"==typeof s&&s)||function(){return this}()||Function("return this")(),d=function(t){try{return!!t()}catch(t){return!0}},p=!d((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),m=p,f=Function.prototype,v=f.apply,g=f.call,y="object"==typeof Reflect&&Reflect.apply||(m?g.bind(v):function(){return g.apply(v,arguments)}),b=p,w=Function.prototype,k=w.call,x=b&&w.bind.bind(k,k),_=b?x:function(t){return function(){return k.apply(t,arguments)}},C=_,S=C({}.toString),D=C("".slice),T=function(t){return D(S(t),8,-1)},O=T,E=_,A=function(t){if("Function"===O(t))return E(t)},I="object"==typeof document&&document.all,P={all:I,IS_HTMLDDA:void 0===I&&void 0!==I},M=P.all,N=P.IS_HTMLDDA?function(t){return"function"==typeof t||t===M}:function(t){return"function"==typeof t},F={},R=!d((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),L=p,j=Function.prototype.call,B=L?j.bind(j):function(){return j.apply(j,arguments)},z={},H={}.propertyIsEnumerable,G=Object.getOwnPropertyDescriptor,W=G&&!H.call({1:2},1);z.f=W?function(t){var e=G(this,t);return!!e&&e.enumerable}:H;var Y,V,U=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},X=d,q=T,K=Object,$=_("".split),Z=X((function(){return!K("z").propertyIsEnumerable(0)}))?function(t){return"String"==q(t)?$(t,""):K(t)}:K,Q=function(t){return null==t},J=Q,tt=TypeError,et=function(t){if(J(t))throw tt("Can't call method on "+t);return t},it=Z,nt=et,ot=function(t){return it(nt(t))},rt=N,st=P.all,at=P.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:rt(t)||t===st}:function(t){return"object"==typeof t?null!==t:rt(t)},lt={},ht=lt,ut=c,ct=N,dt=function(t){return ct(t)?t:void 0},pt=function(t,e){return arguments.length<2?dt(ht[t])||dt(ut[t]):ht[t]&&ht[t][e]||ut[t]&&ut[t][e]},mt=_({}.isPrototypeOf),ft="undefined"!=typeof navigator&&String(navigator.userAgent)||"",vt=c,gt=ft,yt=vt.process,bt=vt.Deno,wt=yt&&yt.versions||bt&&bt.version,kt=wt&&wt.v8;kt&&(V=(Y=kt.split("."))[0]>0&&Y[0]<4?1:+(Y[0]+Y[1])),!V&&gt&&(!(Y=gt.match(/Edge\/(\d+)/))||Y[1]>=74)&&(Y=gt.match(/Chrome\/(\d+)/))&&(V=+Y[1]);var xt=V,_t=xt,Ct=d,St=!!Object.getOwnPropertySymbols&&!Ct((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&_t&&_t<41})),Dt=St&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Tt=pt,Ot=N,Et=mt,At=Object,It=Dt?function(t){return"symbol"==typeof t}:function(t){var e=Tt("Symbol");return Ot(e)&&Et(e.prototype,At(t))},Pt=String,Mt=function(t){try{return Pt(t)}catch(t){return"Object"}},Nt=N,Ft=Mt,Rt=TypeError,Lt=function(t){if(Nt(t))return t;throw Rt(Ft(t)+" is not a function")},jt=Lt,Bt=Q,zt=function(t,e){var i=t[e];return Bt(i)?void 0:jt(i)},Ht=B,Gt=N,Wt=at,Yt=TypeError,Vt={},Ut={get exports(){return Vt},set exports(t){Vt=t}},Xt=c,qt=Object.defineProperty,Kt=function(t,e){try{qt(Xt,t,{value:e,configurable:!0,writable:!0})}catch(i){Xt[t]=e}return e},$t="__core-js_shared__",Zt=c[$t]||Kt($t,{}),Qt=Zt;(Ut.exports=function(t,e){return Qt[t]||(Qt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Jt=et,te=Object,ee=function(t){return te(Jt(t))},ie=ee,ne=_({}.hasOwnProperty),oe=Object.hasOwn||function(t,e){return ne(ie(t),e)},re=_,se=0,ae=Math.random(),le=re(1..toString),he=function(t){return"Symbol("+(void 0===t?"":t)+")_"+le(++se+ae,36)},ue=Vt,ce=oe,de=he,pe=St,me=Dt,fe=c.Symbol,ve=ue("wks"),ge=me?fe.for||fe:fe&&fe.withoutSetter||de,ye=function(t){return ce(ve,t)||(ve[t]=pe&&ce(fe,t)?fe[t]:ge("Symbol."+t)),ve[t]},be=B,we=at,ke=It,xe=zt,_e=function(t,e){var i,n;if("string"===e&&Gt(i=t.toString)&&!Wt(n=Ht(i,t)))return n;if(Gt(i=t.valueOf)&&!Wt(n=Ht(i,t)))return n;if("string"!==e&&Gt(i=t.toString)&&!Wt(n=Ht(i,t)))return n;throw Yt("Can't convert object to primitive value")},Ce=TypeError,Se=ye("toPrimitive"),De=function(t,e){if(!we(t)||ke(t))return t;var i,n=xe(t,Se);if(n){if(void 0===e&&(e="default"),i=be(n,t,e),!we(i)||ke(i))return i;throw Ce("Can't convert object to primitive value")}return void 0===e&&(e="number"),_e(t,e)},Te=It,Oe=function(t){var e=De(t,"string");return Te(e)?e:e+""},Ee=at,Ae=c.document,Ie=Ee(Ae)&&Ee(Ae.createElement),Pe=function(t){return Ie?Ae.createElement(t):{}},Me=Pe,Ne=!R&&!d((function(){return 7!=Object.defineProperty(Me("div"),"a",{get:function(){return 7}}).a})),Fe=R,Re=B,Le=z,je=U,Be=ot,ze=Oe,He=oe,Ge=Ne,We=Object.getOwnPropertyDescriptor;F.f=Fe?We:function(t,e){if(t=Be(t),e=ze(e),Ge)try{return We(t,e)}catch(t){}if(He(t,e))return je(!Re(Le.f,t,e),t[e])};var Ye=d,Ve=N,Ue=/#|\.prototype\./,Xe=function(t,e){var i=Ke[qe(t)];return i==Ze||i!=$e&&(Ve(e)?Ye(e):!!e)},qe=Xe.normalize=function(t){return String(t).replace(Ue,".").toLowerCase()},Ke=Xe.data={},$e=Xe.NATIVE="N",Ze=Xe.POLYFILL="P",Qe=Xe,Je=Lt,ti=p,ei=A(A.bind),ii=function(t,e){return Je(t),void 0===e?t:ti?ei(t,e):function(){return t.apply(e,arguments)}},ni={},oi=R&&d((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),ri=at,si=String,ai=TypeError,li=function(t){if(ri(t))return t;throw ai(si(t)+" is not an object")},hi=R,ui=Ne,ci=oi,di=li,pi=Oe,mi=TypeError,fi=Object.defineProperty,vi=Object.getOwnPropertyDescriptor,gi="enumerable",yi="configurable",bi="writable";ni.f=hi?ci?function(t,e,i){if(di(t),e=pi(e),di(i),"function"==typeof t&&"prototype"===e&&"value"in i&&bi in i&&!i[bi]){var n=vi(t,e);n&&n[bi]&&(t[e]=i.value,i={configurable:yi in i?i[yi]:n[yi],enumerable:gi in i?i[gi]:n[gi],writable:!1})}return fi(t,e,i)}:fi:function(t,e,i){if(di(t),e=pi(e),di(i),ui)try{return fi(t,e,i)}catch(t){}if("get"in i||"set"in i)throw mi("Accessors not supported");return"value"in i&&(t[e]=i.value),t};var wi=ni,ki=U,xi=R?function(t,e,i){return wi.f(t,e,ki(1,i))}:function(t,e,i){return t[e]=i,t},_i=c,Ci=y,Si=A,Di=N,Ti=F.f,Oi=Qe,Ei=lt,Ai=ii,Ii=xi,Pi=oe,Mi=function(t){var e=function(i,n,o){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(i);case 2:return new t(i,n)}return new t(i,n,o)}return Ci(t,this,arguments)};return e.prototype=t.prototype,e},Ni=function(t,e){var i,n,o,r,s,a,l,h,u,c=t.target,d=t.global,p=t.stat,m=t.proto,f=d?_i:p?_i[c]:(_i[c]||{}).prototype,v=d?Ei:Ei[c]||Ii(Ei,c,{})[c],g=v.prototype;for(r in e)n=!(i=Oi(d?r:c+(p?".":"#")+r,t.forced))&&f&&Pi(f,r),a=v[r],n&&(l=t.dontCallGetSet?(u=Ti(f,r))&&u.value:f[r]),s=n&&l?l:e[r],n&&typeof a==typeof s||(h=t.bind&&n?Ai(s,_i):t.wrap&&n?Mi(s):m&&Di(s)?Si(s):s,(t.sham||s&&s.sham||a&&a.sham)&&Ii(h,"sham",!0),Ii(v,r,h),m&&(Pi(Ei,o=c+"Prototype")||Ii(Ei,o,{}),Ii(Ei[o],r,s),t.real&&g&&(i||!g[r])&&Ii(g,r,s)))},Fi=_([].slice),Ri=_,Li=Lt,ji=at,Bi=oe,zi=Fi,Hi=p,Gi=Function,Wi=Ri([].concat),Yi=Ri([].join),Vi={},Ui=function(t,e,i){if(!Bi(Vi,e)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";Vi[e]=Gi("C,a","return new C("+Yi(n,",")+")")}return Vi[e](t,i)},Xi=Hi?Gi.bind:function(t){var e=Li(this),i=e.prototype,n=zi(arguments,1),o=function(){var i=Wi(n,zi(arguments));return this instanceof o?Ui(e,i.length,i):e.apply(t,i)};return ji(i)&&(o.prototype=i),o},qi={};qi[ye("toStringTag")]="z";var Ki="[object z]"===String(qi),$i=Ki,Zi=N,Qi=T,Ji=ye("toStringTag"),tn=Object,en="Arguments"==Qi(function(){return arguments}()),nn=$i?Qi:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=tn(t),Ji))?i:en?Qi(e):"Object"==(n=Qi(e))&&Zi(e.callee)?"Arguments":n},on=N,rn=Zt,sn=_(Function.toString);on(rn.inspectSource)||(rn.inspectSource=function(t){return sn(t)});var an=rn.inspectSource,ln=_,hn=d,un=N,cn=nn,dn=an,pn=function(){},mn=[],fn=pt("Reflect","construct"),vn=/^\s*(?:class|function)\b/,gn=ln(vn.exec),yn=!vn.exec(pn),bn=function(t){if(!un(t))return!1;try{return fn(pn,mn,t),!0}catch(t){return!1}},wn=function(t){if(!un(t))return!1;switch(cn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return yn||!!gn(vn,dn(t))}catch(t){return!0}};wn.sham=!0;var kn=!fn||hn((function(){var t;return bn(bn.call)||!bn(Object)||!bn((function(){t=!0}))||t}))?wn:bn,xn=kn,_n=Mt,Cn=TypeError,Sn={},Dn=Math.ceil,Tn=Math.floor,On=Math.trunc||function(t){var e=+t;return(e>0?Tn:Dn)(e)},En=function(t){var e=+t;return e!=e||0===e?0:On(e)},An=En,In=Math.max,Pn=Math.min,Mn=function(t,e){var i=An(t);return i<0?In(i+e,0):Pn(i,e)},Nn=En,Fn=Math.min,Rn=function(t){return t>0?Fn(Nn(t),9007199254740991):0},Ln=function(t){return Rn(t.length)},jn=ot,Bn=Mn,zn=Ln,Hn=function(t){return function(e,i,n){var o,r=jn(e),s=zn(r),a=Bn(n,s);if(t&&i!=i){for(;s>a;)if((o=r[a++])!=o)return!0}else for(;s>a;a++)if((t||a in r)&&r[a]===i)return t||a||0;return!t&&-1}},Gn={includes:Hn(!0),indexOf:Hn(!1)},Wn={},Yn=oe,Vn=ot,Un=Gn.indexOf,Xn=Wn,qn=_([].push),Kn=function(t,e){var i,n=Vn(t),o=0,r=[];for(i in n)!Yn(Xn,i)&&Yn(n,i)&&qn(r,i);for(;e.length>o;)Yn(n,i=e[o++])&&(~Un(r,i)||qn(r,i));return r},$n=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Zn=Kn,Qn=$n,Jn=Object.keys||function(t){return Zn(t,Qn)},to=R,eo=oi,io=ni,no=li,oo=ot,ro=Jn;Sn.f=to&&!eo?Object.defineProperties:function(t,e){no(t);for(var i,n=oo(e),o=ro(e),r=o.length,s=0;r>s;)io.f(t,i=o[s++],n[i]);return t};var so,ao=pt("document","documentElement"),lo=he,ho=Vt("keys"),uo=function(t){return ho[t]||(ho[t]=lo(t))},co=li,po=Sn,mo=$n,fo=Wn,vo=ao,go=Pe,yo="prototype",bo="script",wo=uo("IE_PROTO"),ko=function(){},xo=function(t){return"<"+bo+">"+t+"</"+bo+">"},_o=function(t){t.write(xo("")),t.close();var e=t.parentWindow.Object;return t=null,e},Co=function(){try{so=new ActiveXObject("htmlfile")}catch(t){}var t,e,i;Co="undefined"!=typeof document?document.domain&&so?_o(so):(e=go("iframe"),i="java"+bo+":",e.style.display="none",vo.appendChild(e),e.src=String(i),(t=e.contentWindow.document).open(),t.write(xo("document.F=Object")),t.close(),t.F):_o(so);for(var n=mo.length;n--;)delete Co[yo][mo[n]];return Co()};fo[wo]=!0;var So=Object.create||function(t,e){var i;return null!==t?(ko[yo]=co(t),i=new ko,ko[yo]=null,i[wo]=t):i=Co(),void 0===e?i:po.f(i,e)},Do=Ni,To=y,Oo=Xi,Eo=function(t){if(xn(t))return t;throw Cn(_n(t)+" is not a constructor")},Ao=li,Io=at,Po=So,Mo=d,No=pt("Reflect","construct"),Fo=Object.prototype,Ro=[].push,Lo=Mo((function(){function t(){}return!(No((function(){}),[],t)instanceof t)})),jo=!Mo((function(){No((function(){}))})),Bo=Lo||jo;Do({target:"Reflect",stat:!0,forced:Bo,sham:Bo},{construct:function(t,e){Eo(t),Ao(e);var i=arguments.length<3?t:Eo(arguments[2]);if(jo&&!Lo)return No(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return To(Ro,n,e),new(To(Oo,t,n))}var o=i.prototype,r=Po(Io(o)?o:Fo),s=To(t,r,e);return Io(s)?s:r}});var zo=lt.Reflect.construct;h.exports=zo;var Ho=a(l);function Go(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var Wo={},Yo={get exports(){return Wo},set exports(t){Wo=t}},Vo={},Uo={get exports(){return Vo},set exports(t){Vo=t}},Xo={},qo={get exports(){return Xo},set exports(t){Xo=t}},Ko=Ni,$o=R,Zo=ni.f;Ko({target:"Object",stat:!0,forced:Object.defineProperty!==Zo,sham:!$o},{defineProperty:Zo});var Qo=lt.Object,Jo=qo.exports=function(t,e,i){return Qo.defineProperty(t,e,i)};Qo.defineProperty.sham&&(Jo.sham=!0);var tr=Xo,er=tr;Uo.exports=er,Yo.exports=Vo;var ir=a(Wo),nr={},or={get exports(){return nr},set exports(t){nr=t}},rr={},sr={get exports(){return rr},set exports(t){rr=t}},ar=T,lr=Array.isArray||function(t){return"Array"==ar(t)},hr=TypeError,ur=function(t){if(t>9007199254740991)throw hr("Maximum allowed index exceeded");return t},cr=Oe,dr=ni,pr=U,mr=function(t,e,i){var n=cr(e);n in t?dr.f(t,n,pr(0,i)):t[n]=i},fr=lr,vr=kn,gr=at,yr=ye("species"),br=Array,wr=function(t){var e;return fr(t)&&(e=t.constructor,(vr(e)&&(e===br||fr(e.prototype))||gr(e)&&null===(e=e[yr]))&&(e=void 0)),void 0===e?br:e},kr=function(t,e){return new(wr(t))(0===e?0:e)},xr=d,_r=xt,Cr=ye("species"),Sr=function(t){return _r>=51||!xr((function(){var e=[];return(e.constructor={})[Cr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Dr=Ni,Tr=d,Or=lr,Er=at,Ar=ee,Ir=Ln,Pr=ur,Mr=mr,Nr=kr,Fr=Sr,Rr=xt,Lr=ye("isConcatSpreadable"),jr=Rr>=51||!Tr((function(){var t=[];return t[Lr]=!1,t.concat()[0]!==t})),Br=function(t){if(!Er(t))return!1;var e=t[Lr];return void 0!==e?!!e:Or(t)};Dr({target:"Array",proto:!0,arity:1,forced:!jr||!Fr("concat")},{concat:function(t){var e,i,n,o,r,s=Ar(this),a=Nr(s,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(Br(r=-1===e?s:arguments[e]))for(o=Ir(r),Pr(l+o),i=0;i<o;i++,l++)i in r&&Mr(a,l,r[i]);else Pr(l+1),Mr(a,l++,r);return a.length=l,a}});var zr=nn,Hr=String,Gr=function(t){if("Symbol"===zr(t))throw TypeError("Cannot convert a Symbol value to a string");return Hr(t)},Wr={},Yr=Kn,Vr=$n.concat("length","prototype");Wr.f=Object.getOwnPropertyNames||function(t){return Yr(t,Vr)};var Ur={},Xr=Mn,qr=Ln,Kr=mr,$r=Array,Zr=Math.max,Qr=function(t,e,i){for(var n=qr(t),o=Xr(e,n),r=Xr(void 0===i?n:i,n),s=$r(Zr(r-o,0)),a=0;o<r;o++,a++)Kr(s,a,t[o]);return s.length=a,s},Jr=T,ts=ot,es=Wr.f,is=Qr,ns="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ur.f=function(t){return ns&&"Window"==Jr(t)?function(t){try{return es(t)}catch(t){return is(ns)}}(t):es(ts(t))};var os={};os.f=Object.getOwnPropertySymbols;var rs=xi,ss=function(t,e,i,n){return n&&n.enumerable?t[e]=i:rs(t,e,i),t},as=ni,ls=function(t,e,i){return as.f(t,e,i)},hs={},us=ye;hs.f=us;var cs,ds,ps,ms=lt,fs=oe,vs=hs,gs=ni.f,ys=function(t){var e=ms.Symbol||(ms.Symbol={});fs(e,t)||gs(e,t,{value:vs.f(t)})},bs=B,ws=pt,ks=ye,xs=ss,_s=function(){var t=ws("Symbol"),e=t&&t.prototype,i=e&&e.valueOf,n=ks("toPrimitive");e&&!e[n]&&xs(e,n,(function(t){return bs(i,this)}),{arity:1})},Cs=nn,Ss=Ki?{}.toString:function(){return"[object "+Cs(this)+"]"},Ds=Ki,Ts=ni.f,Os=xi,Es=oe,As=Ss,Is=ye("toStringTag"),Ps=function(t,e,i,n){if(t){var o=i?t:t.prototype;Es(o,Is)||Ts(o,Is,{configurable:!0,value:e}),n&&!Ds&&Os(o,"toString",As)}},Ms=N,Ns=c.WeakMap,Fs=Ms(Ns)&&/native code/.test(String(Ns)),Rs=c,Ls=at,js=xi,Bs=oe,zs=Zt,Hs=uo,Gs=Wn,Ws="Object already initialized",Ys=Rs.TypeError,Vs=Rs.WeakMap;if(Fs||zs.state){var Us=zs.state||(zs.state=new Vs);Us.get=Us.get,Us.has=Us.has,Us.set=Us.set,cs=function(t,e){if(Us.has(t))throw Ys(Ws);return e.facade=t,Us.set(t,e),e},ds=function(t){return Us.get(t)||{}},ps=function(t){return Us.has(t)}}else{var Xs=Hs("state");Gs[Xs]=!0,cs=function(t,e){if(Bs(t,Xs))throw Ys(Ws);return e.facade=t,js(t,Xs,e),e},ds=function(t){return Bs(t,Xs)?t[Xs]:{}},ps=function(t){return Bs(t,Xs)}}var qs={set:cs,get:ds,has:ps,enforce:function(t){return ps(t)?ds(t):cs(t,{})},getterFor:function(t){return function(e){var i;if(!Ls(e)||(i=ds(e)).type!==t)throw Ys("Incompatible receiver, "+t+" required");return i}}},Ks=ii,$s=Z,Zs=ee,Qs=Ln,Js=kr,ta=_([].push),ea=function(t){var e=1==t,i=2==t,n=3==t,o=4==t,r=6==t,s=7==t,a=5==t||r;return function(l,h,u,c){for(var d,p,m=Zs(l),f=$s(m),v=Ks(h,u),g=Qs(f),y=0,b=c||Js,w=e?b(l,g):i||s?b(l,0):void 0;g>y;y++)if((a||y in f)&&(p=v(d=f[y],y,m),t))if(e)w[y]=p;else if(p)switch(t){case 3:return!0;case 5:return d;case 6:return y;case 2:ta(w,d)}else switch(t){case 4:return!1;case 7:ta(w,d)}return r?-1:n||o?o:w}},ia={forEach:ea(0),map:ea(1),filter:ea(2),some:ea(3),every:ea(4),find:ea(5),findIndex:ea(6),filterReject:ea(7)},na=Ni,oa=c,ra=B,sa=_,aa=R,la=St,ha=d,ua=oe,ca=mt,da=li,pa=ot,ma=Oe,fa=Gr,va=U,ga=So,ya=Jn,ba=Wr,wa=Ur,ka=os,xa=F,_a=ni,Ca=Sn,Sa=z,Da=ss,Ta=ls,Oa=Vt,Ea=Wn,Aa=he,Ia=ye,Pa=hs,Ma=ys,Na=_s,Fa=Ps,Ra=qs,La=ia.forEach,ja=uo("hidden"),Ba="Symbol",za="prototype",Ha=Ra.set,Ga=Ra.getterFor(Ba),Wa=Object[za],Ya=oa.Symbol,Va=Ya&&Ya[za],Ua=oa.TypeError,Xa=oa.QObject,qa=xa.f,Ka=_a.f,$a=wa.f,Za=Sa.f,Qa=sa([].push),Ja=Oa("symbols"),tl=Oa("op-symbols"),el=Oa("wks"),il=!Xa||!Xa[za]||!Xa[za].findChild,nl=aa&&ha((function(){return 7!=ga(Ka({},"a",{get:function(){return Ka(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=qa(Wa,e);n&&delete Wa[e],Ka(t,e,i),n&&t!==Wa&&Ka(Wa,e,n)}:Ka,ol=function(t,e){var i=Ja[t]=ga(Va);return Ha(i,{type:Ba,tag:t,description:e}),aa||(i.description=e),i},rl=function(t,e,i){t===Wa&&rl(tl,e,i),da(t);var n=ma(e);return da(i),ua(Ja,n)?(i.enumerable?(ua(t,ja)&&t[ja][n]&&(t[ja][n]=!1),i=ga(i,{enumerable:va(0,!1)})):(ua(t,ja)||Ka(t,ja,va(1,{})),t[ja][n]=!0),nl(t,n,i)):Ka(t,n,i)},sl=function(t,e){da(t);var i=pa(e),n=ya(i).concat(ul(i));return La(n,(function(e){aa&&!ra(al,i,e)||rl(t,e,i[e])})),t},al=function(t){var e=ma(t),i=ra(Za,this,e);return!(this===Wa&&ua(Ja,e)&&!ua(tl,e))&&(!(i||!ua(this,e)||!ua(Ja,e)||ua(this,ja)&&this[ja][e])||i)},ll=function(t,e){var i=pa(t),n=ma(e);if(i!==Wa||!ua(Ja,n)||ua(tl,n)){var o=qa(i,n);return!o||!ua(Ja,n)||ua(i,ja)&&i[ja][n]||(o.enumerable=!0),o}},hl=function(t){var e=$a(pa(t)),i=[];return La(e,(function(t){ua(Ja,t)||ua(Ea,t)||Qa(i,t)})),i},ul=function(t){var e=t===Wa,i=$a(e?tl:pa(t)),n=[];return La(i,(function(t){!ua(Ja,t)||e&&!ua(Wa,t)||Qa(n,Ja[t])})),n};la||(Da(Va=(Ya=function(){if(ca(Va,this))throw Ua("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?fa(arguments[0]):void 0,e=Aa(t),i=function(t){this===Wa&&ra(i,tl,t),ua(this,ja)&&ua(this[ja],e)&&(this[ja][e]=!1),nl(this,e,va(1,t))};return aa&&il&&nl(Wa,e,{configurable:!0,set:i}),ol(e,t)})[za],"toString",(function(){return Ga(this).tag})),Da(Ya,"withoutSetter",(function(t){return ol(Aa(t),t)})),Sa.f=al,_a.f=rl,Ca.f=sl,xa.f=ll,ba.f=wa.f=hl,ka.f=ul,Pa.f=function(t){return ol(Ia(t),t)},aa&&Ta(Va,"description",{configurable:!0,get:function(){return Ga(this).description}})),na({global:!0,constructor:!0,wrap:!0,forced:!la,sham:!la},{Symbol:Ya}),La(ya(el),(function(t){Ma(t)})),na({target:Ba,stat:!0,forced:!la},{useSetter:function(){il=!0},useSimple:function(){il=!1}}),na({target:"Object",stat:!0,forced:!la,sham:!aa},{create:function(t,e){return void 0===e?ga(t):sl(ga(t),e)},defineProperty:rl,defineProperties:sl,getOwnPropertyDescriptor:ll}),na({target:"Object",stat:!0,forced:!la},{getOwnPropertyNames:hl}),Na(),Fa(Ya,Ba),Ea[ja]=!0;var cl=St&&!!Symbol.for&&!!Symbol.keyFor,dl=Ni,pl=pt,ml=oe,fl=Gr,vl=Vt,gl=cl,yl=vl("string-to-symbol-registry"),bl=vl("symbol-to-string-registry");dl({target:"Symbol",stat:!0,forced:!gl},{for:function(t){var e=fl(t);if(ml(yl,e))return yl[e];var i=pl("Symbol")(e);return yl[e]=i,bl[i]=e,i}});var wl=Ni,kl=oe,xl=It,_l=Mt,Cl=cl,Sl=Vt("symbol-to-string-registry");wl({target:"Symbol",stat:!0,forced:!Cl},{keyFor:function(t){if(!xl(t))throw TypeError(_l(t)+" is not a symbol");if(kl(Sl,t))return Sl[t]}});var Dl=lr,Tl=N,Ol=T,El=Gr,Al=_([].push),Il=Ni,Pl=pt,Ml=y,Nl=B,Fl=_,Rl=d,Ll=N,jl=It,Bl=Fi,zl=function(t){if(Tl(t))return t;if(Dl(t)){for(var e=t.length,i=[],n=0;n<e;n++){var o=t[n];"string"==typeof o?Al(i,o):"number"!=typeof o&&"Number"!=Ol(o)&&"String"!=Ol(o)||Al(i,El(o))}var r=i.length,s=!0;return function(t,e){if(s)return s=!1,e;if(Dl(this))return e;for(var n=0;n<r;n++)if(i[n]===t)return e}}},Hl=St,Gl=String,Wl=Pl("JSON","stringify"),Yl=Fl(/./.exec),Vl=Fl("".charAt),Ul=Fl("".charCodeAt),Xl=Fl("".replace),ql=Fl(1..toString),Kl=/[\uD800-\uDFFF]/g,$l=/^[\uD800-\uDBFF]$/,Zl=/^[\uDC00-\uDFFF]$/,Ql=!Hl||Rl((function(){var t=Pl("Symbol")();return"[null]"!=Wl([t])||"{}"!=Wl({a:t})||"{}"!=Wl(Object(t))})),Jl=Rl((function(){return'"\\udf06\\ud834"'!==Wl("\udf06\ud834")||'"\\udead"'!==Wl("\udead")})),th=function(t,e){var i=Bl(arguments),n=zl(e);if(Ll(n)||void 0!==t&&!jl(t))return i[1]=function(t,e){if(Ll(n)&&(e=Nl(n,this,Gl(t),e)),!jl(e))return e},Ml(Wl,null,i)},eh=function(t,e,i){var n=Vl(i,e-1),o=Vl(i,e+1);return Yl($l,t)&&!Yl(Zl,o)||Yl(Zl,t)&&!Yl($l,n)?"\\u"+ql(Ul(t,0),16):t};Wl&&Il({target:"JSON",stat:!0,arity:3,forced:Ql||Jl},{stringify:function(t,e,i){var n=Bl(arguments),o=Ml(Ql?th:Wl,null,n);return Jl&&"string"==typeof o?Xl(o,Kl,eh):o}});var ih=os,nh=ee;Ni({target:"Object",stat:!0,forced:!St||d((function(){ih.f(1)}))},{getOwnPropertySymbols:function(t){var e=ih.f;return e?e(nh(t)):[]}}),ys("asyncIterator"),ys("hasInstance"),ys("isConcatSpreadable"),ys("iterator"),ys("match"),ys("matchAll"),ys("replace"),ys("search"),ys("species"),ys("split");var oh=_s;ys("toPrimitive"),oh();var rh=pt,sh=Ps;ys("toStringTag"),sh(rh("Symbol"),"Symbol"),ys("unscopables"),Ps(c.JSON,"JSON",!0);var ah,lh,hh,uh=lt.Symbol,ch={},dh=R,ph=oe,mh=Function.prototype,fh=dh&&Object.getOwnPropertyDescriptor,vh=ph(mh,"name"),gh={EXISTS:vh,PROPER:vh&&"something"===function(){}.name,CONFIGURABLE:vh&&(!dh||dh&&fh(mh,"name").configurable)},yh=!d((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),bh=oe,wh=N,kh=ee,xh=yh,_h=uo("IE_PROTO"),Ch=Object,Sh=Ch.prototype,Dh=xh?Ch.getPrototypeOf:function(t){var e=kh(t);if(bh(e,_h))return e[_h];var i=e.constructor;return wh(i)&&e instanceof i?i.prototype:e instanceof Ch?Sh:null},Th=d,Oh=N,Eh=at,Ah=So,Ih=Dh,Ph=ss,Mh=ye("iterator"),Nh=!1;[].keys&&("next"in(hh=[].keys())?(lh=Ih(Ih(hh)))!==Object.prototype&&(ah=lh):Nh=!0);var Fh=!Eh(ah)||Th((function(){var t={};return ah[Mh].call(t)!==t}));Oh((ah=Fh?{}:Ah(ah))[Mh])||Ph(ah,Mh,(function(){return this}));var Rh={IteratorPrototype:ah,BUGGY_SAFARI_ITERATORS:Nh},Lh=Rh.IteratorPrototype,jh=So,Bh=U,zh=Ps,Hh=ch,Gh=function(){return this},Wh=_,Yh=Lt,Vh=N,Uh=String,Xh=TypeError,qh=function(t,e,i){try{return Wh(Yh(Object.getOwnPropertyDescriptor(t,e)[i]))}catch(t){}},Kh=li,$h=function(t){if("object"==typeof t||Vh(t))return t;throw Xh("Can't set "+Uh(t)+" as a prototype")},Zh=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=qh(Object.prototype,"__proto__","set"))(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return Kh(i),$h(n),e?t(i,n):i.__proto__=n,i}}():void 0),Qh=Ni,Jh=B,tu=function(t,e,i,n){var o=e+" Iterator";return t.prototype=jh(Lh,{next:Bh(+!n,i)}),zh(t,o,!1,!0),Hh[o]=Gh,t},eu=Dh,iu=Ps,nu=ss,ou=ch,ru=gh.PROPER,su=Rh.BUGGY_SAFARI_ITERATORS,au=ye("iterator"),lu="keys",hu="values",uu="entries",cu=function(){return this},du=function(t,e,i,n,o,r,s){tu(i,e,n);var a,l,h,u=function(t){if(t===o&&f)return f;if(!su&&t in p)return p[t];switch(t){case lu:case hu:case uu:return function(){return new i(this,t)}}return function(){return new i(this)}},c=e+" Iterator",d=!1,p=t.prototype,m=p[au]||p["@@iterator"]||o&&p[o],f=!su&&m||u(o),v="Array"==e&&p.entries||m;if(v&&(a=eu(v.call(new t)))!==Object.prototype&&a.next&&(iu(a,c,!0,!0),ou[c]=cu),ru&&o==hu&&m&&m.name!==hu&&(d=!0,f=function(){return Jh(m,this)}),o)if(l={values:u(hu),keys:r?f:u(lu),entries:u(uu)},s)for(h in l)(su||d||!(h in p))&&nu(p,h,l[h]);else Qh({target:e,proto:!0,forced:su||d},l);return s&&p[au]!==f&&nu(p,au,f,{name:o}),ou[e]=f,l},pu=function(t,e){return{value:t,done:e}},mu=ot,fu=ch,vu=qs;ni.f;var gu=du,yu=pu,bu="Array Iterator",wu=vu.set,ku=vu.getterFor(bu);gu(Array,"Array",(function(t,e){wu(this,{type:bu,target:mu(t),index:0,kind:e})}),(function(){var t=ku(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,yu(void 0,!0)):yu("keys"==i?n:"values"==i?e[n]:[n,e[n]],!1)}),"values"),fu.Arguments=fu.Array;var xu={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},_u=c,Cu=nn,Su=xi,Du=ch,Tu=ye("toStringTag");for(var Ou in xu){var Eu=_u[Ou],Au=Eu&&Eu.prototype;Au&&Cu(Au)!==Tu&&Su(Au,Tu,Ou),Du[Ou]=Du.Array}var Iu=uh;ys("dispose");var Pu=Iu;ys("asyncDispose");var Mu=Ni,Nu=_,Fu=pt("Symbol"),Ru=Fu.keyFor,Lu=Nu(Fu.prototype.valueOf);Mu({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Ru(Lu(t))}catch(t){return!1}}});for(var ju=Ni,Bu=Vt,zu=pt,Hu=_,Gu=It,Wu=ye,Yu=zu("Symbol"),Vu=Yu.isWellKnown,Uu=zu("Object","getOwnPropertyNames"),Xu=Hu(Yu.prototype.valueOf),qu=Bu("wks"),Ku=0,$u=Uu(Yu),Zu=$u.length;Ku<Zu;Ku++)try{var Qu=$u[Ku];Gu(Yu[Qu])&&Wu(Qu)}catch(t){}ju({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(Vu&&Vu(t))return!0;try{for(var e=Xu(t),i=0,n=Uu(qu),o=n.length;i<o;i++)if(qu[n[i]]==e)return!0}catch(t){}return!1}}),ys("matcher"),ys("metadataKey"),ys("observable"),ys("metadata"),ys("patternMatch"),ys("replaceAll");var Ju=Pu;sr.exports=Ju,or.exports=rr;var tc=a(nr),ec={},ic={get exports(){return ec},set exports(t){ec=t}},nc={},oc={get exports(){return nc},set exports(t){nc=t}},rc=_,sc=En,ac=Gr,lc=et,hc=rc("".charAt),uc=rc("".charCodeAt),cc=rc("".slice),dc=function(t){return function(e,i){var n,o,r=ac(lc(e)),s=sc(i),a=r.length;return s<0||s>=a?t?"":void 0:(n=uc(r,s))<55296||n>56319||s+1===a||(o=uc(r,s+1))<56320||o>57343?t?hc(r,s):n:t?cc(r,s,s+2):o-56320+(n-55296<<10)+65536}},pc={codeAt:dc(!1),charAt:dc(!0)}.charAt,mc=Gr,fc=qs,vc=du,gc=pu,yc="String Iterator",bc=fc.set,wc=fc.getterFor(yc);vc(String,"String",(function(t){bc(this,{type:yc,string:mc(t),index:0})}),(function(){var t,e=wc(this),i=e.string,n=e.index;return n>=i.length?gc(void 0,!0):(t=pc(i,n),e.index+=t.length,gc(t,!1))}));var kc=hs.f("iterator");oc.exports=kc,ic.exports=nc;var xc=a(ec);function _c(t){return _c="function"==typeof tc&&"symbol"==typeof xc?function(t){return typeof t}:function(t){return t&&"function"==typeof tc&&t.constructor===tc&&t!==tc.prototype?"symbol":typeof t},_c(t)}var Cc={},Sc={get exports(){return Cc},set exports(t){Cc=t}},Dc={},Tc={get exports(){return Dc},set exports(t){Dc=t}},Oc=hs.f("toPrimitive");Tc.exports=Oc,Sc.exports=Dc;var Ec=a(Cc);function Ac(t){var e=function(t,e){if("object"!==_c(t)||null===t)return t;var i=t[Ec];if(void 0!==i){var n=i.call(t,e||"default");if("object"!==_c(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===_c(e)?e:String(e)}function Ic(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),ir(t,Ac(n.key),n)}}function Pc(t,e,i){return e&&Ic(t.prototype,e),i&&Ic(t,i),ir(t,"prototype",{writable:!1}),t}function Mc(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Nc={},Fc={get exports(){return Nc},set exports(t){Nc=t}},Rc={},Lc={get exports(){return Rc},set exports(t){Rc=t}};Ni({target:"Object",stat:!0,sham:!R},{create:So});var jc=lt.Object,Bc=function(t,e){return jc.create(t,e)},zc=Bc;Lc.exports=zc,Fc.exports=Rc;var Hc=a(Nc),Gc={},Wc={get exports(){return Gc},set exports(t){Gc=t}},Yc={},Vc={get exports(){return Yc},set exports(t){Yc=t}};Ni({target:"Object",stat:!0},{setPrototypeOf:Zh});var Uc=lt.Object.setPrototypeOf;Vc.exports=Uc,Wc.exports=Yc;var Xc=a(Gc),qc={},Kc={get exports(){return qc},set exports(t){qc=t}},$c={},Zc={get exports(){return $c},set exports(t){$c=t}},Qc=Xi;Ni({target:"Function",proto:!0,forced:Function.bind!==Qc},{bind:Qc});var Jc=lt,td=function(t){return Jc[t+"Prototype"]},ed=td("Function").bind,id=mt,nd=ed,od=Function.prototype,rd=function(t){var e=t.bind;return t===od||id(od,t)&&e===od.bind?nd:e},sd=rd,ad=sd;Zc.exports=ad,Kc.exports=$c;var ld=a(qc);function hd(t,e){var i;return hd=Xc?ld(i=Xc).call(i):function(t,e){return t.__proto__=e,t},hd(t,e)}function ud(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Hc(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),ir(t,"prototype",{writable:!1}),e&&hd(t,e)}function cd(t,e){if(e&&("object"===_c(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return Mc(t)}var dd={},pd={get exports(){return dd},set exports(t){dd=t}},md={},fd={get exports(){return md},set exports(t){md=t}},vd=ee,gd=Dh,yd=yh;Ni({target:"Object",stat:!0,forced:d((function(){gd(1)})),sham:!yd},{getPrototypeOf:function(t){return gd(vd(t))}});var bd=lt.Object.getPrototypeOf,wd=bd;fd.exports=wd,pd.exports=md;var kd=a(dd);function xd(t){var e;return xd=Xc?ld(e=kd).call(e):function(t){return t.__proto__||kd(t)},xd(t)}var _d={},Cd={get exports(){return _d},set exports(t){_d=t}};Ni({target:"Array",stat:!0},{isArray:lr});var Sd=lt.Array.isArray;Cd.exports=Sd;var Dd=a(_d),Td={};({get exports(){return Td},set exports(t){Td=t}}).exports=sd;var Od=a(Td),Ed={},Ad={get exports(){return Ed},set exports(t){Ed=t}},Id="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,Pd=TypeError,Md=c,Nd=y,Fd=N,Rd=Id,Ld=ft,jd=Fi,Bd=function(t,e){if(t<e)throw Pd("Not enough arguments");return t},zd=Md.Function,Hd=/MSIE .\./.test(Ld)||Rd&&function(){var t=Md.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Gd=function(t,e){var i=e?2:1;return Hd?function(n,o){var r=Bd(arguments.length,1)>i,s=Fd(n)?n:zd(n),a=r?jd(arguments,i):[],l=r?function(){Nd(s,this,a)}:s;return e?t(l,o):t(l)}:t},Wd=Ni,Yd=c,Vd=Gd(Yd.setInterval,!0);Wd({global:!0,bind:!0,forced:Yd.setInterval!==Vd},{setInterval:Vd});var Ud=Ni,Xd=c,qd=Gd(Xd.setTimeout,!0);Ud({global:!0,bind:!0,forced:Xd.setTimeout!==qd},{setTimeout:qd});var Kd=lt.setTimeout;Ad.exports=Kd;var $d=a(Ed),Zd={},Qd={get exports(){return Zd},set exports(t){Zd=t}},Jd=d,tp=function(t,e){var i=[][t];return!!i&&Jd((function(){i.call(null,e||function(){return 1},1)}))},ep=ia.forEach,ip=tp("forEach")?[].forEach:function(t){return ep(this,t,arguments.length>1?arguments[1]:void 0)};Ni({target:"Array",proto:!0,forced:[].forEach!=ip},{forEach:ip});var np=td("Array").forEach,op=nn,rp=oe,sp=mt,ap=np,lp=Array.prototype,hp={DOMTokenList:!0,NodeList:!0},up=function(t){var e=t.forEach;return t===lp||sp(lp,t)&&e===lp.forEach||rp(hp,op(t))?ap:e};Qd.exports=up;var cp=a(Zd),dp="undefined"!=typeof window&&window.moment||t,pp={},mp={get exports(){return pp},set exports(t){pp=t}},fp=lt.Object.getOwnPropertySymbols;mp.exports=fp;var vp=a(pp),gp={},yp={get exports(){return gp},set exports(t){gp=t}},bp=ia.filter;Ni({target:"Array",proto:!0,forced:!Sr("filter")},{filter:function(t){return bp(this,t,arguments.length>1?arguments[1]:void 0)}});var wp=td("Array").filter,kp=mt,xp=wp,_p=Array.prototype,Cp=function(t){var e=t.filter;return t===_p||kp(_p,t)&&e===_p.filter?xp:e},Sp=Cp;yp.exports=Sp;var Dp=a(gp),Tp={},Op={get exports(){return Tp},set exports(t){Tp=t}},Ep={},Ap={get exports(){return Ep},set exports(t){Ep=t}},Ip=Ni,Pp=d,Mp=ot,Np=F.f,Fp=R;Ip({target:"Object",stat:!0,forced:!Fp||Pp((function(){Np(1)})),sham:!Fp},{getOwnPropertyDescriptor:function(t,e){return Np(Mp(t),e)}});var Rp=lt.Object,Lp=Ap.exports=function(t,e){return Rp.getOwnPropertyDescriptor(t,e)};Rp.getOwnPropertyDescriptor.sham&&(Lp.sham=!0);var jp=Ep;Op.exports=jp;var Bp=a(Tp),zp={},Hp={get exports(){return zp},set exports(t){zp=t}},Gp=pt,Wp=Wr,Yp=os,Vp=li,Up=_([].concat),Xp=Gp("Reflect","ownKeys")||function(t){var e=Wp.f(Vp(t)),i=Yp.f;return i?Up(e,i(t)):e},qp=Xp,Kp=ot,$p=F,Zp=mr;Ni({target:"Object",stat:!0,sham:!R},{getOwnPropertyDescriptors:function(t){for(var e,i,n=Kp(t),o=$p.f,r=qp(n),s={},a=0;r.length>a;)void 0!==(i=o(n,e=r[a++]))&&Zp(s,e,i);return s}});var Qp=lt.Object.getOwnPropertyDescriptors;Hp.exports=Qp;var Jp=a(zp),tm={},em={get exports(){return tm},set exports(t){tm=t}},im={},nm={get exports(){return im},set exports(t){im=t}},om=Ni,rm=R,sm=Sn.f;om({target:"Object",stat:!0,forced:Object.defineProperties!==sm,sham:!rm},{defineProperties:sm});var am=lt.Object,lm=nm.exports=function(t,e){return am.defineProperties(t,e)};am.defineProperties.sham&&(lm.sham=!0);var hm=im;em.exports=hm;var um=a(tm);function cm(t,e,i){return(e=Ac(e))in t?ir(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}var dm={},pm={get exports(){return dm},set exports(t){dm=t}},mm=ia.map;Ni({target:"Array",proto:!0,forced:!Sr("map")},{map:function(t){return mm(this,t,arguments.length>1?arguments[1]:void 0)}});var fm=td("Array").map,vm=mt,gm=fm,ym=Array.prototype,bm=function(t){var e=t.map;return t===ym||vm(ym,t)&&e===ym.map?gm:e},wm=bm;pm.exports=wm;var km=a(dm),xm={},_m={get exports(){return xm},set exports(t){xm=t}},Cm=Lt,Sm=ee,Dm=Z,Tm=Ln,Om=TypeError,Em=function(t){return function(e,i,n,o){Cm(i);var r=Sm(e),s=Dm(r),a=Tm(r),l=t?a-1:0,h=t?-1:1;if(n<2)for(;;){if(l in s){o=s[l],l+=h;break}if(l+=h,t?l<0:a<=l)throw Om("Reduce of empty array with no initial value")}for(;t?l>=0:a>l;l+=h)l in s&&(o=i(o,s[l],l,r));return o}},Am={left:Em(!1),right:Em(!0)},Im="undefined"!=typeof process&&"process"==T(process),Pm=Am.left;Ni({target:"Array",proto:!0,forced:!Im&&xt>79&&xt<83||!tp("reduce")},{reduce:function(t){var e=arguments.length;return Pm(this,t,e,e>1?arguments[1]:void 0)}});var Mm=td("Array").reduce,Nm=mt,Fm=Mm,Rm=Array.prototype,Lm=function(t){var e=t.reduce;return t===Rm||Nm(Rm,t)&&e===Rm.reduce?Fm:e},jm=Lm;_m.exports=jm;var Bm=a(xm),zm={},Hm={get exports(){return zm},set exports(t){zm=t}},Gm=ee,Wm=Jn;Ni({target:"Object",stat:!0,forced:d((function(){Wm(1)}))},{keys:function(t){return Wm(Gm(t))}});var Ym=lt.Object.keys;Hm.exports=Ym;var Vm=a(zm),Um={};({get exports(){return Um},set exports(t){Um=t}}).exports=tr;var Xm=a(Um),qm={},Km={get exports(){return qm},set exports(t){qm=t}},$m=B,Zm=li,Qm=zt,Jm=function(t,e,i){var n,o;Zm(t);try{if(!(n=Qm(t,"return"))){if("throw"===e)throw i;return i}n=$m(n,t)}catch(t){o=!0,n=t}if("throw"===e)throw i;if(o)throw n;return Zm(n),i},tf=li,ef=Jm,nf=ch,of=ye("iterator"),rf=Array.prototype,sf=function(t){return void 0!==t&&(nf.Array===t||rf[of]===t)},af=nn,lf=zt,hf=Q,uf=ch,cf=ye("iterator"),df=function(t){if(!hf(t))return lf(t,cf)||lf(t,"@@iterator")||uf[af(t)]},pf=B,mf=Lt,ff=li,vf=Mt,gf=df,yf=TypeError,bf=function(t,e){var i=arguments.length<2?gf(t):e;if(mf(i))return ff(pf(i,t));throw yf(vf(t)+" is not iterable")},wf=ii,kf=B,xf=ee,_f=function(t,e,i,n){try{return n?e(tf(i)[0],i[1]):e(i)}catch(e){ef(t,"throw",e)}},Cf=sf,Sf=kn,Df=Ln,Tf=mr,Of=bf,Ef=df,Af=Array,If=ye("iterator"),Pf=!1;try{var Mf=0,Nf={next:function(){return{done:!!Mf++}},return:function(){Pf=!0}};Nf[If]=function(){return this},Array.from(Nf,(function(){throw 2}))}catch(t){}var Ff=function(t){var e=xf(t),i=Sf(this),n=arguments.length,o=n>1?arguments[1]:void 0,r=void 0!==o;r&&(o=wf(o,n>2?arguments[2]:void 0));var s,a,l,h,u,c,d=Ef(e),p=0;if(!d||this===Af&&Cf(d))for(s=Df(e),a=i?new this(s):Af(s);s>p;p++)c=r?o(e[p],p):e[p],Tf(a,p,c);else for(u=(h=Of(e,d)).next,a=i?new this:[];!(l=kf(u,h)).done;p++)c=r?_f(h,o,[l.value,p],!0):l.value,Tf(a,p,c);return a.length=p,a},Rf=function(t,e){if(!e&&!Pf)return!1;var i=!1;try{var n={};n[If]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i};Ni({target:"Array",stat:!0,forced:!Rf((function(t){Array.from(t)}))},{from:Ff});var Lf=lt.Array.from;Km.exports=Lf;var jf=a(qm),Bf={},zf={get exports(){return Bf},set exports(t){Bf=t}},Hf={},Gf=df;({get exports(){return Hf},set exports(t){Hf=t}}).exports=Gf,zf.exports=Hf;var Wf=a(Bf),Yf={},Vf={get exports(){return Yf},set exports(t){Yf=t}},Uf={},Xf=Sd;({get exports(){return Uf},set exports(t){Uf=t}}).exports=Xf,Vf.exports=Uf;var qf=a(Yf);var Kf={},$f={get exports(){return Kf},set exports(t){Kf=t}},Zf={},Qf={get exports(){return Zf},set exports(t){Zf=t}},Jf=Ni,tv=lr,ev=kn,iv=at,nv=Mn,ov=Ln,rv=ot,sv=mr,av=ye,lv=Fi,hv=Sr("slice"),uv=av("species"),cv=Array,dv=Math.max;Jf({target:"Array",proto:!0,forced:!hv},{slice:function(t,e){var i,n,o,r=rv(this),s=ov(r),a=nv(t,s),l=nv(void 0===e?s:e,s);if(tv(r)&&(i=r.constructor,(ev(i)&&(i===cv||tv(i.prototype))||iv(i)&&null===(i=i[uv]))&&(i=void 0),i===cv||void 0===i))return lv(r,a,l);for(n=new(void 0===i?cv:i)(dv(l-a,0)),o=0;a<l;a++,o++)a in r&&sv(n,o,r[a]);return n.length=o,n}});var pv=td("Array").slice,mv=mt,fv=pv,vv=Array.prototype,gv=function(t){var e=t.slice;return t===vv||mv(vv,t)&&e===vv.slice?fv:e},yv=gv,bv=yv;Qf.exports=bv,$f.exports=Zf;var wv=a(Kf),kv={},xv={get exports(){return kv},set exports(t){kv=t}},_v={},Cv=Lf;({get exports(){return _v},set exports(t){_v=t}}).exports=Cv,xv.exports=_v;var Sv=a(kv);function Dv(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Tv(t,e){var i;if(t){if("string"==typeof t)return Dv(t,e);var n=wv(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Sv(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Dv(t,e):void 0}}function Ov(t,e){return function(t){if(qf(t))return t}(t)||function(t,e){var i=null==t?null:void 0!==tc&&Wf(t)||t["@@iterator"];if(null!=i){var n,o,r,s,a=[],l=!0,h=!1;try{if(r=(i=i.call(t)).next,0===e){if(Object(i)!==i)return;l=!1}else for(;!(l=(n=r.call(i)).done)&&(a.push(n.value),a.length!==e);l=!0);}catch(t){h=!0,o=t}finally{try{if(!l&&null!=i.return&&(s=i.return(),Object(s)!==s))return}finally{if(h)throw o}}return a}}(t,e)||Tv(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Ev(t){return function(t){if(qf(t))return Dv(t)}(t)||function(t){if(void 0!==tc&&null!=Wf(t)||null!=t["@@iterator"])return Sv(t)}(t)||Tv(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Av={};({get exports(){return Av},set exports(t){Av=t}}).exports=Iu;var Iv=a(Av),Pv={},Mv={get exports(){return Pv},set exports(t){Pv=t}},Nv=td("Array").concat,Fv=mt,Rv=Nv,Lv=Array.prototype,jv=function(t){var e=t.concat;return t===Lv||Fv(Lv,t)&&e===Lv.concat?Rv:e},Bv=jv;Mv.exports=Bv;var zv=a(Pv),Hv={};({get exports(){return Hv},set exports(t){Hv=t}}).exports=yv;var Gv=a(Hv),Wv={},Yv={get exports(){return Wv},set exports(t){Wv=t}};Ni({target:"Reflect",stat:!0},{ownKeys:Xp});var Vv=lt.Reflect.ownKeys;Yv.exports=Vv;var Uv=a(Wv),Xv={},qv={get exports(){return Xv},set exports(t){Xv=t}},Kv=Ni,$v=Date,Zv=_($v.prototype.getTime);Kv({target:"Date",stat:!0},{now:function(){return Zv(new $v)}});var Qv=lt.Date.now;qv.exports=Qv;var Jv=a(Xv),tg={},eg={get exports(){return tg},set exports(t){tg=t}},ig=Ni,ng=lr,og=_([].reverse),rg=[1,2];ig({target:"Array",proto:!0,forced:String(rg)===String(rg.reverse())},{reverse:function(){return ng(this)&&(this.length=this.length),og(this)}});var sg=td("Array").reverse,ag=mt,lg=sg,hg=Array.prototype,ug=function(t){var e=t.reverse;return t===hg||ag(hg,t)&&e===hg.reverse?lg:e},cg=ug;eg.exports=cg;var dg=a(tg),pg={},mg={get exports(){return pg},set exports(t){pg=t}},fg=R,vg=lr,gg=TypeError,yg=Object.getOwnPropertyDescriptor,bg=fg&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),wg=Mt,kg=TypeError,xg=function(t,e){if(!delete t[e])throw kg("Cannot delete property "+wg(e)+" of "+wg(t))},_g=Ni,Cg=ee,Sg=Mn,Dg=En,Tg=Ln,Og=bg?function(t,e){if(vg(t)&&!yg(t,"length").writable)throw gg("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Eg=ur,Ag=kr,Ig=mr,Pg=xg,Mg=Sr("splice"),Ng=Math.max,Fg=Math.min;_g({target:"Array",proto:!0,forced:!Mg},{splice:function(t,e){var i,n,o,r,s,a,l=Cg(this),h=Tg(l),u=Sg(t,h),c=arguments.length;for(0===c?i=n=0:1===c?(i=0,n=h-u):(i=c-2,n=Fg(Ng(Dg(e),0),h-u)),Eg(h+i-n),o=Ag(l,n),r=0;r<n;r++)(s=u+r)in l&&Ig(o,r,l[s]);if(o.length=n,i<n){for(r=u;r<h-n;r++)a=r+i,(s=r+n)in l?l[a]=l[s]:Pg(l,a);for(r=h;r>h-n+i;r--)Pg(l,r-1)}else if(i>n)for(r=h-n;r>u;r--)a=r+i-1,(s=r+n-1)in l?l[a]=l[s]:Pg(l,a);for(r=0;r<i;r++)l[r+u]=arguments[r+2];return Og(l,h-n+i),o}});var Rg=td("Array").splice,Lg=mt,jg=Rg,Bg=Array.prototype,zg=function(t){var e=t.splice;return t===Bg||Lg(Bg,t)&&e===Bg.splice?jg:e},Hg=zg;mg.exports=Hg;var Gg=a(pg),Wg={},Yg={get exports(){return Wg},set exports(t){Wg=t}},Vg=R,Ug=_,Xg=B,qg=d,Kg=Jn,$g=os,Zg=z,Qg=ee,Jg=Z,ty=Object.assign,ey=Object.defineProperty,iy=Ug([].concat),ny=!ty||qg((function(){if(Vg&&1!==ty({b:1},ty(ey({},"a",{enumerable:!0,get:function(){ey(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),n="abcdefghijklmnopqrst";return t[i]=7,n.split("").forEach((function(t){e[t]=t})),7!=ty({},t)[i]||Kg(ty({},e)).join("")!=n}))?function(t,e){for(var i=Qg(t),n=arguments.length,o=1,r=$g.f,s=Zg.f;n>o;)for(var a,l=Jg(arguments[o++]),h=r?iy(Kg(l),r(l)):Kg(l),u=h.length,c=0;u>c;)a=h[c++],Vg&&!Xg(s,l,a)||(i[a]=l[a]);return i}:ty,oy=ny;Ni({target:"Object",stat:!0,arity:2,forced:Object.assign!==oy},{assign:oy});var ry=lt.Object.assign;Yg.exports=ry;var sy=a(Wg),ay={},ly={get exports(){return ay},set exports(t){ay=t}},hy=Gn.includes;Ni({target:"Array",proto:!0,forced:d((function(){return!Array(1).includes()}))},{includes:function(t){return hy(this,t,arguments.length>1?arguments[1]:void 0)}});var uy=td("Array").includes,cy=at,dy=T,py=ye("match"),my=function(t){var e;return cy(t)&&(void 0!==(e=t[py])?!!e:"RegExp"==dy(t))},fy=TypeError,vy=ye("match"),gy=Ni,yy=function(t){if(my(t))throw fy("The method doesn't accept regular expressions");return t},by=et,wy=Gr,ky=function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[vy]=!1,"/./"[t](e)}catch(t){}}return!1},xy=_("".indexOf);gy({target:"String",proto:!0,forced:!ky("includes")},{includes:function(t){return!!~xy(wy(by(this)),wy(yy(t)),arguments.length>1?arguments[1]:void 0)}});var _y=td("String").includes,Cy=mt,Sy=uy,Dy=_y,Ty=Array.prototype,Oy=String.prototype,Ey=function(t){var e=t.includes;return t===Ty||Cy(Ty,t)&&e===Ty.includes?Sy:"string"==typeof t||t===Oy||Cy(Oy,t)&&e===Oy.includes?Dy:e},Ay=Ey;ly.exports=Ay;var Iy=a(ay),Py={};({get exports(){return Py},set exports(t){Py=t}}).exports=bd;var My=a(Py),Ny={},Fy={get exports(){return Ny},set exports(t){Ny=t}},Ry=R,Ly=_,jy=Jn,By=ot,zy=Ly(z.f),Hy=Ly([].push),Gy=function(t){return function(e){for(var i,n=By(e),o=jy(n),r=o.length,s=0,a=[];r>s;)i=o[s++],Ry&&!zy(n,i)||Hy(a,t?[i,n[i]]:n[i]);return a}},Wy={entries:Gy(!0),values:Gy(!1)}.values;Ni({target:"Object",stat:!0},{values:function(t){return Wy(t)}});var Yy=lt.Object.values;Fy.exports=Yy;var Vy=a(Ny),Uy={},Xy={get exports(){return Uy},set exports(t){Uy=t}},qy="\t\n\v\f\r                　\u2028\u2029\ufeff",Ky=et,$y=Gr,Zy=qy,Qy=_("".replace),Jy=RegExp("^["+Zy+"]+"),tb=RegExp("(^|[^"+Zy+"])["+Zy+"]+$"),eb=function(t){return function(e){var i=$y(Ky(e));return 1&t&&(i=Qy(i,Jy,"")),2&t&&(i=Qy(i,tb,"$1")),i}},ib={start:eb(1),end:eb(2),trim:eb(3)},nb=c,ob=d,rb=_,sb=Gr,ab=ib.trim,lb=qy,hb=nb.parseInt,ub=nb.Symbol,cb=ub&&ub.iterator,db=/^[+-]?0x/i,pb=rb(db.exec),mb=8!==hb(lb+"08")||22!==hb(lb+"0x16")||cb&&!ob((function(){hb(Object(cb))}))?function(t,e){var i=ab(sb(t));return hb(i,e>>>0||(pb(db,i)?16:10))}:hb;Ni({global:!0,forced:parseInt!=mb},{parseInt:mb});var fb=lt.parseInt;Xy.exports=fb;var vb=a(Uy),gb={},yb={get exports(){return gb},set exports(t){gb=t}},bb=Ni,wb=Gn.indexOf,kb=tp,xb=A([].indexOf),_b=!!xb&&1/xb([1],1,-0)<0;bb({target:"Array",proto:!0,forced:_b||!kb("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return _b?xb(this,t,e)||0:wb(this,t,e)}});var Cb=td("Array").indexOf,Sb=mt,Db=Cb,Tb=Array.prototype,Ob=function(t){var e=t.indexOf;return t===Tb||Sb(Tb,t)&&e===Tb.indexOf?Db:e},Eb=Ob;yb.exports=Eb;var Ab=a(gb),Ib={},Pb={get exports(){return Ib},set exports(t){Ib=t}},Mb=gh.PROPER,Nb=d,Fb=qy,Rb=ib.trim;Ni({target:"String",proto:!0,forced:function(t){return Nb((function(){return!!Fb[t]()||"​᠎"!=="​᠎"[t]()||Mb&&Fb[t].name!==t}))}("trim")},{trim:function(){return Rb(this)}});var Lb=td("String").trim,jb=mt,Bb=Lb,zb=String.prototype,Hb=function(t){var e=t.trim;return"string"==typeof t||t===zb||jb(zb,t)&&e===zb.trim?Bb:e},Gb=Hb;Pb.exports=Gb;var Wb=a(Ib),Yb={};({get exports(){return Yb},set exports(t){Yb=t}}).exports=Bc;var Vb=a(Yb),Ub={},Xb={get exports(){return Ub},set exports(t){Ub=t}},qb=lt,Kb=y;qb.JSON||(qb.JSON={stringify:JSON.stringify});var $b=function(t,e,i){return Kb(qb.JSON.stringify,null,arguments)};Xb.exports=$b;var Zb=a(Ub),Qb={},Jb={get exports(){return Qb},set exports(t){Qb=t}},tw=ee,ew=Mn,iw=Ln;Ni({target:"Array",proto:!0},{fill:function(t){for(var e=tw(this),i=iw(e),n=arguments.length,o=ew(n>1?arguments[1]:void 0,i),r=n>2?arguments[2]:void 0,s=void 0===r?i:ew(r,i);s>o;)e[o++]=t;return e}});var nw=td("Array").fill,ow=mt,rw=nw,sw=Array.prototype,aw=function(t){var e=t.fill;return t===sw||ow(sw,t)&&e===sw.fill?rw:e},lw=aw;Jb.exports=lw;var hw=a(Qb),uw={},cw={get exports(){return uw},set exports(t){uw=t}};!function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}cw.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var o=0;o<n.length;o++)if((i=n[o])===e||i.fn===e){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var o=(i=i.slice(0)).length;n<o;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var dw=uw;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function pw(){return pw=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},pw.apply(this,arguments)}function mw(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function fw(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var vw,gw="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(e[o]=n[o])}return e}:Object.assign,yw=["","webkit","Moz","MS","ms","o"],bw="undefined"==typeof document?{style:{}}:document.createElement("div"),ww="function",kw=Math.round,xw=Math.abs,_w=Date.now;function Cw(t,e){for(var i,n,o=e[0].toUpperCase()+e.slice(1),r=0;r<yw.length;){if((n=(i=yw[r])?i+o:e)in t)return n;r++}}vw="undefined"==typeof window?{}:window;var Sw=Cw(bw.style,"touchAction"),Dw=void 0!==Sw;var Tw="compute",Ow="auto",Ew="manipulation",Aw="none",Iw="pan-x",Pw="pan-y",Mw=function(){if(!Dw)return!1;var t={},e=vw.CSS&&vw.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||vw.CSS.supports("touch-action",i)})),t}(),Nw="ontouchstart"in vw,Fw=void 0!==Cw(vw,"PointerEvent"),Rw=Nw&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Lw="touch",jw="mouse",Bw=25,zw=1,Hw=2,Gw=4,Ww=8,Yw=1,Vw=2,Uw=4,Xw=8,qw=16,Kw=Vw|Uw,$w=Xw|qw,Zw=Kw|$w,Qw=["x","y"],Jw=["clientX","clientY"];function tk(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function ek(t,e){return typeof t===ww?t.apply(e&&e[0]||void 0,e):t}function ik(t,e){return t.indexOf(e)>-1}var nk=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Tw&&(t=this.compute()),Dw&&this.manager.element.style&&Mw[t]&&(this.manager.element.style[Sw]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return tk(this.manager.recognizers,(function(e){ek(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(ik(t,Aw))return Aw;var e=ik(t,Iw),i=ik(t,Pw);return e&&i?Aw:e||i?e?Iw:Pw:ik(t,Ew)?Ew:Ow}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,o=ik(n,Aw)&&!Mw[Aw],r=ik(n,Pw)&&!Mw[Pw],s=ik(n,Iw)&&!Mw[Iw];if(o){var a=1===t.pointers.length,l=t.distance<2,h=t.deltaTime<250;if(a&&l&&h)return}if(!s||!r)return o||r&&i&Kw||s&&i&$w?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function ok(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function rk(t){var e=t.length;if(1===e)return{x:kw(t[0].clientX),y:kw(t[0].clientY)};for(var i=0,n=0,o=0;o<e;)i+=t[o].clientX,n+=t[o].clientY,o++;return{x:kw(i/e),y:kw(n/e)}}function sk(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:kw(t.pointers[i].clientX),clientY:kw(t.pointers[i].clientY)},i++;return{timeStamp:_w(),pointers:e,center:rk(e),deltaX:t.deltaX,deltaY:t.deltaY}}function ak(t,e,i){i||(i=Qw);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return Math.sqrt(n*n+o*o)}function lk(t,e,i){i||(i=Qw);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return 180*Math.atan2(o,n)/Math.PI}function hk(t,e){return t===e?Yw:xw(t)>=xw(e)?t<0?Vw:Uw:e<0?Xw:qw}function uk(t,e,i){return{x:e/t||0,y:i/t||0}}function ck(t,e){var i=t.session,n=e.pointers,o=n.length;i.firstInput||(i.firstInput=sk(e)),o>1&&!i.firstMultiple?i.firstMultiple=sk(e):1===o&&(i.firstMultiple=!1);var r=i.firstInput,s=i.firstMultiple,a=s?s.center:r.center,l=e.center=rk(n);e.timeStamp=_w(),e.deltaTime=e.timeStamp-r.timeStamp,e.angle=lk(a,l),e.distance=ak(a,l),function(t,e){var i=e.center,n=t.offsetDelta||{},o=t.prevDelta||{},r=t.prevInput||{};e.eventType!==zw&&r.eventType!==Gw||(o=t.prevDelta={x:r.deltaX||0,y:r.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=o.x+(i.x-n.x),e.deltaY=o.y+(i.y-n.y)}(i,e),e.offsetDirection=hk(e.deltaX,e.deltaY);var h,u,c=uk(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=c.x,e.overallVelocityY=c.y,e.overallVelocity=xw(c.x)>xw(c.y)?c.x:c.y,e.scale=s?(h=s.pointers,ak((u=n)[0],u[1],Jw)/ak(h[0],h[1],Jw)):1,e.rotation=s?function(t,e){return lk(e[1],e[0],Jw)+lk(t[1],t[0],Jw)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,o,r,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==Ww&&(a>Bw||void 0===s.velocity)){var l=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,u=uk(a,l,h);n=u.x,o=u.y,i=xw(u.x)>xw(u.y)?u.x:u.y,r=hk(l,h),t.lastInterval=e}else i=s.velocity,n=s.velocityX,o=s.velocityY,r=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=o,e.direction=r}(i,e);var d,p=t.element,m=e.srcEvent;ok(d=m.composedPath?m.composedPath()[0]:m.path?m.path[0]:m.target,p)&&(p=d),e.target=p}function dk(t,e,i){var n=i.pointers.length,o=i.changedPointers.length,r=e&zw&&n-o==0,s=e&(Gw|Ww)&&n-o==0;i.isFirst=!!r,i.isFinal=!!s,r&&(t.session={}),i.eventType=e,ck(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function pk(t){return t.trim().split(/\s+/g)}function mk(t,e,i){tk(pk(e),(function(e){t.addEventListener(e,i,!1)}))}function fk(t,e,i){tk(pk(e),(function(e){t.removeEventListener(e,i,!1)}))}function vk(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var gk=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){ek(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&mk(this.element,this.evEl,this.domHandler),this.evTarget&&mk(this.target,this.evTarget,this.domHandler),this.evWin&&mk(vk(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&fk(this.element,this.evEl,this.domHandler),this.evTarget&&fk(this.target,this.evTarget,this.domHandler),this.evWin&&fk(vk(this.element),this.evWin,this.domHandler)},t}();function yk(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var bk={pointerdown:zw,pointermove:Hw,pointerup:Gw,pointercancel:Ww,pointerout:Ww},wk={2:Lw,3:"pen",4:jw,5:"kinect"},kk="pointerdown",xk="pointermove pointerup pointercancel";vw.MSPointerEvent&&!vw.PointerEvent&&(kk="MSPointerDown",xk="MSPointerMove MSPointerUp MSPointerCancel");var _k=function(t){function e(){var i,n=e.prototype;return n.evEl=kk,n.evWin=xk,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return mw(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),o=bk[n],r=wk[t.pointerType]||t.pointerType,s=r===Lw,a=yk(e,t.pointerId,"pointerId");o&zw&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):o&(Gw|Ww)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,o,{pointers:e,changedPointers:[t],pointerType:r,srcEvent:t}),i&&e.splice(a,1))},e}(gk);function Ck(t){return Array.prototype.slice.call(t,0)}function Sk(t,e,i){for(var n=[],o=[],r=0;r<t.length;){var s=e?t[r][e]:t[r];yk(o,s)<0&&n.push(t[r]),o[r]=s,r++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var Dk={touchstart:zw,touchmove:Hw,touchend:Gw,touchcancel:Ww},Tk="touchstart touchmove touchend touchcancel",Ok=function(t){function e(){var i;return e.prototype.evTarget=Tk,(i=t.apply(this,arguments)||this).targetIds={},i}return mw(e,t),e.prototype.handler=function(t){var e=Dk[t.type],i=Ek.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Lw,srcEvent:t})},e}(gk);function Ek(t,e){var i,n,o=Ck(t.touches),r=this.targetIds;if(e&(zw|Hw)&&1===o.length)return r[o[0].identifier]=!0,[o,o];var s=Ck(t.changedTouches),a=[],l=this.target;if(n=o.filter((function(t){return ok(t.target,l)})),e===zw)for(i=0;i<n.length;)r[n[i].identifier]=!0,i++;for(i=0;i<s.length;)r[s[i].identifier]&&a.push(s[i]),e&(Gw|Ww)&&delete r[s[i].identifier],i++;return a.length?[Sk(n.concat(a),"identifier",!0),a]:void 0}var Ak={mousedown:zw,mousemove:Hw,mouseup:Gw},Ik="mousedown",Pk="mousemove mouseup",Mk=function(t){function e(){var i,n=e.prototype;return n.evEl=Ik,n.evWin=Pk,(i=t.apply(this,arguments)||this).pressed=!1,i}return mw(e,t),e.prototype.handler=function(t){var e=Ak[t.type];e&zw&&0===t.button&&(this.pressed=!0),e&Hw&&1!==t.which&&(e=Gw),this.pressed&&(e&Gw&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:jw,srcEvent:t}))},e}(gk),Nk=2500,Fk=25;function Rk(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),Nk)}}function Lk(t,e){t&zw?(this.primaryTouch=e.changedPointers[0].identifier,Rk.call(this,e)):t&(Gw|Ww)&&Rk.call(this,e)}function jk(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],r=Math.abs(e-o.x),s=Math.abs(i-o.y);if(r<=Fk&&s<=Fk)return!0}return!1}var Bk=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var o=i.pointerType===Lw,r=i.pointerType===jw;if(!(r&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(o)Lk.call(fw(fw(n)),e,i);else if(r&&jk.call(fw(fw(n)),i))return;n.callback(t,e,i)}},n.touch=new Ok(n.manager,n.handler),n.mouse=new Mk(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return mw(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(gk)}();function zk(t,e,i){return!!Array.isArray(t)&&(tk(t,i[e],i),!0)}var Hk=1,Gk=2,Wk=4,Yk=8,Vk=Yk,Uk=16,Xk=32,qk=1;function Kk(t,e){var i=e.manager;return i?i.get(t):t}function $k(t){return t&Uk?"cancel":t&Yk?"end":t&Wk?"move":t&Gk?"start":""}var Zk=function(){function t(t){void 0===t&&(t={}),this.options=pw({enable:!0},t),this.id=qk++,this.manager=null,this.state=Hk,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return gw(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(zk(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Kk(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return zk(t,"dropRecognizeWith",this)||(t=Kk(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(zk(t,"requireFailure",this))return this;var e=this.requireFail;return-1===yk(e,t=Kk(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(zk(t,"dropRequireFailure",this))return this;t=Kk(t,this);var e=yk(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<Yk&&n(e.options.event+$k(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=Yk&&n(e.options.event+$k(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Xk},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Xk|Hk)))return!1;t++}return!0},e.recognize=function(t){var e=gw({},t);if(!ek(this.options.enable,[this,e]))return this.reset(),void(this.state=Xk);this.state&(Vk|Uk|Xk)&&(this.state=Hk),this.state=this.process(e),this.state&(Gk|Wk|Yk|Uk)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Qk=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,pw({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}mw(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Ew]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime<i.time;if(this.reset(),t.eventType&zw&&0===this.count)return this.failTimeout();if(o&&r&&n){if(t.eventType!==Gw)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||ak(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Vk,e.tryEmit()}),i.interval),Gk):Vk}return Xk},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Xk}),this.options.interval),Xk},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===Vk&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Zk),Jk=function(t){function e(e){return void 0===e&&(e={}),t.call(this,pw({pointers:1},e))||this}mw(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=e&(Gk|Wk),o=this.attrTest(t);return n&&(i&Ww||!o)?e|Uk:n||o?i&Gw?e|Yk:e&Gk?e|Wk:Gk:Xk},e}(Zk);function tx(t){return t===qw?"down":t===Xw?"up":t===Vw?"left":t===Uw?"right":""}var ex=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,pw({event:"pan",threshold:10,pointers:1,direction:Zw},e))||this).pX=null,i.pY=null,i}mw(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Kw&&e.push(Pw),t&$w&&e.push(Iw),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,o=t.direction,r=t.deltaX,s=t.deltaY;return o&e.direction||(e.direction&Kw?(o=0===r?Yw:r<0?Vw:Uw,i=r!==this.pX,n=Math.abs(t.deltaX)):(o=0===s?Yw:s<0?Xw:qw,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=o,i&&n>e.threshold&&o&e.direction},i.attrTest=function(t){return Jk.prototype.attrTest.call(this,t)&&(this.state&Gk||!(this.state&Gk)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=tx(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Jk),ix=function(t){function e(e){return void 0===e&&(e={}),t.call(this,pw({event:"swipe",threshold:10,velocity:.3,direction:Kw|$w,pointers:1},e))||this}mw(e,t);var i=e.prototype;return i.getTouchAction=function(){return ex.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return n&(Kw|$w)?i=e.overallVelocity:n&Kw?i=e.overallVelocityX:n&$w&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&xw(i)>this.options.velocity&&e.eventType&Gw},i.emit=function(t){var e=tx(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Jk),nx=function(t){function e(e){return void 0===e&&(e={}),t.call(this,pw({event:"pinch",threshold:0,pointers:2},e))||this}mw(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Aw]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Gk)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Jk),ox=function(t){function e(e){return void 0===e&&(e={}),t.call(this,pw({event:"rotate",threshold:0,pointers:2},e))||this}mw(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Aw]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Gk)},e}(Jk),rx=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,pw({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}mw(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Ow]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime>i.time;if(this._input=t,!o||!n||t.eventType&(Gw|Ww)&&!r)this.reset();else if(t.eventType&zw)this.reset(),this._timer=setTimeout((function(){e.state=Vk,e.tryEmit()}),i.time);else if(t.eventType&Gw)return Vk;return Xk},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===Vk&&(t&&t.eventType&Gw?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=_w(),this.manager.emit(this.options.event,this._input)))},e}(Zk),sx={domEvents:!1,touchAction:Tw,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},ax=[[ox,{enable:!1}],[nx,{enable:!1},["rotate"]],[ix,{direction:Kw}],[ex,{direction:Kw},["swipe"]],[Qk],[Qk,{event:"doubletap",taps:2},["tap"]],[rx]];function lx(t,e){var i,n=t.element;n.style&&(tk(t.options.cssProps,(function(o,r){i=Cw(n.style,r),e?(t.oldCssProps[i]=n.style[i],n.style[i]=o):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var hx=function(){function t(t,e){var i,n=this;this.options=gw({},sx,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Fw?_k:Rw?Ok:Nw?Bk:Mk))(i,dk),this.touchAction=new nk(this,this.options.touchAction),lx(this,!0),tk(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return gw(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,o=e.curRecognizer;(!o||o&&o.state&Vk)&&(e.curRecognizer=null,o=null);for(var r=0;r<n.length;)i=n[r],2===e.stopped||o&&i!==o&&!i.canRecognizeWith(o)?i.reset():i.recognize(t),!o&&i.state&(Gk|Wk|Yk)&&(e.curRecognizer=i,o=i),r++}},e.get=function(t){if(t instanceof Zk)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(zk(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(zk(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=yk(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return tk(pk(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return tk(pk(t),(function(t){e?i[t]&&i[t].splice(yk(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&lx(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),ux={touchstart:zw,touchmove:Hw,touchend:Gw,touchcancel:Ww},cx="touchstart",dx="touchstart touchmove touchend touchcancel",px=function(t){function e(){var i,n=e.prototype;return n.evTarget=cx,n.evWin=dx,(i=t.apply(this,arguments)||this).started=!1,i}return mw(e,t),e.prototype.handler=function(t){var e=ux[t.type];if(e===zw&&(this.started=!0),this.started){var i=mx.call(this,t,e);e&(Gw|Ww)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Lw,srcEvent:t})}},e}(gk);function mx(t,e){var i=Ck(t.touches),n=Ck(t.changedTouches);return e&(Gw|Ww)&&(i=Sk(i.concat(n),"identifier",!0)),[i,n]}function fx(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,i),t.apply(this,arguments)}}var vx=fx((function(t,e,i){for(var n=Object.keys(e),o=0;o<n.length;)(!i||i&&void 0===t[n[o]])&&(t[n[o]]=e[n[o]]),o++;return t}),"extend","Use `assign`."),gx=fx((function(t,e){return vx(t,e,!0)}),"merge","Use `assign`.");function yx(t,e,i){var n,o=e.prototype;(n=t.prototype=Object.create(o)).constructor=t,n._super=o,i&&gw(n,i)}function bx(t,e){return function(){return t.apply(e,arguments)}}var wx=function(){var t=function(t,e){return void 0===e&&(e={}),new hx(t,pw({recognizers:ax.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Zw,t.DIRECTION_DOWN=qw,t.DIRECTION_LEFT=Vw,t.DIRECTION_RIGHT=Uw,t.DIRECTION_UP=Xw,t.DIRECTION_HORIZONTAL=Kw,t.DIRECTION_VERTICAL=$w,t.DIRECTION_NONE=Yw,t.DIRECTION_DOWN=qw,t.INPUT_START=zw,t.INPUT_MOVE=Hw,t.INPUT_END=Gw,t.INPUT_CANCEL=Ww,t.STATE_POSSIBLE=Hk,t.STATE_BEGAN=Gk,t.STATE_CHANGED=Wk,t.STATE_ENDED=Yk,t.STATE_RECOGNIZED=Vk,t.STATE_CANCELLED=Uk,t.STATE_FAILED=Xk,t.Manager=hx,t.Input=gk,t.TouchAction=nk,t.TouchInput=Ok,t.MouseInput=Mk,t.PointerEventInput=_k,t.TouchMouseInput=Bk,t.SingleTouchInput=px,t.Recognizer=Zk,t.AttrRecognizer=Jk,t.Tap=Qk,t.Pan=ex,t.Swipe=ix,t.Pinch=nx,t.Rotate=ox,t.Press=rx,t.on=mk,t.off=fk,t.each=tk,t.merge=gx,t.extend=vx,t.bindFn=bx,t.assign=gw,t.inherit=yx,t.bindFn=bx,t.prefixed=Cw,t.toArray=Ck,t.inArray=yk,t.uniqueArray=Sk,t.splitStr=pk,t.boolOrFn=ek,t.hasParent=ok,t.addEventListeners=mk,t.removeEventListeners=fk,t.defaults=gw({},sx,{preset:ax}),t}();wx.defaults;var kx=wx;function xx(t,e){var i=Vm(t);if(vp){var n=vp(t);e&&(n=Dp(n).call(n,(function(e){return Bp(t,e).enumerable}))),i.push.apply(i,n)}return i}function _x(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?cp(i=xx(Object(o),!0)).call(i,(function(e){cm(t,e,o[e])})):Jp?um(t,Jp(o)):cp(n=xx(Object(o))).call(n,(function(e){Xm(t,e,Bp(o,e))}))}return t}function Cx(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Sx(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Sx(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Sx(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var Dx=Iv("DELETE");function Tx(){var t=Ox.apply(void 0,arguments);return Ax(t),t}function Ox(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var n;if(e.length>2)return Ox.apply(void 0,zv(n=[Tx(e[0],e[1])]).call(n,Ev(Gv(e).call(e,2))));var o,r=e[0],s=e[1],a=Cx(Uv(s));try{for(a.s();!(o=a.n()).done;){var l=o.value;Object.prototype.propertyIsEnumerable.call(s,l)&&(s[l]===Dx?delete r[l]:null===r[l]||null===s[l]||"object"!==_c(r[l])||"object"!==_c(s[l])||Dd(r[l])||Dd(s[l])?r[l]=Ex(s[l]):r[l]=Ox(r[l],s[l]))}}catch(t){a.e(t)}finally{a.f()}return r}function Ex(t){return Dd(t)?km(t).call(t,(function(t){return Ex(t)})):"object"===_c(t)&&null!==t?Ox({},t):t}function Ax(t){for(var e=0,i=Vm(t);e<i.length;e++){var n=i[e];t[n]===Dx?delete t[n]:"object"===_c(t[n])&&null!==t[n]&&Ax(t[n])}}var Ix="undefined"!=typeof window?window.Hammer||kx:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function Px(t){var e,i=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){i._dom.overlay.parentNode.removeChild(i._dom.overlay)}));var n=Ix(this._dom.overlay);n.on("tap",Od(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];cp(o).call(o,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||i.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",i._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&i.deactivate()}}dw(Px.prototype),Px.current=null,Px.prototype.destroy=function(){var t,e;this.deactivate();var i,n=Cx(dg(t=Gg(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(i=n.n()).done;){(0,i.value)()}}catch(t){n.e(t)}finally{n.f()}},Px.prototype.activate=function(){Px.current&&Px.current.deactivate(),Px.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Px.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Px.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Mx=/^\/?Date\((-?\d+)/i,Nx=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Fx=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Rx=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Lx=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function jx(t){return t instanceof Number||"number"==typeof t}function Bx(t){return t instanceof String||"string"==typeof t}function zx(t){return"object"===_c(t)&&null!==t}function Hx(t,e,i,n){var o=!1;!0===n&&(o=null===e[i]&&void 0!==t[i]),o?delete t[i]:t[i]=e[i]}var Gx=sy;function Wx(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var o in e)if(Object.prototype.hasOwnProperty.call(e,o)||!0===i)if("object"===_c(e[o])&&null!==e[o]&&My(e[o])===Object.prototype)void 0===t[o]?t[o]=Wx({},e[o],i):"object"===_c(t[o])&&null!==t[o]&&My(t[o])===Object.prototype?Wx(t[o],e[o],i):Hx(t,e,o,n);else if(Dd(e[o])){var r;t[o]=Gv(r=e[o]).call(r)}else Hx(t,e,o,n);return t}function Yx(t){var e=_c(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Dd(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function Vx(t,e){var i;return zv(i=[]).call(i,Ev(t),[e])}function Ux(t){return Gv(t).call(t)}var Xx=Vy;var qx={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),Bx(t)?t:jx(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function Kx(t){var e;switch(t.length){case 3:case 4:return(e=Fx.exec(t))?{r:vb(e[1]+e[1],16),g:vb(e[2]+e[2],16),b:vb(e[3]+e[3],16)}:null;case 6:case 7:return(e=Nx.exec(t))?{r:vb(e[1],16),g:vb(e[2],16),b:vb(e[3],16)}:null;default:return null}}function $x(t,e,i){var n;return"#"+Gv(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function Zx(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),o=Math.max(t,Math.max(e,i));return n===o?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(o-n))/360,s:(o-n)/o,v:o}}var Qx={split:function(t){var e,i={};return cp(e=t.split(";")).call(e,(function(t){if(""!=Wb(t).call(t)){var e,n,o=t.split(":"),r=Wb(e=o[0]).call(e),s=Wb(n=o[1]).call(n);i[r]=s}})),i},join:function(t){var e;return km(e=Vm(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function Jx(t,e,i){var n,o,r,s=Math.floor(6*t),a=6*t-s,l=i*(1-e),h=i*(1-a*e),u=i*(1-(1-a)*e);switch(s%6){case 0:n=i,o=u,r=l;break;case 1:n=h,o=i,r=l;break;case 2:n=l,o=i,r=u;break;case 3:n=l,o=h,r=i;break;case 4:n=u,o=l,r=i;break;case 5:n=i,o=l,r=h}return{r:Math.floor(255*n),g:Math.floor(255*o),b:Math.floor(255*r)}}function t_(t,e,i){var n=Jx(t,e,i);return $x(n.r,n.g,n.b)}function e_(t){var e=Kx(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return Zx(e.r,e.g,e.b)}function i_(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function n_(t){return Rx.test(t)}function o_(t){return Lx.test(t)}function r_(t){if(null===t||"object"!==_c(t))return null;if(t instanceof Element)return t;var e=Vb(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==_c(t[i])&&(e[i]=r_(t[i]));return e}var s_={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},a_=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Go(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Pc(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return s_[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===Bx(t)){if(!0===n_(t)){var o=t.substr(4).substr(0,t.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(!0===o_(t)){var r=t.substr(5).substr(0,t.length-6).split(",");i={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===i_(t)){var s=Kx(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Zb(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=sy({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",$d((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=sy({},t)),this.color=t;var e=Zx(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,o=this.centerCoordinates.x+n*Math.sin(i*e.h),r=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=o-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=r-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=Zx(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=Jx(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=Zx(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),hw(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var o=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var r=document.createElement("DIV");r.style.color="red",r.style.fontWeight="bold",r.style.padding="10px",r.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(r)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Od(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Od(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Od(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Od(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Ix(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,o,r=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,s),this.centerCoordinates={x:.5*r,y:.5*s},this.r=.49*r;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(o=0;o<this.r;o++)e=this.centerCoordinates.x+o*Math.sin(l*n),i=this.centerCoordinates.y+o*Math.cos(l*n),a=Jx(.002777777777777778*n,o*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,o=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,s=i-r,a=n-o,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),r),u=Math.cos(l)*h+o,c=Math.sin(l)*h+r;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=c-.5*this.colorPickerSelector.clientWidth+"px";var d=l/(2*Math.PI);d=d<0?d+1:d;var p=h/this.r,m=Zx(this.color.r,this.color.g,this.color.b);m.h=d,m.s=p;var f=Jx(m.h,m.s,m.v);f.a=this.color.a,this.color=f,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function l_(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var n=document.createElement(e[0]);return n.appendChild(l_.apply(void 0,Ev(Gv(e).call(e,1)))),n}var h_,u_=function(){function t(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,r=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};Go(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.hideOption=r,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},sy(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new a_(o),this.wrapper=void 0}return Pc(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(Dd(t))this.options.filter=t.join();else if("object"===_c(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==Dp(t)&&(this.options.filter=Dp(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===Dp(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=Dp(this.options),e=0,i=!1;for(var n in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===Ab(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return cp(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");if(n.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===i){for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(l_("i","b",t))}else n.innerText=t+":";return n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var o=0;void 0!==e&&-1!==Ab(t).call(t,e)&&(o=Ab(t).call(t,e));for(var r=0;r<t.length;r++){var s=document.createElement("option");s.value=t[r],r===o&&(s.selected="selected"),s.innerText=t[r],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],o=t[1],r=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=o,a.max=r}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<o?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<o&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>r&&1!==r&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var c=document.createElement("input");c.className="vis-configuration vis-config-rangeinput",c.value=a.value;var d=this;a.onchange=function(){c.value=this.value,d._update(Number(this.value),i)},a.oninput=function(){c.value=this.value};var p=this._makeLabel(i[i.length-1],i),m=this._makeItem(i,p,a,c);""!==l&&this.popupHistory[m]!==h&&(this.popupHistory[m]=h,this._setupPopup(l,m))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerText=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=$d((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=$d((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===_c(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var o=this;n.onchange=function(){o._update(this.checked,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var o=this;n.onchange=function(){o._update(this.value,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,o=t[1],r=document.createElement("div");"none"!==(e=void 0===e?o:e)?(r.className="vis-configuration vis-config-colorBlock",r.style.backgroundColor=e):r.className="vis-configuration vis-config-colorBlock none",e=void 0===e?o:e,r.onclick=function(){n._showColorPicker(e,r,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,r)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var o="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=o,n._update(o,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=Dp(this.options),r=!1;for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){n=!0;var a=t[s],l=Vx(e,s);if("function"==typeof o&&!1===(n=o(s,e))&&!Dd(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){r=!0;var h=this._getValue(l);if(Dd(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){if(!this.hideOption(e,s,this.moduleOptions))if(void 0!==a.enabled){var u=Vx(l,"enabled"),c=this._getValue(u);if(!0===c){var d=this._makeLabel(s,l,!0);this._makeItem(l,d),r=this._handleObject(a,l)||r}else this._makeCheckbox(a,c,l)}else{var p=this._makeLabel(s,l,!0);this._makeItem(l,p),r=this._handleObject(a,l)||r}}else console.error("dont know how to handle",a,s,l)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var o=0;o<e.length;o++)"global"!==e[o]&&(void 0===n[e[o]]&&(n[e[o]]={}),o!==e.length-1?n=n[e[o]]:n[e[o]]=t);return i}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(l_("pre","const options = "+Zb(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),c_=function(){function t(e,i){Go(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Pc(t,[{key:"setPosition",value:function(t,e){this.x=vb(t),this.y=vb(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,r=0,s=0;if("flip"==this.overflowMethod){var a=!1,l=!0;this.y-e<this.padding&&(l=!1),this.x+i>o-this.padding&&(a=!0),r=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(r=this.x)+i+this.padding>o&&(r=o-i-this.padding),r<this.padding&&(r=this.padding);this.frame.style.left=r+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),d_=!1,p_="background: #FFeeee; color: #dd0000",m_=function(){function t(){Go(this,t)}return Pc(t,null,[{key:"validate",value:function(e,i,n){d_=!1,h_=i;var o=i;return void 0!==n&&(o=i[n]),t.parse(e,o,[]),d_}},{key:"parse",value:function(e,i,n){for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.check(o,e,i,n)}},{key:"check",value:function(e,i,n,o){if(void 0!==n[e]||void 0!==n.__any__){var r=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(r="__any__",s="object"===t.getType(i[e]));var a=n[r];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,r,a,o)}else t.getSuggestion(e,n,o)}},{key:"checkFields",value:function(e,i,n,o,r,s){var a=function(i){console.error("%c"+i+t.printLocation(s,e),p_)},l=t.getType(i[e]),h=r[l];void 0!==h?"array"===t.getType(h)&&-1===Ab(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),d_=!0):"object"===l&&"__any__"!==o&&(s=Vx(s,e),t.parse(i[e],n[o],s)):void 0===r.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(Vm(r))+". Received ["+l+'] "'+i[e]+'"'),d_=!0)}},{key:"getType",value:function(t){var e=_c(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Dd(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var o,r=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,h_,[],!0);o=void 0!==r.indexMatch?" in "+t.printLocation(r.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+r.indexMatch+'"?\n\n':s.distance<=4&&r.distance>s.distance?" in "+t.printLocation(r.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):r.distance<=8?'. Did you mean "'+r.closestMatch+'"?'+t.printLocation(r.path,e):". Did you mean one of these: "+t.print(Vm(i))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+o,p_),d_=!0}},{key:"findInOptions",value:function(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var c=void 0;if(void 0!==i[u].__type__&&!0===o){var d=t.findInOptions(e,i[u],Vx(n,u));r>d.distance&&(s=d.closestMatch,a=d.path,r=d.distance,h=d.indexMatch)}else{var p;-1!==Ab(p=u.toLowerCase()).call(p,l)&&(h=u),r>(c=t.levenshteinDistance(e,u))&&(s=u,a=Ux(n),r=c)}}return{closestMatch:s,path:a,distance:r,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)i+="  ";i+=t[n]+": {\n"}for(var r=0;r<t.length+1;r++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Zb(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,o=[];for(i=0;i<=e.length;i++)o[i]=[i];for(n=0;n<=t.length;n++)o[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?o[i][n]=o[i-1][n-1]:o[i][n]=Math.min(o[i-1][n-1]+1,Math.min(o[i][n-1]+1,o[i-1][n]+1));return o[e.length][t.length]}}]),t}(),f_=Px,v_=a_,g_=u_,y_=Ix,b_=c_,w_=p_,k_=m_,x_=Object.freeze({__proto__:null,Activator:f_,Alea:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var o=.02519603282416938*(t+=i.charCodeAt(n));o-=t=o>>>0,t=(o*=t)>>>0,t+=4294967296*(o-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),i=t(" "),n=t(" "),o=0;o<arguments.length;o++)(e-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(e+=1),(i-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(i+=1),(n-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(n+=1);return[e,i,n]}(t),i=Ov(e,3),n=i[0],o=i[1],r=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=o,o=r,r=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}(e.length?e:[Jv()])},ColorPicker:v_,Configurator:g_,DELETE:Dx,HSVToHex:t_,HSVToRGB:Jx,Hammer:y_,Popup:b_,RGBToHSV:Zx,RGBToHex:$x,VALIDATOR_PRINT_STYLE:w_,Validator:k_,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=zv(i).call(i,Dp(n).call(n,(function(t){return!Iy(i).call(i,t)}))),t.className=i.join(" ")},addCssText:function(t,e){var i=Qx.split(t.style.cssText),n=Qx.split(e),o=_x(_x({},i),n);t.style.cssText=Qx.join(o)},addEventListener:function(t,e,i,n){var o;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Iy(o=navigator.userAgent).call(o,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)},binarySearchCustom:function(t,e,i,n){for(var o=0,r=0,s=t.length-1;r<=s&&o<1e4;){var a=Math.floor((r+s)/2),l=t[a],h=e(void 0===n?l[i]:l[i][n]);if(0==h)return a;-1==h?r=a+1:s=a-1,o++}return-1},binarySearchValue:function(t,e,i,n,o){var r,s,a,l,h=0,u=0,c=t.length-1;for(o=null!=o?o:function(t,e){return t==e?0:t<e?-1:1};u<=c&&h<1e4;){if(l=Math.floor(.5*(c+u)),r=t[Math.max(0,l-1)][i],s=t[l][i],a=t[Math.min(t.length-1,l+1)][i],0==o(s,e))return l;if(o(r,e)<0&&o(s,e)>0)return"before"==n?Math.max(0,l-1):l;if(o(s,e)<0&&o(a,e)>0)return"before"==n?l:Math.min(t.length-1,l+1);o(s,e)<0?u=l+1:c=l-1,h++}return-1},bridgeObject:r_,copyAndExtendArray:Vx,copyArray:Ux,deepExtend:Wx,deepObjectAssign:Tx,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:Gx,fillIfDefined:function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var o in e)if(void 0!==i[o])if(null===i[o]||"object"!==_c(i[o]))Hx(e,i,o,n);else{var r=e[o],s=i[o];zx(r)&&zx(s)&&t(r,s,n)}},forEach:function(t,e){if(Dd(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&e(t[o],o,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:Yx,hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:e_,hexToRGB:Kx,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],o=void 0;for(o=i;o>0&&e(n,t[o-1])<0;o--)t[o]=t[o-1];t[o]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(Bx(t)){if(Mx.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:jx,isObject:zx,isString:Bx,isValidHex:i_,isValidRGB:n_,isValidRGBA:o_,mergeOptions:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=function(t){return null!=t},r=function(t){return null!==t&&"object"===_c(t)};if(!r(t))throw new Error("Parameter mergeTarget must be an object");if(!r(e))throw new Error("Parameter options must be an object");if(!o(i))throw new Error("Parameter option must have a value");if(!r(n))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=r(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[i]:void 0,l=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return r(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!r(t[i])){if(!o(a))return;t[i]=Vb(a)}if(r(s)){var h=!0;void 0!==s.enabled?h=s.enabled:void 0!==l&&(h=a.enabled),function(t,e,i){r(t[i])||(t[i]={});var n=e[i],o=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(o[s]=n[s])}(t,e,i),t[i].enabled=h}}},option:qx,overrideOpacity:function(t,e){if(Iy(t).call(t,"rgba"))return t;if(Iy(t).call(t,"rgb")){var i=t.substr(Ab(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=Kx(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},parseColor:function(t,e){if(Bx(t)){var i=t;if(n_(i)){var n,o=km(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return vb(t)}));i=$x(o[0],o[1],o[2])}if(!0===i_(i)){var r=e_(i),s={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},a={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},l=t_(a.h,a.s,a.v),h=t_(s.h,s.s,s.v);return{background:i,border:l,highlight:{background:h,border:l},hover:{background:h,border:l}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:Bx(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:Bx(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:Bx(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:Bx(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:function(t){for(var e,i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return Tx.apply(void 0,zv(e=[{},t]).call(e,n))},recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Dp(i).call(i,(function(t){return!Iy(n).call(n,t)})),t.className=i.join(" ")},removeCssText:function(t,e){var i=Qx.split(t.style.cssText),n=Qx.split(e);for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&delete i[o];t.style.cssText=Qx.join(i)},removeEventListener:function(t,e,i,n){var o;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Iy(o=navigator.userAgent).call(o,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)},selectiveBridgeObject:function(t,e){if(null!==e&&"object"===_c(e)){for(var i=Vb(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==_c(e[t[n]])&&(i[t[n]]=r_(e[t[n]]));return i}return null},selectiveDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Dd(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o=0;o<t.length;o++){var r=t[o];if(Object.prototype.hasOwnProperty.call(i,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?Wx(e[r],i[r],!1,n):Hx(e,i,r,n);else{if(Dd(i[r]))throw new TypeError("Arrays are not supported by deepExtend");Hx(e,i,r,n)}}return e},selectiveExtend:function(t,e){if(!Dd(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),o=2;o<i;o++)n[o-2]=arguments[o];for(var r=0,s=n;r<s.length;r++)for(var a=s[r],l=0;l<t.length;l++){var h=t[l];a&&Object.prototype.hasOwnProperty.call(a,h)&&(e[h]=a[h])}return e},selectiveNotDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Dd(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o in i)if(Object.prototype.hasOwnProperty.call(i,o)&&!Iy(t).call(t,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Wx(e[o],i[o]):Hx(e,i,o,n);else if(Dd(i[o])){e[o]=[];for(var r=0;r<i[o].length;r++)e[o].push(i[o][r])}else Hx(e,i,o,n);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Xx,topMost:function(t,e){var i;Dd(e)||(e=[e]);var n,o=Cx(t);try{for(o.s();!(n=o.n()).done;){var r=n.value;if(r){i=r[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){o.e(t)}finally{o.f()}return i},updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}}),__={},C_={get exports(){return __},set exports(t){__=t}},S_={},D_={},T_={get exports(){return D_},set exports(t){D_=t}},O_={};function E_(){var t={"align-content":!1,"align-items":!1,"align-self":!1,"alignment-adjust":!1,"alignment-baseline":!1,all:!1,"anchor-point":!1,animation:!1,"animation-delay":!1,"animation-direction":!1,"animation-duration":!1,"animation-fill-mode":!1,"animation-iteration-count":!1,"animation-name":!1,"animation-play-state":!1,"animation-timing-function":!1,azimuth:!1,"backface-visibility":!1,background:!0,"background-attachment":!0,"background-clip":!0,"background-color":!0,"background-image":!0,"background-origin":!0,"background-position":!0,"background-repeat":!0,"background-size":!0,"baseline-shift":!1,binding:!1,bleed:!1,"bookmark-label":!1,"bookmark-level":!1,"bookmark-state":!1,border:!0,"border-bottom":!0,"border-bottom-color":!0,"border-bottom-left-radius":!0,"border-bottom-right-radius":!0,"border-bottom-style":!0,"border-bottom-width":!0,"border-collapse":!0,"border-color":!0,"border-image":!0,"border-image-outset":!0,"border-image-repeat":!0,"border-image-slice":!0,"border-image-source":!0,"border-image-width":!0,"border-left":!0,"border-left-color":!0,"border-left-style":!0,"border-left-width":!0,"border-radius":!0,"border-right":!0,"border-right-color":!0,"border-right-style":!0,"border-right-width":!0,"border-spacing":!0,"border-style":!0,"border-top":!0,"border-top-color":!0,"border-top-left-radius":!0,"border-top-right-radius":!0,"border-top-style":!0,"border-top-width":!0,"border-width":!0,bottom:!1,"box-decoration-break":!0,"box-shadow":!0,"box-sizing":!0,"box-snap":!0,"box-suppress":!0,"break-after":!0,"break-before":!0,"break-inside":!0,"caption-side":!1,chains:!1,clear:!0,clip:!1,"clip-path":!1,"clip-rule":!1,color:!0,"color-interpolation-filters":!0,"column-count":!1,"column-fill":!1,"column-gap":!1,"column-rule":!1,"column-rule-color":!1,"column-rule-style":!1,"column-rule-width":!1,"column-span":!1,"column-width":!1,columns:!1,contain:!1,content:!1,"counter-increment":!1,"counter-reset":!1,"counter-set":!1,crop:!1,cue:!1,"cue-after":!1,"cue-before":!1,cursor:!1,direction:!1,display:!0,"display-inside":!0,"display-list":!0,"display-outside":!0,"dominant-baseline":!1,elevation:!1,"empty-cells":!1,filter:!1,flex:!1,"flex-basis":!1,"flex-direction":!1,"flex-flow":!1,"flex-grow":!1,"flex-shrink":!1,"flex-wrap":!1,float:!1,"float-offset":!1,"flood-color":!1,"flood-opacity":!1,"flow-from":!1,"flow-into":!1,font:!0,"font-family":!0,"font-feature-settings":!0,"font-kerning":!0,"font-language-override":!0,"font-size":!0,"font-size-adjust":!0,"font-stretch":!0,"font-style":!0,"font-synthesis":!0,"font-variant":!0,"font-variant-alternates":!0,"font-variant-caps":!0,"font-variant-east-asian":!0,"font-variant-ligatures":!0,"font-variant-numeric":!0,"font-variant-position":!0,"font-weight":!0,grid:!1,"grid-area":!1,"grid-auto-columns":!1,"grid-auto-flow":!1,"grid-auto-rows":!1,"grid-column":!1,"grid-column-end":!1,"grid-column-start":!1,"grid-row":!1,"grid-row-end":!1,"grid-row-start":!1,"grid-template":!1,"grid-template-areas":!1,"grid-template-columns":!1,"grid-template-rows":!1,"hanging-punctuation":!1,height:!0,hyphens:!1,icon:!1,"image-orientation":!1,"image-resolution":!1,"ime-mode":!1,"initial-letters":!1,"inline-box-align":!1,"justify-content":!1,"justify-items":!1,"justify-self":!1,left:!1,"letter-spacing":!0,"lighting-color":!0,"line-box-contain":!1,"line-break":!1,"line-grid":!1,"line-height":!1,"line-snap":!1,"line-stacking":!1,"line-stacking-ruby":!1,"line-stacking-shift":!1,"line-stacking-strategy":!1,"list-style":!0,"list-style-image":!0,"list-style-position":!0,"list-style-type":!0,margin:!0,"margin-bottom":!0,"margin-left":!0,"margin-right":!0,"margin-top":!0,"marker-offset":!1,"marker-side":!1,marks:!1,mask:!1,"mask-box":!1,"mask-box-outset":!1,"mask-box-repeat":!1,"mask-box-slice":!1,"mask-box-source":!1,"mask-box-width":!1,"mask-clip":!1,"mask-image":!1,"mask-origin":!1,"mask-position":!1,"mask-repeat":!1,"mask-size":!1,"mask-source-type":!1,"mask-type":!1,"max-height":!0,"max-lines":!1,"max-width":!0,"min-height":!0,"min-width":!0,"move-to":!1,"nav-down":!1,"nav-index":!1,"nav-left":!1,"nav-right":!1,"nav-up":!1,"object-fit":!1,"object-position":!1,opacity:!1,order:!1,orphans:!1,outline:!1,"outline-color":!1,"outline-offset":!1,"outline-style":!1,"outline-width":!1,overflow:!1,"overflow-wrap":!1,"overflow-x":!1,"overflow-y":!1,padding:!0,"padding-bottom":!0,"padding-left":!0,"padding-right":!0,"padding-top":!0,page:!1,"page-break-after":!1,"page-break-before":!1,"page-break-inside":!1,"page-policy":!1,pause:!1,"pause-after":!1,"pause-before":!1,perspective:!1,"perspective-origin":!1,pitch:!1,"pitch-range":!1,"play-during":!1,position:!1,"presentation-level":!1,quotes:!1,"region-fragment":!1,resize:!1,rest:!1,"rest-after":!1,"rest-before":!1,richness:!1,right:!1,rotation:!1,"rotation-point":!1,"ruby-align":!1,"ruby-merge":!1,"ruby-position":!1,"shape-image-threshold":!1,"shape-outside":!1,"shape-margin":!1,size:!1,speak:!1,"speak-as":!1,"speak-header":!1,"speak-numeral":!1,"speak-punctuation":!1,"speech-rate":!1,stress:!1,"string-set":!1,"tab-size":!1,"table-layout":!1,"text-align":!0,"text-align-last":!0,"text-combine-upright":!0,"text-decoration":!0,"text-decoration-color":!0,"text-decoration-line":!0,"text-decoration-skip":!0,"text-decoration-style":!0,"text-emphasis":!0,"text-emphasis-color":!0,"text-emphasis-position":!0,"text-emphasis-style":!0,"text-height":!0,"text-indent":!0,"text-justify":!0,"text-orientation":!0,"text-overflow":!0,"text-shadow":!0,"text-space-collapse":!0,"text-transform":!0,"text-underline-position":!0,"text-wrap":!0,top:!1,transform:!1,"transform-origin":!1,"transform-style":!1,transition:!1,"transition-delay":!1,"transition-duration":!1,"transition-property":!1,"transition-timing-function":!1,"unicode-bidi":!1,"vertical-align":!1,visibility:!1,"voice-balance":!1,"voice-duration":!1,"voice-family":!1,"voice-pitch":!1,"voice-range":!1,"voice-rate":!1,"voice-stress":!1,"voice-volume":!1,volume:!1,"white-space":!1,widows:!1,width:!0,"will-change":!1,"word-break":!0,"word-spacing":!0,"word-wrap":!0,"wrap-flow":!1,"wrap-through":!1,"writing-mode":!1,"z-index":!1};return t}var A_=/javascript\s*\:/gim;O_.whiteList=E_(),O_.getDefaultWhiteList=E_,O_.onAttr=function(t,e,i){},O_.onIgnoreAttr=function(t,e,i){},O_.safeAttrValue=function(t,e){return A_.test(e)?"":e};var I_={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,o;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,o=t.length;n<o;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},trimRight:function(t){return String.prototype.trimRight?t.trimRight():t.replace(/(\s*$)/g,"")}};var P_=function(t,e){";"!==(t=I_.trimRight(t))[t.length-1]&&(t+=";");var i=t.length,n=!1,o=0,r=0,s="";function a(){if(!n){var i=I_.trim(t.slice(o,r)),a=i.indexOf(":");if(-1!==a){var l=I_.trim(i.slice(0,a)),h=I_.trim(i.slice(a+1));if(l){var u=e(o,s.length,l,h,i);u&&(s+=u+"; ")}}}o=r+1}for(;r<i;r++){var l=t[r];if("/"===l&&"*"===t[r+1]){var h=t.indexOf("*/",r+2);if(-1===h)break;o=(r=h+1)+1,n=!1}else"("===l?n=!0:")"===l?n=!1:";"===l?n||a():"\n"===l&&a()}return I_.trim(s)},M_=O_,N_=P_;function F_(t){return null==t}function R_(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).whiteList=t.whiteList||M_.whiteList,t.onAttr=t.onAttr||M_.onAttr,t.onIgnoreAttr=t.onIgnoreAttr||M_.onIgnoreAttr,t.safeAttrValue=t.safeAttrValue||M_.safeAttrValue,this.options=t}R_.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onAttr,o=e.onIgnoreAttr,r=e.safeAttrValue,s=N_(t,(function(t,e,s,a,l){var h=i[s],u=!1;if(!0===h?u=h:"function"==typeof h?u=h(a):h instanceof RegExp&&(u=h.test(a)),!0!==u&&(u=!1),a=r(s,a)){var c,d={position:e,sourcePosition:t,source:l,isWhite:u};return u?F_(c=n(s,a,d))?s+":"+a:c:F_(c=o(s,a,d))?void 0:c}}));return s};var L_=R_;!function(t,e){var i=O_,n=L_;for(var o in e=t.exports=function(t,e){return new n(e).process(t)},e.FilterCSS=n,i)e[o]=i[o];"undefined"!=typeof window&&(window.filterCSS=t.exports)}(T_,D_);var j_={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,o;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,o=t.length;n<o;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},spaceIndex:function(t){var e=/\s|\n|\t/.exec(t);return e?e.index:-1}},B_=D_.FilterCSS,z_=D_.getDefaultWhiteList,H_=j_;function G_(){return{a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height"],ins:["datetime"],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]}}var W_=new B_;function Y_(t){return t.replace(V_,"&lt;").replace(U_,"&gt;")}var V_=/</g,U_=/>/g,X_=/"/g,q_=/&quot;/g,K_=/&#([a-zA-Z0-9]*);?/gim,$_=/&colon;?/gim,Z_=/&newline;?/gim,Q_=/((j\s*a\s*v\s*a|v\s*b|l\s*i\s*v\s*e)\s*s\s*c\s*r\s*i\s*p\s*t\s*|m\s*o\s*c\s*h\s*a):/gi,J_=/e\s*x\s*p\s*r\s*e\s*s\s*s\s*i\s*o\s*n\s*\(.*/gi,tC=/u\s*r\s*l\s*\(.*/gi;function eC(t){return t.replace(X_,"&quot;")}function iC(t){return t.replace(q_,'"')}function nC(t){return t.replace(K_,(function(t,e){return"x"===e[0]||"X"===e[0]?String.fromCharCode(parseInt(e.substr(1),16)):String.fromCharCode(parseInt(e,10))}))}function oC(t){return t.replace($_,":").replace(Z_," ")}function rC(t){for(var e="",i=0,n=t.length;i<n;i++)e+=t.charCodeAt(i)<32?" ":t.charAt(i);return H_.trim(e)}function sC(t){return t=rC(t=oC(t=nC(t=iC(t))))}function aC(t){return t=Y_(t=eC(t))}S_.whiteList={a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height"],ins:["datetime"],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]},S_.getDefaultWhiteList=G_,S_.onTag=function(t,e,i){},S_.onIgnoreTag=function(t,e,i){},S_.onTagAttr=function(t,e,i){},S_.onIgnoreTagAttr=function(t,e,i){},S_.safeAttrValue=function(t,e,i,n){if(i=sC(i),"href"===e||"src"===e){if("#"===(i=H_.trim(i)))return"#";if("http://"!==i.substr(0,7)&&"https://"!==i.substr(0,8)&&"mailto:"!==i.substr(0,7)&&"tel:"!==i.substr(0,4)&&"data:image/"!==i.substr(0,11)&&"ftp://"!==i.substr(0,6)&&"./"!==i.substr(0,2)&&"../"!==i.substr(0,3)&&"#"!==i[0]&&"/"!==i[0])return""}else if("background"===e){if(Q_.lastIndex=0,Q_.test(i))return""}else if("style"===e){if(J_.lastIndex=0,J_.test(i))return"";if(tC.lastIndex=0,tC.test(i)&&(Q_.lastIndex=0,Q_.test(i)))return"";!1!==n&&(i=(n=n||W_).process(i))}return i=aC(i)},S_.escapeHtml=Y_,S_.escapeQuote=eC,S_.unescapeQuote=iC,S_.escapeHtmlEntities=nC,S_.escapeDangerHtml5Entities=oC,S_.clearNonPrintableCharacter=rC,S_.friendlyAttrValue=sC,S_.escapeAttrValue=aC,S_.onIgnoreTagStripAll=function(){return""},S_.StripTagBody=function(t,e){"function"!=typeof e&&(e=function(){});var i=!Array.isArray(t),n=[],o=!1;return{onIgnoreTag:function(r,s,a){if(function(e){return!!i||-1!==H_.indexOf(t,e)}(r)){if(a.isClosing){var l="[/removed]",h=a.position+l.length;return n.push([!1!==o?o:a.position,h]),o=!1,l}return o||(o=a.position),"[removed]"}return e(r,s,a)},remove:function(t){var e="",i=0;return H_.forEach(n,(function(n){e+=t.slice(i,n[0]),i=n[1]})),e+=t.slice(i)}}},S_.stripCommentTag=function(t){for(var e="",i=0;i<t.length;){var n=t.indexOf("\x3c!--",i);if(-1===n){e+=t.slice(i);break}e+=t.slice(i,n);var o=t.indexOf("--\x3e",n);if(-1===o)break;i=o+3}return e},S_.stripBlankChar=function(t){var e=t.split("");return(e=e.filter((function(t){var e=t.charCodeAt(0);return 127!==e&&(!(e<=31)||(10===e||13===e))}))).join("")},S_.cssFilter=W_,S_.getDefaultCSSWhiteList=z_;var lC={},hC=j_;function uC(t){var e,i=hC.spaceIndex(t);return e=-1===i?t.slice(1,-1):t.slice(1,i+1),"/"===(e=hC.trim(e).toLowerCase()).slice(0,1)&&(e=e.slice(1)),"/"===e.slice(-1)&&(e=e.slice(0,-1)),e}function cC(t){return"</"===t.slice(0,2)}var dC=/[^a-zA-Z0-9\\_:.-]/gim;function pC(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"="===i?e:-1}}function mC(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"'"===i||'"'===i?e:-1}}function fC(t,e){for(;e>0;e--){var i=t[e];if(" "!==i)return"="===i?e:-1}}function vC(t){return function(t){return'"'===t[0]&&'"'===t[t.length-1]||"'"===t[0]&&"'"===t[t.length-1]}(t)?t.substr(1,t.length-2):t}lC.parseTag=function(t,e,i){var n="",o=0,r=!1,s=!1,a=0,l=t.length,h="",u="";t:for(a=0;a<l;a++){var c=t.charAt(a);if(!1===r){if("<"===c){r=a;continue}}else if(!1===s){if("<"===c){n+=i(t.slice(o,a)),r=a,o=a;continue}if(">"===c||a===l-1){n+=i(t.slice(o,r)),h=uC(u=t.slice(r,a+1)),n+=e(r,n.length,h,u,cC(u)),o=a+1,r=!1;continue}if('"'===c||"'"===c)for(var d=1,p=t.charAt(a-d);""===p.trim()||"="===p;){if("="===p){s=c;continue t}p=t.charAt(a-++d)}}else if(c===s){s=!1;continue}}return o<l&&(n+=i(t.substr(o))),n},lC.parseAttr=function(t,e){var i=0,n=0,o=[],r=!1,s=t.length;function a(t,i){if(!((t=(t=hC.trim(t)).replace(dC,"").toLowerCase()).length<1)){var n=e(t,i||"");n&&o.push(n)}}for(var l=0;l<s;l++){var h,u=t.charAt(l);if(!1!==r||"="!==u)if(!1===r||l!==n)if(/\s|\n|\t/.test(u)){if(t=t.replace(/\s|\n|\t/g," "),!1===r){if(-1===(h=pC(t,l))){a(hC.trim(t.slice(i,l))),r=!1,i=l+1;continue}l=h-1;continue}if(-1===(h=fC(t,l-1))){a(r,vC(hC.trim(t.slice(i,l)))),r=!1,i=l+1;continue}}else;else{if(-1===(h=t.indexOf(u,l+1)))break;a(r,hC.trim(t.slice(n+1,h))),r=!1,i=(l=h)+1}else r=t.slice(i,l),i=l+1,n='"'===t.charAt(i)||"'"===t.charAt(i)?i:mC(t,l+1)}return i<t.length&&(!1===r?a(t.slice(i)):a(r,vC(hC.trim(t.slice(i))))),hC.trim(o.join(" "))};var gC=D_.FilterCSS,yC=S_,bC=lC,wC=bC.parseTag,kC=bC.parseAttr,xC=j_;function _C(t){return null==t}function CC(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).stripIgnoreTag&&(t.onIgnoreTag&&console.error('Notes: cannot use these two options "stripIgnoreTag" and "onIgnoreTag" at the same time'),t.onIgnoreTag=yC.onIgnoreTagStripAll),t.whiteList||t.allowList?t.whiteList=function(t){var e={};for(var i in t)Array.isArray(t[i])?e[i.toLowerCase()]=t[i].map((function(t){return t.toLowerCase()})):e[i.toLowerCase()]=t[i];return e}(t.whiteList||t.allowList):t.whiteList=yC.whiteList,t.onTag=t.onTag||yC.onTag,t.onTagAttr=t.onTagAttr||yC.onTagAttr,t.onIgnoreTag=t.onIgnoreTag||yC.onIgnoreTag,t.onIgnoreTagAttr=t.onIgnoreTagAttr||yC.onIgnoreTagAttr,t.safeAttrValue=t.safeAttrValue||yC.safeAttrValue,t.escapeHtml=t.escapeHtml||yC.escapeHtml,this.options=t,!1===t.css?this.cssFilter=!1:(t.css=t.css||{},this.cssFilter=new gC(t.css))}CC.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onTag,o=e.onIgnoreTag,r=e.onTagAttr,s=e.onIgnoreTagAttr,a=e.safeAttrValue,l=e.escapeHtml,h=this.cssFilter;e.stripBlankChar&&(t=yC.stripBlankChar(t)),e.allowCommentTag||(t=yC.stripCommentTag(t));var u=!1;e.stripIgnoreTagBody&&(u=yC.StripTagBody(e.stripIgnoreTagBody,o),o=u.onIgnoreTag);var c=wC(t,(function(t,e,u,c,d){var p={sourcePosition:t,position:e,isClosing:d,isWhite:Object.prototype.hasOwnProperty.call(i,u)},m=n(u,c,p);if(!_C(m))return m;if(p.isWhite){if(p.isClosing)return"</"+u+">";var f=function(t){var e=xC.spaceIndex(t);if(-1===e)return{html:"",closing:"/"===t[t.length-2]};var i="/"===(t=xC.trim(t.slice(e+1,-1)))[t.length-1];return i&&(t=xC.trim(t.slice(0,-1))),{html:t,closing:i}}(c),v=i[u],g=kC(f.html,(function(t,e){var i=-1!==xC.indexOf(v,t),n=r(u,t,e,i);return _C(n)?i?(e=a(u,t,e,h))?t+'="'+e+'"':t:_C(n=s(u,t,e,i))?void 0:n:n}));return c="<"+u,g&&(c+=" "+g),f.closing&&(c+=" /"),c+=">"}return _C(m=o(u,c,p))?l(c):m}),l);return u&&(c=u.remove(c)),c};var SC=CC;!function(t,e){var i=S_,n=lC,o=SC;function r(t,e){return new o(e).process(t)}(e=t.exports=r).filterXSS=r,e.FilterXSS=o,function(){for(var t in i)e[t]=i[t];for(var o in n)e[o]=n[o]}(),"undefined"!=typeof window&&(window.filterXSS=t.exports),"undefined"!=typeof self&&"undefined"!=typeof DedicatedWorkerGlobalScope&&self instanceof DedicatedWorkerGlobalScope&&(self.filterXSS=t.exports)}(C_,__);var DC=__,TC="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),OC=new Uint8Array(16);function EC(){if(!TC)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return TC(OC)}for(var AC=[],IC=0;IC<256;++IC)AC[IC]=(IC+256).toString(16).substr(1);function PC(t,e,i){var n=e&&i||0;"string"==typeof t&&(e="binary"===t?new Array(16):null,t=null);var o=(t=t||{}).random||(t.rng||EC)();if(o[6]=15&o[6]|64,o[8]=63&o[8]|128,e)for(var r=0;r<16;++r)e[n+r]=o[r];return e||function(t,e){var i=e||0,n=AC;return[n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]]].join("")}(o)}function MC(t,e){var i=Vm(t);if(vp){var n=vp(t);e&&(n=Dp(n).call(n,(function(e){return Bp(t,e).enumerable}))),i.push.apply(i,n)}return i}function NC(t){for(var e=1;e<arguments.length;e++){var i,n,o=null!=arguments[e]?arguments[e]:{};e%2?cp(i=MC(Object(o),!0)).call(i,(function(e){cm(t,e,o[e])})):Jp?um(t,Jp(o)):cp(n=MC(Object(o))).call(n,(function(e){Xm(t,e,Bp(o,e))}))}return t}function FC(t){var i;if(!t)return!1;var n=null!==(i=t.idProp)&&void 0!==i?i:t._idProp;return!!n&&e(n,t)}var RC=/^\/?Date\((-?\d+)/i,LC=/^\d+$/;function jC(e,i){var n;if(void 0!==e){if(null===e)return null;if(!i)return e;if("string"!=typeof i&&!(i instanceof String))throw new Error("Type must be a string");switch(i){case"boolean":case"Boolean":return Boolean(e);case"number":case"Number":return Bx(e)&&!isNaN(Date.parse(e))?t(e).valueOf():Number(e.valueOf());case"string":case"String":return String(e);case"Date":try{return jC(e,"Moment").toDate()}catch(t){throw t instanceof TypeError?new TypeError("Cannot convert object of type "+Yx(e)+" to type "+i):t}case"Moment":if(jx(e))return t(e);if(e instanceof Date)return t(e.valueOf());if(t.isMoment(e))return t(e);if(Bx(e))return(n=RC.exec(e))?t(Number(n[1])):(n=LC.exec(e),t(n?Number(e):e));throw new TypeError("Cannot convert object of type "+Yx(e)+" to type "+i);case"ISODate":if(jx(e))return new Date(e);if(e instanceof Date)return e.toISOString();if(t.isMoment(e))return e.toDate().toISOString();if(Bx(e))return(n=RC.exec(e))?new Date(Number(n[1])).toISOString():t(e).format();throw new Error("Cannot convert object of type "+Yx(e)+" to type ISODate");case"ASPDate":if(jx(e))return"/Date("+e+")/";if(e instanceof Date||t.isMoment(e))return"/Date("+e.valueOf()+")/";if(Bx(e))return"/Date("+((n=RC.exec(e))?new Date(Number(n[1])).valueOf():new Date(e).valueOf())+")/";throw new Error("Cannot convert object of type "+Yx(e)+" to type ASPDate");default:throw new Error("Unknown type ".concat(i))}}}function BC(t){var e,i,r,s,a,l,h=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{start:"Date",end:"Date"},u=t._idProp,c=new n({fieldId:u}),d=km(e=o(t)).call(e,(function(t){var e;return Bm(e=Vm(t)).call(e,(function(e,i){return e[i]=jC(t[i],h[i]),e}),{})})).to(c);return d.all().start(),{add:function(){var e;return(e=t.getDataSet()).add.apply(e,arguments)},remove:function(){var e;return(e=t.getDataSet()).remove.apply(e,arguments)},update:function(){var e;return(e=t.getDataSet()).update.apply(e,arguments)},updateOnly:function(){var e;return(e=t.getDataSet()).updateOnly.apply(e,arguments)},clear:function(){var e;return(e=t.getDataSet()).clear.apply(e,arguments)},forEach:Od(i=cp(c)).call(i,c),get:Od(r=c.get).call(r,c),getIds:Od(s=c.getIds).call(s,c),off:Od(a=c.off).call(a,c),on:Od(l=c.on).call(l,c),get length(){return c.length},idProp:u,type:h,rawDS:t,coercedDS:c,dispose:function(){return d.stop()}}}var zC=function(t){var e=new DC.FilterXSS(t);return function(t){return e.process(t)}},HC=function(t){return t},GC=zC(),WC=NC(NC({},x_),{},{convert:jC,setupXSSProtection:function(t){t&&(!0===t.disabled?(GC=HC,console.warn("You disabled XSS protection for vis-Timeline. I sure hope you know what you're doing!")):t.filterOptions&&(GC=zC(t.filterOptions)))}});Xm(WC,"xss",{get:function(){return GC}});var YC={},VC={get exports(){return YC},set exports(t){YC=t}},UC=c,XC=d,qC=Gr,KC=ib.trim,$C=qy,ZC=_("".charAt),QC=UC.parseFloat,JC=UC.Symbol,tS=JC&&JC.iterator,eS=1/QC($C+"-0")!=-1/0||tS&&!XC((function(){QC(Object(tS))}))?function(t){var e=KC(qC(t)),i=QC(e);return 0===i&&"-"==ZC(e,0)?-0:i}:QC;Ni({global:!0,forced:parseFloat!=eS},{parseFloat:eS});var iS=lt.parseFloat;VC.exports=iS;var nS=a(YC),oS=function(){function t(e,i){Go(this,t),this.options=null,this.props=null}return Pc(t,[{key:"setOptions",value:function(t){t&&WC.extend(this.options,t)}},{key:"redraw",value:function(){return!1}},{key:"destroy",value:function(){}},{key:"_isResized",value:function(){var t=this.props._previousWidth!==this.props.width||this.props._previousHeight!==this.props.height;return this.props._previousWidth=this.props.width,this.props._previousHeight=this.props.height,t}}]),t}(),rS={},sS={get exports(){return rS},set exports(t){rS=t}},aS=En,lS=Gr,hS=et,uS=RangeError;Ni({target:"String",proto:!0},{repeat:function(t){var e=lS(hS(this)),i="",n=aS(t);if(n<0||n==1/0)throw uS("Wrong number of repetitions");for(;n>0;(n>>>=1)&&(e+=e))1&n&&(i+=e);return i}});var cS=td("String").repeat,dS=mt,pS=cS,mS=String.prototype,fS=function(t){var e=t.repeat;return"string"==typeof t||t===mS||dS(mS,t)&&e===mS.repeat?pS:e},vS=fS;sS.exports=vS;var gS=a(rS),yS={},bS={get exports(){return yS},set exports(t){yS=t}},wS=Qr,kS=Math.floor,xS=function(t,e){var i=t.length,n=kS(i/2);return i<8?_S(t,e):CS(t,xS(wS(t,0,n),e),xS(wS(t,n),e),e)},_S=function(t,e){for(var i,n,o=t.length,r=1;r<o;){for(n=r,i=t[r];n&&e(t[n-1],i)>0;)t[n]=t[--n];n!==r++&&(t[n]=i)}return t},CS=function(t,e,i,n){for(var o=e.length,r=i.length,s=0,a=0;s<o||a<r;)t[s+a]=s<o&&a<r?n(e[s],i[a])<=0?e[s++]:i[a++]:s<o?e[s++]:i[a++];return t},SS=xS,DS=ft.match(/firefox\/(\d+)/i),TS=!!DS&&+DS[1],OS=/MSIE|Trident/.test(ft),ES=ft.match(/AppleWebKit\/(\d+)\./),AS=!!ES&&+ES[1],IS=Ni,PS=_,MS=Lt,NS=ee,FS=Ln,RS=xg,LS=Gr,jS=d,BS=SS,zS=tp,HS=TS,GS=OS,WS=xt,YS=AS,VS=[],US=PS(VS.sort),XS=PS(VS.push),qS=jS((function(){VS.sort(void 0)})),KS=jS((function(){VS.sort(null)})),$S=zS("sort"),ZS=!jS((function(){if(WS)return WS<70;if(!(HS&&HS>3)){if(GS)return!0;if(YS)return YS<603;var t,e,i,n,o="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:i=3;break;case 68:case 71:i=4;break;default:i=2}for(n=0;n<47;n++)VS.push({k:e+n,v:i})}for(VS.sort((function(t,e){return e.v-t.v})),n=0;n<VS.length;n++)e=VS[n].k.charAt(0),o.charAt(o.length-1)!==e&&(o+=e);return"DGBEFHACIJK"!==o}}));IS({target:"Array",proto:!0,forced:qS||!KS||!$S||!ZS},{sort:function(t){void 0!==t&&MS(t);var e=NS(this);if(ZS)return void 0===t?US(e):US(e,t);var i,n,o=[],r=FS(e);for(n=0;n<r;n++)n in e&&XS(o,e[n]);for(BS(o,function(t){return function(e,i){return void 0===i?-1:void 0===e?1:void 0!==t?+t(e,i)||0:LS(e)>LS(i)?1:-1}}(t)),i=FS(o),n=0;n<i;)e[n]=o[n++];for(;n<r;)RS(e,n++);return e}});var QS=td("Array").sort,JS=mt,tD=QS,eD=Array.prototype,iD=function(t){var e=t.sort;return t===eD||JS(eD,t)&&e===eD.sort?tD:e},nD=iD;bS.exports=nD;var oD=a(yS);function rD(t,e,i){if(i&&!Dd(i))return rD(t,e,[i]);if(e.hiddenDates=[],i&&1==Dd(i)){for(var n,o=0;o<i.length;o++)if(void 0===gS(i[o])){var r={};r.start=t(i[o].start).toDate().valueOf(),r.end=t(i[o].end).toDate().valueOf(),e.hiddenDates.push(r)}oD(n=e.hiddenDates).call(n,(function(t,e){return t.start-e.start}))}}function sD(t,e,i){if(i&&!Dd(i))return sD(t,e,[i]);if(i&&void 0!==e.domProps.centerContainer.width){rD(t,e,i);for(var n=t(e.range.start),o=t(e.range.end),r=(e.range.end-e.range.start)/e.domProps.centerContainer.width,s=0;s<i.length;s++)if(void 0!==gS(i[s])){var a=t(i[s].start),l=t(i[s].end);if("Invalid Date"==a._d)throw new Error("Supplied start date is not valid: ".concat(i[s].start));if("Invalid Date"==l._d)throw new Error("Supplied end date is not valid: ".concat(i[s].end));if(l-a>=4*r){var h=0,u=o.clone();switch(gS(i[s])){case"daily":a.day()!=l.day()&&(h=1),a.dayOfYear(n.dayOfYear()),a.year(n.year()),a.subtract(7,"days"),l.dayOfYear(n.dayOfYear()),l.year(n.year()),l.subtract(7-h,"days"),u.add(1,"weeks");break;case"weekly":var c=l.diff(a,"days"),d=a.day();a.date(n.date()),a.month(n.month()),a.year(n.year()),l=a.clone(),a.day(d),l.day(d),l.add(c,"days"),a.subtract(1,"weeks"),l.subtract(1,"weeks"),u.add(1,"weeks");break;case"monthly":a.month()!=l.month()&&(h=1),a.month(n.month()),a.year(n.year()),a.subtract(1,"months"),l.month(n.month()),l.year(n.year()),l.subtract(1,"months"),l.add(h,"months"),u.add(1,"months");break;case"yearly":a.year()!=l.year()&&(h=1),a.year(n.year()),a.subtract(1,"years"),l.year(n.year()),l.subtract(1,"years"),l.add(h,"years"),u.add(1,"years");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",gS(i[s]))}for(;a<u;)switch(e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()}),gS(i[s])){case"daily":a.add(1,"days"),l.add(1,"days");break;case"weekly":a.add(1,"weeks"),l.add(1,"weeks");break;case"monthly":a.add(1,"months"),l.add(1,"months");break;case"yearly":a.add(1,"y"),l.add(1,"y");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",gS(i[s]))}e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()})}}aD(e);var p=gD(e.range.start,e.hiddenDates),m=gD(e.range.end,e.hiddenDates),f=e.range.start,v=e.range.end;1==p.hidden&&(f=1==e.range.startToFront?p.startDate-1:p.endDate+1),1==m.hidden&&(v=1==e.range.endToFront?m.startDate-1:m.endDate+1),1!=p.hidden&&1!=m.hidden||e.range._applyRange(f,v)}}function aD(t){for(var e,i=t.hiddenDates,n=[],o=0;o<i.length;o++)for(var r=0;r<i.length;r++)o!=r&&1!=i[r].remove&&1!=i[o].remove&&(i[r].start>=i[o].start&&i[r].end<=i[o].end?i[r].remove=!0:i[r].start>=i[o].start&&i[r].start<=i[o].end?(i[o].end=i[r].end,i[r].remove=!0):i[r].end>=i[o].start&&i[r].end<=i[o].end&&(i[o].start=i[r].start,i[r].remove=!0));for(o=0;o<i.length;o++)!0!==i[o].remove&&n.push(i[o]);t.hiddenDates=n,oD(e=t.hiddenDates).call(e,(function(t,e){return t.start-e.start}))}function lD(t,e,i){for(var n=!1,o=e.current.valueOf(),r=0;r<e.hiddenDates.length;r++){var s=e.hiddenDates[r].start,a=e.hiddenDates[r].end;if(o>=s&&o<a){n=!0;break}}if(1==n&&o<e._end.valueOf()&&o!=i){var l=t(i),h=t(a);l.year()!=h.year()?e.switchedYear=!0:l.month()!=h.month()?e.switchedMonth=!0:l.dayOfYear()!=h.dayOfYear()&&(e.switchedDay=!0),e.current=h}}function hD(t,e,i){var n;if(0==t.body.hiddenDates.length)return n=t.range.conversion(i),(e.valueOf()-n.offset)*n.scale;var o=gD(e,t.body.hiddenDates);1==o.hidden&&(e=o.startDate);var r=cD(t.body.hiddenDates,t.range.start,t.range.end);if(e<t.range.start){n=t.range.conversion(i,r);var s=dD(t.body.hiddenDates,e,n.offset);return e=t.options.moment(e).toDate().valueOf(),e+=s,-(n.offset-e.valueOf())*n.scale}if(e>t.range.end){var a={start:t.range.start,end:e};return e=pD(t.options.moment,t.body.hiddenDates,a,e),n=t.range.conversion(i,r),(e.valueOf()-n.offset)*n.scale}return e=pD(t.options.moment,t.body.hiddenDates,t.range,e),n=t.range.conversion(i,r),(e.valueOf()-n.offset)*n.scale}function uD(t,e,i){if(0==t.body.hiddenDates.length){var n=t.range.conversion(i);return new Date(e/n.scale+n.offset)}var o=cD(t.body.hiddenDates,t.range.start,t.range.end),r=(t.range.end-t.range.start-o)*e/i,s=fD(t.body.hiddenDates,t.range,r);return new Date(s+r+t.range.start)}function cD(t,e,i){for(var n=0,o=0;o<t.length;o++){var r=t[o].start,s=t[o].end;r>=e&&s<i&&(n+=s-r)}return n}function dD(t,e,i){for(var n=0,o=0;o<t.length;o++){var r=t[o].start,s=t[o].end;r>=e&&s<=i&&(n+=s-r)}return n}function pD(t,e,i,n){return n=t(n).toDate().valueOf(),n-=mD(t,e,i,n)}function mD(t,e,i,n){var o=0;n=t(n).toDate().valueOf();for(var r=0;r<e.length;r++){var s=e[r].start,a=e[r].end;s>=i.start&&a<i.end&&n>=a&&(o+=a-s)}return o}function fD(t,e,i){for(var n=0,o=0,r=e.start,s=0;s<t.length;s++){var a=t[s].start,l=t[s].end;if(a>=e.start&&l<e.end){if(o+=a-r,r=l,o>=i)break;n+=l-a}}return n}function vD(t,e,i,n){var o=gD(e,t);return 1==o.hidden?i<0?1==n?o.startDate-(o.endDate-e)-1:o.startDate-1:1==n?o.endDate+(e-o.startDate)+1:o.endDate+1:e}function gD(t,e){for(var i=0;i<e.length;i++){var n=e[i].start,o=e[i].end;if(t>=n&&t<o)return{hidden:!0,startDate:n,endDate:o}}return{hidden:!1,startDate:n,endDate:o}}var yD=Object.freeze({__proto__:null,convertHiddenOptions:rD,correctTimeForHidden:pD,getAccumulatedHiddenDuration:fD,getHiddenDurationBefore:mD,getHiddenDurationBeforeStart:dD,getHiddenDurationBetween:cD,getIsHidden:gD,printDates:function(t){for(var e=0;e<t.length;e++)console.log(e,new Date(t[e].start),new Date(t[e].end),t[e].start,t[e].end,t[e].remove)},removeDuplicates:aD,snapAwayFromHidden:vD,stepOverHiddenDates:lD,toScreen:hD,toTime:uD,updateHiddenDates:sD});function bD(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var wD=function(t){ud(i,oS);var e=bD(i);function i(t,n){var o,r,s,a,l,h,u,c;Go(this,i),c=e.call(this);var d=dp().hours(0).minutes(0).seconds(0).milliseconds(0),p=d.clone().add(-3,"days").valueOf(),m=d.clone().add(3,"days").valueOf();return c.millisecondsPerPixelCache=void 0,void 0===n?(c.start=p,c.end=m):(c.start=n.start||p,c.end=n.end||m),c.rolling=!1,c.body=t,c.deltaDifference=0,c.scaleOffset=0,c.startToFront=!1,c.endToFront=!0,c.defaultOptions={rtl:!1,start:null,end:null,moment:dp,direction:"horizontal",moveable:!0,zoomable:!0,min:null,max:null,zoomMin:10,zoomMax:31536e10,rollingMode:{follow:!1,offset:.5}},c.options=WC.extend({},c.defaultOptions),c.props={touch:{}},c.animationTimer=null,c.body.emitter.on("panstart",Od(o=c._onDragStart).call(o,Mc(c))),c.body.emitter.on("panmove",Od(r=c._onDrag).call(r,Mc(c))),c.body.emitter.on("panend",Od(s=c._onDragEnd).call(s,Mc(c))),c.body.emitter.on("mousewheel",Od(a=c._onMouseWheel).call(a,Mc(c))),c.body.emitter.on("touch",Od(l=c._onTouch).call(l,Mc(c))),c.body.emitter.on("pinch",Od(h=c._onPinch).call(h,Mc(c))),c.body.dom.rollingModeBtn.addEventListener("click",Od(u=c.startRolling).call(u,Mc(c))),c.setOptions(n),c}return Pc(i,[{key:"setOptions",value:function(t){if(t){WC.selectiveExtend(["animation","direction","min","max","zoomMin","zoomMax","moveable","zoomable","moment","activate","hiddenDates","zoomKey","zoomFriction","rtl","showCurrentTime","rollingMode","horizontalScroll"],this.options,t),t.rollingMode&&t.rollingMode.follow&&this.startRolling(),("start"in t||"end"in t)&&this.setRange(t.start,t.end)}}},{key:"startRolling",value:function(){var t=this;!function e(){t.stopRolling(),t.rolling=!0;var i=t.end-t.start,n=WC.convert(new Date,"Date").valueOf(),o=t.options.rollingMode&&t.options.rollingMode.offset||.5,r=n-i*o,s=n+i*(1-o);t.setRange(r,s,{animation:!1}),(i=1/t.conversion(t.body.domProps.center.width).scale/10)<30&&(i=30),i>1e3&&(i=1e3),t.body.dom.rollingModeBtn.style.visibility="hidden",t.currentTimeTimer=$d(e,i)}()}},{key:"stopRolling",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),this.rolling=!1,this.body.dom.rollingModeBtn.style.visibility="visible")}},{key:"setRange",value:function(t,e,i,n,o){i||(i={}),!0!==i.byUser&&(i.byUser=!1);var r=this,s=null!=t?WC.convert(t,"Date").valueOf():null,a=null!=e?WC.convert(e,"Date").valueOf():null;if(this._cancelAnimation(),this.millisecondsPerPixelCache=void 0,i.animation){var l,h=this.start,u=this.end,c="object"===_c(i.animation)&&"duration"in i.animation?i.animation.duration:500,d="object"===_c(i.animation)&&"easingFunction"in i.animation?i.animation.easingFunction:"easeInOutQuad",p=WC.easingFunctions[d];if(!p)throw new Error(zv(l="Unknown easing function ".concat(Zb(d),". Choose from: ")).call(l,Vm(WC.easingFunctions).join(", ")));var m=Jv(),f=!1;return function t(){if(!r.props.touch.dragging){var e=Jv()-m,l=p(e/c),d=e>c,g=d||null===s?s:h+(s-h)*l,y=d||null===a?a:u+(a-u)*l;v=r._applyRange(g,y),sD(r.options.moment,r.body,r.options.hiddenDates),f=f||v;var b={start:new Date(r.start),end:new Date(r.end),byUser:i.byUser,event:i.event};if(o&&o(l,v,d),v&&r.body.emitter.emit("rangechange",b),d){if(f&&(r.body.emitter.emit("rangechanged",b),n))return n()}else r.animationTimer=$d(t,20)}}()}var v=this._applyRange(s,a);if(sD(this.options.moment,this.body,this.options.hiddenDates),v){var g={start:new Date(this.start),end:new Date(this.end),byUser:i.byUser,event:i.event};if(this.body.emitter.emit("rangechange",g),clearTimeout(r.timeoutID),r.timeoutID=$d((function(){r.body.emitter.emit("rangechanged",g)}),200),n)return n()}}},{key:"getMillisecondsPerPixel",value:function(){return void 0===this.millisecondsPerPixelCache&&(this.millisecondsPerPixelCache=(this.end-this.start)/this.body.dom.center.clientWidth),this.millisecondsPerPixelCache}},{key:"_cancelAnimation",value:function(){this.animationTimer&&(clearTimeout(this.animationTimer),this.animationTimer=null)}},{key:"_applyRange",value:function(t,e){var i,n=null!=t?WC.convert(t,"Date").valueOf():this.start,o=null!=e?WC.convert(e,"Date").valueOf():this.end,r=null!=this.options.max?WC.convert(this.options.max,"Date").valueOf():null,s=null!=this.options.min?WC.convert(this.options.min,"Date").valueOf():null;if(isNaN(n)||null===n)throw new Error('Invalid start "'.concat(t,'"'));if(isNaN(o)||null===o)throw new Error('Invalid end "'.concat(e,'"'));if(o<n&&(o=n),null!==s&&n<s&&(n+=i=s-n,o+=i,null!=r&&o>r&&(o=r)),null!==r&&o>r&&(n-=i=o-r,o-=i,null!=s&&n<s&&(n=s)),null!==this.options.zoomMin){var a=nS(this.options.zoomMin);if(a<0&&(a=0),o-n<a){this.end-this.start===a&&n>=this.start-.5&&o<=this.end?(n=this.start,o=this.end):(n-=(i=a-(o-n))/2,o+=i/2)}}if(null!==this.options.zoomMax){var l=nS(this.options.zoomMax);l<0&&(l=0),o-n>l&&(this.end-this.start===l&&n<this.start&&o>this.end?(n=this.start,o=this.end):(n+=(i=o-n-l)/2,o-=i/2))}var h=this.start!=n||this.end!=o;return n>=this.start&&n<=this.end||o>=this.start&&o<=this.end||this.start>=n&&this.start<=o||this.end>=n&&this.end<=o||this.body.emitter.emit("checkRangedItems"),this.start=n,this.end=o,h}},{key:"getRange",value:function(){return{start:this.start,end:this.end}}},{key:"conversion",value:function(t,e){return i.conversion(this.start,this.end,t,e)}},{key:"_onDragStart",value:function(t){this.deltaDifference=0,this.previousDelta=0,this.options.moveable&&this._isInsideRange(t)&&this.props.touch.allowDragging&&(this.stopRolling(),this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.dragging=!0,this.body.dom.root&&(this.body.dom.root.style.cursor="move"))}},{key:"_onDrag",value:function(t){if(t&&this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging){var e=this.options.direction;kD(e);var i="horizontal"==e?t.deltaX:t.deltaY;i-=this.deltaDifference;var n=this.props.touch.end-this.props.touch.start;n-=cD(this.body.hiddenDates,this.start,this.end);var o,r="horizontal"==e?this.body.domProps.center.width:this.body.domProps.center.height;o=this.options.rtl?i/r*n:-i/r*n;var s=this.props.touch.start+o,a=this.props.touch.end+o,l=vD(this.body.hiddenDates,s,this.previousDelta-i,!0),h=vD(this.body.hiddenDates,a,this.previousDelta-i,!0);if(l!=s||h!=a)return this.deltaDifference+=i,this.props.touch.start=l,this.props.touch.end=h,void this._onDrag(t);this.previousDelta=i,this._applyRange(s,a);var u=new Date(this.start),c=new Date(this.end);this.body.emitter.emit("rangechange",{start:u,end:c,byUser:!0,event:t}),this.body.emitter.emit("panmove")}}},{key:"_onDragEnd",value:function(t){this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging&&(this.props.touch.dragging=!1,this.body.dom.root&&(this.body.dom.root.style.cursor="auto"),this.body.emitter.emit("rangechanged",{start:new Date(this.start),end:new Date(this.end),byUser:!0,event:t}))}},{key:"_onMouseWheel",value:function(t){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail?e=-t.detail/3:t.deltaY&&(e=-t.deltaY/3),!(this.options.zoomKey&&!t[this.options.zoomKey]&&this.options.zoomable||!this.options.zoomable&&this.options.moveable)&&this.options.zoomable&&this.options.moveable&&this._isInsideRange(t)&&e){var i,n,o=this.options.zoomFriction||5;if(i=e<0?1-e/o:1/(1+e/o),this.rolling){var r=this.options.rollingMode&&this.options.rollingMode.offset||.5;n=this.start+(this.end-this.start)*r}else{var s=this.getPointer({x:t.clientX,y:t.clientY},this.body.dom.center);n=this._pointerToDate(s)}this.zoom(i,n,e,t),t.preventDefault()}}},{key:"_onTouch",value:function(t){this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.allowDragging=!0,this.props.touch.center=null,this.props.touch.centerDate=null,this.scaleOffset=0,this.deltaDifference=0,WC.preventDefault(t)}},{key:"_onPinch",value:function(t){if(this.options.zoomable&&this.options.moveable){WC.preventDefault(t),this.props.touch.allowDragging=!1,this.props.touch.center||(this.props.touch.center=this.getPointer(t.center,this.body.dom.center),this.props.touch.centerDate=this._pointerToDate(this.props.touch.center)),this.stopRolling();var e=1/(t.scale+this.scaleOffset),i=this.props.touch.centerDate,n=cD(this.body.hiddenDates,this.start,this.end),o=mD(this.options.moment,this.body.hiddenDates,this,i),r=n-o,s=i-o+(this.props.touch.start-(i-o))*e,a=i+r+(this.props.touch.end-(i+r))*e;this.startToFront=1-e<=0,this.endToFront=e-1<=0;var l=vD(this.body.hiddenDates,s,1-e,!0),h=vD(this.body.hiddenDates,a,e-1,!0);l==s&&h==a||(this.props.touch.start=l,this.props.touch.end=h,this.scaleOffset=1-t.scale,s=l,a=h);var u={animation:!1,byUser:!0,event:t};this.setRange(s,a,u),this.startToFront=!1,this.endToFront=!0}}},{key:"_isInsideRange",value:function(t){var e=t.center?t.center.x:t.clientX,i=this.body.dom.centerContainer.getBoundingClientRect(),n=this.options.rtl?e-i.left:i.right-e,o=this.body.util.toTime(n);return o>=this.start&&o<=this.end}},{key:"_pointerToDate",value:function(t){var e,i=this.options.direction;if(kD(i),"horizontal"==i)return this.body.util.toTime(t.x).valueOf();var n=this.body.domProps.center.height;return e=this.conversion(n),t.y/e.scale+e.offset}},{key:"getPointer",value:function(t,e){var i=e.getBoundingClientRect();return this.options.rtl?{x:i.right-t.x,y:t.y-i.top}:{x:t.x-i.left,y:t.y-i.top}}},{key:"zoom",value:function(t,e,i,n){null==e&&(e=(this.start+this.end)/2);var o=cD(this.body.hiddenDates,this.start,this.end),r=mD(this.options.moment,this.body.hiddenDates,this,e),s=o-r,a=e-r+(this.start-(e-r))*t,l=e+s+(this.end-(e+s))*t;this.startToFront=!(i>0),this.endToFront=!(-i>0);var h=vD(this.body.hiddenDates,a,i,!0),u=vD(this.body.hiddenDates,l,-i,!0);h==a&&u==l||(a=h,l=u);var c={animation:!1,byUser:!0,event:n};this.setRange(a,l,c),this.startToFront=!1,this.endToFront=!0}},{key:"move",value:function(t){var e=this.end-this.start,i=this.start+e*t,n=this.end+e*t;this.start=i,this.end=n}},{key:"moveTo",value:function(t){var e=(this.start+this.end)/2-t,i=this.start-e,n=this.end-e;this.setRange(i,n,{animation:!1,byUser:!0,event:null})}}],[{key:"conversion",value:function(t,e,i,n){return void 0===n&&(n=0),0!=i&&e-t!=0?{offset:t,scale:i/(e-t-n)}:{offset:0,scale:1}}}]),i}();function kD(t){if("horizontal"!=t&&"vertical"!=t)throw new TypeError('Unknown direction "'.concat(t,'". Choose "horizontal" or "vertical".'))}var xD={},_D={get exports(){return xD},set exports(t){xD=t}},CD=ia.some;Ni({target:"Array",proto:!0,forced:!tp("some")},{some:function(t){return CD(this,t,arguments.length>1?arguments[1]:void 0)}});var SD=td("Array").some,DD=mt,TD=SD,OD=Array.prototype,ED=function(t){var e=t.some;return t===OD||DD(OD,t)&&e===OD.some?TD:e},AD=ED;_D.exports=AD;var ID=a(xD),PD={},MD=lt.setInterval;({get exports(){return PD},set exports(t){PD=t}}).exports=MD;var ND,FD=a(PD),RD=null;"undefined"!=typeof window?ND=function t(e,i){var n=i||{preventDefault:!1};if(e.Manager){var o=e,r=function(e,i){var r=Object.create(n);return i&&o.assign(r,i),t(new o(e,r),r)};return o.assign(r,o),r.Manager=function(e,i){var r=Object.create(n);return i&&o.assign(r,i),t(new o.Manager(e,r),r)},r}var s=Object.create(e),a=e.element;function l(t){return t.match(/[^ ]+/g)}function h(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var i=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof i&&(t.srcEvent.stopPropagation=function(){i(),t.stopPropagation()}),t.firstTarget=RD;for(var n=RD;n&&!e;){var o=n.hammer;if(o)for(var r,s=0;s<o.length;s++)if(r=o[s]._handlers[t.type])for(var a=0;a<r.length&&!e;a++)r[a](t);n=n.parentNode}}return a.hammer||(a.hammer=[]),a.hammer.push(s),e.on("hammer.input",(function(t){!0!==n.preventDefault&&n.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(RD=t.target)})),s._handlers={},s.on=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n||(s._handlers[t]=n=[],e.on(t,h)),n.push(i)})),s},s.off=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n&&((n=i?n.filter((function(t){return t!==i})):[]).length>0?s._handlers[t]=n:(e.off(t,h),delete s._handlers[t]))})),s},s.emit=function(t,i){RD=i.target,e.emit(t,i)},s.destroy=function(){var t=e.element.hammer,i=t.indexOf(s);-1!==i&&t.splice(i,1),t.length||delete e.element.hammer,s._handlers={},e.destroy()},s}(window.Hammer||kx,{preventDefault:"mouse"}):ND=function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(e){return{set:t}}}}()};var LD=ND;function jD(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}var BD=function(){function t(e,i,n,o,r){Go(this,t),this.moment=r&&r.moment||dp,this.options=r||{},this.current=this.moment(),this._start=this.moment(),this._end=this.moment(),this.autoScale=!0,this.scale="day",this.step=1,this.setRange(e,i,n),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,Dd(o)?this.hiddenDates=o:this.hiddenDates=null!=o?[o]:[],this.format=t.FORMAT}return Pc(t,[{key:"setMoment",value:function(t){this.moment=t,this.current=this.moment(this.current.valueOf()),this._start=this.moment(this._start.valueOf()),this._end=this.moment(this._end.valueOf())}},{key:"setFormat",value:function(e){var i=WC.deepExtend({},t.FORMAT);this.format=WC.deepExtend(i,e)}},{key:"setRange",value:function(t,e,i){if(!(t instanceof Date&&e instanceof Date))throw"No legal start or end date in method setRange";this._start=null!=t?this.moment(t.valueOf()):Jv(),this._end=null!=e?this.moment(e.valueOf()):Jv(),this.autoScale&&this.setMinimumStep(i)}},{key:"start",value:function(){this.current=this._start.clone(),this.roundToMinor()}},{key:"roundToMinor",value:function(){switch("week"==this.scale&&this.current.weekday(0),this.scale){case"year":this.current.year(this.step*Math.floor(this.current.year()/this.step)),this.current.month(0);case"month":this.current.date(1);case"week":case"day":case"weekday":this.current.hours(0);case"hour":this.current.minutes(0);case"minute":this.current.seconds(0);case"second":this.current.milliseconds(0)}if(1!=this.step){var t=this.current.clone();switch(this.scale){case"millisecond":this.current.subtract(this.current.milliseconds()%this.step,"milliseconds");break;case"second":this.current.subtract(this.current.seconds()%this.step,"seconds");break;case"minute":this.current.subtract(this.current.minutes()%this.step,"minutes");break;case"hour":this.current.subtract(this.current.hours()%this.step,"hours");break;case"weekday":case"day":this.current.subtract((this.current.date()-1)%this.step,"day");break;case"week":this.current.subtract(this.current.week()%this.step,"week");break;case"month":this.current.subtract(this.current.month()%this.step,"month");break;case"year":this.current.subtract(this.current.year()%this.step,"year")}t.isSame(this.current)||(this.current=this.moment(vD(this.hiddenDates,this.current.valueOf(),-1,!0)))}}},{key:"hasNext",value:function(){return this.current.valueOf()<=this._end.valueOf()}},{key:"next",value:function(){var t=this.current.valueOf();switch(this.scale){case"millisecond":this.current.add(this.step,"millisecond");break;case"second":this.current.add(this.step,"second");break;case"minute":this.current.add(this.step,"minute");break;case"hour":this.current.add(this.step,"hour"),this.current.month()<6?this.current.subtract(this.current.hours()%this.step,"hour"):this.current.hours()%this.step!=0&&this.current.add(this.step-this.current.hours()%this.step,"hour");break;case"weekday":case"day":this.current.add(this.step,"day");break;case"week":if(0!==this.current.weekday())this.current.weekday(0),this.current.add(this.step,"week");else if(!1===this.options.showMajorLabels)this.current.add(this.step,"week");else{var e=this.current.clone();e.add(1,"week"),e.isSame(this.current,"month")?this.current.add(this.step,"week"):(this.current.add(this.step,"week"),this.current.date(1))}break;case"month":this.current.add(this.step,"month");break;case"year":this.current.add(this.step,"year")}if(1!=this.step)switch(this.scale){case"millisecond":this.current.milliseconds()>0&&this.current.milliseconds()<this.step&&this.current.milliseconds(0);break;case"second":this.current.seconds()>0&&this.current.seconds()<this.step&&this.current.seconds(0);break;case"minute":this.current.minutes()>0&&this.current.minutes()<this.step&&this.current.minutes(0);break;case"hour":this.current.hours()>0&&this.current.hours()<this.step&&this.current.hours(0);break;case"weekday":case"day":this.current.date()<this.step+1&&this.current.date(1);break;case"week":this.current.week()<this.step&&this.current.week(1);break;case"month":this.current.month()<this.step&&this.current.month(0)}this.current.valueOf()==t&&(this.current=this._end.clone()),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,lD(this.moment,this,t)}},{key:"getCurrent",value:function(){return this.current.clone()}},{key:"setScale",value:function(t){t&&"string"==typeof t.scale&&(this.scale=t.scale,this.step=t.step>0?t.step:1,this.autoScale=!1)}},{key:"setAutoScale",value:function(t){this.autoScale=t}},{key:"setMinimumStep",value:function(t){if(null!=t){var e=31104e6,i=2592e6,n=864e5,o=36e5,r=6e4,s=1e3;1e3*e>t&&(this.scale="year",this.step=1e3),500*e>t&&(this.scale="year",this.step=500),100*e>t&&(this.scale="year",this.step=100),50*e>t&&(this.scale="year",this.step=50),10*e>t&&(this.scale="year",this.step=10),5*e>t&&(this.scale="year",this.step=5),e>t&&(this.scale="year",this.step=1),7776e6>t&&(this.scale="month",this.step=3),i>t&&(this.scale="month",this.step=1),6048e5>t&&this.options.showWeekScale&&(this.scale="week",this.step=1),1728e5>t&&(this.scale="day",this.step=2),n>t&&(this.scale="day",this.step=1),432e5>t&&(this.scale="weekday",this.step=1),144e5>t&&(this.scale="hour",this.step=4),o>t&&(this.scale="hour",this.step=1),9e5>t&&(this.scale="minute",this.step=15),6e5>t&&(this.scale="minute",this.step=10),3e5>t&&(this.scale="minute",this.step=5),r>t&&(this.scale="minute",this.step=1),15e3>t&&(this.scale="second",this.step=15),1e4>t&&(this.scale="second",this.step=10),5e3>t&&(this.scale="second",this.step=5),s>t&&(this.scale="second",this.step=1),200>t&&(this.scale="millisecond",this.step=200),100>t&&(this.scale="millisecond",this.step=100),50>t&&(this.scale="millisecond",this.step=50),10>t&&(this.scale="millisecond",this.step=10),5>t&&(this.scale="millisecond",this.step=5),1>t&&(this.scale="millisecond",this.step=1)}}},{key:"isMajor",value:function(){if(1==this.switchedYear)switch(this.scale){case"year":case"month":case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedMonth)switch(this.scale){case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedDay)switch(this.scale){case"millisecond":case"second":case"minute":case"hour":return!0;default:return!1}var t=this.moment(this.current);switch(this.scale){case"millisecond":return 0==t.milliseconds();case"second":return 0==t.seconds();case"minute":return 0==t.hours()&&0==t.minutes();case"hour":return 0==t.hours();case"weekday":case"day":return this.options.showWeekScale?1==t.isoWeekday():1==t.date();case"week":return 1==t.date();case"month":return 0==t.month();default:return!1}}},{key:"getLabelMinor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.minorLabels)return this.format.minorLabels(t,this.scale,this.step);var e=this.format.minorLabels[this.scale];return"week"===this.scale&&1===t.date()&&0!==t.weekday()?"":e&&e.length>0?this.moment(t).format(e):""}},{key:"getLabelMajor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.majorLabels)return this.format.majorLabels(t,this.scale,this.step);var e=this.format.majorLabels[this.scale];return e&&e.length>0?this.moment(t).format(e):""}},{key:"getClassName",value:function(){var t,e=this.moment,i=this.moment(this.current),n=i.locale?i.locale("en"):i.lang("en"),o=this.step,r=[];function s(t){return t/o%2==0?" vis-even":" vis-odd"}function a(t){return t.isSame(Jv(),"day")?" vis-today":t.isSame(e().add(1,"day"),"day")?" vis-tomorrow":t.isSame(e().add(-1,"day"),"day")?" vis-yesterday":""}function l(t){return t.isSame(Jv(),"week")?" vis-current-week":""}function h(t){return t.isSame(Jv(),"month")?" vis-current-month":""}switch(this.scale){case"millisecond":r.push(a(n)),r.push(s(n.milliseconds()));break;case"second":r.push(a(n)),r.push(s(n.seconds()));break;case"minute":r.push(a(n)),r.push(s(n.minutes()));break;case"hour":r.push(zv(t="vis-h".concat(n.hours())).call(t,4==this.step?"-h"+(n.hours()+4):"")),r.push(a(n)),r.push(s(n.hours()));break;case"weekday":r.push("vis-".concat(n.format("dddd").toLowerCase())),r.push(a(n)),r.push(l(n)),r.push(s(n.date()));break;case"day":r.push("vis-day".concat(n.date())),r.push("vis-".concat(n.format("MMMM").toLowerCase())),r.push(a(n)),r.push(h(n)),r.push(this.step<=2?a(n):""),r.push(this.step<=2?"vis-".concat(n.format("dddd").toLowerCase()):""),r.push(s(n.date()-1));break;case"week":r.push("vis-week".concat(n.format("w"))),r.push(l(n)),r.push(s(n.week()));break;case"month":r.push("vis-".concat(n.format("MMMM").toLowerCase())),r.push(h(n)),r.push(s(n.month()));break;case"year":r.push("vis-year".concat(n.year())),r.push(function(t){return t.isSame(Jv(),"year")?" vis-current-year":""}(n)),r.push(s(n.year()))}return Dp(r).call(r,String).join(" ")}}],[{key:"snap",value:function(t,e,i){var n=dp(t);if("year"==e){var o=n.year()+Math.round(n.month()/12);n.year(Math.round(o/i)*i),n.month(0),n.date(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("month"==e)n.date()>15?(n.date(1),n.add(1,"month")):n.date(1),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("week"==e)n.weekday()>2?(n.weekday(0),n.add(1,"week")):n.weekday(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("day"==e){switch(i){case 5:case 2:n.hours(24*Math.round(n.hours()/24));break;default:n.hours(12*Math.round(n.hours()/12))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("weekday"==e){switch(i){case 5:case 2:n.hours(12*Math.round(n.hours()/12));break;default:n.hours(6*Math.round(n.hours()/6))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("hour"==e){if(4===i)n.minutes(60*Math.round(n.minutes()/60));else n.minutes(30*Math.round(n.minutes()/30));n.seconds(0),n.milliseconds(0)}else if("minute"==e){switch(i){case 15:case 10:n.minutes(5*Math.round(n.minutes()/5)),n.seconds(0);break;case 5:n.seconds(60*Math.round(n.seconds()/60));break;default:n.seconds(30*Math.round(n.seconds()/30))}n.milliseconds(0)}else if("second"==e)switch(i){case 15:case 10:n.seconds(5*Math.round(n.seconds()/5)),n.milliseconds(0);break;case 5:n.milliseconds(1e3*Math.round(n.milliseconds()/1e3));break;default:n.milliseconds(500*Math.round(n.milliseconds()/500))}else if("millisecond"==e){var r=i>5?i/2:1;n.milliseconds(Math.round(n.milliseconds()/r)*r)}return n}}]),t}();function zD(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}BD.FORMAT={minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}};var HD=function(t){ud(i,oS);var e=zD(i);function i(t,n){var o;return Go(this,i),(o=e.call(this)).dom={foreground:null,lines:[],majorTexts:[],minorTexts:[],redundant:{lines:[],majorTexts:[],minorTexts:[]}},o.props={range:{start:0,end:0,minimumStep:0},lineTop:0},o.defaultOptions={orientation:{axis:"bottom"},showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,maxMinorChars:7,format:WC.extend({},BD.FORMAT),moment:dp,timeAxis:null},o.options=WC.extend({},o.defaultOptions),o.body=t,o._create(),o.setOptions(n),o}return Pc(i,[{key:"setOptions",value:function(t){t&&(WC.selectiveExtend(["showMinorLabels","showMajorLabels","showWeekScale","maxMinorChars","hiddenDates","timeAxis","moment","rtl"],this.options,t),WC.selectiveDeepExtend(["format"],this.options,t),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.axis=t.orientation:"object"===_c(t.orientation)&&"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis)),"locale"in t&&("function"==typeof dp.locale?dp.locale(t.locale):dp.lang(t.locale)))}},{key:"_create",value:function(){this.dom.foreground=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.foreground.className="vis-time-axis vis-foreground",this.dom.background.className="vis-time-axis vis-background"}},{key:"destroy",value:function(){this.dom.foreground.parentNode&&this.dom.foreground.parentNode.removeChild(this.dom.foreground),this.dom.background.parentNode&&this.dom.background.parentNode.removeChild(this.dom.background),this.body=null}},{key:"redraw",value:function(){var t=this.props,e=this.dom.foreground,i=this.dom.background,n="top"==this.options.orientation.axis?this.body.dom.top:this.body.dom.bottom,o=e.parentNode!==n;this._calculateCharSize();var r=this.options.showMinorLabels&&"none"!==this.options.orientation.axis,s=this.options.showMajorLabels&&"none"!==this.options.orientation.axis;t.minorLabelHeight=r?t.minorCharHeight:0,t.majorLabelHeight=s?t.majorCharHeight:0,t.height=t.minorLabelHeight+t.majorLabelHeight,t.width=e.offsetWidth,t.minorLineHeight=this.body.domProps.root.height-t.majorLabelHeight-("top"==this.options.orientation.axis?this.body.domProps.bottom.height:this.body.domProps.top.height),t.minorLineWidth=1,t.majorLineHeight=t.minorLineHeight+t.majorLabelHeight,t.majorLineWidth=1;var a=e.nextSibling,l=i.nextSibling;return e.parentNode&&e.parentNode.removeChild(e),i.parentNode&&i.parentNode.removeChild(i),e.style.height="".concat(this.props.height,"px"),this._repaintLabels(),a?n.insertBefore(e,a):n.appendChild(e),l?this.body.dom.backgroundVertical.insertBefore(i,l):this.body.dom.backgroundVertical.appendChild(i),this._isResized()||o}},{key:"_repaintLabels",value:function(){var t=this.options.orientation.axis,e=WC.convert(this.body.range.start,"Number"),i=WC.convert(this.body.range.end,"Number"),n=this.body.util.toTime((this.props.minorCharWidth||10)*this.options.maxMinorChars).valueOf(),o=n-mD(this.options.moment,this.body.hiddenDates,this.body.range,n);o-=this.body.util.toTime(0).valueOf();var r=new BD(new Date(e),new Date(i),o,this.body.hiddenDates,this.options);r.setMoment(this.options.moment),this.options.format&&r.setFormat(this.options.format),this.options.timeAxis&&r.setScale(this.options.timeAxis),this.step=r;var s,a,l,h,u,c,d=this.dom;d.redundant.lines=d.lines,d.redundant.majorTexts=d.majorTexts,d.redundant.minorTexts=d.minorTexts,d.lines=[],d.majorTexts=[],d.minorTexts=[];var p,m,f,v=0,g=void 0,y=0,b=1e3;for(r.start(),a=r.getCurrent(),h=this.body.util.toScreen(a);r.hasNext()&&y<b;){if(y++,u=r.isMajor(),f=r.getClassName(),s=a,l=h,r.next(),a=r.getCurrent(),p=v,v=(h=this.body.util.toScreen(a))-l,"week"===r.scale)c=!0;else c=v>=.4*p;if(this.options.showMinorLabels&&c){var w=this._repaintMinorText(l,r.getLabelMinor(s),t,f);w.style.width="".concat(v,"px")}u&&this.options.showMajorLabels?(l>0&&(null==g&&(g=l),w=this._repaintMajorText(l,r.getLabelMajor(s),t,f)),m=this._repaintMajorLine(l,v,t,f)):c?m=this._repaintMinorLine(l,v,t,f):m&&(m.style.width="".concat(vb(m.style.width)+v,"px"))}if(y!==b||GD||(console.warn("Something is wrong with the Timeline scale. Limited drawing of grid lines to ".concat(b," lines.")),GD=!0),this.options.showMajorLabels){var k=this.body.util.toTime(0),x=r.getLabelMajor(k),_=x.length*(this.props.majorCharWidth||10)+10;(null==g||_<g)&&this._repaintMajorText(0,x,t,f)}cp(WC).call(WC,this.dom.redundant,(function(t){for(;t.length;){var e=t.pop();e&&e.parentNode&&e.parentNode.removeChild(e)}}))}},{key:"_repaintMinorText",value:function(t,e,i,n){var o=this.dom.redundant.minorTexts.shift();if(!o){var r=document.createTextNode("");(o=document.createElement("div")).appendChild(r),this.dom.foreground.appendChild(o)}this.dom.minorTexts.push(o),o.innerHTML=WC.xss(e);var s="top"==i?this.props.majorLabelHeight:0;return this._setXY(o,t,s),o.className="vis-text vis-minor ".concat(n),o}},{key:"_repaintMajorText",value:function(t,e,i,n){var o=this.dom.redundant.majorTexts.shift();if(!o){var r=document.createElement("div");(o=document.createElement("div")).appendChild(r),this.dom.foreground.appendChild(o)}o.childNodes[0].innerHTML=WC.xss(e),o.className="vis-text vis-major ".concat(n);var s="top"==i?0:this.props.minorLabelHeight;return this._setXY(o,t,s),this.dom.majorTexts.push(o),o}},{key:"_setXY",value:function(t,e,i){var n,o=this.options.rtl?-1*e:e;t.style.transform=zv(n="translate(".concat(o,"px, ")).call(n,i,"px)")}},{key:"_repaintMinorLine",value:function(t,e,i,n){var o,r=this.dom.redundant.lines.shift();r||(r=document.createElement("div"),this.dom.background.appendChild(r)),this.dom.lines.push(r);var s=this.props;r.style.width="".concat(e,"px"),r.style.height="".concat(s.minorLineHeight,"px");var a="top"==i?s.majorLabelHeight:this.body.domProps.top.height,l=t-s.minorLineWidth/2;return this._setXY(r,l,a),r.className=zv(o="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-minor ")).call(o,n),r}},{key:"_repaintMajorLine",value:function(t,e,i,n){var o,r=this.dom.redundant.lines.shift();r||(r=document.createElement("div"),this.dom.background.appendChild(r)),this.dom.lines.push(r);var s=this.props;r.style.width="".concat(e,"px"),r.style.height="".concat(s.majorLineHeight,"px");var a="top"==i?0:this.body.domProps.top.height,l=t-s.majorLineWidth/2;return this._setXY(r,l,a),r.className=zv(o="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-major ")).call(o,n),r}},{key:"_calculateCharSize",value:function(){this.dom.measureCharMinor||(this.dom.measureCharMinor=document.createElement("DIV"),this.dom.measureCharMinor.className="vis-text vis-minor vis-measure",this.dom.measureCharMinor.style.position="absolute",this.dom.measureCharMinor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMinor)),this.props.minorCharHeight=this.dom.measureCharMinor.clientHeight,this.props.minorCharWidth=this.dom.measureCharMinor.clientWidth,this.dom.measureCharMajor||(this.dom.measureCharMajor=document.createElement("DIV"),this.dom.measureCharMajor.className="vis-text vis-major vis-measure",this.dom.measureCharMajor.style.position="absolute",this.dom.measureCharMajor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMajor)),this.props.majorCharHeight=this.dom.measureCharMajor.clientHeight,this.props.majorCharWidth=this.dom.measureCharMajor.clientWidth}}]),i}(),GD=!1;function WD(t){var e,i;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=LD(this.dom.overlay),this.hammer.on("tap",Od(e=this._onTapOverlay).call(e,this));var n=this,o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];cp(o).call(o,(function(t){n.hammer.on(t,(function(t){t.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=function(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,o={},r={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){h(t,"keydown")},l=function(t){h(t,"keyup")},h=function(t,e){if(void 0!==r[e][t.keyCode]){for(var n=r[e][t.keyCode],o=0;o<n.length;o++)(void 0===n[o].shift||1==n[o].shift&&1==t.shiftKey||0==n[o].shift&&0==t.shiftKey)&&n[o].fn(t);1==i&&t.preventDefault()}};return o.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===r[i][s[t].code]&&(r[i][s[t].code]=[]),r[i][s[t].code].push({fn:e,shift:s[t].shift})},o.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&o.bind(i,t,e)},o.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},o.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],o=r[i][s[t].code];if(void 0!==o)for(var a=0;a<o.length;a++)o[a].fn==e&&o[a].shift==s[t].shift||n.push(r[i][s[t].code][a]);r[i][s[t].code]=n}else r[i][s[t].code]=[]},o.reset=function(){r={keydown:{},keyup:{}}},o.destroy=function(){r={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",l,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",l,!0),o}(),this.escListener=Od(i=this.deactivate).call(i,this)}dw(WD.prototype),WD.current=null,WD.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},WD.prototype.activate=function(){var t;WD.current&&WD.current.deactivate(),WD.current=this,this.active=!0,this.dom.overlay.style.display="none",WC.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),Od(t=this.keycharm).call(t,"esc",this.escListener)},WD.prototype.deactivate=function(){WD.current===this&&(WD.current=null),this.active=!1,this.dom.overlay.style.display="",WC.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},WD.prototype._onTapOverlay=function(t){this.activate(),t.stopPropagation()};var YD={current:"current",time:"time",deleteSelected:"Delete selected"},VD={current:"attuale",time:"tempo",deleteSelected:"Cancella la selezione"},UD={current:"huidige",time:"tijd",deleteSelected:"Selectie verwijderen"},XD={current:"Aktuelle",time:"Zeit",deleteSelected:"Lösche Auswahl"},qD={current:"actuel",time:"heure",deleteSelected:"Effacer la selection"},KD={current:"corriente",time:"hora",deleteSelected:"Eliminar selección"},$D={current:"поточний",time:"час",deleteSelected:"Видалити обране"},ZD={current:"текущее",time:"время",deleteSelected:"Удалить выбранное"},QD={current:"aktualny",time:"czas",deleteSelected:"Usuń wybrane"},JD={current:"atual",time:"data",deleteSelected:"Apagar selecionado"},tT={current:"現在",time:"時刻",deleteSelected:"選択されたものを削除"},eT={current:"nuvarande",time:"tid",deleteSelected:"Radera valda"},iT={current:"nåværende",time:"tid",deleteSelected:"Slett valgte"},nT={current:"einamas",time:"laikas",deleteSelected:"Pašalinti pasirinktą"},oT={en:YD,en_EN:YD,en_US:YD,it:VD,it_IT:VD,it_CH:VD,nl:UD,nl_NL:UD,nl_BE:UD,de:XD,de_DE:XD,fr:qD,fr_FR:qD,fr_CA:qD,fr_BE:qD,es:KD,es_ES:KD,uk:$D,uk_UA:$D,ru:ZD,ru_RU:ZD,pl:QD,pl_PL:QD,pt:JD,pt_BR:JD,pt_PT:JD,ja:tT,ja_JP:tT,lt:nT,lt_LT:nT,sv:eT,sv_SE:eT,nb:iT,nn:iT,nb_NO:iT,nn_NO:iT};function rT(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var sT=function(t){ud(i,oS);var e=rT(i);function i(t,n){var o,r;Go(this,i),(r=e.call(this)).body=t,r.defaultOptions={moment:dp,locales:oT,locale:"en",id:void 0,title:void 0},r.options=WC.extend({},r.defaultOptions),r.setOptions(n),r.options.locales=WC.extend({},oT,r.options.locales);var s=r.defaultOptions.locales[r.defaultOptions.locale];return cp(o=Vm(r.options.locales)).call(o,(function(t){r.options.locales[t]=WC.extend({},s,r.options.locales[t])})),n&&null!=n.time?r.customTime=n.time:r.customTime=new Date,r.eventParams={},r._create(),r}return Pc(i,[{key:"setOptions",value:function(t){t&&WC.selectiveExtend(["moment","locale","locales","id","title","rtl","snap"],this.options,t)}},{key:"_create",value:function(){var t,e,i,n=document.createElement("div");n["custom-time"]=this,n.className="vis-custom-time ".concat(this.options.id||""),n.style.position="absolute",n.style.top="0px",n.style.height="100%",this.bar=n;var o=document.createElement("div");function r(t){this.body.range._onMouseWheel(t)}o.style.position="relative",o.style.top="0px",this.options.rtl?o.style.right="-10px":o.style.left="-10px",o.style.height="100%",o.style.width="20px",o.addEventListener?(o.addEventListener("mousewheel",Od(r).call(r,this),!1),o.addEventListener("DOMMouseScroll",Od(r).call(r,this),!1)):o.attachEvent("onmousewheel",Od(r).call(r,this)),n.appendChild(o),this.hammer=new LD(o),this.hammer.on("panstart",Od(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Od(e=this._onDrag).call(e,this)),this.hammer.on("panend",Od(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:LD.DIRECTION_ALL}),this.hammer.get("press").set({time:1e4})}},{key:"destroy",value:function(){this.hide(),this.hammer.destroy(),this.hammer=null,this.body=null}},{key:"redraw",value:function(){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar));var e=this.body.util.toScreen(this.customTime),i=this.options.locales[this.options.locale];i||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),i=this.options.locales.en);var n,o=this.options.title;void 0===o?o=(o=zv(n="".concat(i.time,": ")).call(n,this.options.moment(this.customTime).format("dddd, MMMM Do YYYY, H:mm:ss"))).charAt(0).toUpperCase()+o.substring(1):"function"==typeof o&&(o=o.call(this,this.customTime));return this.options.rtl?this.bar.style.right="".concat(e,"px"):this.bar.style.left="".concat(e,"px"),this.bar.title=o,!1}},{key:"hide",value:function(){this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar)}},{key:"setCustomTime",value:function(t){this.customTime=WC.convert(t,"Date"),this.redraw()}},{key:"getCustomTime",value:function(){return new Date(this.customTime.valueOf())}},{key:"setCustomMarker",value:function(t,e){var i,n,o=document.createElement("div");(o.className="vis-custom-time-marker",o.innerHTML=WC.xss(t),o.style.position="absolute",e)&&(o.setAttribute("contenteditable","true"),o.addEventListener("pointerdown",(function(){o.focus()})),o.addEventListener("input",Od(i=this._onMarkerChange).call(i,this)),o.title=t,o.addEventListener("blur",Od(n=function(t){this.title!=t.target.innerHTML&&(this._onMarkerChanged(t),this.title=t.target.innerHTML)}).call(n,this)));this.bar.appendChild(o)}},{key:"setCustomTitle",value:function(t){this.options.title=t}},{key:"_onDragStart",value:function(t){this.eventParams.dragging=!0,this.eventParams.customTime=this.customTime,t.stopPropagation()}},{key:"_onDrag",value:function(t){if(this.eventParams.dragging){var e=this.options.rtl?-1*t.deltaX:t.deltaX,i=this.body.util.toScreen(this.eventParams.customTime)+e,n=this.body.util.toTime(i),o=this.body.util.getScale(),r=this.body.util.getStep(),s=this.options.snap,a=s?s(n,o,r):n;this.setCustomTime(a),this.body.emitter.emit("timechange",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation()}}},{key:"_onDragEnd",value:function(t){this.eventParams.dragging&&(this.body.emitter.emit("timechanged",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation())}},{key:"_onMarkerChange",value:function(t){this.body.emitter.emit("markerchange",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}},{key:"_onMarkerChanged",value:function(t){this.body.emitter.emit("markerchanged",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}}],[{key:"customTimeFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("custom-time"))return e["custom-time"];e=e.parentNode}return null}}]),i}(),aT=function(){function t(){Go(this,t)}return Pc(t,[{key:"_create",value:function(t){var e,i,n,o=this;this.dom={},this.dom.container=t,this.dom.container.style.position="relative",this.dom.root=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.backgroundVertical=document.createElement("div"),this.dom.backgroundHorizontal=document.createElement("div"),this.dom.centerContainer=document.createElement("div"),this.dom.leftContainer=document.createElement("div"),this.dom.rightContainer=document.createElement("div"),this.dom.center=document.createElement("div"),this.dom.left=document.createElement("div"),this.dom.right=document.createElement("div"),this.dom.top=document.createElement("div"),this.dom.bottom=document.createElement("div"),this.dom.shadowTop=document.createElement("div"),this.dom.shadowBottom=document.createElement("div"),this.dom.shadowTopLeft=document.createElement("div"),this.dom.shadowBottomLeft=document.createElement("div"),this.dom.shadowTopRight=document.createElement("div"),this.dom.shadowBottomRight=document.createElement("div"),this.dom.rollingModeBtn=document.createElement("div"),this.dom.loadingScreen=document.createElement("div"),this.dom.root.className="vis-timeline",this.dom.background.className="vis-panel vis-background",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical",this.dom.backgroundHorizontal.className="vis-panel vis-background vis-horizontal",this.dom.centerContainer.className="vis-panel vis-center",this.dom.leftContainer.className="vis-panel vis-left",this.dom.rightContainer.className="vis-panel vis-right",this.dom.top.className="vis-panel vis-top",this.dom.bottom.className="vis-panel vis-bottom",this.dom.left.className="vis-content",this.dom.center.className="vis-content",this.dom.right.className="vis-content",this.dom.shadowTop.className="vis-shadow vis-top",this.dom.shadowBottom.className="vis-shadow vis-bottom",this.dom.shadowTopLeft.className="vis-shadow vis-top",this.dom.shadowBottomLeft.className="vis-shadow vis-bottom",this.dom.shadowTopRight.className="vis-shadow vis-top",this.dom.shadowBottomRight.className="vis-shadow vis-bottom",this.dom.rollingModeBtn.className="vis-rolling-mode-btn",this.dom.loadingScreen.className="vis-loading-screen",this.dom.root.appendChild(this.dom.background),this.dom.root.appendChild(this.dom.backgroundVertical),this.dom.root.appendChild(this.dom.backgroundHorizontal),this.dom.root.appendChild(this.dom.centerContainer),this.dom.root.appendChild(this.dom.leftContainer),this.dom.root.appendChild(this.dom.rightContainer),this.dom.root.appendChild(this.dom.top),this.dom.root.appendChild(this.dom.bottom),this.dom.root.appendChild(this.dom.rollingModeBtn),this.dom.centerContainer.appendChild(this.dom.center),this.dom.leftContainer.appendChild(this.dom.left),this.dom.rightContainer.appendChild(this.dom.right),this.dom.centerContainer.appendChild(this.dom.shadowTop),this.dom.centerContainer.appendChild(this.dom.shadowBottom),this.dom.leftContainer.appendChild(this.dom.shadowTopLeft),this.dom.leftContainer.appendChild(this.dom.shadowBottomLeft),this.dom.rightContainer.appendChild(this.dom.shadowTopRight),this.dom.rightContainer.appendChild(this.dom.shadowBottomRight),this.props={root:{},background:{},centerContainer:{},leftContainer:{},rightContainer:{},center:{},left:{},right:{},top:{},bottom:{},border:{},scrollTop:0,scrollTopMin:0},this.on("rangechange",(function(){!0===o.initialDrawDone&&o._redraw()})),this.on("rangechanged",(function(){o.initialRangeChangeDone||(o.initialRangeChangeDone=!0)})),this.on("touch",Od(e=this._onTouch).call(e,this)),this.on("panmove",Od(i=this._onDrag).call(i,this));var r=this;this._origRedraw=Od(n=this._redraw).call(n,this),this._redraw=WC.throttle(this._origRedraw),this.on("_change",(function(t){r.itemSet&&r.itemSet.initialItemSetDrawn&&t&&1==t.queue?r._redraw():r._origRedraw()})),this.hammer=new LD(this.dom.root);var s=this.hammer.get("pinch").set({enable:!0});s&&function(t){t.getTouchAction=function(){return["pan-y"]}}(s),this.hammer.get("pan").set({threshold:5,direction:LD.DIRECTION_ALL}),this.timelineListeners={};var a,l,h=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];function u(t){this.isActive()&&this.emit("mousewheel",t);var e=0,i=0;if("detail"in t&&(i=-1*t.detail),"wheelDelta"in t&&(i=t.wheelDelta),"wheelDeltaY"in t&&(i=t.wheelDeltaY),"wheelDeltaX"in t&&(e=-1*t.wheelDeltaX),"axis"in t&&t.axis===t.HORIZONTAL_AXIS&&(e=-1*i,i=0),"deltaY"in t&&(i=-1*t.deltaY),"deltaX"in t&&(e=t.deltaX),t.deltaMode&&(1===t.deltaMode?(e*=40,i*=40):(e*=40,i*=800)),this.options.preferZoom){if(!this.options.zoomKey||t[this.options.zoomKey])return}else if(this.options.zoomKey&&t[this.options.zoomKey])return;if(this.options.verticalScroll||this.options.horizontalScroll)if(this.options.verticalScroll&&Math.abs(i)>=Math.abs(e)){var n=this.props.scrollTop,o=n+i;if(this.isActive())this._setScrollTop(o)!==n&&(this._redraw(),this.emit("scroll",t),t.preventDefault())}else if(this.options.horizontalScroll){var r=(Math.abs(e)>=Math.abs(i)?e:i)/120*(this.range.end-this.range.start)/20,s=this.range.start+r,a=this.range.end+r,l={animation:!1,byUser:!0,event:t};this.range.setRange(s,a,l),t.preventDefault()}}cp(h).call(h,(function(t){var e=function(e){r.isActive()&&r.emit(t,e)};r.hammer.on(t,e),r.timelineListeners[t]=e})),jD(this.hammer,(function(t){r.emit("touch",t)})),a=this.hammer,(l=function(t){r.emit("release",t)}).inputHandler=function(t){t.isFinal&&l(t)},a.on("hammer.input",l.inputHandler);var c="onwheel"in document.createElement("div")?"wheel":void 0!==document.onmousewheel?"mousewheel":this.dom.centerContainer.addEventListener?"DOMMouseScroll":"onmousewheel";function d(t){if(r.options.verticalScroll&&(t.preventDefault(),r.isActive())){var e=-t.target.scrollTop;r._setScrollTop(e),r._redraw(),r.emit("scrollSide",t)}}this.dom.top.addEventListener,this.dom.bottom.addEventListener,this.dom.centerContainer.addEventListener(c,Od(u).call(u,this),!1),this.dom.top.addEventListener(c,Od(u).call(u,this),!1),this.dom.bottom.addEventListener(c,Od(u).call(u,this),!1),this.dom.left.parentNode.addEventListener("scroll",Od(d).call(d,this)),this.dom.right.parentNode.addEventListener("scroll",Od(d).call(d,this));var p=!1;function m(t){var e;if(t.preventDefault&&(r.emit("dragover",r.getEventProperties(t)),t.preventDefault()),Ab(e=t.target.className).call(e,"timeline")>-1&&!p)return t.dataTransfer.dropEffect="move",p=!0,!1}function f(t){t.preventDefault&&t.preventDefault(),t.stopPropagation&&t.stopPropagation();try{var e=JSON.parse(t.dataTransfer.getData("text"));if(!e||!e.content)return}catch(t){return!1}return p=!1,t.center={x:t.clientX,y:t.clientY},"item"!==e.target?r.itemSet._onAddItem(t):r.itemSet._onDropObjectOnItem(t),r.emit("drop",r.getEventProperties(t)),!1}if(this.dom.center.addEventListener("dragover",Od(m).call(m,this),!1),this.dom.center.addEventListener("drop",Od(f).call(f,this),!1),this.customTimes=[],this.touch={},this.redrawCount=0,this.initialDrawDone=!1,this.initialRangeChangeDone=!1,!t)throw new Error("No container provided");t.appendChild(this.dom.root),t.appendChild(this.dom.loadingScreen)}},{key:"setOptions",value:function(t){var e;if(t){if(WC.selectiveExtend(["width","height","minHeight","maxHeight","autoResize","start","end","clickToUse","dataAttributes","hiddenDates","locale","locales","moment","preferZoom","rtl","zoomKey","horizontalScroll","verticalScroll","longSelectPressTime","snap"],this.options,t),this.dom.rollingModeBtn.style.visibility="hidden",this.options.rtl&&(this.dom.container.style.direction="rtl",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical-rtl"),this.options.verticalScroll&&(this.options.rtl?this.dom.rightContainer.className="vis-panel vis-right vis-vertical-scroll":this.dom.leftContainer.className="vis-panel vis-left vis-vertical-scroll"),"object"!==_c(this.options.orientation)&&(this.options.orientation={item:void 0,axis:void 0}),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation={item:t.orientation,axis:t.orientation}:"object"===_c(t.orientation)&&("item"in t.orientation&&(this.options.orientation.item=t.orientation.item),"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis))),"both"===this.options.orientation.axis){if(!this.timeAxis2){var i=this.timeAxis2=new HD(this.body);i.setOptions=function(t){var e=t?WC.extend({},t):{};e.orientation="top",HD.prototype.setOptions.call(i,e)},this.components.push(i)}}else if(this.timeAxis2){var n,o,r=Ab(n=this.components).call(n,this.timeAxis2);if(-1!==r)Gg(o=this.components).call(o,r,1);this.timeAxis2.destroy(),this.timeAxis2=null}"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),"hiddenDates"in this.options&&rD(this.options.moment,this.body,this.options.hiddenDates),"clickToUse"in t&&(t.clickToUse?this.activator||(this.activator=new WD(this.dom.root)):this.activator&&(this.activator.destroy(),delete this.activator)),this._initAutoResize()}if(cp(e=this.components).call(e,(function(e){return e.setOptions(t)})),"configure"in t){var s;this.configurator||(this.configurator=this._createConfigurator()),this.configurator.setOptions(t.configure);var a=WC.deepExtend({},this.options);cp(s=this.components).call(s,(function(t){WC.deepExtend(a,t.options)})),this.configurator.setModuleOptions({global:a})}this._redraw()}},{key:"isActive",value:function(){return!this.activator||this.activator.active}},{key:"destroy",value:function(){var t;for(var e in this.setItems(null),this.setGroups(null),this.off(),this._stopAutoResize(),this.dom.root.parentNode&&this.dom.root.parentNode.removeChild(this.dom.root),this.dom=null,this.activator&&(this.activator.destroy(),delete this.activator),this.timelineListeners)this.timelineListeners.hasOwnProperty(e)&&delete this.timelineListeners[e];this.timelineListeners=null,this.hammer&&this.hammer.destroy(),this.hammer=null,cp(t=this.components).call(t,(function(t){return t.destroy()})),this.body=null}},{key:"setCustomTime",value:function(t,e){var i,n=Dp(i=this.customTimes).call(i,(function(t){return e===t.options.id}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(Zb(e)));n.length>0&&n[0].setCustomTime(t)}},{key:"getCustomTime",value:function(t){var e,i=Dp(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(Zb(t)));return i[0].getCustomTime()}},{key:"setCustomTimeMarker",value:function(t,e,i){var n,o=Dp(n=this.customTimes).call(n,(function(t){return t.options.id===e}));if(0===o.length)throw new Error("No custom time bar found with id ".concat(Zb(e)));o.length>0&&o[0].setCustomMarker(t,i)}},{key:"setCustomTimeTitle",value:function(t,e){var i,n=Dp(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(Zb(e)));if(n.length>0)return n[0].setCustomTitle(t)}},{key:"getEventProperties",value:function(t){return{event:t}}},{key:"addCustomTime",value:function(t,e){var i,n=void 0!==t?WC.convert(t,"Date"):new Date,o=ID(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(o)throw new Error("A custom time with id ".concat(Zb(e)," already exists"));var r=new sT(this.body,WC.extend({},this.options,{time:n,id:e,snap:this.itemSet?this.itemSet.options.snap:this.options.snap}));return this.customTimes.push(r),this.components.push(r),this._redraw(),e}},{key:"removeCustomTime",value:function(t){var e,i=this,n=Dp(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(Zb(t)));cp(n).call(n,(function(t){var e,n,o,r;Gg(e=i.customTimes).call(e,Ab(n=i.customTimes).call(n,t),1),Gg(o=i.components).call(o,Ab(r=i.components).call(r,t),1),t.destroy()}))}},{key:"getVisibleItems",value:function(){return this.itemSet&&this.itemSet.getVisibleItems()||[]}},{key:"getItemsAtCurrentTime",value:function(t){return this.time=t,this.itemSet&&this.itemSet.getItemsAtCurrentTime(this.time)||[]}},{key:"getVisibleGroups",value:function(){return this.itemSet&&this.itemSet.getVisibleGroups()||[]}},{key:"fit",value:function(t,e){var i=this.getDataRange();if(null!==i.min||null!==i.max){var n=i.max-i.min,o=new Date(i.min.valueOf()-.01*n),r=new Date(i.max.valueOf()+.01*n),s=!t||void 0===t.animation||t.animation;this.range.setRange(o,r,{animation:s},e)}}},{key:"getDataRange",value:function(){throw new Error("Cannot invoke abstract method getDataRange")}},{key:"setWindow",value:function(t,e,i,n){var o,r;"function"==typeof arguments[2]&&(n=arguments[2],i={}),1==arguments.length?(o=void 0===(r=arguments[0]).animation||r.animation,this.range.setRange(r.start,r.end,{animation:o})):2==arguments.length&&"function"==typeof arguments[1]?(n=arguments[1],o=void 0===(r=arguments[0]).animation||r.animation,this.range.setRange(r.start,r.end,{animation:o},n)):(o=!i||void 0===i.animation||i.animation,this.range.setRange(t,e,{animation:o},n))}},{key:"moveTo",value:function(t,e,i){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.range.end-this.range.start,o=WC.convert(t,"Date").valueOf(),r=o-n/2,s=o+n/2,a=!e||void 0===e.animation||e.animation;this.range.setRange(r,s,{animation:a},i)}},{key:"getWindow",value:function(){var t=this.range.getRange();return{start:new Date(t.start),end:new Date(t.end)}}},{key:"zoomIn",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),o=n.start.valueOf(),r=n.end.valueOf(),s=r-o,a=(s-s/(1+t))/2,l=o+a,h=r-a;this.setWindow(l,h,e,i)}}},{key:"zoomOut",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),o=n.start.valueOf(),r=n.end.valueOf(),s=r-o,a=o-s*t/2,l=r+s*t/2;this.setWindow(a,l,e,i)}}},{key:"redraw",value:function(){this._redraw()}},{key:"_redraw",value:function(){var t;this.redrawCount++;var e=this.dom;if(e&&e.container&&0!=e.root.offsetWidth){var i=!1,n=this.options,o=this.props;sD(this.options.moment,this.body,this.options.hiddenDates),"top"==n.orientation?(WC.addClassName(e.root,"vis-top"),WC.removeClassName(e.root,"vis-bottom")):(WC.removeClassName(e.root,"vis-top"),WC.addClassName(e.root,"vis-bottom")),n.rtl?(WC.addClassName(e.root,"vis-rtl"),WC.removeClassName(e.root,"vis-ltr")):(WC.addClassName(e.root,"vis-ltr"),WC.removeClassName(e.root,"vis-rtl")),e.root.style.maxHeight=WC.option.asSize(n.maxHeight,""),e.root.style.minHeight=WC.option.asSize(n.minHeight,""),e.root.style.width=WC.option.asSize(n.width,"");var r=e.root.offsetWidth;o.border.left=1,o.border.right=1,o.border.top=1,o.border.bottom=1,o.center.height=e.center.offsetHeight,o.left.height=e.left.offsetHeight,o.right.height=e.right.offsetHeight,o.top.height=e.top.clientHeight||-o.border.top,o.bottom.height=Math.round(e.bottom.getBoundingClientRect().height)||e.bottom.clientHeight||-o.border.bottom;var s=Math.max(o.left.height,o.center.height,o.right.height),a=o.top.height+s+o.bottom.height+o.border.top+o.border.bottom;e.root.style.height=WC.option.asSize(n.height,"".concat(a,"px")),o.root.height=e.root.offsetHeight,o.background.height=o.root.height;var l=o.root.height-o.top.height-o.bottom.height;o.centerContainer.height=l,o.leftContainer.height=l,o.rightContainer.height=o.leftContainer.height,o.root.width=r,o.background.width=o.root.width,this.initialDrawDone||(o.scrollbarWidth=WC.getScrollBarWidth());var h=e.leftContainer.clientWidth,u=e.rightContainer.clientWidth;n.verticalScroll?n.rtl?(o.left.width=h||-o.border.left,o.right.width=u+o.scrollbarWidth||-o.border.right):(o.left.width=h+o.scrollbarWidth||-o.border.left,o.right.width=u||-o.border.right):(o.left.width=h||-o.border.left,o.right.width=u||-o.border.right),this._setDOM();var c=this._updateScrollTop();"top"!=n.orientation.item&&(c+=Math.max(o.centerContainer.height-o.center.height-o.border.top-o.border.bottom,0)),e.center.style.transform="translateY(".concat(c,"px)");var d=0==o.scrollTop?"hidden":"",p=o.scrollTop==o.scrollTopMin?"hidden":"";e.shadowTop.style.visibility=d,e.shadowBottom.style.visibility=p,e.shadowTopLeft.style.visibility=d,e.shadowBottomLeft.style.visibility=p,e.shadowTopRight.style.visibility=d,e.shadowBottomRight.style.visibility=p,n.verticalScroll&&(e.rightContainer.className="vis-panel vis-right vis-vertical-scroll",e.leftContainer.className="vis-panel vis-left vis-vertical-scroll",e.shadowTopRight.style.visibility="hidden",e.shadowBottomRight.style.visibility="hidden",e.shadowTopLeft.style.visibility="hidden",e.shadowBottomLeft.style.visibility="hidden",e.left.style.top="0px",e.right.style.top="0px"),(!n.verticalScroll||o.center.height<o.centerContainer.height)&&(e.left.style.top="".concat(c,"px"),e.right.style.top="".concat(c,"px"),e.rightContainer.className=e.rightContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),e.leftContainer.className=e.leftContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),o.left.width=h||-o.border.left,o.right.width=u||-o.border.right,this._setDOM());var m=o.center.height>o.centerContainer.height;this.hammer.get("pan").set({direction:m?LD.DIRECTION_ALL:LD.DIRECTION_HORIZONTAL}),this.hammer.get("press").set({time:this.options.longSelectPressTime}),cp(t=this.components).call(t,(function(t){i=t.redraw()||i}));if(i){if(this.redrawCount<5)return void this.body.emitter.emit("_change");console.log("WARNING: infinite loop in redraw?")}else this.redrawCount=0;this.body.emitter.emit("changed")}}},{key:"_setDOM",value:function(){var t=this.props,e=this.dom;t.leftContainer.width=t.left.width,t.rightContainer.width=t.right.width;var i=t.root.width-t.left.width-t.right.width;t.center.width=i,t.centerContainer.width=i,t.top.width=i,t.bottom.width=i,e.background.style.height="".concat(t.background.height,"px"),e.backgroundVertical.style.height="".concat(t.background.height,"px"),e.backgroundHorizontal.style.height="".concat(t.centerContainer.height,"px"),e.centerContainer.style.height="".concat(t.centerContainer.height,"px"),e.leftContainer.style.height="".concat(t.leftContainer.height,"px"),e.rightContainer.style.height="".concat(t.rightContainer.height,"px"),e.background.style.width="".concat(t.background.width,"px"),e.backgroundVertical.style.width="".concat(t.centerContainer.width,"px"),e.backgroundHorizontal.style.width="".concat(t.background.width,"px"),e.centerContainer.style.width="".concat(t.center.width,"px"),e.top.style.width="".concat(t.top.width,"px"),e.bottom.style.width="".concat(t.bottom.width,"px"),e.background.style.left="0",e.background.style.top="0",e.backgroundVertical.style.left="".concat(t.left.width+t.border.left,"px"),e.backgroundVertical.style.top="0",e.backgroundHorizontal.style.left="0",e.backgroundHorizontal.style.top="".concat(t.top.height,"px"),e.centerContainer.style.left="".concat(t.left.width,"px"),e.centerContainer.style.top="".concat(t.top.height,"px"),e.leftContainer.style.left="0",e.leftContainer.style.top="".concat(t.top.height,"px"),e.rightContainer.style.left="".concat(t.left.width+t.center.width,"px"),e.rightContainer.style.top="".concat(t.top.height,"px"),e.top.style.left="".concat(t.left.width,"px"),e.top.style.top="0",e.bottom.style.left="".concat(t.left.width,"px"),e.bottom.style.top="".concat(t.top.height+t.centerContainer.height,"px"),e.center.style.left="0",e.left.style.left="0",e.right.style.left="0"}},{key:"setCurrentTime",value:function(t){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");this.currentTime.setCurrentTime(t)}},{key:"getCurrentTime",value:function(){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");return this.currentTime.getCurrentTime()}},{key:"_toTime",value:function(t){return uD(this,t,this.props.center.width)}},{key:"_toGlobalTime",value:function(t){return uD(this,t,this.props.root.width)}},{key:"_toScreen",value:function(t){return hD(this,t,this.props.center.width)}},{key:"_toGlobalScreen",value:function(t){return hD(this,t,this.props.root.width)}},{key:"_initAutoResize",value:function(){1==this.options.autoResize?this._startAutoResize():this._stopAutoResize()}},{key:"_startAutoResize",value:function(){var t=this;this._stopAutoResize(),this._onResize=function(){if(1==t.options.autoResize){if(t.dom.root){var e=t.dom.root.offsetHeight,i=t.dom.root.offsetWidth;i==t.props.lastWidth&&e==t.props.lastHeight||(t.props.lastWidth=i,t.props.lastHeight=e,t.props.scrollbarWidth=WC.getScrollBarWidth(),t.body.emitter.emit("_change"))}}else t._stopAutoResize()},WC.addEventListener(window,"resize",this._onResize),t.dom.root&&(t.props.lastWidth=t.dom.root.offsetWidth,t.props.lastHeight=t.dom.root.offsetHeight),this.watchTimer=FD(this._onResize,1e3)}},{key:"_stopAutoResize",value:function(){this.watchTimer&&(clearInterval(this.watchTimer),this.watchTimer=void 0),this._onResize&&(WC.removeEventListener(window,"resize",this._onResize),this._onResize=null)}},{key:"_onTouch",value:function(t){this.touch.allowDragging=!0,this.touch.initialScrollTop=this.props.scrollTop}},{key:"_onPinch",value:function(t){this.touch.allowDragging=!1}},{key:"_onDrag",value:function(t){if(t&&this.touch.allowDragging){var e=t.deltaY,i=this._getScrollTop(),n=this._setScrollTop(this.touch.initialScrollTop+e);this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),n!=i&&this.emit("verticalDrag")}}},{key:"_setScrollTop",value:function(t){return this.props.scrollTop=t,this._updateScrollTop(),this.props.scrollTop}},{key:"_updateScrollTop",value:function(){var t=Math.min(this.props.centerContainer.height-this.props.border.top-this.props.border.bottom-this.props.center.height,0);return t!=this.props.scrollTopMin&&("top"!=this.options.orientation.item&&(this.props.scrollTop+=t-this.props.scrollTopMin),this.props.scrollTopMin=t),this.props.scrollTop>0&&(this.props.scrollTop=0),this.props.scrollTop<t&&(this.props.scrollTop=t),this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),this.props.scrollTop}},{key:"_getScrollTop",value:function(){return this.props.scrollTop}},{key:"_createConfigurator",value:function(){throw new Error("Cannot invoke abstract method _createConfigurator")}}]),t}();function lT(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}dw(aT.prototype);var hT=function(t){ud(i,oS);var e=lT(i);function i(t,n){var o,r;Go(this,i),(r=e.call(this)).body=t,r.defaultOptions={rtl:!1,showCurrentTime:!0,alignCurrentTime:void 0,moment:dp,locales:oT,locale:"en"},r.options=WC.extend({},r.defaultOptions),r.setOptions(n),r.options.locales=WC.extend({},oT,r.options.locales);var s=r.defaultOptions.locales[r.defaultOptions.locale];return cp(o=Vm(r.options.locales)).call(o,(function(t){r.options.locales[t]=WC.extend({},s,r.options.locales[t])})),r.offset=0,r._create(),r}return Pc(i,[{key:"_create",value:function(){var t=document.createElement("div");t.className="vis-current-time",t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t}},{key:"destroy",value:function(){this.options.showCurrentTime=!1,this.redraw(),this.body=null}},{key:"setOptions",value:function(t){t&&WC.selectiveExtend(["rtl","showCurrentTime","alignCurrentTime","moment","locale","locales"],this.options,t)}},{key:"redraw",value:function(){if(this.options.showCurrentTime){var t,e,i=this.body.dom.backgroundVertical;this.bar.parentNode!=i&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),i.appendChild(this.bar),this.start());var n=this.options.moment(Jv()+this.offset);this.options.alignCurrentTime&&(n=n.startOf(this.options.alignCurrentTime));var o=this.body.util.toScreen(n),r=this.options.locales[this.options.locale];r||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),r=this.options.locales.en);var s=zv(t=zv(e="".concat(r.current," ")).call(e,r.time,": ")).call(t,n.format("dddd, MMMM Do YYYY, H:mm:ss"));s=s.charAt(0).toUpperCase()+s.substring(1),this.options.rtl?this.bar.style.transform="translateX(".concat(-1*o,"px)"):this.bar.style.transform="translateX(".concat(o,"px)"),this.bar.title=s}else this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),this.stop();return!1}},{key:"start",value:function(){var t=this;!function e(){t.stop();var i=1/t.body.range.conversion(t.body.domProps.center.width).scale/10;i<30&&(i=30),i>1e3&&(i=1e3),t.redraw(),t.body.emitter.emit("currentTimeTick"),t.currentTimeTimer=$d(e,i)}()}},{key:"stop",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),delete this.currentTimeTimer)}},{key:"setCurrentTime",value:function(t){var e=WC.convert(t,"Date").valueOf(),i=Jv();this.offset=e-i,this.redraw()}},{key:"getCurrentTime",value:function(){return new Date(Jv()+this.offset)}}]),i}(),uT={},cT={get exports(){return uT},set exports(t){uT=t}},dT=Ni,pT=ia.find,mT="find",fT=!0;mT in[]&&Array(1)[mT]((function(){fT=!1})),dT({target:"Array",proto:!0,forced:fT},{find:function(t){return pT(this,t,arguments.length>1?arguments[1]:void 0)}});var vT=td("Array").find,gT=mt,yT=vT,bT=Array.prototype,wT=function(t){var e=t.find;return t===bT||gT(bT,t)&&e===bT.find?yT:e},kT=wT;cT.exports=kT;var xT=a(uT),_T={},CT={get exports(){return _T},set exports(t){_T=t}},ST={},DT={get exports(){return ST},set exports(t){ST=t}},TT=d((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),OT=d,ET=at,AT=T,IT=TT,PT=Object.isExtensible,MT=OT((function(){PT(1)}))||IT?function(t){return!!ET(t)&&((!IT||"ArrayBuffer"!=AT(t))&&(!PT||PT(t)))}:PT,NT=!d((function(){return Object.isExtensible(Object.preventExtensions({}))})),FT=Ni,RT=_,LT=Wn,jT=at,BT=oe,zT=ni.f,HT=Wr,GT=Ur,WT=MT,YT=NT,VT=!1,UT=he("meta"),XT=0,qT=function(t){zT(t,UT,{value:{objectID:"O"+XT++,weakData:{}}})},KT=DT.exports={enable:function(){KT.enable=function(){},VT=!0;var t=HT.f,e=RT([].splice),i={};i[UT]=1,t(i).length&&(HT.f=function(i){for(var n=t(i),o=0,r=n.length;o<r;o++)if(n[o]===UT){e(n,o,1);break}return n},FT({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:GT.f}))},fastKey:function(t,e){if(!jT(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!BT(t,UT)){if(!WT(t))return"F";if(!e)return"E";qT(t)}return t[UT].objectID},getWeakData:function(t,e){if(!BT(t,UT)){if(!WT(t))return!0;if(!e)return!1;qT(t)}return t[UT].weakData},onFreeze:function(t){return YT&&VT&&WT(t)&&!BT(t,UT)&&qT(t),t}};LT[UT]=!0;var $T=ii,ZT=B,QT=li,JT=Mt,tO=sf,eO=Ln,iO=mt,nO=bf,oO=df,rO=Jm,sO=TypeError,aO=function(t,e){this.stopped=t,this.result=e},lO=aO.prototype,hO=function(t,e,i){var n,o,r,s,a,l,h,u=i&&i.that,c=!(!i||!i.AS_ENTRIES),d=!(!i||!i.IS_RECORD),p=!(!i||!i.IS_ITERATOR),m=!(!i||!i.INTERRUPTED),f=$T(e,u),v=function(t){return n&&rO(n,"normal",t),new aO(!0,t)},g=function(t){return c?(QT(t),m?f(t[0],t[1],v):f(t[0],t[1])):m?f(t,v):f(t)};if(d)n=t.iterator;else if(p)n=t;else{if(!(o=oO(t)))throw sO(JT(t)+" is not iterable");if(tO(o)){for(r=0,s=eO(t);s>r;r++)if((a=g(t[r]))&&iO(lO,a))return a;return new aO(!1)}n=nO(t,o)}for(l=d?t.next:n.next;!(h=ZT(l,n)).done;){try{a=g(h.value)}catch(t){rO(n,"throw",t)}if("object"==typeof a&&a&&iO(lO,a))return a}return new aO(!1)},uO=mt,cO=TypeError,dO=function(t,e){if(uO(e,t))return t;throw cO("Incorrect invocation")},pO=Ni,mO=c,fO=ST,vO=d,gO=xi,yO=hO,bO=dO,wO=N,kO=at,xO=Ps,_O=ni.f,CO=ia.forEach,SO=R,DO=qs.set,TO=qs.getterFor,OO=ss,EO=pt,AO=ls,IO=R,PO=ye("species"),MO=So,NO=ls,FO=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:OO(t,n,e[n],i);return t},RO=ii,LO=dO,jO=Q,BO=hO,zO=du,HO=pu,GO=function(t){var e=EO(t);IO&&e&&!e[PO]&&AO(e,PO,{configurable:!0,get:function(){return this}})},WO=R,YO=ST.fastKey,VO=qs.set,UO=qs.getterFor,XO={getConstructor:function(t,e,i,n){var o=t((function(t,o){LO(t,r),VO(t,{type:e,index:MO(null),first:void 0,last:void 0,size:0}),WO||(t.size=0),jO(o)||BO(o,t[n],{that:t,AS_ENTRIES:i})})),r=o.prototype,s=UO(e),a=function(t,e,i){var n,o,r=s(t),a=l(t,e);return a?a.value=i:(r.last=a={index:o=YO(e,!0),key:e,value:i,previous:n=r.last,next:void 0,removed:!1},r.first||(r.first=a),n&&(n.next=a),WO?r.size++:t.size++,"F"!==o&&(r.index[o]=a)),t},l=function(t,e){var i,n=s(t),o=YO(e);if("F"!==o)return n.index[o];for(i=n.first;i;i=i.next)if(i.key==e)return i};return FO(r,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,WO?t.size=0:this.size=0},delete:function(t){var e=this,i=s(e),n=l(e,t);if(n){var o=n.next,r=n.previous;delete i.index[n.index],n.removed=!0,r&&(r.next=o),o&&(o.previous=r),i.first==n&&(i.first=o),i.last==n&&(i.last=r),WO?i.size--:e.size--}return!!n},forEach:function(t){for(var e,i=s(this),n=RO(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!l(this,t)}}),FO(r,i?{get:function(t){var e=l(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),WO&&NO(r,"size",{configurable:!0,get:function(){return s(this).size}}),o},setStrong:function(t,e,i){var n=e+" Iterator",o=UO(e),r=UO(n);zO(t,e,(function(t,e){VO(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=r(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?HO("keys"==e?i.key:"values"==e?i.value:[i.key,i.value],!1):(t.target=void 0,HO(void 0,!0))}),i?"entries":"values",!i,!0),GO(e)}},qO=function(t,e,i){var n,o=-1!==t.indexOf("Map"),r=-1!==t.indexOf("Weak"),s=o?"set":"add",a=mO[t],l=a&&a.prototype,h={};if(SO&&wO(a)&&(r||l.forEach&&!vO((function(){(new a).entries().next()})))){var u=(n=e((function(e,i){DO(bO(e,u),{type:t,collection:new a}),null!=i&&yO(i,e[s],{that:e,AS_ENTRIES:o})}))).prototype,c=TO(t);CO(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||r&&"clear"==t||gO(u,t,(function(i,n){var o=c(this).collection;if(!e&&r&&!kO(i))return"get"==t&&void 0;var s=o[t](0===i?0:i,n);return e?this:s}))})),r||_O(u,"size",{configurable:!0,get:function(){return c(this).collection.size}})}else n=i.getConstructor(e,t,o,s),fO.enable();return xO(n,t,!1,!0),h[t]=n,pO({global:!0,forced:!0},h),r||i.setStrong(n,t,o),n};qO("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),XO);var KO=lt.Set;CT.exports=KO;var $O=a(_T),ZO={},QO={get exports(){return ZO},set exports(t){ZO=t}},JO=Ni,tE=ia.findIndex,eE="findIndex",iE=!0;eE in[]&&Array(1)[eE]((function(){iE=!1})),JO({target:"Array",proto:!0,forced:iE},{findIndex:function(t){return tE(this,t,arguments.length>1?arguments[1]:void 0)}});var nE=td("Array").findIndex,oE=mt,rE=nE,sE=Array.prototype,aE=function(t){var e=t.findIndex;return t===sE||oE(sE,t)&&e===sE.findIndex?rE:e},lE=aE;QO.exports=lE;var hE=a(ZO);function uE(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return cE(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return cE(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function cE(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var dE=.001;function pE(t){oD(t).call(t,(function(t,e){return t.data.start-e.data.start}))}function mE(t){oD(t).call(t,(function(t,e){return("end"in t.data?t.data.end:t.data.start)-("end"in e.data?e.data.end:e.data.start)}))}function fE(t,e,i,n){return null===wE(t,e.item,!1,(function(t){return t.stack&&(i||null===t.top)}),(function(t){return t.stack}),(function(t){return e.axis}),n)}function vE(t,e,i){var n=wE(t,e.item,!1,(function(t){return t.stack}),(function(t){return!0}),(function(t){return t.baseTop}));i.height=n-i.top+.5*e.item.vertical}function gE(t,e,i,n){for(var o=0;o<t.length;o++)if(null==t[o].data.subgroup)t[o].top=e.item.vertical;else if(void 0!==t[o].data.subgroup&&n){var r=0;for(var s in i)i.hasOwnProperty(s)&&1==i[s].visible&&i[s].index<i[t[o].data.subgroup].index&&(r+=i[s].height,i[t[o].data.subgroup].top=r);t[o].top=r+.5*e.item.vertical}n||yE(t,e,i)}function yE(t,e,i){var n;wE(oD(n=Vy(i)).call(n,(function(t,e){return t.index>e.index?1:t.index<e.index?-1:0})),{vertical:0},!0,(function(t){return!0}),(function(t){return!0}),(function(t){return 0}));for(var o=0;o<t.length;o++)void 0!==t[o].data.subgroup&&(t[o].top=i[t[o].data.subgroup].top+.5*e.item.vertical)}function bE(t,e,i){var n=!1,o=[];for(var r in i)i[r].hasOwnProperty("index")?o[i[r].index]=r:o.push(r);for(var s=0;s<o.length;s++)if(r=o[s],i.hasOwnProperty(r)){for(var a in n=n||i[r].stack,i[r].top=0,i)i[a].visible&&i[r].index>i[a].index&&(i[r].top+=i[a].height);for(var l=t[r],h=0;h<l.length;h++)void 0!==l[h].data.subgroup&&(l[h].top=i[l[h].data.subgroup].top+.5*e.item.vertical,i[r].stack&&(l[h].baseTop=l[h].top));n&&i[r].stack&&vE(t[r],e,i[r])}}function wE(t,e,n,o,r,s,a){var l=function(t){return t.start},h=function(t){return t.end};if(!n){var u=!(!t[0]||!t[0].options.rtl);l=u?function(t){return t.right}:function(t){return t.left},h=function(t){return l(t)+t.width+e.horizontal}}var c,d=[],p=[],m=null,f=0,v=uE(t);try{var g=function(){var t=c.value;if(o(t))d.push(t);else if(r(t)){var e=l(t);null!==m&&e<m-dE&&(f=0),m=e,f=kE(p,(function(t){return l(t)-dE>e}),f),Gg(p).call(p,f,0,t),f++}};for(v.s();!(c=v.n()).done;)g()}catch(t){v.e(t)}finally{v.f()}m=null;var y=null;f=0;for(var b=0,w=0,k=0,x=function(){var t,n,o=d.shift();o.top=s(o);var u=l(o),c=h(o);null!==m&&u<m-dE&&(b=0,w=0,f=0,y=null),m=u,b=kE(p,(function(t){return u<h(t)-dE}),b),(null===y||y<c-dE)&&(w=kE(p,(function(t){return c<l(t)-dE}),Math.max(b,w))),null!==y&&y-dE>c&&(w=function(t,e,n,o){n||(n=0);o||(o=t.length);for(i=o-1;i>=n;i--)if(e(t[i]))return i;return n-1}(p,(function(t){return c+dE>=l(t)}),b,horizontalOVerlapEndIndex)+1);for(var v,g,x,_=oD(t=Dp(n=Gv(p).call(p,b,w)).call(n,(function(t){return u<h(t)-dE&&c-dE>l(t)}))).call(t,(function(t,e){return t.top-e.top})),C=0;C<_.length;C++){var S=_[C];g=S,x=e,(v=o).top-x.vertical+dE<g.top+g.height&&v.top+v.height+x.vertical-dE>g.top&&(o.top=S.top+S.height+e.vertical)}r(o)&&(f=kE(p,(function(t){return l(t)-dE>u}),f),Gg(p).call(p,f,0,o),f++);var D=o.top+o.height;if(D>k&&(k=D),a&&a())return{v:null}};d.length>0;){var _=x();if("object"===_c(_))return _.v}return k}function kE(t,e,i){var n;i||(i=0);var o=hE(n=Gv(t).call(t,i)).call(n,e);return-1===o?t.length:o+i}var xE=Object.freeze({__proto__:null,nostack:gE,orderByEnd:mE,orderByStart:pE,stack:fE,stackSubgroups:yE,stackSubgroupsWithInnerStack:bE,substack:vE}),_E="__background__",CE=function(){function t(e,i,n){var o=this;if(Go(this,t),this.groupId=e,this.subgroups={},this.subgroupStack={},this.subgroupStackAll=!1,this.subgroupVisibility={},this.doInnerStack=!1,this.shouldBailStackItems=!1,this.subgroupIndex=0,this.subgroupOrderer=i&&i.subgroupOrder,this.itemSet=n,this.isVisible=null,this.stackDirty=!0,this._disposeCallbacks=[],i&&i.nestedGroups&&(this.nestedGroups=i.nestedGroups,0==i.showNested?this.showNested=!1:this.showNested=!0),i&&i.subgroupStack)if("boolean"==typeof i.subgroupStack)this.doInnerStack=i.subgroupStack,this.subgroupStackAll=i.subgroupStack;else for(var r in i.subgroupStack)this.subgroupStack[r]=i.subgroupStack[r],this.doInnerStack=this.doInnerStack||i.subgroupStack[r];i&&i.heightMode?this.heightMode=i.heightMode:this.heightMode=n.options.groupHeightMode,this.nestedInGroup=null,this.dom={},this.props={label:{width:0,height:0}},this.className=null,this.items={},this.visibleItems=[],this.itemsInRange=[],this.orderedItems={byStart:[],byEnd:[]},this.checkRangedItems=!1;var s=function(){o.checkRangedItems=!0};this.itemSet.body.emitter.on("checkRangedItems",s),this._disposeCallbacks.push((function(){o.itemSet.body.emitter.off("checkRangedItems",s)})),this._create(),this.setData(i)}return Pc(t,[{key:"_create",value:function(){var t=document.createElement("div");this.itemSet.options.groupEditable.order?t.className="vis-label draggable":t.className="vis-label",this.dom.label=t;var e=document.createElement("div");e.className="vis-inner",t.appendChild(e),this.dom.inner=e;var i=document.createElement("div");i.className="vis-group",i["vis-group"]=this,this.dom.foreground=i,this.dom.background=document.createElement("div"),this.dom.background.className="vis-group",this.dom.axis=document.createElement("div"),this.dom.axis.className="vis-group",this.dom.marker=document.createElement("div"),this.dom.marker.style.visibility="hidden",this.dom.marker.style.position="absolute",this.dom.marker.innerHTML="",this.dom.background.appendChild(this.dom.marker)}},{key:"setData",value:function(t){if(!this.itemSet.groupTouchParams.isDragging){var e,i,n;if(t&&t.subgroupVisibility)for(var o in t.subgroupVisibility)this.subgroupVisibility[o]=t.subgroupVisibility[o];if(this.itemSet.options&&this.itemSet.options.groupTemplate)e=(i=Od(n=this.itemSet.options.groupTemplate).call(n,this))(t,this.dom.inner);else e=t&&t.content;if(e instanceof Element){for(;this.dom.inner.firstChild;)this.dom.inner.removeChild(this.dom.inner.firstChild);this.dom.inner.appendChild(e)}else e instanceof Object&&e.isReactComponent||(e instanceof Object?i(t,this.dom.inner):this.dom.inner.innerHTML=null!=e?WC.xss(e):WC.xss(this.groupId||""));this.dom.label.title=t&&t.title||"",this.dom.inner.firstChild?WC.removeClassName(this.dom.inner,"vis-hidden"):WC.addClassName(this.dom.inner,"vis-hidden"),t&&t.nestedGroups?(this.nestedGroups&&this.nestedGroups==t.nestedGroups||(this.nestedGroups=t.nestedGroups),void 0===t.showNested&&void 0!==this.showNested||(0==t.showNested?this.showNested=!1:this.showNested=!0),WC.addClassName(this.dom.label,"vis-nesting-group"),this.showNested?(WC.removeClassName(this.dom.label,"collapsed"),WC.addClassName(this.dom.label,"expanded")):(WC.removeClassName(this.dom.label,"expanded"),WC.addClassName(this.dom.label,"collapsed"))):this.nestedGroups&&(this.nestedGroups=null,WC.removeClassName(this.dom.label,"collapsed"),WC.removeClassName(this.dom.label,"expanded"),WC.removeClassName(this.dom.label,"vis-nesting-group")),t&&(t.treeLevel||t.nestedInGroup)?(WC.addClassName(this.dom.label,"vis-nested-group"),t.treeLevel?WC.addClassName(this.dom.label,"vis-group-level-"+t.treeLevel):WC.addClassName(this.dom.label,"vis-group-level-unknown-but-gte1")):WC.addClassName(this.dom.label,"vis-group-level-0");var r=t&&t.className||null;r!=this.className&&(this.className&&(WC.removeClassName(this.dom.label,this.className),WC.removeClassName(this.dom.foreground,this.className),WC.removeClassName(this.dom.background,this.className),WC.removeClassName(this.dom.axis,this.className)),WC.addClassName(this.dom.label,r),WC.addClassName(this.dom.foreground,r),WC.addClassName(this.dom.background,r),WC.addClassName(this.dom.axis,r),this.className=r),this.style&&(WC.removeCssText(this.dom.label,this.style),this.style=null),t&&t.style&&(WC.addCssText(this.dom.label,t.style),this.style=t.style)}}},{key:"getLabelWidth",value:function(){return this.props.label.width}},{key:"_didMarkerHeightChange",value:function(){var t=this.dom.marker.clientHeight;if(t!=this.lastMarkerHeight){this.lastMarkerHeight=t;var e={},i=0;if(cp(WC).call(WC,this.items,(function(t,n){if(t.dirty=!0,t.displayed){e[n]=t.redraw(!0),i=e[n].length}})),i>0)for(var n=function(t){cp(WC).call(WC,e,(function(e){e[t]()}))},o=0;o<i;o++)n(o);return!0}return!1}},{key:"_calculateGroupSizeAndPosition",value:function(){var t=this.dom.foreground,e=t.offsetTop,i=t.offsetLeft,n=t.offsetWidth;this.top=e,this.right=i,this.width=n}},{key:"_shouldBailItemsRedraw",value:function(){var t=this,e=this.itemSet.options.onTimeout,i={relativeBailingTime:this.itemSet.itemsSettingTime,bailTimeMs:e&&e.timeoutMs,userBailFunction:e&&e.callback,shouldBailStackItems:this.shouldBailStackItems},n=null;if(!this.itemSet.initialDrawDone){if(i.shouldBailStackItems)return!0;Math.abs(Jv()-new Date(i.relativeBailingTime))>i.bailTimeMs&&(i.userBailFunction&&null==this.itemSet.userContinueNotBail?i.userBailFunction((function(e){t.itemSet.userContinueNotBail=e,n=!e})):n=0==t.itemSet.userContinueNotBail)}return n}},{key:"_redrawItems",value:function(t,e,i,n){var o=this;if(t||this.stackDirty||this.isVisible&&!e){var r,s,a,l,h,u,c={byEnd:Dp(r=this.orderedItems.byEnd).call(r,(function(t){return!t.isCluster})),byStart:Dp(s=this.orderedItems.byStart).call(s,(function(t){return!t.isCluster}))},d={byEnd:Ev(new $O(Dp(a=km(l=this.orderedItems.byEnd).call(l,(function(t){return t.cluster}))).call(a,(function(t){return!!t})))),byStart:Ev(new $O(Dp(h=km(u=this.orderedItems.byStart).call(u,(function(t){return t.cluster}))).call(h,(function(t){return!!t}))))},p=function(){var t,e,i,r=o._updateItemsInRange(c,Dp(t=o.visibleItems).call(t,(function(t){return!t.isCluster})),n),s=o._updateClustersInRange(d,Dp(e=o.visibleItems).call(e,(function(t){return t.isCluster})),n);return zv(i=[]).call(i,Ev(r),Ev(s))},m=function(t){var e={},i=function(i){var n,r=Dp(n=o.visibleItems).call(n,(function(t){return t.data.subgroup===i}));e[i]=t?oD(r).call(r,(function(e,i){return t(e.data,i.data)})):r};for(var n in o.subgroups)i(n);return e};if("function"==typeof this.itemSet.options.order){var f=this;if(this.doInnerStack&&this.itemSet.options.stackSubgroups){bE(m(this.itemSet.options.order),i,this.subgroups),this.visibleItems=p(),this._updateSubGroupHeights(i)}else{var v,g,y,b;this.visibleItems=p(),this._updateSubGroupHeights(i);var w=oD(v=Dp(g=Gv(y=this.visibleItems).call(y)).call(g,(function(t){return t.isCluster||!t.isCluster&&!t.cluster}))).call(v,(function(t,e){return f.itemSet.options.order(t.data,e.data)}));this.shouldBailStackItems=fE(w,i,!0,Od(b=this._shouldBailItemsRedraw).call(b,this))}}else{var k;if(this.visibleItems=p(),this._updateSubGroupHeights(i),this.itemSet.options.stack)if(this.doInnerStack&&this.itemSet.options.stackSubgroups)bE(m(),i,this.subgroups);else this.shouldBailStackItems=fE(this.visibleItems,i,!0,Od(k=this._shouldBailItemsRedraw).call(k,this));else gE(this.visibleItems,i,this.subgroups,this.itemSet.options.stackSubgroups)}for(var x=0;x<this.visibleItems.length;x++)this.visibleItems[x].repositionX(),void 0!==this.subgroupVisibility[this.visibleItems[x].data.subgroup]&&(this.subgroupVisibility[this.visibleItems[x].data.subgroup]||this.visibleItems[x].hide());this.itemSet.options.cluster&&cp(WC).call(WC,this.items,(function(t){t.cluster&&t.displayed&&t.hide()})),this.shouldBailStackItems&&this.itemSet.body.emitter.emit("destroyTimeline"),this.stackDirty=!1}}},{key:"_didResize",value:function(t,e){t=WC.updateProperty(this,"height",e)||t;var i=this.dom.inner.clientWidth,n=this.dom.inner.clientHeight;return t=WC.updateProperty(this.props.label,"width",i)||t,t=WC.updateProperty(this.props.label,"height",n)||t}},{key:"_applyGroupHeight",value:function(t){this.dom.background.style.height="".concat(t,"px"),this.dom.foreground.style.height="".concat(t,"px"),this.dom.label.style.height="".concat(t,"px")}},{key:"_updateItemsVerticalPosition",value:function(t){for(var e=0,i=this.visibleItems.length;e<i;e++){var n=this.visibleItems[e];n.repositionY(t),this.isVisible||this.groupId==_E||n.displayed&&n.hide()}}},{key:"redraw",value:function(t,e,i,n){var o,r,s,a,l,h,u,c=this,d=!1,p=this.isVisible,m=[function(){i=c._didMarkerHeightChange.call(c)||i},Od(o=this._updateSubGroupHeights).call(o,this,e),Od(r=this._calculateGroupSizeAndPosition).call(r,this),function(){var i;c.isVisible=Od(i=c._isGroupVisible).call(i,c)(t,e)},function(){var n;Od(n=c._redrawItems).call(n,c)(i,p,e,t)},Od(s=this._updateSubgroupsSizes).call(s,this),function(){var t;h=Od(t=c._calculateHeight).call(t,c)(e)},Od(a=this._calculateGroupSizeAndPosition).call(a,this),function(){var t;d=Od(t=c._didResize).call(t,c)(d,h)},function(){var t;Od(t=c._applyGroupHeight).call(t,c)(h)},function(){var t;Od(t=c._updateItemsVerticalPosition).call(t,c)(e)},Od(l=function(){return!c.isVisible&&c.height&&(d=!1),d}).call(l,this)];return n?m:(cp(m).call(m,(function(t){u=t()})),u)}},{key:"_updateSubGroupHeights",value:function(t){var e=this;if(Vm(this.subgroups).length>0){var i=this;this._resetSubgroups(),cp(WC).call(WC,this.visibleItems,(function(n){void 0!==n.data.subgroup&&(i.subgroups[n.data.subgroup].height=Math.max(i.subgroups[n.data.subgroup].height,n.height+t.item.vertical),i.subgroups[n.data.subgroup].visible=void 0===e.subgroupVisibility[n.data.subgroup]||Boolean(e.subgroupVisibility[n.data.subgroup]))}))}}},{key:"_isGroupVisible",value:function(t,e){return this.top<=t.body.domProps.centerContainer.height-t.body.domProps.scrollTop+e.axis&&this.top+this.height+e.axis>=-t.body.domProps.scrollTop}},{key:"_calculateHeight",value:function(t){var e,i;if((i="fixed"===this.heightMode?WC.toArray(this.items):this.visibleItems).length>0){var n=i[0].top,o=i[0].top+i[0].height;if(cp(WC).call(WC,i,(function(t){n=Math.min(n,t.top),o=Math.max(o,t.top+t.height)})),n>t.axis){var r=n-t.axis;o-=r,cp(WC).call(WC,i,(function(t){t.top-=r}))}e=Math.ceil(o+t.item.vertical/2),"fitItems"!==this.heightMode&&(e=Math.max(e,this.props.label.height))}else e=this.props.label.height;return e}},{key:"show",value:function(){this.dom.label.parentNode||this.itemSet.dom.labelSet.appendChild(this.dom.label),this.dom.foreground.parentNode||this.itemSet.dom.foreground.appendChild(this.dom.foreground),this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background),this.dom.axis.parentNode||this.itemSet.dom.axis.appendChild(this.dom.axis)}},{key:"hide",value:function(){var t=this.dom.label;t.parentNode&&t.parentNode.removeChild(t);var e=this.dom.foreground;e.parentNode&&e.parentNode.removeChild(e);var i=this.dom.background;i.parentNode&&i.parentNode.removeChild(i);var n=this.dom.axis;n.parentNode&&n.parentNode.removeChild(n)}},{key:"add",value:function(t){var e;if(this.items[t.id]=t,t.setParent(this),this.stackDirty=!0,void 0!==t.data.subgroup&&(this._addToSubgroup(t),this.orderSubgroups()),!Iy(e=this.visibleItems).call(e,t)){var i=this.itemSet.body.range;this._checkIfVisible(t,this.visibleItems,i)}}},{key:"_addToSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;null!=e&&void 0===this.subgroups[e]&&(this.subgroups[e]={height:0,top:0,start:t.data.start,end:t.data.end||t.data.start,visible:!1,index:this.subgroupIndex,items:[],stack:this.subgroupStackAll||this.subgroupStack[e]||!1},this.subgroupIndex++),new Date(t.data.start)<new Date(this.subgroups[e].start)&&(this.subgroups[e].start=t.data.start);var i=t.data.end||t.data.start;new Date(i)>new Date(this.subgroups[e].end)&&(this.subgroups[e].end=i),this.subgroups[e].items.push(t)}},{key:"_updateSubgroupsSizes",value:function(){var t=this;if(t.subgroups){var e=function(){var e,n=t.subgroups[i].items[0].data.end||t.subgroups[i].items[0].data.start,o=t.subgroups[i].items[0].data.start,r=n-1;cp(e=t.subgroups[i].items).call(e,(function(t){new Date(t.data.start)<new Date(o)&&(o=t.data.start);var e=t.data.end||t.data.start;new Date(e)>new Date(r)&&(r=e)})),t.subgroups[i].start=o,t.subgroups[i].end=new Date(r-1)};for(var i in t.subgroups)e()}}},{key:"orderSubgroups",value:function(){if(void 0!==this.subgroupOrderer){var t=[];if("string"==typeof this.subgroupOrderer){for(var e in this.subgroups)t.push({subgroup:e,sortField:this.subgroups[e].items[0].data[this.subgroupOrderer]});oD(t).call(t,(function(t,e){return t.sortField-e.sortField}))}else if("function"==typeof this.subgroupOrderer){for(var i in this.subgroups)t.push(this.subgroups[i].items[0].data);oD(t).call(t,this.subgroupOrderer)}if(t.length>0)for(var n=0;n<t.length;n++)this.subgroups[t[n].subgroup].index=n}}},{key:"_resetSubgroups",value:function(){for(var t in this.subgroups)this.subgroups.hasOwnProperty(t)&&(this.subgroups[t].visible=!1,this.subgroups[t].height=0)}},{key:"remove",value:function(t){var e,i;delete this.items[t.id],t.setParent(null),this.stackDirty=!0;var n=Ab(e=this.visibleItems).call(e,t);-1!=n&&Gg(i=this.visibleItems).call(i,n,1),void 0!==t.data.subgroup&&(this._removeFromSubgroup(t),this.orderSubgroups())}},{key:"_removeFromSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;if(null!=e){var i=this.subgroups[e];if(i){var n,o,r=Ab(n=i.items).call(n,t);if(r>=0)Gg(o=i.items).call(o,r,1),i.items.length?this._updateSubgroupsSizes():delete this.subgroups[e]}}}},{key:"removeFromDataSet",value:function(t){this.itemSet.removeItem(t.id)}},{key:"order",value:function(){for(var t=WC.toArray(this.items),e=[],i=[],n=0;n<t.length;n++)void 0!==t[n].data.end&&i.push(t[n]),e.push(t[n]);this.orderedItems={byStart:e,byEnd:i},pE(this.orderedItems.byStart),mE(this.orderedItems.byEnd)}},{key:"_updateItemsInRange",value:function(t,e,i){var n=[],o={};if(!this.isVisible&&this.groupId!=_E){for(var r=0;r<e.length;r++){var s=e[r];s.displayed&&s.hide()}return n}var a=(i.end-i.start)/4,l=i.start-a,h=i.end+a;if(e.length>0)for(var u=0;u<e.length;u++)this._checkIfVisibleWithReference(e[u],n,o,i);var c=WC.binarySearchCustom(t.byStart,(function(t){return t<l?-1:t<=h?0:1}),"data","start");if(this._traceVisible(c,t.byStart,n,o,(function(t){return t.data.start<l||t.data.start>h})),1==this.checkRangedItems){this.checkRangedItems=!1;for(var d=0;d<t.byEnd.length;d++)this._checkIfVisibleWithReference(t.byEnd[d],n,o,i)}else{var p=WC.binarySearchCustom(t.byEnd,(function(t){var e=t.start;return t.end<l?-1:e<=h?0:1}),"data");this._traceVisible(p,t.byEnd,n,o,(function(t){return t.data.end<l||t.data.start>h}))}for(var m={},f=0,v=0;v<n.length;v++){var g=n[v];if(!g.displayed){m[v]=g.redraw(!0),f=m[v].length}}if(f>0)for(var y=function(t){cp(WC).call(WC,m,(function(e){e[t]()}))},b=0;b<f;b++)y(b);for(var w=0;w<n.length;w++)n[w].repositionX();return n}},{key:"_traceVisible",value:function(t,e,i,n,o){if(-1!=t){for(var r=t;r>=0;r--){var s=e[r];if(o(s))break;s.isCluster&&!s.hasItems()||s.cluster||void 0===n[s.id]&&(n[s.id]=!0,i.push(s))}for(var a=t+1;a<e.length;a++){var l=e[a];if(o(l))break;l.isCluster&&!l.hasItems()||l.cluster||void 0===n[l.id]&&(n[l.id]=!0,i.push(l))}}}},{key:"_checkIfVisible",value:function(t,e,i){t.isVisible(i)?(t.displayed||t.show(),t.repositionX(),e.push(t)):t.displayed&&t.hide()}},{key:"_checkIfVisibleWithReference",value:function(t,e,i,n){t.isVisible(n)?void 0===i[t.id]&&(i[t.id]=!0,e.push(t)):t.displayed&&t.hide()}},{key:"_updateClustersInRange",value:function(t,e,i){var n=[],o={};if(e.length>0)for(var r=0;r<e.length;r++)this._checkIfVisibleWithReference(e[r],n,o,i);for(var s=0;s<t.byStart.length;s++)this._checkIfVisibleWithReference(t.byStart[s],n,o,i);for(var a=0;a<t.byEnd.length;a++)this._checkIfVisibleWithReference(t.byEnd[a],n,o,i);for(var l={},h=0,u=0;u<n.length;u++){var c=n[u];if(!c.displayed){l[u]=c.redraw(!0),h=l[u].length}}if(h>0)for(var d=0;d<h;d++)cp(WC).call(WC,l,(function(t){t[d]()}));for(var p=0;p<n.length;p++)n[p].repositionX();return n}},{key:"changeSubgroup",value:function(t,e,i){this._removeFromSubgroup(t,e),this._addToSubgroup(t,i),this.orderSubgroups()}},{key:"dispose",value:function(){var t;for(this.hide();t=this._disposeCallbacks.pop();)t()}}]),t}();function SE(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var DE=function(t){ud(i,CE);var e=SE(i);function i(t,n,o){var r;return Go(this,i),(r=e.call(this,t,n,o)).width=0,r.height=0,r.top=0,r.left=0,r}return Pc(i,[{key:"redraw",value:function(t,e,i){this.visibleItems=this._updateItemsInRange(this.orderedItems,this.visibleItems,t),this.width=this.dom.background.offsetWidth,this.dom.background.style.height="0";for(var n=0,o=this.visibleItems.length;n<o;n++){this.visibleItems[n].repositionY(e)}return!1}},{key:"show",value:function(){this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background)}}]),i}();function TE(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return OE(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return OE(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function OE(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var EE=function(){function t(e,i,n){var o,r=this;Go(this,t),this.id=null,this.parent=null,this.data=e,this.dom=null,this.conversion=i||{},this.defaultOptions={locales:oT,locale:"en"},this.options=WC.extend({},this.defaultOptions,n),this.options.locales=WC.extend({},oT,this.options.locales);var s=this.defaultOptions.locales[this.defaultOptions.locale];cp(o=Vm(this.options.locales)).call(o,(function(t){r.options.locales[t]=WC.extend({},s,r.options.locales[t])})),this.selected=!1,this.displayed=!1,this.groupShowing=!0,this.selectable=n&&n.selectable||!1,this.dirty=!0,this.top=null,this.right=null,this.left=null,this.width=null,this.height=null,this.setSelectability(e),this.editable=null,this._updateEditStatus()}return Pc(t,[{key:"select",value:function(){this.selectable&&(this.selected=!0,this.dirty=!0,this.displayed&&this.redraw())}},{key:"unselect",value:function(){this.selected=!1,this.dirty=!0,this.displayed&&this.redraw()}},{key:"setData",value:function(t){null!=t.group&&this.data.group!=t.group&&null!=this.parent&&this.parent.itemSet._moveToGroup(this,t.group),this.setSelectability(t),this.parent&&(this.parent.stackDirty=!0),null!=t.subgroup&&this.data.subgroup!=t.subgroup&&null!=this.parent&&this.parent.changeSubgroup(this,this.data.subgroup,t.subgroup),this.data=t,this._updateEditStatus(),this.dirty=!0,this.displayed&&this.redraw()}},{key:"setSelectability",value:function(t){t&&(this.selectable=void 0===t.selectable||Boolean(t.selectable))}},{key:"setParent",value:function(t){this.displayed?(this.hide(),this.parent=t,this.parent&&this.show()):this.parent=t}},{key:"isVisible",value:function(t){return!1}},{key:"show",value:function(){return!1}},{key:"hide",value:function(){return!1}},{key:"redraw",value:function(){}},{key:"repositionX",value:function(){}},{key:"repositionY",value:function(){}},{key:"_repaintDragCenter",value:function(){if(this.selected&&this.editable.updateTime&&!this.dom.dragCenter){var t,e,i=this,n=document.createElement("div");n.className="vis-drag-center",n.dragCenterItem=this,this.hammerDragCenter=new LD(n),this.hammerDragCenter.on("tap",(function(t){i.parent.itemSet.body.emitter.emit("click",{event:t,item:i.id})})),this.hammerDragCenter.on("doubletap",(function(t){t.stopPropagation(),i.parent.itemSet._onUpdateItem(i),i.parent.itemSet.body.emitter.emit("doubleClick",{event:t,item:i.id})})),this.hammerDragCenter.on("panstart",(function(t){t.stopPropagation(),i.parent.itemSet._onDragStart(t)})),this.hammerDragCenter.on("panmove",Od(t=i.parent.itemSet._onDrag).call(t,i.parent.itemSet)),this.hammerDragCenter.on("panend",Od(e=i.parent.itemSet._onDragEnd).call(e,i.parent.itemSet)),this.hammerDragCenter.get("press").set({time:1e4}),this.dom.box?this.dom.dragLeft?this.dom.box.insertBefore(n,this.dom.dragLeft):this.dom.box.appendChild(n):this.dom.point&&this.dom.point.appendChild(n),this.dom.dragCenter=n}else!this.selected&&this.dom.dragCenter&&(this.dom.dragCenter.parentNode&&this.dom.dragCenter.parentNode.removeChild(this.dom.dragCenter),this.dom.dragCenter=null,this.hammerDragCenter&&(this.hammerDragCenter.destroy(),this.hammerDragCenter=null))}},{key:"_repaintDeleteButton",value:function(t){var e=(this.options.editable.overrideItems||null==this.editable)&&this.options.editable.remove||!this.options.editable.overrideItems&&null!=this.editable&&this.editable.remove;if(this.selected&&e&&!this.dom.deleteButton){var i=this,n=document.createElement("div");this.options.rtl?n.className="vis-delete-rtl":n.className="vis-delete";var o=this.options.locales[this.options.locale];o||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),o=this.options.locales.en),n.title=o.deleteSelected,this.hammerDeleteButton=new LD(n).on("tap",(function(t){t.stopPropagation(),i.parent.removeFromDataSet(i)})),t.appendChild(n),this.dom.deleteButton=n}else this.selected&&e||!this.dom.deleteButton||(this.dom.deleteButton.parentNode&&this.dom.deleteButton.parentNode.removeChild(this.dom.deleteButton),this.dom.deleteButton=null,this.hammerDeleteButton&&(this.hammerDeleteButton.destroy(),this.hammerDeleteButton=null))}},{key:"_repaintOnItemUpdateTimeTooltip",value:function(t){if(this.options.tooltipOnItemUpdateTime){var e=(this.options.editable.updateTime||!0===this.data.editable)&&!1!==this.data.editable;if(this.selected&&e&&!this.dom.onItemUpdateTimeTooltip){var i=document.createElement("div");i.className="vis-onUpdateTime-tooltip",t.appendChild(i),this.dom.onItemUpdateTimeTooltip=i}else!this.selected&&this.dom.onItemUpdateTimeTooltip&&(this.dom.onItemUpdateTimeTooltip.parentNode&&this.dom.onItemUpdateTimeTooltip.parentNode.removeChild(this.dom.onItemUpdateTimeTooltip),this.dom.onItemUpdateTimeTooltip=null);if(this.dom.onItemUpdateTimeTooltip){this.dom.onItemUpdateTimeTooltip.style.visibility=this.parent.itemSet.touchParams.itemIsDragging?"visible":"hidden",this.dom.onItemUpdateTimeTooltip.style.transform="translateX(-50%)",this.dom.onItemUpdateTimeTooltip.style.left="50%";var n,o,r=this.parent.itemSet.body.domProps.scrollTop;if(("top"==this.options.orientation.item?this.top:this.parent.height-this.top-this.height)+this.parent.top-50<-r?(this.dom.onItemUpdateTimeTooltip.style.bottom="",this.dom.onItemUpdateTimeTooltip.style.top="".concat(this.height+2,"px")):(this.dom.onItemUpdateTimeTooltip.style.top="",this.dom.onItemUpdateTimeTooltip.style.bottom="".concat(this.height+2,"px")),this.options.tooltipOnItemUpdateTime&&this.options.tooltipOnItemUpdateTime.template)n=Od(o=this.options.tooltipOnItemUpdateTime.template).call(o,this)(this.data);else n="start: ".concat(dp(this.data.start).format("MM/DD/YYYY hh:mm")),this.data.end&&(n+="<br> end: ".concat(dp(this.data.end).format("MM/DD/YYYY hh:mm")));this.dom.onItemUpdateTimeTooltip.innerHTML=WC.xss(n)}}}},{key:"_getItemData",value:function(){return this.parent.itemSet.itemsData.get(this.id)}},{key:"_updateContents",value:function(t){var e,i,n,o,r,s,a=this._getItemData(),l=(this.dom.box||this.dom.point).getElementsByClassName("vis-item-visible-frame")[0];this.options.visibleFrameTemplate?(o=Od(r=this.options.visibleFrameTemplate).call(r,this),n=WC.xss(o(a,l))):n="";if(l)if(n instanceof Object&&!(n instanceof Element))o(a,l);else if(this._contentToString(this.itemVisibleFrameContent)!==this._contentToString(n)){if(n instanceof Element)l.innerHTML="",l.appendChild(n);else if(null!=n)l.innerHTML=WC.xss(n);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.itemVisibleFrameContent=n}this.options.template?e=(i=Od(s=this.options.template).call(s,this))(a,t,this.data):e=this.data.content;if(e instanceof Object&&!(e instanceof Element))i(a,t);else if(this._contentToString(this.content)!==this._contentToString(e)){if(e instanceof Element)t.innerHTML="",t.appendChild(e);else if(null!=e)t.innerHTML=WC.xss(e);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.content=e}}},{key:"_updateDataAttributes",value:function(t){if(this.options.dataAttributes&&this.options.dataAttributes.length>0){var e=[];if(Dd(this.options.dataAttributes))e=this.options.dataAttributes;else{if("all"!=this.options.dataAttributes)return;e=Vm(this.data)}var i,n=TE(e);try{for(n.s();!(i=n.n()).done;){var o=i.value,r=this.data[o];null!=r?t.setAttribute("data-".concat(o),r):t.removeAttribute("data-".concat(o))}}catch(t){n.e(t)}finally{n.f()}}}},{key:"_updateStyle",value:function(t){this.style&&(WC.removeCssText(t,this.style),this.style=null),this.data.style&&(WC.addCssText(t,this.data.style),this.style=this.data.style)}},{key:"_contentToString",value:function(t){return"string"==typeof t?t:t&&"outerHTML"in t?t.outerHTML:t}},{key:"_updateEditStatus",value:function(){this.options&&("boolean"==typeof this.options.editable?this.editable={updateTime:this.options.editable,updateGroup:this.options.editable,remove:this.options.editable}:"object"===_c(this.options.editable)&&(this.editable={},WC.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.options.editable))),this.options&&this.options.editable&&!0===this.options.editable.overrideItems||this.data&&("boolean"==typeof this.data.editable?this.editable={updateTime:this.data.editable,updateGroup:this.data.editable,remove:this.data.editable}:"object"===_c(this.data.editable)&&(this.editable={},WC.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.data.editable)))}},{key:"getWidthLeft",value:function(){return 0}},{key:"getWidthRight",value:function(){return 0}},{key:"getTitle",value:function(){var t;return this.options.tooltip&&this.options.tooltip.template?Od(t=this.options.tooltip.template).call(t,this)(this._getItemData(),this.data):this.data.title}}]),t}();function AE(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}EE.prototype.stack=!0;var IE=function(t){ud(i,EE);var e=AE(i);function i(t,n,o){var r;if(Go(this,i),(r=e.call(this,t,n,o)).props={dot:{width:0,height:0},line:{width:0,height:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return r}return Pc(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e,i=this.data.align||this.options.align,n=this.width*t.getMillisecondsPerPixel();return e="right"==i?this.data.start.getTime()>t.start&&this.data.start.getTime()-n<t.end:"left"==i?this.data.start.getTime()+n>t.start&&this.data.start.getTime()<t.end:this.data.start.getTime()+n/2>t.start&&this.data.start.getTime()-n/2<t.end,e}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-line",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-dot",this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}if(!this.dom.line.parentNode){var e=this.parent.dom.background;if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className="vis-item vis-box".concat(e),this.dom.line.className="vis-item vis-line".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},dot:{height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},line:{width:this.dom.line.offsetWidth},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.props.dot.height=t.dot.height,this.props.dot.width=t.dot.width,this.props.line.width=t.line.width,this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.box)}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[Od(e=this._createDomElement).call(e,this),Od(i=this._appendDomElement).call(i,this),Od(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(r=a._getDomComponentsSizes())},function(){var t;a.dirty&&Od(t=a._updateDomComponentsSizes).call(t,a)(r)},Od(o=this._repaintDomAdditionals).call(o,this)];return t?l:(cp(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.remove?t.box.remove():t.box.parentNode&&t.box.parentNode.removeChild(t.box),t.line.remove?t.line.remove():t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.remove?t.dot.remove():t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot),this.displayed=!1}}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?zv(n="translate(".concat(o,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(o,"px)")}};e(this.dom.box,this.boxX,this.boxY,t),e(this.dom.dot,this.dotX,this.dotY,t),e(this.dom.line,this.lineX,this.lineY,t)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=void 0===this.data.align?this.options.align:this.data.align,i=this.props.line.width,n=this.props.dot.width;"right"==e?(this.boxX=t-this.width,this.lineX=t-i,this.dotX=t-i/2-n/2):"left"==e?(this.boxX=t,this.lineX=t,this.dotX=t+i/2-n/2):(this.boxX=t-this.width/2,this.lineX=this.options.rtl?t-i:t-i/2,this.dotX=t-n/2),this.options.rtl?this.right=this.boxX:this.left=this.boxX,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.line.style;if("top"==t){var i=this.parent.top+this.top+1;this.boxY=this.top||0,e.height="".concat(i,"px"),e.bottom="",e.top="0"}else{var n=this.parent.itemSet.props.height-this.parent.top-this.parent.height+this.top;this.boxY=this.parent.height-this.top-(this.height||0),e.height="".concat(n,"px"),e.top="",e.bottom="0"}this.dotY=-this.props.dot.height/2,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}}]),i}();function PE(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var ME=function(t){ud(i,EE);var e=PE(i);function i(t,n,o){var r;if(Go(this,i),(r=e.call(this,t,n,o)).props={dot:{top:0,width:0,height:0},content:{height:0,marginLeft:0,marginRight:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return r}return Pc(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e=this.width*t.getMillisecondsPerPixel();return this.data.start.getTime()+e>t.start&&this.data.start<t.end}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.point=document.createElement("div"),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.point.appendChild(this.dom.content),this.dom.dot=document.createElement("div"),this.dom.point.appendChild(this.dom.dot),this.dom.point["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.point.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.point)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.point),this._updateStyle(this.dom.point);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.point.className="vis-item vis-point".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{dot:{width:this.dom.dot.offsetWidth,height:this.dom.dot.offsetHeight},content:{width:this.dom.content.offsetWidth,height:this.dom.content.offsetHeight},point:{width:this.dom.point.offsetWidth,height:this.dom.point.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.dot.width=t.dot.width,this.props.dot.height=t.dot.height,this.props.content.height=t.content.height,this.options.rtl?this.dom.content.style.marginRight="".concat(this.props.dot.width/2,"px"):this.dom.content.style.marginLeft="".concat(this.props.dot.width/2,"px"),this.width=t.point.width,this.height=t.point.height,this.dom.dot.style.top="".concat((this.height-this.props.dot.height)/2,"px");var e=this.props.dot.width,i=this.options.rtl?e/2:e/2*-1;this.dom.dot.style.transform="translateX(".concat(i,"px"),this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.point),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.point)}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[Od(e=this._createDomElement).call(e,this),Od(i=this._appendDomElement).call(i,this),Od(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(r=a._getDomComponentsSizes())},function(){var t;a.dirty&&Od(t=a._updateDomComponentsSizes).call(t,a)(r)},Od(o=this._repaintDomAdditionals).call(o,this)];return t?l:(cp(l).call(l,(function(t){s=t()})),s)}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?zv(n="translate(".concat(o,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(o,"px)")}};e(this.dom.point,this.pointX,this.pointY,t)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){this.displayed&&(this.dom.point.parentNode&&this.dom.point.parentNode.removeChild(this.dom.point),this.displayed=!1)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start);this.pointX=t,this.options.rtl?this.right=t-this.props.dot.width:this.left=t-this.props.dot.width,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item;this.pointY="top"==t?this.top:this.parent.height-this.top-this.height,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.props.dot.width}},{key:"getWidthRight",value:function(){return this.props.dot.width}}]),i}();function NE(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var FE=function(t){ud(i,EE);var e=NE(i);function i(t,n,o){var r;if(Go(this,i),(r=e.call(this,t,n,o)).props={content:{width:0}},r.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return r}return Pc(i,[{key:"isVisible",value:function(t){return!this.cluster&&(this.data.start<t.end&&this.data.end>t.start)}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.visibleFrame=document.createElement("div"),this.dom.visibleFrame.className="vis-item-visible-frame",this.dom.box.appendChild(this.dom.visibleFrame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className=this.baseClassName+e,this.dom.content.style.maxWidth="none"}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.frame).overflow,this.whiteSpace="nowrap"!==window.getComputedStyle(this.dom.content).whiteSpace,{content:{width:this.dom.content.offsetWidth},box:{height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=t.box.height,this.dom.content.style.maxWidth="",this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDeleteButton(this.dom.box),this._repaintDragCenter(),this._repaintDragLeft(),this._repaintDragRight()}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[Od(e=this._createDomElement).call(e,this),Od(i=this._appendDomElement).call(i,this),Od(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(r=Od(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Od(t=a._updateDomComponentsSizes).call(t,a)(r)},Od(o=this._repaintDomAdditionals).call(o,this)];return t?l:(cp(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom.box;t.parentNode&&t.parentNode.removeChild(t),this.displayed=!1}}},{key:"repositionX",value:function(t){var e,i,n=this.parent.width,o=this.conversion.toScreen(this.data.start),r=this.conversion.toScreen(this.data.end),s=void 0===this.data.align?this.options.align:this.data.align;!1===this.data.limitSize||void 0!==t&&!0!==t||(o<-n&&(o=-n),r>2*n&&(r=2*n));var a=Math.max(Math.round(1e3*(r-o))/1e3,1);switch(this.overflow?(this.options.rtl?this.right=o:this.left=o,this.width=a+this.props.content.width,i=this.props.content.width):(this.options.rtl?this.right=o:this.left=o,this.width=a,i=Math.min(r-o,this.props.content.width)),this.options.rtl?this.dom.box.style.transform="translateX(".concat(-1*this.right,"px)"):this.dom.box.style.transform="translateX(".concat(this.left,"px)"),this.dom.box.style.width="".concat(a,"px"),this.whiteSpace&&(this.height=this.dom.box.offsetHeight),s){case"left":this.dom.content.style.transform="translateX(0)";break;case"right":if(this.options.rtl){var l=-1*Math.max(a-i,0);this.dom.content.style.transform="translateX(".concat(l,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max(a-i,0),"px)");break;case"center":if(this.options.rtl){var h=-1*Math.max((a-i)/2,0);this.dom.content.style.transform="translateX(".concat(h,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max((a-i)/2,0),"px)");break;default:if(e=this.overflow?r>0?Math.max(-o,0):-i:o<0?-o:0,this.options.rtl){var u=-1*e;this.dom.content.style.transform="translateX(".concat(u,"px)")}else this.dom.content.style.transform="translateX(".concat(e,"px)")}}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;e.style.top="".concat("top"==t?this.top:this.parent.height-this.top-this.height,"px")}},{key:"_repaintDragLeft",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragLeft){var t=document.createElement("div");t.className="vis-drag-left",t.dragLeftItem=this,this.dom.box.appendChild(t),this.dom.dragLeft=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragLeft||(this.dom.dragLeft.parentNode&&this.dom.dragLeft.parentNode.removeChild(this.dom.dragLeft),this.dom.dragLeft=null)}},{key:"_repaintDragRight",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragRight){var t=document.createElement("div");t.className="vis-drag-right",t.dragRightItem=this,this.dom.box.appendChild(t),this.dom.dragRight=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragRight||(this.dom.dragRight.parentNode&&this.dom.dragRight.parentNode.removeChild(this.dom.dragRight),this.dom.dragRight=null)}}]),i}();function RE(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}FE.prototype.baseClassName="vis-item vis-range";var LE=function(t){ud(i,EE);var e=RE(i);function i(t,n,o){var r;if(Go(this,i),(r=e.call(this,t,n,o)).props={content:{width:0}},r.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return r}return Pc(i,[{key:"isVisible",value:function(t){return this.data.start<t.end&&this.data.end>t.start}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.background;if(!t)throw new Error("Cannot redraw item: parent has no background container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.content),this._updateStyle(this.dom.box);var t=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"");this.dom.box.className=this.baseClassName+t}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.content).overflow,{content:{width:this.dom.content.offsetWidth}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=0,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[Od(e=this._createDomElement).call(e,this),Od(i=this._appendDomElement).call(i,this),Od(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(r=Od(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Od(t=a._updateDomComponentsSizes).call(t,a)(r)},Od(o=this._repaintDomAdditionals).call(o,this)];return t?l:(cp(l).call(l,(function(t){s=t()})),s)}},{key:"repositionY",value:function(t){var e,i=this.options.orientation.item;if(void 0!==this.data.subgroup){var n=this.data.subgroup;this.dom.box.style.height="".concat(this.parent.subgroups[n].height,"px"),this.dom.box.style.top="".concat("top"==i?this.parent.top+this.parent.subgroups[n].top:this.parent.top+this.parent.height-this.parent.subgroups[n].top-this.parent.subgroups[n].height,"px"),this.dom.box.style.bottom=""}else this.parent instanceof DE?(e=Math.max(this.parent.height,this.parent.itemSet.body.domProps.center.height,this.parent.itemSet.body.domProps.centerContainer.height),this.dom.box.style.bottom="bottom"==i?"0":"",this.dom.box.style.top="top"==i?"0":""):(e=this.parent.height,this.dom.box.style.top="".concat(this.parent.top,"px"),this.dom.box.style.bottom="");this.dom.box.style.height="".concat(e,"px")}}]),i}();LE.prototype.baseClassName="vis-item vis-background",LE.prototype.stack=!1,LE.prototype.show=FE.prototype.show,LE.prototype.hide=FE.prototype.hide,LE.prototype.repositionX=FE.prototype.repositionX;var jE=function(){function t(e,i){Go(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Pc(t,[{key:"setPosition",value:function(t,e){this.x=vb(t),this.y=vb(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=WC.xss(t)}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,r=0,s=0;if("flip"==this.overflowMethod||"none"==this.overflowMethod){var a=!1,l=!0;"flip"==this.overflowMethod&&(this.y-e<this.padding&&(l=!1),this.x+i>o-this.padding&&(a=!0)),r=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(r=this.x)+i+this.padding>o&&(r=o-i-this.padding),r<this.padding&&(r=this.padding);this.frame.style.left=r+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),BE={},zE={get exports(){return BE},set exports(t){BE=t}},HE=ia.every;Ni({target:"Array",proto:!0,forced:!tp("every")},{every:function(t){return HE(this,t,arguments.length>1?arguments[1]:void 0)}});var GE=td("Array").every,WE=mt,YE=GE,VE=Array.prototype,UE=function(t){var e=t.every;return t===VE||WE(VE,t)&&e===VE.every?YE:e},XE=UE;zE.exports=XE;var qE=a(BE);function KE(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return $E(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $E(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function $E(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function ZE(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var QE=function(t){ud(i,EE);var e=ZE(i);function i(t,n,o){var r;Go(this,i);var s=sy({},{fitOnDoubleClick:!0},o,{editable:!1});if((r=e.call(this,t,n,s)).props={content:{width:0,height:0}},!t||null==t.uiItems)throw new Error('Property "uiItems" missing in item '+t.id);return r.id=PC(),r.group=t.group,r._setupRange(),r.emitter=r.data.eventEmitter,r.range=r.data.range,r.attached=!1,r.isCluster=!0,r.data.isCluster=!0,r}return Pc(i,[{key:"hasItems",value:function(){return this.data.uiItems&&this.data.uiItems.length&&this.attached}},{key:"setUiItems",value:function(t){this.detach(),this.data.uiItems=t,this._setupRange(),this.attach()}},{key:"isVisible",value:function(t){var e=this.data.end?this.data.end-this.data.start:0,i=this.width*t.getMillisecondsPerPixel(),n=Math.max(this.data.start.getTime()+e,this.data.start.getTime()+i);return this.data.start<t.end&&n>t.start&&this.hasItems()}},{key:"getData",value:function(){return{isCluster:!0,id:this.id,items:this.data.items||[],data:this.data}}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a,l,h=[Od(e=this._createDomElement).call(e,this),Od(i=this._appendDomElement).call(i,this),Od(n=this._updateDirtyDomComponents).call(n,this),Od(o=function(){this.dirty&&(a=this._getDomComponentsSizes())}).call(o,this),Od(r=function(){var t;this.dirty&&Od(t=this._updateDomComponentsSizes).call(t,this)(a)}).call(r,this),Od(s=this._repaintDomAdditionals).call(s,this)];return t?h:(cp(h).call(h,(function(t){l=t()})),l)}},{key:"show",value:function(){this.displayed||this.redraw()}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.parentNode.removeChild(t.box),this.options.showStipes&&(t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot)),this.displayed=!1}}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.data.end?this.conversion.toScreen(this.data.end):0;if(e)this.repositionXWithRanges(t,e);else{var i=void 0===this.data.align?this.options.align:this.data.align;this.repositionXWithoutRanges(t,i)}this.options.showStipes&&(this.dom.line.style.display=this._isStipeVisible()?"block":"none",this.dom.dot.style.display=this._isStipeVisible()?"block":"none",this._isStipeVisible()&&this.repositionStype(t,e))}},{key:"repositionStype",value:function(t,e){this.dom.line.style.display="block",this.dom.dot.style.display="block";var i=this.dom.line.offsetWidth,n=this.dom.dot.offsetWidth;if(e){var o=i+t+(e-t)/2,r=o-n/2,s=this.options.rtl?-1*o:o,a=this.options.rtl?-1*r:r;this.dom.line.style.transform="translateX(".concat(s,"px)"),this.dom.dot.style.transform="translateX(".concat(a,"px)")}else{var l=this.options.rtl?-1*t:t,h=this.options.rtl?-1*(t-n/2):t-n/2;this.dom.line.style.transform="translateX(".concat(l,"px)"),this.dom.dot.style.transform="translateX(".concat(h,"px)")}}},{key:"repositionXWithoutRanges",value:function(t,e){"right"==e?this.options.rtl?(this.right=t-this.width,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width,this.dom.box.style.left=this.left+"px"):"left"==e?this.options.rtl?(this.right=t,this.dom.box.style.right=this.right+"px"):(this.left=t,this.dom.box.style.left=this.left+"px"):this.options.rtl?(this.right=t-this.width/2,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width/2,this.dom.box.style.left=this.left+"px")}},{key:"repositionXWithRanges",value:function(t,e){var i=Math.round(Math.max(e-t+.5,1));this.options.rtl?this.right=t:this.left=t,this.width=Math.max(i,this.minWidth||0),this.options.rtl?this.dom.box.style.right=this.right+"px":this.dom.box.style.left=this.left+"px",this.dom.box.style.width=i+"px"}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;if(e.style.top="top"==t?(this.top||0)+"px":(this.parent.height-this.top-this.height||0)+"px",this.options.showStipes){if("top"==t)this.dom.line.style.top="0",this.dom.line.style.height=this.parent.top+this.top+1+"px",this.dom.line.style.bottom="";else{var i=this.parent.itemSet.props.height,n=i-this.parent.top-this.parent.height+this.top;this.dom.line.style.top=i-n+"px",this.dom.line.style.bottom="0"}this.dom.dot.style.top=-this.dom.dot.offsetHeight/2+"px"}}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}},{key:"move",value:function(){this.repositionX(),this.repositionY()}},{key:"attach",value:function(){var t,e,i=KE(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){e.value.cluster=this}}catch(t){i.e(t)}finally{i.f()}this.data.items=km(t=this.data.uiItems).call(t,(function(t){return t.data})),this.attached=!0,this.dirty=!0}},{key:"detach",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.hasItems()){var e,i=KE(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){delete e.value.cluster}}catch(t){i.e(t)}finally{i.f()}this.attached=!1,t&&this.group&&(this.group.remove(this),this.group=null),this.data.items=[],this.dirty=!0}}},{key:"_onDoubleClick",value:function(){this._fit()}},{key:"_setupRange",value:function(){var t,e,i,n=km(t=this.data.uiItems).call(t,(function(t){return{start:t.data.start.valueOf(),end:t.data.end?t.data.end.valueOf():t.data.start.valueOf()}}));this.data.min=Math.min.apply(Math,Ev(km(n).call(n,(function(t){return Math.min(t.start,t.end||t.start)})))),this.data.max=Math.max.apply(Math,Ev(km(n).call(n,(function(t){return Math.max(t.start,t.end||t.start)}))));var o=km(e=this.data.uiItems).call(e,(function(t){return t.center})),r=Bm(o).call(o,(function(t,e){return t+e}),0)/this.data.uiItems.length;ID(i=this.data.uiItems).call(i,(function(t){return t.data.end}))?(this.data.start=new Date(this.data.min),this.data.end=new Date(this.data.max)):(this.data.start=new Date(r),this.data.end=null)}},{key:"_getUiItems",value:function(){var t,e=this;return this.data.uiItems&&this.data.uiItems.length?Dp(t=this.data.uiItems).call(t,(function(t){return t.cluster===e})):[]}},{key:"_createDomElement",value:function(){if(!this.dom){var t;if(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.options.showStipes&&(this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-cluster-line",this.dom.line.style.display="none",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-cluster-dot",this.dom.dot.style.display="none"),this.options.fitOnDoubleClick)this.dom.box.ondblclick=Od(t=i.prototype._onDoubleClick).call(t,this);this.dom.box["vis-item"]=this,this.dirty=!0}}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}var e=this.parent.dom.background;if(this.options.showStipes){if(!this.dom.line.parentNode){if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.baseClassName+" "+(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+" vis-readonly";this.dom.box.className="vis-item "+t,this.options.showStipes&&(this.dom.line.className="vis-item vis-cluster-line "+(this.selected?" vis-selected":""),this.dom.dot.className="vis-item vis-cluster-dot "+(this.selected?" vis-selected":"")),this.data.end&&(this.dom.content.style.maxWidth="none")}}},{key:"_getDomComponentsSizes",value:function(){var t={previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}};return this.options.showStipes&&(t.dot={height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},t.line={width:this.dom.line.offsetWidth}),t}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.data.end?this.minWidth=t.box.width:this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box)}},{key:"_isStipeVisible",value:function(){return this.minWidth>=this.width||!this.data.end}},{key:"_getFitRange",value:function(){var t=.05*(this.data.max-this.data.min)/2;return{fitStart:this.data.min-t,fitEnd:this.data.max+t}}},{key:"_fit",value:function(){if(this.emitter){var t=this._getFitRange(),e=t.fitStart,i=t.fitEnd,n={start:new Date(e),end:new Date(i),animation:!0};this.emitter.emit("fit",n)}}},{key:"_getItemData",value:function(){return this.data}}]),i}();function JE(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return tA(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return tA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function tA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}QE.prototype.baseClassName="vis-item vis-range vis-cluster";var eA="__ungrouped__",iA=function(){function t(e){Go(this,t),this.itemSet=e,this.groups={},this.cache={},this.cache[-1]=[]}return Pc(t,[{key:"createClusterItem",value:function(t,e,i){return new QE(t,e,i)}},{key:"setItems",value:function(t,e){this.items=t||[],this.dataChanged=!0,this.applyOnChangedLevel=!1,e&&e.applyOnChangedLevel&&(this.applyOnChangedLevel=e.applyOnChangedLevel)}},{key:"updateData",value:function(){this.dataChanged=!0,this.applyOnChangedLevel=!1}},{key:"getClusters",value:function(t,e,i){var n="boolean"==typeof i?{}:i,o=n.maxItems,r=n.clusterCriteria;r||(r=function(){return!0}),o=o||1;var s=-1,a=0;if(e>0){if(e>=1)return[];s=Math.abs(Math.round(Math.log(100/e)/Math.log(2))),a=Math.abs(Math.pow(2,s))}if(this.dataChanged){var l=s!=this.cacheLevel;(!this.applyOnChangedLevel||l)&&(this._dropLevelsCache(),this._filterData())}this.cacheLevel=s;var h=this.cache[s];if(!h){for(var u in h=[],this.groups)if(this.groups.hasOwnProperty(u))for(var c=this.groups[u],d=c.length,p=0;p<d;){for(var m=c[p],f=1,v=p-1;v>=0&&m.center-c[v].center<a/2;)!c[v].cluster&&r(m.data,c[v].data)&&f++,v--;for(var g=p+1;g<c.length&&c[g].center-m.center<a/2;)r(m.data,c[g].data)&&f++,g++;for(var y=h.length-1;y>=0&&m.center-h[y].center<a;)m.group==h[y].group&&r(m.data,h[y].data)&&f++,y--;if(f>o){for(var b=f-o+1,w=[],k=p;w.length<b&&k<c.length;)r(c[p].data,c[k].data)&&w.push(c[k]),k++;var x=this.itemSet.getGroupId(m.data),_=this.itemSet.groups[x]||this.itemSet.groups[eA],C=this._getClusterForItems(w,_,t,i);h.push(C),p+=b}else delete m.cluster,p+=1}this.cache[s]=h}return h}},{key:"_filterData",value:function(){var t={};this.groups=t;for(var e=0,i=Vy(this.items);e<i.length;e++){var n=i[e],o=n.parent?n.parent.groupId:"",r=t[o];r||(r=[],t[o]=r),r.push(n),n.data.start&&(n.data.end?n.center=(n.data.start.valueOf()+n.data.end.valueOf())/2:n.center=n.data.start.valueOf())}for(var s in t){var a;if(t.hasOwnProperty(s))oD(a=t[s]).call(a,(function(t,e){return t.center-e.center}))}this.dataChanged=!1}},{key:"_getClusterForItems",value:function(t,e,i,n){var o,r,s=km(o=i||[]).call(o,(function(t){var e;return{cluster:t,itemsIds:new $O(km(e=t.data.uiItems).call(e,(function(t){return t.id})))}}));if(s.length){var a,l=JE(s);try{var h=function(){var e=a.value;if(e.itemsIds.size===t.length&&qE(t).call(t,(function(t){return e.itemsIds.has(t.id)})))return r=e.cluster,"break"};for(l.s();!(a=l.n()).done;){if("break"===h())break}}catch(t){l.e(t)}finally{l.f()}}if(r)return r.setUiItems(t),r.group!==e&&(r.group&&r.group.remove(r),e&&(e.add(r),r.group=e)),r;var u=n.titleTemplate||"",c={toScreen:this.itemSet.body.util.toScreen,toTime:this.itemSet.body.util.toTime},d=u.replace(/{count}/,t.length),p='<div title="'+d+'">'+t.length+"</div>",m=sy({},n,this.itemSet.options),f={content:p,title:d,group:e,uiItems:t,eventEmitter:this.itemSet.body.emitter,range:this.itemSet.body.range};return r=this.createClusterItem(f,c,m),e&&(e.add(r),r.group=e),r.attach(),r}},{key:"_dropLevelsCache",value:function(){this.cache={},this.cacheLevel=-1,this.cache[this.cacheLevel]=[]}}]),t}();function nA(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return oA(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return oA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function oA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function rA(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var sA="__ungrouped__",aA="__background__",lA=function(t){ud(i,oS);var e=rA(i);function i(t,n){var o;Go(this,i),(o=e.call(this)).body=t,o.defaultOptions={type:null,orientation:{item:"bottom"},align:"auto",stack:!0,stackSubgroups:!0,groupOrderSwap:function(t,e,i){var n=e.order;e.order=t.order,t.order=n},groupOrder:"order",selectable:!0,multiselect:!1,longSelectPressTime:251,itemsAlwaysDraggable:{item:!1,range:!1},editable:{updateTime:!1,updateGroup:!1,add:!1,remove:!1,overrideItems:!1},groupEditable:{order:!1,add:!1,remove:!1},snap:BD.snap,onDropObjectOnItem:function(t,e,i){i(e)},onAdd:function(t,e){e(t)},onUpdate:function(t,e){e(t)},onMove:function(t,e){e(t)},onRemove:function(t,e){e(t)},onMoving:function(t,e){e(t)},onAddGroup:function(t,e){e(t)},onMoveGroup:function(t,e){e(t)},onRemoveGroup:function(t,e){e(t)},margin:{item:{horizontal:10,vertical:10},axis:20},showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:500},tooltipOnItemUpdateTime:!1},o.options=WC.extend({},o.defaultOptions),o.options.rtl=n.rtl,o.options.onTimeout=n.onTimeout,o.conversion={toScreen:t.util.toScreen,toTime:t.util.toTime},o.dom={},o.props={},o.hammer=null;var r=Mc(o);return o.itemsData=null,o.groupsData=null,o.itemsSettingTime=null,o.initialItemSetDrawn=!1,o.userContinueNotBail=null,o.sequentialSelection=!1,o.itemListeners={add:function(t,e,i){r._onAdd(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()},update:function(t,e,i){r._onUpdate(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()},remove:function(t,e,i){r._onRemove(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()}},o.groupListeners={add:function(t,e,i){if(r._onAddGroups(e.items),r.groupsData&&r.groupsData.length>0){var n,o=r.groupsData.getDataSet();cp(n=o.get()).call(n,(function(t){if(t.nestedGroups){var e;0!=t.showNested&&(t.showNested=!0);var n=[];cp(e=t.nestedGroups).call(e,(function(e){var i=o.get(e);i&&(i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),n=zv(n).call(n,i))})),o.update(n,i)}}))}},update:function(t,e,i){r._onUpdateGroups(e.items)},remove:function(t,e,i){r._onRemoveGroups(e.items)}},o.items={},o.groups={},o.groupIds=[],o.selection=[],o.popup=null,o.popupTimer=null,o.touchParams={},o.groupTouchParams={group:null,isDragging:!1},o._create(),o.setOptions(n),o.clusters=[],o}return Pc(i,[{key:"_create",value:function(){var t,e,i,n,o,r,s,a,l,h,u,c,d,p,m,f=this,v=document.createElement("div");v.className="vis-itemset",v["vis-itemset"]=this,this.dom.frame=v;var g=document.createElement("div");g.className="vis-background",v.appendChild(g),this.dom.background=g;var y=document.createElement("div");y.className="vis-foreground",v.appendChild(y),this.dom.foreground=y;var b=document.createElement("div");b.className="vis-axis",this.dom.axis=b;var w=document.createElement("div");w.className="vis-labelset",this.dom.labelSet=w,this._updateUngrouped();var k=new DE(aA,null,this);k.show(),this.groups[aA]=k,this.hammer=new LD(this.body.dom.centerContainer),this.hammer.on("hammer.input",(function(t){t.isFirst&&f._onTouch(t)})),this.hammer.on("panstart",Od(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Od(e=this._onDrag).call(e,this)),this.hammer.on("panend",Od(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:LD.ALL}),this.hammer.get("press").set({time:1e4}),this.hammer.on("tap",Od(n=this._onSelectItem).call(n,this)),this.hammer.on("press",Od(o=this._onMultiSelectItem).call(o,this)),this.hammer.get("press").set({time:1e4}),this.hammer.on("doubletap",Od(r=this._onAddItem).call(r,this)),this.options.rtl?this.groupHammer=new LD(this.body.dom.rightContainer):this.groupHammer=new LD(this.body.dom.leftContainer),this.groupHammer.on("tap",Od(s=this._onGroupClick).call(s,this)),this.groupHammer.on("panstart",Od(a=this._onGroupDragStart).call(a,this)),this.groupHammer.on("panmove",Od(l=this._onGroupDrag).call(l,this)),this.groupHammer.on("panend",Od(h=this._onGroupDragEnd).call(h,this)),this.groupHammer.get("pan").set({threshold:5,direction:LD.DIRECTION_VERTICAL}),this.body.dom.centerContainer.addEventListener("mouseover",Od(u=this._onMouseOver).call(u,this)),this.body.dom.centerContainer.addEventListener("mouseout",Od(c=this._onMouseOut).call(c,this)),this.body.dom.centerContainer.addEventListener("mousemove",Od(d=this._onMouseMove).call(d,this)),this.body.dom.centerContainer.addEventListener("contextmenu",Od(p=this._onDragEnd).call(p,this)),this.body.dom.centerContainer.addEventListener("mousewheel",Od(m=this._onMouseWheel).call(m,this)),this.show()}},{key:"setOptions",value:function(t){var e=this;if(t){var i,n;WC.selectiveExtend(["type","rtl","align","order","stack","stackSubgroups","selectable","multiselect","sequentialSelection","multiselectPerGroup","longSelectPressTime","groupOrder","dataAttributes","template","groupTemplate","visibleFrameTemplate","hide","snap","groupOrderSwap","showTooltips","tooltip","tooltipOnItemUpdateTime","groupHeightMode","onTimeout"],this.options,t),"itemsAlwaysDraggable"in t&&("boolean"==typeof t.itemsAlwaysDraggable?(this.options.itemsAlwaysDraggable.item=t.itemsAlwaysDraggable,this.options.itemsAlwaysDraggable.range=!1):"object"===_c(t.itemsAlwaysDraggable)&&(WC.selectiveExtend(["item","range"],this.options.itemsAlwaysDraggable,t.itemsAlwaysDraggable),this.options.itemsAlwaysDraggable.item||(this.options.itemsAlwaysDraggable.range=!1))),"sequentialSelection"in t&&"boolean"==typeof t.sequentialSelection&&(this.options.sequentialSelection=t.sequentialSelection),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.item="top"===t.orientation?"top":"bottom":"object"===_c(t.orientation)&&"item"in t.orientation&&(this.options.orientation.item=t.orientation.item)),"margin"in t&&("number"==typeof t.margin?(this.options.margin.axis=t.margin,this.options.margin.item.horizontal=t.margin,this.options.margin.item.vertical=t.margin):"object"===_c(t.margin)&&(WC.selectiveExtend(["axis"],this.options.margin,t.margin),"item"in t.margin&&("number"==typeof t.margin.item?(this.options.margin.item.horizontal=t.margin.item,this.options.margin.item.vertical=t.margin.item):"object"===_c(t.margin.item)&&WC.selectiveExtend(["horizontal","vertical"],this.options.margin.item,t.margin.item)))),cp(i=["locale","locales"]).call(i,(function(i){i in t&&(e.options[i]=t[i])})),"editable"in t&&("boolean"==typeof t.editable?(this.options.editable.updateTime=t.editable,this.options.editable.updateGroup=t.editable,this.options.editable.add=t.editable,this.options.editable.remove=t.editable,this.options.editable.overrideItems=!1):"object"===_c(t.editable)&&WC.selectiveExtend(["updateTime","updateGroup","add","remove","overrideItems"],this.options.editable,t.editable)),"groupEditable"in t&&("boolean"==typeof t.groupEditable?(this.options.groupEditable.order=t.groupEditable,this.options.groupEditable.add=t.groupEditable,this.options.groupEditable.remove=t.groupEditable):"object"===_c(t.groupEditable)&&WC.selectiveExtend(["order","add","remove"],this.options.groupEditable,t.groupEditable));cp(n=["onDropObjectOnItem","onAdd","onUpdate","onRemove","onMove","onMoving","onAddGroup","onMoveGroup","onRemoveGroup"]).call(n,(function(i){var n=t[i];if(n){var o;if("function"!=typeof n)throw new Error(zv(o="option ".concat(i," must be a function ")).call(o,i,"(item, callback)"));e.options[i]=n}})),t.cluster?(sy(this.options,{cluster:t.cluster}),this.clusterGenerator||(this.clusterGenerator=new iA(this)),this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.clusterGenerator?(this._detachAllClusters(),this.clusters=[],this.clusterGenerator=null,this.options.cluster=void 0,this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.markDirty()}}},{key:"markDirty",value:function(t){this.groupIds=[],t&&(t.refreshItems&&cp(WC).call(WC,this.items,(function(t){t.dirty=!0,t.displayed&&t.redraw()})),t.restackGroups&&cp(WC).call(WC,this.groups,(function(t,e){e!==aA&&(t.stackDirty=!0)})))}},{key:"destroy",value:function(){this.clearPopupTimer(),this.hide(),this.setItems(null),this.setGroups(null),this.hammer&&this.hammer.destroy(),this.groupHammer&&this.groupHammer.destroy(),this.hammer=null,this.body=null,this.conversion=null}},{key:"hide",value:function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.axis.parentNode&&this.dom.axis.parentNode.removeChild(this.dom.axis),this.dom.labelSet.parentNode&&this.dom.labelSet.parentNode.removeChild(this.dom.labelSet)}},{key:"show",value:function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame),this.dom.axis.parentNode||this.body.dom.backgroundVertical.appendChild(this.dom.axis),this.dom.labelSet.parentNode||(this.options.rtl?this.body.dom.right.appendChild(this.dom.labelSet):this.body.dom.left.appendChild(this.dom.labelSet))}},{key:"setPopupTimer",value:function(t){if(this.clearPopupTimer(),t){var e=this.options.tooltip.delay||"number"==typeof this.options.tooltip.delay?this.options.tooltip.delay:500;this.popupTimer=$d((function(){t.show()}),e)}}},{key:"clearPopupTimer",value:function(){null!=this.popupTimer&&(clearTimeout(this.popupTimer),this.popupTimer=null)}},{key:"setSelection",value:function(t){var e;null==t&&(t=[]),Dd(t)||(t=[t]);var i,n=Dp(e=this.selection).call(e,(function(e){return-1===Ab(t).call(t,e)})),o=nA(n);try{for(o.s();!(i=o.n()).done;){var r=i.value,s=this.getItemById(r);s&&s.unselect()}}catch(t){o.e(t)}finally{o.f()}this.selection=Ev(t);var a,l=nA(t);try{for(l.s();!(a=l.n()).done;){var h=a.value,u=this.getItemById(h);u&&u.select()}}catch(t){l.e(t)}finally{l.f()}}},{key:"getSelection",value:function(){var t;return zv(t=this.selection).call(t,[])}},{key:"getVisibleItems",value:function(){var t,e,i=this.body.range.getRange();this.options.rtl?(t=this.body.util.toScreen(i.start),e=this.body.util.toScreen(i.end)):(e=this.body.util.toScreen(i.start),t=this.body.util.toScreen(i.end));var n=[];for(var o in this.groups)if(this.groups.hasOwnProperty(o)){var r,s=this.groups[o],a=nA(s.isVisible?s.visibleItems:[]);try{for(a.s();!(r=a.n()).done;){var l=r.value;this.options.rtl?l.right<e&&l.right+l.width>t&&n.push(l.id):l.left<t&&l.left+l.width>e&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getItemsAtCurrentTime",value:function(t){var e,i;this.options.rtl?(e=this.body.util.toScreen(t),i=this.body.util.toScreen(t)):(i=this.body.util.toScreen(t),e=this.body.util.toScreen(t));var n=[];for(var o in this.groups)if(this.groups.hasOwnProperty(o)){var r,s=this.groups[o],a=nA(s.isVisible?s.visibleItems:[]);try{for(a.s();!(r=a.n()).done;){var l=r.value;this.options.rtl?l.right<i&&l.right+l.width>e&&n.push(l.id):l.left<e&&l.left+l.width>i&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getVisibleGroups",value:function(){var t=[];for(var e in this.groups){if(this.groups.hasOwnProperty(e))this.groups[e].isVisible&&t.push(e)}return t}},{key:"getItemById",value:function(t){var e;return this.items[t]||xT(e=this.clusters).call(e,(function(e){return e.id===t}))}},{key:"_deselect",value:function(t){for(var e=this.selection,i=0,n=e.length;i<n;i++)if(e[i]==t){Gg(e).call(e,i,1);break}}},{key:"redraw",value:function(){var t=this.options.margin,e=this.body.range,i=WC.option.asSize,n=this.options,o=n.orientation.item,r=!1,s=this.dom.frame;this.props.top=this.body.domProps.top.height+this.body.domProps.border.top,this.options.rtl?this.props.right=this.body.domProps.right.width+this.body.domProps.border.right:this.props.left=this.body.domProps.left.width+this.body.domProps.border.left,s.className="vis-itemset",this.options.cluster&&this._clusterItems(),r=this._orderGroups()||r;var a=e.end-e.start,l=a!=this.lastVisibleInterval||this.props.width!=this.props.lastWidth,h=e.start!=this.lastRangeStart,u=n.stack!=this.lastStack,c=n.stackSubgroups!=this.lastStackSubgroups,d=l||h||u||c;this.lastVisibleInterval=a,this.lastRangeStart=e.start,this.lastStack=n.stack,this.lastStackSubgroups=n.stackSubgroups,this.props.lastWidth=this.props.width;var p=this._firstGroup(),m={item:t.item,axis:t.axis},f={item:t.item,axis:t.item.vertical/2},v=0,g=t.axis+t.item.vertical;this.groups[aA].redraw(e,f,d);var y={},b=0;if(cp(WC).call(WC,this.groups,(function(t,i){if(i!==aA){var n=t==p?m:f;y[i]=t.redraw(e,n,d,!0),b=y[i].length}})),b>0){for(var w={},k=function(t){cp(WC).call(WC,y,(function(e,i){w[i]=e[t]()}))},x=0;x<b;x++)k(x);cp(WC).call(WC,this.groups,(function(t,e){if(e!==aA){var i=w[e];r=i||r,v+=t.height}})),v=Math.max(v,g)}return v=Math.max(v,g),s.style.height=i(v),this.props.width=s.offsetWidth,this.props.height=v,this.dom.axis.style.top=i("top"==o?this.body.domProps.top.height+this.body.domProps.border.top:this.body.domProps.top.height+this.body.domProps.centerContainer.height),this.options.rtl?this.dom.axis.style.right="0":this.dom.axis.style.left="0",this.hammer.get("press").set({time:this.options.longSelectPressTime}),this.initialItemSetDrawn=!0,r=this._isResized()||r}},{key:"_firstGroup",value:function(){var t="top"==this.options.orientation.item?0:this.groupIds.length-1,e=this.groupIds[t];return this.groups[e]||this.groups[sA]||null}},{key:"_updateUngrouped",value:function(){var t,e,i=this.groups[sA];if(this.groupsData){if(i)for(e in i.dispose(),delete this.groups[sA],this.items)if(this.items.hasOwnProperty(e)){(t=this.items[e]).parent&&t.parent.remove(t);var n=this.getGroupId(t.data),o=this.groups[n];o&&o.add(t)||t.hide()}}else if(!i){for(e in i=new CE(null,null,this),this.groups[sA]=i,this.items)this.items.hasOwnProperty(e)&&(t=this.items[e],i.add(t));i.show()}}},{key:"getLabelSet",value:function(){return this.dom.labelSet}},{key:"setItems",value:function(t){this.itemsSettingTime=new Date;var e,i=this,n=this.itemsData;if(t){if(!FC(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=BC(t)}else this.itemsData=null;if(n&&(cp(WC).call(WC,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var o=this.id;cp(WC).call(WC,this.itemListeners,(function(t,e){i.itemsData.on(e,t,o)})),e=this.itemsData.getIds(),this._onAdd(e),this._updateUngrouped()}this.body.emitter.emit("_change",{queue:!0})}},{key:"getItems",value:function(){return null!=this.itemsData?this.itemsData.rawDS:null}},{key:"setGroups",value:function(t){var e,i=this;if(this.groupsData&&(cp(WC).call(WC,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null,this._onRemoveGroups(e)),t){if(!FC(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var n,o=this.groupsData.getDataSet();cp(n=o.get()).call(n,(function(t){var e;t.nestedGroups&&cp(e=t.nestedGroups).call(e,(function(e){var i=o.get(e);i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),o.update(i)}))}));var r=this.id;cp(WC).call(WC,this.groupListeners,(function(t,e){i.groupsData.on(e,t,r)})),e=this.groupsData.getIds(),this._onAddGroups(e)}this._updateUngrouped(),this._order(),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems(),this.markDirty({refreshItems:!0,restackGroups:!0})),this.body.emitter.emit("_change",{queue:!0})}},{key:"getGroups",value:function(){return this.groupsData}},{key:"removeItem",value:function(t){var e=this,i=this.itemsData.get(t);i&&this.options.onRemove(i,(function(i){i&&e.itemsData.remove(t)}))}},{key:"_getType",value:function(t){return t.type||this.options.type||(t.end?"range":"box")}},{key:"getGroupId",value:function(t){return"background"==this._getType(t)&&null==t.group?aA:this.groupsData?t.group:sA}},{key:"_onUpdate",value:function(t){var e=this,n=this;cp(t).call(t,(function(t){var o,r=n.itemsData.get(t),s=n.items[t],a=r?n._getType(r):null,l=i.types[a];if(s&&(l&&s instanceof l?n._updateItem(s,r):(o=s.selected,n._removeItem(s),s=null)),!s&&r){if(!l)throw new TypeError('Unknown item type "'.concat(a,'"'));(s=new l(r,n.conversion,n.options)).id=t,n._addItem(s),o&&(e.selection.push(t),s.select())}})),this._order(),this.options.cluster&&(this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this._clusterItems()),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemove",value:function(t){var e=0,i=this;cp(t).call(t,(function(t){var n=i.items[t];n&&(e++,i._removeItem(n))})),e&&(this._order(),this.body.emitter.emit("_change",{queue:!0}))}},{key:"_order",value:function(){cp(WC).call(WC,this.groups,(function(t){t.order()}))}},{key:"_onUpdateGroups",value:function(t){this._onAddGroups(t)}},{key:"_onAddGroups",value:function(t){var e=this;cp(t).call(t,(function(t){var i=e.groupsData.get(t),n=e.groups[t];if(n)n.setData(i);else{if(t==sA||t==aA)throw new Error("Illegal group id. ".concat(t," is a reserved id."));var o=Vb(e.options);for(var r in WC.extend(o,{height:null}),n=new CE(t,i,e),e.groups[t]=n,e.items)if(e.items.hasOwnProperty(r)){var s=e.items[r];s.data.group==t&&n.add(s)}n.order(),n.show()}})),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemoveGroups",value:function(t){var e=this;cp(t).call(t,(function(t){var i=e.groups[t];i&&(i.dispose(),delete e.groups[t])})),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems()),this.markDirty({restackGroups:!!this.options.cluster}),this.body.emitter.emit("_change",{queue:!0})}},{key:"_orderGroups",value:function(){if(this.groupsData){var t=this.groupsData.getIds({order:this.options.groupOrder});t=this._orderNestedGroups(t);var e=!WC.equalArray(t,this.groupIds);if(e){var i=this.groups;cp(t).call(t,(function(t){i[t].hide()})),cp(t).call(t,(function(t){i[t].show()})),this.groupIds=t}return e}return!1}},{key:"_orderNestedGroups",value:function(t){var e=this;return function t(e,i){var n=[];return cp(i).call(i,(function(i){if(n.push(i),e.groupsData.get(i).nestedGroups){var o,r=km(o=e.groupsData.get({filter:function(t){return t.nestedInGroup==i},order:e.options.groupOrder})).call(o,(function(t){return t.id}));n=zv(n).call(n,t(e,r))}})),n}(this,Dp(t).call(t,(function(t){return!e.groupsData.get(t).nestedInGroup})))}},{key:"_addItem",value:function(t){this.items[t.id]=t;var e=this.getGroupId(t.data),i=this.groups[e];i?i&&i.data&&i.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1,i&&i.add(t)}},{key:"_updateItem",value:function(t,e){t.setData(e);var i=this.getGroupId(t.data),n=this.groups[i];n?n&&n.data&&n.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1}},{key:"_removeItem",value:function(t){var e,i;t.hide(),delete this.items[t.id];var n=Ab(e=this.selection).call(e,t.id);-1!=n&&Gg(i=this.selection).call(i,n,1),t.parent&&t.parent.remove(t),null!=this.popup&&this.popup.hide()}},{key:"_constructByEndArray",value:function(t){for(var e=[],i=0;i<t.length;i++)t[i]instanceof FE&&e.push(t[i]);return e}},{key:"_onTouch",value:function(t){this.touchParams.item=this.itemFromTarget(t),this.touchParams.dragLeftItem=t.target.dragLeftItem||!1,this.touchParams.dragRightItem=t.target.dragRightItem||!1,this.touchParams.itemProps=null}},{key:"_getGroupIndex",value:function(t){for(var e=0;e<this.groupIds.length;e++)if(t==this.groupIds[e])return e}},{key:"_onDragStart",value:function(t){var e=this;if(!this.touchParams.itemIsDragging){var i,n=this.touchParams.item||null,o=this;if(n&&(n.selected||this.options.itemsAlwaysDraggable.item)){if(this.options.editable.overrideItems&&!this.options.editable.updateTime&&!this.options.editable.updateGroup)return;if(null!=n.editable&&!n.editable.updateTime&&!n.editable.updateGroup&&!this.options.editable.overrideItems)return;var r=this.touchParams.dragLeftItem,s=this.touchParams.dragRightItem;if(this.touchParams.itemIsDragging=!0,this.touchParams.selectedItem=n,r)i={item:r,initialX:t.center.x,dragLeft:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(s)i={item:s,initialX:t.center.x,dragRight:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey))this._onDragStartAddItem(t);else{this.groupIds.length<1&&this.redraw();var a=this._getGroupIndex(n.data.group),l=this.options.itemsAlwaysDraggable.item&&!n.selected?[n.id]:this.getSelection();this.touchParams.itemProps=km(l).call(l,(function(i){var n=o.items[i],r=o._getGroupIndex(n.data.group);return{item:n,initialX:t.center.x,groupOffset:a-r,data:e._cloneItemData(n.data)}}))}t.stopPropagation()}else this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey)&&this._onDragStartAddItem(t)}}},{key:"_onDragStartAddItem",value:function(t){var e=this.options.snap||null,i=this.dom.frame.getBoundingClientRect(),n=this.options.rtl?i.right-t.center.x+10:t.center.x-i.left-10,o=this.body.util.toTime(n),r=this.body.util.getScale(),s=this.body.util.getStep(),a=e?e(o,r,s):o,l={type:"range",start:a,end:a,content:"new item"},h=PC();l[this.itemsData.idProp]=h;var u=this.groupFromTarget(t);u&&(l.group=u.groupId);var c=new FE(l,this.conversion,this.options);c.id=h,c.data=this._cloneItemData(l),this._addItem(c),this.touchParams.selectedItem=c;var d={item:c,initialX:t.center.x,data:c.data};this.options.rtl?d.dragLeft=!0:d.dragRight=!0,this.touchParams.itemProps=[d],t.stopPropagation()}},{key:"_onDrag",value:function(t){var e=this;if(null!=this.popup&&this.options.showTooltips&&!this.popup.hidden){var i=this.body.dom.centerContainer,n=i.getBoundingClientRect();this.popup.setPosition(t.center.x-n.left+i.offsetLeft,t.center.y-n.top+i.offsetTop),this.popup.show()}if(this.touchParams.itemProps){var o;t.stopPropagation();var r=this,s=this.options.snap||null,a=this.body.dom.root.offsetLeft,l=this.options.rtl?a+this.body.domProps.right.width:a+this.body.domProps.left.width,h=this.body.util.getScale(),u=this.body.util.getStep(),c=this.touchParams.selectedItem,d=(this.options.editable.overrideItems||null==c.editable)&&this.options.editable.updateGroup||!this.options.editable.overrideItems&&null!=c.editable&&c.editable.updateGroup,p=null;if(d&&c&&null!=c.data.group){var m=r.groupFromTarget(t);m&&(p=this._getGroupIndex(m.groupId))}cp(o=this.touchParams.itemProps).call(o,(function(i){var n,o,a,m,f,v=r.body.util.toTime(t.center.x-l),g=r.body.util.toTime(i.initialX-l);n=e.options.rtl?-(v-g):v-g;var y=e._cloneItemData(i.item.data);if(null==i.item.editable||i.item.editable.updateTime||i.item.editable.updateGroup||r.options.editable.overrideItems){if((e.options.editable.overrideItems||null==c.editable)&&e.options.editable.updateTime||!e.options.editable.overrideItems&&null!=c.editable&&c.editable.updateTime)if(i.dragLeft)e.options.rtl?null!=y.end&&(a=WC.convert(i.data.end,"Date"),f=new Date(a.valueOf()+n),y.end=s?s(f,h,u):f):null!=y.start&&(o=WC.convert(i.data.start,"Date"),m=new Date(o.valueOf()+n),y.start=s?s(m,h,u):m);else if(i.dragRight)e.options.rtl?null!=y.start&&(o=WC.convert(i.data.start,"Date"),m=new Date(o.valueOf()+n),y.start=s?s(m,h,u):m):null!=y.end&&(a=WC.convert(i.data.end,"Date"),f=new Date(a.valueOf()+n),y.end=s?s(f,h,u):f);else if(null!=y.start)if(o=WC.convert(i.data.start,"Date").valueOf(),m=new Date(o+n),null!=y.end){var b=(a=WC.convert(i.data.end,"Date")).valueOf()-o.valueOf();y.start=s?s(m,h,u):m,y.end=new Date(y.start.valueOf()+b)}else y.start=s?s(m,h,u):m;if(d&&!i.dragLeft&&!i.dragRight&&null!=p&&null!=y.group){var w=p-i.groupOffset;w=Math.max(0,w),w=Math.min(r.groupIds.length-1,w),y.group=r.groupIds[w]}y=e._cloneItemData(y),r.options.onMoving(y,(function(t){t&&i.item.setData(e._cloneItemData(t,"Date"))}))}})),this.body.emitter.emit("_change")}}},{key:"_moveToGroup",value:function(t,e){var i=this.groups[e];if(i&&i.groupId!=t.data.group){var n=t.parent;n.remove(t),n.order(),t.data.group=i.groupId,i.add(t),i.order()}}},{key:"_onDragEnd",value:function(t){var e=this;if(this.touchParams.itemIsDragging=!1,this.touchParams.itemProps){t.stopPropagation();var i=this,n=this.touchParams.itemProps;this.touchParams.itemProps=null,cp(n).call(n,(function(t){var n=t.item.id;if(null!=i.itemsData.get(n)){var o=e._cloneItemData(t.item.data);i.options.onMove(o,(function(o){o?(o[e.itemsData.idProp]=n,e.itemsData.update(o)):(t.item.setData(t.data),i.body.emitter.emit("_change"))}))}else i.options.onAdd(t.item.data,(function(e){i._removeItem(t.item),e&&i.itemsData.add(e),i.body.emitter.emit("_change")}))}))}}},{key:"_onGroupClick",value:function(t){var e=this,i=this.groupFromTarget(t);$d((function(){e.toggleGroupShowNested(i)}),1)}},{key:"toggleGroupShowNested",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(t&&t.nestedGroups){var i=this.groupsData.getDataSet();t.showNested=null!=e?!!e:!t.showNested;var n=i.get(t.groupId);n.showNested=t.showNested;for(var o,r=t.nestedGroups,s=r;s.length>0;){var a=s;s=[];for(var l=0;l<a.length;l++){var h=i.get(a[l]);h.nestedGroups&&(s=zv(s).call(s,h.nestedGroups))}s.length>0&&(r=zv(r).call(r,s))}if(n.showNested){for(var u=i.get(n.nestedGroups),c=0;c<u.length;c++){var d=u[c];d.nestedGroups&&d.nestedGroups.length>0&&(null==d.showNested||1==d.showNested)&&u.push.apply(u,Ev(i.get(d.nestedGroups)))}o=km(u).call(u,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}else{var p;o=km(p=i.get(r)).call(p,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}i.update(zv(o).call(o,n)),n.showNested?(WC.removeClassName(t.dom.label,"collapsed"),WC.addClassName(t.dom.label,"expanded")):(WC.removeClassName(t.dom.label,"expanded"),WC.addClassName(t.dom.label,"collapsed"))}}},{key:"toggleGroupDragClassName",value:function(t){t.dom.label.classList.toggle("vis-group-is-dragging"),t.dom.foreground.classList.toggle("vis-group-is-dragging")}},{key:"_onGroupDragStart",value:function(t){this.groupTouchParams.isDragging||this.options.groupEditable.order&&(this.groupTouchParams.group=this.groupFromTarget(t),this.groupTouchParams.group&&(t.stopPropagation(),this.groupTouchParams.isDragging=!0,this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.originalOrder=this.groupsData.getIds({order:this.options.groupOrder})))}},{key:"_onGroupDrag",value:function(t){if(this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this.groupsData.getDataSet(),i=this.groupFromTarget(t);if(i&&i.height!=this.groupTouchParams.group.height){var n=i.top<this.groupTouchParams.group.top,o=t.center?t.center.y:t.clientY,r=i.dom.foreground.getBoundingClientRect(),s=this.groupTouchParams.group.height;if(n){if(r.top+s<o)return}else{var a=i.height;if(r.top+a-s>o)return}}if(i&&i!=this.groupTouchParams.group){var l=e.get(i.groupId),h=e.get(this.groupTouchParams.group.groupId);h&&l&&(this.options.groupOrderSwap(h,l,e),e.update(h),e.update(l));var u=e.getIds({order:this.options.groupOrder});if(!WC.equalArray(u,this.groupTouchParams.originalOrder))for(var c=this.groupTouchParams.originalOrder,d=this.groupTouchParams.group.groupId,p=Math.min(c.length,u.length),m=0,f=0,v=0;m<p;){for(;m+f<p&&m+v<p&&u[m+f]==c[m+v];)m++;if(m+f>=p)break;if(u[m+f]==d)f=1;else if(c[m+v]==d)v=1;else{var g=Ab(u).call(u,c[m+v]),y=e.get(u[m+f]),b=e.get(c[m+v]);this.options.groupOrderSwap(y,b,e),e.update(y),e.update(b);var w=u[m+f];u[m+f]=c[m+v],u[g]=w,m++}}}}}},{key:"_onGroupDragEnd",value:function(t){if(this.groupTouchParams.isDragging=!1,this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this,i=e.groupTouchParams.group.groupId,n=e.groupsData.getDataSet(),o=WC.extend({},n.get(i));e.options.onMoveGroup(o,(function(t){if(t)t[n._idProp]=i,n.update(t);else{var o=n.getIds({order:e.options.groupOrder});if(!WC.equalArray(o,e.groupTouchParams.originalOrder))for(var r=e.groupTouchParams.originalOrder,s=Math.min(r.length,o.length),a=0;a<s;){for(;a<s&&o[a]==r[a];)a++;if(a>=s)break;var l=Ab(o).call(o,r[a]),h=n.get(o[a]),u=n.get(r[a]);e.options.groupOrderSwap(h,u,n),n.update(h),n.update(u);var c=o[a];o[a]=r[a],o[l]=c,a++}}})),e.body.emitter.emit("groupDragged",{groupId:i}),this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.group=null}}},{key:"_onSelectItem",value:function(t){if(this.options.selectable){var e=t.srcEvent&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey),i=t.srcEvent&&t.srcEvent.shiftKey;if(e||i)this._onMultiSelectItem(t);else{var n=this.getSelection(),o=this.itemFromTarget(t),r=o&&o.selectable?[o.id]:[];this.setSelection(r);var s=this.getSelection();(s.length>0||n.length>0)&&this.body.emitter.emit("select",{items:s,event:t})}}}},{key:"_onMouseOver",value:function(t){var e=this.itemFromTarget(t);if(e&&e!==this.itemFromRelatedTarget(t)){var i=e.getTitle();if(this.options.showTooltips&&i){null==this.popup&&(this.popup=new jE(this.body.dom.root,this.options.tooltip.overflowMethod||"flip")),this.popup.setText(i);var n=this.body.dom.centerContainer,o=n.getBoundingClientRect();this.popup.setPosition(t.clientX-o.left+n.offsetLeft,t.clientY-o.top+n.offsetTop),this.setPopupTimer(this.popup)}else this.clearPopupTimer(),null!=this.popup&&this.popup.hide();this.body.emitter.emit("itemover",{item:e.id,event:t})}}},{key:"_onMouseOut",value:function(t){var e=this.itemFromTarget(t);e&&(e!==this.itemFromRelatedTarget(t)&&(this.clearPopupTimer(),null!=this.popup&&this.popup.hide(),this.body.emitter.emit("itemout",{item:e.id,event:t})))}},{key:"_onMouseMove",value:function(t){if(this.itemFromTarget(t)&&(null!=this.popupTimer&&this.setPopupTimer(this.popup),this.options.showTooltips&&this.options.tooltip.followMouse&&this.popup&&!this.popup.hidden)){var e=this.body.dom.centerContainer,i=e.getBoundingClientRect();this.popup.setPosition(t.clientX-i.left+e.offsetLeft,t.clientY-i.top+e.offsetTop),this.popup.show()}}},{key:"_onMouseWheel",value:function(t){this.touchParams.itemIsDragging&&this._onDragEnd(t)}},{key:"_onUpdateItem",value:function(t){if(this.options.selectable&&(this.options.editable.updateTime||this.options.editable.updateGroup)){var e=this;if(t){var i=e.itemsData.get(t.id);this.options.onUpdate(i,(function(t){t&&e.itemsData.update(t)}))}}}},{key:"_onDropObjectOnItem",value:function(t){var e=this.itemFromTarget(t),i=JSON.parse(t.dataTransfer.getData("text"));this.options.onDropObjectOnItem(i,e)}},{key:"_onAddItem",value:function(t){if(this.options.selectable&&this.options.editable.add){var e,i,n=this,o=this.options.snap||null,r=this.dom.frame.getBoundingClientRect(),s=this.options.rtl?r.right-t.center.x:t.center.x-r.left,a=this.body.util.toTime(s),l=this.body.util.getScale(),h=this.body.util.getStep();"drop"==t.type?((i=JSON.parse(t.dataTransfer.getData("text"))).content=i.content?i.content:"new item",i.start=i.start?i.start:o?o(a,l,h):a,i.type=i.type||"box",i[this.itemsData.idProp]=i.id||PC(),"range"!=i.type||i.end||(e=this.body.util.toTime(s+this.props.width/5),i.end=o?o(e,l,h):e)):((i={start:o?o(a,l,h):a,content:"new item"})[this.itemsData.idProp]=PC(),"range"===this.options.type&&(e=this.body.util.toTime(s+this.props.width/5),i.end=o?o(e,l,h):e));var u=this.groupFromTarget(t);u&&(i.group=u.groupId),i=this._cloneItemData(i),this.options.onAdd(i,(function(e){e&&(n.itemsData.add(e),"drop"==t.type&&n.setSelection([e.id]))}))}}},{key:"_onMultiSelectItem",value:function(t){var e=this;if(this.options.selectable){var n=this.itemFromTarget(t);if(n){var o=this.options.multiselect?this.getSelection():[];if((t.srcEvent&&t.srcEvent.shiftKey||!1||this.options.sequentialSelection)&&this.options.multiselect){var r=this.itemsData.get(n.id).group,s=void 0;this.options.multiselectPerGroup&&o.length>0&&(s=this.itemsData.get(o[0]).group),this.options.multiselectPerGroup&&null!=s&&s!=r||o.push(n.id);var a=i._getItemRange(this.itemsData.get(o));if(!this.options.multiselectPerGroup||s==r)for(var l in o=[],this.items)if(this.items.hasOwnProperty(l)){var h=this.items[l],u=h.data.start,c=void 0!==h.data.end?h.data.end:u;!(u>=a.min&&c<=a.max)||this.options.multiselectPerGroup&&s!=this.itemsData.get(h.id).group||h instanceof LE||o.push(h.id)}}else{var d=Ab(o).call(o,n.id);-1==d?o.push(n.id):Gg(o).call(o,d,1)}var p=Dp(o).call(o,(function(t){return e.getItemById(t).selectable}));this.setSelection(p),this.body.emitter.emit("select",{items:this.getSelection(),event:t})}}}},{key:"itemFromElement",value:function(t){for(var e=t;e;){if(e.hasOwnProperty("vis-item"))return e["vis-item"];e=e.parentNode}return null}},{key:"itemFromTarget",value:function(t){return this.itemFromElement(t.target)}},{key:"itemFromRelatedTarget",value:function(t){return this.itemFromElement(t.relatedTarget)}},{key:"groupFromTarget",value:function(t){var e=t.center?t.center.y:t.clientY,i=this.groupIds;i.length<=0&&this.groupsData&&(i=this.groupsData.getIds({order:this.options.groupOrder}));for(var n=0;n<i.length;n++){var o=i[n],r=this.groups[o],s=r.dom.foreground,a=s.getBoundingClientRect();if(e>=a.top&&e<a.top+s.offsetHeight)return r;if("top"===this.options.orientation.item){if(n===this.groupIds.length-1&&e>a.top)return r}else if(0===n&&e<a.top+s.offset)return r}return null}},{key:"_cloneItemData",value:function(t,e){var i=WC.extend({},t);return e||(e=this.itemsData.type),null!=i.start&&(i.start=WC.convert(i.start,e&&e.start||"Date")),null!=i.end&&(i.end=WC.convert(i.end,e&&e.end||"Date")),i}},{key:"_clusterItems",value:function(){if(this.options.cluster){var t=this.body.range.conversion(this.body.domProps.center.width).scale,e=this.clusterGenerator.getClusters(this.clusters,t,this.options.cluster);if(this.clusters!=e){if(this._detachAllClusters(),e){var i,n=nA(e);try{for(n.s();!(i=n.n()).done;){i.value.attach()}}catch(t){n.e(t)}finally{n.f()}this.clusters=e}this._updateClusters(e)}}}},{key:"_detachAllClusters",value:function(){if(this.options.cluster&&this.clusters&&this.clusters.length){var t,e=nA(this.clusters);try{for(e.s();!(t=e.n()).done;){t.value.detach()}}catch(t){e.e(t)}finally{e.f()}}}},{key:"_updateClusters",value:function(t){if(this.clusters&&this.clusters.length){var e,i,n=new $O(km(t).call(t,(function(t){return t.id}))),o=Dp(e=this.clusters).call(e,(function(t){return!n.has(t.id)})),r=!1,s=nA(o);try{for(s.s();!(i=s.n()).done;){var a,l,h=i.value,u=Ab(a=this.selection).call(a,h.id);if(-1!==u)h.unselect(),Gg(l=this.selection).call(l,u,1),r=!0}}catch(t){s.e(t)}finally{s.f()}if(r){var c=this.getSelection();this.body.emitter.emit("select",{items:c,event:event})}}this.clusters=t||[]}}],[{key:"_getItemRange",value:function(t){var e=null,i=null;return cp(t).call(t,(function(t){(null==i||t.start<i)&&(i=t.start),null!=t.end?(null==e||t.end>e)&&(e=t.end):(null==e||t.start>e)&&(e=t.start)})),{min:i,max:e}}},{key:"itemSetFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("vis-itemset"))return e["vis-itemset"];e=e.parentNode}return null}}]),i}();lA.types={background:LE,box:IE,range:FE,point:ME},lA.prototype._onAdd=lA.prototype._onUpdate;var hA,uA=!1,cA="background: #FFeeee; color: #dd0000",dA=function(){function t(){Go(this,t)}return Pc(t,null,[{key:"validate",value:function(e,i,n){uA=!1,hA=i;var o=i;return void 0!==n&&(o=i[n]),t.parse(e,o,[]),uA}},{key:"parse",value:function(e,i,n){for(var o in e)e.hasOwnProperty(o)&&t.check(o,e,i,n)}},{key:"check",value:function(e,i,n,o){if(void 0!==n[e]||void 0!==n.__any__){var r=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(r="__any__",s="object"===t.getType(i[e]));var a=n[r];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,r,a,o)}else t.getSuggestion(e,n,o)}},{key:"checkFields",value:function(e,i,n,o,r,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),cA)},l=t.getType(i[e]),h=r[l];void 0!==h?"array"===t.getType(h)&&-1===Ab(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),uA=!0):"object"===l&&"__any__"!==o&&(s=WC.copyAndExtendArray(s,e),t.parse(i[e],n[o],s)):void 0===r.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(Vm(r))+". Received ["+l+'] "'+i[e]+'"'),uA=!0)}},{key:"getType",value:function(t){var e=_c(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Dd(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var o,r=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,hA,[],!0);o=void 0!==r.indexMatch?" in "+t.printLocation(r.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+r.indexMatch+'"?\n\n':s.distance<=4&&r.distance>s.distance?" in "+t.printLocation(r.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):r.distance<=8?'. Did you mean "'+r.closestMatch+'"?'+t.printLocation(r.path,e):". Did you mean one of these: "+t.print(Vm(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+o,cA),uA=!0}},{key:"findInOptions",value:function(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var c=void 0;if(void 0!==i[u].__type__&&!0===o){var d=t.findInOptions(e,i[u],WC.copyAndExtendArray(n,u));r>d.distance&&(s=d.closestMatch,a=d.path,r=d.distance,h=d.indexMatch)}else{var p;-1!==Ab(p=u.toLowerCase()).call(p,l)&&(h=u),r>(c=t.levenshteinDistance(e,u))&&(s=u,a=WC.copyArray(n),r=c)}}return{closestMatch:s,path:a,distance:r,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)i+="  ";i+=t[n]+": {\n"}for(var r=0;r<t.length+1;r++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Zb(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,o=[];for(i=0;i<=e.length;i++)o[i]=[i];for(n=0;n<=t.length;n++)o[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?o[i][n]=o[i-1][n-1]:o[i][n]=Math.min(o[i-1][n-1]+1,Math.min(o[i][n-1]+1,o[i-1][n]+1));return o[e.length][t.length]}}]),t}(),pA="string",mA="boolean",fA="number",vA="array",gA="date",yA="object",bA="moment",wA={configure:{enabled:{boolean:mA},filter:{boolean:mA,function:"function"},container:{dom:"dom"},__type__:{object:yA,boolean:mA,function:"function"}},align:{string:pA},alignCurrentTime:{string:pA,undefined:"undefined"},rtl:{boolean:mA,undefined:"undefined"},rollingMode:{follow:{boolean:mA},offset:{number:fA,undefined:"undefined"},__type__:{object:yA}},onTimeout:{timeoutMs:{number:fA},callback:{function:"function"},__type__:{object:yA}},verticalScroll:{boolean:mA,undefined:"undefined"},horizontalScroll:{boolean:mA,undefined:"undefined"},autoResize:{boolean:mA},throttleRedraw:{number:fA},clickToUse:{boolean:mA},dataAttributes:{string:pA,array:vA},editable:{add:{boolean:mA,undefined:"undefined"},remove:{boolean:mA,undefined:"undefined"},updateGroup:{boolean:mA,undefined:"undefined"},updateTime:{boolean:mA,undefined:"undefined"},overrideItems:{boolean:mA,undefined:"undefined"},__type__:{boolean:mA,object:yA}},end:{number:fA,date:gA,string:pA,moment:bA},format:{minorLabels:{millisecond:{string:pA,undefined:"undefined"},second:{string:pA,undefined:"undefined"},minute:{string:pA,undefined:"undefined"},hour:{string:pA,undefined:"undefined"},weekday:{string:pA,undefined:"undefined"},day:{string:pA,undefined:"undefined"},week:{string:pA,undefined:"undefined"},month:{string:pA,undefined:"undefined"},year:{string:pA,undefined:"undefined"},__type__:{object:yA,function:"function"}},majorLabels:{millisecond:{string:pA,undefined:"undefined"},second:{string:pA,undefined:"undefined"},minute:{string:pA,undefined:"undefined"},hour:{string:pA,undefined:"undefined"},weekday:{string:pA,undefined:"undefined"},day:{string:pA,undefined:"undefined"},week:{string:pA,undefined:"undefined"},month:{string:pA,undefined:"undefined"},year:{string:pA,undefined:"undefined"},__type__:{object:yA,function:"function"}},__type__:{object:yA}},moment:{function:"function"},groupHeightMode:{string:pA},groupOrder:{string:pA,function:"function"},groupEditable:{add:{boolean:mA,undefined:"undefined"},remove:{boolean:mA,undefined:"undefined"},order:{boolean:mA,undefined:"undefined"},__type__:{boolean:mA,object:yA}},groupOrderSwap:{function:"function"},height:{string:pA,number:fA},hiddenDates:{start:{date:gA,number:fA,string:pA,moment:bA},end:{date:gA,number:fA,string:pA,moment:bA},repeat:{string:pA},__type__:{object:yA,array:vA}},itemsAlwaysDraggable:{item:{boolean:mA,undefined:"undefined"},range:{boolean:mA,undefined:"undefined"},__type__:{boolean:mA,object:yA}},limitSize:{boolean:mA},locale:{string:pA},locales:{__any__:{any:"any"},__type__:{object:yA}},longSelectPressTime:{number:fA},margin:{axis:{number:fA},item:{horizontal:{number:fA,undefined:"undefined"},vertical:{number:fA,undefined:"undefined"},__type__:{object:yA,number:fA}},__type__:{object:yA,number:fA}},max:{date:gA,number:fA,string:pA,moment:bA},maxHeight:{number:fA,string:pA},maxMinorChars:{number:fA},min:{date:gA,number:fA,string:pA,moment:bA},minHeight:{number:fA,string:pA},moveable:{boolean:mA},multiselect:{boolean:mA},multiselectPerGroup:{boolean:mA},onAdd:{function:"function"},onDropObjectOnItem:{function:"function"},onUpdate:{function:"function"},onMove:{function:"function"},onMoving:{function:"function"},onRemove:{function:"function"},onAddGroup:{function:"function"},onMoveGroup:{function:"function"},onRemoveGroup:{function:"function"},onInitialDrawComplete:{function:"function"},order:{function:"function"},orientation:{axis:{string:pA,undefined:"undefined"},item:{string:pA,undefined:"undefined"},__type__:{string:pA,object:yA}},selectable:{boolean:mA},sequentialSelection:{boolean:mA},showCurrentTime:{boolean:mA},showMajorLabels:{boolean:mA},showMinorLabels:{boolean:mA},showWeekScale:{boolean:mA},stack:{boolean:mA},stackSubgroups:{boolean:mA},cluster:{maxItems:{number:fA,undefined:"undefined"},titleTemplate:{string:pA,undefined:"undefined"},clusterCriteria:{function:"function",undefined:"undefined"},showStipes:{boolean:mA,undefined:"undefined"},fitOnDoubleClick:{boolean:mA,undefined:"undefined"},__type__:{boolean:mA,object:yA}},snap:{function:"function",null:"null"},start:{date:gA,number:fA,string:pA,moment:bA},template:{function:"function"},loadingScreenTemplate:{function:"function"},groupTemplate:{function:"function"},visibleFrameTemplate:{string:pA,function:"function"},showTooltips:{boolean:mA},tooltip:{followMouse:{boolean:mA},overflowMethod:{string:["cap","flip","none"]},delay:{number:fA},template:{function:"function"},__type__:{object:yA}},tooltipOnItemUpdateTime:{template:{function:"function"},__type__:{boolean:mA,object:yA}},timeAxis:{scale:{string:pA,undefined:"undefined"},step:{number:fA,undefined:"undefined"},__type__:{object:yA}},type:{string:pA},width:{string:pA,number:fA},preferZoom:{boolean:mA},zoomable:{boolean:mA},zoomKey:{string:["ctrlKey","altKey","shiftKey","metaKey",""]},zoomFriction:{number:fA},zoomMax:{number:fA},zoomMin:{number:fA},xss:{disabled:{boolean:mA},filterOptions:{__any__:{any:"any"},__type__:{object:yA}},__type__:{object:yA}},__type__:{object:yA}},kA={global:{align:["center","left","right"],alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],direction:!1,autoResize:!0,clickToUse:!1,editable:{add:!1,remove:!1,updateGroup:!1,updateTime:!1},end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}},groupHeightMode:["auto","fixed","fitItems"],groupsDraggable:!1,height:"",locale:"",longSelectPressTime:251,margin:{axis:[20,0,100,1],item:{horizontal:[10,0,100,1],vertical:[10,0,100,1]}},max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!1,multiselect:!1,multiselectPerGroup:!1,orientation:{axis:["both","bottom","top"],item:["bottom","top"]},preferZoom:!1,selectable:!0,showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,stack:!0,stackSubgroups:!0,cluster:!1,start:"",showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:[500,0,99999,100]},tooltipOnItemUpdateTime:!1,type:["box","point","range","background"],width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","shiftKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],xss:{disabled:!1}}},xA={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},_A=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Go(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Pc(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return xA[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===WC.isString(t)){if(!0===WC.isValidRGB(t)){var o=t.substr(4).substr(0,t.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(!0===WC.isValidRGBA(t)){var r=t.substr(5).substr(0,t.length-6).split(",");i={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===WC.isValidHex(t)){var s=WC.hexToRGB(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Zb(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=WC.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",$d((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=WC.extend({},t)),this.color=t;var e=WC.RGBToHSV(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,o=this.centerCoordinates.x+n*Math.sin(i*e.h),r=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=o-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=r-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=WC.RGBToHSV(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=WC.HSVToRGB(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=WC.RGBToHSV(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),hw(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var o=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var r=document.createElement("DIV");r.style.color="red",r.style.fontWeight="bold",r.style.padding="10px",r.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(r)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=Od(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=Od(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=Od(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=Od(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new LD(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),jD(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,o,r=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,s),this.centerCoordinates={x:.5*r,y:.5*s},this.r=.49*r;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(o=0;o<this.r;o++)e=this.centerCoordinates.x+o*Math.sin(l*n),i=this.centerCoordinates.y+o*Math.cos(l*n),a=WC.HSVToRGB(.002777777777777778*n,o*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,o=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,s=i-r,a=n-o,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),r),u=Math.cos(l)*h+o,c=Math.sin(l)*h+r;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=c-.5*this.colorPickerSelector.clientWidth+"px";var d=l/(2*Math.PI);d=d<0?d+1:d;var p=h/this.r,m=WC.RGBToHSV(this.color.r,this.color.g,this.color.b);m.h=d,m.s=p;var f=WC.HSVToRGB(m.h,m.s,m.v);f.a=this.color.a,this.color=f,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}(),CA=function(){function t(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Go(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},WC.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new _A(o),this.wrapper=void 0}return Pc(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(Dd(t))this.options.filter=t.join();else if("object"===_c(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==Dp(t)&&(this.options.filter=Dp(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===Dp(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=Dp(this.options),e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===Ab(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return cp(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=WC.xss(t),this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?WC.xss("<i><b>"+t+":</b></i>"):WC.xss(t+":"),n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var o=0;void 0!==e&&-1!==Ab(t).call(t,e)&&(o=Ab(t).call(t,e));for(var r=0;r<t.length;r++){var s=document.createElement("option");s.value=t[r],r===o&&(s.selected="selected"),s.innerHTML=t[r],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],o=t[1],r=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=o,a.max=r}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<o?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<o&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>r&&1!==r&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var c=document.createElement("input");c.className="vis-configuration vis-config-rangeinput",c.value=Number(a.value);var d=this;a.onchange=function(){c.value=this.value,d._update(Number(this.value),i)},a.oninput=function(){c.value=this.value};var p=this._makeLabel(i[i.length-1],i),m=this._makeItem(i,p,a,c);""!==l&&this.popupHistory[m]!==h&&(this.popupHistory[m]=h,this._setupPopup(l,m))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=WC.xss(t),n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=$d((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=$d((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===_c(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var o=this;n.onchange=function(){o._update(this.checked,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var o=this;n.onchange=function(){o._update(this.value,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,o=t[1],r=document.createElement("div");"none"!==(e=void 0===e?o:e)?(r.className="vis-configuration vis-config-colorBlock",r.style.backgroundColor=e):r.className="vis-configuration vis-config-colorBlock none",e=void 0===e?o:e,r.onclick=function(){n._showColorPicker(e,r,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,r)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var o="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=o,n._update(o,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=Dp(this.options),r=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],l=WC.copyAndExtendArray(e,s);if("function"==typeof o&&!1===(n=o(s,e))&&!Dd(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){r=!0;var h=this._getValue(l);if(Dd(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){var u=!0;if(-1!==Ab(e).call(e,"physics")&&this.moduleOptions.physics.solver!==s&&(u=!1),!0===u)if(void 0!==a.enabled){var c=WC.copyAndExtendArray(l,"enabled"),d=this._getValue(c);if(!0===d){var p=this._makeLabel(s,l,!0);this._makeItem(l,p),r=this._handleObject(a,l)||r}else this._makeCheckbox(a,d,l)}else{var m=this._makeLabel(s,l,!0);this._makeItem(l,m),r=this._handleObject(a,l)||r}}else console.error("dont know how to handle",a,s,l)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var o=0;o<e.length;o++)"global"!==e[o]&&(void 0===n[e[o]]&&(n[e[o]]={}),o!==e.length-1?n=n[e[o]]:n[e[o]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+Zb(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}();function SA(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var DA=function(t){ud(i,aT);var e=SA(i);function i(t,n,o,r){var s,a,l,h,u,c,d,p;if(Go(this,i),(p=e.call(this)).initTime=new Date,p.itemsDone=!1,!(Mc(p)instanceof i))throw new SyntaxError("Constructor must be called with the new operator");if(!Dd(o)&&!FC(o)&&o instanceof Object){var m=r;r=o,o=m}r&&r.throttleRedraw&&console.warn('Timeline option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var f=Mc(p);if(p.defaultOptions={autoResize:!0,longSelectPressTime:251,orientation:{axis:"bottom",item:"bottom"},moment:dp},p.options=WC.deepExtend({},p.defaultOptions),r&&WC.setupXSSProtection(r.xss),p._create(t),!r||r&&void 0===r.rtl){var v;p.dom.root.style.visibility="hidden";for(var g=p.dom.root;!v&&g;)v=window.getComputedStyle(g,null).direction,g=g.parentElement;p.options.rtl=v&&"rtl"==v.toLowerCase()}else p.options.rtl=r.rtl;r&&(r.rollingMode&&(p.options.rollingMode=r.rollingMode),r.onInitialDrawComplete&&(p.options.onInitialDrawComplete=r.onInitialDrawComplete),r.onTimeout&&(p.options.onTimeout=r.onTimeout),r.loadingScreenTemplate&&(p.options.loadingScreenTemplate=r.loadingScreenTemplate));var y=document.createElement("div");if(p.options.loadingScreenTemplate){var b,w=Od(b=p.options.loadingScreenTemplate).call(b,Mc(p)),k=w(p.dom.loadingScreen);k instanceof Object&&!(k instanceof Element)?w(y):k instanceof Element?(y.innerHTML="",y.appendChild(k)):null!=k&&(y.innerHTML=WC.xss(k))}function x(t,e){f.hasListeners(t)&&f.emit(t,f.getEventProperties(e))}return p.dom.loadingScreen.appendChild(y),p.components=[],p.body={dom:p.dom,domProps:p.props,emitter:{on:Od(s=p.on).call(s,Mc(p)),off:Od(a=p.off).call(a,Mc(p)),emit:Od(l=p.emit).call(l,Mc(p))},hiddenDates:[],util:{getScale:function(){return f.timeAxis.step.scale},getStep:function(){return f.timeAxis.step.step},toScreen:Od(h=f._toScreen).call(h,f),toGlobalScreen:Od(u=f._toGlobalScreen).call(u,f),toTime:Od(c=f._toTime).call(c,f),toGlobalTime:Od(d=f._toGlobalTime).call(d,f)}},p.range=new wD(p.body,p.options),p.components.push(p.range),p.body.range=p.range,p.timeAxis=new HD(p.body,p.options),p.timeAxis2=null,p.components.push(p.timeAxis),p.currentTime=new hT(p.body,p.options),p.components.push(p.currentTime),p.itemSet=new lA(p.body,p.options),p.components.push(p.itemSet),p.itemsData=null,p.groupsData=null,p.dom.root.onclick=function(t){x("click",t)},p.dom.root.ondblclick=function(t){x("doubleClick",t)},p.dom.root.oncontextmenu=function(t){x("contextmenu",t)},p.dom.root.onmouseover=function(t){x("mouseOver",t)},window.PointerEvent?(p.dom.root.onpointerdown=function(t){x("mouseDown",t)},p.dom.root.onpointermove=function(t){x("mouseMove",t)},p.dom.root.onpointerup=function(t){x("mouseUp",t)}):(p.dom.root.onmousemove=function(t){x("mouseMove",t)},p.dom.root.onmousedown=function(t){x("mouseDown",t)},p.dom.root.onmouseup=function(t){x("mouseUp",t)}),p.initialFitDone=!1,p.on("changed",(function(){if(null!=f.itemsData){if(!f.initialFitDone&&!f.options.rollingMode)if(f.initialFitDone=!0,null!=f.options.start||null!=f.options.end){if(null==f.options.start||null==f.options.end)var t=f.getItemRange();var e=null!=f.options.start?f.options.start:t.min,i=null!=f.options.end?f.options.end:t.max;f.setWindow(e,i,{animation:!1})}else f.fit({animation:!1});f.initialDrawDone||!f.initialRangeChangeDone&&(f.options.start||f.options.end)&&!f.options.rollingMode||(f.initialDrawDone=!0,f.itemSet.initialDrawDone=!0,f.dom.root.style.visibility="visible",f.dom.loadingScreen.parentNode.removeChild(f.dom.loadingScreen),f.options.onInitialDrawComplete&&$d((function(){return f.options.onInitialDrawComplete()}),0))}})),p.on("destroyTimeline",(function(){f.destroy()})),r&&p.setOptions(r),p.body.emitter.on("fit",(function(t){p._onFit(t),p.redraw()})),o&&p.setGroups(o),n&&p.setItems(n),p._redraw(),p}return Pc(i,[{key:"_createConfigurator",value:function(){return new CA(this,this.dom.container,kA)}},{key:"redraw",value:function(){this.itemSet&&this.itemSet.markDirty({refreshItems:!0}),this._redraw()}},{key:"setOptions",value:function(t){if(!0===dA.validate(t,wA)&&console.log("%cErrors have been found in the supplied options object.",cA),aT.prototype.setOptions.call(this,t),"type"in t&&t.type!==this.options.type){this.options.type=t.type;var e=this.itemsData;if(e){var i=this.getSelection();this.setItems(null),this.setItems(e.rawDS),this.setSelection(i)}}}},{key:"setItems",value:function(t){var e;this.itemsDone=!1,e=t?FC(t)?BC(t):BC(new n(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.itemSet&&this.itemSet.setItems(null!=e?e.rawDS:null)}},{key:"setGroups",value:function(t){var e;t?(Dd(t)&&(t=new n(t)),e=new r(t,{filter:function(t){return!1!==t.visible}})):e=null,null!=this.groupsData&&"function"==typeof this.groupsData.setData&&this.groupsData.setData(null),this.groupsData=e,this.itemSet.setGroups(e)}},{key:"setData",value:function(t){t&&t.groups&&this.setGroups(t.groups),t&&t.items&&this.setItems(t.items)}},{key:"setSelection",value:function(t,e){this.itemSet&&this.itemSet.setSelection(t),e&&e.focus&&this.focus(t,e)}},{key:"getSelection",value:function(){return this.itemSet&&this.itemSet.getSelection()||[]}},{key:"focus",value:function(t,e){if(this.itemsData&&null!=t){var i=Dd(t)?t:[t],n=this.itemsData.get(i),o=null,r=null;if(cp(n).call(n,(function(t){var e=t.start.valueOf(),i="end"in t?t.end.valueOf():t.start.valueOf();(null===o||e<o)&&(o=e),(null===r||i>r)&&(r=i)})),null!==o&&null!==r){var s=this,a=this.itemSet.items[i[0]],l=-1*this._getScrollTop(),h=null,u=function(){var t=EA(s,a);t.shouldScroll&&t.itemTop!=h.itemTop&&(s._setScrollTop(-t.scrollOffset),s._redraw())},c=!e||void 0===e.zoom||e.zoom,d=(o+r)/2,p=c?1.1*(r-o):Math.max(this.range.end-this.range.start,1.1*(r-o)),m=!e||void 0===e.animation||e.animation;m||(h={shouldScroll:!1,scrollOffset:-1,itemTop:-1}),this.range.setRange(d-p/2,d+p/2,{animation:m},(function(){u(),$d(u,100)}),(function(t,e,i){var n=EA(s,a);if(!1!==n&&(h||(h=n),h.itemTop!=n.itemTop||h.shouldScroll)){h.itemTop!=n.itemTop&&n.shouldScroll&&(h=n,l=-1*s._getScrollTop());var o=l,r=h.scrollOffset,u=i?r:o+(r-o)*t;s._setScrollTop(-u),e||s._redraw()}}))}}}},{key:"fit",value:function(t,e){var i,n=!t||void 0===t.animation||t.animation;1===this.itemsData.length&&void 0===this.itemsData.get()[0].end?(i=this.getDataRange(),this.moveTo(i.min.valueOf(),{animation:n},e)):(i=this.getItemRange(),this.range.setRange(i.min,i.max,{animation:n},e))}},{key:"getItemRange",value:function(){var t=this,e=this.getDataRange(),i=null!==e.min?e.min.valueOf():null,n=null!==e.max?e.max.valueOf():null,o=null,r=null;if(null!=i&&null!=n){var s=n-i;s<=0&&(s=10);var a=s/this.props.center.width,l={},h=0;if(cp(WC).call(WC,this.itemSet.items,(function(t,e){if(t.groupShowing){l[e]=t.redraw(!0),h=l[e].length}})),h>0)for(var u=function(t){cp(WC).call(WC,l,(function(e){e[t]()}))},c=0;c<h;c++)u(c);if(cp(WC).call(WC,this.itemSet.items,(function(e){var s,l,h=TA(e),u=OA(e);t.options.rtl?(s=h-(e.getWidthRight()+10)*a,l=u+(e.getWidthLeft()+10)*a):(s=h-(e.getWidthLeft()+10)*a,l=u+(e.getWidthRight()+10)*a),s<i&&(i=s,o=e),l>n&&(n=l,r=e)})),o&&r){var d=o.getWidthLeft()+10,p=r.getWidthRight()+10,m=this.props.center.width-d-p;m>0&&(this.options.rtl?(i=TA(o)-p*s/m,n=OA(r)+d*s/m):(i=TA(o)-d*s/m,n=OA(r)+p*s/m))}}return{min:null!=i?new Date(i):null,max:null!=n?new Date(n):null}}},{key:"getDataRange",value:function(){var t,e=null,i=null;this.itemsData&&cp(t=this.itemsData).call(t,(function(t){var n=WC.convert(t.start,"Date").valueOf(),o=WC.convert(null!=t.end?t.end:t.start,"Date").valueOf();(null===e||n<e)&&(e=n),(null===i||o>i)&&(i=o)}));return{min:null!=e?new Date(e):null,max:null!=i?new Date(i):null}}},{key:"getEventProperties",value:function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=this.dom.centerContainer.getBoundingClientRect(),o=this.options.rtl?n.right-e:e-n.left,r=i-n.top,s=this.itemSet.itemFromTarget(t),a=this.itemSet.groupFromTarget(t),l=sT.customTimeFromTarget(t),h=this.itemSet.options.snap||null,u=this.body.util.getScale(),c=this.body.util.getStep(),d=this._toTime(o),p=h?h(d,u,c):d,m=WC.getTarget(t),f=null;return null!=s?f="item":null!=l?f="custom-time":WC.hasParent(m,this.timeAxis.dom.foreground)||this.timeAxis2&&WC.hasParent(m,this.timeAxis2.dom.foreground)?f="axis":WC.hasParent(m,this.itemSet.dom.labelSet)?f="group-label":WC.hasParent(m,this.currentTime.bar)?f="current-time":WC.hasParent(m,this.dom.center)&&(f="background"),{event:t,item:s?s.id:null,isCluster:!!s&&!!s.isCluster,items:s?s.items||[]:null,group:a?a.groupId:null,customTime:l?l.options.id:null,what:f,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:o,y:r,time:d,snappedTime:p}}},{key:"toggleRollingMode",value:function(){this.range.rolling?this.range.stopRolling():(null==this.options.rollingMode&&this.setOptions(this.options),this.range.startRolling())}},{key:"_redraw",value:function(){aT.prototype._redraw.call(this)}},{key:"_onFit",value:function(t){var e=t.start,i=t.end,n=t.animation;i?this.range.setRange(e,i,{animation:n}):this.moveTo(e.valueOf(),{animation:n})}}]),i}();function TA(t){return WC.convert(t.data.start,"Date").valueOf()}function OA(t){var e=null!=t.data.end?t.data.end:t.data.start;return WC.convert(e,"Date").valueOf()}function EA(t,e){if(!e.parent)return!1;var i=t.options.rtl?t.props.rightContainer.height:t.props.leftContainer.height,n=t.props.center.height,o=e.parent,r=o.top,s=!0,a=t.timeAxis.options.orientation.axis,l=function(){return"bottom"==a?o.height-e.top-e.height:e.top},h=-1*t._getScrollTop(),u=r+l(),c=e.height;return u<h?r+i<=r+l()+c&&(r+=l()-t.itemSet.options.margin.item.vertical):u+c>h+i?r+=l()+c-i+t.itemSet.options.margin.item.vertical:s=!1,{shouldScroll:s,scrollOffset:r=Math.min(r,n-i),itemTop:u}}function AA(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])}function IA(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function PA(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}function MA(t,e,i,n){var o;return e.hasOwnProperty(t)?e[t].redundant.length>0?(o=e[t].redundant[0],e[t].redundant.shift()):(o=document.createElement(t),void 0!==n?i.insertBefore(o,n):i.appendChild(o)):(o=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(o,n):i.appendChild(o)),e[t].used.push(o),o}function NA(t,e,i,n,o,r){var s;if("circle"==i.style?((s=PA("circle",n,o)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=PA("rect",n,o)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),r){var a=PA("text",n,o);r.xOffset&&(t+=r.xOffset),r.yOffset&&(e+=r.yOffset),r.content&&(a.textContent=r.content),r.className&&a.setAttributeNS(null,"class",r.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s}function FA(t,e,i,n,o,r,s,a){if(0!=n){n<0&&(e-=n*=-1);var l=PA("rect",r,s);l.setAttributeNS(null,"x",t-.5*i),l.setAttributeNS(null,"y",e),l.setAttributeNS(null,"width",i),l.setAttributeNS(null,"height",n),l.setAttributeNS(null,"class",o),a&&l.setAttributeNS(null,"style",a)}}var RA=function(){function t(e,i,n,o,r,s){var a=arguments.length>6&&void 0!==arguments[6]&&arguments[6],l=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(Go(this,t),this.majorSteps=[1,2,5,10],this.minorSteps=[.25,.5,1,2],this.customLines=null,this.containerHeight=r,this.majorCharHeight=s,this._start=e,this._end=i,this.scale=1,this.minorStepIdx=-1,this.magnitudefactor=1,this.determineScale(),this.zeroAlign=a,this.autoScaleStart=n,this.autoScaleEnd=o,this.formattingFunction=l,n||o){var h=this,u=function(t){var e=t-t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx]);return t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx])>h.magnitudefactor*h.minorSteps[h.minorStepIdx]*.5?e+h.magnitudefactor*h.minorSteps[h.minorStepIdx]:e};n&&(this._start-=2*this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._start=u(this._start)),o&&(this._end+=this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._end=u(this._end)),this.determineScale()}}return Pc(t,[{key:"setCharHeight",value:function(t){this.majorCharHeight=t}},{key:"setHeight",value:function(t){this.containerHeight=t}},{key:"determineScale",value:function(){var t=this._end-this._start;this.scale=this.containerHeight/t;var e=this.majorCharHeight/this.scale,i=t>0?Math.round(Math.log(t)/Math.LN10):0;this.minorStepIdx=-1,this.magnitudefactor=Math.pow(10,i);var n=0;i<0&&(n=i);for(var o=!1,r=n;Math.abs(r)<=Math.abs(i);r++){this.magnitudefactor=Math.pow(10,r);for(var s=0;s<this.minorSteps.length;s++){if(this.magnitudefactor*this.minorSteps[s]>=e){o=!0,this.minorStepIdx=s;break}}if(!0===o)break}}},{key:"is_major",value:function(t){return t%(this.magnitudefactor*this.majorSteps[this.minorStepIdx])==0}},{key:"getStep",value:function(){return this.magnitudefactor*this.minorSteps[this.minorStepIdx]}},{key:"getFirstMajor",value:function(){var t=this.magnitudefactor*this.majorSteps[this.minorStepIdx];return this.convertValue(this._start+(t-this._start%t)%t)}},{key:"formatValue",value:function(t){var e=t.toPrecision(5);return"function"==typeof this.formattingFunction&&(e=this.formattingFunction(t)),"number"==typeof e?"".concat(e):"string"==typeof e?e:t.toPrecision(5)}},{key:"getLines",value:function(){for(var t=[],e=this.getStep(),i=(e-this._start%e)%e,n=this._start+i;this._end-n>1e-5;n+=e)n!=this._start&&t.push({major:this.is_major(n),y:this.convertValue(n),val:this.formatValue(n)});return t}},{key:"followScale",value:function(t){var e=this.minorStepIdx,i=this._start,n=this._end,o=this,r=function(){o.magnitudefactor*=2},s=function(){o.magnitudefactor/=2};t.minorStepIdx<=1&&this.minorStepIdx<=1||t.minorStepIdx>1&&this.minorStepIdx>1||(t.minorStepIdx<this.minorStepIdx?(this.minorStepIdx=1,2==e||r(),r()):(this.minorStepIdx=2,1==e||s(),s()));for(var a=t.convertValue(0),l=t.getStep()*t.scale,h=!1,u=0;!h&&u++<5;){this.scale=l/(this.minorSteps[this.minorStepIdx]*this.magnitudefactor);var c=this.containerHeight/this.scale;this._start=i,this._end=this._start+c;var d=this._end*this.scale,p=this.magnitudefactor*this.majorSteps[this.minorStepIdx],m=this.getFirstMajor()-t.getFirstMajor();if(this.zeroAlign){var f=a-d;this._end+=f/this.scale,this._start=this._end-c}else this.autoScaleStart?(this._start-=m/this.scale,this._end=this._start+c):(this._start+=p-m/this.scale,this._end=this._start+c);if(!this.autoScaleEnd&&this._end>n+1e-5)s(),h=!1;else{if(!this.autoScaleStart&&this._start<i-1e-5){if(!(this.zeroAlign&&i>=0)){s(),h=!1;continue}console.warn("Can't adhere to given 'min' range, due to zeroalign")}this.autoScaleStart&&this.autoScaleEnd&&c<n-i?(r(),h=!1):h=!0}}}},{key:"convertValue",value:function(t){return this.containerHeight-(t-this._start)*this.scale}},{key:"screenToValue",value:function(t){return(this.containerHeight-t)/this.scale+this._start}}]),t}();function LA(t,e){var i=void 0!==Iv&&Wf(t)||t["@@iterator"];if(!i){if(Dd(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return jA(t,e);var n=Gv(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return jf(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function jA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function BA(t){var e=function(){if("undefined"==typeof Reflect||!Ho)return!1;if(Ho.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Ho(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=xd(t);if(e){var o=xd(this).constructor;i=Ho(n,arguments,o)}else i=n.apply(this,arguments);return cd(this,i)}}var zA=function(t){ud(i,oS);var e=BA(i);function i(t,n,o,r){var s;Go(this,i),(s=e.call(this)).id=PC(),s.body=t,s.defaultOptions={orientation:"left",showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,majorLinesOffset:7,minorLinesOffset:4,labelOffsetX:10,labelOffsetY:2,iconWidth:20,width:"40px",visible:!0,alignZeros:!0,left:{range:{min:void 0,max:void 0},format:function(t){return"".concat(nS(t.toPrecision(3)))},title:{text:void 0,style:void 0}},right:{range:{min:void 0,max:void 0},format:function(t){return"".concat(nS(t.toPrecision(3)))},title:{text:void 0,style:void 0}}},s.linegraphOptions=r,s.linegraphSVG=o,s.props={},s.DOMelements={lines:{},labels:{},title:{}},s.dom={},s.scale=void 0,s.range={start:0,end:0},s.options=WC.extend({},s.defaultOptions),s.conversionFactor=1,s.setOptions(n),s.width=Number("".concat(s.options.width).replace("px","")),s.minWidth=s.width,s.height=s.linegraphSVG.getBoundingClientRect().height,s.hidden=!1,s.stepPixels=25,s.zeroCrossing=-1,s.amountOfSteps=-1,s.lineOffset=0,s.master=!0,s.masterAxis=null,s.svgElements={},s.iconsRemoved=!1,s.groups={},s.amountOfGroups=0,s._create(),null==s.scale&&s._redrawLabels(),s.framework={svg:s.svg,svgElements:s.svgElements,options:s.options,groups:s.groups};var a=Mc(s);return s.body.emitter.on("verticalDrag",(function(){a.dom.lineContainer.style.top="".concat(a.body.domProps.scrollTop,"px")})),s}return Pc(i,[{key:"addGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1}},{key:"updateGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.amountOfGroups+=1),this.groups[t]=e}},{key:"removeGroup",value:function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)}},{key:"setOptions",value:function(t){if(t){var e=!1;this.options.orientation!=t.orientation&&void 0!==t.orientation&&(e=!0);WC.selectiveDeepExtend(["orientation","showMinorLabels","showMajorLabels","icons","majorLinesOffset","minorLinesOffset","labelOffsetX","labelOffsetY","iconWidth","width","visible","left","right","alignZeros"],this.options,t),this.minWidth=Number("".concat(this.options.width).replace("px","")),!0===e&&this.dom.frame&&(this.hide(),this.show())}}},{key:"_create",value:function(){this.dom.frame=document.createElement("div"),this.dom.frame.style.width=this.options.width,this.dom.frame.style.height=this.height,this.dom.lineContainer=document.createElement("div"),this.dom.lineContainer.style.width="100%",this.dom.lineContainer.style.height=this.height,this.dom.lineContainer.style.position="relative",this.dom.lineContainer.style.visibility="visible",this.dom.lineContainer.style.display="block",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.height="100%",this.svg.style.width="100%",this.svg.style.display="block",this.dom.frame.appendChild(this.svg)}},{key:"_redrawGroupIcons",value:function(){var t;AA(this.svgElements);var e=this.options.iconWidth,i=11.5;t="left"===this.options.orientation?4:this.width-e-4;var n=Vm(this.groups);oD(n).call(n,(function(t,e){return t<e?-1:1}));var o,r=LA(n);try{for(r.s();!(o=r.n()).done;){var s=o.value;!0!==this.groups[s].visible||void 0!==this.linegraphOptions.visibility[s]&&!0!==this.linegraphOptions.visibility[s]||(this.groups[s].getLegend(e,15,this.framework,t,i),i+=19)}}catch(t){r.e(t)}finally{r.f()}IA(this.svgElements),this.iconsRemoved=!1}},{key:"_cleanupIcons",value:function(){!1===this.iconsRemoved&&(AA(this.svgElements),IA(this.svgElements),this.iconsRemoved=!0)}},{key:"show",value:function(){this.hidden=!1,this.dom.frame.parentNode||("left"===this.options.orientation?this.body.dom.left.appendChild(this.dom.frame):this.body.dom.right.appendChild(this.dom.frame)),this.dom.lineContainer.parentNode||this.body.dom.backgroundHorizontal.appendChild(this.dom.lineContainer),this.dom.lineContainer.style.display="block"}},{key:"hide",value:function(){this.hidden=!0,this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.lineContainer.style.display="none"}},{key:"setRange",value:function(t,e){this.range.start=t,this.range.end=e}},{key:"redraw",value:function(){var t=!1,e=0;for(var i in this.dom.lineContainer.style.top="".concat(this.body.domProps.scrollTop,"px"),this.groups)this.groups.hasOwnProperty(i)&&(!0!==this.groups[i].visible||void 0!==this.linegraphOptions.visibility[i]&&!0!==this.linegraphOptions.visibility[i]||e++);if(0===this.amountOfGroups||0===e)this.hide();else{this.show(),this.height=Number(this.linegraphSVG.style.height.replace("px","")),this.dom.lineContainer.style.height="".concat(this.height,"px"),this.width=!0===this.options.visible?Number("".concat(this.options.width).replace("px","")):0;var n=this.props,o=this.dom.frame;o.className="vis-data-axis",this._calculateCharSize();var r=this.options.orientation,s=this.options.showMinorLabels,a=this.options.showMajorLabels,l=this.body.dom.backgroundHorizontal.offsetWidth;n.minorLabelHeight=s?n.minorCharHeight:0,n.majorLabelHeight=a?n.majorCharHeight:0,n.minorLineWidth=l-this.lineOffset-this.width+2*this.options.minorLinesOffset,n.minorLineHeight=1,n.majorLineWidth=l-this.lineOffset-this.width+2*this.options.majorLinesOffset,n.majorLineHeight=1,"left"===r?(o.style.top="0",o.style.left="0",o.style.bottom="",o.style.width="".concat(this.width,"px"),o.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.left.width,this.props.height=this.body.domProps.left.height):(o.style.top="",o.style.bottom="0",o.style.left="0",o.style.width="".concat(this.width,"px"),o.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.right.width,this.props.height=this.body.domProps.right.height),t=this._redrawLabels(),t=this._isResized()||t,!0===this.options.icons?this._redrawGroupIcons():this._cleanupIcons(),this._redrawTitle(r)}return t}},{key:"_redrawLabels",value:function(){var t=this,e=!1;AA(this.DOMelements.lines),AA(this.DOMelements.labels);var i=this.options.orientation,n=null!=this.options[i].range?this.options[i].range:{},o=!0;null!=n.max&&(this.range.end=n.max,o=!1);var r=!0;null!=n.min&&(this.range.start=n.min,r=!1),this.scale=new RA(this.range.start,this.range.end,r,o,this.dom.frame.offsetHeight,this.props.majorCharHeight,this.options.alignZeros,this.options[i].format),!1===this.master&&null!=this.masterAxis?(this.scale.followScale(this.masterAxis.scale),this.dom.lineContainer.style.display="none"):this.dom.lineContainer.style.display="block",this.maxLabelSize=0;var s=this.scale.getLines();cp(s).call(s,(function(e){var n=e.y,o=e.major;t.options.showMinorLabels&&!1===o&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-minor",t.props.minorCharHeight),o&&n>=0&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-major",t.props.majorCharHeight),!0===t.master&&(o?t._redrawLine(n,i,"vis-grid vis-horizontal vis-major",t.options.majorLinesOffset,t.props.majorLineWidth):t._redrawLine(n,i,"vis-grid vis-horizontal vis-minor",t.options.minorLinesOffset,t.props.minorLineWidth))}));var a=0;void 0!==this.options[i].title&&void 0!==this.options[i].title.text&&(a=this.props.titleCharHeight);var l=!0===this.options.icons?Math.max(this.options.iconWidth,a)+this.options.labelOffsetX+15:a+this.options.labelOffsetX+15;return this.maxLabelSize>this.width-l&&!0===this.options.visible?(this.width=this.maxLabelSize+l,this.options.width="".concat(this.width,"px"),IA(this.DOMelements.lines),IA(this.DOMelements.labels),this.redraw(),e=!0):this.maxLabelSize<this.width-l&&!0===this.options.visible&&this.width>this.minWidth?(this.width=Math.max(this.minWidth,this.maxLabelSize+l),this.options.width="".concat(this.width,"px"),IA(this.DOMelements.lines),IA(this.DOMelements.labels),this.redraw(),e=!0):(IA(this.DOMelements.lines),IA(this.DOMelements.labels),e=!1),e}},{key:"convertValue",value:function(t){return this.scale.convertValue(t)}},{key:"screenToValue",value:function(t){return this.scale.screenToValue(t)}},{key:"_redrawLabel",value:function(t,e,i,n,o){var r=MA("div",this.DOMelements.labels,this.dom.frame);r.className=n,r.innerHTML=WC.xss(e),"left"===i?(r.style.left="-".concat(this.options.labelOffsetX,"px"),r.style.textAlign="right"):(r.style.right="-".concat(this.options.labelOffsetX,"px"),r.style.textAlign="left"),r.style.top="".concat(t-.5*o+this.options.labelOffsetY,"px"),e+="";var s=Math.max(this.props.majorCharWidth,this.props.minorCharWidth);this.maxLabelSize<e.length*s&&(this.maxLabelSize=e.length*s)}},{key:"_redrawLine",value:function(t,e,i,n,o){if(!0===this.master){var r=MA("div",this.DOMelements.lines,this.dom.lineContainer);r.className=i,r.innerHTML="","left"===e?r.style.left="".concat(this.width-n,"px"):r.style.right="".concat(this.width-n,"px"),r.style.width="".concat(o,"px"),r.style.top="".concat(t,"px")}}},{key:"_redrawTitle",value:function(t){if(AA(this.DOMelements.title),void 0!==this.options[t].title&&void 0!==this.options[t].title.text){var e=MA("div",this.DOMelements.title,this.dom.frame);e.className="vis-y-axis vis-title vis-".concat(t),e.innerHTML=WC.xss(this.options[t].title.text),void 0!==this.options[t].title.style&&WC.addCssText(e,this.options[t].title.style),"left"===t?e.style.left="".concat(this.props.titleCharHeight,"px"):e.style.right="".concat(this.props.titleCharHeight,"px"),e.style.width="".concat(this.height,"px")}IA(this.DOMelements.title)}},{key:"_calculateCharSize",value:function(){if(!("minorCharHeight"in this.props)){var t=document.createTextNode("0"),e=document.createElement("div");e.className="vis-y-axis vis-minor vis-measure",e.appendChild(t),this.dom.frame.appendChild(e),this.props.minorCharHeight=e.clientHeight,this.props.minorCharWidth=e.clientWidth,this.dom.frame.removeChild(e)}if(!("majorCharHeight"in this.props)){var i=document.createTextNode("0"),n=document.createElement("div");n.className="vis-y-axis vis-major vis-measure",n.appendChild(i),this.dom.frame.appendChild(n),this.props.majorCharHeight=n.clientHeight,this.props.majorCharWidth=n.clientWidth,this.dom.frame.removeChild(n)}if(!("titleCharHeight"in this.props)){var o=document.createTextNode("0"),r=document.createElement("div");r.className="vis-y-axis vis-title vis-measure",r.appendChild(o),this.dom.frame.appendChild(r),this.props.titleCharHeight=r.clientHeight,this.props.titleCharWidth=r.clientWidth,this.dom.frame.removeChild(r)}}}]),i}();function HA(t,e){}function GA(t,e){return{style:(e=void 0===e?{}:e).style||t.options.drawPoints.style,styles:e.styles||t.options.drawPoints.styles,size:e.size||t.options.drawPoints.size,className:e.className||t.className}}function WA(t,e){}function YA(t,e){}function VA(t,e,i,n){this.id=e;this.options=WC.selectiveBridgeObject(["sampling","style","sort","yAxisOrientation","barChart","drawPoints","shaded","interpolation","zIndex","excludeFromStacking","excludeFromLegend"],i),this.usingDefaultStyle=void 0===t.className,this.groupsUsingDefaultStyles=n,this.zeroPosition=0,this.update(t),1==this.usingDefaultStyle&&(this.groupsUsingDefaultStyles[0]+=1),this.itemsData=[],this.visible=void 0===t.visible||t.visible}function UA(t,e,i,n){this.body=t,this.defaultOptions={enabled:!1,icons:!0,iconSize:20,iconSpacing:6,left:{visible:!0,position:"top-left"},right:{visible:!0,position:"top-right"}},this.side=i,this.options=WC.extend({},this.defaultOptions),this.linegraphOptions=n,this.svgElements={},this.dom={},this.groups={},this.amountOfGroups=0,this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups},this.setOptions(e)}HA.draw=function(t,e,i,n){n=n||0;for(var o=function(t,e){var i=void 0;t.options&&t.options.drawPoints&&t.options.drawPoints.onRender&&"function"==typeof t.options.drawPoints.onRender&&(i=t.options.drawPoints.onRender);e.group.options&&e.group.options.drawPoints&&e.group.options.drawPoints.onRender&&"function"==typeof e.group.options.drawPoints.onRender&&(i=e.group.options.drawPoints.onRender);return i}(i,e),r=0;r<t.length;r++)if(o){var s=o(t[r],e);!0!==s&&"object"!==_c(s)||NA(t[r].screen_x+n,t[r].screen_y,GA(e,s),i.svgElements,i.svg,t[r].label)}else NA(t[r].screen_x+n,t[r].screen_y,GA(e),i.svgElements,i.svg,t[r].label)},HA.drawIcon=function(t,e,i,n,o,r){var s=.5*o,a=PA("rect",r.svgElements,r.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline"),NA(e+.5*n,i,GA(t),r.svgElements,r.svg)},WA.drawIcon=function(t,e,i,n,o,r){var s=.5*o,a=PA("rect",r.svgElements,r.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline");var l=Math.round(.3*n),h=t.options.barChart.width/l,u=Math.round(.4*o),c=Math.round(.75*o),d=Math.round((n-2*l)/3);if(FA(e+.5*l+d,i+s-u-1,l,u,t.className+" vis-bar",r.svgElements,r.svg,t.style),FA(e+1.5*l+d+2,i+s-c-1,l,c,t.className+" vis-bar",r.svgElements,r.svg,t.style),1==t.options.drawPoints.enabled){var p={style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size/h,className:t.className};NA(e+.5*l+d,i+s-u-1,p,r.svgElements,r.svg),NA(e+1.5*l+d+2,i+s-c-1,p,r.svgElements,r.svg)}},WA.draw=function(t,e,i){var n,o,r,s,a,l,h=[],u={},c=0;for(a=0;a<t.length;a++)if("bar"===(s=i.groups[t[a]]).options.style&&!0===s.visible&&(void 0===i.options.groups.visibility[t[a]]||!0===i.options.groups.visibility[t[a]]))for(l=0;l<e[t[a]].length;l++)h.push({screen_x:e[t[a]][l].screen_x,screen_end:e[t[a]][l].screen_end,screen_y:e[t[a]][l].screen_y,x:e[t[a]][l].x,end:e[t[a]][l].end,y:e[t[a]][l].y,groupId:t[a],label:e[t[a]][l].label}),c+=1;if(0!==c)for(oD(h).call(h,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x})),WA._getDataIntersections(u,h),a=0;a<h.length;a++){var d=null!=(s=i.groups[h[a].groupId]).options.barChart.minWidth?s.options.barChart.minWidth:.1*s.options.barChart.width,p=0;if(void 0===u[o=h[a].screen_x])a+1<h.length&&(n=Math.abs(h[a+1].screen_x-o)),r=WA._getSafeDrawData(n,s,d);else{var m=a+(u[o].amount-u[o].resolved);m<h.length&&(n=Math.abs(h[m].screen_x-o)),r=WA._getSafeDrawData(n,s,d),u[o].resolved+=1,!0===s.options.stack&&!0!==s.options.excludeFromStacking?h[a].screen_y<s.zeroPosition?(p=u[o].accumulatedNegative,u[o].accumulatedNegative+=s.zeroPosition-h[a].screen_y):(p=u[o].accumulatedPositive,u[o].accumulatedPositive+=s.zeroPosition-h[a].screen_y):!0===s.options.barChart.sideBySide&&(r.width=r.width/u[o].amount,r.offset+=u[o].resolved*r.width-.5*r.width*(u[o].amount+1))}var f=r.width,v=h[a].screen_x;if(null!=h[a].screen_end?v+=.5*(f=h[a].screen_end-h[a].screen_x):v+=r.offset,FA(v,h[a].screen_y-p,f,s.zeroPosition-h[a].screen_y,s.className+" vis-bar",i.svgElements,i.svg,s.style),!0===s.options.drawPoints.enabled){var g={screen_x:h[a].screen_x,screen_y:h[a].screen_y-p,x:h[a].x,y:h[a].y,groupId:h[a].groupId,label:h[a].label};HA.draw([g],s,i,r.offset)}}},WA._getDataIntersections=function(t,e){for(var i,n=0;n<e.length;n++)n+1<e.length&&(i=Math.abs(e[n+1].screen_x-e[n].screen_x)),n>0&&(i=Math.min(i,Math.abs(e[n-1].screen_x-e[n].screen_x))),0===i&&(void 0===t[e[n].screen_x]&&(t[e[n].screen_x]={amount:0,resolved:0,accumulatedPositive:0,accumulatedNegative:0}),t[e[n].screen_x].amount+=1)},WA._getSafeDrawData=function(t,e,i){var n,o;return t<e.options.barChart.width&&t>0?(n=t<i?i:t,o=0,"left"===e.options.barChart.align?o-=.5*t:"right"===e.options.barChart.align&&(o+=.5*t)):(n=e.options.barChart.width,o=0,"left"===e.options.barChart.align?o-=.5*e.options.barChart.width:"right"===e.options.barChart.align&&(o+=.5*e.options.barChart.width)),{width:n,offset:o}},WA.getStackedYRange=function(t,e,i,n,o){if(t.length>0){oD(t).call(t,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x}));var r={};WA._getDataIntersections(r,t),e[n]=WA._getStackedYRange(r,t),e[n].yAxisOrientation=o,i.push(n)}},WA._getStackedYRange=function(t,e){for(var i,n=e[0].screen_y,o=e[0].screen_y,r=0;r<e.length;r++)void 0===t[i=e[r].screen_x]?(n=n>e[r].screen_y?e[r].screen_y:n,o=o<e[r].screen_y?e[r].screen_y:o):e[r].screen_y<0?t[i].accumulatedNegative+=e[r].screen_y:t[i].accumulatedPositive+=e[r].screen_y;for(var s in t)t.hasOwnProperty(s)&&(n=(n=n>t[s].accumulatedNegative?t[s].accumulatedNegative:n)>t[s].accumulatedPositive?t[s].accumulatedPositive:n,o=(o=o<t[s].accumulatedNegative?t[s].accumulatedNegative:o)<t[s].accumulatedPositive?t[s].accumulatedPositive:o);return{min:n,max:o}},YA.calcPath=function(t,e){if(null!=t&&t.length>0){return 1==e.options.interpolation.enabled?YA._catmullRom(t,e):YA._linear(t)}},YA.drawIcon=function(t,e,i,n,o,r){var s,a,l=.5*o,h=PA("rect",r.svgElements,r.svg);(h.setAttributeNS(null,"x",e),h.setAttributeNS(null,"y",i-l),h.setAttributeNS(null,"width",n),h.setAttributeNS(null,"height",2*l),h.setAttributeNS(null,"class","vis-outline"),(s=PA("path",r.svgElements,r.svg)).setAttributeNS(null,"class",t.className),void 0!==t.style&&s.setAttributeNS(null,"style",t.style),s.setAttributeNS(null,"d","M"+e+","+i+" L"+(e+n)+","+i),1==t.options.shaded.enabled&&(a=PA("path",r.svgElements,r.svg),"top"==t.options.shaded.orientation?a.setAttributeNS(null,"d","M"+e+", "+(i-l)+"L"+e+","+i+" L"+(e+n)+","+i+" L"+(e+n)+","+(i-l)):a.setAttributeNS(null,"d","M"+e+","+i+" L"+e+","+(i+l)+" L"+(e+n)+","+(i+l)+"L"+(e+n)+","+i),a.setAttributeNS(null,"class",t.className+" vis-icon-fill"),void 0!==t.options.shaded.style&&""!==t.options.shaded.style&&a.setAttributeNS(null,"style",t.options.shaded.style)),1==t.options.drawPoints.enabled)&&NA(e+.5*n,i,{style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size,className:t.className},r.svgElements,r.svg)},YA.drawShading=function(t,e,i,n){if(1==e.options.shaded.enabled){var o,r=Number(n.svg.style.height.replace("px","")),s=PA("path",n.svgElements,n.svg),a="L";1==e.options.interpolation.enabled&&(a="C");var l=0;l="top"==e.options.shaded.orientation?0:"bottom"==e.options.shaded.orientation?r:Math.min(Math.max(0,e.zeroPosition),r),o="group"==e.options.shaded.orientation&&null!=i&&null!=i?"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" L"+i[i.length-1][0]+","+i[i.length-1][1]+" "+this.serializePath(i,a,!0)+i[0][0]+","+i[0][1]+" Z":"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" V"+l+" H"+t[0][0]+" Z",s.setAttributeNS(null,"class",e.className+" vis-fill"),void 0!==e.options.shaded.style&&s.setAttributeNS(null,"style",e.options.shaded.style),s.setAttributeNS(null,"d",o)}},YA.draw=function(t,e,i){if(null!=t&&null!=t){var n=PA("path",i.svgElements,i.svg);n.setAttributeNS(null,"class",e.className),void 0!==e.style&&n.setAttributeNS(null,"style",e.style);var o="L";1==e.options.interpolation.enabled&&(o="C"),n.setAttributeNS(null,"d","M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,o,!1))}},YA.serializePath=function(t,e,i){if(t.length<2)return"";var n,o=e;if(i)for(n=t.length-2;n>0;n--)o+=t[n][0]+","+t[n][1]+" ";else for(n=1;n<t.length;n++)o+=t[n][0]+","+t[n][1]+" ";return o},YA._catmullRomUniform=function(t){var e,i,n,o,r,s,a=[];a.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var l=1/6,h=t.length,u=0;u<h-1;u++)e=0==u?t[0]:t[u-1],i=t[u],n=t[u+1],o=u+2<h?t[u+2]:n,r={screen_x:(-e.screen_x+6*i.screen_x+n.screen_x)*l,screen_y:(-e.screen_y+6*i.screen_y+n.screen_y)*l},s={screen_x:(i.screen_x+6*n.screen_x-o.screen_x)*l,screen_y:(i.screen_y+6*n.screen_y-o.screen_y)*l},a.push([r.screen_x,r.screen_y]),a.push([s.screen_x,s.screen_y]),a.push([n.screen_x,n.screen_y]);return a},YA._catmullRom=function(t,e){var i=e.options.interpolation.alpha;if(0==i||void 0===i)return this._catmullRomUniform(t);var n,o,r,s,a,l,h,u,c,d,p,m,f,v,g,y,b,w,k,x=[];x.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var _=t.length,C=0;C<_-1;C++)n=0==C?t[0]:t[C-1],o=t[C],r=t[C+1],s=C+2<_?t[C+2]:r,h=Math.sqrt(Math.pow(n.screen_x-o.screen_x,2)+Math.pow(n.screen_y-o.screen_y,2)),u=Math.sqrt(Math.pow(o.screen_x-r.screen_x,2)+Math.pow(o.screen_y-r.screen_y,2)),c=Math.sqrt(Math.pow(r.screen_x-s.screen_x,2)+Math.pow(r.screen_y-s.screen_y,2)),v=Math.pow(c,i),y=Math.pow(c,2*i),g=Math.pow(u,i),b=Math.pow(u,2*i),k=Math.pow(h,i),d=2*(w=Math.pow(h,2*i))+3*k*g+b,p=2*y+3*v*g+b,(m=3*k*(k+g))>0&&(m=1/m),(f=3*v*(v+g))>0&&(f=1/f),a={screen_x:(-b*n.screen_x+d*o.screen_x+w*r.screen_x)*m,screen_y:(-b*n.screen_y+d*o.screen_y+w*r.screen_y)*m},l={screen_x:(y*o.screen_x+p*r.screen_x-b*s.screen_x)*f,screen_y:(y*o.screen_y+p*r.screen_y-b*s.screen_y)*f},0==a.screen_x&&0==a.screen_y&&(a=o),0==l.screen_x&&0==l.screen_y&&(l=r),x.push([a.screen_x,a.screen_y]),x.push([l.screen_x,l.screen_y]),x.push([r.screen_x,r.screen_y]);return x},YA._linear=function(t){for(var e=[],i=0;i<t.length;i++)e.push([t[i].screen_x,t[i].screen_y]);return e},VA.prototype.setItems=function(t){null!=t?(this.itemsData=t,1==oD(this.options)&&WC.insertSort(this.itemsData,(function(t,e){return t.x>e.x?1:-1}))):this.itemsData=[]},VA.prototype.getItems=function(){return this.itemsData},VA.prototype.setZeroPosition=function(t){this.zeroPosition=t},VA.prototype.setOptions=function(t){if(void 0!==t){WC.selectiveDeepExtend(["sampling","style","sort","yAxisOrientation","barChart","zIndex","excludeFromStacking","excludeFromLegend"],this.options,t),"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),WC.mergeOptions(this.options,t,"interpolation"),WC.mergeOptions(this.options,t,"drawPoints"),WC.mergeOptions(this.options,t,"shaded"),t.interpolation&&"object"==_c(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5))}},VA.prototype.update=function(t){this.group=t,this.content=t.content||"graph",this.className=t.className||this.className||"vis-graph-group"+this.groupsUsingDefaultStyles[0]%10,this.visible=void 0===t.visible||t.visible,this.style=t.style,this.setOptions(t.options)},VA.prototype.getLegend=function(t,e,i,n,o){null!=i&&null!=i||(i={svg:document.createElementNS("http://www.w3.org/2000/svg","svg"),svgElements:{},options:this.options,groups:[this]});switch(null!=n&&null!=n||(n=0),null!=o&&null!=o||(o=.5*e),this.options.style){case"line":YA.drawIcon(this,n,o,t,e,i);break;case"points":case"point":HA.drawIcon(this,n,o,t,e,i);break;case"bar":WA.drawIcon(this,n,o,t,e,i)}return{icon:i.svg,label:this.content,orientation:this.options.yAxisOrientation}},VA.prototype.getYRange=function(t){for(var e=t[0].y,i=t[0].y,n=0;n<t.length;n++)e=e>t[n].y?t[n].y:e,i=i<t[n].y?t[n].y:i;return{min:e,max:i,yAxisOrientation:this.options.yAxisOrientation}},UA.prototype=new oS,UA.prototype.clear=function(){this.groups={},this.amountOfGroups=0},UA.prototype.addGroup=function(t,e){1!=e.options.excludeFromLegend&&(this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1)},UA.prototype.updateGroup=function(t,e){this.groups[t]=e},UA.prototype.removeGroup=function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)},UA.prototype._create=function(){this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-legend",this.dom.frame.style.position="absolute",this.dom.frame.style.top="10px",this.dom.frame.style.display="block",this.dom.textArea=document.createElement("div"),this.dom.textArea.className="vis-legend-text",this.dom.textArea.style.position="relative",this.dom.textArea.style.top="0px",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.width=this.options.iconSize+5+"px",this.svg.style.height="100%",this.dom.frame.appendChild(this.svg),this.dom.frame.appendChild(this.dom.textArea)},UA.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},UA.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},UA.prototype.setOptions=function(t){WC.selectiveDeepExtend(["enabled","orientation","icons","left","right"],this.options,t)},UA.prototype.redraw=function(){var t=0,e=Vm(this.groups);oD(e).call(e,(function(t,e){return t<e?-1:1}));for(var i=0;i<e.length;i++){var n=e[i];1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||t++}if(0==this.options[this.side].visible||0==this.amountOfGroups||0==this.options.enabled||0==t)this.hide();else{if(this.show(),"top-left"==this.options[this.side].position||"bottom-left"==this.options[this.side].position?(this.dom.frame.style.left="4px",this.dom.frame.style.textAlign="left",this.dom.textArea.style.textAlign="left",this.dom.textArea.style.left=this.options.iconSize+15+"px",this.dom.textArea.style.right="",this.svg.style.left="0px",this.svg.style.right=""):(this.dom.frame.style.right="4px",this.dom.frame.style.textAlign="right",this.dom.textArea.style.textAlign="right",this.dom.textArea.style.right=this.options.iconSize+15+"px",this.dom.textArea.style.left="",this.svg.style.right="0px",this.svg.style.left=""),"top-left"==this.options[this.side].position||"top-right"==this.options[this.side].position)this.dom.frame.style.top=4-Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.bottom="";else{var o=this.body.domProps.center.height-this.body.domProps.centerContainer.height;this.dom.frame.style.bottom=4+o+Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.top=""}0==this.options.icons?(this.dom.frame.style.width=this.dom.textArea.offsetWidth+10+"px",this.dom.textArea.style.right="",this.dom.textArea.style.left="",this.svg.style.width="0px"):(this.dom.frame.style.width=this.options.iconSize+15+this.dom.textArea.offsetWidth+10+"px",this.drawLegendIcons());var r="";for(i=0;i<e.length;i++)n=e[i],1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||(r+=this.groups[n].content+"<br />");this.dom.textArea.innerHTML=WC.xss(r),this.dom.textArea.style.lineHeight=.75*this.options.iconSize+this.options.iconSpacing+"px"}},UA.prototype.drawLegendIcons=function(){if(this.dom.frame.parentNode){var t=Vm(this.groups);oD(t).call(t,(function(t,e){return t<e?-1:1})),AA(h=this.svgElements),IA(h),AA(h);var e=window.getComputedStyle(this.dom.frame).paddingTop,i=Number(e.replace("px","")),n=i,o=this.options.iconSize,r=.75*this.options.iconSize,s=i+.5*r+3;this.svg.style.width=o+5+i+"px";for(var a=0;a<t.length;a++){var l=t[a];1!=this.groups[l].visible||void 0!==this.linegraphOptions.visibility[l]&&1!=this.linegraphOptions.visibility[l]||(this.groups[l].getLegend(o,r,this.framework,n,s),s+=r+this.options.iconSpacing)}}var h};var XA="__ungrouped__";function qA(t,e){this.id=PC(),this.body=t,this.defaultOptions={yAxisOrientation:"left",defaultGroup:"default",sort:!0,sampling:!0,stack:!1,graphHeight:"400px",shaded:{enabled:!1,orientation:"bottom"},style:"line",barChart:{width:50,sideBySide:!1,align:"center"},interpolation:{enabled:!0,parametrization:"centripetal",alpha:.5},drawPoints:{enabled:!0,size:6,style:"square"},dataAxis:{},legend:{},groups:{visibility:{}}},this.options=WC.extend({},this.defaultOptions),this.dom={},this.props={},this.hammer=null,this.groups={},this.abortedGraphUpdate=!1,this.updateSVGheight=!1,this.updateSVGheightOnResize=!1,this.forceGraphUpdate=!0;var i=this;this.itemsData=null,this.groupsData=null,this.itemListeners={add:function(t,e,n){i._onAdd(e.items)},update:function(t,e,n){i._onUpdate(e.items)},remove:function(t,e,n){i._onRemove(e.items)}},this.groupListeners={add:function(t,e,n){i._onAddGroups(e.items)},update:function(t,e,n){i._onUpdateGroups(e.items)},remove:function(t,e,n){i._onRemoveGroups(e.items)}},this.items={},this.selection=[],this.lastStart=this.body.range.start,this.touchParams={},this.svgElements={},this.setOptions(e),this.groupsUsingDefaultStyles=[0],this.body.emitter.on("rangechanged",(function(){i.svg.style.left=WC.option.asSize(-i.props.width),i.forceGraphUpdate=!0,i.redraw.call(i)})),this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups}}qA.prototype=new oS,qA.prototype._create=function(){var t=document.createElement("div");t.className="vis-line-graph",this.dom.frame=t,this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="relative",this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",this.svg.style.display="block",t.appendChild(this.svg),this.options.dataAxis.orientation="left",this.yAxisLeft=new zA(this.body,this.options.dataAxis,this.svg,this.options.groups),this.options.dataAxis.orientation="right",this.yAxisRight=new zA(this.body,this.options.dataAxis,this.svg,this.options.groups),delete this.options.dataAxis.orientation,this.legendLeft=new UA(this.body,this.options.legend,"left",this.options.groups),this.legendRight=new UA(this.body,this.options.legend,"right",this.options.groups),this.show()},qA.prototype.setOptions=function(t){if(t){void 0===t.graphHeight&&void 0!==t.height?(this.updateSVGheight=!0,this.updateSVGheightOnResize=!0):void 0!==this.body.domProps.centerContainer.height&&void 0!==t.graphHeight&&vb((t.graphHeight+"").replace("px",""))<this.body.domProps.centerContainer.height&&(this.updateSVGheight=!0),WC.selectiveDeepExtend(["sampling","defaultGroup","stack","height","graphHeight","yAxisOrientation","style","barChart","dataAxis","sort","groups"],this.options,t),WC.mergeOptions(this.options,t,"interpolation"),WC.mergeOptions(this.options,t,"drawPoints"),WC.mergeOptions(this.options,t,"shaded"),WC.mergeOptions(this.options,t,"legend"),t.interpolation&&"object"==_c(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5)),this.yAxisLeft&&void 0!==t.dataAxis&&(this.yAxisLeft.setOptions(this.options.dataAxis),this.yAxisRight.setOptions(this.options.dataAxis)),this.legendLeft&&void 0!==t.legend&&(this.legendLeft.setOptions(this.options.legend),this.legendRight.setOptions(this.options.legend)),this.groups.hasOwnProperty(XA)&&this.groups[XA].setOptions(t)}this.dom.frame&&(this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0}))},qA.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},qA.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},qA.prototype.setItems=function(t){var e,i=this,n=this.itemsData;if(t){if(!FC(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=BC(t)}else this.itemsData=null;if(n&&(cp(WC).call(WC,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var o=this.id;cp(WC).call(WC,this.itemListeners,(function(t,e){i.itemsData.on(e,t,o)})),e=this.itemsData.getIds(),this._onAdd(e)}},qA.prototype.setGroups=function(t){var e,i=this;if(this.groupsData){cp(WC).call(WC,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null;for(var n=0;n<e.length;n++)this._removeGroup(e[n])}if(t){if(!FC(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var o=this.id;cp(WC).call(WC,this.groupListeners,(function(t,e){i.groupsData.on(e,t,o)})),e=this.groupsData.getIds(),this._onAddGroups(e)}},qA.prototype._onUpdate=function(t){this._updateAllGroupData(t)},qA.prototype._onAdd=function(t){this._onUpdate(t)},qA.prototype._onRemove=function(t){this._onUpdate(t)},qA.prototype._onUpdateGroups=function(t){this._updateAllGroupData(null,t)},qA.prototype._onAddGroups=function(t){this._onUpdateGroups(t)},qA.prototype._onRemoveGroups=function(t){for(var e=0;e<t.length;e++)this._removeGroup(t[e]);this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})},qA.prototype._removeGroup=function(t){this.groups.hasOwnProperty(t)&&("right"==this.groups[t].options.yAxisOrientation?(this.yAxisRight.removeGroup(t),this.legendRight.removeGroup(t),this.legendRight.redraw()):(this.yAxisLeft.removeGroup(t),this.legendLeft.removeGroup(t),this.legendLeft.redraw()),delete this.groups[t])},qA.prototype._updateGroup=function(t,e){this.groups.hasOwnProperty(e)?(this.groups[e].update(t),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.updateGroup(e,this.groups[e]),this.legendRight.updateGroup(e,this.groups[e]),this.yAxisLeft.removeGroup(e),this.legendLeft.removeGroup(e)):(this.yAxisLeft.updateGroup(e,this.groups[e]),this.legendLeft.updateGroup(e,this.groups[e]),this.yAxisRight.removeGroup(e),this.legendRight.removeGroup(e))):(this.groups[e]=new VA(t,e,this.options,this.groupsUsingDefaultStyles),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.addGroup(e,this.groups[e]),this.legendRight.addGroup(e,this.groups[e])):(this.yAxisLeft.addGroup(e,this.groups[e]),this.legendLeft.addGroup(e,this.groups[e]))),this.legendLeft.redraw(),this.legendRight.redraw()},qA.prototype._updateAllGroupData=function(t,e){if(null!=this.itemsData){var i={},n=this.itemsData.get(),o=this.itemsData.idProp,r={};t&&km(t).call(t,(function(t){r[t]=t}));for(var s={},a=0;a<n.length;a++){var l=n[a],h=l.group;null==h&&(h=XA),s.hasOwnProperty(h)?s[h]++:s[h]=1}var u={};if(!e&&t)for(h in this.groups)if(this.groups.hasOwnProperty(h)){var c=(f=this.groups[h]).getItems();i[h]=Dp(c).call(c,(function(t){return u[t[o]]=t[o],t[o]!==r[t[o]]}));var d=s[h];s[h]-=i[h].length,i[h].length<d&&(i[h][d-1]={})}for(a=0;a<n.length;a++)if(null==(h=(l=n[a]).group)&&(h=XA),e||!t||l[o]===r[l[o]]||!u.hasOwnProperty(l[o])){i.hasOwnProperty(h)||(i[h]=new Array(s[h]));var p=WC.bridgeObject(l);p.x=WC.convert(l.x,"Date"),p.end=WC.convert(l.end,"Date"),p.orginalY=l.y,p.y=Number(l.y),p[o]=l[o];var m=i[h].length-s[h]--;i[h][m]=p}for(h in this.groups)this.groups.hasOwnProperty(h)&&(i.hasOwnProperty(h)||(i[h]=new Array(0)));for(h in i)if(i.hasOwnProperty(h))if(0==i[h].length)this.groups.hasOwnProperty(h)&&this._removeGroup(h);else{var f=void 0;null!=this.groupsData&&(f=this.groupsData.get(h)),null==f&&(f={id:h,content:this.options.defaultGroup+h}),this._updateGroup(f,h),this.groups[h].setItems(i[h])}this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})}},qA.prototype.redraw=function(){var t=!1;this.props.width=this.dom.frame.offsetWidth,this.props.height=this.body.domProps.centerContainer.height-this.body.domProps.border.top-this.body.domProps.border.bottom,t=this._isResized()||t;var e,i=this.body.range.end-this.body.range.start,n=i!=this.lastVisibleInterval;(this.lastVisibleInterval=i,1==t)&&(this.svg.style.width=WC.option.asSize(3*this.props.width),this.svg.style.left=WC.option.asSize(-this.props.width),-1==Ab(e=this.options.height+"").call(e,"%")&&1!=this.updateSVGheightOnResize||(this.updateSVGheight=!0));if(1==this.updateSVGheight?(this.options.graphHeight!=this.props.height+"px"&&(this.options.graphHeight=this.props.height+"px",this.svg.style.height=this.props.height+"px"),this.updateSVGheight=!1):this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",1==t||1==n||1==this.abortedGraphUpdate||1==this.forceGraphUpdate)t=this._updateGraph()||t,this.forceGraphUpdate=!1,this.lastStart=this.body.range.start,this.svg.style.left=-this.props.width+"px";else if(0!=this.lastStart){var o=this.body.range.start-this.lastStart,r=this.body.range.end-this.body.range.start;if(0!=this.props.width){var s=o*(this.props.width/r);this.svg.style.left=-this.props.width-s+"px"}}return this.legendLeft.redraw(),this.legendRight.redraw(),t},qA.prototype._getSortedGroupIds=function(){var t=[];for(var e in this.groups)if(this.groups.hasOwnProperty(e)){var i=this.groups[e];1!=i.visible||void 0!==this.options.groups.visibility[e]&&1!=this.options.groups.visibility[e]||t.push({id:e,zIndex:i.options.zIndex})}WC.insertSort(t,(function(t,e){var i=t.zIndex,n=e.zIndex;return void 0===i&&(i=0),void 0===n&&(n=0),i==n?0:i<n?-1:1}));for(var n=new Array(t.length),o=0;o<t.length;o++)n[o]=t[o].id;return n},qA.prototype._updateGraph=function(){if(AA(this.svgElements),0!=this.props.width&&null!=this.itemsData){var t,e,i={},n=this.body.util.toGlobalTime(-this.body.domProps.root.width),o=this.body.util.toGlobalTime(2*this.body.domProps.root.width),r=this._getSortedGroupIds();if(r.length>0){var s={};for(this._getRelevantData(r,s,n,o),this._applySampling(r,s),e=0;e<r.length;e++)this._convertXcoordinates(s[r[e]]);if(this._getYRanges(r,s,i),1==this._updateYAxis(r,i))return IA(this.svgElements),this.abortedGraphUpdate=!0,!0;this.abortedGraphUpdate=!1;var a=void 0;for(e=0;e<r.length;e++)t=this.groups[r[e]],!0===this.options.stack&&"line"===this.options.style&&(null!=t.options.excludeFromStacking&&t.options.excludeFromStacking||(null!=a&&(this._stack(s[t.id],s[a.id]),1==t.options.shaded.enabled&&"group"!==t.options.shaded.orientation&&("top"==t.options.shaded.orientation&&"group"!==a.options.shaded.orientation?(a.options.shaded.orientation="group",a.options.shaded.groupId=t.id):(t.options.shaded.orientation="group",t.options.shaded.groupId=a.id))),a=t)),this._convertYcoordinates(s[r[e]],t);var l={};for(e=0;e<r.length;e++)if("line"===(t=this.groups[r[e]]).options.style&&1==t.options.shaded.enabled){var h=s[r[e]];if(null==h||0==h.length)continue;if(l.hasOwnProperty(r[e])||(l[r[e]]=YA.calcPath(h,t)),"group"===t.options.shaded.orientation){var u=t.options.shaded.groupId;if(-1===Ab(r).call(r,u)){console.log(t.id+": Unknown shading group target given:"+u);continue}l.hasOwnProperty(u)||(l[u]=YA.calcPath(s[u],this.groups[u])),YA.drawShading(l[r[e]],t,l[u],this.framework)}else YA.drawShading(l[r[e]],t,void 0,this.framework)}for(WA.draw(r,s,this.framework),e=0;e<r.length;e++)if(t=this.groups[r[e]],s[r[e]].length>0)switch(t.options.style){case"line":l.hasOwnProperty(r[e])||(l[r[e]]=YA.calcPath(s[r[e]],t)),YA.draw(l[r[e]],t,this.framework);case"point":case"points":"point"!=t.options.style&&"points"!=t.options.style&&1!=t.options.drawPoints.enabled||HA.draw(s[r[e]],t,this.framework)}}}return IA(this.svgElements),!1},qA.prototype._stack=function(t,e){var i,n,o,r,s;i=0;for(var a=0;a<t.length;a++){r=void 0,s=void 0;for(var l=i;l<e.length;l++){if(e[l].x===t[a].x){r=e[l],s=e[l],i=l;break}if(e[l].x>t[a].x){s=e[l],r=0==l?s:e[l-1],i=l;break}}void 0===s&&(r=e[e.length-1],s=e[e.length-1]),n=s.x-r.x,o=s.y-r.y,t[a].y=0==n?t[a].orginalY+s.y:t[a].orginalY+o/n*(t[a].x-r.x)+r.y}},qA.prototype._getRelevantData=function(t,e,i,n){var o,r,s,a;if(t.length>0)for(r=0;r<t.length;r++){var l=(o=this.groups[t[r]]).getItems();if(1==oD(o.options)){var h=function(t,e){return t.getTime()==e.getTime()?0:t<e?-1:1},u=Math.max(0,WC.binarySearchValue(l,i,"x","before",h)),c=Math.min(l.length,WC.binarySearchValue(l,n,"x","after",h)+1);c<=0&&(c=l.length);var d=new Array(c-u);for(s=u;s<c;s++)a=o.itemsData[s],d[s-u]=a;e[t[r]]=d}else e[t[r]]=o.itemsData}},qA.prototype._applySampling=function(t,e){if(t.length>0)for(var i=0;i<t.length;i++)if(1==this.groups[t[i]].options.sampling){var n=e[t[i]];if(n.length>0){var o,r=n.length,s=r/(this.body.util.toGlobalScreen(n[n.length-1].x)-this.body.util.toGlobalScreen(n[0].x));o=Math.min(Math.ceil(.2*r),Math.max(1,Math.round(s)));for(var a=new Array(r),l=0;l<r;l+=o){a[Math.round(l/o)]=n[l]}e[t[i]]=Gg(a).call(a,0,Math.round(r/o))}}},qA.prototype._getYRanges=function(t,e,i){var n,o,r,s,a=[],l=[];if(t.length>0){for(r=0;r<t.length;r++)n=e[t[r]],s=this.groups[t[r]].options,n.length>0&&(o=this.groups[t[r]],!0===s.stack&&"bar"===s.style?"left"===s.yAxisOrientation?a=zv(a).call(a,n):l=zv(l).call(l,n):i[t[r]]=o.getYRange(n,t[r]));WA.getStackedYRange(a,i,t,"__barStackLeft","left"),WA.getStackedYRange(l,i,t,"__barStackRight","right")}},qA.prototype._updateYAxis=function(t,e){var i,n,o=!1,r=!1,s=!1,a=1e9,l=1e9,h=-1e9,u=-1e9;if(t.length>0){for(var c=0;c<t.length;c++){var d=this.groups[t[c]];d&&"right"!=d.options.yAxisOrientation?(r=!0,a=1e9,h=-1e9):d&&d.options.yAxisOrientation&&(s=!0,l=1e9,u=-1e9)}for(c=0;c<t.length;c++)e.hasOwnProperty(t[c])&&!0!==e[t[c]].ignore&&(i=e[t[c]].min,n=e[t[c]].max,"right"!=e[t[c]].yAxisOrientation?(r=!0,a=a>i?i:a,h=h<n?n:h):(s=!0,l=l>i?i:l,u=u<n?n:u));1==r&&this.yAxisLeft.setRange(a,h),1==s&&this.yAxisRight.setRange(l,u)}o=this._toggleAxisVisiblity(r,this.yAxisLeft)||o,o=this._toggleAxisVisiblity(s,this.yAxisRight)||o,1==s&&1==r?(this.yAxisLeft.drawIcons=!0,this.yAxisRight.drawIcons=!0):(this.yAxisLeft.drawIcons=!1,this.yAxisRight.drawIcons=!1),this.yAxisRight.master=!r,this.yAxisRight.masterAxis=this.yAxisLeft,0==this.yAxisRight.master?(this.yAxisLeft.lineOffset=1==s?this.yAxisRight.width:0,o=this.yAxisLeft.redraw()||o,o=this.yAxisRight.redraw()||o):o=this.yAxisRight.redraw()||o;var p=["__barStackLeft","__barStackRight","__lineStackLeft","__lineStackRight"];for(c=0;c<p.length;c++)-1!=Ab(t).call(t,p[c])&&Gg(t).call(t,Ab(t).call(t,p[c]),1);return o},qA.prototype._toggleAxisVisiblity=function(t,e){var i=!1;return 0==t?e.dom.frame.parentNode&&0==e.hidden&&(e.hide(),i=!0):e.dom.frame.parentNode||1!=e.hidden||(e.show(),i=!0),i},qA.prototype._convertXcoordinates=function(t){for(var e=this.body.util.toScreen,i=0;i<t.length;i++)t[i].screen_x=e(t[i].x)+this.props.width,t[i].screen_y=t[i].y,null!=t[i].end?t[i].screen_end=e(t[i].end)+this.props.width:t[i].screen_end=void 0},qA.prototype._convertYcoordinates=function(t,e){var i=this.yAxisLeft,n=Number(this.svg.style.height.replace("px",""));"right"==e.options.yAxisOrientation&&(i=this.yAxisRight);for(var o=0;o<t.length;o++)t[o].screen_y=Math.round(i.convertValue(t[o].y));e.setZeroPosition(Math.min(n,i.convertValue(0)))};var KA="string",$A="boolean",ZA="number",QA="date",JA="object",tI="moment",eI={configure:{enabled:{boolean:$A},filter:{boolean:$A,function:"function"},container:{dom:"dom"},__type__:{object:JA,boolean:$A,function:"function"}},alignCurrentTime:{string:KA,undefined:"undefined"},yAxisOrientation:{string:["left","right"]},defaultGroup:{string:KA},sort:{boolean:$A},sampling:{boolean:$A},stack:{boolean:$A},graphHeight:{string:KA,number:ZA},shaded:{enabled:{boolean:$A},orientation:{string:["bottom","top","zero","group"]},groupId:{object:JA},__type__:{boolean:$A,object:JA}},style:{string:["line","bar","points"]},barChart:{width:{number:ZA},minWidth:{number:ZA},sideBySide:{boolean:$A},align:{string:["left","center","right"]},__type__:{object:JA}},interpolation:{enabled:{boolean:$A},parametrization:{string:["centripetal","chordal","uniform"]},alpha:{number:ZA},__type__:{object:JA,boolean:$A}},drawPoints:{enabled:{boolean:$A},onRender:{function:"function"},size:{number:ZA},style:{string:["square","circle"]},__type__:{object:JA,boolean:$A,function:"function"}},dataAxis:{showMinorLabels:{boolean:$A},showMajorLabels:{boolean:$A},showWeekScale:{boolean:$A},icons:{boolean:$A},width:{string:KA,number:ZA},visible:{boolean:$A},alignZeros:{boolean:$A},left:{range:{min:{number:ZA,undefined:"undefined"},max:{number:ZA,undefined:"undefined"},__type__:{object:JA}},format:{function:"function"},title:{text:{string:KA,number:ZA,undefined:"undefined"},style:{string:KA,undefined:"undefined"},__type__:{object:JA}},__type__:{object:JA}},right:{range:{min:{number:ZA,undefined:"undefined"},max:{number:ZA,undefined:"undefined"},__type__:{object:JA}},format:{function:"function"},title:{text:{string:KA,number:ZA,undefined:"undefined"},style:{string:KA,undefined:"undefined"},__type__:{object:JA}},__type__:{object:JA}},__type__:{object:JA}},legend:{enabled:{boolean:$A},icons:{boolean:$A},left:{visible:{boolean:$A},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:JA}},right:{visible:{boolean:$A},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:JA}},__type__:{object:JA,boolean:$A}},groups:{visibility:{any:"any"},__type__:{object:JA}},autoResize:{boolean:$A},throttleRedraw:{number:ZA},clickToUse:{boolean:$A},end:{number:ZA,date:QA,string:KA,moment:tI},format:{minorLabels:{millisecond:{string:KA,undefined:"undefined"},second:{string:KA,undefined:"undefined"},minute:{string:KA,undefined:"undefined"},hour:{string:KA,undefined:"undefined"},weekday:{string:KA,undefined:"undefined"},day:{string:KA,undefined:"undefined"},week:{string:KA,undefined:"undefined"},month:{string:KA,undefined:"undefined"},quarter:{string:KA,undefined:"undefined"},year:{string:KA,undefined:"undefined"},__type__:{object:JA}},majorLabels:{millisecond:{string:KA,undefined:"undefined"},second:{string:KA,undefined:"undefined"},minute:{string:KA,undefined:"undefined"},hour:{string:KA,undefined:"undefined"},weekday:{string:KA,undefined:"undefined"},day:{string:KA,undefined:"undefined"},week:{string:KA,undefined:"undefined"},month:{string:KA,undefined:"undefined"},quarter:{string:KA,undefined:"undefined"},year:{string:KA,undefined:"undefined"},__type__:{object:JA}},__type__:{object:JA}},moment:{function:"function"},height:{string:KA,number:ZA},hiddenDates:{start:{date:QA,number:ZA,string:KA,moment:tI},end:{date:QA,number:ZA,string:KA,moment:tI},repeat:{string:KA},__type__:{object:JA,array:"array"}},locale:{string:KA},locales:{__any__:{any:"any"},__type__:{object:JA}},max:{date:QA,number:ZA,string:KA,moment:tI},maxHeight:{number:ZA,string:KA},maxMinorChars:{number:ZA},min:{date:QA,number:ZA,string:KA,moment:tI},minHeight:{number:ZA,string:KA},moveable:{boolean:$A},multiselect:{boolean:$A},orientation:{string:KA},showCurrentTime:{boolean:$A},showMajorLabels:{boolean:$A},showMinorLabels:{boolean:$A},showWeekScale:{boolean:$A},snap:{function:"function",null:"null"},start:{date:QA,number:ZA,string:KA,moment:tI},timeAxis:{scale:{string:KA,undefined:"undefined"},step:{number:ZA,undefined:"undefined"},__type__:{object:JA}},width:{string:KA,number:ZA},zoomable:{boolean:$A},zoomKey:{string:["ctrlKey","altKey","metaKey",""]},zoomMax:{number:ZA},zoomMin:{number:ZA},zIndex:{number:ZA},__type__:{object:JA}},iI={global:{alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],sort:!0,sampling:!0,stack:!1,shaded:{enabled:!1,orientation:["zero","top","bottom","group"]},style:["line","bar","points"],barChart:{width:[50,5,100,5],minWidth:[50,5,100,5],sideBySide:!1,align:["left","center","right"]},interpolation:{enabled:!0,parametrization:["centripetal","chordal","uniform"]},drawPoints:{enabled:!0,size:[6,2,30,1],style:["square","circle"]},dataAxis:{showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,width:[40,0,200,1],visible:!0,alignZeros:!0,left:{title:{text:"",style:""}},right:{title:{text:"",style:""}}},legend:{enabled:!1,icons:!0,left:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]},right:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]}},autoResize:!0,clickToUse:!1,end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",quarter:"[Q]Q",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",quarter:"YYYY",year:""}},height:"",locale:"",max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!0,orientation:["both","bottom","top"],showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,showWeekScale:!1,start:"",width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],zIndex:0}};function nI(t,e,i,n){var o,r,s,a,l,h,u;if(!Dd(i)&&!FC(i)&&i instanceof Object){var c=n;n=i,i=c}n&&n.throttleRedraw&&console.warn('Graph2d option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var d=this;this.defaultOptions={start:null,end:null,autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:dp,width:null,height:null,maxHeight:null,minHeight:null},this.options=WC.deepExtend({},this.defaultOptions),this._create(t),this.components=[],this.body={dom:this.dom,domProps:this.props,emitter:{on:Od(o=this.on).call(o,this),off:Od(r=this.off).call(r,this),emit:Od(s=this.emit).call(s,this)},hiddenDates:[],util:{getScale:function(){return d.timeAxis.step.scale},getStep:function(){return d.timeAxis.step.step},toScreen:Od(a=d._toScreen).call(a,d),toGlobalScreen:Od(l=d._toGlobalScreen).call(l,d),toTime:Od(h=d._toTime).call(h,d),toGlobalTime:Od(u=d._toGlobalTime).call(u,d)}},this.range=new wD(this.body),this.components.push(this.range),this.body.range=this.range,this.timeAxis=new HD(this.body),this.components.push(this.timeAxis),this.currentTime=new hT(this.body),this.components.push(this.currentTime),this.linegraph=new qA(this.body),this.components.push(this.linegraph),this.itemsData=null,this.groupsData=null,this.on("tap",(function(t){d.emit("click",d.getEventProperties(t))})),this.on("doubletap",(function(t){d.emit("doubleClick",d.getEventProperties(t))})),this.dom.root.oncontextmenu=function(t){d.emit("contextmenu",d.getEventProperties(t))},this.initialFitDone=!1,this.on("changed",(function(){if(null!=d.itemsData){if(!d.initialFitDone&&!d.options.rollingMode)if(d.initialFitDone=!0,null!=d.options.start||null!=d.options.end){if(null==d.options.start||null==d.options.end)var t=d.getItemRange();var e=null!=d.options.start?d.options.start:t.min,i=null!=d.options.end?d.options.end:t.max;d.setWindow(e,i,{animation:!1})}else d.fit({animation:!1});d.initialDrawDone||!d.initialRangeChangeDone&&(d.options.start||d.options.end)&&!d.options.rollingMode||(d.initialDrawDone=!0,d.dom.root.style.visibility="visible",d.dom.loadingScreen.parentNode.removeChild(d.dom.loadingScreen),d.options.onInitialDrawComplete&&$d((function(){return d.options.onInitialDrawComplete()}),0))}})),n&&this.setOptions(n),i&&this.setGroups(i),e&&this.setItems(e),this._redraw()}nI.prototype=new aT,nI.prototype.setOptions=function(t){!0===dA.validate(t,eI)&&console.log("%cErrors have been found in the supplied options object.",cA),aT.prototype.setOptions.call(this,t)},nI.prototype.setItems=function(t){var e,i=null==this.itemsData;if(e=t?FC(t)?BC(t):BC(new n(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.linegraph&&this.linegraph.setItems(null!=e?e.rawDS:null),i)if(null!=this.options.start||null!=this.options.end){var o=null!=this.options.start?this.options.start:null,r=null!=this.options.end?this.options.end:null;this.setWindow(o,r,{animation:!1})}else this.fit({animation:!1})},nI.prototype.setGroups=function(t){var e;e=t?FC(t)?t:new n(t):null,this.groupsData=e,this.linegraph.setGroups(e)},nI.prototype.getLegend=function(t,e,i){return void 0===e&&(e=15),void 0===i&&(i=15),void 0!==this.linegraph.groups[t]?this.linegraph.groups[t].getLegend(e,i):"cannot find group:'"+t+"'"},nI.prototype.isGroupVisible=function(t){return void 0!==this.linegraph.groups[t]&&(this.linegraph.groups[t].visible&&(void 0===this.linegraph.options.groups.visibility[t]||1==this.linegraph.options.groups.visibility[t]))},nI.prototype.getDataRange=function(){var t=null,e=null;for(var i in this.linegraph.groups)if(this.linegraph.groups.hasOwnProperty(i)&&1==this.linegraph.groups[i].visible)for(var n=0;n<this.linegraph.groups[i].itemsData.length;n++){var o=this.linegraph.groups[i].itemsData[n],r=WC.convert(o.x,"Date").valueOf();t=null==t||t>r?r:t,e=null==e||e<r?r:e}return{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}},nI.prototype.getEventProperties=function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=e-WC.getAbsoluteLeft(this.dom.centerContainer),o=i-WC.getAbsoluteTop(this.dom.centerContainer),r=this._toTime(n),s=sT.customTimeFromTarget(t),a=WC.getTarget(t),l=null;WC.hasParent(a,this.timeAxis.dom.foreground)||this.timeAxis2&&WC.hasParent(a,this.timeAxis2.dom.foreground)?l="axis":WC.hasParent(a,this.linegraph.yAxisLeft.dom.frame)||WC.hasParent(a,this.linegraph.yAxisRight.dom.frame)?l="data-axis":WC.hasParent(a,this.linegraph.legendLeft.dom.frame)||WC.hasParent(a,this.linegraph.legendRight.dom.frame)?l="legend":null!=s?l="custom-time":WC.hasParent(a,this.currentTime.bar)?l="current-time":WC.hasParent(a,this.dom.center)&&(l="background");var h=[],u=this.linegraph.yAxisLeft,c=this.linegraph.yAxisRight;return!u.hidden&&this.itemsData.length>0&&h.push(u.screenToValue(o)),!c.hidden&&this.itemsData.length>0&&h.push(c.screenToValue(o)),{event:t,customTime:s?s.options.id:null,what:l,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:n,y:o,time:r,value:h}},nI.prototype._createConfigurator=function(){return new CA(this,this.dom.container,iI)};var oI=function(){try{return navigator?navigator.languages&&navigator.languages.length?navigator.languages:navigator.userLanguage||navigator.language||navigator.browserLanguage||"en":"en"}catch(t){return"en"}}();t.locale(oI);var rI={Core:aT,DateUtil:yD,Range:wD,stack:xE,TimeStep:BD,components:{items:{Item:EE,BackgroundItem:LE,BoxItem:IE,ClusterItem:QE,PointItem:ME,RangeItem:FE},BackgroundGroup:DE,Component:oS,CurrentTime:hT,CustomTime:sT,DataAxis:zA,DataScale:RA,GraphGroup:VA,Group:CE,ItemSet:lA,Legend:UA,LineGraph:qA,TimeAxis:HD}};export{nI as Graph2d,DA as Timeline,rI as timeline};
//# sourceMappingURL=vis-timeline-graph2d.min.js.map
