/**
 * vis-timeline and vis-graph2d
 * https://visjs.github.io/vis-timeline/
 *
 * Create a fully customizable, interactive timeline with items and ranges.
 *
 * @version 7.7.1
 * @date    2023-03-21T17:19:12.331Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}function n(t){throw new Error('Could not dynamically require "'+t+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var r,o,s={},a={get exports(){return s},set exports(t){s=t}};function l(){return r||(r=1,(t=a).exports=function(){var e,i;function r(){return e.apply(null,arguments)}function o(t){e=t}function s(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function a(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function l(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function h(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(l(t,e))return!1;return!0}function u(t){return void 0===t}function d(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function c(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function p(t,e){var i,n=[],r=t.length;for(i=0;i<r;++i)n.push(e(t[i],i));return n}function f(t,e){for(var i in e)l(e,i)&&(t[i]=e[i]);return l(e,"toString")&&(t.toString=e.toString),l(e,"valueOf")&&(t.valueOf=e.valueOf),t}function m(t,e,i,n){return qi(t,e,i,n,!0).utc()}function v(){return{empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}}function g(t){return null==t._pf&&(t._pf=v()),t._pf}function y(t){if(null==t._isValid){var e=g(t),n=i.call(e.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function b(t){var e=m(NaN);return null!=t?f(g(e),t):g(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){var e,i=Object(this),n=i.length>>>0;for(e=0;e<n;e++)if(e in i&&t.call(this,i[e],e,i))return!0;return!1};var _=r.momentProperties=[],w=!1;function k(t,e){var i,n,r,o=_.length;if(u(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),u(e._i)||(t._i=e._i),u(e._f)||(t._f=e._f),u(e._l)||(t._l=e._l),u(e._strict)||(t._strict=e._strict),u(e._tzm)||(t._tzm=e._tzm),u(e._isUTC)||(t._isUTC=e._isUTC),u(e._offset)||(t._offset=e._offset),u(e._pf)||(t._pf=g(e)),u(e._locale)||(t._locale=e._locale),o>0)for(i=0;i<o;i++)u(r=e[n=_[i]])||(t[n]=r);return t}function x(t){k(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===w&&(w=!0,r.updateOffset(this),w=!1)}function D(t){return t instanceof x||null!=t&&null!=t._isAMomentObject}function S(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function C(t,e){var i=!0;return f((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),i){var n,o,s,a=[],h=arguments.length;for(o=0;o<h;o++){if(n="","object"==typeof arguments[o]){for(s in n+="\n["+o+"] ",arguments[0])l(arguments[0],s)&&(n+=s+": "+arguments[0][s]+", ");n=n.slice(0,-2)}else n=arguments[o];a.push(n)}S(t+"\nArguments: "+Array.prototype.slice.call(a).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var T,M={};function O(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),M[t]||(S(e),M[t]=!0)}function E(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function P(t){var e,i;for(i in t)l(t,i)&&(E(e=t[i])?this[i]=e:this["_"+i]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)}function A(t,e){var i,n=f({},t);for(i in e)l(e,i)&&(a(t[i])&&a(e[i])?(n[i]={},f(n[i],t[i]),f(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)l(t,i)&&!l(e,i)&&a(t[i])&&(n[i]=f({},n[i]));return n}function I(t){null!=t&&this.set(t)}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,T=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)l(t,e)&&i.push(e);return i};var L={sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"};function N(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return E(n)?n.call(e,i):n}function R(t,e,i){var n=""+Math.abs(t),r=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+n}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,j=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,Y={},H={};function z(t,e,i,n){var r=n;"string"==typeof n&&(r=function(){return this[n]()}),t&&(H[t]=r),e&&(H[e[0]]=function(){return R(r.apply(this,arguments),e[1],e[2])}),i&&(H[i]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function B(t){return t.match(/\[[\s\S]/)?t.replace(/^\[|\]$/g,""):t.replace(/\\/g,"")}function G(t){var e,i,n=t.match(F);for(e=0,i=n.length;e<i;e++)H[n[e]]?n[e]=H[n[e]]:n[e]=B(n[e]);return function(e){var r,o="";for(r=0;r<i;r++)o+=E(n[r])?n[r].call(e,t):n[r];return o}}function W(t,e){return t.isValid()?(e=V(e,t.localeData()),Y[e]=Y[e]||G(e),Y[e](t)):t.localeData().invalidDate()}function V(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(j.lastIndex=0;i>=0&&j.test(t);)t=t.replace(j,n),j.lastIndex=0,i-=1;return t}var U={LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"};function X(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.match(F).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])}var q="Invalid date";function $(){return this._invalidDate}var Z="%d",K=/\d{1,2}/;function J(t){return this._ordinal.replace("%d",t)}var Q={future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"};function tt(t,e,i,n){var r=this._relativeTime[i];return E(r)?r(t,e,i,n):r.replace(/%d/i,t)}function et(t,e){var i=this._relativeTime[t>0?"future":"past"];return E(i)?i(e):i.replace(/%s/i,e)}var it={};function nt(t,e){var i=t.toLowerCase();it[i]=it[i+"s"]=it[e]=t}function rt(t){return"string"==typeof t?it[t]||it[t.toLowerCase()]:void 0}function ot(t){var e,i,n={};for(i in t)l(t,i)&&(e=rt(i))&&(n[e]=t[i]);return n}var st={};function at(t,e){st[t]=e}function lt(t){var e,i=[];for(e in t)l(t,e)&&i.push({unit:e,priority:st[e]});return i.sort((function(t,e){return t.priority-e.priority})),i}function ht(t){return t%4==0&&t%100!=0||t%400==0}function ut(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function dt(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=ut(e)),i}function ct(t,e){return function(i){return null!=i?(ft(this,t,i),r.updateOffset(this,e),this):pt(this,t)}}function pt(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function ft(t,e,i){t.isValid()&&!isNaN(i)&&("FullYear"===e&&ht(t.year())&&1===t.month()&&29===t.date()?(i=dt(i),t._d["set"+(t._isUTC?"UTC":"")+e](i,t.month(),te(i,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](i))}function mt(t){return E(this[t=rt(t)])?this[t]():this}function vt(t,e){if("object"==typeof t){var i,n=lt(t=ot(t)),r=n.length;for(i=0;i<r;i++)this[n[i].unit](t[n[i].unit])}else if(E(this[t=rt(t)]))return this[t](e);return this}var gt,yt=/\d/,bt=/\d\d/,_t=/\d{3}/,wt=/\d{4}/,kt=/[+-]?\d{6}/,xt=/\d\d?/,Dt=/\d\d\d\d?/,St=/\d\d\d\d\d\d?/,Ct=/\d{1,3}/,Tt=/\d{1,4}/,Mt=/[+-]?\d{1,6}/,Ot=/\d+/,Et=/[+-]?\d+/,Pt=/Z|[+-]\d\d:?\d\d/gi,At=/Z|[+-]\d\d(?::?\d\d)?/gi,It=/[+-]?\d+(\.\d{1,3})?/,Lt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function Nt(t,e,i){gt[t]=E(e)?e:function(t,n){return t&&i?i:e}}function Rt(t,e){return l(gt,t)?gt[t](e._strict,e._locale):new RegExp(Ft(t))}function Ft(t){return jt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,r){return e||i||n||r})))}function jt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}gt={};var Yt={};function Ht(t,e){var i,n,r=e;for("string"==typeof t&&(t=[t]),d(e)&&(r=function(t,i){i[e]=dt(t)}),n=t.length,i=0;i<n;i++)Yt[t[i]]=r}function zt(t,e){Ht(t,(function(t,i,n,r){n._w=n._w||{},e(t,n._w,n,r)}))}function Bt(t,e,i){null!=e&&l(Yt,t)&&Yt[t](e,i._a,i,t)}var Gt,Wt=0,Vt=1,Ut=2,Xt=3,qt=4,$t=5,Zt=6,Kt=7,Jt=8;function Qt(t,e){return(t%e+e)%e}function te(t,e){if(isNaN(t)||isNaN(e))return NaN;var i=Qt(e,12);return t+=(e-i)/12,1===i?ht(t)?29:28:31-i%7%2}Gt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},z("M",["MM",2],"Mo",(function(){return this.month()+1})),z("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),z("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),nt("month","M"),at("month",8),Nt("M",xt),Nt("MM",xt,bt),Nt("MMM",(function(t,e){return e.monthsShortRegex(t)})),Nt("MMMM",(function(t,e){return e.monthsRegex(t)})),Ht(["M","MM"],(function(t,e){e[Vt]=dt(t)-1})),Ht(["MMM","MMMM"],(function(t,e,i,n){var r=i._locale.monthsParse(t,n,i._strict);null!=r?e[Vt]=r:g(i).invalidMonth=t}));var ee="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),ie="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),ne=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,re=Lt,oe=Lt;function se(t,e){return t?s(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||ne).test(e)?"format":"standalone"][t.month()]:s(this._months)?this._months:this._months.standalone}function ae(t,e){return t?s(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[ne.test(e)?"format":"standalone"][t.month()]:s(this._monthsShort)?this._monthsShort:this._monthsShort.standalone}function le(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)o=m([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(o,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(r=Gt.call(this._shortMonthsParse,s))?r:null:-1!==(r=Gt.call(this._longMonthsParse,s))?r:null:"MMM"===e?-1!==(r=Gt.call(this._shortMonthsParse,s))||-1!==(r=Gt.call(this._longMonthsParse,s))?r:null:-1!==(r=Gt.call(this._longMonthsParse,s))||-1!==(r=Gt.call(this._shortMonthsParse,s))?r:null}function he(t,e,i){var n,r,o;if(this._monthsParseExact)return le.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(r=m([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[n]=new RegExp(o.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}}function ue(t,e){var i;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=dt(e);else if(!d(e=t.localeData().monthsParse(e)))return t;return i=Math.min(t.date(),te(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,i),t}function de(t){return null!=t?(ue(this,t),r.updateOffset(this,!0),this):pt(this,"Month")}function ce(){return te(this.year(),this.month())}function pe(t){return this._monthsParseExact?(l(this,"_monthsRegex")||me.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(l(this,"_monthsShortRegex")||(this._monthsShortRegex=re),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)}function fe(t){return this._monthsParseExact?(l(this,"_monthsRegex")||me.call(this),t?this._monthsStrictRegex:this._monthsRegex):(l(this,"_monthsRegex")||(this._monthsRegex=oe),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)}function me(){function t(t,e){return e.length-t.length}var e,i,n=[],r=[],o=[];for(e=0;e<12;e++)i=m([2e3,e]),n.push(this.monthsShort(i,"")),r.push(this.months(i,"")),o.push(this.months(i,"")),o.push(this.monthsShort(i,""));for(n.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)n[e]=jt(n[e]),r[e]=jt(r[e]);for(e=0;e<24;e++)o[e]=jt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function ve(t){return ht(t)?366:365}z("Y",0,0,(function(){var t=this.year();return t<=9999?R(t,4):"+"+t})),z(0,["YY",2],0,(function(){return this.year()%100})),z(0,["YYYY",4],0,"year"),z(0,["YYYYY",5],0,"year"),z(0,["YYYYYY",6,!0],0,"year"),nt("year","y"),at("year",1),Nt("Y",Et),Nt("YY",xt,bt),Nt("YYYY",Tt,wt),Nt("YYYYY",Mt,kt),Nt("YYYYYY",Mt,kt),Ht(["YYYYY","YYYYYY"],Wt),Ht("YYYY",(function(t,e){e[Wt]=2===t.length?r.parseTwoDigitYear(t):dt(t)})),Ht("YY",(function(t,e){e[Wt]=r.parseTwoDigitYear(t)})),Ht("Y",(function(t,e){e[Wt]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return dt(t)+(dt(t)>68?1900:2e3)};var ge=ct("FullYear",!0);function ye(){return ht(this.year())}function be(t,e,i,n,r,o,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,r,o,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,r,o,s),a}function _e(t){var e,i;return t<100&&t>=0?((i=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function we(t,e,i){var n=7+e-i;return-(7+_e(t,0,n).getUTCDay()-e)%7+n-1}function ke(t,e,i,n,r){var o,s,a=1+7*(e-1)+(7+i-n)%7+we(t,n,r);return a<=0?s=ve(o=t-1)+a:a>ve(t)?(o=t+1,s=a-ve(t)):(o=t,s=a),{year:o,dayOfYear:s}}function xe(t,e,i){var n,r,o=we(t.year(),e,i),s=Math.floor((t.dayOfYear()-o-1)/7)+1;return s<1?n=s+De(r=t.year()-1,e,i):s>De(t.year(),e,i)?(n=s-De(t.year(),e,i),r=t.year()+1):(r=t.year(),n=s),{week:n,year:r}}function De(t,e,i){var n=we(t,e,i),r=we(t+1,e,i);return(ve(t)-n+r)/7}function Se(t){return xe(t,this._week.dow,this._week.doy).week}z("w",["ww",2],"wo","week"),z("W",["WW",2],"Wo","isoWeek"),nt("week","w"),nt("isoWeek","W"),at("week",5),at("isoWeek",5),Nt("w",xt),Nt("ww",xt,bt),Nt("W",xt),Nt("WW",xt,bt),zt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=dt(t)}));var Ce={dow:0,doy:6};function Te(){return this._week.dow}function Me(){return this._week.doy}function Oe(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")}function Ee(t){var e=xe(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")}function Pe(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}function Ae(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}function Ie(t,e){return t.slice(e,7).concat(t.slice(0,e))}z("d",0,"do","day"),z("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),z("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),z("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),z("e",0,0,"weekday"),z("E",0,0,"isoWeekday"),nt("day","d"),nt("weekday","e"),nt("isoWeekday","E"),at("day",11),at("weekday",11),at("isoWeekday",11),Nt("d",xt),Nt("e",xt),Nt("E",xt),Nt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),Nt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),Nt("dddd",(function(t,e){return e.weekdaysRegex(t)})),zt(["dd","ddd","dddd"],(function(t,e,i,n){var r=i._locale.weekdaysParse(t,n,i._strict);null!=r?e.d=r:g(i).invalidWeekday=t})),zt(["d","e","E"],(function(t,e,i,n){e[n]=dt(t)}));var Le="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Ne="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Re="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Fe=Lt,je=Lt,Ye=Lt;function He(t,e){var i=s(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Ie(i,this._week.dow):t?i[t.day()]:i}function ze(t){return!0===t?Ie(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort}function Be(t){return!0===t?Ie(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin}function Ge(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)o=m([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(o,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(r=Gt.call(this._weekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Gt.call(this._shortWeekdaysParse,s))?r:null:-1!==(r=Gt.call(this._minWeekdaysParse,s))?r:null:"dddd"===e?-1!==(r=Gt.call(this._weekdaysParse,s))||-1!==(r=Gt.call(this._shortWeekdaysParse,s))||-1!==(r=Gt.call(this._minWeekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Gt.call(this._shortWeekdaysParse,s))||-1!==(r=Gt.call(this._weekdaysParse,s))||-1!==(r=Gt.call(this._minWeekdaysParse,s))?r:null:-1!==(r=Gt.call(this._minWeekdaysParse,s))||-1!==(r=Gt.call(this._weekdaysParse,s))||-1!==(r=Gt.call(this._shortWeekdaysParse,s))?r:null}function We(t,e,i){var n,r,o;if(this._weekdaysParseExact)return Ge.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(r=m([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[n]=new RegExp(o.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}}function Ve(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=Pe(t,this.localeData()),this.add(t-e,"d")):e}function Ue(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")}function Xe(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=Ae(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7}function qe(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(l(this,"_weekdaysRegex")||(this._weekdaysRegex=Fe),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)}function $e(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(l(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=je),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)}function Ze(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(l(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Ye),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)}function Ke(){function t(t,e){return e.length-t.length}var e,i,n,r,o,s=[],a=[],l=[],h=[];for(e=0;e<7;e++)i=m([2e3,1]).day(e),n=jt(this.weekdaysMin(i,"")),r=jt(this.weekdaysShort(i,"")),o=jt(this.weekdays(i,"")),s.push(n),a.push(r),l.push(o),h.push(n),h.push(r),h.push(o);s.sort(t),a.sort(t),l.sort(t),h.sort(t),this._weekdaysRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function Je(){return this.hours()%12||12}function Qe(){return this.hours()||24}function ti(t,e){z(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function ei(t,e){return e._meridiemParse}function ii(t){return"p"===(t+"").toLowerCase().charAt(0)}z("H",["HH",2],0,"hour"),z("h",["hh",2],0,Je),z("k",["kk",2],0,Qe),z("hmm",0,0,(function(){return""+Je.apply(this)+R(this.minutes(),2)})),z("hmmss",0,0,(function(){return""+Je.apply(this)+R(this.minutes(),2)+R(this.seconds(),2)})),z("Hmm",0,0,(function(){return""+this.hours()+R(this.minutes(),2)})),z("Hmmss",0,0,(function(){return""+this.hours()+R(this.minutes(),2)+R(this.seconds(),2)})),ti("a",!0),ti("A",!1),nt("hour","h"),at("hour",13),Nt("a",ei),Nt("A",ei),Nt("H",xt),Nt("h",xt),Nt("k",xt),Nt("HH",xt,bt),Nt("hh",xt,bt),Nt("kk",xt,bt),Nt("hmm",Dt),Nt("hmmss",St),Nt("Hmm",Dt),Nt("Hmmss",St),Ht(["H","HH"],Xt),Ht(["k","kk"],(function(t,e,i){var n=dt(t);e[Xt]=24===n?0:n})),Ht(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),Ht(["h","hh"],(function(t,e,i){e[Xt]=dt(t),g(i).bigHour=!0})),Ht("hmm",(function(t,e,i){var n=t.length-2;e[Xt]=dt(t.substr(0,n)),e[qt]=dt(t.substr(n)),g(i).bigHour=!0})),Ht("hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[Xt]=dt(t.substr(0,n)),e[qt]=dt(t.substr(n,2)),e[$t]=dt(t.substr(r)),g(i).bigHour=!0})),Ht("Hmm",(function(t,e,i){var n=t.length-2;e[Xt]=dt(t.substr(0,n)),e[qt]=dt(t.substr(n))})),Ht("Hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[Xt]=dt(t.substr(0,n)),e[qt]=dt(t.substr(n,2)),e[$t]=dt(t.substr(r))}));var ni=/[ap]\.?m?\.?/i,ri=ct("Hours",!0);function oi(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"}var si,ai={calendar:L,longDateFormat:U,invalidDate:q,ordinal:Z,dayOfMonthOrdinalParse:K,relativeTime:Q,months:ee,monthsShort:ie,week:Ce,weekdays:Le,weekdaysMin:Re,weekdaysShort:Ne,meridiemParse:ni},li={},hi={};function ui(t,e){var i,n=Math.min(t.length,e.length);for(i=0;i<n;i+=1)if(t[i]!==e[i])return i;return n}function di(t){return t?t.toLowerCase().replace("_","-"):t}function ci(t){for(var e,i,n,r,o=0;o<t.length;){for(e=(r=di(t[o]).split("-")).length,i=(i=di(t[o+1]))?i.split("-"):null;e>0;){if(n=fi(r.slice(0,e).join("-")))return n;if(i&&i.length>=e&&ui(r,i)>=e-1)break;e--}o++}return si}function pi(t){return null!=t.match("^[^/\\\\]*$")}function fi(e){var i=null;if(void 0===li[e]&&t&&t.exports&&pi(e))try{i=si._abbr,n("./locale/"+e),mi(i)}catch(t){li[e]=null}return li[e]}function mi(t,e){var i;return t&&((i=u(e)?yi(t):vi(t,e))?si=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),si._abbr}function vi(t,e){if(null!==e){var i,n=ai;if(e.abbr=t,null!=li[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=li[t]._config;else if(null!=e.parentLocale)if(null!=li[e.parentLocale])n=li[e.parentLocale]._config;else{if(null==(i=fi(e.parentLocale)))return hi[e.parentLocale]||(hi[e.parentLocale]=[]),hi[e.parentLocale].push({name:t,config:e}),null;n=i._config}return li[t]=new I(A(n,e)),hi[t]&&hi[t].forEach((function(t){vi(t.name,t.config)})),mi(t),li[t]}return delete li[t],null}function gi(t,e){if(null!=e){var i,n,r=ai;null!=li[t]&&null!=li[t].parentLocale?li[t].set(A(li[t]._config,e)):(null!=(n=fi(t))&&(r=n._config),e=A(r,e),null==n&&(e.abbr=t),(i=new I(e)).parentLocale=li[t],li[t]=i),mi(t)}else null!=li[t]&&(null!=li[t].parentLocale?(li[t]=li[t].parentLocale,t===mi()&&mi(t)):null!=li[t]&&delete li[t]);return li[t]}function yi(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return si;if(!s(t)){if(e=fi(t))return e;t=[t]}return ci(t)}function bi(){return T(li)}function _i(t){var e,i=t._a;return i&&-2===g(t).overflow&&(e=i[Vt]<0||i[Vt]>11?Vt:i[Ut]<1||i[Ut]>te(i[Wt],i[Vt])?Ut:i[Xt]<0||i[Xt]>24||24===i[Xt]&&(0!==i[qt]||0!==i[$t]||0!==i[Zt])?Xt:i[qt]<0||i[qt]>59?qt:i[$t]<0||i[$t]>59?$t:i[Zt]<0||i[Zt]>999?Zt:-1,g(t)._overflowDayOfYear&&(e<Wt||e>Ut)&&(e=Ut),g(t)._overflowWeeks&&-1===e&&(e=Kt),g(t)._overflowWeekday&&-1===e&&(e=Jt),g(t).overflow=e),t}var wi=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ki=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,xi=/Z|[+-]\d\d(?::?\d\d)?/,Di=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],Si=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Ci=/^\/?Date\((-?\d+)/i,Ti=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,Mi={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Oi(t){var e,i,n,r,o,s,a=t._i,l=wi.exec(a)||ki.exec(a),h=Di.length,u=Si.length;if(l){for(g(t).iso=!0,e=0,i=h;e<i;e++)if(Di[e][1].exec(l[1])){r=Di[e][0],n=!1!==Di[e][2];break}if(null==r)return void(t._isValid=!1);if(l[3]){for(e=0,i=u;e<i;e++)if(Si[e][1].exec(l[3])){o=(l[2]||" ")+Si[e][0];break}if(null==o)return void(t._isValid=!1)}if(!n&&null!=o)return void(t._isValid=!1);if(l[4]){if(!xi.exec(l[4]))return void(t._isValid=!1);s="Z"}t._f=r+(o||"")+(s||""),zi(t)}else t._isValid=!1}function Ei(t,e,i,n,r,o){var s=[Pi(t),ie.indexOf(e),parseInt(i,10),parseInt(n,10),parseInt(r,10)];return o&&s.push(parseInt(o,10)),s}function Pi(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function Ai(t){return t.replace(/\([^()]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}function Ii(t,e,i){return!t||Ne.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(g(i).weekdayMismatch=!0,i._isValid=!1,!1)}function Li(t,e,i){if(t)return Mi[t];if(e)return 0;var n=parseInt(i,10),r=n%100;return(n-r)/100*60+r}function Ni(t){var e,i=Ti.exec(Ai(t._i));if(i){if(e=Ei(i[4],i[3],i[2],i[5],i[6],i[7]),!Ii(i[1],e,t))return;t._a=e,t._tzm=Li(i[8],i[9],i[10]),t._d=_e.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),g(t).rfc2822=!0}else t._isValid=!1}function Ri(t){var e=Ci.exec(t._i);null===e?(Oi(t),!1===t._isValid&&(delete t._isValid,Ni(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:r.createFromInputFallback(t)))):t._d=new Date(+e[1])}function Fi(t,e,i){return null!=t?t:null!=e?e:i}function ji(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}function Yi(t){var e,i,n,r,o,s=[];if(!t._d){for(n=ji(t),t._w&&null==t._a[Ut]&&null==t._a[Vt]&&Hi(t),null!=t._dayOfYear&&(o=Fi(t._a[Wt],n[Wt]),(t._dayOfYear>ve(o)||0===t._dayOfYear)&&(g(t)._overflowDayOfYear=!0),i=_e(o,0,t._dayOfYear),t._a[Vt]=i.getUTCMonth(),t._a[Ut]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=n[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[Xt]&&0===t._a[qt]&&0===t._a[$t]&&0===t._a[Zt]&&(t._nextDay=!0,t._a[Xt]=0),t._d=(t._useUTC?_e:be).apply(null,s),r=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[Xt]=24),t._w&&void 0!==t._w.d&&t._w.d!==r&&(g(t).weekdayMismatch=!0)}}function Hi(t){var e,i,n,r,o,s,a,l,h;null!=(e=t._w).GG||null!=e.W||null!=e.E?(o=1,s=4,i=Fi(e.GG,t._a[Wt],xe($i(),1,4).year),n=Fi(e.W,1),((r=Fi(e.E,1))<1||r>7)&&(l=!0)):(o=t._locale._week.dow,s=t._locale._week.doy,h=xe($i(),o,s),i=Fi(e.gg,t._a[Wt],h.year),n=Fi(e.w,h.week),null!=e.d?((r=e.d)<0||r>6)&&(l=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(l=!0)):r=o),n<1||n>De(i,o,s)?g(t)._overflowWeeks=!0:null!=l?g(t)._overflowWeekday=!0:(a=ke(i,n,r,o,s),t._a[Wt]=a.year,t._dayOfYear=a.dayOfYear)}function zi(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],g(t).empty=!0;var e,i,n,o,s,a,l,h=""+t._i,u=h.length,d=0;for(l=(n=V(t._f,t._locale).match(F)||[]).length,e=0;e<l;e++)o=n[e],(i=(h.match(Rt(o,t))||[])[0])&&((s=h.substr(0,h.indexOf(i))).length>0&&g(t).unusedInput.push(s),h=h.slice(h.indexOf(i)+i.length),d+=i.length),H[o]?(i?g(t).empty=!1:g(t).unusedTokens.push(o),Bt(o,i,t)):t._strict&&!i&&g(t).unusedTokens.push(o);g(t).charsLeftOver=u-d,h.length>0&&g(t).unusedInput.push(h),t._a[Xt]<=12&&!0===g(t).bigHour&&t._a[Xt]>0&&(g(t).bigHour=void 0),g(t).parsedDateParts=t._a.slice(0),g(t).meridiem=t._meridiem,t._a[Xt]=Bi(t._locale,t._a[Xt],t._meridiem),null!==(a=g(t).era)&&(t._a[Wt]=t._locale.erasConvertYear(a,t._a[Wt])),Yi(t),_i(t)}else Ni(t);else Oi(t)}function Bi(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}function Gi(t){var e,i,n,r,o,s,a=!1,l=t._f.length;if(0===l)return g(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<l;r++)o=0,s=!1,e=k({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],zi(e),y(e)&&(s=!0),o+=g(e).charsLeftOver,o+=10*g(e).unusedTokens.length,g(e).score=o,a?o<n&&(n=o,i=e):(null==n||o<n||s)&&(n=o,i=e,s&&(a=!0));f(t,i||e)}function Wi(t){if(!t._d){var e=ot(t._i),i=void 0===e.day?e.date:e.day;t._a=p([e.year,e.month,i,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),Yi(t)}}function Vi(t){var e=new x(_i(Ui(t)));return e._nextDay&&(e.add(1,"d"),e._nextDay=void 0),e}function Ui(t){var e=t._i,i=t._f;return t._locale=t._locale||yi(t._l),null===e||void 0===i&&""===e?b({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),D(e)?new x(_i(e)):(c(e)?t._d=e:s(i)?Gi(t):i?zi(t):Xi(t),y(t)||(t._d=null),t))}function Xi(t){var e=t._i;u(e)?t._d=new Date(r.now()):c(e)?t._d=new Date(e.valueOf()):"string"==typeof e?Ri(t):s(e)?(t._a=p(e.slice(0),(function(t){return parseInt(t,10)})),Yi(t)):a(e)?Wi(t):d(e)?t._d=new Date(e):r.createFromInputFallback(t)}function qi(t,e,i,n,r){var o={};return!0!==e&&!1!==e||(n=e,e=void 0),!0!==i&&!1!==i||(n=i,i=void 0),(a(t)&&h(t)||s(t)&&0===t.length)&&(t=void 0),o._isAMomentObject=!0,o._useUTC=o._isUTC=r,o._l=i,o._i=t,o._f=e,o._strict=n,Vi(o)}function $i(t,e,i,n){return qi(t,e,i,n,!1)}r.createFromInputFallback=C("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Zi=C("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=$i.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:b()})),Ki=C("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=$i.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:b()}));function Ji(t,e){var i,n;if(1===e.length&&s(e[0])&&(e=e[0]),!e.length)return $i();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}function Qi(){return Ji("isBefore",[].slice.call(arguments,0))}function tn(){return Ji("isAfter",[].slice.call(arguments,0))}var en=function(){return Date.now?Date.now():+new Date},nn=["year","quarter","month","week","day","hour","minute","second","millisecond"];function rn(t){var e,i,n=!1,r=nn.length;for(e in t)if(l(t,e)&&(-1===Gt.call(nn,e)||null!=t[e]&&isNaN(t[e])))return!1;for(i=0;i<r;++i)if(t[nn[i]]){if(n)return!1;parseFloat(t[nn[i]])!==dt(t[nn[i]])&&(n=!0)}return!0}function on(){return this._isValid}function sn(){return On(NaN)}function an(t){var e=ot(t),i=e.year||0,n=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,a=e.hour||0,l=e.minute||0,h=e.second||0,u=e.millisecond||0;this._isValid=rn(e),this._milliseconds=+u+1e3*h+6e4*l+1e3*a*60*60,this._days=+s+7*o,this._months=+r+3*n+12*i,this._data={},this._locale=yi(),this._bubble()}function ln(t){return t instanceof an}function hn(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function un(t,e,i){var n,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),s=0;for(n=0;n<r;n++)(i&&t[n]!==e[n]||!i&&dt(t[n])!==dt(e[n]))&&s++;return s+o}function dn(t,e){z(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+R(~~(t/60),2)+e+R(~~t%60,2)}))}dn("Z",":"),dn("ZZ",""),Nt("Z",At),Nt("ZZ",At),Ht(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=pn(At,t)}));var cn=/([\+\-]|\d\d)/gi;function pn(t,e){var i,n,r=(e||"").match(t);return null===r?null:0===(n=60*(i=((r[r.length-1]||[])+"").match(cn)||["-",0,0])[1]+dt(i[2]))?0:"+"===i[0]?n:-n}function fn(t,e){var i,n;return e._isUTC?(i=e.clone(),n=(D(t)||c(t)?t.valueOf():$i(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+n),r.updateOffset(i,!1),i):$i(t).local()}function mn(t){return-Math.round(t._d.getTimezoneOffset())}function vn(t,e,i){var n,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=pn(At,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(n=mn(this)),this._offset=t,this._isUTC=!0,null!=n&&this.add(n,"m"),o!==t&&(!e||this._changeInProgress?Ln(this,On(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:mn(this)}function gn(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()}function yn(t){return this.utcOffset(0,t)}function bn(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(mn(this),"m")),this}function _n(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=pn(Pt,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this}function wn(t){return!!this.isValid()&&(t=t?$i(t).utcOffset():0,(this.utcOffset()-t)%60==0)}function kn(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()}function xn(){if(!u(this._isDSTShifted))return this._isDSTShifted;var t,e={};return k(e,this),(e=Ui(e))._a?(t=e._isUTC?m(e._a):$i(e._a),this._isDSTShifted=this.isValid()&&un(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}function Dn(){return!!this.isValid()&&!this._isUTC}function Sn(){return!!this.isValid()&&this._isUTC}function Cn(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var Tn=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Mn=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function On(t,e){var i,n,r,o=t,s=null;return ln(t)?o={ms:t._milliseconds,d:t._days,M:t._months}:d(t)||!isNaN(+t)?(o={},e?o[e]=+t:o.milliseconds=+t):(s=Tn.exec(t))?(i="-"===s[1]?-1:1,o={y:0,d:dt(s[Ut])*i,h:dt(s[Xt])*i,m:dt(s[qt])*i,s:dt(s[$t])*i,ms:dt(hn(1e3*s[Zt]))*i}):(s=Mn.exec(t))?(i="-"===s[1]?-1:1,o={y:En(s[2],i),M:En(s[3],i),w:En(s[4],i),d:En(s[5],i),h:En(s[6],i),m:En(s[7],i),s:En(s[8],i)}):null==o?o={}:"object"==typeof o&&("from"in o||"to"in o)&&(r=An($i(o.from),$i(o.to)),(o={}).ms=r.milliseconds,o.M=r.months),n=new an(o),ln(t)&&l(t,"_locale")&&(n._locale=t._locale),ln(t)&&l(t,"_isValid")&&(n._isValid=t._isValid),n}function En(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Pn(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function An(t,e){var i;return t.isValid()&&e.isValid()?(e=fn(e,t),t.isBefore(e)?i=Pn(t,e):((i=Pn(e,t)).milliseconds=-i.milliseconds,i.months=-i.months),i):{milliseconds:0,months:0}}function In(t,e){return function(i,n){var r;return null===n||isNaN(+n)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=i,i=n,n=r),Ln(this,On(i,n),t),this}}function Ln(t,e,i,n){var o=e._milliseconds,s=hn(e._days),a=hn(e._months);t.isValid()&&(n=null==n||n,a&&ue(t,pt(t,"Month")+a*i),s&&ft(t,"Date",pt(t,"Date")+s*i),o&&t._d.setTime(t._d.valueOf()+o*i),n&&r.updateOffset(t,s||a))}On.fn=an.prototype,On.invalid=sn;var Nn=In(1,"add"),Rn=In(-1,"subtract");function Fn(t){return"string"==typeof t||t instanceof String}function jn(t){return D(t)||c(t)||Fn(t)||d(t)||Hn(t)||Yn(t)||null==t}function Yn(t){var e,i,n=a(t)&&!h(t),r=!1,o=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"],s=o.length;for(e=0;e<s;e+=1)i=o[e],r=r||l(t,i);return n&&r}function Hn(t){var e=s(t),i=!1;return e&&(i=0===t.filter((function(e){return!d(e)&&Fn(t)})).length),e&&i}function zn(t){var e,i,n=a(t)&&!h(t),r=!1,o=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<o.length;e+=1)i=o[e],r=r||l(t,i);return n&&r}function Bn(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"}function Gn(t,e){1===arguments.length&&(arguments[0]?jn(arguments[0])?(t=arguments[0],e=void 0):zn(arguments[0])&&(e=arguments[0],t=void 0):(t=void 0,e=void 0));var i=t||$i(),n=fn(i,this).startOf("day"),o=r.calendarFormat(this,n)||"sameElse",s=e&&(E(e[o])?e[o].call(this,i):e[o]);return this.format(s||this.localeData().calendar(o,this,$i(i)))}function Wn(){return new x(this)}function Vn(t,e){var i=D(t)?t:$i(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=rt(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())}function Un(t,e){var i=D(t)?t:$i(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=rt(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())}function Xn(t,e,i,n){var r=D(t)?t:$i(t),o=D(e)?e:$i(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(n=n||"()")[0]?this.isAfter(r,i):!this.isBefore(r,i))&&(")"===n[1]?this.isBefore(o,i):!this.isAfter(o,i))}function qn(t,e){var i,n=D(t)?t:$i(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=rt(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))}function $n(t,e){return this.isSame(t,e)||this.isAfter(t,e)}function Zn(t,e){return this.isSame(t,e)||this.isBefore(t,e)}function Kn(t,e,i){var n,r,o;if(!this.isValid())return NaN;if(!(n=fn(t,this)).isValid())return NaN;switch(r=6e4*(n.utcOffset()-this.utcOffset()),e=rt(e)){case"year":o=Jn(this,n)/12;break;case"month":o=Jn(this,n);break;case"quarter":o=Jn(this,n)/3;break;case"second":o=(this-n)/1e3;break;case"minute":o=(this-n)/6e4;break;case"hour":o=(this-n)/36e5;break;case"day":o=(this-n-r)/864e5;break;case"week":o=(this-n-r)/6048e5;break;default:o=this-n}return i?o:ut(o)}function Jn(t,e){if(t.date()<e.date())return-Jn(e,t);var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function Qn(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")}function tr(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?W(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):E(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",W(i,"Z")):W(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")}function er(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,i,n,r="moment",o="";return this.isLocal()||(r=0===this.utcOffset()?"moment.utc":"moment.parseZone",o="Z"),t="["+r+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i="-MM-DD[T]HH:mm:ss.SSS",n=o+'[")]',this.format(t+e+i+n)}function ir(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=W(this,t);return this.localeData().postformat(e)}function nr(t,e){return this.isValid()&&(D(t)&&t.isValid()||$i(t).isValid())?On({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function rr(t){return this.from($i(),t)}function or(t,e){return this.isValid()&&(D(t)&&t.isValid()||$i(t).isValid())?On({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function sr(t){return this.to($i(),t)}function ar(t){var e;return void 0===t?this._locale._abbr:(null!=(e=yi(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var lr=C("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function hr(){return this._locale}var ur=1e3,dr=60*ur,cr=60*dr,pr=3506328*cr;function fr(t,e){return(t%e+e)%e}function mr(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-pr:new Date(t,e,i).valueOf()}function vr(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-pr:Date.UTC(t,e,i)}function gr(t){var e,i;if(void 0===(t=rt(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?vr:mr,t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=fr(e+(this._isUTC?0:this.utcOffset()*dr),cr);break;case"minute":e=this._d.valueOf(),e-=fr(e,dr);break;case"second":e=this._d.valueOf(),e-=fr(e,ur)}return this._d.setTime(e),r.updateOffset(this,!0),this}function yr(t){var e,i;if(void 0===(t=rt(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?vr:mr,t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=cr-fr(e+(this._isUTC?0:this.utcOffset()*dr),cr)-1;break;case"minute":e=this._d.valueOf(),e+=dr-fr(e,dr)-1;break;case"second":e=this._d.valueOf(),e+=ur-fr(e,ur)-1}return this._d.setTime(e),r.updateOffset(this,!0),this}function br(){return this._d.valueOf()-6e4*(this._offset||0)}function _r(){return Math.floor(this.valueOf()/1e3)}function wr(){return new Date(this.valueOf())}function kr(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]}function xr(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}}function Dr(){return this.isValid()?this.toISOString():null}function Sr(){return y(this)}function Cr(){return f({},g(this))}function Tr(){return g(this).overflow}function Mr(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}}function Or(t,e){var i,n,o,s=this._eras||yi("en")._eras;for(i=0,n=s.length;i<n;++i)switch("string"==typeof s[i].since&&(o=r(s[i].since).startOf("day"),s[i].since=o.valueOf()),typeof s[i].until){case"undefined":s[i].until=1/0;break;case"string":o=r(s[i].until).startOf("day").valueOf(),s[i].until=o.valueOf()}return s}function Er(t,e,i){var n,r,o,s,a,l=this.eras();for(t=t.toUpperCase(),n=0,r=l.length;n<r;++n)if(o=l[n].name.toUpperCase(),s=l[n].abbr.toUpperCase(),a=l[n].narrow.toUpperCase(),i)switch(e){case"N":case"NN":case"NNN":if(s===t)return l[n];break;case"NNNN":if(o===t)return l[n];break;case"NNNNN":if(a===t)return l[n]}else if([o,s,a].indexOf(t)>=0)return l[n]}function Pr(t,e){var i=t.since<=t.until?1:-1;return void 0===e?r(t.since).year():r(t.since).year()+(e-t.offset)*i}function Ar(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].name;if(n[t].until<=i&&i<=n[t].since)return n[t].name}return""}function Ir(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].narrow;if(n[t].until<=i&&i<=n[t].since)return n[t].narrow}return""}function Lr(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].abbr;if(n[t].until<=i&&i<=n[t].since)return n[t].abbr}return""}function Nr(){var t,e,i,n,o=this.localeData().eras();for(t=0,e=o.length;t<e;++t)if(i=o[t].since<=o[t].until?1:-1,n=this.clone().startOf("day").valueOf(),o[t].since<=n&&n<=o[t].until||o[t].until<=n&&n<=o[t].since)return(this.year()-r(o[t].since).year())*i+o[t].offset;return this.year()}function Rr(t){return l(this,"_erasNameRegex")||Gr.call(this),t?this._erasNameRegex:this._erasRegex}function Fr(t){return l(this,"_erasAbbrRegex")||Gr.call(this),t?this._erasAbbrRegex:this._erasRegex}function jr(t){return l(this,"_erasNarrowRegex")||Gr.call(this),t?this._erasNarrowRegex:this._erasRegex}function Yr(t,e){return e.erasAbbrRegex(t)}function Hr(t,e){return e.erasNameRegex(t)}function zr(t,e){return e.erasNarrowRegex(t)}function Br(t,e){return e._eraYearOrdinalRegex||Ot}function Gr(){var t,e,i=[],n=[],r=[],o=[],s=this.eras();for(t=0,e=s.length;t<e;++t)n.push(jt(s[t].name)),i.push(jt(s[t].abbr)),r.push(jt(s[t].narrow)),o.push(jt(s[t].name)),o.push(jt(s[t].abbr)),o.push(jt(s[t].narrow));this._erasRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+n.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+i.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+r.join("|")+")","i")}function Wr(t,e){z(0,[t,t.length],0,e)}function Vr(t){return Kr.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)}function Ur(t){return Kr.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)}function Xr(){return De(this.year(),1,4)}function qr(){return De(this.isoWeekYear(),1,4)}function $r(){var t=this.localeData()._week;return De(this.year(),t.dow,t.doy)}function Zr(){var t=this.localeData()._week;return De(this.weekYear(),t.dow,t.doy)}function Kr(t,e,i,n,r){var o;return null==t?xe(this,n,r).year:(e>(o=De(t,n,r))&&(e=o),Jr.call(this,t,e,i,n,r))}function Jr(t,e,i,n,r){var o=ke(t,e,i,n,r),s=_e(o.year,0,o.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}function Qr(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)}z("N",0,0,"eraAbbr"),z("NN",0,0,"eraAbbr"),z("NNN",0,0,"eraAbbr"),z("NNNN",0,0,"eraName"),z("NNNNN",0,0,"eraNarrow"),z("y",["y",1],"yo","eraYear"),z("y",["yy",2],0,"eraYear"),z("y",["yyy",3],0,"eraYear"),z("y",["yyyy",4],0,"eraYear"),Nt("N",Yr),Nt("NN",Yr),Nt("NNN",Yr),Nt("NNNN",Hr),Nt("NNNNN",zr),Ht(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,i,n){var r=i._locale.erasParse(t,n,i._strict);r?g(i).era=r:g(i).invalidEra=t})),Nt("y",Ot),Nt("yy",Ot),Nt("yyy",Ot),Nt("yyyy",Ot),Nt("yo",Br),Ht(["y","yy","yyy","yyyy"],Wt),Ht(["yo"],(function(t,e,i,n){var r;i._locale._eraYearOrdinalRegex&&(r=t.match(i._locale._eraYearOrdinalRegex)),i._locale.eraYearOrdinalParse?e[Wt]=i._locale.eraYearOrdinalParse(t,r):e[Wt]=parseInt(t,10)})),z(0,["gg",2],0,(function(){return this.weekYear()%100})),z(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),Wr("gggg","weekYear"),Wr("ggggg","weekYear"),Wr("GGGG","isoWeekYear"),Wr("GGGGG","isoWeekYear"),nt("weekYear","gg"),nt("isoWeekYear","GG"),at("weekYear",1),at("isoWeekYear",1),Nt("G",Et),Nt("g",Et),Nt("GG",xt,bt),Nt("gg",xt,bt),Nt("GGGG",Tt,wt),Nt("gggg",Tt,wt),Nt("GGGGG",Mt,kt),Nt("ggggg",Mt,kt),zt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=dt(t)})),zt(["gg","GG"],(function(t,e,i,n){e[n]=r.parseTwoDigitYear(t)})),z("Q",0,"Qo","quarter"),nt("quarter","Q"),at("quarter",7),Nt("Q",yt),Ht("Q",(function(t,e){e[Vt]=3*(dt(t)-1)})),z("D",["DD",2],"Do","date"),nt("date","D"),at("date",9),Nt("D",xt),Nt("DD",xt,bt),Nt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),Ht(["D","DD"],Ut),Ht("Do",(function(t,e){e[Ut]=dt(t.match(xt)[0])}));var to=ct("Date",!0);function eo(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")}z("DDD",["DDDD",3],"DDDo","dayOfYear"),nt("dayOfYear","DDD"),at("dayOfYear",4),Nt("DDD",Ct),Nt("DDDD",_t),Ht(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=dt(t)})),z("m",["mm",2],0,"minute"),nt("minute","m"),at("minute",14),Nt("m",xt),Nt("mm",xt,bt),Ht(["m","mm"],qt);var io=ct("Minutes",!1);z("s",["ss",2],0,"second"),nt("second","s"),at("second",15),Nt("s",xt),Nt("ss",xt,bt),Ht(["s","ss"],$t);var no,ro,oo=ct("Seconds",!1);for(z("S",0,0,(function(){return~~(this.millisecond()/100)})),z(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),z(0,["SSS",3],0,"millisecond"),z(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),z(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),z(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),z(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),z(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),z(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),nt("millisecond","ms"),at("millisecond",16),Nt("S",Ct,yt),Nt("SS",Ct,bt),Nt("SSS",Ct,_t),no="SSSS";no.length<=9;no+="S")Nt(no,Ot);function so(t,e){e[Zt]=dt(1e3*("0."+t))}for(no="S";no.length<=9;no+="S")Ht(no,so);function ao(){return this._isUTC?"UTC":""}function lo(){return this._isUTC?"Coordinated Universal Time":""}ro=ct("Milliseconds",!1),z("z",0,0,"zoneAbbr"),z("zz",0,0,"zoneName");var ho=x.prototype;function uo(t){return $i(1e3*t)}function co(){return $i.apply(null,arguments).parseZone()}function po(t){return t}ho.add=Nn,ho.calendar=Gn,ho.clone=Wn,ho.diff=Kn,ho.endOf=yr,ho.format=ir,ho.from=nr,ho.fromNow=rr,ho.to=or,ho.toNow=sr,ho.get=mt,ho.invalidAt=Tr,ho.isAfter=Vn,ho.isBefore=Un,ho.isBetween=Xn,ho.isSame=qn,ho.isSameOrAfter=$n,ho.isSameOrBefore=Zn,ho.isValid=Sr,ho.lang=lr,ho.locale=ar,ho.localeData=hr,ho.max=Ki,ho.min=Zi,ho.parsingFlags=Cr,ho.set=vt,ho.startOf=gr,ho.subtract=Rn,ho.toArray=kr,ho.toObject=xr,ho.toDate=wr,ho.toISOString=tr,ho.inspect=er,"undefined"!=typeof Symbol&&null!=Symbol.for&&(ho[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),ho.toJSON=Dr,ho.toString=Qn,ho.unix=_r,ho.valueOf=br,ho.creationData=Mr,ho.eraName=Ar,ho.eraNarrow=Ir,ho.eraAbbr=Lr,ho.eraYear=Nr,ho.year=ge,ho.isLeapYear=ye,ho.weekYear=Vr,ho.isoWeekYear=Ur,ho.quarter=ho.quarters=Qr,ho.month=de,ho.daysInMonth=ce,ho.week=ho.weeks=Oe,ho.isoWeek=ho.isoWeeks=Ee,ho.weeksInYear=$r,ho.weeksInWeekYear=Zr,ho.isoWeeksInYear=Xr,ho.isoWeeksInISOWeekYear=qr,ho.date=to,ho.day=ho.days=Ve,ho.weekday=Ue,ho.isoWeekday=Xe,ho.dayOfYear=eo,ho.hour=ho.hours=ri,ho.minute=ho.minutes=io,ho.second=ho.seconds=oo,ho.millisecond=ho.milliseconds=ro,ho.utcOffset=vn,ho.utc=yn,ho.local=bn,ho.parseZone=_n,ho.hasAlignedHourOffset=wn,ho.isDST=kn,ho.isLocal=Dn,ho.isUtcOffset=Sn,ho.isUtc=Cn,ho.isUTC=Cn,ho.zoneAbbr=ao,ho.zoneName=lo,ho.dates=C("dates accessor is deprecated. Use date instead.",to),ho.months=C("months accessor is deprecated. Use month instead",de),ho.years=C("years accessor is deprecated. Use year instead",ge),ho.zone=C("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",gn),ho.isDSTShifted=C("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",xn);var fo=I.prototype;function mo(t,e,i,n){var r=yi(),o=m().set(n,e);return r[i](o,t)}function vo(t,e,i){if(d(t)&&(e=t,t=void 0),t=t||"",null!=e)return mo(t,e,i,"month");var n,r=[];for(n=0;n<12;n++)r[n]=mo(t,n,i,"month");return r}function go(t,e,i,n){"boolean"==typeof t?(d(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,d(e)&&(i=e,e=void 0),e=e||"");var r,o=yi(),s=t?o._week.dow:0,a=[];if(null!=i)return mo(e,(i+s)%7,n,"day");for(r=0;r<7;r++)a[r]=mo(e,(r+s)%7,n,"day");return a}function yo(t,e){return vo(t,e,"months")}function bo(t,e){return vo(t,e,"monthsShort")}function _o(t,e,i){return go(t,e,i,"weekdays")}function wo(t,e,i){return go(t,e,i,"weekdaysShort")}function ko(t,e,i){return go(t,e,i,"weekdaysMin")}fo.calendar=N,fo.longDateFormat=X,fo.invalidDate=$,fo.ordinal=J,fo.preparse=po,fo.postformat=po,fo.relativeTime=tt,fo.pastFuture=et,fo.set=P,fo.eras=Or,fo.erasParse=Er,fo.erasConvertYear=Pr,fo.erasAbbrRegex=Fr,fo.erasNameRegex=Rr,fo.erasNarrowRegex=jr,fo.months=se,fo.monthsShort=ae,fo.monthsParse=he,fo.monthsRegex=fe,fo.monthsShortRegex=pe,fo.week=Se,fo.firstDayOfYear=Me,fo.firstDayOfWeek=Te,fo.weekdays=He,fo.weekdaysMin=Be,fo.weekdaysShort=ze,fo.weekdaysParse=We,fo.weekdaysRegex=qe,fo.weekdaysShortRegex=$e,fo.weekdaysMinRegex=Ze,fo.isPM=ii,fo.meridiem=oi,mi("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===dt(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=C("moment.lang is deprecated. Use moment.locale instead.",mi),r.langData=C("moment.langData is deprecated. Use moment.localeData instead.",yi);var xo=Math.abs;function Do(){var t=this._data;return this._milliseconds=xo(this._milliseconds),this._days=xo(this._days),this._months=xo(this._months),t.milliseconds=xo(t.milliseconds),t.seconds=xo(t.seconds),t.minutes=xo(t.minutes),t.hours=xo(t.hours),t.months=xo(t.months),t.years=xo(t.years),this}function So(t,e,i,n){var r=On(e,i);return t._milliseconds+=n*r._milliseconds,t._days+=n*r._days,t._months+=n*r._months,t._bubble()}function Co(t,e){return So(this,t,e,1)}function To(t,e){return So(this,t,e,-1)}function Mo(t){return t<0?Math.floor(t):Math.ceil(t)}function Oo(){var t,e,i,n,r,o=this._milliseconds,s=this._days,a=this._months,l=this._data;return o>=0&&s>=0&&a>=0||o<=0&&s<=0&&a<=0||(o+=864e5*Mo(Po(a)+s),s=0,a=0),l.milliseconds=o%1e3,t=ut(o/1e3),l.seconds=t%60,e=ut(t/60),l.minutes=e%60,i=ut(e/60),l.hours=i%24,s+=ut(i/24),a+=r=ut(Eo(s)),s-=Mo(Po(r)),n=ut(a/12),a%=12,l.days=s,l.months=a,l.years=n,this}function Eo(t){return 4800*t/146097}function Po(t){return 146097*t/4800}function Ao(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=rt(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Eo(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Po(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}}function Io(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*dt(this._months/12):NaN}function Lo(t){return function(){return this.as(t)}}var No=Lo("ms"),Ro=Lo("s"),Fo=Lo("m"),jo=Lo("h"),Yo=Lo("d"),Ho=Lo("w"),zo=Lo("M"),Bo=Lo("Q"),Go=Lo("y");function Wo(){return On(this)}function Vo(t){return t=rt(t),this.isValid()?this[t+"s"]():NaN}function Uo(t){return function(){return this.isValid()?this._data[t]:NaN}}var Xo=Uo("milliseconds"),qo=Uo("seconds"),$o=Uo("minutes"),Zo=Uo("hours"),Ko=Uo("days"),Jo=Uo("months"),Qo=Uo("years");function ts(){return ut(this.days()/7)}var es=Math.round,is={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function ns(t,e,i,n,r){return r.relativeTime(e||1,!!i,t,n)}function rs(t,e,i,n){var r=On(t).abs(),o=es(r.as("s")),s=es(r.as("m")),a=es(r.as("h")),l=es(r.as("d")),h=es(r.as("M")),u=es(r.as("w")),d=es(r.as("y")),c=o<=i.ss&&["s",o]||o<i.s&&["ss",o]||s<=1&&["m"]||s<i.m&&["mm",s]||a<=1&&["h"]||a<i.h&&["hh",a]||l<=1&&["d"]||l<i.d&&["dd",l];return null!=i.w&&(c=c||u<=1&&["w"]||u<i.w&&["ww",u]),(c=c||h<=1&&["M"]||h<i.M&&["MM",h]||d<=1&&["y"]||["yy",d])[2]=e,c[3]=+t>0,c[4]=n,ns.apply(null,c)}function os(t){return void 0===t?es:"function"==typeof t&&(es=t,!0)}function ss(t,e){return void 0!==is[t]&&(void 0===e?is[t]:(is[t]=e,"s"===t&&(is.ss=e-1),!0))}function as(t,e){if(!this.isValid())return this.localeData().invalidDate();var i,n,r=!1,o=is;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(r=t),"object"==typeof e&&(o=Object.assign({},is,e),null!=e.s&&null==e.ss&&(o.ss=e.s-1)),n=rs(this,!r,o,i=this.localeData()),r&&(n=i.pastFuture(+this,n)),i.postformat(n)}var ls=Math.abs;function hs(t){return(t>0)-(t<0)||+t}function us(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i,n,r,o,s,a,l=ls(this._milliseconds)/1e3,h=ls(this._days),u=ls(this._months),d=this.asSeconds();return d?(t=ut(l/60),e=ut(t/60),l%=60,t%=60,i=ut(u/12),u%=12,n=l?l.toFixed(3).replace(/\.?0+$/,""):"",r=d<0?"-":"",o=hs(this._months)!==hs(d)?"-":"",s=hs(this._days)!==hs(d)?"-":"",a=hs(this._milliseconds)!==hs(d)?"-":"",r+"P"+(i?o+i+"Y":"")+(u?o+u+"M":"")+(h?s+h+"D":"")+(e||t||l?"T":"")+(e?a+e+"H":"")+(t?a+t+"M":"")+(l?a+n+"S":"")):"P0D"}var ds=an.prototype;return ds.isValid=on,ds.abs=Do,ds.add=Co,ds.subtract=To,ds.as=Ao,ds.asMilliseconds=No,ds.asSeconds=Ro,ds.asMinutes=Fo,ds.asHours=jo,ds.asDays=Yo,ds.asWeeks=Ho,ds.asMonths=zo,ds.asQuarters=Bo,ds.asYears=Go,ds.valueOf=Io,ds._bubble=Oo,ds.clone=Wo,ds.get=Vo,ds.milliseconds=Xo,ds.seconds=qo,ds.minutes=$o,ds.hours=Zo,ds.days=Ko,ds.weeks=ts,ds.months=Jo,ds.years=Qo,ds.humanize=as,ds.toISOString=us,ds.toString=us,ds.toJSON=us,ds.locale=ar,ds.localeData=hr,ds.toIsoString=C("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",us),ds.lang=lr,z("X",0,0,"unix"),z("x",0,0,"valueOf"),Nt("x",Et),Nt("X",It),Ht("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t))})),Ht("x",(function(t,e,i){i._d=new Date(dt(t))})),
//! moment.js
r.version="2.29.4",o($i),r.fn=ho,r.min=Qi,r.max=tn,r.now=en,r.utc=m,r.unix=uo,r.months=yo,r.isDate=c,r.locale=mi,r.invalid=b,r.duration=On,r.isMoment=D,r.weekdays=_o,r.parseZone=co,r.localeData=yi,r.isDuration=ln,r.monthsShort=bo,r.weekdaysMin=ko,r.defineLocale=vi,r.updateLocale=gi,r.locales=bi,r.weekdaysShort=wo,r.normalizeUnits=rt,r.relativeTimeRounding=os,r.relativeTimeThreshold=ss,r.calendarFormat=Bn,r.prototype=ho,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()),s;var t}o=function(t){
//! moment.js locale configuration
function e(t,e,i,n){var r={m:["eine Minute","einer Minute"],h:["eine Stunde","einer Stunde"],d:["ein Tag","einem Tag"],dd:[t+" Tage",t+" Tagen"],w:["eine Woche","einer Woche"],M:["ein Monat","einem Monat"],MM:[t+" Monate",t+" Monaten"],y:["ein Jahr","einem Jahr"],yy:[t+" Jahre",t+" Jahren"]};return e?r[i][0]:r[i][1]}return t.defineLocale("de",{months:"Januar_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember".split("_"),monthsShort:"Jan._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.".split("_"),monthsParseExact:!0,weekdays:"Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag".split("_"),weekdaysShort:"So._Mo._Di._Mi._Do._Fr._Sa.".split("_"),weekdaysMin:"So_Mo_Di_Mi_Do_Fr_Sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D. MMMM YYYY",LLL:"D. MMMM YYYY HH:mm",LLLL:"dddd, D. MMMM YYYY HH:mm"},calendar:{sameDay:"[heute um] LT [Uhr]",sameElse:"L",nextDay:"[morgen um] LT [Uhr]",nextWeek:"dddd [um] LT [Uhr]",lastDay:"[gestern um] LT [Uhr]",lastWeek:"[letzten] dddd [um] LT [Uhr]"},relativeTime:{future:"in %s",past:"vor %s",s:"ein paar Sekunden",ss:"%d Sekunden",m:e,mm:"%d Minuten",h:e,hh:"%d Stunden",d:e,dd:e,w:e,ww:"%d Wochen",M:e,MM:e,y:e,yy:e},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})},o(l()),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e="ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.".split("_"),i="ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic".split("_"),n=[/^ene/i,/^feb/i,/^mar/i,/^abr/i,/^may/i,/^jun/i,/^jul/i,/^ago/i,/^sep/i,/^oct/i,/^nov/i,/^dic/i],r=/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;return t.defineLocale("es",{months:"enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,monthsShortStrictRegex:/^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"domingo_lunes_martes_miércoles_jueves_viernes_sábado".split("_"),weekdaysShort:"dom._lun._mar._mié._jue._vie._sáb.".split("_"),weekdaysMin:"do_lu_ma_mi_ju_vi_sá".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD/MM/YYYY",LL:"D [de] MMMM [de] YYYY",LLL:"D [de] MMMM [de] YYYY H:mm",LLLL:"dddd, D [de] MMMM [de] YYYY H:mm"},calendar:{sameDay:function(){return"[hoy a la"+(1!==this.hours()?"s":"")+"] LT"},nextDay:function(){return"[mañana a la"+(1!==this.hours()?"s":"")+"] LT"},nextWeek:function(){return"dddd [a la"+(1!==this.hours()?"s":"")+"] LT"},lastDay:function(){return"[ayer a la"+(1!==this.hours()?"s":"")+"] LT"},lastWeek:function(){return"[el] dddd [pasado a la"+(1!==this.hours()?"s":"")+"] LT"},sameElse:"L"},relativeTime:{future:"en %s",past:"hace %s",s:"unos segundos",ss:"%d segundos",m:"un minuto",mm:"%d minutos",h:"una hora",hh:"%d horas",d:"un día",dd:"%d días",w:"una semana",ww:"%d semanas",M:"un mes",MM:"%d meses",y:"un año",yy:"%d años"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4},invalidDate:"Fecha inválida"})})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e=/(janv\.?|févr\.?|mars|avr\.?|mai|juin|juil\.?|août|sept\.?|oct\.?|nov\.?|déc\.?|janvier|février|mars|avril|mai|juin|juillet|août|septembre|octobre|novembre|décembre)/i,i=[/^janv/i,/^févr/i,/^mars/i,/^avr/i,/^mai/i,/^juin/i,/^juil/i,/^août/i,/^sept/i,/^oct/i,/^nov/i,/^déc/i],n=t.defineLocale("fr",{months:"janvier_février_mars_avril_mai_juin_juillet_août_septembre_octobre_novembre_décembre".split("_"),monthsShort:"janv._févr._mars_avr._mai_juin_juil._août_sept._oct._nov._déc.".split("_"),monthsRegex:e,monthsShortRegex:e,monthsStrictRegex:/^(janvier|février|mars|avril|mai|juin|juillet|août|septembre|octobre|novembre|décembre)/i,monthsShortStrictRegex:/(janv\.?|févr\.?|mars|avr\.?|mai|juin|juil\.?|août|sept\.?|oct\.?|nov\.?|déc\.?)/i,monthsParse:i,longMonthsParse:i,shortMonthsParse:i,weekdays:"dimanche_lundi_mardi_mercredi_jeudi_vendredi_samedi".split("_"),weekdaysShort:"dim._lun._mar._mer._jeu._ven._sam.".split("_"),weekdaysMin:"di_lu_ma_me_je_ve_sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[Aujourd’hui à] LT",nextDay:"[Demain à] LT",nextWeek:"dddd [à] LT",lastDay:"[Hier à] LT",lastWeek:"dddd [dernier à] LT",sameElse:"L"},relativeTime:{future:"dans %s",past:"il y a %s",s:"quelques secondes",ss:"%d secondes",m:"une minute",mm:"%d minutes",h:"une heure",hh:"%d heures",d:"un jour",dd:"%d jours",w:"une semaine",ww:"%d semaines",M:"un mois",MM:"%d mois",y:"un an",yy:"%d ans"},dayOfMonthOrdinalParse:/\d{1,2}(er|)/,ordinal:function(t,e){switch(e){case"D":return t+(1===t?"er":"");default:case"M":case"Q":case"DDD":case"d":return t+(1===t?"er":"e");case"w":case"W":return t+(1===t?"re":"e")}},week:{dow:1,doy:4}});return n})),function(t,e){e(l())}(0,(function(t){return t.defineLocale("it",{months:"gennaio_febbraio_marzo_aprile_maggio_giugno_luglio_agosto_settembre_ottobre_novembre_dicembre".split("_"),monthsShort:"gen_feb_mar_apr_mag_giu_lug_ago_set_ott_nov_dic".split("_"),weekdays:"domenica_lunedì_martedì_mercoledì_giovedì_venerdì_sabato".split("_"),weekdaysShort:"dom_lun_mar_mer_gio_ven_sab".split("_"),weekdaysMin:"do_lu_ma_me_gi_ve_sa".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:function(){return"[Oggi a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},nextDay:function(){return"[Domani a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},nextWeek:function(){return"dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},lastDay:function(){return"[Ieri a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},lastWeek:function(){return 0===this.day()?"[La scorsa] dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT":"[Lo scorso] dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},sameElse:"L"},relativeTime:{future:"tra %s",past:"%s fa",s:"alcuni secondi",ss:"%d secondi",m:"un minuto",mm:"%d minuti",h:"un'ora",hh:"%d ore",d:"un giorno",dd:"%d giorni",w:"una settimana",ww:"%d settimane",M:"un mese",MM:"%d mesi",y:"un anno",yy:"%d anni"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4}})})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e=t.defineLocale("ja",{eras:[{since:"2019-05-01",offset:1,name:"令和",narrow:"㋿",abbr:"R"},{since:"1989-01-08",until:"2019-04-30",offset:1,name:"平成",narrow:"㍻",abbr:"H"},{since:"1926-12-25",until:"1989-01-07",offset:1,name:"昭和",narrow:"㍼",abbr:"S"},{since:"1912-07-30",until:"1926-12-24",offset:1,name:"大正",narrow:"㍽",abbr:"T"},{since:"1873-01-01",until:"1912-07-29",offset:6,name:"明治",narrow:"㍾",abbr:"M"},{since:"0001-01-01",until:"1873-12-31",offset:1,name:"西暦",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"紀元前",narrow:"BC",abbr:"BC"}],eraYearOrdinalRegex:/(元|\d+)年/,eraYearOrdinalParse:function(t,e){return"元"===e[1]?1:parseInt(e[1]||t,10)},months:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),monthsShort:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),weekdays:"日曜日_月曜日_火曜日_水曜日_木曜日_金曜日_土曜日".split("_"),weekdaysShort:"日_月_火_水_木_金_土".split("_"),weekdaysMin:"日_月_火_水_木_金_土".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"YYYY/MM/DD",LL:"YYYY年M月D日",LLL:"YYYY年M月D日 HH:mm",LLLL:"YYYY年M月D日 dddd HH:mm",l:"YYYY/MM/DD",ll:"YYYY年M月D日",lll:"YYYY年M月D日 HH:mm",llll:"YYYY年M月D日(ddd) HH:mm"},meridiemParse:/午前|午後/i,isPM:function(t){return"午後"===t},meridiem:function(t,e,i){return t<12?"午前":"午後"},calendar:{sameDay:"[今日] LT",nextDay:"[明日] LT",nextWeek:function(t){return t.week()!==this.week()?"[来週]dddd LT":"dddd LT"},lastDay:"[昨日] LT",lastWeek:function(t){return this.week()!==t.week()?"[先週]dddd LT":"dddd LT"},sameElse:"L"},dayOfMonthOrdinalParse:/\d{1,2}日/,ordinal:function(t,e){switch(e){case"y":return 1===t?"元年":t+"年";case"d":case"D":case"DDD":return t+"日";default:return t}},relativeTime:{future:"%s後",past:"%s前",s:"数秒",ss:"%d秒",m:"1分",mm:"%d分",h:"1時間",hh:"%d時間",d:"1日",dd:"%d日",M:"1ヶ月",MM:"%dヶ月",y:"1年",yy:"%d年"}});return e})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e="jan._feb._mrt._apr._mei_jun._jul._aug._sep._okt._nov._dec.".split("_"),i="jan_feb_mrt_apr_mei_jun_jul_aug_sep_okt_nov_dec".split("_"),n=[/^jan/i,/^feb/i,/^maart|mrt.?$/i,/^apr/i,/^mei$/i,/^jun[i.]?$/i,/^jul[i.]?$/i,/^aug/i,/^sep/i,/^okt/i,/^nov/i,/^dec/i],r=/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december|jan\.?|feb\.?|mrt\.?|apr\.?|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,o=t.defineLocale("nl",{months:"januari_februari_maart_april_mei_juni_juli_augustus_september_oktober_november_december".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december)/i,monthsShortStrictRegex:/^(jan\.?|feb\.?|mrt\.?|apr\.?|mei|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"zondag_maandag_dinsdag_woensdag_donderdag_vrijdag_zaterdag".split("_"),weekdaysShort:"zo._ma._di._wo._do._vr._za.".split("_"),weekdaysMin:"zo_ma_di_wo_do_vr_za".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD-MM-YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[vandaag om] LT",nextDay:"[morgen om] LT",nextWeek:"dddd [om] LT",lastDay:"[gisteren om] LT",lastWeek:"[afgelopen] dddd [om] LT",sameElse:"L"},relativeTime:{future:"over %s",past:"%s geleden",s:"een paar seconden",ss:"%d seconden",m:"één minuut",mm:"%d minuten",h:"één uur",hh:"%d uur",d:"één dag",dd:"%d dagen",w:"één week",ww:"%d weken",M:"één maand",MM:"%d maanden",y:"één jaar",yy:"%d jaar"},dayOfMonthOrdinalParse:/\d{1,2}(ste|de)/,ordinal:function(t){return t+(1===t||8===t||t>=20?"ste":"de")},week:{dow:1,doy:4}});return o})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e="styczeń_luty_marzec_kwiecień_maj_czerwiec_lipiec_sierpień_wrzesień_październik_listopad_grudzień".split("_"),i="stycznia_lutego_marca_kwietnia_maja_czerwca_lipca_sierpnia_września_października_listopada_grudnia".split("_"),n=[/^sty/i,/^lut/i,/^mar/i,/^kwi/i,/^maj/i,/^cze/i,/^lip/i,/^sie/i,/^wrz/i,/^paź/i,/^lis/i,/^gru/i];function r(t){return t%10<5&&t%10>1&&~~(t/10)%10!=1}function o(t,e,i){var n=t+" ";switch(i){case"ss":return n+(r(t)?"sekundy":"sekund");case"m":return e?"minuta":"minutę";case"mm":return n+(r(t)?"minuty":"minut");case"h":return e?"godzina":"godzinę";case"hh":return n+(r(t)?"godziny":"godzin");case"ww":return n+(r(t)?"tygodnie":"tygodni");case"MM":return n+(r(t)?"miesiące":"miesięcy");case"yy":return n+(r(t)?"lata":"lat")}}return t.defineLocale("pl",{months:function(t,n){return t?/D MMMM/.test(n)?i[t.month()]:e[t.month()]:e},monthsShort:"sty_lut_mar_kwi_maj_cze_lip_sie_wrz_paź_lis_gru".split("_"),monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"niedziela_poniedziałek_wtorek_środa_czwartek_piątek_sobota".split("_"),weekdaysShort:"ndz_pon_wt_śr_czw_pt_sob".split("_"),weekdaysMin:"Nd_Pn_Wt_Śr_Cz_Pt_So".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd, D MMMM YYYY HH:mm"},calendar:{sameDay:"[Dziś o] LT",nextDay:"[Jutro o] LT",nextWeek:function(){switch(this.day()){case 0:return"[W niedzielę o] LT";case 2:return"[We wtorek o] LT";case 3:return"[W środę o] LT";case 6:return"[W sobotę o] LT";default:return"[W] dddd [o] LT"}},lastDay:"[Wczoraj o] LT",lastWeek:function(){switch(this.day()){case 0:return"[W zeszłą niedzielę o] LT";case 3:return"[W zeszłą środę o] LT";case 6:return"[W zeszłą sobotę o] LT";default:return"[W zeszły] dddd [o] LT"}},sameElse:"L"},relativeTime:{future:"za %s",past:"%s temu",s:"kilka sekund",ss:o,m:o,mm:o,h:o,hh:o,d:"1 dzień",dd:"%d dni",w:"tydzień",ww:o,M:"miesiąc",MM:o,y:"rok",yy:o},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})})),function(t,e){e(l())}(0,(function(t){function e(t,e,i){var n,r;return"m"===i?e?"минута":"минуту":t+" "+(n=+t,r={ss:e?"секунда_секунды_секунд":"секунду_секунды_секунд",mm:e?"минута_минуты_минут":"минуту_минуты_минут",hh:"час_часа_часов",dd:"день_дня_дней",ww:"неделя_недели_недель",MM:"месяц_месяца_месяцев",yy:"год_года_лет"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}var i=[/^янв/i,/^фев/i,/^мар/i,/^апр/i,/^ма[йя]/i,/^июн/i,/^июл/i,/^авг/i,/^сен/i,/^окт/i,/^ноя/i,/^дек/i],n=t.defineLocale("ru",{months:{format:"января_февраля_марта_апреля_мая_июня_июля_августа_сентября_октября_ноября_декабря".split("_"),standalone:"январь_февраль_март_апрель_май_июнь_июль_август_сентябрь_октябрь_ноябрь_декабрь".split("_")},monthsShort:{format:"янв._февр._мар._апр._мая_июня_июля_авг._сент._окт._нояб._дек.".split("_"),standalone:"янв._февр._март_апр._май_июнь_июль_авг._сент._окт._нояб._дек.".split("_")},weekdays:{standalone:"воскресенье_понедельник_вторник_среда_четверг_пятница_суббота".split("_"),format:"воскресенье_понедельник_вторник_среду_четверг_пятницу_субботу".split("_"),isFormat:/\[ ?[Вв] ?(?:прошлую|следующую|эту)? ?] ?dddd/},weekdaysShort:"вс_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"вс_пн_вт_ср_чт_пт_сб".split("_"),monthsParse:i,longMonthsParse:i,shortMonthsParse:i,monthsRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsShortRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsStrictRegex:/^(январ[яь]|феврал[яь]|марта?|апрел[яь]|ма[яй]|июн[яь]|июл[яь]|августа?|сентябр[яь]|октябр[яь]|ноябр[яь]|декабр[яь])/i,monthsShortStrictRegex:/^(янв\.|февр?\.|мар[т.]|апр\.|ма[яй]|июн[ья.]|июл[ья.]|авг\.|сент?\.|окт\.|нояб?\.|дек\.)/i,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY г.",LLL:"D MMMM YYYY г., H:mm",LLLL:"dddd, D MMMM YYYY г., H:mm"},calendar:{sameDay:"[Сегодня, в] LT",nextDay:"[Завтра, в] LT",lastDay:"[Вчера, в] LT",nextWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В следующее] dddd, [в] LT";case 1:case 2:case 4:return"[В следующий] dddd, [в] LT";case 3:case 5:case 6:return"[В следующую] dddd, [в] LT"}},lastWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В прошлое] dddd, [в] LT";case 1:case 2:case 4:return"[В прошлый] dddd, [в] LT";case 3:case 5:case 6:return"[В прошлую] dddd, [в] LT"}},sameElse:"L"},relativeTime:{future:"через %s",past:"%s назад",s:"несколько секунд",ss:e,m:e,mm:e,h:"час",hh:e,d:"день",dd:e,w:"неделя",ww:e,M:"месяц",MM:e,y:"год",yy:e},meridiemParse:/ночи|утра|дня|вечера/i,isPM:function(t){return/^(дня|вечера)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночи":t<12?"утра":t<17?"дня":"вечера"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го|я)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":return t+"-й";case"D":return t+"-го";case"w":case"W":return t+"-я";default:return t}},week:{dow:1,doy:4}});return n})),function(t,e){e(l())}(0,(function(t){function e(t,e,i){var n,r;return"m"===i?e?"хвилина":"хвилину":"h"===i?e?"година":"годину":t+" "+(n=+t,r={ss:e?"секунда_секунди_секунд":"секунду_секунди_секунд",mm:e?"хвилина_хвилини_хвилин":"хвилину_хвилини_хвилин",hh:e?"година_години_годин":"годину_години_годин",dd:"день_дні_днів",MM:"місяць_місяці_місяців",yy:"рік_роки_років"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}function i(t){return function(){return t+"о"+(11===this.hours()?"б":"")+"] LT"}}var n=t.defineLocale("uk",{months:{format:"січня_лютого_березня_квітня_травня_червня_липня_серпня_вересня_жовтня_листопада_грудня".split("_"),standalone:"січень_лютий_березень_квітень_травень_червень_липень_серпень_вересень_жовтень_листопад_грудень".split("_")},monthsShort:"січ_лют_бер_квіт_трав_черв_лип_серп_вер_жовт_лист_груд".split("_"),weekdays:function(t,e){var i={nominative:"неділя_понеділок_вівторок_середа_четвер_п’ятниця_субота".split("_"),accusative:"неділю_понеділок_вівторок_середу_четвер_п’ятницю_суботу".split("_"),genitive:"неділі_понеділка_вівторка_середи_четверга_п’ятниці_суботи".split("_")};return!0===t?i.nominative.slice(1,7).concat(i.nominative.slice(0,1)):t?i[/(\[[ВвУу]\]) ?dddd/.test(e)?"accusative":/\[?(?:минулої|наступної)? ?\] ?dddd/.test(e)?"genitive":"nominative"][t.day()]:i.nominative},weekdaysShort:"нд_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"нд_пн_вт_ср_чт_пт_сб".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY р.",LLL:"D MMMM YYYY р., HH:mm",LLLL:"dddd, D MMMM YYYY р., HH:mm"},calendar:{sameDay:i("[Сьогодні "),nextDay:i("[Завтра "),lastDay:i("[Вчора "),nextWeek:i("[У] dddd ["),lastWeek:function(){switch(this.day()){case 0:case 3:case 5:case 6:return i("[Минулої] dddd [").call(this);case 1:case 2:case 4:return i("[Минулого] dddd [").call(this)}},sameElse:"L"},relativeTime:{future:"за %s",past:"%s тому",s:"декілька секунд",ss:e,m:e,mm:e,h:"годину",hh:e,d:"день",dd:e,M:"місяць",MM:e,y:"рік",yy:e},meridiemParse:/ночі|ранку|дня|вечора/,isPM:function(t){return/^(дня|вечора)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночі":t<12?"ранку":t<17?"дня":"вечора"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":case"w":case"W":return t+"-й";case"D":return t+"-го";default:return t}},week:{dow:1,doy:7}});return n}));var h={},u={get exports(){return h},set exports(t){h=t}},d=function(t){try{return!!t()}catch(t){return!0}},c=!d((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),p=c,f=Function.prototype,m=f.call,v=p&&f.bind.bind(m,m),g=p?v:function(t){return function(){return m.apply(t,arguments)}},y=Math.ceil,b=Math.floor,_=Math.trunc||function(t){var e=+t;return(e>0?b:y)(e)},w=function(t){var e=+t;return e!=e||0===e?0:_(e)},k=function(t){return t&&t.Math==Math&&t},x=k("object"==typeof globalThis&&globalThis)||k("object"==typeof window&&window)||k("object"==typeof self&&self)||k("object"==typeof t&&t)||function(){return this}()||Function("return this")(),D={},S={get exports(){return D},set exports(t){D=t}},C=x,T=Object.defineProperty,M=function(t,e){try{T(C,t,{value:e,configurable:!0,writable:!0})}catch(i){C[t]=e}return e},O="__core-js_shared__",E=x[O]||M(O,{}),P=E;(S.exports=function(t,e){return P[t]||(P[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var A,I,L=function(t){return null==t},N=L,R=TypeError,F=function(t){if(N(t))throw R("Can't call method on "+t);return t},j=F,Y=Object,H=function(t){return Y(j(t))},z=H,B=g({}.hasOwnProperty),G=Object.hasOwn||function(t,e){return B(z(t),e)},W=g,V=0,U=Math.random(),X=W(1..toString),q=function(t){return"Symbol("+(void 0===t?"":t)+")_"+X(++V+U,36)},$="undefined"!=typeof navigator&&String(navigator.userAgent)||"",Z=x,K=$,J=Z.process,Q=Z.Deno,tt=J&&J.versions||Q&&Q.version,et=tt&&tt.v8;et&&(I=(A=et.split("."))[0]>0&&A[0]<4?1:+(A[0]+A[1])),!I&&K&&(!(A=K.match(/Edge\/(\d+)/))||A[1]>=74)&&(A=K.match(/Chrome\/(\d+)/))&&(I=+A[1]);var it=I,nt=it,rt=d,ot=!!Object.getOwnPropertySymbols&&!rt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&nt&&nt<41})),st=ot&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,at=D,lt=G,ht=q,ut=ot,dt=st,ct=x.Symbol,pt=at("wks"),ft=dt?ct.for||ct:ct&&ct.withoutSetter||ht,mt=function(t){return lt(pt,t)||(pt[t]=ut&&lt(ct,t)?ct[t]:ft("Symbol."+t)),pt[t]},vt={};vt[mt("toStringTag")]="z";var gt="[object z]"===String(vt),yt="object"==typeof document&&document.all,bt={all:yt,IS_HTMLDDA:void 0===yt&&void 0!==yt},_t=bt.all,wt=bt.IS_HTMLDDA?function(t){return"function"==typeof t||t===_t}:function(t){return"function"==typeof t},kt=g,xt=kt({}.toString),Dt=kt("".slice),St=function(t){return Dt(xt(t),8,-1)},Ct=gt,Tt=wt,Mt=St,Ot=mt("toStringTag"),Et=Object,Pt="Arguments"==Mt(function(){return arguments}()),At=Ct?Mt:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Et(t),Ot))?i:Pt?Mt(e):"Object"==(n=Mt(e))&&Tt(e.callee)?"Arguments":n},It=At,Lt=String,Nt=function(t){if("Symbol"===It(t))throw TypeError("Cannot convert a Symbol value to a string");return Lt(t)},Rt=g,Ft=w,jt=Nt,Yt=F,Ht=Rt("".charAt),zt=Rt("".charCodeAt),Bt=Rt("".slice),Gt=function(t){return function(e,i){var n,r,o=jt(Yt(e)),s=Ft(i),a=o.length;return s<0||s>=a?t?"":void 0:(n=zt(o,s))<55296||n>56319||s+1===a||(r=zt(o,s+1))<56320||r>57343?t?Ht(o,s):n:t?Bt(o,s,s+2):r-56320+(n-55296<<10)+65536}},Wt={codeAt:Gt(!1),charAt:Gt(!0)},Vt=wt,Ut=x.WeakMap,Xt=Vt(Ut)&&/native code/.test(String(Ut)),qt=wt,$t=bt.all,Zt=bt.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:qt(t)||t===$t}:function(t){return"object"==typeof t?null!==t:qt(t)},Kt=!d((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),Jt={},Qt=Zt,te=x.document,ee=Qt(te)&&Qt(te.createElement),ie=function(t){return ee?te.createElement(t):{}},ne=ie,re=!Kt&&!d((function(){return 7!=Object.defineProperty(ne("div"),"a",{get:function(){return 7}}).a})),oe=Kt&&d((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),se=Zt,ae=String,le=TypeError,he=function(t){if(se(t))return t;throw le(ae(t)+" is not an object")},ue=c,de=Function.prototype.call,ce=ue?de.bind(de):function(){return de.apply(de,arguments)},pe={},fe=pe,me=x,ve=wt,ge=function(t){return ve(t)?t:void 0},ye=function(t,e){return arguments.length<2?ge(fe[t])||ge(me[t]):fe[t]&&fe[t][e]||me[t]&&me[t][e]},be=g({}.isPrototypeOf),_e=ye,we=wt,ke=be,xe=Object,De=st?function(t){return"symbol"==typeof t}:function(t){var e=_e("Symbol");return we(e)&&ke(e.prototype,xe(t))},Se=String,Ce=function(t){try{return Se(t)}catch(t){return"Object"}},Te=wt,Me=Ce,Oe=TypeError,Ee=function(t){if(Te(t))return t;throw Oe(Me(t)+" is not a function")},Pe=Ee,Ae=L,Ie=function(t,e){var i=t[e];return Ae(i)?void 0:Pe(i)},Le=ce,Ne=wt,Re=Zt,Fe=TypeError,je=ce,Ye=Zt,He=De,ze=Ie,Be=function(t,e){var i,n;if("string"===e&&Ne(i=t.toString)&&!Re(n=Le(i,t)))return n;if(Ne(i=t.valueOf)&&!Re(n=Le(i,t)))return n;if("string"!==e&&Ne(i=t.toString)&&!Re(n=Le(i,t)))return n;throw Fe("Can't convert object to primitive value")},Ge=TypeError,We=mt("toPrimitive"),Ve=function(t,e){if(!Ye(t)||He(t))return t;var i,n=ze(t,We);if(n){if(void 0===e&&(e="default"),i=je(n,t,e),!Ye(i)||He(i))return i;throw Ge("Can't convert object to primitive value")}return void 0===e&&(e="number"),Be(t,e)},Ue=De,Xe=function(t){var e=Ve(t,"string");return Ue(e)?e:e+""},qe=Kt,$e=re,Ze=oe,Ke=he,Je=Xe,Qe=TypeError,ti=Object.defineProperty,ei=Object.getOwnPropertyDescriptor,ii="enumerable",ni="configurable",ri="writable";Jt.f=qe?Ze?function(t,e,i){if(Ke(t),e=Je(e),Ke(i),"function"==typeof t&&"prototype"===e&&"value"in i&&ri in i&&!i[ri]){var n=ei(t,e);n&&n[ri]&&(t[e]=i.value,i={configurable:ni in i?i[ni]:n[ni],enumerable:ii in i?i[ii]:n[ii],writable:!1})}return ti(t,e,i)}:ti:function(t,e,i){if(Ke(t),e=Je(e),Ke(i),$e)try{return ti(t,e,i)}catch(t){}if("get"in i||"set"in i)throw Qe("Accessors not supported");return"value"in i&&(t[e]=i.value),t};var oi,si,ai,li=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},hi=Jt,ui=li,di=Kt?function(t,e,i){return hi.f(t,e,ui(1,i))}:function(t,e,i){return t[e]=i,t},ci=q,pi=D("keys"),fi=function(t){return pi[t]||(pi[t]=ci(t))},mi={},vi=Xt,gi=x,yi=Zt,bi=di,_i=G,wi=E,ki=fi,xi=mi,Di="Object already initialized",Si=gi.TypeError,Ci=gi.WeakMap;if(vi||wi.state){var Ti=wi.state||(wi.state=new Ci);Ti.get=Ti.get,Ti.has=Ti.has,Ti.set=Ti.set,oi=function(t,e){if(Ti.has(t))throw Si(Di);return e.facade=t,Ti.set(t,e),e},si=function(t){return Ti.get(t)||{}},ai=function(t){return Ti.has(t)}}else{var Mi=ki("state");xi[Mi]=!0,oi=function(t,e){if(_i(t,Mi))throw Si(Di);return e.facade=t,bi(t,Mi,e),e},si=function(t){return _i(t,Mi)?t[Mi]:{}},ai=function(t){return _i(t,Mi)}}var Oi={set:oi,get:si,has:ai,enforce:function(t){return ai(t)?si(t):oi(t,{})},getterFor:function(t){return function(e){var i;if(!yi(e)||(i=si(e)).type!==t)throw Si("Incompatible receiver, "+t+" required");return i}}},Ei=c,Pi=Function.prototype,Ai=Pi.apply,Ii=Pi.call,Li="object"==typeof Reflect&&Reflect.apply||(Ei?Ii.bind(Ai):function(){return Ii.apply(Ai,arguments)}),Ni=St,Ri=g,Fi=function(t){if("Function"===Ni(t))return Ri(t)},ji={},Yi={},Hi={}.propertyIsEnumerable,zi=Object.getOwnPropertyDescriptor,Bi=zi&&!Hi.call({1:2},1);Yi.f=Bi?function(t){var e=zi(this,t);return!!e&&e.enumerable}:Hi;var Gi=d,Wi=St,Vi=Object,Ui=g("".split),Xi=Gi((function(){return!Vi("z").propertyIsEnumerable(0)}))?function(t){return"String"==Wi(t)?Ui(t,""):Vi(t)}:Vi,qi=Xi,$i=F,Zi=function(t){return qi($i(t))},Ki=Kt,Ji=ce,Qi=Yi,tn=li,en=Zi,nn=Xe,rn=G,on=re,sn=Object.getOwnPropertyDescriptor;ji.f=Ki?sn:function(t,e){if(t=en(t),e=nn(e),on)try{return sn(t,e)}catch(t){}if(rn(t,e))return tn(!Ji(Qi.f,t,e),t[e])};var an=d,ln=wt,hn=/#|\.prototype\./,un=function(t,e){var i=cn[dn(t)];return i==fn||i!=pn&&(ln(e)?an(e):!!e)},dn=un.normalize=function(t){return String(t).replace(hn,".").toLowerCase()},cn=un.data={},pn=un.NATIVE="N",fn=un.POLYFILL="P",mn=un,vn=Ee,gn=c,yn=Fi(Fi.bind),bn=function(t,e){return vn(t),void 0===e?t:gn?yn(t,e):function(){return t.apply(e,arguments)}},_n=x,wn=Li,kn=Fi,xn=wt,Dn=ji.f,Sn=mn,Cn=pe,Tn=bn,Mn=di,On=G,En=function(t){var e=function(i,n,r){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(i);case 2:return new t(i,n)}return new t(i,n,r)}return wn(t,this,arguments)};return e.prototype=t.prototype,e},Pn=function(t,e){var i,n,r,o,s,a,l,h,u,d=t.target,c=t.global,p=t.stat,f=t.proto,m=c?_n:p?_n[d]:(_n[d]||{}).prototype,v=c?Cn:Cn[d]||Mn(Cn,d,{})[d],g=v.prototype;for(o in e)n=!(i=Sn(c?o:d+(p?".":"#")+o,t.forced))&&m&&On(m,o),a=v[o],n&&(l=t.dontCallGetSet?(u=Dn(m,o))&&u.value:m[o]),s=n&&l?l:e[o],n&&typeof a==typeof s||(h=t.bind&&n?Tn(s,_n):t.wrap&&n?En(s):f&&xn(s)?kn(s):s,(t.sham||s&&s.sham||a&&a.sham)&&Mn(h,"sham",!0),Mn(v,o,h),f&&(On(Cn,r=d+"Prototype")||Mn(Cn,r,{}),Mn(Cn[r],o,s),t.real&&g&&(i||!g[o])&&Mn(g,o,s)))},An=Kt,In=G,Ln=Function.prototype,Nn=An&&Object.getOwnPropertyDescriptor,Rn=In(Ln,"name"),Fn={EXISTS:Rn,PROPER:Rn&&"something"===function(){}.name,CONFIGURABLE:Rn&&(!An||An&&Nn(Ln,"name").configurable)},jn={},Yn=w,Hn=Math.max,zn=Math.min,Bn=function(t,e){var i=Yn(t);return i<0?Hn(i+e,0):zn(i,e)},Gn=w,Wn=Math.min,Vn=function(t){return t>0?Wn(Gn(t),9007199254740991):0},Un=function(t){return Vn(t.length)},Xn=Zi,qn=Bn,$n=Un,Zn=function(t){return function(e,i,n){var r,o=Xn(e),s=$n(o),a=qn(n,s);if(t&&i!=i){for(;s>a;)if((r=o[a++])!=r)return!0}else for(;s>a;a++)if((t||a in o)&&o[a]===i)return t||a||0;return!t&&-1}},Kn={includes:Zn(!0),indexOf:Zn(!1)},Jn=G,Qn=Zi,tr=Kn.indexOf,er=mi,ir=g([].push),nr=function(t,e){var i,n=Qn(t),r=0,o=[];for(i in n)!Jn(er,i)&&Jn(n,i)&&ir(o,i);for(;e.length>r;)Jn(n,i=e[r++])&&(~tr(o,i)||ir(o,i));return o},rr=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],or=nr,sr=rr,ar=Object.keys||function(t){return or(t,sr)},lr=Kt,hr=oe,ur=Jt,dr=he,cr=Zi,pr=ar;jn.f=lr&&!hr?Object.defineProperties:function(t,e){dr(t);for(var i,n=cr(e),r=pr(e),o=r.length,s=0;o>s;)ur.f(t,i=r[s++],n[i]);return t};var fr,mr=ye("document","documentElement"),vr=he,gr=jn,yr=rr,br=mi,_r=mr,wr=ie,kr="prototype",xr="script",Dr=fi("IE_PROTO"),Sr=function(){},Cr=function(t){return"<"+xr+">"+t+"</"+xr+">"},Tr=function(t){t.write(Cr("")),t.close();var e=t.parentWindow.Object;return t=null,e},Mr=function(){try{fr=new ActiveXObject("htmlfile")}catch(t){}var t,e,i;Mr="undefined"!=typeof document?document.domain&&fr?Tr(fr):(e=wr("iframe"),i="java"+xr+":",e.style.display="none",_r.appendChild(e),e.src=String(i),(t=e.contentWindow.document).open(),t.write(Cr("document.F=Object")),t.close(),t.F):Tr(fr);for(var n=yr.length;n--;)delete Mr[kr][yr[n]];return Mr()};br[Dr]=!0;var Or,Er,Pr,Ar=Object.create||function(t,e){var i;return null!==t?(Sr[kr]=vr(t),i=new Sr,Sr[kr]=null,i[Dr]=t):i=Mr(),void 0===e?i:gr.f(i,e)},Ir=!d((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Lr=G,Nr=wt,Rr=H,Fr=Ir,jr=fi("IE_PROTO"),Yr=Object,Hr=Yr.prototype,zr=Fr?Yr.getPrototypeOf:function(t){var e=Rr(t);if(Lr(e,jr))return e[jr];var i=e.constructor;return Nr(i)&&e instanceof i?i.prototype:e instanceof Yr?Hr:null},Br=di,Gr=function(t,e,i,n){return n&&n.enumerable?t[e]=i:Br(t,e,i),t},Wr=d,Vr=wt,Ur=Zt,Xr=Ar,qr=zr,$r=Gr,Zr=mt("iterator"),Kr=!1;[].keys&&("next"in(Pr=[].keys())?(Er=qr(qr(Pr)))!==Object.prototype&&(Or=Er):Kr=!0);var Jr=!Ur(Or)||Wr((function(){var t={};return Or[Zr].call(t)!==t}));Vr((Or=Jr?{}:Xr(Or))[Zr])||$r(Or,Zr,(function(){return this}));var Qr={IteratorPrototype:Or,BUGGY_SAFARI_ITERATORS:Kr},to=At,eo=gt?{}.toString:function(){return"[object "+to(this)+"]"},io=gt,no=Jt.f,ro=di,oo=G,so=eo,ao=mt("toStringTag"),lo=function(t,e,i,n){if(t){var r=i?t:t.prototype;oo(r,ao)||no(r,ao,{configurable:!0,value:e}),n&&!io&&ro(r,"toString",so)}},ho={},uo=Qr.IteratorPrototype,co=Ar,po=li,fo=lo,mo=ho,vo=function(){return this},go=g,yo=Ee,bo=wt,_o=String,wo=TypeError,ko=function(t,e,i){try{return go(yo(Object.getOwnPropertyDescriptor(t,e)[i]))}catch(t){}},xo=he,Do=function(t){if("object"==typeof t||bo(t))return t;throw wo("Can't set "+_o(t)+" as a prototype")},So=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=ko(Object.prototype,"__proto__","set"))(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return xo(i),Do(n),e?t(i,n):i.__proto__=n,i}}():void 0),Co=Pn,To=ce,Mo=function(t,e,i,n){var r=e+" Iterator";return t.prototype=co(uo,{next:po(+!n,i)}),fo(t,r,!1,!0),mo[r]=vo,t},Oo=zr,Eo=lo,Po=Gr,Ao=ho,Io=Fn.PROPER,Lo=Qr.BUGGY_SAFARI_ITERATORS,No=mt("iterator"),Ro="keys",Fo="values",jo="entries",Yo=function(){return this},Ho=function(t,e,i,n,r,o,s){Mo(i,e,n);var a,l,h,u=function(t){if(t===r&&m)return m;if(!Lo&&t in p)return p[t];switch(t){case Ro:case Fo:case jo:return function(){return new i(this,t)}}return function(){return new i(this)}},d=e+" Iterator",c=!1,p=t.prototype,f=p[No]||p["@@iterator"]||r&&p[r],m=!Lo&&f||u(r),v="Array"==e&&p.entries||f;if(v&&(a=Oo(v.call(new t)))!==Object.prototype&&a.next&&(Eo(a,d,!0,!0),Ao[d]=Yo),Io&&r==Fo&&f&&f.name!==Fo&&(c=!0,m=function(){return To(f,this)}),r)if(l={values:u(Fo),keys:o?m:u(Ro),entries:u(jo)},s)for(h in l)(Lo||c||!(h in p))&&Po(p,h,l[h]);else Co({target:e,proto:!0,forced:Lo||c},l);return s&&p[No]!==m&&Po(p,No,m,{name:r}),Ao[e]=m,l},zo=function(t,e){return{value:t,done:e}},Bo=Wt.charAt,Go=Nt,Wo=Oi,Vo=Ho,Uo=zo,Xo="String Iterator",qo=Wo.set,$o=Wo.getterFor(Xo);Vo(String,"String",(function(t){qo(this,{type:Xo,string:Go(t),index:0})}),(function(){var t,e=$o(this),i=e.string,n=e.index;return n>=i.length?Uo(void 0,!0):(t=Bo(i,n),e.index+=t.length,Uo(t,!1))}));var Zo=ce,Ko=he,Jo=Ie,Qo=function(t,e,i){var n,r;Ko(t);try{if(!(n=Jo(t,"return"))){if("throw"===e)throw i;return i}n=Zo(n,t)}catch(t){r=!0,n=t}if("throw"===e)throw i;if(r)throw n;return Ko(n),i},ts=he,es=Qo,is=ho,ns=mt("iterator"),rs=Array.prototype,os=function(t){return void 0!==t&&(is.Array===t||rs[ns]===t)},ss=wt,as=E,ls=g(Function.toString);ss(as.inspectSource)||(as.inspectSource=function(t){return ls(t)});var hs=as.inspectSource,us=g,ds=d,cs=wt,ps=At,fs=hs,ms=function(){},vs=[],gs=ye("Reflect","construct"),ys=/^\s*(?:class|function)\b/,bs=us(ys.exec),_s=!ys.exec(ms),ws=function(t){if(!cs(t))return!1;try{return gs(ms,vs,t),!0}catch(t){return!1}},ks=function(t){if(!cs(t))return!1;switch(ps(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return _s||!!bs(ys,fs(t))}catch(t){return!0}};ks.sham=!0;var xs=!gs||ds((function(){var t;return ws(ws.call)||!ws(Object)||!ws((function(){t=!0}))||t}))?ks:ws,Ds=Xe,Ss=Jt,Cs=li,Ts=function(t,e,i){var n=Ds(e);n in t?Ss.f(t,n,Cs(0,i)):t[n]=i},Ms=At,Os=Ie,Es=L,Ps=ho,As=mt("iterator"),Is=function(t){if(!Es(t))return Os(t,As)||Os(t,"@@iterator")||Ps[Ms(t)]},Ls=ce,Ns=Ee,Rs=he,Fs=Ce,js=Is,Ys=TypeError,Hs=function(t,e){var i=arguments.length<2?js(t):e;if(Ns(i))return Rs(Ls(i,t));throw Ys(Fs(t)+" is not iterable")},zs=bn,Bs=ce,Gs=H,Ws=function(t,e,i,n){try{return n?e(ts(i)[0],i[1]):e(i)}catch(e){es(t,"throw",e)}},Vs=os,Us=xs,Xs=Un,qs=Ts,$s=Hs,Zs=Is,Ks=Array,Js=mt("iterator"),Qs=!1;try{var ta=0,ea={next:function(){return{done:!!ta++}},return:function(){Qs=!0}};ea[Js]=function(){return this},Array.from(ea,(function(){throw 2}))}catch(t){}var ia=function(t,e){if(!e&&!Qs)return!1;var i=!1;try{var n={};n[Js]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i},na=function(t){var e=Gs(t),i=Us(this),n=arguments.length,r=n>1?arguments[1]:void 0,o=void 0!==r;o&&(r=zs(r,n>2?arguments[2]:void 0));var s,a,l,h,u,d,c=Zs(e),p=0;if(!c||this===Ks&&Vs(c))for(s=Xs(e),a=i?new this(s):Ks(s);s>p;p++)d=o?r(e[p],p):e[p],qs(a,p,d);else for(u=(h=$s(e,c)).next,a=i?new this:[];!(l=Bs(u,h)).done;p++)d=o?Ws(h,r,[l.value,p],!0):l.value,qs(a,p,d);return a.length=p,a};Pn({target:"Array",stat:!0,forced:!ia((function(t){Array.from(t)}))},{from:na});var ra=pe.Array.from;u.exports=ra;var oa=e(h),sa={},aa={get exports(){return sa},set exports(t){sa=t}},la={},ha={get exports(){return la},set exports(t){la=t}},ua=Zi,da=ho,ca=Oi;Jt.f;var pa=Ho,fa=zo,ma="Array Iterator",va=ca.set,ga=ca.getterFor(ma);pa(Array,"Array",(function(t,e){va(this,{type:ma,target:ua(t),index:0,kind:e})}),(function(){var t=ga(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,fa(void 0,!0)):fa("keys"==i?n:"values"==i?e[n]:[n,e[n]],!1)}),"values"),da.Arguments=da.Array;var ya=Is,ba={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},_a=x,wa=At,ka=di,xa=ho,Da=mt("toStringTag");for(var Sa in ba){var Ca=_a[Sa],Ta=Ca&&Ca.prototype;Ta&&wa(Ta)!==Da&&ka(Ta,Da,Sa),xa[Sa]=xa.Array}var Ma=ya;ha.exports=Ma,aa.exports=la;var Oa=e(sa),Ea={},Pa={get exports(){return Ea},set exports(t){Ea=t}},Aa={},Ia=nr,La=rr.concat("length","prototype");Aa.f=Object.getOwnPropertyNames||function(t){return Ia(t,La)};var Na={},Ra=Bn,Fa=Un,ja=Ts,Ya=Array,Ha=Math.max,za=function(t,e,i){for(var n=Fa(t),r=Ra(e,n),o=Ra(void 0===i?n:i,n),s=Ya(Ha(o-r,0)),a=0;r<o;r++,a++)ja(s,a,t[r]);return s.length=a,s},Ba=St,Ga=Zi,Wa=Aa.f,Va=za,Ua="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Na.f=function(t){return Ua&&"Window"==Ba(t)?function(t){try{return Wa(t)}catch(t){return Va(Ua)}}(t):Wa(Ga(t))};var Xa={};Xa.f=Object.getOwnPropertySymbols;var qa=Jt,$a=function(t,e,i){return qa.f(t,e,i)},Za={},Ka=mt;Za.f=Ka;var Ja=pe,Qa=G,tl=Za,el=Jt.f,il=function(t){var e=Ja.Symbol||(Ja.Symbol={});Qa(e,t)||el(e,t,{value:tl.f(t)})},nl=ce,rl=ye,ol=mt,sl=Gr,al=function(){var t=rl("Symbol"),e=t&&t.prototype,i=e&&e.valueOf,n=ol("toPrimitive");e&&!e[n]&&sl(e,n,(function(t){return nl(i,this)}),{arity:1})},ll=St,hl=Array.isArray||function(t){return"Array"==ll(t)},ul=hl,dl=xs,cl=Zt,pl=mt("species"),fl=Array,ml=function(t){var e;return ul(t)&&(e=t.constructor,(dl(e)&&(e===fl||ul(e.prototype))||cl(e)&&null===(e=e[pl]))&&(e=void 0)),void 0===e?fl:e},vl=function(t,e){return new(ml(t))(0===e?0:e)},gl=bn,yl=Xi,bl=H,_l=Un,wl=vl,kl=g([].push),xl=function(t){var e=1==t,i=2==t,n=3==t,r=4==t,o=6==t,s=7==t,a=5==t||o;return function(l,h,u,d){for(var c,p,f=bl(l),m=yl(f),v=gl(h,u),g=_l(m),y=0,b=d||wl,_=e?b(l,g):i||s?b(l,0):void 0;g>y;y++)if((a||y in m)&&(p=v(c=m[y],y,f),t))if(e)_[y]=p;else if(p)switch(t){case 3:return!0;case 5:return c;case 6:return y;case 2:kl(_,c)}else switch(t){case 4:return!1;case 7:kl(_,c)}return o?-1:n||r?r:_}},Dl={forEach:xl(0),map:xl(1),filter:xl(2),some:xl(3),every:xl(4),find:xl(5),findIndex:xl(6),filterReject:xl(7)},Sl=Pn,Cl=x,Tl=ce,Ml=g,Ol=Kt,El=ot,Pl=d,Al=G,Il=be,Ll=he,Nl=Zi,Rl=Xe,Fl=Nt,jl=li,Yl=Ar,Hl=ar,zl=Aa,Bl=Na,Gl=Xa,Wl=ji,Vl=Jt,Ul=jn,Xl=Yi,ql=Gr,$l=$a,Zl=D,Kl=mi,Jl=q,Ql=mt,th=Za,eh=il,ih=al,nh=lo,rh=Oi,oh=Dl.forEach,sh=fi("hidden"),ah="Symbol",lh="prototype",hh=rh.set,uh=rh.getterFor(ah),dh=Object[lh],ch=Cl.Symbol,ph=ch&&ch[lh],fh=Cl.TypeError,mh=Cl.QObject,vh=Wl.f,gh=Vl.f,yh=Bl.f,bh=Xl.f,_h=Ml([].push),wh=Zl("symbols"),kh=Zl("op-symbols"),xh=Zl("wks"),Dh=!mh||!mh[lh]||!mh[lh].findChild,Sh=Ol&&Pl((function(){return 7!=Yl(gh({},"a",{get:function(){return gh(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=vh(dh,e);n&&delete dh[e],gh(t,e,i),n&&t!==dh&&gh(dh,e,n)}:gh,Ch=function(t,e){var i=wh[t]=Yl(ph);return hh(i,{type:ah,tag:t,description:e}),Ol||(i.description=e),i},Th=function(t,e,i){t===dh&&Th(kh,e,i),Ll(t);var n=Rl(e);return Ll(i),Al(wh,n)?(i.enumerable?(Al(t,sh)&&t[sh][n]&&(t[sh][n]=!1),i=Yl(i,{enumerable:jl(0,!1)})):(Al(t,sh)||gh(t,sh,jl(1,{})),t[sh][n]=!0),Sh(t,n,i)):gh(t,n,i)},Mh=function(t,e){Ll(t);var i=Nl(e),n=Hl(i).concat(Ah(i));return oh(n,(function(e){Ol&&!Tl(Oh,i,e)||Th(t,e,i[e])})),t},Oh=function(t){var e=Rl(t),i=Tl(bh,this,e);return!(this===dh&&Al(wh,e)&&!Al(kh,e))&&(!(i||!Al(this,e)||!Al(wh,e)||Al(this,sh)&&this[sh][e])||i)},Eh=function(t,e){var i=Nl(t),n=Rl(e);if(i!==dh||!Al(wh,n)||Al(kh,n)){var r=vh(i,n);return!r||!Al(wh,n)||Al(i,sh)&&i[sh][n]||(r.enumerable=!0),r}},Ph=function(t){var e=yh(Nl(t)),i=[];return oh(e,(function(t){Al(wh,t)||Al(Kl,t)||_h(i,t)})),i},Ah=function(t){var e=t===dh,i=yh(e?kh:Nl(t)),n=[];return oh(i,(function(t){!Al(wh,t)||e&&!Al(dh,t)||_h(n,wh[t])})),n};El||(ql(ph=(ch=function(){if(Il(ph,this))throw fh("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Fl(arguments[0]):void 0,e=Jl(t),i=function(t){this===dh&&Tl(i,kh,t),Al(this,sh)&&Al(this[sh],e)&&(this[sh][e]=!1),Sh(this,e,jl(1,t))};return Ol&&Dh&&Sh(dh,e,{configurable:!0,set:i}),Ch(e,t)})[lh],"toString",(function(){return uh(this).tag})),ql(ch,"withoutSetter",(function(t){return Ch(Jl(t),t)})),Xl.f=Oh,Vl.f=Th,Ul.f=Mh,Wl.f=Eh,zl.f=Bl.f=Ph,Gl.f=Ah,th.f=function(t){return Ch(Ql(t),t)},Ol&&$l(ph,"description",{configurable:!0,get:function(){return uh(this).description}})),Sl({global:!0,constructor:!0,wrap:!0,forced:!El,sham:!El},{Symbol:ch}),oh(Hl(xh),(function(t){eh(t)})),Sl({target:ah,stat:!0,forced:!El},{useSetter:function(){Dh=!0},useSimple:function(){Dh=!1}}),Sl({target:"Object",stat:!0,forced:!El,sham:!Ol},{create:function(t,e){return void 0===e?Yl(t):Mh(Yl(t),e)},defineProperty:Th,defineProperties:Mh,getOwnPropertyDescriptor:Eh}),Sl({target:"Object",stat:!0,forced:!El},{getOwnPropertyNames:Ph}),ih(),nh(ch,ah),Kl[sh]=!0;var Ih=ot&&!!Symbol.for&&!!Symbol.keyFor,Lh=Pn,Nh=ye,Rh=G,Fh=Nt,jh=D,Yh=Ih,Hh=jh("string-to-symbol-registry"),zh=jh("symbol-to-string-registry");Lh({target:"Symbol",stat:!0,forced:!Yh},{for:function(t){var e=Fh(t);if(Rh(Hh,e))return Hh[e];var i=Nh("Symbol")(e);return Hh[e]=i,zh[i]=e,i}});var Bh=Pn,Gh=G,Wh=De,Vh=Ce,Uh=Ih,Xh=D("symbol-to-string-registry");Bh({target:"Symbol",stat:!0,forced:!Uh},{keyFor:function(t){if(!Wh(t))throw TypeError(Vh(t)+" is not a symbol");if(Gh(Xh,t))return Xh[t]}});var qh=g([].slice),$h=hl,Zh=wt,Kh=St,Jh=Nt,Qh=g([].push),tu=Pn,eu=ye,iu=Li,nu=ce,ru=g,ou=d,su=wt,au=De,lu=qh,hu=function(t){if(Zh(t))return t;if($h(t)){for(var e=t.length,i=[],n=0;n<e;n++){var r=t[n];"string"==typeof r?Qh(i,r):"number"!=typeof r&&"Number"!=Kh(r)&&"String"!=Kh(r)||Qh(i,Jh(r))}var o=i.length,s=!0;return function(t,e){if(s)return s=!1,e;if($h(this))return e;for(var n=0;n<o;n++)if(i[n]===t)return e}}},uu=ot,du=String,cu=eu("JSON","stringify"),pu=ru(/./.exec),fu=ru("".charAt),mu=ru("".charCodeAt),vu=ru("".replace),gu=ru(1..toString),yu=/[\uD800-\uDFFF]/g,bu=/^[\uD800-\uDBFF]$/,_u=/^[\uDC00-\uDFFF]$/,wu=!uu||ou((function(){var t=eu("Symbol")();return"[null]"!=cu([t])||"{}"!=cu({a:t})||"{}"!=cu(Object(t))})),ku=ou((function(){return'"\\udf06\\ud834"'!==cu("\udf06\ud834")||'"\\udead"'!==cu("\udead")})),xu=function(t,e){var i=lu(arguments),n=hu(e);if(su(n)||void 0!==t&&!au(t))return i[1]=function(t,e){if(su(n)&&(e=nu(n,this,du(t),e)),!au(e))return e},iu(cu,null,i)},Du=function(t,e,i){var n=fu(i,e-1),r=fu(i,e+1);return pu(bu,t)&&!pu(_u,r)||pu(_u,t)&&!pu(bu,n)?"\\u"+gu(mu(t,0),16):t};cu&&tu({target:"JSON",stat:!0,arity:3,forced:wu||ku},{stringify:function(t,e,i){var n=lu(arguments),r=iu(wu?xu:cu,null,n);return ku&&"string"==typeof r?vu(r,yu,Du):r}});var Su=Xa,Cu=H;Pn({target:"Object",stat:!0,forced:!ot||d((function(){Su.f(1)}))},{getOwnPropertySymbols:function(t){var e=Su.f;return e?e(Cu(t)):[]}});var Tu=pe.Object.getOwnPropertySymbols;Pa.exports=Tu;var Mu=e(Ea),Ou={},Eu={get exports(){return Ou},set exports(t){Ou=t}},Pu={},Au={get exports(){return Pu},set exports(t){Pu=t}},Iu=Pn,Lu=d,Nu=Zi,Ru=ji.f,Fu=Kt;Iu({target:"Object",stat:!0,forced:!Fu||Lu((function(){Ru(1)})),sham:!Fu},{getOwnPropertyDescriptor:function(t,e){return Ru(Nu(t),e)}});var ju=pe.Object,Yu=Au.exports=function(t,e){return ju.getOwnPropertyDescriptor(t,e)};ju.getOwnPropertyDescriptor.sham&&(Yu.sham=!0);var Hu=Pu;Eu.exports=Hu;var zu=e(Ou),Bu={},Gu={get exports(){return Bu},set exports(t){Bu=t}},Wu=ye,Vu=Aa,Uu=Xa,Xu=he,qu=g([].concat),$u=Wu("Reflect","ownKeys")||function(t){var e=Vu.f(Xu(t)),i=Uu.f;return i?qu(e,i(t)):e},Zu=$u,Ku=Zi,Ju=ji,Qu=Ts;Pn({target:"Object",stat:!0,sham:!Kt},{getOwnPropertyDescriptors:function(t){for(var e,i,n=Ku(t),r=Ju.f,o=Zu(n),s={},a=0;o.length>a;)void 0!==(i=r(n,e=o[a++]))&&Qu(s,e,i);return s}});var td=pe.Object.getOwnPropertyDescriptors;Gu.exports=td;var ed=e(Bu),id={},nd={get exports(){return id},set exports(t){id=t}},rd={},od={get exports(){return rd},set exports(t){rd=t}},sd=Pn,ad=Kt,ld=jn.f;sd({target:"Object",stat:!0,forced:Object.defineProperties!==ld,sham:!ad},{defineProperties:ld});var hd=pe.Object,ud=od.exports=function(t,e){return hd.defineProperties(t,e)};hd.defineProperties.sham&&(ud.sham=!0);var dd=rd;nd.exports=dd;var cd=e(id),pd={},fd={get exports(){return pd},set exports(t){pd=t}},md={},vd={get exports(){return md},set exports(t){md=t}},gd=Pn,yd=Kt,bd=Jt.f;gd({target:"Object",stat:!0,forced:Object.defineProperty!==bd,sham:!yd},{defineProperty:bd});var _d=pe.Object,wd=vd.exports=function(t,e,i){return _d.defineProperty(t,e,i)};_d.defineProperty.sham&&(wd.sham=!0);var kd=md;fd.exports=kd;var xd=e(pd);function Dd(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var Sd={},Cd={get exports(){return Sd},set exports(t){Sd=t}},Td={},Md=kd;({get exports(){return Td},set exports(t){Td=t}}).exports=Md,Cd.exports=Td;var Od=e(Sd),Ed={},Pd={get exports(){return Ed},set exports(t){Ed=t}},Ad={},Id={get exports(){return Ad},set exports(t){Ad=t}},Ld=TypeError,Nd=function(t){if(t>9007199254740991)throw Ld("Maximum allowed index exceeded");return t},Rd=d,Fd=it,jd=mt("species"),Yd=function(t){return Fd>=51||!Rd((function(){var e=[];return(e.constructor={})[jd]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Hd=Pn,zd=d,Bd=hl,Gd=Zt,Wd=H,Vd=Un,Ud=Nd,Xd=Ts,qd=vl,$d=Yd,Zd=it,Kd=mt("isConcatSpreadable"),Jd=Zd>=51||!zd((function(){var t=[];return t[Kd]=!1,t.concat()[0]!==t})),Qd=function(t){if(!Gd(t))return!1;var e=t[Kd];return void 0!==e?!!e:Bd(t)};Hd({target:"Array",proto:!0,arity:1,forced:!Jd||!$d("concat")},{concat:function(t){var e,i,n,r,o,s=Wd(this),a=qd(s,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(Qd(o=-1===e?s:arguments[e]))for(r=Vd(o),Ud(l+r),i=0;i<r;i++,l++)i in o&&Xd(a,l,o[i]);else Ud(l+1),Xd(a,l++,o);return a.length=l,a}}),il("asyncIterator"),il("hasInstance"),il("isConcatSpreadable"),il("iterator"),il("match"),il("matchAll"),il("replace"),il("search"),il("species"),il("split");var tc=al;il("toPrimitive"),tc();var ec=ye,ic=lo;il("toStringTag"),ic(ec("Symbol"),"Symbol"),il("unscopables"),lo(x.JSON,"JSON",!0);var nc=pe.Symbol;il("dispose");var rc=nc;il("asyncDispose");var oc=Pn,sc=g,ac=ye("Symbol"),lc=ac.keyFor,hc=sc(ac.prototype.valueOf);oc({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==lc(hc(t))}catch(t){return!1}}});for(var uc=Pn,dc=D,cc=ye,pc=g,fc=De,mc=mt,vc=cc("Symbol"),gc=vc.isWellKnown,yc=cc("Object","getOwnPropertyNames"),bc=pc(vc.prototype.valueOf),_c=dc("wks"),wc=0,kc=yc(vc),xc=kc.length;wc<xc;wc++)try{var Dc=kc[wc];fc(vc[Dc])&&mc(Dc)}catch(t){}uc({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(gc&&gc(t))return!0;try{for(var e=bc(t),i=0,n=yc(_c),r=n.length;i<r;i++)if(_c[n[i]]==e)return!0}catch(t){}return!1}}),il("matcher"),il("metadataKey"),il("observable"),il("metadata"),il("patternMatch"),il("replaceAll");var Sc=rc;Id.exports=Sc,Pd.exports=Ad;var Cc=e(Ed),Tc={},Mc={get exports(){return Tc},set exports(t){Tc=t}},Oc={},Ec={get exports(){return Oc},set exports(t){Oc=t}},Pc=Za.f("iterator"),Ac=Pc;Ec.exports=Ac,Mc.exports=Oc;var Ic=e(Tc);function Lc(t){return Lc="function"==typeof Cc&&"symbol"==typeof Ic?function(t){return typeof t}:function(t){return t&&"function"==typeof Cc&&t.constructor===Cc&&t!==Cc.prototype?"symbol":typeof t},Lc(t)}var Nc={},Rc={get exports(){return Nc},set exports(t){Nc=t}},Fc={},jc={get exports(){return Fc},set exports(t){Fc=t}},Yc=Za.f("toPrimitive");jc.exports=Yc,Rc.exports=Fc;var Hc=e(Nc);function zc(t){var e=function(t,e){if("object"!==Lc(t)||null===t)return t;var i=t[Hc];if(void 0!==i){var n=i.call(t,e||"default");if("object"!==Lc(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Lc(e)?e:String(e)}function Bc(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Od(t,zc(n.key),n)}}function Gc(t,e,i){return e&&Bc(t.prototype,e),i&&Bc(t,i),Od(t,"prototype",{writable:!1}),t}function Wc(t,e,i){return(e=zc(e))in t?Od(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}var Vc={},Uc={get exports(){return Vc},set exports(t){Vc=t}},Xc={},qc={get exports(){return Xc},set exports(t){Xc=t}};Pn({target:"Array",stat:!0},{isArray:hl});var $c=pe.Array.isArray,Zc=$c;qc.exports=Zc,Uc.exports=Xc;var Kc=e(Vc);var Jc={},Qc={get exports(){return Jc},set exports(t){Jc=t}},tp={},ep={get exports(){return tp},set exports(t){tp=t}},ip=Pn,np=hl,rp=xs,op=Zt,sp=Bn,ap=Un,lp=Zi,hp=Ts,up=mt,dp=qh,cp=Yd("slice"),pp=up("species"),fp=Array,mp=Math.max;ip({target:"Array",proto:!0,forced:!cp},{slice:function(t,e){var i,n,r,o=lp(this),s=ap(o),a=sp(t,s),l=sp(void 0===e?s:e,s);if(np(o)&&(i=o.constructor,(rp(i)&&(i===fp||np(i.prototype))||op(i)&&null===(i=i[pp]))&&(i=void 0),i===fp||void 0===i))return dp(o,a,l);for(n=new(void 0===i?fp:i)(mp(l-a,0)),r=0;a<l;a++,r++)a in o&&hp(n,r,o[a]);return n.length=r,n}});var vp=pe,gp=function(t){return vp[t+"Prototype"]},yp=gp("Array").slice,bp=be,_p=yp,wp=Array.prototype,kp=function(t){var e=t.slice;return t===wp||bp(wp,t)&&e===wp.slice?_p:e},xp=kp,Dp=xp;ep.exports=Dp,Qc.exports=tp;var Sp=e(Jc),Cp={},Tp={get exports(){return Cp},set exports(t){Cp=t}},Mp={},Op=ra;({get exports(){return Mp},set exports(t){Mp=t}}).exports=Op,Tp.exports=Mp;var Ep=e(Cp);function Pp(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Ap(t,e){var i;if(t){if("string"==typeof t)return Pp(t,e);var n=Sp(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Ep(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Pp(t,e):void 0}}function Ip(t,e){return function(t){if(Kc(t))return t}(t)||function(t,e){var i=null==t?null:void 0!==Cc&&Oa(t)||t["@@iterator"];if(null!=i){var n,r,o,s,a=[],l=!0,h=!1;try{if(o=(i=i.call(t)).next,0===e){if(Object(i)!==i)return;l=!1}else for(;!(l=(n=o.call(i)).done)&&(a.push(n.value),a.length!==e);l=!0);}catch(t){h=!0,r=t}finally{try{if(!l&&null!=i.return&&(s=i.return(),Object(s)!==s))return}finally{if(h)throw r}}return a}}(t,e)||Ap(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Lp(t){return function(t){if(Kc(t))return Pp(t)}(t)||function(t){if(void 0!==Cc&&null!=Oa(t)||null!=t["@@iterator"])return Ep(t)}(t)||Ap(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Np={};({get exports(){return Np},set exports(t){Np=t}}).exports=nc;var Rp=e(Np),Fp={},jp={get exports(){return Fp},set exports(t){Fp=t}},Yp=gp("Array").concat,Hp=be,zp=Yp,Bp=Array.prototype,Gp=function(t){var e=t.concat;return t===Bp||Hp(Bp,t)&&e===Bp.concat?zp:e},Wp=Gp;jp.exports=Wp;var Vp=e(Fp),Up={};({get exports(){return Up},set exports(t){Up=t}}).exports=xp;var Xp=e(Up),qp={},$p={get exports(){return qp},set exports(t){qp=t}};Pn({target:"Reflect",stat:!0},{ownKeys:$u});var Zp=pe.Reflect.ownKeys;$p.exports=Zp;var Kp=e(qp),Jp={};({get exports(){return Jp},set exports(t){Jp=t}}).exports=$c;var Qp=e(Jp),tf={},ef={get exports(){return tf},set exports(t){tf=t}},nf=Dl.map;Pn({target:"Array",proto:!0,forced:!Yd("map")},{map:function(t){return nf(this,t,arguments.length>1?arguments[1]:void 0)}});var rf=gp("Array").map,of=be,sf=rf,af=Array.prototype,lf=function(t){var e=t.map;return t===af||of(af,t)&&e===af.map?sf:e},hf=lf;ef.exports=hf;var uf=e(tf),df={},cf={get exports(){return df},set exports(t){df=t}},pf=H,ff=ar;Pn({target:"Object",stat:!0,forced:d((function(){ff(1)}))},{keys:function(t){return ff(pf(t))}});var mf=pe.Object.keys;cf.exports=mf;var vf=e(df),gf={},yf={get exports(){return gf},set exports(t){gf=t}},bf=Pn,_f=Date,wf=g(_f.prototype.getTime);bf({target:"Date",stat:!0},{now:function(){return wf(new _f)}});var kf=pe.Date.now;yf.exports=kf;var xf=e(gf),Df={},Sf={get exports(){return Df},set exports(t){Df=t}},Cf=g,Tf=Ee,Mf=Zt,Of=G,Ef=qh,Pf=c,Af=Function,If=Cf([].concat),Lf=Cf([].join),Nf={},Rf=function(t,e,i){if(!Of(Nf,e)){for(var n=[],r=0;r<e;r++)n[r]="a["+r+"]";Nf[e]=Af("C,a","return new C("+Lf(n,",")+")")}return Nf[e](t,i)},Ff=Pf?Af.bind:function(t){var e=Tf(this),i=e.prototype,n=Ef(arguments,1),r=function(){var i=If(n,Ef(arguments));return this instanceof r?Rf(e,i.length,i):e.apply(t,i)};return Mf(i)&&(r.prototype=i),r},jf=Ff;Pn({target:"Function",proto:!0,forced:Function.bind!==jf},{bind:jf});var Yf=gp("Function").bind,Hf=be,zf=Yf,Bf=Function.prototype,Gf=function(t){var e=t.bind;return t===Bf||Hf(Bf,t)&&e===Bf.bind?zf:e},Wf=Gf;Sf.exports=Wf;var Vf=e(Df),Uf={},Xf={get exports(){return Uf},set exports(t){Uf=t}},qf=d,$f=function(t,e){var i=[][t];return!!i&&qf((function(){i.call(null,e||function(){return 1},1)}))},Zf=Dl.forEach,Kf=$f("forEach")?[].forEach:function(t){return Zf(this,t,arguments.length>1?arguments[1]:void 0)};Pn({target:"Array",proto:!0,forced:[].forEach!=Kf},{forEach:Kf});var Jf=gp("Array").forEach,Qf=At,tm=G,em=be,im=Jf,nm=Array.prototype,rm={DOMTokenList:!0,NodeList:!0},om=function(t){var e=t.forEach;return t===nm||em(nm,t)&&e===nm.forEach||tm(rm,Qf(t))?im:e};Xf.exports=om;var sm=e(Uf),am={},lm={get exports(){return am},set exports(t){am=t}},hm=Pn,um=hl,dm=g([].reverse),cm=[1,2];hm({target:"Array",proto:!0,forced:String(cm)===String(cm.reverse())},{reverse:function(){return um(this)&&(this.length=this.length),dm(this)}});var pm=gp("Array").reverse,fm=be,mm=pm,vm=Array.prototype,gm=function(t){var e=t.reverse;return t===vm||fm(vm,t)&&e===vm.reverse?mm:e},ym=gm;lm.exports=ym;var bm=e(am),_m={},wm={get exports(){return _m},set exports(t){_m=t}},km=Kt,xm=hl,Dm=TypeError,Sm=Object.getOwnPropertyDescriptor,Cm=km&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),Tm=Ce,Mm=TypeError,Om=function(t,e){if(!delete t[e])throw Mm("Cannot delete property "+Tm(e)+" of "+Tm(t))},Em=Pn,Pm=H,Am=Bn,Im=w,Lm=Un,Nm=Cm?function(t,e){if(xm(t)&&!Sm(t,"length").writable)throw Dm("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Rm=Nd,Fm=vl,jm=Ts,Ym=Om,Hm=Yd("splice"),zm=Math.max,Bm=Math.min;Em({target:"Array",proto:!0,forced:!Hm},{splice:function(t,e){var i,n,r,o,s,a,l=Pm(this),h=Lm(l),u=Am(t,h),d=arguments.length;for(0===d?i=n=0:1===d?(i=0,n=h-u):(i=d-2,n=Bm(zm(Im(e),0),h-u)),Rm(h+i-n),r=Fm(l,n),o=0;o<n;o++)(s=u+o)in l&&jm(r,o,l[s]);if(r.length=n,i<n){for(o=u;o<h-n;o++)a=o+i,(s=o+n)in l?l[a]=l[s]:Ym(l,a);for(o=h;o>h-n+i;o--)Ym(l,o-1)}else if(i>n)for(o=h-n;o>u;o--)a=o+i-1,(s=o+n-1)in l?l[a]=l[s]:Ym(l,a);for(o=0;o<i;o++)l[o+u]=arguments[o+2];return Nm(l,h-n+i),r}});var Gm=gp("Array").splice,Wm=be,Vm=Gm,Um=Array.prototype,Xm=function(t){var e=t.splice;return t===Um||Wm(Um,t)&&e===Um.splice?Vm:e},qm=Xm;wm.exports=qm;var $m=e(_m),Zm={},Km={get exports(){return Zm},set exports(t){Zm=t}},Jm=Kt,Qm=g,tv=ce,ev=d,iv=ar,nv=Xa,rv=Yi,ov=H,sv=Xi,av=Object.assign,lv=Object.defineProperty,hv=Qm([].concat),uv=!av||ev((function(){if(Jm&&1!==av({b:1},av(lv({},"a",{enumerable:!0,get:function(){lv(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol(),n="abcdefghijklmnopqrst";return t[i]=7,n.split("").forEach((function(t){e[t]=t})),7!=av({},t)[i]||iv(av({},e)).join("")!=n}))?function(t,e){for(var i=ov(t),n=arguments.length,r=1,o=nv.f,s=rv.f;n>r;)for(var a,l=sv(arguments[r++]),h=o?hv(iv(l),o(l)):iv(l),u=h.length,d=0;u>d;)a=h[d++],Jm&&!tv(s,l,a)||(i[a]=l[a]);return i}:av,dv=uv;Pn({target:"Object",stat:!0,arity:2,forced:Object.assign!==dv},{assign:dv});var cv=pe.Object.assign;Km.exports=cv;var pv=e(Zm),fv={},mv={get exports(){return fv},set exports(t){fv=t}},vv=Kn.includes;Pn({target:"Array",proto:!0,forced:d((function(){return!Array(1).includes()}))},{includes:function(t){return vv(this,t,arguments.length>1?arguments[1]:void 0)}});var gv=gp("Array").includes,yv=Zt,bv=St,_v=mt("match"),wv=function(t){var e;return yv(t)&&(void 0!==(e=t[_v])?!!e:"RegExp"==bv(t))},kv=TypeError,xv=mt("match"),Dv=Pn,Sv=function(t){if(wv(t))throw kv("The method doesn't accept regular expressions");return t},Cv=F,Tv=Nt,Mv=function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[xv]=!1,"/./"[t](e)}catch(t){}}return!1},Ov=g("".indexOf);Dv({target:"String",proto:!0,forced:!Mv("includes")},{includes:function(t){return!!~Ov(Tv(Cv(this)),Tv(Sv(t)),arguments.length>1?arguments[1]:void 0)}});var Ev=gp("String").includes,Pv=be,Av=gv,Iv=Ev,Lv=Array.prototype,Nv=String.prototype,Rv=function(t){var e=t.includes;return t===Lv||Pv(Lv,t)&&e===Lv.includes?Av:"string"==typeof t||t===Nv||Pv(Nv,t)&&e===Nv.includes?Iv:e},Fv=Rv;mv.exports=Fv;var jv=e(fv),Yv={},Hv={get exports(){return Yv},set exports(t){Yv=t}},zv=H,Bv=zr,Gv=Ir;Pn({target:"Object",stat:!0,forced:d((function(){Bv(1)})),sham:!Gv},{getPrototypeOf:function(t){return Bv(zv(t))}});var Wv=pe.Object.getPrototypeOf;Hv.exports=Wv;var Vv=e(Yv),Uv={},Xv={get exports(){return Uv},set exports(t){Uv=t}},qv=Dl.filter;Pn({target:"Array",proto:!0,forced:!Yd("filter")},{filter:function(t){return qv(this,t,arguments.length>1?arguments[1]:void 0)}});var $v=gp("Array").filter,Zv=be,Kv=$v,Jv=Array.prototype,Qv=function(t){var e=t.filter;return t===Jv||Zv(Jv,t)&&e===Jv.filter?Kv:e},tg=Qv;Xv.exports=tg;var eg=e(Uv),ig={},ng={get exports(){return ig},set exports(t){ig=t}},rg=Kt,og=g,sg=ar,ag=Zi,lg=og(Yi.f),hg=og([].push),ug=function(t){return function(e){for(var i,n=ag(e),r=sg(n),o=r.length,s=0,a=[];o>s;)i=r[s++],rg&&!lg(n,i)||hg(a,t?[i,n[i]]:n[i]);return a}},dg={entries:ug(!0),values:ug(!1)}.values;Pn({target:"Object",stat:!0},{values:function(t){return dg(t)}});var cg=pe.Object.values;ng.exports=cg;var pg=e(ig),fg={},mg={get exports(){return fg},set exports(t){fg=t}},vg="\t\n\v\f\r                　\u2028\u2029\ufeff",gg=F,yg=Nt,bg=vg,_g=g("".replace),wg=RegExp("^["+bg+"]+"),kg=RegExp("(^|[^"+bg+"])["+bg+"]+$"),xg=function(t){return function(e){var i=yg(gg(e));return 1&t&&(i=_g(i,wg,"")),2&t&&(i=_g(i,kg,"$1")),i}},Dg={start:xg(1),end:xg(2),trim:xg(3)},Sg=x,Cg=d,Tg=g,Mg=Nt,Og=Dg.trim,Eg=vg,Pg=Sg.parseInt,Ag=Sg.Symbol,Ig=Ag&&Ag.iterator,Lg=/^[+-]?0x/i,Ng=Tg(Lg.exec),Rg=8!==Pg(Eg+"08")||22!==Pg(Eg+"0x16")||Ig&&!Cg((function(){Pg(Object(Ig))}))?function(t,e){var i=Og(Mg(t));return Pg(i,e>>>0||(Ng(Lg,i)?16:10))}:Pg;Pn({global:!0,forced:parseInt!=Rg},{parseInt:Rg});var Fg=pe.parseInt;mg.exports=Fg;var jg=e(fg),Yg={},Hg={get exports(){return Yg},set exports(t){Yg=t}},zg=Pn,Bg=Kn.indexOf,Gg=$f,Wg=Fi([].indexOf),Vg=!!Wg&&1/Wg([1],1,-0)<0;zg({target:"Array",proto:!0,forced:Vg||!Gg("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Vg?Wg(this,t,e)||0:Bg(this,t,e)}});var Ug=gp("Array").indexOf,Xg=be,qg=Ug,$g=Array.prototype,Zg=function(t){var e=t.indexOf;return t===$g||Xg($g,t)&&e===$g.indexOf?qg:e},Kg=Zg;Hg.exports=Kg;var Jg=e(Yg),Qg={},ty={get exports(){return Qg},set exports(t){Qg=t}},ey=Fn.PROPER,iy=d,ny=vg,ry=Dg.trim;Pn({target:"String",proto:!0,forced:function(t){return iy((function(){return!!ny[t]()||"​᠎"!=="​᠎"[t]()||ey&&ny[t].name!==t}))}("trim")},{trim:function(){return ry(this)}});var oy=gp("String").trim,sy=be,ay=oy,ly=String.prototype,hy=function(t){var e=t.trim;return"string"==typeof t||t===ly||sy(ly,t)&&e===ly.trim?ay:e},uy=hy;ty.exports=uy;var dy=e(Qg),cy={},py={get exports(){return cy},set exports(t){cy=t}};Pn({target:"Object",stat:!0,sham:!Kt},{create:Ar});var fy=pe.Object,my=function(t,e){return fy.create(t,e)};py.exports=my;var vy=e(cy),gy={},yy={get exports(){return gy},set exports(t){gy=t}},by=pe,_y=Li;by.JSON||(by.JSON={stringify:JSON.stringify});var wy=function(t,e,i){return _y(by.JSON.stringify,null,arguments)};yy.exports=wy;var ky=e(gy),xy={},Dy={get exports(){return xy},set exports(t){xy=t}},Sy="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,Cy=TypeError,Ty=function(t,e){if(t<e)throw Cy("Not enough arguments");return t},My=x,Oy=Li,Ey=wt,Py=Sy,Ay=$,Iy=qh,Ly=Ty,Ny=My.Function,Ry=/MSIE .\./.test(Ay)||Py&&function(){var t=My.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Fy=function(t,e){var i=e?2:1;return Ry?function(n,r){var o=Ly(arguments.length,1)>i,s=Ey(n)?n:Ny(n),a=o?Iy(arguments,i):[],l=o?function(){Oy(s,this,a)}:s;return e?t(l,r):t(l)}:t},jy=Pn,Yy=x,Hy=Fy(Yy.setInterval,!0);jy({global:!0,bind:!0,forced:Yy.setInterval!==Hy},{setInterval:Hy});var zy=Pn,By=x,Gy=Fy(By.setTimeout,!0);zy({global:!0,bind:!0,forced:By.setTimeout!==Gy},{setTimeout:Gy});var Wy=pe.setTimeout;Dy.exports=Wy;var Vy=e(xy),Uy={},Xy={get exports(){return Uy},set exports(t){Uy=t}},qy=H,$y=Bn,Zy=Un;Pn({target:"Array",proto:!0},{fill:function(t){for(var e=qy(this),i=Zy(e),n=arguments.length,r=$y(n>1?arguments[1]:void 0,i),o=n>2?arguments[2]:void 0,s=void 0===o?i:$y(o,i);s>r;)e[r++]=t;return e}});var Ky=gp("Array").fill,Jy=be,Qy=Ky,tb=Array.prototype,eb=function(t){var e=t.fill;return t===tb||Jy(tb,t)&&e===tb.fill?Qy:e},ib=eb;Xy.exports=ib;var nb=e(Uy),rb={},ob={get exports(){return rb},set exports(t){rb=t}};!function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}ob.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var r=0;r<n.length;r++)if((i=n[r])===e||i.fn===e){n.splice(r,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var r=(i=i.slice(0)).length;n<r;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var sb=rb;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function ab(){return ab=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},ab.apply(this,arguments)}function lb(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function hb(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var ub,db="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var r in n)n.hasOwnProperty(r)&&(e[r]=n[r])}return e}:Object.assign,cb=["","webkit","Moz","MS","ms","o"],pb="undefined"==typeof document?{style:{}}:document.createElement("div"),fb="function",mb=Math.round,vb=Math.abs,gb=Date.now;function yb(t,e){for(var i,n,r=e[0].toUpperCase()+e.slice(1),o=0;o<cb.length;){if((n=(i=cb[o])?i+r:e)in t)return n;o++}}ub="undefined"==typeof window?{}:window;var bb=yb(pb.style,"touchAction"),_b=void 0!==bb;var wb="compute",kb="auto",xb="manipulation",Db="none",Sb="pan-x",Cb="pan-y",Tb=function(){if(!_b)return!1;var t={},e=ub.CSS&&ub.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||ub.CSS.supports("touch-action",i)})),t}(),Mb="ontouchstart"in ub,Ob=void 0!==yb(ub,"PointerEvent"),Eb=Mb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Pb="touch",Ab="mouse",Ib=25,Lb=1,Nb=2,Rb=4,Fb=8,jb=1,Yb=2,Hb=4,zb=8,Bb=16,Gb=Yb|Hb,Wb=zb|Bb,Vb=Gb|Wb,Ub=["x","y"],Xb=["clientX","clientY"];function qb(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function $b(t,e){return typeof t===fb?t.apply(e&&e[0]||void 0,e):t}function Zb(t,e){return t.indexOf(e)>-1}var Kb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===wb&&(t=this.compute()),_b&&this.manager.element.style&&Tb[t]&&(this.manager.element.style[bb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return qb(this.manager.recognizers,(function(e){$b(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Zb(t,Db))return Db;var e=Zb(t,Sb),i=Zb(t,Cb);return e&&i?Db:e||i?e?Sb:Cb:Zb(t,xb)?xb:kb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,r=Zb(n,Db)&&!Tb[Db],o=Zb(n,Cb)&&!Tb[Cb],s=Zb(n,Sb)&&!Tb[Sb];if(r){var a=1===t.pointers.length,l=t.distance<2,h=t.deltaTime<250;if(a&&l&&h)return}if(!s||!o)return r||o&&i&Gb||s&&i&Wb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Jb(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Qb(t){var e=t.length;if(1===e)return{x:mb(t[0].clientX),y:mb(t[0].clientY)};for(var i=0,n=0,r=0;r<e;)i+=t[r].clientX,n+=t[r].clientY,r++;return{x:mb(i/e),y:mb(n/e)}}function t_(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:mb(t.pointers[i].clientX),clientY:mb(t.pointers[i].clientY)},i++;return{timeStamp:gb(),pointers:e,center:Qb(e),deltaX:t.deltaX,deltaY:t.deltaY}}function e_(t,e,i){i||(i=Ub);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return Math.sqrt(n*n+r*r)}function i_(t,e,i){i||(i=Ub);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return 180*Math.atan2(r,n)/Math.PI}function n_(t,e){return t===e?jb:vb(t)>=vb(e)?t<0?Yb:Hb:e<0?zb:Bb}function r_(t,e,i){return{x:e/t||0,y:i/t||0}}function o_(t,e){var i=t.session,n=e.pointers,r=n.length;i.firstInput||(i.firstInput=t_(e)),r>1&&!i.firstMultiple?i.firstMultiple=t_(e):1===r&&(i.firstMultiple=!1);var o=i.firstInput,s=i.firstMultiple,a=s?s.center:o.center,l=e.center=Qb(n);e.timeStamp=gb(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=i_(a,l),e.distance=e_(a,l),function(t,e){var i=e.center,n=t.offsetDelta||{},r=t.prevDelta||{},o=t.prevInput||{};e.eventType!==Lb&&o.eventType!==Rb||(r=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=r.x+(i.x-n.x),e.deltaY=r.y+(i.y-n.y)}(i,e),e.offsetDirection=n_(e.deltaX,e.deltaY);var h,u,d=r_(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=d.x,e.overallVelocityY=d.y,e.overallVelocity=vb(d.x)>vb(d.y)?d.x:d.y,e.scale=s?(h=s.pointers,e_((u=n)[0],u[1],Xb)/e_(h[0],h[1],Xb)):1,e.rotation=s?function(t,e){return i_(e[1],e[0],Xb)+i_(t[1],t[0],Xb)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,r,o,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==Fb&&(a>Ib||void 0===s.velocity)){var l=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,u=r_(a,l,h);n=u.x,r=u.y,i=vb(u.x)>vb(u.y)?u.x:u.y,o=n_(l,h),t.lastInterval=e}else i=s.velocity,n=s.velocityX,r=s.velocityY,o=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=r,e.direction=o}(i,e);var c,p=t.element,f=e.srcEvent;Jb(c=f.composedPath?f.composedPath()[0]:f.path?f.path[0]:f.target,p)&&(p=c),e.target=p}function s_(t,e,i){var n=i.pointers.length,r=i.changedPointers.length,o=e&Lb&&n-r==0,s=e&(Rb|Fb)&&n-r==0;i.isFirst=!!o,i.isFinal=!!s,o&&(t.session={}),i.eventType=e,o_(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function a_(t){return t.trim().split(/\s+/g)}function l_(t,e,i){qb(a_(e),(function(e){t.addEventListener(e,i,!1)}))}function h_(t,e,i){qb(a_(e),(function(e){t.removeEventListener(e,i,!1)}))}function u_(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var d_=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){$b(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&l_(this.element,this.evEl,this.domHandler),this.evTarget&&l_(this.target,this.evTarget,this.domHandler),this.evWin&&l_(u_(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&h_(this.element,this.evEl,this.domHandler),this.evTarget&&h_(this.target,this.evTarget,this.domHandler),this.evWin&&h_(u_(this.element),this.evWin,this.domHandler)},t}();function c_(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var p_={pointerdown:Lb,pointermove:Nb,pointerup:Rb,pointercancel:Fb,pointerout:Fb},f_={2:Pb,3:"pen",4:Ab,5:"kinect"},m_="pointerdown",v_="pointermove pointerup pointercancel";ub.MSPointerEvent&&!ub.PointerEvent&&(m_="MSPointerDown",v_="MSPointerMove MSPointerUp MSPointerCancel");var g_=function(t){function e(){var i,n=e.prototype;return n.evEl=m_,n.evWin=v_,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return lb(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),r=p_[n],o=f_[t.pointerType]||t.pointerType,s=o===Pb,a=c_(e,t.pointerId,"pointerId");r&Lb&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):r&(Rb|Fb)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,r,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),i&&e.splice(a,1))},e}(d_);function y_(t){return Array.prototype.slice.call(t,0)}function b_(t,e,i){for(var n=[],r=[],o=0;o<t.length;){var s=e?t[o][e]:t[o];c_(r,s)<0&&n.push(t[o]),r[o]=s,o++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var __={touchstart:Lb,touchmove:Nb,touchend:Rb,touchcancel:Fb},w_="touchstart touchmove touchend touchcancel",k_=function(t){function e(){var i;return e.prototype.evTarget=w_,(i=t.apply(this,arguments)||this).targetIds={},i}return lb(e,t),e.prototype.handler=function(t){var e=__[t.type],i=x_.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Pb,srcEvent:t})},e}(d_);function x_(t,e){var i,n,r=y_(t.touches),o=this.targetIds;if(e&(Lb|Nb)&&1===r.length)return o[r[0].identifier]=!0,[r,r];var s=y_(t.changedTouches),a=[],l=this.target;if(n=r.filter((function(t){return Jb(t.target,l)})),e===Lb)for(i=0;i<n.length;)o[n[i].identifier]=!0,i++;for(i=0;i<s.length;)o[s[i].identifier]&&a.push(s[i]),e&(Rb|Fb)&&delete o[s[i].identifier],i++;return a.length?[b_(n.concat(a),"identifier",!0),a]:void 0}var D_={mousedown:Lb,mousemove:Nb,mouseup:Rb},S_="mousedown",C_="mousemove mouseup",T_=function(t){function e(){var i,n=e.prototype;return n.evEl=S_,n.evWin=C_,(i=t.apply(this,arguments)||this).pressed=!1,i}return lb(e,t),e.prototype.handler=function(t){var e=D_[t.type];e&Lb&&0===t.button&&(this.pressed=!0),e&Nb&&1!==t.which&&(e=Rb),this.pressed&&(e&Rb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Ab,srcEvent:t}))},e}(d_),M_=2500,O_=25;function E_(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),M_)}}function P_(t,e){t&Lb?(this.primaryTouch=e.changedPointers[0].identifier,E_.call(this,e)):t&(Rb|Fb)&&E_.call(this,e)}function A_(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var r=this.lastTouches[n],o=Math.abs(e-r.x),s=Math.abs(i-r.y);if(o<=O_&&s<=O_)return!0}return!1}var I_=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var r=i.pointerType===Pb,o=i.pointerType===Ab;if(!(o&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(r)P_.call(hb(hb(n)),e,i);else if(o&&A_.call(hb(hb(n)),i))return;n.callback(t,e,i)}},n.touch=new k_(n.manager,n.handler),n.mouse=new T_(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return lb(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(d_)}();function L_(t,e,i){return!!Array.isArray(t)&&(qb(t,i[e],i),!0)}var N_=1,R_=2,F_=4,j_=8,Y_=j_,H_=16,z_=32,B_=1;function G_(t,e){var i=e.manager;return i?i.get(t):t}function W_(t){return t&H_?"cancel":t&j_?"end":t&F_?"move":t&R_?"start":""}var V_=function(){function t(t){void 0===t&&(t={}),this.options=ab({enable:!0},t),this.id=B_++,this.manager=null,this.state=N_,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return db(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(L_(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=G_(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return L_(t,"dropRecognizeWith",this)||(t=G_(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(L_(t,"requireFailure",this))return this;var e=this.requireFail;return-1===c_(e,t=G_(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(L_(t,"dropRequireFailure",this))return this;t=G_(t,this);var e=c_(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<j_&&n(e.options.event+W_(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=j_&&n(e.options.event+W_(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=z_},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(z_|N_)))return!1;t++}return!0},e.recognize=function(t){var e=db({},t);if(!$b(this.options.enable,[this,e]))return this.reset(),void(this.state=z_);this.state&(Y_|H_|z_)&&(this.state=N_),this.state=this.process(e),this.state&(R_|F_|j_|H_)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),U_=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ab({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[xb]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime<i.time;if(this.reset(),t.eventType&Lb&&0===this.count)return this.failTimeout();if(r&&o&&n){if(t.eventType!==Rb)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||e_(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Y_,e.tryEmit()}),i.interval),R_):Y_}return z_},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=z_}),this.options.interval),z_},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===Y_&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(V_),X_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ab({pointers:1},e))||this}lb(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=e&(R_|F_),r=this.attrTest(t);return n&&(i&Fb||!r)?e|H_:n||r?i&Rb?e|j_:e&R_?e|F_:R_:z_},e}(V_);function q_(t){return t===Bb?"down":t===zb?"up":t===Yb?"left":t===Hb?"right":""}var $_=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ab({event:"pan",threshold:10,pointers:1,direction:Vb},e))||this).pX=null,i.pY=null,i}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Gb&&e.push(Cb),t&Wb&&e.push(Sb),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,r=t.direction,o=t.deltaX,s=t.deltaY;return r&e.direction||(e.direction&Gb?(r=0===o?jb:o<0?Yb:Hb,i=o!==this.pX,n=Math.abs(t.deltaX)):(r=0===s?jb:s<0?zb:Bb,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=r,i&&n>e.threshold&&r&e.direction},i.attrTest=function(t){return X_.prototype.attrTest.call(this,t)&&(this.state&R_||!(this.state&R_)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=q_(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(X_),Z_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ab({event:"swipe",threshold:10,velocity:.3,direction:Gb|Wb,pointers:1},e))||this}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return $_.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return n&(Gb|Wb)?i=e.overallVelocity:n&Gb?i=e.overallVelocityX:n&Wb&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&vb(i)>this.options.velocity&&e.eventType&Rb},i.emit=function(t){var e=q_(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(X_),K_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ab({event:"pinch",threshold:0,pointers:2},e))||this}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Db]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&R_)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(X_),J_=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ab({event:"rotate",threshold:0,pointers:2},e))||this}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Db]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&R_)},e}(X_),Q_=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ab({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}lb(e,t);var i=e.prototype;return i.getTouchAction=function(){return[kb]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime>i.time;if(this._input=t,!r||!n||t.eventType&(Rb|Fb)&&!o)this.reset();else if(t.eventType&Lb)this.reset(),this._timer=setTimeout((function(){e.state=Y_,e.tryEmit()}),i.time);else if(t.eventType&Rb)return Y_;return z_},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===Y_&&(t&&t.eventType&Rb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=gb(),this.manager.emit(this.options.event,this._input)))},e}(V_),tw={domEvents:!1,touchAction:wb,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},ew=[[J_,{enable:!1}],[K_,{enable:!1},["rotate"]],[Z_,{direction:Gb}],[$_,{direction:Gb},["swipe"]],[U_],[U_,{event:"doubletap",taps:2},["tap"]],[Q_]];function iw(t,e){var i,n=t.element;n.style&&(qb(t.options.cssProps,(function(r,o){i=yb(n.style,o),e?(t.oldCssProps[i]=n.style[i],n.style[i]=r):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var nw=function(){function t(t,e){var i,n=this;this.options=db({},tw,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Ob?g_:Eb?k_:Mb?I_:T_))(i,s_),this.touchAction=new Kb(this,this.options.touchAction),iw(this,!0),qb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return db(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,r=e.curRecognizer;(!r||r&&r.state&Y_)&&(e.curRecognizer=null,r=null);for(var o=0;o<n.length;)i=n[o],2===e.stopped||r&&i!==r&&!i.canRecognizeWith(r)?i.reset():i.recognize(t),!r&&i.state&(R_|F_|j_)&&(e.curRecognizer=i,r=i),o++}},e.get=function(t){if(t instanceof V_)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(L_(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(L_(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=c_(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return qb(a_(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return qb(a_(t),(function(t){e?i[t]&&i[t].splice(c_(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&iw(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),rw={touchstart:Lb,touchmove:Nb,touchend:Rb,touchcancel:Fb},ow="touchstart",sw="touchstart touchmove touchend touchcancel",aw=function(t){function e(){var i,n=e.prototype;return n.evTarget=ow,n.evWin=sw,(i=t.apply(this,arguments)||this).started=!1,i}return lb(e,t),e.prototype.handler=function(t){var e=rw[t.type];if(e===Lb&&(this.started=!0),this.started){var i=lw.call(this,t,e);e&(Rb|Fb)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Pb,srcEvent:t})}},e}(d_);function lw(t,e){var i=y_(t.touches),n=y_(t.changedTouches);return e&(Rb|Fb)&&(i=b_(i.concat(n),"identifier",!0)),[i,n]}function hw(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",r=window.console&&(window.console.warn||window.console.log);return r&&r.call(window.console,n,i),t.apply(this,arguments)}}var uw=hw((function(t,e,i){for(var n=Object.keys(e),r=0;r<n.length;)(!i||i&&void 0===t[n[r]])&&(t[n[r]]=e[n[r]]),r++;return t}),"extend","Use `assign`."),dw=hw((function(t,e){return uw(t,e,!0)}),"merge","Use `assign`.");function cw(t,e,i){var n,r=e.prototype;(n=t.prototype=Object.create(r)).constructor=t,n._super=r,i&&db(n,i)}function pw(t,e){return function(){return t.apply(e,arguments)}}var fw=function(){var t=function(t,e){return void 0===e&&(e={}),new nw(t,ab({recognizers:ew.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Vb,t.DIRECTION_DOWN=Bb,t.DIRECTION_LEFT=Yb,t.DIRECTION_RIGHT=Hb,t.DIRECTION_UP=zb,t.DIRECTION_HORIZONTAL=Gb,t.DIRECTION_VERTICAL=Wb,t.DIRECTION_NONE=jb,t.DIRECTION_DOWN=Bb,t.INPUT_START=Lb,t.INPUT_MOVE=Nb,t.INPUT_END=Rb,t.INPUT_CANCEL=Fb,t.STATE_POSSIBLE=N_,t.STATE_BEGAN=R_,t.STATE_CHANGED=F_,t.STATE_ENDED=j_,t.STATE_RECOGNIZED=Y_,t.STATE_CANCELLED=H_,t.STATE_FAILED=z_,t.Manager=nw,t.Input=d_,t.TouchAction=Kb,t.TouchInput=k_,t.MouseInput=T_,t.PointerEventInput=g_,t.TouchMouseInput=I_,t.SingleTouchInput=aw,t.Recognizer=V_,t.AttrRecognizer=X_,t.Tap=U_,t.Pan=$_,t.Swipe=Z_,t.Pinch=K_,t.Rotate=J_,t.Press=Q_,t.on=l_,t.off=h_,t.each=qb,t.merge=dw,t.extend=uw,t.bindFn=pw,t.assign=db,t.inherit=cw,t.bindFn=pw,t.prefixed=yb,t.toArray=y_,t.inArray=c_,t.uniqueArray=b_,t.splitStr=a_,t.boolOrFn=$b,t.hasParent=Jb,t.addEventListeners=l_,t.removeEventListeners=h_,t.defaults=db({},tw,{preset:ew}),t}();fw.defaults;var mw=fw;function vw(t,e){var i=vf(t);if(Mu){var n=Mu(t);e&&(n=eg(n).call(n,(function(e){return zu(t,e).enumerable}))),i.push.apply(i,n)}return i}function gw(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?sm(i=vw(Object(r),!0)).call(i,(function(e){Wc(t,e,r[e])})):ed?cd(t,ed(r)):sm(n=vw(Object(r))).call(n,(function(e){xd(t,e,zu(r,e))}))}return t}function yw(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return bw(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bw(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function bw(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var _w=Rp("DELETE");function ww(t){for(var e,i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return kw.apply(void 0,Vp(e=[{},t]).call(e,n))}function kw(){var t=xw.apply(void 0,arguments);return Sw(t),t}function xw(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var n;if(e.length>2)return xw.apply(void 0,Vp(n=[kw(e[0],e[1])]).call(n,Lp(Xp(e).call(e,2))));var r,o=e[0],s=e[1],a=yw(Kp(s));try{for(a.s();!(r=a.n()).done;){var l=r.value;Object.prototype.propertyIsEnumerable.call(s,l)&&(s[l]===_w?delete o[l]:null===o[l]||null===s[l]||"object"!==Lc(o[l])||"object"!==Lc(s[l])||Qp(o[l])||Qp(s[l])?o[l]=Dw(s[l]):o[l]=xw(o[l],s[l]))}}catch(t){a.e(t)}finally{a.f()}return o}function Dw(t){return Qp(t)?uf(t).call(t,(function(t){return Dw(t)})):"object"===Lc(t)&&null!==t?xw({},t):t}function Sw(t){for(var e=0,i=vf(t);e<i.length;e++){var n=i[e];t[n]===_w?delete t[n]:"object"===Lc(t[n])&&null!==t[n]&&Sw(t[n])}}var Cw="undefined"!=typeof window?window.Hammer||mw:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function Tw(t){var e,i=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){i._dom.overlay.parentNode.removeChild(i._dom.overlay)}));var n=Cw(this._dom.overlay);n.on("tap",Vf(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var r=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];sm(r).call(r,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||i.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",i._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&i.deactivate()}}sb(Tw.prototype),Tw.current=null,Tw.prototype.destroy=function(){var t,e;this.deactivate();var i,n=yw(bm(t=$m(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(i=n.n()).done;){(0,i.value)()}}catch(t){n.e(t)}finally{n.f()}},Tw.prototype.activate=function(){Tw.current&&Tw.current.deactivate(),Tw.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Tw.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Tw.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Mw=/^\/?Date\((-?\d+)/i,Ow=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Ew=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Pw=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Aw=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Iw(t){return t instanceof Number||"number"==typeof t}function Lw(t){return t instanceof String||"string"==typeof t}function Nw(t){return"object"===Lc(t)&&null!==t}function Rw(t,e,i,n){var r=!1;!0===n&&(r=null===e[i]&&void 0!==t[i]),r?delete t[i]:t[i]=e[i]}var Fw=pv;function jw(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)||!0===i)if("object"===Lc(e[r])&&null!==e[r]&&Vv(e[r])===Object.prototype)void 0===t[r]?t[r]=jw({},e[r],i):"object"===Lc(t[r])&&null!==t[r]&&Vv(t[r])===Object.prototype?jw(t[r],e[r],i):Rw(t,e,r,n);else if(Qp(e[r])){var o;t[r]=Xp(o=e[r]).call(o)}else Rw(t,e,r,n);return t}function Yw(t){var e=Lc(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Qp(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function Hw(t,e){var i;return Vp(i=[]).call(i,Lp(t),[e])}function zw(t){return Xp(t).call(t)}var Bw=pg;var Gw={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),Lw(t)?t:Iw(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function Ww(t){var e;switch(t.length){case 3:case 4:return(e=Ew.exec(t))?{r:jg(e[1]+e[1],16),g:jg(e[2]+e[2],16),b:jg(e[3]+e[3],16)}:null;case 6:case 7:return(e=Ow.exec(t))?{r:jg(e[1],16),g:jg(e[2],16),b:jg(e[3],16)}:null;default:return null}}function Vw(t,e,i){var n;return"#"+Xp(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function Uw(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),r=Math.max(t,Math.max(e,i));return n===r?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(r-n))/360,s:(r-n)/r,v:r}}var Xw={split:function(t){var e,i={};return sm(e=t.split(";")).call(e,(function(t){if(""!=dy(t).call(t)){var e,n,r=t.split(":"),o=dy(e=r[0]).call(e),s=dy(n=r[1]).call(n);i[o]=s}})),i},join:function(t){var e;return uf(e=vf(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function qw(t,e,i){var n,r,o,s=Math.floor(6*t),a=6*t-s,l=i*(1-e),h=i*(1-a*e),u=i*(1-(1-a)*e);switch(s%6){case 0:n=i,r=u,o=l;break;case 1:n=h,r=i,o=l;break;case 2:n=l,r=i,o=u;break;case 3:n=l,r=h,o=i;break;case 4:n=u,r=l,o=i;break;case 5:n=i,r=l,o=h}return{r:Math.floor(255*n),g:Math.floor(255*r),b:Math.floor(255*o)}}function $w(t,e,i){var n=qw(t,e,i);return Vw(n.r,n.g,n.b)}function Zw(t){var e=Ww(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return Uw(e.r,e.g,e.b)}function Kw(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function Jw(t){return Pw.test(t)}function Qw(t){return Aw.test(t)}function tk(t){if(null===t||"object"!==Lc(t))return null;if(t instanceof Element)return t;var e=vy(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Lc(t[i])&&(e[i]=tk(t[i]));return e}var ek={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},ik=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Dd(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Gc(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return ek[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===Lw(t)){if(!0===Jw(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===Qw(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===Kw(t)){var s=Ww(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+ky(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=pv({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Vy((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=pv({},t)),this.color=t;var e=Uw(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,r=this.centerCoordinates.x+n*Math.sin(i*e.h),o=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=Uw(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=qw(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=Uw(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),nb(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var r=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Vf(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Vf(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Vf(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Vf(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Cw(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(l*n),i=this.centerCoordinates.y+r*Math.cos(l*n),a=qw(.002777777777777778*n,r*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(l)*h+r,d=Math.sin(l)*h+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=d-.5*this.colorPickerSelector.clientWidth+"px";var c=l/(2*Math.PI);c=c<0?c+1:c;var p=h/this.r,f=Uw(this.color.r,this.color.g,this.color.b);f.h=c,f.s=p;var m=qw(f.h,f.s,f.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function nk(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var n=document.createElement(e[0]);return n.appendChild(nk.apply(void 0,Lp(Xp(e).call(e,1)))),n}var rk,ok=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};Dd(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.hideOption=o,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},pv(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new ik(r),this.wrapper=void 0}return Gc(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(Qp(t))this.options.filter=t.join();else if("object"===Lc(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==eg(t)&&(this.options.filter=eg(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===eg(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=eg(this.options),e=0,i=!1;for(var n in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===Jg(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return sm(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");if(n.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===i){for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(nk("i","b",t))}else n.innerText=t+":";return n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==Jg(t).call(t,e)&&(r=Jg(t).call(t,e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerText=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<r?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<r&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>o&&1!==o&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var d=document.createElement("input");d.className="vis-configuration vis-config-rangeinput",d.value=a.value;var c=this;a.onchange=function(){d.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){d.value=this.value};var p=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,p,a,d);""!==l&&this.popupHistory[f]!==h&&(this.popupHistory[f]=h,this._setupPopup(l,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerText=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Vy((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Vy((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Lc(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=eg(this.options),o=!1;for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){n=!0;var a=t[s],l=Hw(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!Qp(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){o=!0;var h=this._getValue(l);if(Qp(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){if(!this.hideOption(e,s,this.moduleOptions))if(void 0!==a.enabled){var u=Hw(l,"enabled"),d=this._getValue(u);if(!0===d){var c=this._makeLabel(s,l,!0);this._makeItem(l,c),o=this._handleObject(a,l)||o}else this._makeCheckbox(a,d,l)}else{var p=this._makeLabel(s,l,!0);this._makeItem(l,p),o=this._handleObject(a,l)||o}}else console.error("dont know how to handle",a,s,l)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(nk("pre","const options = "+ky(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),sk=function(){function t(e,i){Dd(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Gc(t,[{key:"setPosition",value:function(t,e){this.x=jg(t),this.y=jg(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod){var a=!1,l=!0;this.y-e<this.padding&&(l=!1),this.x+i>r-this.padding&&(a=!0),o=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),ak=!1,lk="background: #FFeeee; color: #dd0000",hk=function(){function t(){Dd(this,t)}return Gc(t,null,[{key:"validate",value:function(e,i,n){ak=!1,rk=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),ak}},{key:"parse",value:function(e,i,n){for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.error("%c"+i+t.printLocation(s,e),lk)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Jg(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),ak=!0):"object"===l&&"__any__"!==r&&(s=Hw(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(vf(o))+". Received ["+l+'] "'+i[e]+'"'),ak=!0)}},{key:"getType",value:function(t){var e=Lc(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Qp(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,rk,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(vf(i))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+r,lk),ak=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var d=void 0;if(void 0!==i[u].__type__&&!0===r){var c=t.findInOptions(e,i[u],Hw(n,u));o>c.distance&&(s=c.closestMatch,a=c.path,o=c.distance,h=c.indexMatch)}else{var p;-1!==Jg(p=u.toLowerCase()).call(p,l)&&(h=u),o>(d=t.levenshteinDistance(e,u))&&(s=u,a=zw(n),o=d)}}return{closestMatch:s,path:a,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var r=0;r<n+1;r++)i+="  ";i+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return ky(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),uk=Tw,dk=ik,ck=ok,pk=Cw,fk=sk,mk=lk,vk=hk,gk=Object.freeze({__proto__:null,Activator:uk,Alea:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var r=.02519603282416938*(t+=i.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),i=t(" "),n=t(" "),r=0;r<arguments.length;r++)(e-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(e+=1),(i-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(i+=1),(n-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(n+=1);return[e,i,n]}(t),i=Ip(e,3),n=i[0],r=i[1],o=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=r,r=o,o=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}(e.length?e:[xf()])},ColorPicker:dk,Configurator:ck,DELETE:_w,HSVToHex:$w,HSVToRGB:qw,Hammer:pk,Popup:fk,RGBToHSV:Uw,RGBToHex:Vw,VALIDATOR_PRINT_STYLE:mk,Validator:vk,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Vp(i).call(i,eg(n).call(n,(function(t){return!jv(i).call(i,t)}))),t.className=i.join(" ")},addCssText:function(t,e){var i=Xw.split(t.style.cssText),n=Xw.split(e),r=gw(gw({},i),n);t.style.cssText=Xw.join(r)},addEventListener:function(t,e,i,n){var r;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&jv(r=navigator.userAgent).call(r,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)},binarySearchCustom:function(t,e,i,n){for(var r=0,o=0,s=t.length-1;o<=s&&r<1e4;){var a=Math.floor((o+s)/2),l=t[a],h=e(void 0===n?l[i]:l[i][n]);if(0==h)return a;-1==h?o=a+1:s=a-1,r++}return-1},binarySearchValue:function(t,e,i,n,r){var o,s,a,l,h=0,u=0,d=t.length-1;for(r=null!=r?r:function(t,e){return t==e?0:t<e?-1:1};u<=d&&h<1e4;){if(l=Math.floor(.5*(d+u)),o=t[Math.max(0,l-1)][i],s=t[l][i],a=t[Math.min(t.length-1,l+1)][i],0==r(s,e))return l;if(r(o,e)<0&&r(s,e)>0)return"before"==n?Math.max(0,l-1):l;if(r(s,e)<0&&r(a,e)>0)return"before"==n?l:Math.min(t.length-1,l+1);r(s,e)<0?u=l+1:d=l-1,h++}return-1},bridgeObject:tk,copyAndExtendArray:Hw,copyArray:zw,deepExtend:jw,deepObjectAssign:kw,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:Fw,fillIfDefined:function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var r in e)if(void 0!==i[r])if(null===i[r]||"object"!==Lc(i[r]))Rw(e,i,r,n);else{var o=e[r],s=i[r];Nw(o)&&Nw(s)&&t(o,s,n)}},forEach:function(t,e){if(Qp(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e(t[r],r,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:Yw,hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:Zw,hexToRGB:Ww,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],r=void 0;for(r=i;r>0&&e(n,t[r-1])<0;r--)t[r]=t[r-1];t[r]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(Lw(t)){if(Mw.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:Iw,isObject:Nw,isString:Lw,isValidHex:Kw,isValidRGB:Jw,isValidRGBA:Qw,mergeOptions:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=function(t){return null!=t},o=function(t){return null!==t&&"object"===Lc(t)};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!r(i))throw new Error("Parameter option must have a value");if(!o(n))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=o(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[i]:void 0,l=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return o(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!o(t[i])){if(!r(a))return;t[i]=vy(a)}if(o(s)){var h=!0;void 0!==s.enabled?h=s.enabled:void 0!==l&&(h=a.enabled),function(t,e,i){o(t[i])||(t[i]={});var n=e[i],r=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(r[s]=n[s])}(t,e,i),t[i].enabled=h}}},option:Gw,overrideOpacity:function(t,e){if(jv(t).call(t,"rgba"))return t;if(jv(t).call(t,"rgb")){var i=t.substr(Jg(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=Ww(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},parseColor:function(t,e){if(Lw(t)){var i=t;if(Jw(i)){var n,r=uf(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return jg(t)}));i=Vw(r[0],r[1],r[2])}if(!0===Kw(i)){var o=Zw(i),s={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},a={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},l=$w(a.h,a.s,a.v),h=$w(s.h,s.s,s.v);return{background:i,border:l,highlight:{background:h,border:l},hover:{background:h,border:l}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:Lw(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:Lw(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:Lw(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:Lw(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:ww,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=eg(i).call(i,(function(t){return!jv(n).call(n,t)})),t.className=i.join(" ")},removeCssText:function(t,e){var i=Xw.split(t.style.cssText),n=Xw.split(e);for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&delete i[r];t.style.cssText=Xw.join(i)},removeEventListener:function(t,e,i,n){var r;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&jv(r=navigator.userAgent).call(r,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)},selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Lc(e)){for(var i=vy(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Lc(e[t[n]])&&(i[t[n]]=tk(e[t[n]]));return i}return null},selectiveDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Qp(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r=0;r<t.length;r++){var o=t[r];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?jw(e[o],i[o],!1,n):Rw(e,i,o,n);else{if(Qp(i[o]))throw new TypeError("Arrays are not supported by deepExtend");Rw(e,i,o,n)}}return e},selectiveExtend:function(t,e){if(!Qp(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),r=2;r<i;r++)n[r-2]=arguments[r];for(var o=0,s=n;o<s.length;o++)for(var a=s[o],l=0;l<t.length;l++){var h=t[l];a&&Object.prototype.hasOwnProperty.call(a,h)&&(e[h]=a[h])}return e},selectiveNotDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Qp(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r in i)if(Object.prototype.hasOwnProperty.call(i,r)&&!jv(t).call(t,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?jw(e[r],i[r]):Rw(e,i,r,n);else if(Qp(i[r])){e[r]=[];for(var o=0;o<i[r].length;o++)e[r].push(i[r][o])}else Rw(e,i,r,n);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Bw,topMost:function(t,e){var i;Qp(e)||(e=[e]);var n,r=yw(t);try{for(r.s();!(n=r.n()).done;){var o=n.value;if(o){i=o[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){r.e(t)}finally{r.f()}return i},updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}});function yk(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])}function bk(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function _k(t){yk(t),bk(t),yk(t)}function wk(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}function kk(t,e,i,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElement(t),void 0!==n?i.insertBefore(r,n):i.appendChild(r)):(r=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(r,n):i.appendChild(r)),e[t].used.push(r),r}function xk(t,e,i,n,r,o){var s;if("circle"==i.style?((s=wk("circle",n,r)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=wk("rect",n,r)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),o){var a=wk("text",n,r);o.xOffset&&(t+=o.xOffset),o.yOffset&&(e+=o.yOffset),o.content&&(a.textContent=o.content),o.className&&a.setAttributeNS(null,"class",o.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s}function Dk(t,e,i,n,r,o,s,a){if(0!=n){n<0&&(e-=n*=-1);var l=wk("rect",o,s);l.setAttributeNS(null,"x",t-.5*i),l.setAttributeNS(null,"y",e),l.setAttributeNS(null,"width",i),l.setAttributeNS(null,"height",n),l.setAttributeNS(null,"class",r),a&&l.setAttributeNS(null,"style",a)}}function Sk(){try{return navigator?navigator.languages&&navigator.languages.length?navigator.languages:navigator.userLanguage||navigator.language||navigator.browserLanguage||"en":"en"}catch(t){return"en"}}var Ck=Object.freeze({__proto__:null,cleanupElements:bk,drawBar:Dk,drawPoint:xk,getDOMElement:kk,getNavigatorLanguage:Sk,getSVGElement:wk,prepareElements:yk,resetElements:_k});function Tk(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Mk={},Ok={get exports(){return Mk},set exports(t){Mk=t}},Ek={},Pk=my;({get exports(){return Ek},set exports(t){Ek=t}}).exports=Pk,Ok.exports=Ek;var Ak=e(Mk),Ik={},Lk={get exports(){return Ik},set exports(t){Ik=t}},Nk={},Rk={get exports(){return Nk},set exports(t){Nk=t}};Pn({target:"Object",stat:!0},{setPrototypeOf:So});var Fk=pe.Object.setPrototypeOf;Rk.exports=Fk,Lk.exports=Nk;var jk=e(Ik),Yk={},Hk={get exports(){return Yk},set exports(t){Yk=t}},zk={},Bk=Wf;({get exports(){return zk},set exports(t){zk=t}}).exports=Bk,Hk.exports=zk;var Gk=e(Yk);function Wk(t,e){var i;return Wk=jk?Gk(i=jk).call(i):function(t,e){return t.__proto__=e,t},Wk(t,e)}function Vk(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Ak(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Od(t,"prototype",{writable:!1}),e&&Wk(t,e)}function Uk(t,e){if(e&&("object"===Lc(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return Tk(t)}var Xk={},qk={get exports(){return Xk},set exports(t){Xk=t}},$k={},Zk=Wv;({get exports(){return $k},set exports(t){$k=t}}).exports=Zk,qk.exports=$k;var Kk=e(Xk);function Jk(t){var e;return Jk=jk?Gk(e=Kk).call(e):function(t){return t.__proto__||Kk(t)},Jk(t)}var Qk={},tx={get exports(){return Qk},set exports(t){Qk=t}},ex={};!function(t){var e=Ed,i=Tc;function n(r){return t.exports=n="function"==typeof e&&"symbol"==typeof i?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(r)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return ex},set exports(t){ex=t}});var ix={},nx={get exports(){return ix},set exports(t){ix=t}},rx={},ox=om;({get exports(){return rx},set exports(t){rx=t}}).exports=ox,nx.exports=rx;var sx={},ax={get exports(){return sx},set exports(t){sx=t}},lx={},hx={get exports(){return lx},set exports(t){lx=t}},ux=G,dx=$u,cx=ji,px=Jt,fx=Zt,mx=di,vx=Error,gx=g("".replace),yx=String(vx("zxcasd").stack),bx=/\n\s*at [^:]*:[^\n]*/,_x=bx.test(yx),wx=li,kx=!d((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",wx(1,7)),7!==t.stack)})),xx=di,Dx=function(t,e){if(_x&&"string"==typeof t&&!vx.prepareStackTrace)for(;e--;)t=gx(t,bx,"");return t},Sx=kx,Cx=Error.captureStackTrace,Tx=bn,Mx=ce,Ox=he,Ex=Ce,Px=os,Ax=Un,Ix=be,Lx=Hs,Nx=Is,Rx=Qo,Fx=TypeError,jx=function(t,e){this.stopped=t,this.result=e},Yx=jx.prototype,Hx=function(t,e,i){var n,r,o,s,a,l,h,u=i&&i.that,d=!(!i||!i.AS_ENTRIES),c=!(!i||!i.IS_RECORD),p=!(!i||!i.IS_ITERATOR),f=!(!i||!i.INTERRUPTED),m=Tx(e,u),v=function(t){return n&&Rx(n,"normal",t),new jx(!0,t)},g=function(t){return d?(Ox(t),f?m(t[0],t[1],v):m(t[0],t[1])):f?m(t,v):m(t)};if(c)n=t.iterator;else if(p)n=t;else{if(!(r=Nx(t)))throw Fx(Ex(t)+" is not iterable");if(Px(r)){for(o=0,s=Ax(t);s>o;o++)if((a=g(t[o]))&&Ix(Yx,a))return a;return new jx(!1)}n=Lx(t,r)}for(l=c?t.next:n.next;!(h=Mx(l,n)).done;){try{a=g(h.value)}catch(t){Rx(n,"throw",t)}if("object"==typeof a&&a&&Ix(Yx,a))return a}return new jx(!1)},zx=Nt,Bx=Pn,Gx=be,Wx=zr,Vx=So,Ux=function(t,e,i){for(var n=dx(e),r=px.f,o=cx.f,s=0;s<n.length;s++){var a=n[s];ux(t,a)||i&&ux(i,a)||r(t,a,o(e,a))}},Xx=Ar,qx=di,$x=li,Zx=function(t,e){fx(e)&&"cause"in e&&mx(t,"cause",e.cause)},Kx=function(t,e,i,n){Sx&&(Cx?Cx(t,e):xx(t,"stack",Dx(i,n)))},Jx=Hx,Qx=function(t,e){return void 0===t?arguments.length<2?"":e:zx(t)},tD=mt("toStringTag"),eD=Error,iD=[].push,nD=function(t,e){var i,n=Gx(rD,this);Vx?i=Vx(eD(),n?Wx(this):rD):(i=n?this:Xx(rD),qx(i,tD,"Error")),void 0!==e&&qx(i,"message",Qx(e)),Kx(i,nD,i.stack,1),arguments.length>2&&Zx(i,arguments[2]);var r=[];return Jx(t,iD,{that:r}),qx(i,"errors",r),i};Vx?Vx(nD,eD):Ux(nD,eD,{name:!0});var rD=nD.prototype=Xx(eD.prototype,{constructor:$x(1,nD),message:$x(1,""),name:$x(1,"AggregateError")});Bx({global:!0,constructor:!0,arity:2},{AggregateError:nD});var oD,sD,aD,lD,hD="undefined"!=typeof process&&"process"==St(process),uD=ye,dD=$a,cD=Kt,pD=mt("species"),fD=function(t){var e=uD(t);cD&&e&&!e[pD]&&dD(e,pD,{configurable:!0,get:function(){return this}})},mD=be,vD=TypeError,gD=function(t,e){if(mD(e,t))return t;throw vD("Incorrect invocation")},yD=xs,bD=Ce,_D=TypeError,wD=function(t){if(yD(t))return t;throw _D(bD(t)+" is not a constructor")},kD=he,xD=wD,DD=L,SD=mt("species"),CD=function(t,e){var i,n=kD(t).constructor;return void 0===n||DD(i=kD(n)[SD])?e:xD(i)},TD=/(?:ipad|iphone|ipod).*applewebkit/i.test($),MD=x,OD=Li,ED=bn,PD=wt,AD=G,ID=d,LD=mr,ND=qh,RD=ie,FD=Ty,jD=TD,YD=hD,HD=MD.setImmediate,zD=MD.clearImmediate,BD=MD.process,GD=MD.Dispatch,WD=MD.Function,VD=MD.MessageChannel,UD=MD.String,XD=0,qD={},$D="onreadystatechange";ID((function(){oD=MD.location}));var ZD=function(t){if(AD(qD,t)){var e=qD[t];delete qD[t],e()}},KD=function(t){return function(){ZD(t)}},JD=function(t){ZD(t.data)},QD=function(t){MD.postMessage(UD(t),oD.protocol+"//"+oD.host)};HD&&zD||(HD=function(t){FD(arguments.length,1);var e=PD(t)?t:WD(t),i=ND(arguments,1);return qD[++XD]=function(){OD(e,void 0,i)},sD(XD),XD},zD=function(t){delete qD[t]},YD?sD=function(t){BD.nextTick(KD(t))}:GD&&GD.now?sD=function(t){GD.now(KD(t))}:VD&&!jD?(lD=(aD=new VD).port2,aD.port1.onmessage=JD,sD=ED(lD.postMessage,lD)):MD.addEventListener&&PD(MD.postMessage)&&!MD.importScripts&&oD&&"file:"!==oD.protocol&&!ID(QD)?(sD=QD,MD.addEventListener("message",JD,!1)):sD=$D in RD("script")?function(t){LD.appendChild(RD("script"))[$D]=function(){LD.removeChild(this),ZD(t)}}:function(t){setTimeout(KD(t),0)});var tS={set:HD,clear:zD},eS=function(){this.head=null,this.tail=null};eS.prototype={add:function(t){var e={item:t,next:null},i=this.tail;i?i.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var iS,nS,rS,oS,sS,aS=eS,lS=/ipad|iphone|ipod/i.test($)&&"undefined"!=typeof Pebble,hS=/web0s(?!.*chrome)/i.test($),uS=x,dS=bn,cS=ji.f,pS=tS.set,fS=aS,mS=TD,vS=lS,gS=hS,yS=hD,bS=uS.MutationObserver||uS.WebKitMutationObserver,_S=uS.document,wS=uS.process,kS=uS.Promise,xS=cS(uS,"queueMicrotask"),DS=xS&&xS.value;if(!DS){var SS=new fS,CS=function(){var t,e;for(yS&&(t=wS.domain)&&t.exit();e=SS.get();)try{e()}catch(t){throw SS.head&&iS(),t}t&&t.enter()};mS||yS||gS||!bS||!_S?!vS&&kS&&kS.resolve?((oS=kS.resolve(void 0)).constructor=kS,sS=dS(oS.then,oS),iS=function(){sS(CS)}):yS?iS=function(){wS.nextTick(CS)}:(pS=dS(pS,uS),iS=function(){pS(CS)}):(nS=!0,rS=_S.createTextNode(""),new bS(CS).observe(rS,{characterData:!0}),iS=function(){rS.data=nS=!nS}),DS=function(t){SS.head||iS(),SS.add(t)}}var TS=DS,MS=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},OS=x.Promise,ES="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,PS=!ES&&!hD&&"object"==typeof window&&"object"==typeof document,AS=x,IS=OS,LS=wt,NS=mn,RS=hs,FS=mt,jS=PS,YS=ES,HS=it,zS=IS&&IS.prototype,BS=FS("species"),GS=!1,WS=LS(AS.PromiseRejectionEvent),VS=NS("Promise",(function(){var t=RS(IS),e=t!==String(IS);if(!e&&66===HS)return!0;if(!zS.catch||!zS.finally)return!0;if(!HS||HS<51||!/native code/.test(t)){var i=new IS((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((i.constructor={})[BS]=n,!(GS=i.then((function(){}))instanceof n))return!0}return!e&&(jS||YS)&&!WS})),US={CONSTRUCTOR:VS,REJECTION_EVENT:WS,SUBCLASSING:GS},XS={},qS=Ee,$S=TypeError,ZS=function(t){var e,i;this.promise=new t((function(t,n){if(void 0!==e||void 0!==i)throw $S("Bad Promise constructor");e=t,i=n})),this.resolve=qS(e),this.reject=qS(i)};XS.f=function(t){return new ZS(t)};var KS,JS,QS=Pn,tC=hD,eC=x,iC=ce,nC=Gr,rC=lo,oC=fD,sC=Ee,aC=wt,lC=Zt,hC=gD,uC=CD,dC=tS.set,cC=TS,pC=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},fC=MS,mC=aS,vC=Oi,gC=OS,yC=XS,bC="Promise",_C=US.CONSTRUCTOR,wC=US.REJECTION_EVENT,kC=vC.getterFor(bC),xC=vC.set,DC=gC&&gC.prototype,SC=gC,CC=DC,TC=eC.TypeError,MC=eC.document,OC=eC.process,EC=yC.f,PC=EC,AC=!!(MC&&MC.createEvent&&eC.dispatchEvent),IC="unhandledrejection",LC=function(t){var e;return!(!lC(t)||!aC(e=t.then))&&e},NC=function(t,e){var i,n,r,o=e.value,s=1==e.state,a=s?t.ok:t.fail,l=t.resolve,h=t.reject,u=t.domain;try{a?(s||(2===e.rejection&&HC(e),e.rejection=1),!0===a?i=o:(u&&u.enter(),i=a(o),u&&(u.exit(),r=!0)),i===t.promise?h(TC("Promise-chain cycle")):(n=LC(i))?iC(n,i,l,h):l(i)):h(o)}catch(t){u&&!r&&u.exit(),h(t)}},RC=function(t,e){t.notified||(t.notified=!0,cC((function(){for(var i,n=t.reactions;i=n.get();)NC(i,t);t.notified=!1,e&&!t.rejection&&jC(t)})))},FC=function(t,e,i){var n,r;AC?((n=MC.createEvent("Event")).promise=e,n.reason=i,n.initEvent(t,!1,!0),eC.dispatchEvent(n)):n={promise:e,reason:i},!wC&&(r=eC["on"+t])?r(n):t===IC&&pC("Unhandled promise rejection",i)},jC=function(t){iC(dC,eC,(function(){var e,i=t.facade,n=t.value;if(YC(t)&&(e=fC((function(){tC?OC.emit("unhandledRejection",n,i):FC(IC,i,n)})),t.rejection=tC||YC(t)?2:1,e.error))throw e.value}))},YC=function(t){return 1!==t.rejection&&!t.parent},HC=function(t){iC(dC,eC,(function(){var e=t.facade;tC?OC.emit("rejectionHandled",e):FC("rejectionhandled",e,t.value)}))},zC=function(t,e,i){return function(n){t(e,n,i)}},BC=function(t,e,i){t.done||(t.done=!0,i&&(t=i),t.value=e,t.state=2,RC(t,!0))},GC=function(t,e,i){if(!t.done){t.done=!0,i&&(t=i);try{if(t.facade===e)throw TC("Promise can't be resolved itself");var n=LC(e);n?cC((function(){var i={done:!1};try{iC(n,e,zC(GC,i,t),zC(BC,i,t))}catch(e){BC(i,e,t)}})):(t.value=e,t.state=1,RC(t,!1))}catch(e){BC({done:!1},e,t)}}};_C&&(CC=(SC=function(t){hC(this,CC),sC(t),iC(KS,this);var e=kC(this);try{t(zC(GC,e),zC(BC,e))}catch(t){BC(e,t)}}).prototype,(KS=function(t){xC(this,{type:bC,done:!1,notified:!1,parent:!1,reactions:new mC,rejection:!1,state:0,value:void 0})}).prototype=nC(CC,"then",(function(t,e){var i=kC(this),n=EC(uC(this,SC));return i.parent=!0,n.ok=!aC(t)||t,n.fail=aC(e)&&e,n.domain=tC?OC.domain:void 0,0==i.state?i.reactions.add(n):cC((function(){NC(n,i)})),n.promise})),JS=function(){var t=new KS,e=kC(t);this.promise=t,this.resolve=zC(GC,e),this.reject=zC(BC,e)},yC.f=EC=function(t){return t===SC||undefined===t?new JS(t):PC(t)}),QS({global:!0,constructor:!0,wrap:!0,forced:_C},{Promise:SC}),rC(SC,bC,!1,!0),oC(bC);var WC=OS,VC=US.CONSTRUCTOR||!ia((function(t){WC.all(t).then(void 0,(function(){}))})),UC=ce,XC=Ee,qC=XS,$C=MS,ZC=Hx;Pn({target:"Promise",stat:!0,forced:VC},{all:function(t){var e=this,i=qC.f(e),n=i.resolve,r=i.reject,o=$C((function(){var i=XC(e.resolve),o=[],s=0,a=1;ZC(t,(function(t){var l=s++,h=!1;a++,UC(i,e,t).then((function(t){h||(h=!0,o[l]=t,--a||n(o))}),r)})),--a||n(o)}));return o.error&&r(o.value),i.promise}});var KC=Pn,JC=US.CONSTRUCTOR;OS&&OS.prototype,KC({target:"Promise",proto:!0,forced:JC,real:!0},{catch:function(t){return this.then(void 0,t)}});var QC=ce,tT=Ee,eT=XS,iT=MS,nT=Hx;Pn({target:"Promise",stat:!0,forced:VC},{race:function(t){var e=this,i=eT.f(e),n=i.reject,r=iT((function(){var r=tT(e.resolve);nT(t,(function(t){QC(r,e,t).then(i.resolve,n)}))}));return r.error&&n(r.value),i.promise}});var rT=ce,oT=XS;Pn({target:"Promise",stat:!0,forced:US.CONSTRUCTOR},{reject:function(t){var e=oT.f(this);return rT(e.reject,void 0,t),e.promise}});var sT=he,aT=Zt,lT=XS,hT=function(t,e){if(sT(t),aT(e)&&e.constructor===t)return e;var i=lT.f(t);return(0,i.resolve)(e),i.promise},uT=Pn,dT=OS,cT=US.CONSTRUCTOR,pT=hT,fT=ye("Promise"),mT=!cT;uT({target:"Promise",stat:!0,forced:true},{resolve:function(t){return pT(mT&&this===fT?dT:this,t)}});var vT=ce,gT=Ee,yT=XS,bT=MS,_T=Hx;Pn({target:"Promise",stat:!0,forced:VC},{allSettled:function(t){var e=this,i=yT.f(e),n=i.resolve,r=i.reject,o=bT((function(){var i=gT(e.resolve),r=[],o=0,s=1;_T(t,(function(t){var a=o++,l=!1;s++,vT(i,e,t).then((function(t){l||(l=!0,r[a]={status:"fulfilled",value:t},--s||n(r))}),(function(t){l||(l=!0,r[a]={status:"rejected",reason:t},--s||n(r))}))})),--s||n(r)}));return o.error&&r(o.value),i.promise}});var wT=ce,kT=Ee,xT=ye,DT=XS,ST=MS,CT=Hx,TT="No one promise resolved";Pn({target:"Promise",stat:!0,forced:VC},{any:function(t){var e=this,i=xT("AggregateError"),n=DT.f(e),r=n.resolve,o=n.reject,s=ST((function(){var n=kT(e.resolve),s=[],a=0,l=1,h=!1;CT(t,(function(t){var u=a++,d=!1;l++,wT(n,e,t).then((function(t){d||h||(h=!0,r(t))}),(function(t){d||h||(d=!0,s[u]=t,--l||o(new i(s,TT)))}))})),--l||o(new i(s,TT))}));return s.error&&o(s.value),n.promise}});var MT=Pn,OT=OS,ET=d,PT=ye,AT=wt,IT=CD,LT=hT,NT=OT&&OT.prototype;MT({target:"Promise",proto:!0,real:!0,forced:!!OT&&ET((function(){NT.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=IT(this,PT("Promise")),i=AT(t);return this.then(i?function(i){return LT(e,t()).then((function(){return i}))}:t,i?function(i){return LT(e,t()).then((function(){throw i}))}:t)}});var RT=pe.Promise,FT=XS,jT=MS;Pn({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=FT.f(this),i=jT(t);return(i.error?e.reject:e.resolve)(i.value),e.promise}});var YT=RT;hx.exports=YT,ax.exports=lx;var HT={},zT={get exports(){return HT},set exports(t){HT=t}},BT={},GT=ym;({get exports(){return BT},set exports(t){BT=t}}).exports=GT,zT.exports=BT,function(t){var e=ex.default,i=Sd,n=Ed,r=Mk,o=Xk,s=ix,a=Ik,l=sx,h=HT,u=Jc;function d(){t.exports=d=function(){return c},t.exports.__esModule=!0,t.exports.default=t.exports;var c={},p=Object.prototype,f=p.hasOwnProperty,m=i||function(t,e,i){t[e]=i.value},v="function"==typeof n?n:{},g=v.iterator||"@@iterator",y=v.asyncIterator||"@@asyncIterator",b=v.toStringTag||"@@toStringTag";function _(t,e,n){return i(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{_({},"")}catch(t){_=function(t,e,i){return t[e]=i}}function w(t,e,i,n){var o=e&&e.prototype instanceof D?e:D,s=r(o.prototype),a=new R(n||[]);return m(s,"_invoke",{value:A(t,i,a)}),s}function k(t,e,i){try{return{type:"normal",arg:t.call(e,i)}}catch(t){return{type:"throw",arg:t}}}c.wrap=w;var x={};function D(){}function S(){}function C(){}var T={};_(T,g,(function(){return this}));var M=o&&o(o(F([])));M&&M!==p&&f.call(M,g)&&(T=M);var O=C.prototype=D.prototype=r(T);function E(t){var e;s(e=["next","throw","return"]).call(e,(function(e){_(t,e,(function(t){return this._invoke(e,t)}))}))}function P(t,i){function n(r,o,s,a){var l=k(t[r],t,o);if("throw"!==l.type){var h=l.arg,u=h.value;return u&&"object"==e(u)&&f.call(u,"__await")?i.resolve(u.__await).then((function(t){n("next",t,s,a)}),(function(t){n("throw",t,s,a)})):i.resolve(u).then((function(t){h.value=t,s(h)}),(function(t){return n("throw",t,s,a)}))}a(l.arg)}var r;m(this,"_invoke",{value:function(t,e){function o(){return new i((function(i,r){n(t,e,i,r)}))}return r=r?r.then(o,o):o()}})}function A(t,e,i){var n="suspendedStart";return function(r,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===r)throw o;return j()}for(i.method=r,i.arg=o;;){var s=i.delegate;if(s){var a=I(s,i);if(a){if(a===x)continue;return a}}if("next"===i.method)i.sent=i._sent=i.arg;else if("throw"===i.method){if("suspendedStart"===n)throw n="completed",i.arg;i.dispatchException(i.arg)}else"return"===i.method&&i.abrupt("return",i.arg);n="executing";var l=k(t,e,i);if("normal"===l.type){if(n=i.done?"completed":"suspendedYield",l.arg===x)continue;return{value:l.arg,done:i.done}}"throw"===l.type&&(n="completed",i.method="throw",i.arg=l.arg)}}}function I(t,e){var i=e.method,n=t.iterator[i];if(void 0===n)return e.delegate=null,"throw"===i&&t.iterator.return&&(e.method="return",e.arg=void 0,I(t,e),"throw"===e.method)||"return"!==i&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+i+"' method")),x;var r=k(n,t.iterator,e.arg);if("throw"===r.type)return e.method="throw",e.arg=r.arg,e.delegate=null,x;var o=r.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,x):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,x)}function L(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function N(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function R(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,L,this),this.reset(!0)}function F(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,n=function e(){for(;++i<t.length;)if(f.call(t,i))return e.value=t[i],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:j}}function j(){return{value:void 0,done:!0}}return S.prototype=C,m(O,"constructor",{value:C,configurable:!0}),m(C,"constructor",{value:S,configurable:!0}),S.displayName=_(C,b,"GeneratorFunction"),c.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===S||"GeneratorFunction"===(e.displayName||e.name))},c.mark=function(t){return a?a(t,C):(t.__proto__=C,_(t,b,"GeneratorFunction")),t.prototype=r(O),t},c.awrap=function(t){return{__await:t}},E(P.prototype),_(P.prototype,y,(function(){return this})),c.AsyncIterator=P,c.async=function(t,e,i,n,r){void 0===r&&(r=l);var o=new P(w(t,e,i,n),r);return c.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},E(O),_(O,b,"Generator"),_(O,g,(function(){return this})),_(O,"toString",(function(){return"[object Generator]"})),c.keys=function(t){var e=Object(t),i=[];for(var n in e)i.push(n);return h(i).call(i),function t(){for(;i.length;){var n=i.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},c.values=F,R.prototype={constructor:R,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,N),!t)for(var i in this)"t"===i.charAt(0)&&f.call(this,i)&&!isNaN(+u(i).call(i,1))&&(this[i]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function i(i,n){return o.type="throw",o.arg=t,e.next=i,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var r=this.tryEntries[n],o=r.completion;if("root"===r.tryLoc)return i("end");if(r.tryLoc<=this.prev){var s=f.call(r,"catchLoc"),a=f.call(r,"finallyLoc");if(s&&a){if(this.prev<r.catchLoc)return i(r.catchLoc,!0);if(this.prev<r.finallyLoc)return i(r.finallyLoc)}else if(s){if(this.prev<r.catchLoc)return i(r.catchLoc,!0)}else{if(!a)throw new Error("try statement without catch or finally");if(this.prev<r.finallyLoc)return i(r.finallyLoc)}}}},abrupt:function(t,e){for(var i=this.tryEntries.length-1;i>=0;--i){var n=this.tryEntries[i];if(n.tryLoc<=this.prev&&f.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var r=n;break}}r&&("break"===t||"continue"===t)&&r.tryLoc<=e&&e<=r.finallyLoc&&(r=null);var o=r?r.completion:{};return o.type=t,o.arg=e,r?(this.method="next",this.next=r.finallyLoc,x):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),x},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.finallyLoc===t)return this.complete(i.completion,i.afterLoc),N(i),x}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.tryLoc===t){var n=i.completion;if("throw"===n.type){var r=n.arg;N(i)}return r}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,i){return this.delegate={iterator:F(t),resultName:e,nextLoc:i},"next"===this.method&&(this.arg=void 0),x}},c}t.exports=d,t.exports.__esModule=!0,t.exports.default=t.exports}(tx);var WT=Qk(),VT=WT;try{regeneratorRuntime=WT}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=WT:Function("r","regeneratorRuntime = r")(WT)}var UT={},XT={get exports(){return UT},set exports(t){UT=t}},qT=Ee,$T=H,ZT=Xi,KT=Un,JT=TypeError,QT=function(t){return function(e,i,n,r){qT(i);var o=$T(e),s=ZT(o),a=KT(o),l=t?a-1:0,h=t?-1:1;if(n<2)for(;;){if(l in s){r=s[l],l+=h;break}if(l+=h,t?l<0:a<=l)throw JT("Reduce of empty array with no initial value")}for(;t?l>=0:a>l;l+=h)l in s&&(r=i(r,s[l],l,o));return r}},tM={left:QT(!1),right:QT(!0)}.left;Pn({target:"Array",proto:!0,forced:!hD&&it>79&&it<83||!$f("reduce")},{reduce:function(t){var e=arguments.length;return tM(this,t,e,e>1?arguments[1]:void 0)}});var eM=gp("Array").reduce,iM=be,nM=eM,rM=Array.prototype,oM=function(t){var e=t.reduce;return t===rM||iM(rM,t)&&e===rM.reduce?nM:e},sM=oM;XT.exports=sM;var aM=e(UT),lM={},hM={get exports(){return lM},set exports(t){lM=t}},uM=hl,dM=Un,cM=Nd,pM=bn,fM=function(t,e,i,n,r,o,s,a){for(var l,h,u=r,d=0,c=!!s&&pM(s,a);d<n;)d in i&&(l=c?c(i[d],d,e):i[d],o>0&&uM(l)?(h=dM(l),u=fM(t,e,l,h,u,o-1)-1):(cM(u+1),t[u]=l),u++),d++;return u},mM=fM,vM=Ee,gM=H,yM=Un,bM=vl;Pn({target:"Array",proto:!0},{flatMap:function(t){var e,i=gM(this),n=yM(i);return vM(t),(e=bM(i,0)).length=mM(e,i,i,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var _M=gp("Array").flatMap,wM=be,kM=_M,xM=Array.prototype,DM=function(t){var e=t.flatMap;return t===xM||wM(xM,t)&&e===xM.flatMap?kM:e},SM=DM;hM.exports=SM;var CM=e(lM),TM={},MM={get exports(){return TM},set exports(t){TM=t}},OM={},EM={get exports(){return OM},set exports(t){OM=t}},PM=d((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),AM=d,IM=Zt,LM=St,NM=PM,RM=Object.isExtensible,FM=AM((function(){RM(1)}))||NM?function(t){return!!IM(t)&&((!NM||"ArrayBuffer"!=LM(t))&&(!RM||RM(t)))}:RM,jM=!d((function(){return Object.isExtensible(Object.preventExtensions({}))})),YM=Pn,HM=g,zM=mi,BM=Zt,GM=G,WM=Jt.f,VM=Aa,UM=Na,XM=FM,qM=jM,$M=!1,ZM=q("meta"),KM=0,JM=function(t){WM(t,ZM,{value:{objectID:"O"+KM++,weakData:{}}})},QM=EM.exports={enable:function(){QM.enable=function(){},$M=!0;var t=VM.f,e=HM([].splice),i={};i[ZM]=1,t(i).length&&(VM.f=function(i){for(var n=t(i),r=0,o=n.length;r<o;r++)if(n[r]===ZM){e(n,r,1);break}return n},YM({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:UM.f}))},fastKey:function(t,e){if(!BM(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!GM(t,ZM)){if(!XM(t))return"F";if(!e)return"E";JM(t)}return t[ZM].objectID},getWeakData:function(t,e){if(!GM(t,ZM)){if(!XM(t))return!0;if(!e)return!1;JM(t)}return t[ZM].weakData},onFreeze:function(t){return qM&&$M&&XM(t)&&!GM(t,ZM)&&JM(t),t}};zM[ZM]=!0;var tO=Pn,eO=x,iO=OM,nO=d,rO=di,oO=Hx,sO=gD,aO=wt,lO=Zt,hO=lo,uO=Jt.f,dO=Dl.forEach,cO=Kt,pO=Oi.set,fO=Oi.getterFor,mO=function(t,e,i){var n,r=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),s=r?"set":"add",a=eO[t],l=a&&a.prototype,h={};if(cO&&aO(a)&&(o||l.forEach&&!nO((function(){(new a).entries().next()})))){var u=(n=e((function(e,i){pO(sO(e,u),{type:t,collection:new a}),null!=i&&oO(i,e[s],{that:e,AS_ENTRIES:r})}))).prototype,d=fO(t);dO(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||o&&"clear"==t||rO(u,t,(function(i,n){var r=d(this).collection;if(!e&&o&&!lO(i))return"get"==t&&void 0;var s=r[t](0===i?0:i,n);return e?this:s}))})),o||uO(u,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else n=i.getConstructor(e,t,r,s),iO.enable();return hO(n,t,!1,!0),h[t]=n,tO({global:!0,forced:!0},h),o||i.setStrong(n,t,r),n},vO=Gr,gO=Ar,yO=$a,bO=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:vO(t,n,e[n],i);return t},_O=bn,wO=gD,kO=L,xO=Hx,DO=Ho,SO=zo,CO=fD,TO=Kt,MO=OM.fastKey,OO=Oi.set,EO=Oi.getterFor,PO={getConstructor:function(t,e,i,n){var r=t((function(t,r){wO(t,o),OO(t,{type:e,index:gO(null),first:void 0,last:void 0,size:0}),TO||(t.size=0),kO(r)||xO(r,t[n],{that:t,AS_ENTRIES:i})})),o=r.prototype,s=EO(e),a=function(t,e,i){var n,r,o=s(t),a=l(t,e);return a?a.value=i:(o.last=a={index:r=MO(e,!0),key:e,value:i,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=a),n&&(n.next=a),TO?o.size++:t.size++,"F"!==r&&(o.index[r]=a)),t},l=function(t,e){var i,n=s(t),r=MO(e);if("F"!==r)return n.index[r];for(i=n.first;i;i=i.next)if(i.key==e)return i};return bO(o,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,TO?t.size=0:this.size=0},delete:function(t){var e=this,i=s(e),n=l(e,t);if(n){var r=n.next,o=n.previous;delete i.index[n.index],n.removed=!0,o&&(o.next=r),r&&(r.previous=o),i.first==n&&(i.first=r),i.last==n&&(i.last=o),TO?i.size--:e.size--}return!!n},forEach:function(t){for(var e,i=s(this),n=_O(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!l(this,t)}}),bO(o,i?{get:function(t){var e=l(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),TO&&yO(o,"size",{configurable:!0,get:function(){return s(this).size}}),r},setStrong:function(t,e,i){var n=e+" Iterator",r=EO(e),o=EO(n);DO(t,e,(function(t,e){OO(this,{type:n,target:t,state:r(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?SO("keys"==e?i.key:"values"==e?i.value:[i.key,i.value],!1):(t.target=void 0,SO(void 0,!0))}),i?"entries":"values",!i,!0),CO(e)}};mO("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),PO);var AO=pe.Map;MM.exports=AO;var IO=e(TM),LO={},NO={get exports(){return LO},set exports(t){LO=t}};mO("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),PO);var RO=pe.Set;NO.exports=RO;var FO=e(LO),jO={};({get exports(){return jO},set exports(t){jO=t}}).exports=Pc;var YO=e(jO),HO={},zO={get exports(){return HO},set exports(t){HO=t}},BO={},GO=Hs;({get exports(){return BO},set exports(t){BO=t}}).exports=GO,zO.exports=BO;var WO=e(HO),VO={},UO={get exports(){return VO},set exports(t){VO=t}},XO=za,qO=Math.floor,$O=function(t,e){var i=t.length,n=qO(i/2);return i<8?ZO(t,e):KO(t,$O(XO(t,0,n),e),$O(XO(t,n),e),e)},ZO=function(t,e){for(var i,n,r=t.length,o=1;o<r;){for(n=o,i=t[o];n&&e(t[n-1],i)>0;)t[n]=t[--n];n!==o++&&(t[n]=i)}return t},KO=function(t,e,i,n){for(var r=e.length,o=i.length,s=0,a=0;s<r||a<o;)t[s+a]=s<r&&a<o?n(e[s],i[a])<=0?e[s++]:i[a++]:s<r?e[s++]:i[a++];return t},JO=$O,QO=$.match(/firefox\/(\d+)/i),tE=!!QO&&+QO[1],eE=/MSIE|Trident/.test($),iE=$.match(/AppleWebKit\/(\d+)\./),nE=!!iE&&+iE[1],rE=Pn,oE=g,sE=Ee,aE=H,lE=Un,hE=Om,uE=Nt,dE=d,cE=JO,pE=$f,fE=tE,mE=eE,vE=it,gE=nE,yE=[],bE=oE(yE.sort),_E=oE(yE.push),wE=dE((function(){yE.sort(void 0)})),kE=dE((function(){yE.sort(null)})),xE=pE("sort"),DE=!dE((function(){if(vE)return vE<70;if(!(fE&&fE>3)){if(mE)return!0;if(gE)return gE<603;var t,e,i,n,r="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:i=3;break;case 68:case 71:i=4;break;default:i=2}for(n=0;n<47;n++)yE.push({k:e+n,v:i})}for(yE.sort((function(t,e){return e.v-t.v})),n=0;n<yE.length;n++)e=yE[n].k.charAt(0),r.charAt(r.length-1)!==e&&(r+=e);return"DGBEFHACIJK"!==r}}));rE({target:"Array",proto:!0,forced:wE||!kE||!xE||!DE},{sort:function(t){void 0!==t&&sE(t);var e=aE(this);if(DE)return void 0===t?bE(e):bE(e,t);var i,n,r=[],o=lE(e);for(n=0;n<o;n++)n in e&&_E(r,e[n]);for(cE(r,function(t){return function(e,i){return void 0===i?-1:void 0===e?1:void 0!==t?+t(e,i)||0:uE(e)>uE(i)?1:-1}}(t)),i=lE(r),n=0;n<i;)e[n]=r[n++];for(;n<o;)hE(e,n++);return e}});var SE=gp("Array").sort,CE=be,TE=SE,ME=Array.prototype,OE=function(t){var e=t.sort;return t===ME||CE(ME,t)&&e===ME.sort?TE:e},EE=OE;UO.exports=EE;var PE=e(VO),AE={},IE={get exports(){return AE},set exports(t){AE=t}},LE=Dl.some;Pn({target:"Array",proto:!0,forced:!$f("some")},{some:function(t){return LE(this,t,arguments.length>1?arguments[1]:void 0)}});var NE=gp("Array").some,RE=be,FE=NE,jE=Array.prototype,YE=function(t){var e=t.some;return t===jE||RE(jE,t)&&e===jE.some?FE:e},HE=YE;IE.exports=HE;var zE=e(AE),BE={},GE={get exports(){return BE},set exports(t){BE=t}},WE=gp("Array").keys,VE=At,UE=G,XE=be,qE=WE,$E=Array.prototype,ZE={DOMTokenList:!0,NodeList:!0},KE=function(t){var e=t.keys;return t===$E||XE($E,t)&&e===$E.keys||UE(ZE,VE(t))?qE:e};GE.exports=KE;var JE=e(BE),QE={},tP={get exports(){return QE},set exports(t){QE=t}},eP=gp("Array").values,iP=At,nP=G,rP=be,oP=eP,sP=Array.prototype,aP={DOMTokenList:!0,NodeList:!0},lP=function(t){var e=t.values;return t===sP||rP(sP,t)&&e===sP.values||nP(aP,iP(t))?oP:e};tP.exports=lP;var hP=e(QE),uP={},dP={get exports(){return uP},set exports(t){uP=t}},cP=gp("Array").entries,pP=At,fP=G,mP=be,vP=cP,gP=Array.prototype,yP={DOMTokenList:!0,NodeList:!0},bP=function(t){var e=t.entries;return t===gP||mP(gP,t)&&e===gP.entries||fP(yP,pP(t))?vP:e};dP.exports=bP;var _P=e(uP),wP={},kP={get exports(){return wP},set exports(t){wP=t}},xP=Pn,DP=Li,SP=Ff,CP=wD,TP=he,MP=Zt,OP=Ar,EP=d,PP=ye("Reflect","construct"),AP=Object.prototype,IP=[].push,LP=EP((function(){function t(){}return!(PP((function(){}),[],t)instanceof t)})),NP=!EP((function(){PP((function(){}))})),RP=LP||NP;xP({target:"Reflect",stat:!0,forced:RP,sham:RP},{construct:function(t,e){CP(t),TP(e);var i=arguments.length<3?t:CP(arguments[2]);if(NP&&!LP)return PP(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return DP(IP,n,e),new(DP(SP,t,n))}var r=i.prototype,o=OP(MP(r)?r:AP),s=DP(t,o,e);return MP(s)?s:o}});var FP=pe.Reflect.construct;kP.exports=FP;var jP=e(wP),YP="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),HP=new Uint8Array(16);function zP(){if(!YP)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return YP(HP)}for(var BP,GP=[],WP=0;WP<256;++WP)GP[WP]=(WP+256).toString(16).substr(1);function VP(t,e,i){var n=e&&i||0;"string"==typeof t&&(e="binary"===t?new Array(16):null,t=null);var r=(t=t||{}).random||(t.rng||zP)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e)for(var o=0;o<16;++o)e[n+o]=r[o];return e||function(t,e){var i=e||0,n=GP;return[n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]]].join("")}(r)}function UP(t,e){var i=vf(t);if(Mu){var n=Mu(t);e&&(n=eg(n).call(n,(function(e){return zu(t,e).enumerable}))),i.push.apply(i,n)}return i}function XP(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?sm(i=UP(Object(r),!0)).call(i,(function(e){Wc(t,e,r[e])})):ed?cd(t,ed(r)):sm(n=UP(Object(r))).call(n,(function(e){xd(t,e,zu(r,e))}))}return t}function qP(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}function $P(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return ZP(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZP(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function ZP(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var KP=function(){function t(e,i,n){var r,o,s;Dd(this,t),Wc(this,"_source",void 0),Wc(this,"_transformers",void 0),Wc(this,"_target",void 0),Wc(this,"_listeners",{add:Vf(r=this._add).call(r,this),remove:Vf(o=this._remove).call(o,this),update:Vf(s=this._update).call(s,this)}),this._source=e,this._transformers=i,this._target=n}return Gc(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return aM(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),JP=function(){function t(e){Dd(this,t),Wc(this,"_source",void 0),Wc(this,"_transformers",[]),this._source=e}return Gc(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return eg(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return uf(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return CM(e).call(e,t)})),this}},{key:"to",value:function(t){return new KP(this._source,this._transformers,t)}}]),t}();function QP(t){return"string"==typeof t||"number"==typeof t}var tA=function(){function t(e){Dd(this,t),Wc(this,"delay",void 0),Wc(this,"max",void 0),Wc(this,"_queue",[]),Wc(this,"_timeout",null),Wc(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return Gc(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var n=e[i];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];i.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Vy((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;sm(t=$m(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var n=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var r=[{name:"flush",original:void 0}];if(i&&i.replace)for(var o=0;o<i.replace.length;o++){var s=i.replace[o];r.push({name:s,original:e[s]}),n.replace(e,s)}return n._extended={object:e,methods:r},n}}]),t}(),eA=function(){function t(){Dd(this,t),Wc(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Wc(this,"subscribe",t.prototype.on),Wc(this,"unsubscribe",t.prototype.off)}return Gc(t,[{key:"_trigger",value:function(t,e,i){var n,r;if("*"===t)throw new Error("Cannot trigger event *");sm(n=Vp(r=[]).call(r,Lp(this._subscribers[t]),Lp(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=i?i:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var i;this._subscribers[t]=eg(i=this._subscribers[t]).call(i,(function(t){return t!==e}))}}]),t}();BP=YO;var iA=function(){function t(e){Dd(this,t),Wc(this,"_pairs",void 0),this._pairs=e}return Gc(t,[{key:BP,value:VT.mark((function t(){var e,i,n,r,o;return VT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$P(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Ip(i.value,2),r=n[0],o=n[1],t.next=7,[r,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:VT.mark((function t(){var e,i,n,r,o;return VT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$P(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Ip(i.value,2),r=n[0],o=n[1],t.next=7,[r,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:VT.mark((function t(){var e,i,n,r;return VT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$P(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Ip(i.value,1),r=n[0],t.next=7,r;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:VT.mark((function t(){var e,i,n,r;return VT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$P(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Ip(i.value,2),r=n[1],t.next=7,r;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return uf(t=Lp(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return uf(t=Lp(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Lp(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=vy(null),i=$P(this._pairs);try{for(i.s();!(t=i.n()).done;){var n=Ip(t.value,2),r=n[0],o=n[1];e[r]=o}}catch(t){i.e(t)}finally{i.f()}return e}},{key:"toMap",value:function(){return new IO(this._pairs)}},{key:"toIdSet",value:function(){return new FO(this.toIdArray())}},{key:"toItemSet",value:function(){return new FO(this.toItemArray())}},{key:"cache",value:function(){return new t(Lp(this._pairs))}},{key:"distinct",value:function(t){var e,i=new FO,n=$P(this._pairs);try{for(n.s();!(e=n.n()).done;){var r=Ip(e.value,2),o=r[0],s=r[1];i.add(t(s,o))}}catch(t){n.e(t)}finally{n.f()}return i}},{key:"filter",value:function(e){var i=this._pairs;return new t(Wc({},YO,VT.mark((function t(){var n,r,o,s,a;return VT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=$P(i),t.prev=1,n.s();case 3:if((r=n.n()).done){t.next=10;break}if(o=Ip(r.value,2),s=o[0],a=o[1],!e(a,s)){t.next=8;break}return t.next=8,[s,a];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,i=$P(this._pairs);try{for(i.s();!(e=i.n()).done;){var n=Ip(e.value,2),r=n[0];t(n[1],r)}}catch(t){i.e(t)}finally{i.f()}}},{key:"map",value:function(e){var i=this._pairs;return new t(Wc({},YO,VT.mark((function t(){var n,r,o,s,a;return VT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=$P(i),t.prev=1,n.s();case 3:if((r=n.n()).done){t.next=9;break}return o=Ip(r.value,2),s=o[0],a=o[1],t.next=7,[s,e(a,s)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=WO(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],r=t(i.value[1],i.value[0]);!(i=e.next()).done;){var o=Ip(i.value,2),s=o[0],a=o[1],l=t(a,s);l>r&&(r=l,n=a)}return n}},{key:"min",value:function(t){var e=WO(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],r=t(i.value[1],i.value[0]);!(i=e.next()).done;){var o=Ip(i.value,2),s=o[0],a=o[1],l=t(a,s);l<r&&(r=l,n=a)}return n}},{key:"reduce",value:function(t,e){var i,n=$P(this._pairs);try{for(n.s();!(i=n.n()).done;){var r=Ip(i.value,2),o=r[0];e=t(e,r[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var i=this;return new t(Wc({},YO,(function(){var t;return WO(PE(t=Lp(i._pairs)).call(t,(function(t,i){var n=Ip(t,2),r=n[0],o=n[1],s=Ip(i,2),a=s[0],l=s[1];return e(o,l,r,a)})))})))}}]),t}();var nA=function(t){Vk(i,eA);var e=qP(i);function i(t,n){var r;return Dd(this,i),Wc(Tk(r=e.call(this)),"flush",void 0),Wc(Tk(r),"length",void 0),Wc(Tk(r),"_options",void 0),Wc(Tk(r),"_data",void 0),Wc(Tk(r),"_idProp",void 0),Wc(Tk(r),"_queue",null),t&&!Qp(t)&&(n=t,t=[]),r._options=n||{},r._data=new IO,r.length=0,r._idProp=r._options.fieldId||"id",t&&t.length&&r.add(t),r.setOptions(n),r}return Gc(i,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=tA.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Lc(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,n=this,r=[];if(Qp(t)){var o=uf(t).call(t,(function(t){return t[n._idProp]}));if(zE(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var s=0,a=t.length;s<a;s++)i=this._addItem(t[s]),r.push(i)}else{if(!t||"object"!==Lc(t))throw new Error("Unknown dataType");i=this._addItem(t),r.push(i)}return r.length&&this._trigger("add",{items:r},e),r}},{key:"update",value:function(t,e){var i=this,n=[],r=[],o=[],s=[],a=this._idProp,l=function(t){var e=t[a];if(null!=e&&i._data.has(e)){var l=t,h=pv({},i._data.get(e)),u=i._updateItem(l);r.push(u),s.push(l),o.push(h)}else{var d=i._addItem(t);n.push(d)}};if(Qp(t))for(var h=0,u=t.length;h<u;h++)t[h]&&"object"===Lc(t[h])?l(t[h]):console.warn("Ignoring input item, which is not an object at index "+h);else{if(!t||"object"!==Lc(t))throw new Error("Unknown dataType");l(t)}if(n.length&&this._trigger("add",{items:n},e),r.length){var d={items:r,oldData:o,data:s};this._trigger("update",d,e)}return Vp(n).call(n,r)}},{key:"updateOnly",value:function(t,e){var i,n=this;Qp(t)||(t=[t]);var r=uf(i=uf(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(i,(function(t){var e=t.oldData,i=t.update,r=e[n._idProp],o=ww(e,i);return n._data.set(r,o),{id:r,oldData:e,updatedData:o}}));if(r.length){var o={items:uf(r).call(r,(function(t){return t.id})),oldData:uf(r).call(r,(function(t){return t.oldData})),data:uf(r).call(r,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var i=void 0,n=void 0,r=void 0;QP(t)?(i=t,r=e):Qp(t)?(n=t,r=e):r=t;var o,s=r&&"Object"===r.returnType?"Object":"Array",a=r&&eg(r),l=[],h=void 0,u=void 0,d=void 0;if(null!=i)(h=this._data.get(i))&&a&&!a(h)&&(h=void 0);else if(null!=n)for(var c=0,p=n.length;c<p;c++)null==(h=this._data.get(n[c]))||a&&!a(h)||l.push(h);else for(var f,m=0,v=(u=Lp(JE(f=this._data).call(f))).length;m<v;m++)d=u[m],null==(h=this._data.get(d))||a&&!a(h)||l.push(h);if(r&&r.order&&null==i&&this._sort(l,r.order),r&&r.fields){var g=r.fields;if(null!=i&&null!=h)h=this._filterFields(h,g);else for(var y=0,b=l.length;y<b;y++)l[y]=this._filterFields(l[y],g)}if("Object"==s){for(var _={},w=0,k=l.length;w<k;w++){var x=l[w];_[x[this._idProp]]=x}return _}return null!=i?null!==(o=h)&&void 0!==o?o:null:l}},{key:"getIds",value:function(t){var e=this._data,i=t&&eg(t),n=t&&t.order,r=Lp(JE(e).call(e)),o=[];if(i)if(n){for(var s=[],a=0,l=r.length;a<l;a++){var h=r[a],u=this._data.get(h);null!=u&&i(u)&&s.push(u)}this._sort(s,n);for(var d=0,c=s.length;d<c;d++)o.push(s[d][this._idProp])}else for(var p=0,f=r.length;p<f;p++){var m=r[p],v=this._data.get(m);null!=v&&i(v)&&o.push(v[this._idProp])}else if(n){for(var g=[],y=0,b=r.length;y<b;y++){var _=r[y];g.push(e.get(_))}this._sort(g,n);for(var w=0,k=g.length;w<k;w++)o.push(g[w][this._idProp])}else for(var x=0,D=r.length;x<D;x++){var S=r[x],C=e.get(S);null!=C&&o.push(C[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&eg(e),n=this._data,r=Lp(JE(n).call(n));if(e&&e.order)for(var o=this.get(e),s=0,a=o.length;s<a;s++){var l=o[s];t(l,l[this._idProp])}else for(var h=0,u=r.length;h<u;h++){var d=r[h],c=this._data.get(d);null==c||i&&!i(c)||t(c,d)}}},{key:"map",value:function(t,e){for(var i=e&&eg(e),n=[],r=this._data,o=Lp(JE(r).call(r)),s=0,a=o.length;s<a;s++){var l=o[s],h=this._data.get(l);null==h||i&&!i(h)||n.push(t(h,l))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var i;return t?aM(i=Qp(e)?e:vf(e)).call(i,(function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;PE(t).call(t,(function(t,e){var n=t[i],r=e[i];return n>r?1:n<r?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");PE(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var i=[],n=[],r=Qp(t)?t:[t],o=0,s=r.length;o<s;o++){var a=this._remove(r[o]);if(a){var l=a[this._idProp];null!=l&&(i.push(l),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},e),i}},{key:"_remove",value:function(t){var e;if(QP(t)?e=t:t&&"object"===Lc(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var i=this._data.get(e)||null;return this._data.delete(e),--this.length,i}return null}},{key:"clear",value:function(t){for(var e,i=Lp(JE(e=this._data).call(e)),n=[],r=0,o=i.length;r<o;r++)n.push(this._data.get(i[r]));return this._data.clear(),this.length=0,this._trigger("remove",{items:i,oldData:n},t),i}},{key:"max",value:function(t){var e,i,n=null,r=null,o=$P(hP(e=this._data).call(e));try{for(o.s();!(i=o.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==r||a>r)&&(n=s,r=a)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,i,n=null,r=null,o=$P(hP(e=this._data).call(e));try{for(o.s();!(i=o.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==r||a<r)&&(n=s,r=a)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,i=Lp(JE(e).call(e)),n=[],r=0,o=0,s=i.length;o<s;o++){for(var a=i[o],l=e.get(a)[t],h=!1,u=0;u<r;u++)if(n[u]==l){h=!0;break}h||void 0===l||(n[r]=l,r++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=VP()),t}(t,this._idProp),i=e[this._idProp];if(this._data.has(i))throw new Error("Cannot add item: item with id "+i+" already exists");return this._data.set(i,e),++this.length,i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+ky(t)+")");var i=this._data.get(e);if(!i)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,XP(XP({},i),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new iA(Wc({},YO,VT.mark((function i(){var n,r,o,s;return VT.wrap((function(i){for(;;)switch(i.prev=i.next){case 0:n=$P(t),i.prev=1,n.s();case 3:if((r=n.n()).done){i.next=11;break}if(o=r.value,null==(s=e.get(o))){i.next=9;break}return i.next=9,[o,s];case 9:i.next=3;break;case 11:i.next=16;break;case 13:i.prev=13,i.t0=i.catch(1),n.e(i.t0);case 16:return i.prev=16,n.f(),i.finish(16);case 19:case"end":return i.stop()}}),i,null,[[1,13,16,19]])}))))}var i;return new iA(Wc({},YO,Vf(i=_P(this._data)).call(i,this._data)))}}]),i}(),rA=function(t){Vk(i,eA);var e=qP(i);function i(t,n){var r,o;return Dd(this,i),Wc(Tk(o=e.call(this)),"length",0),Wc(Tk(o),"_listener",void 0),Wc(Tk(o),"_data",void 0),Wc(Tk(o),"_ids",new FO),Wc(Tk(o),"_options",void 0),o._options=n||{},o._listener=Vf(r=o._onEvent).call(r,Tk(o)),o.setData(t),o}return Gc(i,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:eg(this._options)}),i=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:eg(this._options)}),r=0,o=n.length;r<o;r++){var s=n[r];this._ids.add(s)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new nA;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:eg(this._options)}),e=Lp(this._ids),i={},n=[],r=[],o=[],s=0,a=t.length;s<a;s++){var l=t[s];i[l]=!0,this._ids.has(l)||(n.push(l),this._ids.add(l))}for(var h=0,u=e.length;h<u;h++){var d=e[h],c=this._data.get(d);null==c?console.error("If you see this, report it please."):i[d]||(r.push(d),o.push(c),this._ids.delete(d))}this.length+=n.length-r.length,n.length&&this._trigger("add",{items:n}),r.length&&this._trigger("remove",{items:r,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,n=null;QP(t)||Qp(t)?(n=t,i=e):i=t;var r=pv({},this._options,i),o=eg(this._options),s=i&&eg(i);return o&&s&&(r.filter=function(t){return o(t)&&s(t)}),null==n?this._data.get(r):this._data.get(n,r)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=eg(this._options),n=null!=t?eg(t):null;return e=n?i?function(t){return i(t)&&n(t)}:n:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,n,r=eg(this._options),o=e&&eg(e);n=o?r?function(t){return r(t)&&o(t)}:o:r,sm(i=this._data).call(i,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,n,r=eg(this._options),o=e&&eg(e);return n=o?r?function(t){return r(t)&&o(t)}:o:r,uf(i=this._data).call(i,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Wc({},YO,Vf(e=JE(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",r={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=$P(Kp(i.prototype));try{for(o.s();!(e=o.n()).done;){var s=e.value;xd(this,s,r)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var n=e.items,r=[],o=[],s=[],a=[],l=[],h=[];switch(t){case"add":for(var u=0,d=n.length;u<d;u++){var c=n[u];this.get(c)&&(this._ids.add(c),r.push(c))}break;case"update":for(var p=0,f=n.length;p<f;p++){var m=n[p];this.get(m)?this._ids.has(m)?(o.push(m),l.push(e.data[p]),a.push(e.oldData[p])):(this._ids.add(m),r.push(m)):this._ids.has(m)&&(this._ids.delete(m),s.push(m),h.push(e.oldData[p]))}break;case"remove":for(var v=0,g=n.length;v<g;v++){var y=n[v];this._ids.has(y)&&(this._ids.delete(y),s.push(y),h.push(e.oldData[v]))}}this.length+=r.length-s.length,r.length&&this._trigger("add",{items:r},i),o.length&&this._trigger("update",{items:o,oldData:a,data:l},i),s.length&&this._trigger("remove",{items:s,oldData:h},i)}}}]),i}();function oA(t,e){return"object"===Lc(e)&&null!==e&&t===e.idProp&&"function"==typeof sm(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof uf(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&function(t,e){return"object"===Lc(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof sm(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof uf(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}(t,e.getDataSet())}var sA="undefined"!=typeof window&&window.moment||l(),aA=e(l()),lA={},hA={get exports(){return lA},set exports(t){lA=t}},uA={},dA={},cA={get exports(){return dA},set exports(t){dA=t}},pA={};function fA(){var t={"align-content":!1,"align-items":!1,"align-self":!1,"alignment-adjust":!1,"alignment-baseline":!1,all:!1,"anchor-point":!1,animation:!1,"animation-delay":!1,"animation-direction":!1,"animation-duration":!1,"animation-fill-mode":!1,"animation-iteration-count":!1,"animation-name":!1,"animation-play-state":!1,"animation-timing-function":!1,azimuth:!1,"backface-visibility":!1,background:!0,"background-attachment":!0,"background-clip":!0,"background-color":!0,"background-image":!0,"background-origin":!0,"background-position":!0,"background-repeat":!0,"background-size":!0,"baseline-shift":!1,binding:!1,bleed:!1,"bookmark-label":!1,"bookmark-level":!1,"bookmark-state":!1,border:!0,"border-bottom":!0,"border-bottom-color":!0,"border-bottom-left-radius":!0,"border-bottom-right-radius":!0,"border-bottom-style":!0,"border-bottom-width":!0,"border-collapse":!0,"border-color":!0,"border-image":!0,"border-image-outset":!0,"border-image-repeat":!0,"border-image-slice":!0,"border-image-source":!0,"border-image-width":!0,"border-left":!0,"border-left-color":!0,"border-left-style":!0,"border-left-width":!0,"border-radius":!0,"border-right":!0,"border-right-color":!0,"border-right-style":!0,"border-right-width":!0,"border-spacing":!0,"border-style":!0,"border-top":!0,"border-top-color":!0,"border-top-left-radius":!0,"border-top-right-radius":!0,"border-top-style":!0,"border-top-width":!0,"border-width":!0,bottom:!1,"box-decoration-break":!0,"box-shadow":!0,"box-sizing":!0,"box-snap":!0,"box-suppress":!0,"break-after":!0,"break-before":!0,"break-inside":!0,"caption-side":!1,chains:!1,clear:!0,clip:!1,"clip-path":!1,"clip-rule":!1,color:!0,"color-interpolation-filters":!0,"column-count":!1,"column-fill":!1,"column-gap":!1,"column-rule":!1,"column-rule-color":!1,"column-rule-style":!1,"column-rule-width":!1,"column-span":!1,"column-width":!1,columns:!1,contain:!1,content:!1,"counter-increment":!1,"counter-reset":!1,"counter-set":!1,crop:!1,cue:!1,"cue-after":!1,"cue-before":!1,cursor:!1,direction:!1,display:!0,"display-inside":!0,"display-list":!0,"display-outside":!0,"dominant-baseline":!1,elevation:!1,"empty-cells":!1,filter:!1,flex:!1,"flex-basis":!1,"flex-direction":!1,"flex-flow":!1,"flex-grow":!1,"flex-shrink":!1,"flex-wrap":!1,float:!1,"float-offset":!1,"flood-color":!1,"flood-opacity":!1,"flow-from":!1,"flow-into":!1,font:!0,"font-family":!0,"font-feature-settings":!0,"font-kerning":!0,"font-language-override":!0,"font-size":!0,"font-size-adjust":!0,"font-stretch":!0,"font-style":!0,"font-synthesis":!0,"font-variant":!0,"font-variant-alternates":!0,"font-variant-caps":!0,"font-variant-east-asian":!0,"font-variant-ligatures":!0,"font-variant-numeric":!0,"font-variant-position":!0,"font-weight":!0,grid:!1,"grid-area":!1,"grid-auto-columns":!1,"grid-auto-flow":!1,"grid-auto-rows":!1,"grid-column":!1,"grid-column-end":!1,"grid-column-start":!1,"grid-row":!1,"grid-row-end":!1,"grid-row-start":!1,"grid-template":!1,"grid-template-areas":!1,"grid-template-columns":!1,"grid-template-rows":!1,"hanging-punctuation":!1,height:!0,hyphens:!1,icon:!1,"image-orientation":!1,"image-resolution":!1,"ime-mode":!1,"initial-letters":!1,"inline-box-align":!1,"justify-content":!1,"justify-items":!1,"justify-self":!1,left:!1,"letter-spacing":!0,"lighting-color":!0,"line-box-contain":!1,"line-break":!1,"line-grid":!1,"line-height":!1,"line-snap":!1,"line-stacking":!1,"line-stacking-ruby":!1,"line-stacking-shift":!1,"line-stacking-strategy":!1,"list-style":!0,"list-style-image":!0,"list-style-position":!0,"list-style-type":!0,margin:!0,"margin-bottom":!0,"margin-left":!0,"margin-right":!0,"margin-top":!0,"marker-offset":!1,"marker-side":!1,marks:!1,mask:!1,"mask-box":!1,"mask-box-outset":!1,"mask-box-repeat":!1,"mask-box-slice":!1,"mask-box-source":!1,"mask-box-width":!1,"mask-clip":!1,"mask-image":!1,"mask-origin":!1,"mask-position":!1,"mask-repeat":!1,"mask-size":!1,"mask-source-type":!1,"mask-type":!1,"max-height":!0,"max-lines":!1,"max-width":!0,"min-height":!0,"min-width":!0,"move-to":!1,"nav-down":!1,"nav-index":!1,"nav-left":!1,"nav-right":!1,"nav-up":!1,"object-fit":!1,"object-position":!1,opacity:!1,order:!1,orphans:!1,outline:!1,"outline-color":!1,"outline-offset":!1,"outline-style":!1,"outline-width":!1,overflow:!1,"overflow-wrap":!1,"overflow-x":!1,"overflow-y":!1,padding:!0,"padding-bottom":!0,"padding-left":!0,"padding-right":!0,"padding-top":!0,page:!1,"page-break-after":!1,"page-break-before":!1,"page-break-inside":!1,"page-policy":!1,pause:!1,"pause-after":!1,"pause-before":!1,perspective:!1,"perspective-origin":!1,pitch:!1,"pitch-range":!1,"play-during":!1,position:!1,"presentation-level":!1,quotes:!1,"region-fragment":!1,resize:!1,rest:!1,"rest-after":!1,"rest-before":!1,richness:!1,right:!1,rotation:!1,"rotation-point":!1,"ruby-align":!1,"ruby-merge":!1,"ruby-position":!1,"shape-image-threshold":!1,"shape-outside":!1,"shape-margin":!1,size:!1,speak:!1,"speak-as":!1,"speak-header":!1,"speak-numeral":!1,"speak-punctuation":!1,"speech-rate":!1,stress:!1,"string-set":!1,"tab-size":!1,"table-layout":!1,"text-align":!0,"text-align-last":!0,"text-combine-upright":!0,"text-decoration":!0,"text-decoration-color":!0,"text-decoration-line":!0,"text-decoration-skip":!0,"text-decoration-style":!0,"text-emphasis":!0,"text-emphasis-color":!0,"text-emphasis-position":!0,"text-emphasis-style":!0,"text-height":!0,"text-indent":!0,"text-justify":!0,"text-orientation":!0,"text-overflow":!0,"text-shadow":!0,"text-space-collapse":!0,"text-transform":!0,"text-underline-position":!0,"text-wrap":!0,top:!1,transform:!1,"transform-origin":!1,"transform-style":!1,transition:!1,"transition-delay":!1,"transition-duration":!1,"transition-property":!1,"transition-timing-function":!1,"unicode-bidi":!1,"vertical-align":!1,visibility:!1,"voice-balance":!1,"voice-duration":!1,"voice-family":!1,"voice-pitch":!1,"voice-range":!1,"voice-rate":!1,"voice-stress":!1,"voice-volume":!1,volume:!1,"white-space":!1,widows:!1,width:!0,"will-change":!1,"word-break":!0,"word-spacing":!0,"word-wrap":!0,"wrap-flow":!1,"wrap-through":!1,"writing-mode":!1,"z-index":!1};return t}var mA=/javascript\s*\:/gim;pA.whiteList=fA(),pA.getDefaultWhiteList=fA,pA.onAttr=function(t,e,i){},pA.onIgnoreAttr=function(t,e,i){},pA.safeAttrValue=function(t,e){return mA.test(e)?"":e};var vA={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,r;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,r=t.length;n<r;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},trimRight:function(t){return String.prototype.trimRight?t.trimRight():t.replace(/(\s*$)/g,"")}};var gA=function(t,e){";"!==(t=vA.trimRight(t))[t.length-1]&&(t+=";");var i=t.length,n=!1,r=0,o=0,s="";function a(){if(!n){var i=vA.trim(t.slice(r,o)),a=i.indexOf(":");if(-1!==a){var l=vA.trim(i.slice(0,a)),h=vA.trim(i.slice(a+1));if(l){var u=e(r,s.length,l,h,i);u&&(s+=u+"; ")}}}r=o+1}for(;o<i;o++){var l=t[o];if("/"===l&&"*"===t[o+1]){var h=t.indexOf("*/",o+2);if(-1===h)break;r=(o=h+1)+1,n=!1}else"("===l?n=!0:")"===l?n=!1:";"===l?n||a():"\n"===l&&a()}return vA.trim(s)},yA=pA,bA=gA;function _A(t){return null==t}function wA(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).whiteList=t.whiteList||yA.whiteList,t.onAttr=t.onAttr||yA.onAttr,t.onIgnoreAttr=t.onIgnoreAttr||yA.onIgnoreAttr,t.safeAttrValue=t.safeAttrValue||yA.safeAttrValue,this.options=t}wA.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onAttr,r=e.onIgnoreAttr,o=e.safeAttrValue,s=bA(t,(function(t,e,s,a,l){var h=i[s],u=!1;if(!0===h?u=h:"function"==typeof h?u=h(a):h instanceof RegExp&&(u=h.test(a)),!0!==u&&(u=!1),a=o(s,a)){var d,c={position:e,sourcePosition:t,source:l,isWhite:u};return u?_A(d=n(s,a,c))?s+":"+a:d:_A(d=r(s,a,c))?void 0:d}}));return s};var kA=wA;!function(t,e){var i=pA,n=kA;for(var r in e=t.exports=function(t,e){return new n(e).process(t)},e.FilterCSS=n,i)e[r]=i[r];"undefined"!=typeof window&&(window.filterCSS=t.exports)}(cA,dA);var xA={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,r;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,r=t.length;n<r;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},spaceIndex:function(t){var e=/\s|\n|\t/.exec(t);return e?e.index:-1}},DA=dA.FilterCSS,SA=dA.getDefaultWhiteList,CA=xA;function TA(){return{a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height"],ins:["datetime"],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]}}var MA=new DA;function OA(t){return t.replace(EA,"&lt;").replace(PA,"&gt;")}var EA=/</g,PA=/>/g,AA=/"/g,IA=/&quot;/g,LA=/&#([a-zA-Z0-9]*);?/gim,NA=/&colon;?/gim,RA=/&newline;?/gim,FA=/((j\s*a\s*v\s*a|v\s*b|l\s*i\s*v\s*e)\s*s\s*c\s*r\s*i\s*p\s*t\s*|m\s*o\s*c\s*h\s*a):/gi,jA=/e\s*x\s*p\s*r\s*e\s*s\s*s\s*i\s*o\s*n\s*\(.*/gi,YA=/u\s*r\s*l\s*\(.*/gi;function HA(t){return t.replace(AA,"&quot;")}function zA(t){return t.replace(IA,'"')}function BA(t){return t.replace(LA,(function(t,e){return"x"===e[0]||"X"===e[0]?String.fromCharCode(parseInt(e.substr(1),16)):String.fromCharCode(parseInt(e,10))}))}function GA(t){return t.replace(NA,":").replace(RA," ")}function WA(t){for(var e="",i=0,n=t.length;i<n;i++)e+=t.charCodeAt(i)<32?" ":t.charAt(i);return CA.trim(e)}function VA(t){return t=WA(t=GA(t=BA(t=zA(t))))}function UA(t){return t=OA(t=HA(t))}uA.whiteList={a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height"],ins:["datetime"],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]},uA.getDefaultWhiteList=TA,uA.onTag=function(t,e,i){},uA.onIgnoreTag=function(t,e,i){},uA.onTagAttr=function(t,e,i){},uA.onIgnoreTagAttr=function(t,e,i){},uA.safeAttrValue=function(t,e,i,n){if(i=VA(i),"href"===e||"src"===e){if("#"===(i=CA.trim(i)))return"#";if("http://"!==i.substr(0,7)&&"https://"!==i.substr(0,8)&&"mailto:"!==i.substr(0,7)&&"tel:"!==i.substr(0,4)&&"data:image/"!==i.substr(0,11)&&"ftp://"!==i.substr(0,6)&&"./"!==i.substr(0,2)&&"../"!==i.substr(0,3)&&"#"!==i[0]&&"/"!==i[0])return""}else if("background"===e){if(FA.lastIndex=0,FA.test(i))return""}else if("style"===e){if(jA.lastIndex=0,jA.test(i))return"";if(YA.lastIndex=0,YA.test(i)&&(FA.lastIndex=0,FA.test(i)))return"";!1!==n&&(i=(n=n||MA).process(i))}return i=UA(i)},uA.escapeHtml=OA,uA.escapeQuote=HA,uA.unescapeQuote=zA,uA.escapeHtmlEntities=BA,uA.escapeDangerHtml5Entities=GA,uA.clearNonPrintableCharacter=WA,uA.friendlyAttrValue=VA,uA.escapeAttrValue=UA,uA.onIgnoreTagStripAll=function(){return""},uA.StripTagBody=function(t,e){"function"!=typeof e&&(e=function(){});var i=!Array.isArray(t),n=[],r=!1;return{onIgnoreTag:function(o,s,a){if(function(e){return!!i||-1!==CA.indexOf(t,e)}(o)){if(a.isClosing){var l="[/removed]",h=a.position+l.length;return n.push([!1!==r?r:a.position,h]),r=!1,l}return r||(r=a.position),"[removed]"}return e(o,s,a)},remove:function(t){var e="",i=0;return CA.forEach(n,(function(n){e+=t.slice(i,n[0]),i=n[1]})),e+=t.slice(i)}}},uA.stripCommentTag=function(t){for(var e="",i=0;i<t.length;){var n=t.indexOf("\x3c!--",i);if(-1===n){e+=t.slice(i);break}e+=t.slice(i,n);var r=t.indexOf("--\x3e",n);if(-1===r)break;i=r+3}return e},uA.stripBlankChar=function(t){var e=t.split("");return(e=e.filter((function(t){var e=t.charCodeAt(0);return 127!==e&&(!(e<=31)||(10===e||13===e))}))).join("")},uA.cssFilter=MA,uA.getDefaultCSSWhiteList=SA;var XA={},qA=xA;function $A(t){var e,i=qA.spaceIndex(t);return e=-1===i?t.slice(1,-1):t.slice(1,i+1),"/"===(e=qA.trim(e).toLowerCase()).slice(0,1)&&(e=e.slice(1)),"/"===e.slice(-1)&&(e=e.slice(0,-1)),e}function ZA(t){return"</"===t.slice(0,2)}var KA=/[^a-zA-Z0-9\\_:.-]/gim;function JA(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"="===i?e:-1}}function QA(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"'"===i||'"'===i?e:-1}}function tI(t,e){for(;e>0;e--){var i=t[e];if(" "!==i)return"="===i?e:-1}}function eI(t){return function(t){return'"'===t[0]&&'"'===t[t.length-1]||"'"===t[0]&&"'"===t[t.length-1]}(t)?t.substr(1,t.length-2):t}XA.parseTag=function(t,e,i){var n="",r=0,o=!1,s=!1,a=0,l=t.length,h="",u="";t:for(a=0;a<l;a++){var d=t.charAt(a);if(!1===o){if("<"===d){o=a;continue}}else if(!1===s){if("<"===d){n+=i(t.slice(r,a)),o=a,r=a;continue}if(">"===d||a===l-1){n+=i(t.slice(r,o)),h=$A(u=t.slice(o,a+1)),n+=e(o,n.length,h,u,ZA(u)),r=a+1,o=!1;continue}if('"'===d||"'"===d)for(var c=1,p=t.charAt(a-c);""===p.trim()||"="===p;){if("="===p){s=d;continue t}p=t.charAt(a-++c)}}else if(d===s){s=!1;continue}}return r<l&&(n+=i(t.substr(r))),n},XA.parseAttr=function(t,e){var i=0,n=0,r=[],o=!1,s=t.length;function a(t,i){if(!((t=(t=qA.trim(t)).replace(KA,"").toLowerCase()).length<1)){var n=e(t,i||"");n&&r.push(n)}}for(var l=0;l<s;l++){var h,u=t.charAt(l);if(!1!==o||"="!==u)if(!1===o||l!==n)if(/\s|\n|\t/.test(u)){if(t=t.replace(/\s|\n|\t/g," "),!1===o){if(-1===(h=JA(t,l))){a(qA.trim(t.slice(i,l))),o=!1,i=l+1;continue}l=h-1;continue}if(-1===(h=tI(t,l-1))){a(o,eI(qA.trim(t.slice(i,l)))),o=!1,i=l+1;continue}}else;else{if(-1===(h=t.indexOf(u,l+1)))break;a(o,qA.trim(t.slice(n+1,h))),o=!1,i=(l=h)+1}else o=t.slice(i,l),i=l+1,n='"'===t.charAt(i)||"'"===t.charAt(i)?i:QA(t,l+1)}return i<t.length&&(!1===o?a(t.slice(i)):a(o,eI(qA.trim(t.slice(i))))),qA.trim(r.join(" "))};var iI=dA.FilterCSS,nI=uA,rI=XA,oI=rI.parseTag,sI=rI.parseAttr,aI=xA;function lI(t){return null==t}function hI(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).stripIgnoreTag&&(t.onIgnoreTag&&console.error('Notes: cannot use these two options "stripIgnoreTag" and "onIgnoreTag" at the same time'),t.onIgnoreTag=nI.onIgnoreTagStripAll),t.whiteList||t.allowList?t.whiteList=function(t){var e={};for(var i in t)Array.isArray(t[i])?e[i.toLowerCase()]=t[i].map((function(t){return t.toLowerCase()})):e[i.toLowerCase()]=t[i];return e}(t.whiteList||t.allowList):t.whiteList=nI.whiteList,t.onTag=t.onTag||nI.onTag,t.onTagAttr=t.onTagAttr||nI.onTagAttr,t.onIgnoreTag=t.onIgnoreTag||nI.onIgnoreTag,t.onIgnoreTagAttr=t.onIgnoreTagAttr||nI.onIgnoreTagAttr,t.safeAttrValue=t.safeAttrValue||nI.safeAttrValue,t.escapeHtml=t.escapeHtml||nI.escapeHtml,this.options=t,!1===t.css?this.cssFilter=!1:(t.css=t.css||{},this.cssFilter=new iI(t.css))}hI.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onTag,r=e.onIgnoreTag,o=e.onTagAttr,s=e.onIgnoreTagAttr,a=e.safeAttrValue,l=e.escapeHtml,h=this.cssFilter;e.stripBlankChar&&(t=nI.stripBlankChar(t)),e.allowCommentTag||(t=nI.stripCommentTag(t));var u=!1;e.stripIgnoreTagBody&&(u=nI.StripTagBody(e.stripIgnoreTagBody,r),r=u.onIgnoreTag);var d=oI(t,(function(t,e,u,d,c){var p={sourcePosition:t,position:e,isClosing:c,isWhite:Object.prototype.hasOwnProperty.call(i,u)},f=n(u,d,p);if(!lI(f))return f;if(p.isWhite){if(p.isClosing)return"</"+u+">";var m=function(t){var e=aI.spaceIndex(t);if(-1===e)return{html:"",closing:"/"===t[t.length-2]};var i="/"===(t=aI.trim(t.slice(e+1,-1)))[t.length-1];return i&&(t=aI.trim(t.slice(0,-1))),{html:t,closing:i}}(d),v=i[u],g=sI(m.html,(function(t,e){var i=-1!==aI.indexOf(v,t),n=o(u,t,e,i);return lI(n)?i?(e=a(u,t,e,h))?t+'="'+e+'"':t:lI(n=s(u,t,e,i))?void 0:n:n}));return d="<"+u,g&&(d+=" "+g),m.closing&&(d+=" /"),d+=">"}return lI(f=r(u,d,p))?l(d):f}),l);return u&&(d=u.remove(d)),d};var uI=hI;!function(t,e){var i=uA,n=XA,r=uI;function o(t,e){return new r(e).process(t)}(e=t.exports=o).filterXSS=o,e.FilterXSS=r,function(){for(var t in i)e[t]=i[t];for(var r in n)e[r]=n[r]}(),"undefined"!=typeof window&&(window.filterXSS=t.exports),"undefined"!=typeof self&&"undefined"!=typeof DedicatedWorkerGlobalScope&&self instanceof DedicatedWorkerGlobalScope&&(self.filterXSS=t.exports)}(hA,lA);var dI=lA;function cI(t,e){var i=vf(t);if(Mu){var n=Mu(t);e&&(n=eg(n).call(n,(function(e){return zu(t,e).enumerable}))),i.push.apply(i,n)}return i}function pI(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?sm(i=cI(Object(r),!0)).call(i,(function(e){Wc(t,e,r[e])})):ed?cd(t,ed(r)):sm(n=cI(Object(r))).call(n,(function(e){xd(t,e,zu(r,e))}))}return t}function fI(t){var e;if(!t)return!1;var i=null!==(e=t.idProp)&&void 0!==e?e:t._idProp;return!!i&&oA(i,t)}var mI=/^\/?Date\((-?\d+)/i,vI=/^\d+$/;function gI(t,e){var i;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return Lw(t)&&!isNaN(Date.parse(t))?aA(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":try{return gI(t,"Moment").toDate()}catch(i){throw i instanceof TypeError?new TypeError("Cannot convert object of type "+Yw(t)+" to type "+e):i}case"Moment":if(Iw(t))return aA(t);if(t instanceof Date)return aA(t.valueOf());if(aA.isMoment(t))return aA(t);if(Lw(t))return(i=mI.exec(t))?aA(Number(i[1])):(i=vI.exec(t),aA(i?Number(t):t));throw new TypeError("Cannot convert object of type "+Yw(t)+" to type "+e);case"ISODate":if(Iw(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(aA.isMoment(t))return t.toDate().toISOString();if(Lw(t))return(i=mI.exec(t))?new Date(Number(i[1])).toISOString():aA(t).format();throw new Error("Cannot convert object of type "+Yw(t)+" to type ISODate");case"ASPDate":if(Iw(t))return"/Date("+t+")/";if(t instanceof Date||aA.isMoment(t))return"/Date("+t.valueOf()+")/";if(Lw(t))return"/Date("+((i=mI.exec(t))?new Date(Number(i[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+Yw(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function yI(t){var e,i,n,r,o,s,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{start:"Date",end:"Date"},l=t._idProp,h=new nA({fieldId:l}),u=uf(e=function(t){return new JP(t)}(t)).call(e,(function(t){var e;return aM(e=vf(t)).call(e,(function(e,i){return e[i]=gI(t[i],a[i]),e}),{})})).to(h);return u.all().start(),{add:function(){var e;return(e=t.getDataSet()).add.apply(e,arguments)},remove:function(){var e;return(e=t.getDataSet()).remove.apply(e,arguments)},update:function(){var e;return(e=t.getDataSet()).update.apply(e,arguments)},updateOnly:function(){var e;return(e=t.getDataSet()).updateOnly.apply(e,arguments)},clear:function(){var e;return(e=t.getDataSet()).clear.apply(e,arguments)},forEach:Vf(i=sm(h)).call(i,h),get:Vf(n=h.get).call(n,h),getIds:Vf(r=h.getIds).call(r,h),off:Vf(o=h.off).call(o,h),on:Vf(s=h.on).call(s,h),get length(){return h.length},idProp:l,type:a,rawDS:t,coercedDS:h,dispose:function(){return u.stop()}}}var bI=function(t){var e=new dI.FilterXSS(t);return function(t){return e.process(t)}},_I=function(t){return t},wI=bI(),kI=pI(pI({},gk),{},{convert:gI,setupXSSProtection:function(t){t&&(!0===t.disabled?(wI=_I,console.warn("You disabled XSS protection for vis-Timeline. I sure hope you know what you're doing!")):t.filterOptions&&(wI=bI(t.filterOptions)))}});xd(kI,"xss",{get:function(){return wI}});var xI={},DI={get exports(){return xI},set exports(t){xI=t}},SI=x,CI=d,TI=Nt,MI=Dg.trim,OI=vg,EI=g("".charAt),PI=SI.parseFloat,AI=SI.Symbol,II=AI&&AI.iterator,LI=1/PI(OI+"-0")!=-1/0||II&&!CI((function(){PI(Object(II))}))?function(t){var e=MI(TI(t)),i=PI(e);return 0===i&&"-"==EI(e,0)?-0:i}:PI;Pn({global:!0,forced:parseFloat!=LI},{parseFloat:LI});var NI=pe.parseFloat;DI.exports=NI;var RI=e(xI),FI=function(){function t(e,i){Dd(this,t),this.options=null,this.props=null}return Gc(t,[{key:"setOptions",value:function(t){t&&kI.extend(this.options,t)}},{key:"redraw",value:function(){return!1}},{key:"destroy",value:function(){}},{key:"_isResized",value:function(){var t=this.props._previousWidth!==this.props.width||this.props._previousHeight!==this.props.height;return this.props._previousWidth=this.props.width,this.props._previousHeight=this.props.height,t}}]),t}(),jI={},YI={get exports(){return jI},set exports(t){jI=t}},HI=w,zI=Nt,BI=F,GI=RangeError;Pn({target:"String",proto:!0},{repeat:function(t){var e=zI(BI(this)),i="",n=HI(t);if(n<0||n==1/0)throw GI("Wrong number of repetitions");for(;n>0;(n>>>=1)&&(e+=e))1&n&&(i+=e);return i}});var WI=gp("String").repeat,VI=be,UI=WI,XI=String.prototype,qI=function(t){var e=t.repeat;return"string"==typeof t||t===XI||VI(XI,t)&&e===XI.repeat?UI:e},$I=qI;YI.exports=$I;var ZI=e(jI);function KI(t,e,i){if(i&&!Qp(i))return KI(t,e,[i]);if(e.hiddenDates=[],i&&1==Qp(i)){for(var n,r=0;r<i.length;r++)if(void 0===ZI(i[r])){var o={};o.start=t(i[r].start).toDate().valueOf(),o.end=t(i[r].end).toDate().valueOf(),e.hiddenDates.push(o)}PE(n=e.hiddenDates).call(n,(function(t,e){return t.start-e.start}))}}function JI(t,e,i){if(i&&!Qp(i))return JI(t,e,[i]);if(i&&void 0!==e.domProps.centerContainer.width){KI(t,e,i);for(var n=t(e.range.start),r=t(e.range.end),o=(e.range.end-e.range.start)/e.domProps.centerContainer.width,s=0;s<i.length;s++)if(void 0!==ZI(i[s])){var a=t(i[s].start),l=t(i[s].end);if("Invalid Date"==a._d)throw new Error("Supplied start date is not valid: ".concat(i[s].start));if("Invalid Date"==l._d)throw new Error("Supplied end date is not valid: ".concat(i[s].end));if(l-a>=4*o){var h=0,u=r.clone();switch(ZI(i[s])){case"daily":a.day()!=l.day()&&(h=1),a.dayOfYear(n.dayOfYear()),a.year(n.year()),a.subtract(7,"days"),l.dayOfYear(n.dayOfYear()),l.year(n.year()),l.subtract(7-h,"days"),u.add(1,"weeks");break;case"weekly":var d=l.diff(a,"days"),c=a.day();a.date(n.date()),a.month(n.month()),a.year(n.year()),l=a.clone(),a.day(c),l.day(c),l.add(d,"days"),a.subtract(1,"weeks"),l.subtract(1,"weeks"),u.add(1,"weeks");break;case"monthly":a.month()!=l.month()&&(h=1),a.month(n.month()),a.year(n.year()),a.subtract(1,"months"),l.month(n.month()),l.year(n.year()),l.subtract(1,"months"),l.add(h,"months"),u.add(1,"months");break;case"yearly":a.year()!=l.year()&&(h=1),a.year(n.year()),a.subtract(1,"years"),l.year(n.year()),l.subtract(1,"years"),l.add(h,"years"),u.add(1,"years");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",ZI(i[s]))}for(;a<u;)switch(e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()}),ZI(i[s])){case"daily":a.add(1,"days"),l.add(1,"days");break;case"weekly":a.add(1,"weeks"),l.add(1,"weeks");break;case"monthly":a.add(1,"months"),l.add(1,"months");break;case"yearly":a.add(1,"y"),l.add(1,"y");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",ZI(i[s]))}e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()})}}QI(e);var p=hL(e.range.start,e.hiddenDates),f=hL(e.range.end,e.hiddenDates),m=e.range.start,v=e.range.end;1==p.hidden&&(m=1==e.range.startToFront?p.startDate-1:p.endDate+1),1==f.hidden&&(v=1==e.range.endToFront?f.startDate-1:f.endDate+1),1!=p.hidden&&1!=f.hidden||e.range._applyRange(m,v)}}function QI(t){for(var e,i=t.hiddenDates,n=[],r=0;r<i.length;r++)for(var o=0;o<i.length;o++)r!=o&&1!=i[o].remove&&1!=i[r].remove&&(i[o].start>=i[r].start&&i[o].end<=i[r].end?i[o].remove=!0:i[o].start>=i[r].start&&i[o].start<=i[r].end?(i[r].end=i[o].end,i[o].remove=!0):i[o].end>=i[r].start&&i[o].end<=i[r].end&&(i[r].start=i[o].start,i[o].remove=!0));for(r=0;r<i.length;r++)!0!==i[r].remove&&n.push(i[r]);t.hiddenDates=n,PE(e=t.hiddenDates).call(e,(function(t,e){return t.start-e.start}))}function tL(t,e,i){for(var n=!1,r=e.current.valueOf(),o=0;o<e.hiddenDates.length;o++){var s=e.hiddenDates[o].start,a=e.hiddenDates[o].end;if(r>=s&&r<a){n=!0;break}}if(1==n&&r<e._end.valueOf()&&r!=i){var l=t(i),h=t(a);l.year()!=h.year()?e.switchedYear=!0:l.month()!=h.month()?e.switchedMonth=!0:l.dayOfYear()!=h.dayOfYear()&&(e.switchedDay=!0),e.current=h}}function eL(t,e,i){var n;if(0==t.body.hiddenDates.length)return n=t.range.conversion(i),(e.valueOf()-n.offset)*n.scale;var r=hL(e,t.body.hiddenDates);1==r.hidden&&(e=r.startDate);var o=nL(t.body.hiddenDates,t.range.start,t.range.end);if(e<t.range.start){n=t.range.conversion(i,o);var s=rL(t.body.hiddenDates,e,n.offset);return e=t.options.moment(e).toDate().valueOf(),e+=s,-(n.offset-e.valueOf())*n.scale}if(e>t.range.end){var a={start:t.range.start,end:e};return e=oL(t.options.moment,t.body.hiddenDates,a,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}return e=oL(t.options.moment,t.body.hiddenDates,t.range,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}function iL(t,e,i){if(0==t.body.hiddenDates.length){var n=t.range.conversion(i);return new Date(e/n.scale+n.offset)}var r=nL(t.body.hiddenDates,t.range.start,t.range.end),o=(t.range.end-t.range.start-r)*e/i,s=aL(t.body.hiddenDates,t.range,o);return new Date(s+o+t.range.start)}function nL(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<i&&(n+=s-o)}return n}function rL(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<=i&&(n+=s-o)}return n}function oL(t,e,i,n){return n=t(n).toDate().valueOf(),n-=sL(t,e,i,n)}function sL(t,e,i,n){var r=0;n=t(n).toDate().valueOf();for(var o=0;o<e.length;o++){var s=e[o].start,a=e[o].end;s>=i.start&&a<i.end&&n>=a&&(r+=a-s)}return r}function aL(t,e,i){for(var n=0,r=0,o=e.start,s=0;s<t.length;s++){var a=t[s].start,l=t[s].end;if(a>=e.start&&l<e.end){if(r+=a-o,o=l,r>=i)break;n+=l-a}}return n}function lL(t,e,i,n){var r=hL(e,t);return 1==r.hidden?i<0?1==n?r.startDate-(r.endDate-e)-1:r.startDate-1:1==n?r.endDate+(e-r.startDate)+1:r.endDate+1:e}function hL(t,e){for(var i=0;i<e.length;i++){var n=e[i].start,r=e[i].end;if(t>=n&&t<r)return{hidden:!0,startDate:n,endDate:r}}return{hidden:!1,startDate:n,endDate:r}}var uL=Object.freeze({__proto__:null,convertHiddenOptions:KI,correctTimeForHidden:oL,getAccumulatedHiddenDuration:aL,getHiddenDurationBefore:sL,getHiddenDurationBeforeStart:rL,getHiddenDurationBetween:nL,getIsHidden:hL,printDates:function(t){for(var e=0;e<t.length;e++)console.log(e,new Date(t[e].start),new Date(t[e].end),t[e].start,t[e].end,t[e].remove)},removeDuplicates:QI,snapAwayFromHidden:lL,stepOverHiddenDates:tL,toScreen:eL,toTime:iL,updateHiddenDates:JI});function dL(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}var cL=function(t){Vk(i,FI);var e=dL(i);function i(t,n){var r,o,s,a,l,h,u,d;Dd(this,i),d=e.call(this);var c=sA().hours(0).minutes(0).seconds(0).milliseconds(0),p=c.clone().add(-3,"days").valueOf(),f=c.clone().add(3,"days").valueOf();return d.millisecondsPerPixelCache=void 0,void 0===n?(d.start=p,d.end=f):(d.start=n.start||p,d.end=n.end||f),d.rolling=!1,d.body=t,d.deltaDifference=0,d.scaleOffset=0,d.startToFront=!1,d.endToFront=!0,d.defaultOptions={rtl:!1,start:null,end:null,moment:sA,direction:"horizontal",moveable:!0,zoomable:!0,min:null,max:null,zoomMin:10,zoomMax:31536e10,rollingMode:{follow:!1,offset:.5}},d.options=kI.extend({},d.defaultOptions),d.props={touch:{}},d.animationTimer=null,d.body.emitter.on("panstart",Vf(r=d._onDragStart).call(r,Tk(d))),d.body.emitter.on("panmove",Vf(o=d._onDrag).call(o,Tk(d))),d.body.emitter.on("panend",Vf(s=d._onDragEnd).call(s,Tk(d))),d.body.emitter.on("mousewheel",Vf(a=d._onMouseWheel).call(a,Tk(d))),d.body.emitter.on("touch",Vf(l=d._onTouch).call(l,Tk(d))),d.body.emitter.on("pinch",Vf(h=d._onPinch).call(h,Tk(d))),d.body.dom.rollingModeBtn.addEventListener("click",Vf(u=d.startRolling).call(u,Tk(d))),d.setOptions(n),d}return Gc(i,[{key:"setOptions",value:function(t){if(t){kI.selectiveExtend(["animation","direction","min","max","zoomMin","zoomMax","moveable","zoomable","moment","activate","hiddenDates","zoomKey","zoomFriction","rtl","showCurrentTime","rollingMode","horizontalScroll"],this.options,t),t.rollingMode&&t.rollingMode.follow&&this.startRolling(),("start"in t||"end"in t)&&this.setRange(t.start,t.end)}}},{key:"startRolling",value:function(){var t=this;!function e(){t.stopRolling(),t.rolling=!0;var i=t.end-t.start,n=kI.convert(new Date,"Date").valueOf(),r=t.options.rollingMode&&t.options.rollingMode.offset||.5,o=n-i*r,s=n+i*(1-r);t.setRange(o,s,{animation:!1}),(i=1/t.conversion(t.body.domProps.center.width).scale/10)<30&&(i=30),i>1e3&&(i=1e3),t.body.dom.rollingModeBtn.style.visibility="hidden",t.currentTimeTimer=Vy(e,i)}()}},{key:"stopRolling",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),this.rolling=!1,this.body.dom.rollingModeBtn.style.visibility="visible")}},{key:"setRange",value:function(t,e,i,n,r){i||(i={}),!0!==i.byUser&&(i.byUser=!1);var o=this,s=null!=t?kI.convert(t,"Date").valueOf():null,a=null!=e?kI.convert(e,"Date").valueOf():null;if(this._cancelAnimation(),this.millisecondsPerPixelCache=void 0,i.animation){var l,h=this.start,u=this.end,d="object"===Lc(i.animation)&&"duration"in i.animation?i.animation.duration:500,c="object"===Lc(i.animation)&&"easingFunction"in i.animation?i.animation.easingFunction:"easeInOutQuad",p=kI.easingFunctions[c];if(!p)throw new Error(Vp(l="Unknown easing function ".concat(ky(c),". Choose from: ")).call(l,vf(kI.easingFunctions).join(", ")));var f=xf(),m=!1;return function t(){if(!o.props.touch.dragging){var e=xf()-f,l=p(e/d),c=e>d,g=c||null===s?s:h+(s-h)*l,y=c||null===a?a:u+(a-u)*l;v=o._applyRange(g,y),JI(o.options.moment,o.body,o.options.hiddenDates),m=m||v;var b={start:new Date(o.start),end:new Date(o.end),byUser:i.byUser,event:i.event};if(r&&r(l,v,c),v&&o.body.emitter.emit("rangechange",b),c){if(m&&(o.body.emitter.emit("rangechanged",b),n))return n()}else o.animationTimer=Vy(t,20)}}()}var v=this._applyRange(s,a);if(JI(this.options.moment,this.body,this.options.hiddenDates),v){var g={start:new Date(this.start),end:new Date(this.end),byUser:i.byUser,event:i.event};if(this.body.emitter.emit("rangechange",g),clearTimeout(o.timeoutID),o.timeoutID=Vy((function(){o.body.emitter.emit("rangechanged",g)}),200),n)return n()}}},{key:"getMillisecondsPerPixel",value:function(){return void 0===this.millisecondsPerPixelCache&&(this.millisecondsPerPixelCache=(this.end-this.start)/this.body.dom.center.clientWidth),this.millisecondsPerPixelCache}},{key:"_cancelAnimation",value:function(){this.animationTimer&&(clearTimeout(this.animationTimer),this.animationTimer=null)}},{key:"_applyRange",value:function(t,e){var i,n=null!=t?kI.convert(t,"Date").valueOf():this.start,r=null!=e?kI.convert(e,"Date").valueOf():this.end,o=null!=this.options.max?kI.convert(this.options.max,"Date").valueOf():null,s=null!=this.options.min?kI.convert(this.options.min,"Date").valueOf():null;if(isNaN(n)||null===n)throw new Error('Invalid start "'.concat(t,'"'));if(isNaN(r)||null===r)throw new Error('Invalid end "'.concat(e,'"'));if(r<n&&(r=n),null!==s&&n<s&&(n+=i=s-n,r+=i,null!=o&&r>o&&(r=o)),null!==o&&r>o&&(n-=i=r-o,r-=i,null!=s&&n<s&&(n=s)),null!==this.options.zoomMin){var a=RI(this.options.zoomMin);if(a<0&&(a=0),r-n<a){this.end-this.start===a&&n>=this.start-.5&&r<=this.end?(n=this.start,r=this.end):(n-=(i=a-(r-n))/2,r+=i/2)}}if(null!==this.options.zoomMax){var l=RI(this.options.zoomMax);l<0&&(l=0),r-n>l&&(this.end-this.start===l&&n<this.start&&r>this.end?(n=this.start,r=this.end):(n+=(i=r-n-l)/2,r-=i/2))}var h=this.start!=n||this.end!=r;return n>=this.start&&n<=this.end||r>=this.start&&r<=this.end||this.start>=n&&this.start<=r||this.end>=n&&this.end<=r||this.body.emitter.emit("checkRangedItems"),this.start=n,this.end=r,h}},{key:"getRange",value:function(){return{start:this.start,end:this.end}}},{key:"conversion",value:function(t,e){return i.conversion(this.start,this.end,t,e)}},{key:"_onDragStart",value:function(t){this.deltaDifference=0,this.previousDelta=0,this.options.moveable&&this._isInsideRange(t)&&this.props.touch.allowDragging&&(this.stopRolling(),this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.dragging=!0,this.body.dom.root&&(this.body.dom.root.style.cursor="move"))}},{key:"_onDrag",value:function(t){if(t&&this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging){var e=this.options.direction;pL(e);var i="horizontal"==e?t.deltaX:t.deltaY;i-=this.deltaDifference;var n=this.props.touch.end-this.props.touch.start;n-=nL(this.body.hiddenDates,this.start,this.end);var r,o="horizontal"==e?this.body.domProps.center.width:this.body.domProps.center.height;r=this.options.rtl?i/o*n:-i/o*n;var s=this.props.touch.start+r,a=this.props.touch.end+r,l=lL(this.body.hiddenDates,s,this.previousDelta-i,!0),h=lL(this.body.hiddenDates,a,this.previousDelta-i,!0);if(l!=s||h!=a)return this.deltaDifference+=i,this.props.touch.start=l,this.props.touch.end=h,void this._onDrag(t);this.previousDelta=i,this._applyRange(s,a);var u=new Date(this.start),d=new Date(this.end);this.body.emitter.emit("rangechange",{start:u,end:d,byUser:!0,event:t}),this.body.emitter.emit("panmove")}}},{key:"_onDragEnd",value:function(t){this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging&&(this.props.touch.dragging=!1,this.body.dom.root&&(this.body.dom.root.style.cursor="auto"),this.body.emitter.emit("rangechanged",{start:new Date(this.start),end:new Date(this.end),byUser:!0,event:t}))}},{key:"_onMouseWheel",value:function(t){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail?e=-t.detail/3:t.deltaY&&(e=-t.deltaY/3),!(this.options.zoomKey&&!t[this.options.zoomKey]&&this.options.zoomable||!this.options.zoomable&&this.options.moveable)&&this.options.zoomable&&this.options.moveable&&this._isInsideRange(t)&&e){var i,n,r=this.options.zoomFriction||5;if(i=e<0?1-e/r:1/(1+e/r),this.rolling){var o=this.options.rollingMode&&this.options.rollingMode.offset||.5;n=this.start+(this.end-this.start)*o}else{var s=this.getPointer({x:t.clientX,y:t.clientY},this.body.dom.center);n=this._pointerToDate(s)}this.zoom(i,n,e,t),t.preventDefault()}}},{key:"_onTouch",value:function(t){this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.allowDragging=!0,this.props.touch.center=null,this.props.touch.centerDate=null,this.scaleOffset=0,this.deltaDifference=0,kI.preventDefault(t)}},{key:"_onPinch",value:function(t){if(this.options.zoomable&&this.options.moveable){kI.preventDefault(t),this.props.touch.allowDragging=!1,this.props.touch.center||(this.props.touch.center=this.getPointer(t.center,this.body.dom.center),this.props.touch.centerDate=this._pointerToDate(this.props.touch.center)),this.stopRolling();var e=1/(t.scale+this.scaleOffset),i=this.props.touch.centerDate,n=nL(this.body.hiddenDates,this.start,this.end),r=sL(this.options.moment,this.body.hiddenDates,this,i),o=n-r,s=i-r+(this.props.touch.start-(i-r))*e,a=i+o+(this.props.touch.end-(i+o))*e;this.startToFront=1-e<=0,this.endToFront=e-1<=0;var l=lL(this.body.hiddenDates,s,1-e,!0),h=lL(this.body.hiddenDates,a,e-1,!0);l==s&&h==a||(this.props.touch.start=l,this.props.touch.end=h,this.scaleOffset=1-t.scale,s=l,a=h);var u={animation:!1,byUser:!0,event:t};this.setRange(s,a,u),this.startToFront=!1,this.endToFront=!0}}},{key:"_isInsideRange",value:function(t){var e=t.center?t.center.x:t.clientX,i=this.body.dom.centerContainer.getBoundingClientRect(),n=this.options.rtl?e-i.left:i.right-e,r=this.body.util.toTime(n);return r>=this.start&&r<=this.end}},{key:"_pointerToDate",value:function(t){var e,i=this.options.direction;if(pL(i),"horizontal"==i)return this.body.util.toTime(t.x).valueOf();var n=this.body.domProps.center.height;return e=this.conversion(n),t.y/e.scale+e.offset}},{key:"getPointer",value:function(t,e){var i=e.getBoundingClientRect();return this.options.rtl?{x:i.right-t.x,y:t.y-i.top}:{x:t.x-i.left,y:t.y-i.top}}},{key:"zoom",value:function(t,e,i,n){null==e&&(e=(this.start+this.end)/2);var r=nL(this.body.hiddenDates,this.start,this.end),o=sL(this.options.moment,this.body.hiddenDates,this,e),s=r-o,a=e-o+(this.start-(e-o))*t,l=e+s+(this.end-(e+s))*t;this.startToFront=!(i>0),this.endToFront=!(-i>0);var h=lL(this.body.hiddenDates,a,i,!0),u=lL(this.body.hiddenDates,l,-i,!0);h==a&&u==l||(a=h,l=u);var d={animation:!1,byUser:!0,event:n};this.setRange(a,l,d),this.startToFront=!1,this.endToFront=!0}},{key:"move",value:function(t){var e=this.end-this.start,i=this.start+e*t,n=this.end+e*t;this.start=i,this.end=n}},{key:"moveTo",value:function(t){var e=(this.start+this.end)/2-t,i=this.start-e,n=this.end-e;this.setRange(i,n,{animation:!1,byUser:!0,event:null})}}],[{key:"conversion",value:function(t,e,i,n){return void 0===n&&(n=0),0!=i&&e-t!=0?{offset:t,scale:i/(e-t-n)}:{offset:0,scale:1}}}]),i}();function pL(t){if("horizontal"!=t&&"vertical"!=t)throw new TypeError('Unknown direction "'.concat(t,'". Choose "horizontal" or "vertical".'))}var fL={},mL=pe.setInterval;({get exports(){return fL},set exports(t){fL=t}}).exports=mL;var vL,gL=e(fL),yL=null;"undefined"!=typeof window?vL=function t(e,i){var n=i||{preventDefault:!1};if(e.Manager){var r=e,o=function(e,i){var o=Object.create(n);return i&&r.assign(o,i),t(new r(e,o),o)};return r.assign(o,r),o.Manager=function(e,i){var o=Object.create(n);return i&&r.assign(o,i),t(new r.Manager(e,o),o)},o}var s=Object.create(e),a=e.element;function l(t){return t.match(/[^ ]+/g)}function h(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var i=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof i&&(t.srcEvent.stopPropagation=function(){i(),t.stopPropagation()}),t.firstTarget=yL;for(var n=yL;n&&!e;){var r=n.hammer;if(r)for(var o,s=0;s<r.length;s++)if(o=r[s]._handlers[t.type])for(var a=0;a<o.length&&!e;a++)o[a](t);n=n.parentNode}}return a.hammer||(a.hammer=[]),a.hammer.push(s),e.on("hammer.input",(function(t){!0!==n.preventDefault&&n.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(yL=t.target)})),s._handlers={},s.on=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n||(s._handlers[t]=n=[],e.on(t,h)),n.push(i)})),s},s.off=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n&&((n=i?n.filter((function(t){return t!==i})):[]).length>0?s._handlers[t]=n:(e.off(t,h),delete s._handlers[t]))})),s},s.emit=function(t,i){yL=i.target,e.emit(t,i)},s.destroy=function(){var t=e.element.hammer,i=t.indexOf(s);-1!==i&&t.splice(i,1),t.length||delete e.element.hammer,s._handlers={},e.destroy()},s}(window.Hammer||mw,{preventDefault:"mouse"}):vL=function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(e){return{set:t}}}}()};var bL=vL;function _L(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}var wL=function(){function t(e,i,n,r,o){Dd(this,t),this.moment=o&&o.moment||sA,this.options=o||{},this.current=this.moment(),this._start=this.moment(),this._end=this.moment(),this.autoScale=!0,this.scale="day",this.step=1,this.setRange(e,i,n),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,Qp(r)?this.hiddenDates=r:this.hiddenDates=null!=r?[r]:[],this.format=t.FORMAT}return Gc(t,[{key:"setMoment",value:function(t){this.moment=t,this.current=this.moment(this.current.valueOf()),this._start=this.moment(this._start.valueOf()),this._end=this.moment(this._end.valueOf())}},{key:"setFormat",value:function(e){var i=kI.deepExtend({},t.FORMAT);this.format=kI.deepExtend(i,e)}},{key:"setRange",value:function(t,e,i){if(!(t instanceof Date&&e instanceof Date))throw"No legal start or end date in method setRange";this._start=null!=t?this.moment(t.valueOf()):xf(),this._end=null!=e?this.moment(e.valueOf()):xf(),this.autoScale&&this.setMinimumStep(i)}},{key:"start",value:function(){this.current=this._start.clone(),this.roundToMinor()}},{key:"roundToMinor",value:function(){switch("week"==this.scale&&this.current.weekday(0),this.scale){case"year":this.current.year(this.step*Math.floor(this.current.year()/this.step)),this.current.month(0);case"month":this.current.date(1);case"week":case"day":case"weekday":this.current.hours(0);case"hour":this.current.minutes(0);case"minute":this.current.seconds(0);case"second":this.current.milliseconds(0)}if(1!=this.step){var t=this.current.clone();switch(this.scale){case"millisecond":this.current.subtract(this.current.milliseconds()%this.step,"milliseconds");break;case"second":this.current.subtract(this.current.seconds()%this.step,"seconds");break;case"minute":this.current.subtract(this.current.minutes()%this.step,"minutes");break;case"hour":this.current.subtract(this.current.hours()%this.step,"hours");break;case"weekday":case"day":this.current.subtract((this.current.date()-1)%this.step,"day");break;case"week":this.current.subtract(this.current.week()%this.step,"week");break;case"month":this.current.subtract(this.current.month()%this.step,"month");break;case"year":this.current.subtract(this.current.year()%this.step,"year")}t.isSame(this.current)||(this.current=this.moment(lL(this.hiddenDates,this.current.valueOf(),-1,!0)))}}},{key:"hasNext",value:function(){return this.current.valueOf()<=this._end.valueOf()}},{key:"next",value:function(){var t=this.current.valueOf();switch(this.scale){case"millisecond":this.current.add(this.step,"millisecond");break;case"second":this.current.add(this.step,"second");break;case"minute":this.current.add(this.step,"minute");break;case"hour":this.current.add(this.step,"hour"),this.current.month()<6?this.current.subtract(this.current.hours()%this.step,"hour"):this.current.hours()%this.step!=0&&this.current.add(this.step-this.current.hours()%this.step,"hour");break;case"weekday":case"day":this.current.add(this.step,"day");break;case"week":if(0!==this.current.weekday())this.current.weekday(0),this.current.add(this.step,"week");else if(!1===this.options.showMajorLabels)this.current.add(this.step,"week");else{var e=this.current.clone();e.add(1,"week"),e.isSame(this.current,"month")?this.current.add(this.step,"week"):(this.current.add(this.step,"week"),this.current.date(1))}break;case"month":this.current.add(this.step,"month");break;case"year":this.current.add(this.step,"year")}if(1!=this.step)switch(this.scale){case"millisecond":this.current.milliseconds()>0&&this.current.milliseconds()<this.step&&this.current.milliseconds(0);break;case"second":this.current.seconds()>0&&this.current.seconds()<this.step&&this.current.seconds(0);break;case"minute":this.current.minutes()>0&&this.current.minutes()<this.step&&this.current.minutes(0);break;case"hour":this.current.hours()>0&&this.current.hours()<this.step&&this.current.hours(0);break;case"weekday":case"day":this.current.date()<this.step+1&&this.current.date(1);break;case"week":this.current.week()<this.step&&this.current.week(1);break;case"month":this.current.month()<this.step&&this.current.month(0)}this.current.valueOf()==t&&(this.current=this._end.clone()),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,tL(this.moment,this,t)}},{key:"getCurrent",value:function(){return this.current.clone()}},{key:"setScale",value:function(t){t&&"string"==typeof t.scale&&(this.scale=t.scale,this.step=t.step>0?t.step:1,this.autoScale=!1)}},{key:"setAutoScale",value:function(t){this.autoScale=t}},{key:"setMinimumStep",value:function(t){if(null!=t){var e=31104e6,i=2592e6,n=864e5,r=36e5,o=6e4,s=1e3;1e3*e>t&&(this.scale="year",this.step=1e3),500*e>t&&(this.scale="year",this.step=500),100*e>t&&(this.scale="year",this.step=100),50*e>t&&(this.scale="year",this.step=50),10*e>t&&(this.scale="year",this.step=10),5*e>t&&(this.scale="year",this.step=5),e>t&&(this.scale="year",this.step=1),7776e6>t&&(this.scale="month",this.step=3),i>t&&(this.scale="month",this.step=1),6048e5>t&&this.options.showWeekScale&&(this.scale="week",this.step=1),1728e5>t&&(this.scale="day",this.step=2),n>t&&(this.scale="day",this.step=1),432e5>t&&(this.scale="weekday",this.step=1),144e5>t&&(this.scale="hour",this.step=4),r>t&&(this.scale="hour",this.step=1),9e5>t&&(this.scale="minute",this.step=15),6e5>t&&(this.scale="minute",this.step=10),3e5>t&&(this.scale="minute",this.step=5),o>t&&(this.scale="minute",this.step=1),15e3>t&&(this.scale="second",this.step=15),1e4>t&&(this.scale="second",this.step=10),5e3>t&&(this.scale="second",this.step=5),s>t&&(this.scale="second",this.step=1),200>t&&(this.scale="millisecond",this.step=200),100>t&&(this.scale="millisecond",this.step=100),50>t&&(this.scale="millisecond",this.step=50),10>t&&(this.scale="millisecond",this.step=10),5>t&&(this.scale="millisecond",this.step=5),1>t&&(this.scale="millisecond",this.step=1)}}},{key:"isMajor",value:function(){if(1==this.switchedYear)switch(this.scale){case"year":case"month":case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedMonth)switch(this.scale){case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedDay)switch(this.scale){case"millisecond":case"second":case"minute":case"hour":return!0;default:return!1}var t=this.moment(this.current);switch(this.scale){case"millisecond":return 0==t.milliseconds();case"second":return 0==t.seconds();case"minute":return 0==t.hours()&&0==t.minutes();case"hour":return 0==t.hours();case"weekday":case"day":return this.options.showWeekScale?1==t.isoWeekday():1==t.date();case"week":return 1==t.date();case"month":return 0==t.month();default:return!1}}},{key:"getLabelMinor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.minorLabels)return this.format.minorLabels(t,this.scale,this.step);var e=this.format.minorLabels[this.scale];return"week"===this.scale&&1===t.date()&&0!==t.weekday()?"":e&&e.length>0?this.moment(t).format(e):""}},{key:"getLabelMajor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.majorLabels)return this.format.majorLabels(t,this.scale,this.step);var e=this.format.majorLabels[this.scale];return e&&e.length>0?this.moment(t).format(e):""}},{key:"getClassName",value:function(){var t,e=this.moment,i=this.moment(this.current),n=i.locale?i.locale("en"):i.lang("en"),r=this.step,o=[];function s(t){return t/r%2==0?" vis-even":" vis-odd"}function a(t){return t.isSame(xf(),"day")?" vis-today":t.isSame(e().add(1,"day"),"day")?" vis-tomorrow":t.isSame(e().add(-1,"day"),"day")?" vis-yesterday":""}function l(t){return t.isSame(xf(),"week")?" vis-current-week":""}function h(t){return t.isSame(xf(),"month")?" vis-current-month":""}switch(this.scale){case"millisecond":o.push(a(n)),o.push(s(n.milliseconds()));break;case"second":o.push(a(n)),o.push(s(n.seconds()));break;case"minute":o.push(a(n)),o.push(s(n.minutes()));break;case"hour":o.push(Vp(t="vis-h".concat(n.hours())).call(t,4==this.step?"-h"+(n.hours()+4):"")),o.push(a(n)),o.push(s(n.hours()));break;case"weekday":o.push("vis-".concat(n.format("dddd").toLowerCase())),o.push(a(n)),o.push(l(n)),o.push(s(n.date()));break;case"day":o.push("vis-day".concat(n.date())),o.push("vis-".concat(n.format("MMMM").toLowerCase())),o.push(a(n)),o.push(h(n)),o.push(this.step<=2?a(n):""),o.push(this.step<=2?"vis-".concat(n.format("dddd").toLowerCase()):""),o.push(s(n.date()-1));break;case"week":o.push("vis-week".concat(n.format("w"))),o.push(l(n)),o.push(s(n.week()));break;case"month":o.push("vis-".concat(n.format("MMMM").toLowerCase())),o.push(h(n)),o.push(s(n.month()));break;case"year":o.push("vis-year".concat(n.year())),o.push(function(t){return t.isSame(xf(),"year")?" vis-current-year":""}(n)),o.push(s(n.year()))}return eg(o).call(o,String).join(" ")}}],[{key:"snap",value:function(t,e,i){var n=sA(t);if("year"==e){var r=n.year()+Math.round(n.month()/12);n.year(Math.round(r/i)*i),n.month(0),n.date(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("month"==e)n.date()>15?(n.date(1),n.add(1,"month")):n.date(1),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("week"==e)n.weekday()>2?(n.weekday(0),n.add(1,"week")):n.weekday(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("day"==e){switch(i){case 5:case 2:n.hours(24*Math.round(n.hours()/24));break;default:n.hours(12*Math.round(n.hours()/12))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("weekday"==e){switch(i){case 5:case 2:n.hours(12*Math.round(n.hours()/12));break;default:n.hours(6*Math.round(n.hours()/6))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("hour"==e){if(4===i)n.minutes(60*Math.round(n.minutes()/60));else n.minutes(30*Math.round(n.minutes()/30));n.seconds(0),n.milliseconds(0)}else if("minute"==e){switch(i){case 15:case 10:n.minutes(5*Math.round(n.minutes()/5)),n.seconds(0);break;case 5:n.seconds(60*Math.round(n.seconds()/60));break;default:n.seconds(30*Math.round(n.seconds()/30))}n.milliseconds(0)}else if("second"==e)switch(i){case 15:case 10:n.seconds(5*Math.round(n.seconds()/5)),n.milliseconds(0);break;case 5:n.milliseconds(1e3*Math.round(n.milliseconds()/1e3));break;default:n.milliseconds(500*Math.round(n.milliseconds()/500))}else if("millisecond"==e){var o=i>5?i/2:1;n.milliseconds(Math.round(n.milliseconds()/o)*o)}return n}}]),t}();function kL(t,e){void 0===e&&(e={});var i=e.insertAt;if(t&&"undefined"!=typeof document){var n=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style");r.type="text/css","top"===i&&n.firstChild?n.insertBefore(r,n.firstChild):n.appendChild(r),r.styleSheet?r.styleSheet.cssText=t:r.appendChild(document.createTextNode(t))}}wL.FORMAT={minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}};function xL(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}kL(".vis-time-axis{overflow:hidden;position:relative}.vis-time-axis.vis-foreground{left:0;top:0;width:100%}.vis-time-axis.vis-background{height:100%;left:0;position:absolute;top:0;width:100%}.vis-time-axis .vis-text{box-sizing:border-box;color:#4d4d4d;overflow:hidden;padding:3px;position:absolute;white-space:nowrap}.vis-time-axis .vis-text.vis-measure{margin-left:0;margin-right:0;padding-left:0;padding-right:0;position:absolute;visibility:hidden}.vis-time-axis .vis-grid.vis-vertical{border-left:1px solid;position:absolute}.vis-time-axis .vis-grid.vis-vertical-rtl{border-right:1px solid;position:absolute}.vis-time-axis .vis-grid.vis-minor{border-color:#e5e5e5}.vis-time-axis .vis-grid.vis-major{border-color:#bfbfbf}");var DL=function(t){Vk(i,FI);var e=xL(i);function i(t,n){var r;return Dd(this,i),(r=e.call(this)).dom={foreground:null,lines:[],majorTexts:[],minorTexts:[],redundant:{lines:[],majorTexts:[],minorTexts:[]}},r.props={range:{start:0,end:0,minimumStep:0},lineTop:0},r.defaultOptions={orientation:{axis:"bottom"},showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,maxMinorChars:7,format:kI.extend({},wL.FORMAT),moment:sA,timeAxis:null},r.options=kI.extend({},r.defaultOptions),r.body=t,r._create(),r.setOptions(n),r}return Gc(i,[{key:"setOptions",value:function(t){t&&(kI.selectiveExtend(["showMinorLabels","showMajorLabels","showWeekScale","maxMinorChars","hiddenDates","timeAxis","moment","rtl"],this.options,t),kI.selectiveDeepExtend(["format"],this.options,t),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.axis=t.orientation:"object"===Lc(t.orientation)&&"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis)),"locale"in t&&("function"==typeof sA.locale?sA.locale(t.locale):sA.lang(t.locale)))}},{key:"_create",value:function(){this.dom.foreground=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.foreground.className="vis-time-axis vis-foreground",this.dom.background.className="vis-time-axis vis-background"}},{key:"destroy",value:function(){this.dom.foreground.parentNode&&this.dom.foreground.parentNode.removeChild(this.dom.foreground),this.dom.background.parentNode&&this.dom.background.parentNode.removeChild(this.dom.background),this.body=null}},{key:"redraw",value:function(){var t=this.props,e=this.dom.foreground,i=this.dom.background,n="top"==this.options.orientation.axis?this.body.dom.top:this.body.dom.bottom,r=e.parentNode!==n;this._calculateCharSize();var o=this.options.showMinorLabels&&"none"!==this.options.orientation.axis,s=this.options.showMajorLabels&&"none"!==this.options.orientation.axis;t.minorLabelHeight=o?t.minorCharHeight:0,t.majorLabelHeight=s?t.majorCharHeight:0,t.height=t.minorLabelHeight+t.majorLabelHeight,t.width=e.offsetWidth,t.minorLineHeight=this.body.domProps.root.height-t.majorLabelHeight-("top"==this.options.orientation.axis?this.body.domProps.bottom.height:this.body.domProps.top.height),t.minorLineWidth=1,t.majorLineHeight=t.minorLineHeight+t.majorLabelHeight,t.majorLineWidth=1;var a=e.nextSibling,l=i.nextSibling;return e.parentNode&&e.parentNode.removeChild(e),i.parentNode&&i.parentNode.removeChild(i),e.style.height="".concat(this.props.height,"px"),this._repaintLabels(),a?n.insertBefore(e,a):n.appendChild(e),l?this.body.dom.backgroundVertical.insertBefore(i,l):this.body.dom.backgroundVertical.appendChild(i),this._isResized()||r}},{key:"_repaintLabels",value:function(){var t=this.options.orientation.axis,e=kI.convert(this.body.range.start,"Number"),i=kI.convert(this.body.range.end,"Number"),n=this.body.util.toTime((this.props.minorCharWidth||10)*this.options.maxMinorChars).valueOf(),r=n-sL(this.options.moment,this.body.hiddenDates,this.body.range,n);r-=this.body.util.toTime(0).valueOf();var o=new wL(new Date(e),new Date(i),r,this.body.hiddenDates,this.options);o.setMoment(this.options.moment),this.options.format&&o.setFormat(this.options.format),this.options.timeAxis&&o.setScale(this.options.timeAxis),this.step=o;var s,a,l,h,u,d,c=this.dom;c.redundant.lines=c.lines,c.redundant.majorTexts=c.majorTexts,c.redundant.minorTexts=c.minorTexts,c.lines=[],c.majorTexts=[],c.minorTexts=[];var p,f,m,v=0,g=void 0,y=0,b=1e3;for(o.start(),a=o.getCurrent(),h=this.body.util.toScreen(a);o.hasNext()&&y<b;){if(y++,u=o.isMajor(),m=o.getClassName(),s=a,l=h,o.next(),a=o.getCurrent(),p=v,v=(h=this.body.util.toScreen(a))-l,"week"===o.scale)d=!0;else d=v>=.4*p;if(this.options.showMinorLabels&&d){var _=this._repaintMinorText(l,o.getLabelMinor(s),t,m);_.style.width="".concat(v,"px")}u&&this.options.showMajorLabels?(l>0&&(null==g&&(g=l),_=this._repaintMajorText(l,o.getLabelMajor(s),t,m)),f=this._repaintMajorLine(l,v,t,m)):d?f=this._repaintMinorLine(l,v,t,m):f&&(f.style.width="".concat(jg(f.style.width)+v,"px"))}if(y!==b||SL||(console.warn("Something is wrong with the Timeline scale. Limited drawing of grid lines to ".concat(b," lines.")),SL=!0),this.options.showMajorLabels){var w=this.body.util.toTime(0),k=o.getLabelMajor(w),x=k.length*(this.props.majorCharWidth||10)+10;(null==g||x<g)&&this._repaintMajorText(0,k,t,m)}sm(kI).call(kI,this.dom.redundant,(function(t){for(;t.length;){var e=t.pop();e&&e.parentNode&&e.parentNode.removeChild(e)}}))}},{key:"_repaintMinorText",value:function(t,e,i,n){var r=this.dom.redundant.minorTexts.shift();if(!r){var o=document.createTextNode("");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}this.dom.minorTexts.push(r),r.innerHTML=kI.xss(e);var s="top"==i?this.props.majorLabelHeight:0;return this._setXY(r,t,s),r.className="vis-text vis-minor ".concat(n),r}},{key:"_repaintMajorText",value:function(t,e,i,n){var r=this.dom.redundant.majorTexts.shift();if(!r){var o=document.createElement("div");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}r.childNodes[0].innerHTML=kI.xss(e),r.className="vis-text vis-major ".concat(n);var s="top"==i?0:this.props.minorLabelHeight;return this._setXY(r,t,s),this.dom.majorTexts.push(r),r}},{key:"_setXY",value:function(t,e,i){var n,r=this.options.rtl?-1*e:e;t.style.transform=Vp(n="translate(".concat(r,"px, ")).call(n,i,"px)")}},{key:"_repaintMinorLine",value:function(t,e,i,n){var r,o=this.dom.redundant.lines.shift();o||(o=document.createElement("div"),this.dom.background.appendChild(o)),this.dom.lines.push(o);var s=this.props;o.style.width="".concat(e,"px"),o.style.height="".concat(s.minorLineHeight,"px");var a="top"==i?s.majorLabelHeight:this.body.domProps.top.height,l=t-s.minorLineWidth/2;return this._setXY(o,l,a),o.className=Vp(r="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-minor ")).call(r,n),o}},{key:"_repaintMajorLine",value:function(t,e,i,n){var r,o=this.dom.redundant.lines.shift();o||(o=document.createElement("div"),this.dom.background.appendChild(o)),this.dom.lines.push(o);var s=this.props;o.style.width="".concat(e,"px"),o.style.height="".concat(s.majorLineHeight,"px");var a="top"==i?0:this.body.domProps.top.height,l=t-s.majorLineWidth/2;return this._setXY(o,l,a),o.className=Vp(r="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-major ")).call(r,n),o}},{key:"_calculateCharSize",value:function(){this.dom.measureCharMinor||(this.dom.measureCharMinor=document.createElement("DIV"),this.dom.measureCharMinor.className="vis-text vis-minor vis-measure",this.dom.measureCharMinor.style.position="absolute",this.dom.measureCharMinor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMinor)),this.props.minorCharHeight=this.dom.measureCharMinor.clientHeight,this.props.minorCharWidth=this.dom.measureCharMinor.clientWidth,this.dom.measureCharMajor||(this.dom.measureCharMajor=document.createElement("DIV"),this.dom.measureCharMajor.className="vis-text vis-major vis-measure",this.dom.measureCharMajor.style.position="absolute",this.dom.measureCharMajor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMajor)),this.props.majorCharHeight=this.dom.measureCharMajor.clientHeight,this.props.majorCharWidth=this.dom.measureCharMajor.clientWidth}}]),i}(),SL=!1;function CL(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,r={},o={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){h(t,"keydown")},l=function(t){h(t,"keyup")},h=function(t,e){if(void 0!==o[e][t.keyCode]){for(var n=o[e][t.keyCode],r=0;r<n.length;r++)(void 0===n[r].shift||1==n[r].shift&&1==t.shiftKey||0==n[r].shift&&0==t.shiftKey)&&n[r].fn(t);1==i&&t.preventDefault()}};return r.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===o[i][s[t].code]&&(o[i][s[t].code]=[]),o[i][s[t].code].push({fn:e,shift:s[t].shift})},r.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&r.bind(i,t,e)},r.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},r.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],r=o[i][s[t].code];if(void 0!==r)for(var a=0;a<r.length;a++)r[a].fn==e&&r[a].shift==s[t].shift||n.push(o[i][s[t].code][a]);o[i][s[t].code]=n}else o[i][s[t].code]=[]},r.reset=function(){o={keydown:{},keyup:{}}},r.destroy=function(){o={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",l,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",l,!0),r}function TL(t){var e,i;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=bL(this.dom.overlay),this.hammer.on("tap",Vf(e=this._onTapOverlay).call(e,this));var n=this,r=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];sm(r).call(r,(function(t){n.hammer.on(t,(function(t){t.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=CL(),this.escListener=Vf(i=this.deactivate).call(i,this)}kL(".vis .overlay{height:100%;left:0;position:absolute;top:0;width:100%;z-index:10}.vis-active{box-shadow:0 0 10px #86d5f8}"),sb(TL.prototype),TL.current=null,TL.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},TL.prototype.activate=function(){var t;TL.current&&TL.current.deactivate(),TL.current=this,this.active=!0,this.dom.overlay.style.display="none",kI.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),Vf(t=this.keycharm).call(t,"esc",this.escListener)},TL.prototype.deactivate=function(){TL.current===this&&(TL.current=null),this.active=!1,this.dom.overlay.style.display="",kI.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},TL.prototype._onTapOverlay=function(t){this.activate(),t.stopPropagation()};var ML={current:"current",time:"time",deleteSelected:"Delete selected"},OL={current:"attuale",time:"tempo",deleteSelected:"Cancella la selezione"},EL={current:"huidige",time:"tijd",deleteSelected:"Selectie verwijderen"},PL={current:"Aktuelle",time:"Zeit",deleteSelected:"Lösche Auswahl"},AL={current:"actuel",time:"heure",deleteSelected:"Effacer la selection"},IL={current:"corriente",time:"hora",deleteSelected:"Eliminar selección"},LL={current:"поточний",time:"час",deleteSelected:"Видалити обране"},NL={current:"текущее",time:"время",deleteSelected:"Удалить выбранное"},RL={current:"aktualny",time:"czas",deleteSelected:"Usuń wybrane"},FL={current:"atual",time:"data",deleteSelected:"Apagar selecionado"},jL={current:"現在",time:"時刻",deleteSelected:"選択されたものを削除"},YL={current:"nuvarande",time:"tid",deleteSelected:"Radera valda"},HL={current:"nåværende",time:"tid",deleteSelected:"Slett valgte"},zL={current:"einamas",time:"laikas",deleteSelected:"Pašalinti pasirinktą"},BL={en:ML,en_EN:ML,en_US:ML,it:OL,it_IT:OL,it_CH:OL,nl:EL,nl_NL:EL,nl_BE:EL,de:PL,de_DE:PL,fr:AL,fr_FR:AL,fr_CA:AL,fr_BE:AL,es:IL,es_ES:IL,uk:LL,uk_UA:LL,ru:NL,ru_RU:NL,pl:RL,pl_PL:RL,pt:FL,pt_BR:FL,pt_PT:FL,ja:jL,ja_JP:jL,lt:zL,lt_LT:zL,sv:YL,sv_SE:YL,nb:HL,nn:HL,nb_NO:HL,nn_NO:HL};function GL(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}kL(".vis-custom-time{background-color:#6e94ff;cursor:move;width:2px;z-index:1}.vis-custom-time>.vis-custom-time-marker{background-color:inherit;color:#fff;cursor:auto;font-size:12px;padding:3px 5px;top:0;white-space:nowrap;z-index:inherit}");var WL=function(t){Vk(i,FI);var e=GL(i);function i(t,n){var r,o;Dd(this,i),(o=e.call(this)).body=t,o.defaultOptions={moment:sA,locales:BL,locale:"en",id:void 0,title:void 0},o.options=kI.extend({},o.defaultOptions),o.setOptions(n),o.options.locales=kI.extend({},BL,o.options.locales);var s=o.defaultOptions.locales[o.defaultOptions.locale];return sm(r=vf(o.options.locales)).call(r,(function(t){o.options.locales[t]=kI.extend({},s,o.options.locales[t])})),n&&null!=n.time?o.customTime=n.time:o.customTime=new Date,o.eventParams={},o._create(),o}return Gc(i,[{key:"setOptions",value:function(t){t&&kI.selectiveExtend(["moment","locale","locales","id","title","rtl","snap"],this.options,t)}},{key:"_create",value:function(){var t,e,i,n=document.createElement("div");n["custom-time"]=this,n.className="vis-custom-time ".concat(this.options.id||""),n.style.position="absolute",n.style.top="0px",n.style.height="100%",this.bar=n;var r=document.createElement("div");function o(t){this.body.range._onMouseWheel(t)}r.style.position="relative",r.style.top="0px",this.options.rtl?r.style.right="-10px":r.style.left="-10px",r.style.height="100%",r.style.width="20px",r.addEventListener?(r.addEventListener("mousewheel",Vf(o).call(o,this),!1),r.addEventListener("DOMMouseScroll",Vf(o).call(o,this),!1)):r.attachEvent("onmousewheel",Vf(o).call(o,this)),n.appendChild(r),this.hammer=new bL(r),this.hammer.on("panstart",Vf(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Vf(e=this._onDrag).call(e,this)),this.hammer.on("panend",Vf(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:bL.DIRECTION_ALL}),this.hammer.get("press").set({time:1e4})}},{key:"destroy",value:function(){this.hide(),this.hammer.destroy(),this.hammer=null,this.body=null}},{key:"redraw",value:function(){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar));var e=this.body.util.toScreen(this.customTime),i=this.options.locales[this.options.locale];i||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),i=this.options.locales.en);var n,r=this.options.title;void 0===r?r=(r=Vp(n="".concat(i.time,": ")).call(n,this.options.moment(this.customTime).format("dddd, MMMM Do YYYY, H:mm:ss"))).charAt(0).toUpperCase()+r.substring(1):"function"==typeof r&&(r=r.call(this,this.customTime));return this.options.rtl?this.bar.style.right="".concat(e,"px"):this.bar.style.left="".concat(e,"px"),this.bar.title=r,!1}},{key:"hide",value:function(){this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar)}},{key:"setCustomTime",value:function(t){this.customTime=kI.convert(t,"Date"),this.redraw()}},{key:"getCustomTime",value:function(){return new Date(this.customTime.valueOf())}},{key:"setCustomMarker",value:function(t,e){var i,n,r=document.createElement("div");(r.className="vis-custom-time-marker",r.innerHTML=kI.xss(t),r.style.position="absolute",e)&&(r.setAttribute("contenteditable","true"),r.addEventListener("pointerdown",(function(){r.focus()})),r.addEventListener("input",Vf(i=this._onMarkerChange).call(i,this)),r.title=t,r.addEventListener("blur",Vf(n=function(t){this.title!=t.target.innerHTML&&(this._onMarkerChanged(t),this.title=t.target.innerHTML)}).call(n,this)));this.bar.appendChild(r)}},{key:"setCustomTitle",value:function(t){this.options.title=t}},{key:"_onDragStart",value:function(t){this.eventParams.dragging=!0,this.eventParams.customTime=this.customTime,t.stopPropagation()}},{key:"_onDrag",value:function(t){if(this.eventParams.dragging){var e=this.options.rtl?-1*t.deltaX:t.deltaX,i=this.body.util.toScreen(this.eventParams.customTime)+e,n=this.body.util.toTime(i),r=this.body.util.getScale(),o=this.body.util.getStep(),s=this.options.snap,a=s?s(n,r,o):n;this.setCustomTime(a),this.body.emitter.emit("timechange",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation()}}},{key:"_onDragEnd",value:function(t){this.eventParams.dragging&&(this.body.emitter.emit("timechanged",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation())}},{key:"_onMarkerChange",value:function(t){this.body.emitter.emit("markerchange",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}},{key:"_onMarkerChanged",value:function(t){this.body.emitter.emit("markerchanged",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}}],[{key:"customTimeFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("custom-time"))return e["custom-time"];e=e.parentNode}return null}}]),i}();kL("");kL('.vis-current-time{background-color:#ff7f6e;pointer-events:none;width:2px;z-index:1}.vis-rolling-mode-btn{background:#3876c2;border-radius:50%;color:#fff;cursor:pointer;font-size:28px;font-weight:700;height:40px;opacity:.8;position:absolute;right:20px;text-align:center;top:7px;width:40px}.vis-rolling-mode-btn:before{content:"\\26F6"}.vis-rolling-mode-btn:hover{opacity:1}');kL(".vis-panel{box-sizing:border-box;margin:0;padding:0;position:absolute}.vis-panel.vis-bottom,.vis-panel.vis-center,.vis-panel.vis-left,.vis-panel.vis-right,.vis-panel.vis-top{border:1px #bfbfbf}.vis-panel.vis-center,.vis-panel.vis-left,.vis-panel.vis-right{border-bottom-style:solid;border-top-style:solid;overflow:hidden}.vis-left.vis-panel.vis-vertical-scroll,.vis-right.vis-panel.vis-vertical-scroll{height:100%;overflow-x:hidden;overflow-y:scroll}.vis-left.vis-panel.vis-vertical-scroll{direction:rtl}.vis-left.vis-panel.vis-vertical-scroll .vis-content,.vis-right.vis-panel.vis-vertical-scroll{direction:ltr}.vis-right.vis-panel.vis-vertical-scroll .vis-content{direction:rtl}.vis-panel.vis-bottom,.vis-panel.vis-center,.vis-panel.vis-top{border-left-style:solid;border-right-style:solid}.vis-background{overflow:hidden}.vis-panel>.vis-content{position:relative}.vis-panel .vis-shadow{box-shadow:0 0 10px rgba(0,0,0,.8);height:1px;position:absolute;width:100%}.vis-panel .vis-shadow.vis-top{left:0;top:-1px}.vis-panel .vis-shadow.vis-bottom{bottom:-1px;left:0}");kL(".vis-graph-group0{fill:#4f81bd;fill-opacity:0;stroke-width:2px;stroke:#4f81bd}.vis-graph-group1{fill:#f79646;fill-opacity:0;stroke-width:2px;stroke:#f79646}.vis-graph-group2{fill:#8c51cf;fill-opacity:0;stroke-width:2px;stroke:#8c51cf}.vis-graph-group3{fill:#75c841;fill-opacity:0;stroke-width:2px;stroke:#75c841}.vis-graph-group4{fill:#ff0100;fill-opacity:0;stroke-width:2px;stroke:#ff0100}.vis-graph-group5{fill:#37d8e6;fill-opacity:0;stroke-width:2px;stroke:#37d8e6}.vis-graph-group6{fill:#042662;fill-opacity:0;stroke-width:2px;stroke:#042662}.vis-graph-group7{fill:#00ff26;fill-opacity:0;stroke-width:2px;stroke:#00ff26}.vis-graph-group8{fill:#f0f;fill-opacity:0;stroke-width:2px;stroke:#f0f}.vis-graph-group9{fill:#8f3938;fill-opacity:0;stroke-width:2px;stroke:#8f3938}.vis-timeline .vis-fill{fill-opacity:.1;stroke:none}.vis-timeline .vis-bar{fill-opacity:.5;stroke-width:1px}.vis-timeline .vis-point{stroke-width:2px;fill-opacity:1}.vis-timeline .vis-legend-background{stroke-width:1px;fill-opacity:.9;fill:#fff;stroke:#c2c2c2}.vis-timeline .vis-outline{stroke-width:1px;fill-opacity:1;fill:#fff;stroke:#e5e5e5}.vis-timeline .vis-icon-fill{fill-opacity:.3;stroke:none}");kL(".vis-timeline{border:1px solid #bfbfbf;box-sizing:border-box;margin:0;overflow:hidden;padding:0;position:relative}.vis-loading-screen{height:100%;left:0;position:absolute;top:0;width:100%}");kL(".vis [class*=span]{min-height:0;width:auto}");var VL=function(){function t(){Dd(this,t)}return Gc(t,[{key:"_create",value:function(t){var e,i,n,r=this;this.dom={},this.dom.container=t,this.dom.container.style.position="relative",this.dom.root=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.backgroundVertical=document.createElement("div"),this.dom.backgroundHorizontal=document.createElement("div"),this.dom.centerContainer=document.createElement("div"),this.dom.leftContainer=document.createElement("div"),this.dom.rightContainer=document.createElement("div"),this.dom.center=document.createElement("div"),this.dom.left=document.createElement("div"),this.dom.right=document.createElement("div"),this.dom.top=document.createElement("div"),this.dom.bottom=document.createElement("div"),this.dom.shadowTop=document.createElement("div"),this.dom.shadowBottom=document.createElement("div"),this.dom.shadowTopLeft=document.createElement("div"),this.dom.shadowBottomLeft=document.createElement("div"),this.dom.shadowTopRight=document.createElement("div"),this.dom.shadowBottomRight=document.createElement("div"),this.dom.rollingModeBtn=document.createElement("div"),this.dom.loadingScreen=document.createElement("div"),this.dom.root.className="vis-timeline",this.dom.background.className="vis-panel vis-background",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical",this.dom.backgroundHorizontal.className="vis-panel vis-background vis-horizontal",this.dom.centerContainer.className="vis-panel vis-center",this.dom.leftContainer.className="vis-panel vis-left",this.dom.rightContainer.className="vis-panel vis-right",this.dom.top.className="vis-panel vis-top",this.dom.bottom.className="vis-panel vis-bottom",this.dom.left.className="vis-content",this.dom.center.className="vis-content",this.dom.right.className="vis-content",this.dom.shadowTop.className="vis-shadow vis-top",this.dom.shadowBottom.className="vis-shadow vis-bottom",this.dom.shadowTopLeft.className="vis-shadow vis-top",this.dom.shadowBottomLeft.className="vis-shadow vis-bottom",this.dom.shadowTopRight.className="vis-shadow vis-top",this.dom.shadowBottomRight.className="vis-shadow vis-bottom",this.dom.rollingModeBtn.className="vis-rolling-mode-btn",this.dom.loadingScreen.className="vis-loading-screen",this.dom.root.appendChild(this.dom.background),this.dom.root.appendChild(this.dom.backgroundVertical),this.dom.root.appendChild(this.dom.backgroundHorizontal),this.dom.root.appendChild(this.dom.centerContainer),this.dom.root.appendChild(this.dom.leftContainer),this.dom.root.appendChild(this.dom.rightContainer),this.dom.root.appendChild(this.dom.top),this.dom.root.appendChild(this.dom.bottom),this.dom.root.appendChild(this.dom.rollingModeBtn),this.dom.centerContainer.appendChild(this.dom.center),this.dom.leftContainer.appendChild(this.dom.left),this.dom.rightContainer.appendChild(this.dom.right),this.dom.centerContainer.appendChild(this.dom.shadowTop),this.dom.centerContainer.appendChild(this.dom.shadowBottom),this.dom.leftContainer.appendChild(this.dom.shadowTopLeft),this.dom.leftContainer.appendChild(this.dom.shadowBottomLeft),this.dom.rightContainer.appendChild(this.dom.shadowTopRight),this.dom.rightContainer.appendChild(this.dom.shadowBottomRight),this.props={root:{},background:{},centerContainer:{},leftContainer:{},rightContainer:{},center:{},left:{},right:{},top:{},bottom:{},border:{},scrollTop:0,scrollTopMin:0},this.on("rangechange",(function(){!0===r.initialDrawDone&&r._redraw()})),this.on("rangechanged",(function(){r.initialRangeChangeDone||(r.initialRangeChangeDone=!0)})),this.on("touch",Vf(e=this._onTouch).call(e,this)),this.on("panmove",Vf(i=this._onDrag).call(i,this));var o=this;this._origRedraw=Vf(n=this._redraw).call(n,this),this._redraw=kI.throttle(this._origRedraw),this.on("_change",(function(t){o.itemSet&&o.itemSet.initialItemSetDrawn&&t&&1==t.queue?o._redraw():o._origRedraw()})),this.hammer=new bL(this.dom.root);var s=this.hammer.get("pinch").set({enable:!0});s&&function(t){t.getTouchAction=function(){return["pan-y"]}}(s),this.hammer.get("pan").set({threshold:5,direction:bL.DIRECTION_ALL}),this.timelineListeners={};var a,l,h=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];function u(t){this.isActive()&&this.emit("mousewheel",t);var e=0,i=0;if("detail"in t&&(i=-1*t.detail),"wheelDelta"in t&&(i=t.wheelDelta),"wheelDeltaY"in t&&(i=t.wheelDeltaY),"wheelDeltaX"in t&&(e=-1*t.wheelDeltaX),"axis"in t&&t.axis===t.HORIZONTAL_AXIS&&(e=-1*i,i=0),"deltaY"in t&&(i=-1*t.deltaY),"deltaX"in t&&(e=t.deltaX),t.deltaMode&&(1===t.deltaMode?(e*=40,i*=40):(e*=40,i*=800)),this.options.preferZoom){if(!this.options.zoomKey||t[this.options.zoomKey])return}else if(this.options.zoomKey&&t[this.options.zoomKey])return;if(this.options.verticalScroll||this.options.horizontalScroll)if(this.options.verticalScroll&&Math.abs(i)>=Math.abs(e)){var n=this.props.scrollTop,r=n+i;if(this.isActive())this._setScrollTop(r)!==n&&(this._redraw(),this.emit("scroll",t),t.preventDefault())}else if(this.options.horizontalScroll){var o=(Math.abs(e)>=Math.abs(i)?e:i)/120*(this.range.end-this.range.start)/20,s=this.range.start+o,a=this.range.end+o,l={animation:!1,byUser:!0,event:t};this.range.setRange(s,a,l),t.preventDefault()}}sm(h).call(h,(function(t){var e=function(e){o.isActive()&&o.emit(t,e)};o.hammer.on(t,e),o.timelineListeners[t]=e})),_L(this.hammer,(function(t){o.emit("touch",t)})),a=this.hammer,(l=function(t){o.emit("release",t)}).inputHandler=function(t){t.isFinal&&l(t)},a.on("hammer.input",l.inputHandler);var d="onwheel"in document.createElement("div")?"wheel":void 0!==document.onmousewheel?"mousewheel":this.dom.centerContainer.addEventListener?"DOMMouseScroll":"onmousewheel";function c(t){if(o.options.verticalScroll&&(t.preventDefault(),o.isActive())){var e=-t.target.scrollTop;o._setScrollTop(e),o._redraw(),o.emit("scrollSide",t)}}this.dom.top.addEventListener,this.dom.bottom.addEventListener,this.dom.centerContainer.addEventListener(d,Vf(u).call(u,this),!1),this.dom.top.addEventListener(d,Vf(u).call(u,this),!1),this.dom.bottom.addEventListener(d,Vf(u).call(u,this),!1),this.dom.left.parentNode.addEventListener("scroll",Vf(c).call(c,this)),this.dom.right.parentNode.addEventListener("scroll",Vf(c).call(c,this));var p=!1;function f(t){var e;if(t.preventDefault&&(o.emit("dragover",o.getEventProperties(t)),t.preventDefault()),Jg(e=t.target.className).call(e,"timeline")>-1&&!p)return t.dataTransfer.dropEffect="move",p=!0,!1}function m(t){t.preventDefault&&t.preventDefault(),t.stopPropagation&&t.stopPropagation();try{var e=JSON.parse(t.dataTransfer.getData("text"));if(!e||!e.content)return}catch(t){return!1}return p=!1,t.center={x:t.clientX,y:t.clientY},"item"!==e.target?o.itemSet._onAddItem(t):o.itemSet._onDropObjectOnItem(t),o.emit("drop",o.getEventProperties(t)),!1}if(this.dom.center.addEventListener("dragover",Vf(f).call(f,this),!1),this.dom.center.addEventListener("drop",Vf(m).call(m,this),!1),this.customTimes=[],this.touch={},this.redrawCount=0,this.initialDrawDone=!1,this.initialRangeChangeDone=!1,!t)throw new Error("No container provided");t.appendChild(this.dom.root),t.appendChild(this.dom.loadingScreen)}},{key:"setOptions",value:function(t){var e;if(t){if(kI.selectiveExtend(["width","height","minHeight","maxHeight","autoResize","start","end","clickToUse","dataAttributes","hiddenDates","locale","locales","moment","preferZoom","rtl","zoomKey","horizontalScroll","verticalScroll","longSelectPressTime","snap"],this.options,t),this.dom.rollingModeBtn.style.visibility="hidden",this.options.rtl&&(this.dom.container.style.direction="rtl",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical-rtl"),this.options.verticalScroll&&(this.options.rtl?this.dom.rightContainer.className="vis-panel vis-right vis-vertical-scroll":this.dom.leftContainer.className="vis-panel vis-left vis-vertical-scroll"),"object"!==Lc(this.options.orientation)&&(this.options.orientation={item:void 0,axis:void 0}),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation={item:t.orientation,axis:t.orientation}:"object"===Lc(t.orientation)&&("item"in t.orientation&&(this.options.orientation.item=t.orientation.item),"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis))),"both"===this.options.orientation.axis){if(!this.timeAxis2){var i=this.timeAxis2=new DL(this.body);i.setOptions=function(t){var e=t?kI.extend({},t):{};e.orientation="top",DL.prototype.setOptions.call(i,e)},this.components.push(i)}}else if(this.timeAxis2){var n,r,o=Jg(n=this.components).call(n,this.timeAxis2);if(-1!==o)$m(r=this.components).call(r,o,1);this.timeAxis2.destroy(),this.timeAxis2=null}"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),"hiddenDates"in this.options&&KI(this.options.moment,this.body,this.options.hiddenDates),"clickToUse"in t&&(t.clickToUse?this.activator||(this.activator=new TL(this.dom.root)):this.activator&&(this.activator.destroy(),delete this.activator)),this._initAutoResize()}if(sm(e=this.components).call(e,(function(e){return e.setOptions(t)})),"configure"in t){var s;this.configurator||(this.configurator=this._createConfigurator()),this.configurator.setOptions(t.configure);var a=kI.deepExtend({},this.options);sm(s=this.components).call(s,(function(t){kI.deepExtend(a,t.options)})),this.configurator.setModuleOptions({global:a})}this._redraw()}},{key:"isActive",value:function(){return!this.activator||this.activator.active}},{key:"destroy",value:function(){var t;for(var e in this.setItems(null),this.setGroups(null),this.off(),this._stopAutoResize(),this.dom.root.parentNode&&this.dom.root.parentNode.removeChild(this.dom.root),this.dom=null,this.activator&&(this.activator.destroy(),delete this.activator),this.timelineListeners)this.timelineListeners.hasOwnProperty(e)&&delete this.timelineListeners[e];this.timelineListeners=null,this.hammer&&this.hammer.destroy(),this.hammer=null,sm(t=this.components).call(t,(function(t){return t.destroy()})),this.body=null}},{key:"setCustomTime",value:function(t,e){var i,n=eg(i=this.customTimes).call(i,(function(t){return e===t.options.id}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(ky(e)));n.length>0&&n[0].setCustomTime(t)}},{key:"getCustomTime",value:function(t){var e,i=eg(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(ky(t)));return i[0].getCustomTime()}},{key:"setCustomTimeMarker",value:function(t,e,i){var n,r=eg(n=this.customTimes).call(n,(function(t){return t.options.id===e}));if(0===r.length)throw new Error("No custom time bar found with id ".concat(ky(e)));r.length>0&&r[0].setCustomMarker(t,i)}},{key:"setCustomTimeTitle",value:function(t,e){var i,n=eg(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(ky(e)));if(n.length>0)return n[0].setCustomTitle(t)}},{key:"getEventProperties",value:function(t){return{event:t}}},{key:"addCustomTime",value:function(t,e){var i,n=void 0!==t?kI.convert(t,"Date"):new Date,r=zE(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(r)throw new Error("A custom time with id ".concat(ky(e)," already exists"));var o=new WL(this.body,kI.extend({},this.options,{time:n,id:e,snap:this.itemSet?this.itemSet.options.snap:this.options.snap}));return this.customTimes.push(o),this.components.push(o),this._redraw(),e}},{key:"removeCustomTime",value:function(t){var e,i=this,n=eg(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(ky(t)));sm(n).call(n,(function(t){var e,n,r,o;$m(e=i.customTimes).call(e,Jg(n=i.customTimes).call(n,t),1),$m(r=i.components).call(r,Jg(o=i.components).call(o,t),1),t.destroy()}))}},{key:"getVisibleItems",value:function(){return this.itemSet&&this.itemSet.getVisibleItems()||[]}},{key:"getItemsAtCurrentTime",value:function(t){return this.time=t,this.itemSet&&this.itemSet.getItemsAtCurrentTime(this.time)||[]}},{key:"getVisibleGroups",value:function(){return this.itemSet&&this.itemSet.getVisibleGroups()||[]}},{key:"fit",value:function(t,e){var i=this.getDataRange();if(null!==i.min||null!==i.max){var n=i.max-i.min,r=new Date(i.min.valueOf()-.01*n),o=new Date(i.max.valueOf()+.01*n),s=!t||void 0===t.animation||t.animation;this.range.setRange(r,o,{animation:s},e)}}},{key:"getDataRange",value:function(){throw new Error("Cannot invoke abstract method getDataRange")}},{key:"setWindow",value:function(t,e,i,n){var r,o;"function"==typeof arguments[2]&&(n=arguments[2],i={}),1==arguments.length?(r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r})):2==arguments.length&&"function"==typeof arguments[1]?(n=arguments[1],r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r},n)):(r=!i||void 0===i.animation||i.animation,this.range.setRange(t,e,{animation:r},n))}},{key:"moveTo",value:function(t,e,i){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.range.end-this.range.start,r=kI.convert(t,"Date").valueOf(),o=r-n/2,s=r+n/2,a=!e||void 0===e.animation||e.animation;this.range.setRange(o,s,{animation:a},i)}},{key:"getWindow",value:function(){var t=this.range.getRange();return{start:new Date(t.start),end:new Date(t.end)}}},{key:"zoomIn",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=(s-s/(1+t))/2,l=r+a,h=o-a;this.setWindow(l,h,e,i)}}},{key:"zoomOut",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=r-s*t/2,l=o+s*t/2;this.setWindow(a,l,e,i)}}},{key:"redraw",value:function(){this._redraw()}},{key:"_redraw",value:function(){var t;this.redrawCount++;var e=this.dom;if(e&&e.container&&0!=e.root.offsetWidth){var i=!1,n=this.options,r=this.props;JI(this.options.moment,this.body,this.options.hiddenDates),"top"==n.orientation?(kI.addClassName(e.root,"vis-top"),kI.removeClassName(e.root,"vis-bottom")):(kI.removeClassName(e.root,"vis-top"),kI.addClassName(e.root,"vis-bottom")),n.rtl?(kI.addClassName(e.root,"vis-rtl"),kI.removeClassName(e.root,"vis-ltr")):(kI.addClassName(e.root,"vis-ltr"),kI.removeClassName(e.root,"vis-rtl")),e.root.style.maxHeight=kI.option.asSize(n.maxHeight,""),e.root.style.minHeight=kI.option.asSize(n.minHeight,""),e.root.style.width=kI.option.asSize(n.width,"");var o=e.root.offsetWidth;r.border.left=1,r.border.right=1,r.border.top=1,r.border.bottom=1,r.center.height=e.center.offsetHeight,r.left.height=e.left.offsetHeight,r.right.height=e.right.offsetHeight,r.top.height=e.top.clientHeight||-r.border.top,r.bottom.height=Math.round(e.bottom.getBoundingClientRect().height)||e.bottom.clientHeight||-r.border.bottom;var s=Math.max(r.left.height,r.center.height,r.right.height),a=r.top.height+s+r.bottom.height+r.border.top+r.border.bottom;e.root.style.height=kI.option.asSize(n.height,"".concat(a,"px")),r.root.height=e.root.offsetHeight,r.background.height=r.root.height;var l=r.root.height-r.top.height-r.bottom.height;r.centerContainer.height=l,r.leftContainer.height=l,r.rightContainer.height=r.leftContainer.height,r.root.width=o,r.background.width=r.root.width,this.initialDrawDone||(r.scrollbarWidth=kI.getScrollBarWidth());var h=e.leftContainer.clientWidth,u=e.rightContainer.clientWidth;n.verticalScroll?n.rtl?(r.left.width=h||-r.border.left,r.right.width=u+r.scrollbarWidth||-r.border.right):(r.left.width=h+r.scrollbarWidth||-r.border.left,r.right.width=u||-r.border.right):(r.left.width=h||-r.border.left,r.right.width=u||-r.border.right),this._setDOM();var d=this._updateScrollTop();"top"!=n.orientation.item&&(d+=Math.max(r.centerContainer.height-r.center.height-r.border.top-r.border.bottom,0)),e.center.style.transform="translateY(".concat(d,"px)");var c=0==r.scrollTop?"hidden":"",p=r.scrollTop==r.scrollTopMin?"hidden":"";e.shadowTop.style.visibility=c,e.shadowBottom.style.visibility=p,e.shadowTopLeft.style.visibility=c,e.shadowBottomLeft.style.visibility=p,e.shadowTopRight.style.visibility=c,e.shadowBottomRight.style.visibility=p,n.verticalScroll&&(e.rightContainer.className="vis-panel vis-right vis-vertical-scroll",e.leftContainer.className="vis-panel vis-left vis-vertical-scroll",e.shadowTopRight.style.visibility="hidden",e.shadowBottomRight.style.visibility="hidden",e.shadowTopLeft.style.visibility="hidden",e.shadowBottomLeft.style.visibility="hidden",e.left.style.top="0px",e.right.style.top="0px"),(!n.verticalScroll||r.center.height<r.centerContainer.height)&&(e.left.style.top="".concat(d,"px"),e.right.style.top="".concat(d,"px"),e.rightContainer.className=e.rightContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),e.leftContainer.className=e.leftContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),r.left.width=h||-r.border.left,r.right.width=u||-r.border.right,this._setDOM());var f=r.center.height>r.centerContainer.height;this.hammer.get("pan").set({direction:f?bL.DIRECTION_ALL:bL.DIRECTION_HORIZONTAL}),this.hammer.get("press").set({time:this.options.longSelectPressTime}),sm(t=this.components).call(t,(function(t){i=t.redraw()||i}));if(i){if(this.redrawCount<5)return void this.body.emitter.emit("_change");console.log("WARNING: infinite loop in redraw?")}else this.redrawCount=0;this.body.emitter.emit("changed")}}},{key:"_setDOM",value:function(){var t=this.props,e=this.dom;t.leftContainer.width=t.left.width,t.rightContainer.width=t.right.width;var i=t.root.width-t.left.width-t.right.width;t.center.width=i,t.centerContainer.width=i,t.top.width=i,t.bottom.width=i,e.background.style.height="".concat(t.background.height,"px"),e.backgroundVertical.style.height="".concat(t.background.height,"px"),e.backgroundHorizontal.style.height="".concat(t.centerContainer.height,"px"),e.centerContainer.style.height="".concat(t.centerContainer.height,"px"),e.leftContainer.style.height="".concat(t.leftContainer.height,"px"),e.rightContainer.style.height="".concat(t.rightContainer.height,"px"),e.background.style.width="".concat(t.background.width,"px"),e.backgroundVertical.style.width="".concat(t.centerContainer.width,"px"),e.backgroundHorizontal.style.width="".concat(t.background.width,"px"),e.centerContainer.style.width="".concat(t.center.width,"px"),e.top.style.width="".concat(t.top.width,"px"),e.bottom.style.width="".concat(t.bottom.width,"px"),e.background.style.left="0",e.background.style.top="0",e.backgroundVertical.style.left="".concat(t.left.width+t.border.left,"px"),e.backgroundVertical.style.top="0",e.backgroundHorizontal.style.left="0",e.backgroundHorizontal.style.top="".concat(t.top.height,"px"),e.centerContainer.style.left="".concat(t.left.width,"px"),e.centerContainer.style.top="".concat(t.top.height,"px"),e.leftContainer.style.left="0",e.leftContainer.style.top="".concat(t.top.height,"px"),e.rightContainer.style.left="".concat(t.left.width+t.center.width,"px"),e.rightContainer.style.top="".concat(t.top.height,"px"),e.top.style.left="".concat(t.left.width,"px"),e.top.style.top="0",e.bottom.style.left="".concat(t.left.width,"px"),e.bottom.style.top="".concat(t.top.height+t.centerContainer.height,"px"),e.center.style.left="0",e.left.style.left="0",e.right.style.left="0"}},{key:"setCurrentTime",value:function(t){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");this.currentTime.setCurrentTime(t)}},{key:"getCurrentTime",value:function(){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");return this.currentTime.getCurrentTime()}},{key:"_toTime",value:function(t){return iL(this,t,this.props.center.width)}},{key:"_toGlobalTime",value:function(t){return iL(this,t,this.props.root.width)}},{key:"_toScreen",value:function(t){return eL(this,t,this.props.center.width)}},{key:"_toGlobalScreen",value:function(t){return eL(this,t,this.props.root.width)}},{key:"_initAutoResize",value:function(){1==this.options.autoResize?this._startAutoResize():this._stopAutoResize()}},{key:"_startAutoResize",value:function(){var t=this;this._stopAutoResize(),this._onResize=function(){if(1==t.options.autoResize){if(t.dom.root){var e=t.dom.root.offsetHeight,i=t.dom.root.offsetWidth;i==t.props.lastWidth&&e==t.props.lastHeight||(t.props.lastWidth=i,t.props.lastHeight=e,t.props.scrollbarWidth=kI.getScrollBarWidth(),t.body.emitter.emit("_change"))}}else t._stopAutoResize()},kI.addEventListener(window,"resize",this._onResize),t.dom.root&&(t.props.lastWidth=t.dom.root.offsetWidth,t.props.lastHeight=t.dom.root.offsetHeight),this.watchTimer=gL(this._onResize,1e3)}},{key:"_stopAutoResize",value:function(){this.watchTimer&&(clearInterval(this.watchTimer),this.watchTimer=void 0),this._onResize&&(kI.removeEventListener(window,"resize",this._onResize),this._onResize=null)}},{key:"_onTouch",value:function(t){this.touch.allowDragging=!0,this.touch.initialScrollTop=this.props.scrollTop}},{key:"_onPinch",value:function(t){this.touch.allowDragging=!1}},{key:"_onDrag",value:function(t){if(t&&this.touch.allowDragging){var e=t.deltaY,i=this._getScrollTop(),n=this._setScrollTop(this.touch.initialScrollTop+e);this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),n!=i&&this.emit("verticalDrag")}}},{key:"_setScrollTop",value:function(t){return this.props.scrollTop=t,this._updateScrollTop(),this.props.scrollTop}},{key:"_updateScrollTop",value:function(){var t=Math.min(this.props.centerContainer.height-this.props.border.top-this.props.border.bottom-this.props.center.height,0);return t!=this.props.scrollTopMin&&("top"!=this.options.orientation.item&&(this.props.scrollTop+=t-this.props.scrollTopMin),this.props.scrollTopMin=t),this.props.scrollTop>0&&(this.props.scrollTop=0),this.props.scrollTop<t&&(this.props.scrollTop=t),this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),this.props.scrollTop}},{key:"_getScrollTop",value:function(){return this.props.scrollTop}},{key:"_createConfigurator",value:function(){throw new Error("Cannot invoke abstract method _createConfigurator")}}]),t}();function UL(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}sb(VL.prototype);var XL=function(t){Vk(i,FI);var e=UL(i);function i(t,n){var r,o;Dd(this,i),(o=e.call(this)).body=t,o.defaultOptions={rtl:!1,showCurrentTime:!0,alignCurrentTime:void 0,moment:sA,locales:BL,locale:"en"},o.options=kI.extend({},o.defaultOptions),o.setOptions(n),o.options.locales=kI.extend({},BL,o.options.locales);var s=o.defaultOptions.locales[o.defaultOptions.locale];return sm(r=vf(o.options.locales)).call(r,(function(t){o.options.locales[t]=kI.extend({},s,o.options.locales[t])})),o.offset=0,o._create(),o}return Gc(i,[{key:"_create",value:function(){var t=document.createElement("div");t.className="vis-current-time",t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t}},{key:"destroy",value:function(){this.options.showCurrentTime=!1,this.redraw(),this.body=null}},{key:"setOptions",value:function(t){t&&kI.selectiveExtend(["rtl","showCurrentTime","alignCurrentTime","moment","locale","locales"],this.options,t)}},{key:"redraw",value:function(){if(this.options.showCurrentTime){var t,e,i=this.body.dom.backgroundVertical;this.bar.parentNode!=i&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),i.appendChild(this.bar),this.start());var n=this.options.moment(xf()+this.offset);this.options.alignCurrentTime&&(n=n.startOf(this.options.alignCurrentTime));var r=this.body.util.toScreen(n),o=this.options.locales[this.options.locale];o||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),o=this.options.locales.en);var s=Vp(t=Vp(e="".concat(o.current," ")).call(e,o.time,": ")).call(t,n.format("dddd, MMMM Do YYYY, H:mm:ss"));s=s.charAt(0).toUpperCase()+s.substring(1),this.options.rtl?this.bar.style.transform="translateX(".concat(-1*r,"px)"):this.bar.style.transform="translateX(".concat(r,"px)"),this.bar.title=s}else this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),this.stop();return!1}},{key:"start",value:function(){var t=this;!function e(){t.stop();var i=1/t.body.range.conversion(t.body.domProps.center.width).scale/10;i<30&&(i=30),i>1e3&&(i=1e3),t.redraw(),t.body.emitter.emit("currentTimeTick"),t.currentTimeTimer=Vy(e,i)}()}},{key:"stop",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),delete this.currentTimeTimer)}},{key:"setCurrentTime",value:function(t){var e=kI.convert(t,"Date").valueOf(),i=xf();this.offset=e-i,this.redraw()}},{key:"getCurrentTime",value:function(){return new Date(xf()+this.offset)}}]),i}(),qL={},$L={get exports(){return qL},set exports(t){qL=t}},ZL=Pn,KL=Dl.find,JL="find",QL=!0;JL in[]&&Array(1)[JL]((function(){QL=!1})),ZL({target:"Array",proto:!0,forced:QL},{find:function(t){return KL(this,t,arguments.length>1?arguments[1]:void 0)}});var tN=gp("Array").find,eN=be,iN=tN,nN=Array.prototype,rN=function(t){var e=t.find;return t===nN||eN(nN,t)&&e===nN.find?iN:e},oN=rN;$L.exports=oN;var sN=e(qL),aN={},lN={get exports(){return aN},set exports(t){aN=t}},hN=Pn,uN=Dl.findIndex,dN="findIndex",cN=!0;dN in[]&&Array(1)[dN]((function(){cN=!1})),hN({target:"Array",proto:!0,forced:cN},{findIndex:function(t){return uN(this,t,arguments.length>1?arguments[1]:void 0)}});var pN=gp("Array").findIndex,fN=be,mN=pN,vN=Array.prototype,gN=function(t){var e=t.findIndex;return t===vN||fN(vN,t)&&e===vN.findIndex?mN:e},yN=gN;lN.exports=yN;var bN=e(aN);function _N(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return wN(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return wN(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function wN(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var kN=.001;function xN(t){PE(t).call(t,(function(t,e){return t.data.start-e.data.start}))}function DN(t){PE(t).call(t,(function(t,e){return("end"in t.data?t.data.end:t.data.start)-("end"in e.data?e.data.end:e.data.start)}))}function SN(t,e,i,n){return null===EN(t,e.item,!1,(function(t){return t.stack&&(i||null===t.top)}),(function(t){return t.stack}),(function(t){return e.axis}),n)}function CN(t,e,i){var n=EN(t,e.item,!1,(function(t){return t.stack}),(function(t){return!0}),(function(t){return t.baseTop}));i.height=n-i.top+.5*e.item.vertical}function TN(t,e,i,n){for(var r=0;r<t.length;r++)if(null==t[r].data.subgroup)t[r].top=e.item.vertical;else if(void 0!==t[r].data.subgroup&&n){var o=0;for(var s in i)i.hasOwnProperty(s)&&1==i[s].visible&&i[s].index<i[t[r].data.subgroup].index&&(o+=i[s].height,i[t[r].data.subgroup].top=o);t[r].top=o+.5*e.item.vertical}n||MN(t,e,i)}function MN(t,e,i){var n;EN(PE(n=pg(i)).call(n,(function(t,e){return t.index>e.index?1:t.index<e.index?-1:0})),{vertical:0},!0,(function(t){return!0}),(function(t){return!0}),(function(t){return 0}));for(var r=0;r<t.length;r++)void 0!==t[r].data.subgroup&&(t[r].top=i[t[r].data.subgroup].top+.5*e.item.vertical)}function ON(t,e,i){var n=!1,r=[];for(var o in i)i[o].hasOwnProperty("index")?r[i[o].index]=o:r.push(o);for(var s=0;s<r.length;s++)if(o=r[s],i.hasOwnProperty(o)){for(var a in n=n||i[o].stack,i[o].top=0,i)i[a].visible&&i[o].index>i[a].index&&(i[o].top+=i[a].height);for(var l=t[o],h=0;h<l.length;h++)void 0!==l[h].data.subgroup&&(l[h].top=i[l[h].data.subgroup].top+.5*e.item.vertical,i[o].stack&&(l[h].baseTop=l[h].top));n&&i[o].stack&&CN(t[o],e,i[o])}}function EN(t,e,n,r,o,s,a){var l=function(t){return t.start},h=function(t){return t.end};if(!n){var u=!(!t[0]||!t[0].options.rtl);l=u?function(t){return t.right}:function(t){return t.left},h=function(t){return l(t)+t.width+e.horizontal}}var d,c=[],p=[],f=null,m=0,v=_N(t);try{var g=function(){var t=d.value;if(r(t))c.push(t);else if(o(t)){var e=l(t);null!==f&&e<f-kN&&(m=0),f=e,m=PN(p,(function(t){return l(t)-kN>e}),m),$m(p).call(p,m,0,t),m++}};for(v.s();!(d=v.n()).done;)g()}catch(t){v.e(t)}finally{v.f()}f=null;var y=null;m=0;for(var b=0,_=0,w=0,k=function(){var t,n,r=c.shift();r.top=s(r);var u=l(r),d=h(r);null!==f&&u<f-kN&&(b=0,_=0,m=0,y=null),f=u,b=PN(p,(function(t){return u<h(t)-kN}),b),(null===y||y<d-kN)&&(_=PN(p,(function(t){return d<l(t)-kN}),Math.max(b,_))),null!==y&&y-kN>d&&(_=function(t,e,n,r){n||(n=0);r||(r=t.length);for(i=r-1;i>=n;i--)if(e(t[i]))return i;return n-1}(p,(function(t){return d+kN>=l(t)}),b,horizontalOVerlapEndIndex)+1);for(var v,g,k,x=PE(t=eg(n=Xp(p).call(p,b,_)).call(n,(function(t){return u<h(t)-kN&&d-kN>l(t)}))).call(t,(function(t,e){return t.top-e.top})),D=0;D<x.length;D++){var S=x[D];g=S,k=e,(v=r).top-k.vertical+kN<g.top+g.height&&v.top+v.height+k.vertical-kN>g.top&&(r.top=S.top+S.height+e.vertical)}o(r)&&(m=PN(p,(function(t){return l(t)-kN>u}),m),$m(p).call(p,m,0,r),m++);var C=r.top+r.height;if(C>w&&(w=C),a&&a())return{v:null}};c.length>0;){var x=k();if("object"===Lc(x))return x.v}return w}function PN(t,e,i){var n;i||(i=0);var r=bN(n=Xp(t).call(t,i)).call(n,e);return-1===r?t.length:r+i}var AN=Object.freeze({__proto__:null,nostack:TN,orderByEnd:DN,orderByStart:xN,stack:SN,stackSubgroups:MN,stackSubgroupsWithInnerStack:ON,substack:CN}),IN="__background__",LN=function(){function t(e,i,n){var r=this;if(Dd(this,t),this.groupId=e,this.subgroups={},this.subgroupStack={},this.subgroupStackAll=!1,this.subgroupVisibility={},this.doInnerStack=!1,this.shouldBailStackItems=!1,this.subgroupIndex=0,this.subgroupOrderer=i&&i.subgroupOrder,this.itemSet=n,this.isVisible=null,this.stackDirty=!0,this._disposeCallbacks=[],i&&i.nestedGroups&&(this.nestedGroups=i.nestedGroups,0==i.showNested?this.showNested=!1:this.showNested=!0),i&&i.subgroupStack)if("boolean"==typeof i.subgroupStack)this.doInnerStack=i.subgroupStack,this.subgroupStackAll=i.subgroupStack;else for(var o in i.subgroupStack)this.subgroupStack[o]=i.subgroupStack[o],this.doInnerStack=this.doInnerStack||i.subgroupStack[o];i&&i.heightMode?this.heightMode=i.heightMode:this.heightMode=n.options.groupHeightMode,this.nestedInGroup=null,this.dom={},this.props={label:{width:0,height:0}},this.className=null,this.items={},this.visibleItems=[],this.itemsInRange=[],this.orderedItems={byStart:[],byEnd:[]},this.checkRangedItems=!1;var s=function(){r.checkRangedItems=!0};this.itemSet.body.emitter.on("checkRangedItems",s),this._disposeCallbacks.push((function(){r.itemSet.body.emitter.off("checkRangedItems",s)})),this._create(),this.setData(i)}return Gc(t,[{key:"_create",value:function(){var t=document.createElement("div");this.itemSet.options.groupEditable.order?t.className="vis-label draggable":t.className="vis-label",this.dom.label=t;var e=document.createElement("div");e.className="vis-inner",t.appendChild(e),this.dom.inner=e;var i=document.createElement("div");i.className="vis-group",i["vis-group"]=this,this.dom.foreground=i,this.dom.background=document.createElement("div"),this.dom.background.className="vis-group",this.dom.axis=document.createElement("div"),this.dom.axis.className="vis-group",this.dom.marker=document.createElement("div"),this.dom.marker.style.visibility="hidden",this.dom.marker.style.position="absolute",this.dom.marker.innerHTML="",this.dom.background.appendChild(this.dom.marker)}},{key:"setData",value:function(t){if(!this.itemSet.groupTouchParams.isDragging){var e,i,n;if(t&&t.subgroupVisibility)for(var r in t.subgroupVisibility)this.subgroupVisibility[r]=t.subgroupVisibility[r];if(this.itemSet.options&&this.itemSet.options.groupTemplate)e=(i=Vf(n=this.itemSet.options.groupTemplate).call(n,this))(t,this.dom.inner);else e=t&&t.content;if(e instanceof Element){for(;this.dom.inner.firstChild;)this.dom.inner.removeChild(this.dom.inner.firstChild);this.dom.inner.appendChild(e)}else e instanceof Object&&e.isReactComponent||(e instanceof Object?i(t,this.dom.inner):this.dom.inner.innerHTML=null!=e?kI.xss(e):kI.xss(this.groupId||""));this.dom.label.title=t&&t.title||"",this.dom.inner.firstChild?kI.removeClassName(this.dom.inner,"vis-hidden"):kI.addClassName(this.dom.inner,"vis-hidden"),t&&t.nestedGroups?(this.nestedGroups&&this.nestedGroups==t.nestedGroups||(this.nestedGroups=t.nestedGroups),void 0===t.showNested&&void 0!==this.showNested||(0==t.showNested?this.showNested=!1:this.showNested=!0),kI.addClassName(this.dom.label,"vis-nesting-group"),this.showNested?(kI.removeClassName(this.dom.label,"collapsed"),kI.addClassName(this.dom.label,"expanded")):(kI.removeClassName(this.dom.label,"expanded"),kI.addClassName(this.dom.label,"collapsed"))):this.nestedGroups&&(this.nestedGroups=null,kI.removeClassName(this.dom.label,"collapsed"),kI.removeClassName(this.dom.label,"expanded"),kI.removeClassName(this.dom.label,"vis-nesting-group")),t&&(t.treeLevel||t.nestedInGroup)?(kI.addClassName(this.dom.label,"vis-nested-group"),t.treeLevel?kI.addClassName(this.dom.label,"vis-group-level-"+t.treeLevel):kI.addClassName(this.dom.label,"vis-group-level-unknown-but-gte1")):kI.addClassName(this.dom.label,"vis-group-level-0");var o=t&&t.className||null;o!=this.className&&(this.className&&(kI.removeClassName(this.dom.label,this.className),kI.removeClassName(this.dom.foreground,this.className),kI.removeClassName(this.dom.background,this.className),kI.removeClassName(this.dom.axis,this.className)),kI.addClassName(this.dom.label,o),kI.addClassName(this.dom.foreground,o),kI.addClassName(this.dom.background,o),kI.addClassName(this.dom.axis,o),this.className=o),this.style&&(kI.removeCssText(this.dom.label,this.style),this.style=null),t&&t.style&&(kI.addCssText(this.dom.label,t.style),this.style=t.style)}}},{key:"getLabelWidth",value:function(){return this.props.label.width}},{key:"_didMarkerHeightChange",value:function(){var t=this.dom.marker.clientHeight;if(t!=this.lastMarkerHeight){this.lastMarkerHeight=t;var e={},i=0;if(sm(kI).call(kI,this.items,(function(t,n){if(t.dirty=!0,t.displayed){e[n]=t.redraw(!0),i=e[n].length}})),i>0)for(var n=function(t){sm(kI).call(kI,e,(function(e){e[t]()}))},r=0;r<i;r++)n(r);return!0}return!1}},{key:"_calculateGroupSizeAndPosition",value:function(){var t=this.dom.foreground,e=t.offsetTop,i=t.offsetLeft,n=t.offsetWidth;this.top=e,this.right=i,this.width=n}},{key:"_shouldBailItemsRedraw",value:function(){var t=this,e=this.itemSet.options.onTimeout,i={relativeBailingTime:this.itemSet.itemsSettingTime,bailTimeMs:e&&e.timeoutMs,userBailFunction:e&&e.callback,shouldBailStackItems:this.shouldBailStackItems},n=null;if(!this.itemSet.initialDrawDone){if(i.shouldBailStackItems)return!0;Math.abs(xf()-new Date(i.relativeBailingTime))>i.bailTimeMs&&(i.userBailFunction&&null==this.itemSet.userContinueNotBail?i.userBailFunction((function(e){t.itemSet.userContinueNotBail=e,n=!e})):n=0==t.itemSet.userContinueNotBail)}return n}},{key:"_redrawItems",value:function(t,e,i,n){var r=this;if(t||this.stackDirty||this.isVisible&&!e){var o,s,a,l,h,u,d={byEnd:eg(o=this.orderedItems.byEnd).call(o,(function(t){return!t.isCluster})),byStart:eg(s=this.orderedItems.byStart).call(s,(function(t){return!t.isCluster}))},c={byEnd:Lp(new FO(eg(a=uf(l=this.orderedItems.byEnd).call(l,(function(t){return t.cluster}))).call(a,(function(t){return!!t})))),byStart:Lp(new FO(eg(h=uf(u=this.orderedItems.byStart).call(u,(function(t){return t.cluster}))).call(h,(function(t){return!!t}))))},p=function(){var t,e,i,o=r._updateItemsInRange(d,eg(t=r.visibleItems).call(t,(function(t){return!t.isCluster})),n),s=r._updateClustersInRange(c,eg(e=r.visibleItems).call(e,(function(t){return t.isCluster})),n);return Vp(i=[]).call(i,Lp(o),Lp(s))},f=function(t){var e={},i=function(i){var n,o=eg(n=r.visibleItems).call(n,(function(t){return t.data.subgroup===i}));e[i]=t?PE(o).call(o,(function(e,i){return t(e.data,i.data)})):o};for(var n in r.subgroups)i(n);return e};if("function"==typeof this.itemSet.options.order){var m=this;if(this.doInnerStack&&this.itemSet.options.stackSubgroups){ON(f(this.itemSet.options.order),i,this.subgroups),this.visibleItems=p(),this._updateSubGroupHeights(i)}else{var v,g,y,b;this.visibleItems=p(),this._updateSubGroupHeights(i);var _=PE(v=eg(g=Xp(y=this.visibleItems).call(y)).call(g,(function(t){return t.isCluster||!t.isCluster&&!t.cluster}))).call(v,(function(t,e){return m.itemSet.options.order(t.data,e.data)}));this.shouldBailStackItems=SN(_,i,!0,Vf(b=this._shouldBailItemsRedraw).call(b,this))}}else{var w;if(this.visibleItems=p(),this._updateSubGroupHeights(i),this.itemSet.options.stack)if(this.doInnerStack&&this.itemSet.options.stackSubgroups)ON(f(),i,this.subgroups);else this.shouldBailStackItems=SN(this.visibleItems,i,!0,Vf(w=this._shouldBailItemsRedraw).call(w,this));else TN(this.visibleItems,i,this.subgroups,this.itemSet.options.stackSubgroups)}for(var k=0;k<this.visibleItems.length;k++)this.visibleItems[k].repositionX(),void 0!==this.subgroupVisibility[this.visibleItems[k].data.subgroup]&&(this.subgroupVisibility[this.visibleItems[k].data.subgroup]||this.visibleItems[k].hide());this.itemSet.options.cluster&&sm(kI).call(kI,this.items,(function(t){t.cluster&&t.displayed&&t.hide()})),this.shouldBailStackItems&&this.itemSet.body.emitter.emit("destroyTimeline"),this.stackDirty=!1}}},{key:"_didResize",value:function(t,e){t=kI.updateProperty(this,"height",e)||t;var i=this.dom.inner.clientWidth,n=this.dom.inner.clientHeight;return t=kI.updateProperty(this.props.label,"width",i)||t,t=kI.updateProperty(this.props.label,"height",n)||t}},{key:"_applyGroupHeight",value:function(t){this.dom.background.style.height="".concat(t,"px"),this.dom.foreground.style.height="".concat(t,"px"),this.dom.label.style.height="".concat(t,"px")}},{key:"_updateItemsVerticalPosition",value:function(t){for(var e=0,i=this.visibleItems.length;e<i;e++){var n=this.visibleItems[e];n.repositionY(t),this.isVisible||this.groupId==IN||n.displayed&&n.hide()}}},{key:"redraw",value:function(t,e,i,n){var r,o,s,a,l,h,u,d=this,c=!1,p=this.isVisible,f=[function(){i=d._didMarkerHeightChange.call(d)||i},Vf(r=this._updateSubGroupHeights).call(r,this,e),Vf(o=this._calculateGroupSizeAndPosition).call(o,this),function(){var i;d.isVisible=Vf(i=d._isGroupVisible).call(i,d)(t,e)},function(){var n;Vf(n=d._redrawItems).call(n,d)(i,p,e,t)},Vf(s=this._updateSubgroupsSizes).call(s,this),function(){var t;h=Vf(t=d._calculateHeight).call(t,d)(e)},Vf(a=this._calculateGroupSizeAndPosition).call(a,this),function(){var t;c=Vf(t=d._didResize).call(t,d)(c,h)},function(){var t;Vf(t=d._applyGroupHeight).call(t,d)(h)},function(){var t;Vf(t=d._updateItemsVerticalPosition).call(t,d)(e)},Vf(l=function(){return!d.isVisible&&d.height&&(c=!1),c}).call(l,this)];return n?f:(sm(f).call(f,(function(t){u=t()})),u)}},{key:"_updateSubGroupHeights",value:function(t){var e=this;if(vf(this.subgroups).length>0){var i=this;this._resetSubgroups(),sm(kI).call(kI,this.visibleItems,(function(n){void 0!==n.data.subgroup&&(i.subgroups[n.data.subgroup].height=Math.max(i.subgroups[n.data.subgroup].height,n.height+t.item.vertical),i.subgroups[n.data.subgroup].visible=void 0===e.subgroupVisibility[n.data.subgroup]||Boolean(e.subgroupVisibility[n.data.subgroup]))}))}}},{key:"_isGroupVisible",value:function(t,e){return this.top<=t.body.domProps.centerContainer.height-t.body.domProps.scrollTop+e.axis&&this.top+this.height+e.axis>=-t.body.domProps.scrollTop}},{key:"_calculateHeight",value:function(t){var e,i;if((i="fixed"===this.heightMode?kI.toArray(this.items):this.visibleItems).length>0){var n=i[0].top,r=i[0].top+i[0].height;if(sm(kI).call(kI,i,(function(t){n=Math.min(n,t.top),r=Math.max(r,t.top+t.height)})),n>t.axis){var o=n-t.axis;r-=o,sm(kI).call(kI,i,(function(t){t.top-=o}))}e=Math.ceil(r+t.item.vertical/2),"fitItems"!==this.heightMode&&(e=Math.max(e,this.props.label.height))}else e=this.props.label.height;return e}},{key:"show",value:function(){this.dom.label.parentNode||this.itemSet.dom.labelSet.appendChild(this.dom.label),this.dom.foreground.parentNode||this.itemSet.dom.foreground.appendChild(this.dom.foreground),this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background),this.dom.axis.parentNode||this.itemSet.dom.axis.appendChild(this.dom.axis)}},{key:"hide",value:function(){var t=this.dom.label;t.parentNode&&t.parentNode.removeChild(t);var e=this.dom.foreground;e.parentNode&&e.parentNode.removeChild(e);var i=this.dom.background;i.parentNode&&i.parentNode.removeChild(i);var n=this.dom.axis;n.parentNode&&n.parentNode.removeChild(n)}},{key:"add",value:function(t){var e;if(this.items[t.id]=t,t.setParent(this),this.stackDirty=!0,void 0!==t.data.subgroup&&(this._addToSubgroup(t),this.orderSubgroups()),!jv(e=this.visibleItems).call(e,t)){var i=this.itemSet.body.range;this._checkIfVisible(t,this.visibleItems,i)}}},{key:"_addToSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;null!=e&&void 0===this.subgroups[e]&&(this.subgroups[e]={height:0,top:0,start:t.data.start,end:t.data.end||t.data.start,visible:!1,index:this.subgroupIndex,items:[],stack:this.subgroupStackAll||this.subgroupStack[e]||!1},this.subgroupIndex++),new Date(t.data.start)<new Date(this.subgroups[e].start)&&(this.subgroups[e].start=t.data.start);var i=t.data.end||t.data.start;new Date(i)>new Date(this.subgroups[e].end)&&(this.subgroups[e].end=i),this.subgroups[e].items.push(t)}},{key:"_updateSubgroupsSizes",value:function(){var t=this;if(t.subgroups){var e=function(){var e,n=t.subgroups[i].items[0].data.end||t.subgroups[i].items[0].data.start,r=t.subgroups[i].items[0].data.start,o=n-1;sm(e=t.subgroups[i].items).call(e,(function(t){new Date(t.data.start)<new Date(r)&&(r=t.data.start);var e=t.data.end||t.data.start;new Date(e)>new Date(o)&&(o=e)})),t.subgroups[i].start=r,t.subgroups[i].end=new Date(o-1)};for(var i in t.subgroups)e()}}},{key:"orderSubgroups",value:function(){if(void 0!==this.subgroupOrderer){var t=[];if("string"==typeof this.subgroupOrderer){for(var e in this.subgroups)t.push({subgroup:e,sortField:this.subgroups[e].items[0].data[this.subgroupOrderer]});PE(t).call(t,(function(t,e){return t.sortField-e.sortField}))}else if("function"==typeof this.subgroupOrderer){for(var i in this.subgroups)t.push(this.subgroups[i].items[0].data);PE(t).call(t,this.subgroupOrderer)}if(t.length>0)for(var n=0;n<t.length;n++)this.subgroups[t[n].subgroup].index=n}}},{key:"_resetSubgroups",value:function(){for(var t in this.subgroups)this.subgroups.hasOwnProperty(t)&&(this.subgroups[t].visible=!1,this.subgroups[t].height=0)}},{key:"remove",value:function(t){var e,i;delete this.items[t.id],t.setParent(null),this.stackDirty=!0;var n=Jg(e=this.visibleItems).call(e,t);-1!=n&&$m(i=this.visibleItems).call(i,n,1),void 0!==t.data.subgroup&&(this._removeFromSubgroup(t),this.orderSubgroups())}},{key:"_removeFromSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;if(null!=e){var i=this.subgroups[e];if(i){var n,r,o=Jg(n=i.items).call(n,t);if(o>=0)$m(r=i.items).call(r,o,1),i.items.length?this._updateSubgroupsSizes():delete this.subgroups[e]}}}},{key:"removeFromDataSet",value:function(t){this.itemSet.removeItem(t.id)}},{key:"order",value:function(){for(var t=kI.toArray(this.items),e=[],i=[],n=0;n<t.length;n++)void 0!==t[n].data.end&&i.push(t[n]),e.push(t[n]);this.orderedItems={byStart:e,byEnd:i},xN(this.orderedItems.byStart),DN(this.orderedItems.byEnd)}},{key:"_updateItemsInRange",value:function(t,e,i){var n=[],r={};if(!this.isVisible&&this.groupId!=IN){for(var o=0;o<e.length;o++){var s=e[o];s.displayed&&s.hide()}return n}var a=(i.end-i.start)/4,l=i.start-a,h=i.end+a;if(e.length>0)for(var u=0;u<e.length;u++)this._checkIfVisibleWithReference(e[u],n,r,i);var d=kI.binarySearchCustom(t.byStart,(function(t){return t<l?-1:t<=h?0:1}),"data","start");if(this._traceVisible(d,t.byStart,n,r,(function(t){return t.data.start<l||t.data.start>h})),1==this.checkRangedItems){this.checkRangedItems=!1;for(var c=0;c<t.byEnd.length;c++)this._checkIfVisibleWithReference(t.byEnd[c],n,r,i)}else{var p=kI.binarySearchCustom(t.byEnd,(function(t){var e=t.start;return t.end<l?-1:e<=h?0:1}),"data");this._traceVisible(p,t.byEnd,n,r,(function(t){return t.data.end<l||t.data.start>h}))}for(var f={},m=0,v=0;v<n.length;v++){var g=n[v];if(!g.displayed){f[v]=g.redraw(!0),m=f[v].length}}if(m>0)for(var y=function(t){sm(kI).call(kI,f,(function(e){e[t]()}))},b=0;b<m;b++)y(b);for(var _=0;_<n.length;_++)n[_].repositionX();return n}},{key:"_traceVisible",value:function(t,e,i,n,r){if(-1!=t){for(var o=t;o>=0;o--){var s=e[o];if(r(s))break;s.isCluster&&!s.hasItems()||s.cluster||void 0===n[s.id]&&(n[s.id]=!0,i.push(s))}for(var a=t+1;a<e.length;a++){var l=e[a];if(r(l))break;l.isCluster&&!l.hasItems()||l.cluster||void 0===n[l.id]&&(n[l.id]=!0,i.push(l))}}}},{key:"_checkIfVisible",value:function(t,e,i){t.isVisible(i)?(t.displayed||t.show(),t.repositionX(),e.push(t)):t.displayed&&t.hide()}},{key:"_checkIfVisibleWithReference",value:function(t,e,i,n){t.isVisible(n)?void 0===i[t.id]&&(i[t.id]=!0,e.push(t)):t.displayed&&t.hide()}},{key:"_updateClustersInRange",value:function(t,e,i){var n=[],r={};if(e.length>0)for(var o=0;o<e.length;o++)this._checkIfVisibleWithReference(e[o],n,r,i);for(var s=0;s<t.byStart.length;s++)this._checkIfVisibleWithReference(t.byStart[s],n,r,i);for(var a=0;a<t.byEnd.length;a++)this._checkIfVisibleWithReference(t.byEnd[a],n,r,i);for(var l={},h=0,u=0;u<n.length;u++){var d=n[u];if(!d.displayed){l[u]=d.redraw(!0),h=l[u].length}}if(h>0)for(var c=0;c<h;c++)sm(kI).call(kI,l,(function(t){t[c]()}));for(var p=0;p<n.length;p++)n[p].repositionX();return n}},{key:"changeSubgroup",value:function(t,e,i){this._removeFromSubgroup(t,e),this._addToSubgroup(t,i),this.orderSubgroups()}},{key:"dispose",value:function(){var t;for(this.hide();t=this._disposeCallbacks.pop();)t()}}]),t}();function NN(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}var RN=function(t){Vk(i,LN);var e=NN(i);function i(t,n,r){var o;return Dd(this,i),(o=e.call(this,t,n,r)).width=0,o.height=0,o.top=0,o.left=0,o}return Gc(i,[{key:"redraw",value:function(t,e,i){this.visibleItems=this._updateItemsInRange(this.orderedItems,this.visibleItems,t),this.width=this.dom.background.offsetWidth,this.dom.background.style.height="0";for(var n=0,r=this.visibleItems.length;n<r;n++){this.visibleItems[n].repositionY(e)}return!1}},{key:"show",value:function(){this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background)}}]),i}();function FN(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return jN(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jN(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function jN(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}kL('.vis-item{background-color:#d5ddf6;border-color:#97b0f8;border-width:1px;color:#1a1a1a;display:inline-block;position:absolute;z-index:1}.vis-item.vis-selected{background-color:#fff785;border-color:#ffc200;z-index:2}.vis-editable.vis-selected{cursor:move}.vis-item.vis-point.vis-selected{background-color:#fff785}.vis-item.vis-box{border-radius:2px;border-style:solid;text-align:center}.vis-item.vis-point{background:none}.vis-item.vis-dot{border-radius:4px;border-style:solid;border-width:4px;padding:0;position:absolute}.vis-item.vis-range{border-radius:2px;border-style:solid;box-sizing:border-box}.vis-item.vis-background{background-color:rgba(213,221,246,.4);border:none;box-sizing:border-box;margin:0;padding:0}.vis-item .vis-item-overflow{height:100%;margin:0;overflow:hidden;padding:0;position:relative;width:100%}.vis-item-visible-frame{white-space:nowrap}.vis-item.vis-range .vis-item-content{display:inline-block;position:relative}.vis-item.vis-background .vis-item-content{display:inline-block;position:absolute}.vis-item.vis-line{border-left-style:solid;border-left-width:1px;padding:0;position:absolute;width:0}.vis-item .vis-item-content{box-sizing:border-box;padding:5px;white-space:nowrap}.vis-item .vis-onUpdateTime-tooltip{background:#4f81bd;border-radius:1px;color:#fff;padding:5px;position:absolute;text-align:center;transition:.4s;-o-transition:.4s;-moz-transition:.4s;-webkit-transition:.4s;white-space:nowrap;width:200px}.vis-item .vis-delete,.vis-item .vis-delete-rtl{box-sizing:border-box;cursor:pointer;height:24px;padding:0 5px;position:absolute;top:0;-webkit-transition:background .2s linear;-moz-transition:background .2s linear;-ms-transition:background .2s linear;-o-transition:background .2s linear;transition:background .2s linear;width:24px}.vis-item .vis-delete{right:-24px}.vis-item .vis-delete-rtl{left:-24px}.vis-item .vis-delete-rtl:after,.vis-item .vis-delete:after{color:red;content:"\\00D7";font-family:arial,sans-serif;font-size:22px;font-weight:700;-webkit-transition:color .2s linear;-moz-transition:color .2s linear;-ms-transition:color .2s linear;-o-transition:color .2s linear;transition:color .2s linear}.vis-item .vis-delete-rtl:hover,.vis-item .vis-delete:hover{background:red}.vis-item .vis-delete-rtl:hover:after,.vis-item .vis-delete:hover:after{color:#fff}.vis-item .vis-drag-center{cursor:move;height:100%;left:0;position:absolute;top:0;width:100%}.vis-item.vis-range .vis-drag-left{cursor:w-resize;left:-4px}.vis-item.vis-range .vis-drag-left,.vis-item.vis-range .vis-drag-right{height:100%;max-width:20%;min-width:2px;position:absolute;top:0;width:24px}.vis-item.vis-range .vis-drag-right{cursor:e-resize;right:-4px}.vis-range.vis-item.vis-readonly .vis-drag-left,.vis-range.vis-item.vis-readonly .vis-drag-right{cursor:auto}.vis-item.vis-cluster{border-radius:2px;border-style:solid;text-align:center;vertical-align:center}.vis-item.vis-cluster-line{border-left-style:solid;border-left-width:1px;padding:0;position:absolute;width:0}.vis-item.vis-cluster-dot{border-radius:4px;border-style:solid;border-width:4px;padding:0;position:absolute}');var YN=function(){function t(e,i,n){var r,o=this;Dd(this,t),this.id=null,this.parent=null,this.data=e,this.dom=null,this.conversion=i||{},this.defaultOptions={locales:BL,locale:"en"},this.options=kI.extend({},this.defaultOptions,n),this.options.locales=kI.extend({},BL,this.options.locales);var s=this.defaultOptions.locales[this.defaultOptions.locale];sm(r=vf(this.options.locales)).call(r,(function(t){o.options.locales[t]=kI.extend({},s,o.options.locales[t])})),this.selected=!1,this.displayed=!1,this.groupShowing=!0,this.selectable=n&&n.selectable||!1,this.dirty=!0,this.top=null,this.right=null,this.left=null,this.width=null,this.height=null,this.setSelectability(e),this.editable=null,this._updateEditStatus()}return Gc(t,[{key:"select",value:function(){this.selectable&&(this.selected=!0,this.dirty=!0,this.displayed&&this.redraw())}},{key:"unselect",value:function(){this.selected=!1,this.dirty=!0,this.displayed&&this.redraw()}},{key:"setData",value:function(t){null!=t.group&&this.data.group!=t.group&&null!=this.parent&&this.parent.itemSet._moveToGroup(this,t.group),this.setSelectability(t),this.parent&&(this.parent.stackDirty=!0),null!=t.subgroup&&this.data.subgroup!=t.subgroup&&null!=this.parent&&this.parent.changeSubgroup(this,this.data.subgroup,t.subgroup),this.data=t,this._updateEditStatus(),this.dirty=!0,this.displayed&&this.redraw()}},{key:"setSelectability",value:function(t){t&&(this.selectable=void 0===t.selectable||Boolean(t.selectable))}},{key:"setParent",value:function(t){this.displayed?(this.hide(),this.parent=t,this.parent&&this.show()):this.parent=t}},{key:"isVisible",value:function(t){return!1}},{key:"show",value:function(){return!1}},{key:"hide",value:function(){return!1}},{key:"redraw",value:function(){}},{key:"repositionX",value:function(){}},{key:"repositionY",value:function(){}},{key:"_repaintDragCenter",value:function(){if(this.selected&&this.editable.updateTime&&!this.dom.dragCenter){var t,e,i=this,n=document.createElement("div");n.className="vis-drag-center",n.dragCenterItem=this,this.hammerDragCenter=new bL(n),this.hammerDragCenter.on("tap",(function(t){i.parent.itemSet.body.emitter.emit("click",{event:t,item:i.id})})),this.hammerDragCenter.on("doubletap",(function(t){t.stopPropagation(),i.parent.itemSet._onUpdateItem(i),i.parent.itemSet.body.emitter.emit("doubleClick",{event:t,item:i.id})})),this.hammerDragCenter.on("panstart",(function(t){t.stopPropagation(),i.parent.itemSet._onDragStart(t)})),this.hammerDragCenter.on("panmove",Vf(t=i.parent.itemSet._onDrag).call(t,i.parent.itemSet)),this.hammerDragCenter.on("panend",Vf(e=i.parent.itemSet._onDragEnd).call(e,i.parent.itemSet)),this.hammerDragCenter.get("press").set({time:1e4}),this.dom.box?this.dom.dragLeft?this.dom.box.insertBefore(n,this.dom.dragLeft):this.dom.box.appendChild(n):this.dom.point&&this.dom.point.appendChild(n),this.dom.dragCenter=n}else!this.selected&&this.dom.dragCenter&&(this.dom.dragCenter.parentNode&&this.dom.dragCenter.parentNode.removeChild(this.dom.dragCenter),this.dom.dragCenter=null,this.hammerDragCenter&&(this.hammerDragCenter.destroy(),this.hammerDragCenter=null))}},{key:"_repaintDeleteButton",value:function(t){var e=(this.options.editable.overrideItems||null==this.editable)&&this.options.editable.remove||!this.options.editable.overrideItems&&null!=this.editable&&this.editable.remove;if(this.selected&&e&&!this.dom.deleteButton){var i=this,n=document.createElement("div");this.options.rtl?n.className="vis-delete-rtl":n.className="vis-delete";var r=this.options.locales[this.options.locale];r||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),r=this.options.locales.en),n.title=r.deleteSelected,this.hammerDeleteButton=new bL(n).on("tap",(function(t){t.stopPropagation(),i.parent.removeFromDataSet(i)})),t.appendChild(n),this.dom.deleteButton=n}else this.selected&&e||!this.dom.deleteButton||(this.dom.deleteButton.parentNode&&this.dom.deleteButton.parentNode.removeChild(this.dom.deleteButton),this.dom.deleteButton=null,this.hammerDeleteButton&&(this.hammerDeleteButton.destroy(),this.hammerDeleteButton=null))}},{key:"_repaintOnItemUpdateTimeTooltip",value:function(t){if(this.options.tooltipOnItemUpdateTime){var e=(this.options.editable.updateTime||!0===this.data.editable)&&!1!==this.data.editable;if(this.selected&&e&&!this.dom.onItemUpdateTimeTooltip){var i=document.createElement("div");i.className="vis-onUpdateTime-tooltip",t.appendChild(i),this.dom.onItemUpdateTimeTooltip=i}else!this.selected&&this.dom.onItemUpdateTimeTooltip&&(this.dom.onItemUpdateTimeTooltip.parentNode&&this.dom.onItemUpdateTimeTooltip.parentNode.removeChild(this.dom.onItemUpdateTimeTooltip),this.dom.onItemUpdateTimeTooltip=null);if(this.dom.onItemUpdateTimeTooltip){this.dom.onItemUpdateTimeTooltip.style.visibility=this.parent.itemSet.touchParams.itemIsDragging?"visible":"hidden",this.dom.onItemUpdateTimeTooltip.style.transform="translateX(-50%)",this.dom.onItemUpdateTimeTooltip.style.left="50%";var n,r,o=this.parent.itemSet.body.domProps.scrollTop;if(("top"==this.options.orientation.item?this.top:this.parent.height-this.top-this.height)+this.parent.top-50<-o?(this.dom.onItemUpdateTimeTooltip.style.bottom="",this.dom.onItemUpdateTimeTooltip.style.top="".concat(this.height+2,"px")):(this.dom.onItemUpdateTimeTooltip.style.top="",this.dom.onItemUpdateTimeTooltip.style.bottom="".concat(this.height+2,"px")),this.options.tooltipOnItemUpdateTime&&this.options.tooltipOnItemUpdateTime.template)n=Vf(r=this.options.tooltipOnItemUpdateTime.template).call(r,this)(this.data);else n="start: ".concat(sA(this.data.start).format("MM/DD/YYYY hh:mm")),this.data.end&&(n+="<br> end: ".concat(sA(this.data.end).format("MM/DD/YYYY hh:mm")));this.dom.onItemUpdateTimeTooltip.innerHTML=kI.xss(n)}}}},{key:"_getItemData",value:function(){return this.parent.itemSet.itemsData.get(this.id)}},{key:"_updateContents",value:function(t){var e,i,n,r,o,s,a=this._getItemData(),l=(this.dom.box||this.dom.point).getElementsByClassName("vis-item-visible-frame")[0];this.options.visibleFrameTemplate?(r=Vf(o=this.options.visibleFrameTemplate).call(o,this),n=kI.xss(r(a,l))):n="";if(l)if(n instanceof Object&&!(n instanceof Element))r(a,l);else if(this._contentToString(this.itemVisibleFrameContent)!==this._contentToString(n)){if(n instanceof Element)l.innerHTML="",l.appendChild(n);else if(null!=n)l.innerHTML=kI.xss(n);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.itemVisibleFrameContent=n}this.options.template?e=(i=Vf(s=this.options.template).call(s,this))(a,t,this.data):e=this.data.content;if(e instanceof Object&&!(e instanceof Element))i(a,t);else if(this._contentToString(this.content)!==this._contentToString(e)){if(e instanceof Element)t.innerHTML="",t.appendChild(e);else if(null!=e)t.innerHTML=kI.xss(e);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.content=e}}},{key:"_updateDataAttributes",value:function(t){if(this.options.dataAttributes&&this.options.dataAttributes.length>0){var e=[];if(Qp(this.options.dataAttributes))e=this.options.dataAttributes;else{if("all"!=this.options.dataAttributes)return;e=vf(this.data)}var i,n=FN(e);try{for(n.s();!(i=n.n()).done;){var r=i.value,o=this.data[r];null!=o?t.setAttribute("data-".concat(r),o):t.removeAttribute("data-".concat(r))}}catch(t){n.e(t)}finally{n.f()}}}},{key:"_updateStyle",value:function(t){this.style&&(kI.removeCssText(t,this.style),this.style=null),this.data.style&&(kI.addCssText(t,this.data.style),this.style=this.data.style)}},{key:"_contentToString",value:function(t){return"string"==typeof t?t:t&&"outerHTML"in t?t.outerHTML:t}},{key:"_updateEditStatus",value:function(){this.options&&("boolean"==typeof this.options.editable?this.editable={updateTime:this.options.editable,updateGroup:this.options.editable,remove:this.options.editable}:"object"===Lc(this.options.editable)&&(this.editable={},kI.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.options.editable))),this.options&&this.options.editable&&!0===this.options.editable.overrideItems||this.data&&("boolean"==typeof this.data.editable?this.editable={updateTime:this.data.editable,updateGroup:this.data.editable,remove:this.data.editable}:"object"===Lc(this.data.editable)&&(this.editable={},kI.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.data.editable)))}},{key:"getWidthLeft",value:function(){return 0}},{key:"getWidthRight",value:function(){return 0}},{key:"getTitle",value:function(){var t;return this.options.tooltip&&this.options.tooltip.template?Vf(t=this.options.tooltip.template).call(t,this)(this._getItemData(),this.data):this.data.title}}]),t}();function HN(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}YN.prototype.stack=!0;var zN=function(t){Vk(i,YN);var e=HN(i);function i(t,n,r){var o;if(Dd(this,i),(o=e.call(this,t,n,r)).props={dot:{width:0,height:0},line:{width:0,height:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return o}return Gc(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e,i=this.data.align||this.options.align,n=this.width*t.getMillisecondsPerPixel();return e="right"==i?this.data.start.getTime()>t.start&&this.data.start.getTime()-n<t.end:"left"==i?this.data.start.getTime()+n>t.start&&this.data.start.getTime()<t.end:this.data.start.getTime()+n/2>t.start&&this.data.start.getTime()-n/2<t.end,e}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-line",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-dot",this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}if(!this.dom.line.parentNode){var e=this.parent.dom.background;if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className="vis-item vis-box".concat(e),this.dom.line.className="vis-item vis-line".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},dot:{height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},line:{width:this.dom.line.offsetWidth},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.props.dot.height=t.dot.height,this.props.dot.width=t.dot.width,this.props.line.width=t.line.width,this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.box)}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Vf(e=this._createDomElement).call(e,this),Vf(i=this._appendDomElement).call(i,this),Vf(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(o=a._getDomComponentsSizes())},function(){var t;a.dirty&&Vf(t=a._updateDomComponentsSizes).call(t,a)(o)},Vf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(sm(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.remove?t.box.remove():t.box.parentNode&&t.box.parentNode.removeChild(t.box),t.line.remove?t.line.remove():t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.remove?t.dot.remove():t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot),this.displayed=!1}}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?Vp(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.box,this.boxX,this.boxY,t),e(this.dom.dot,this.dotX,this.dotY,t),e(this.dom.line,this.lineX,this.lineY,t)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=void 0===this.data.align?this.options.align:this.data.align,i=this.props.line.width,n=this.props.dot.width;"right"==e?(this.boxX=t-this.width,this.lineX=t-i,this.dotX=t-i/2-n/2):"left"==e?(this.boxX=t,this.lineX=t,this.dotX=t+i/2-n/2):(this.boxX=t-this.width/2,this.lineX=this.options.rtl?t-i:t-i/2,this.dotX=t-n/2),this.options.rtl?this.right=this.boxX:this.left=this.boxX,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.line.style;if("top"==t){var i=this.parent.top+this.top+1;this.boxY=this.top||0,e.height="".concat(i,"px"),e.bottom="",e.top="0"}else{var n=this.parent.itemSet.props.height-this.parent.top-this.parent.height+this.top;this.boxY=this.parent.height-this.top-(this.height||0),e.height="".concat(n,"px"),e.top="",e.bottom="0"}this.dotY=-this.props.dot.height/2,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}}]),i}();function BN(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}var GN=function(t){Vk(i,YN);var e=BN(i);function i(t,n,r){var o;if(Dd(this,i),(o=e.call(this,t,n,r)).props={dot:{top:0,width:0,height:0},content:{height:0,marginLeft:0,marginRight:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return o}return Gc(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e=this.width*t.getMillisecondsPerPixel();return this.data.start.getTime()+e>t.start&&this.data.start<t.end}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.point=document.createElement("div"),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.point.appendChild(this.dom.content),this.dom.dot=document.createElement("div"),this.dom.point.appendChild(this.dom.dot),this.dom.point["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.point.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.point)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.point),this._updateStyle(this.dom.point);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.point.className="vis-item vis-point".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{dot:{width:this.dom.dot.offsetWidth,height:this.dom.dot.offsetHeight},content:{width:this.dom.content.offsetWidth,height:this.dom.content.offsetHeight},point:{width:this.dom.point.offsetWidth,height:this.dom.point.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.dot.width=t.dot.width,this.props.dot.height=t.dot.height,this.props.content.height=t.content.height,this.options.rtl?this.dom.content.style.marginRight="".concat(this.props.dot.width/2,"px"):this.dom.content.style.marginLeft="".concat(this.props.dot.width/2,"px"),this.width=t.point.width,this.height=t.point.height,this.dom.dot.style.top="".concat((this.height-this.props.dot.height)/2,"px");var e=this.props.dot.width,i=this.options.rtl?e/2:e/2*-1;this.dom.dot.style.transform="translateX(".concat(i,"px"),this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.point),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.point)}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Vf(e=this._createDomElement).call(e,this),Vf(i=this._appendDomElement).call(i,this),Vf(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(o=a._getDomComponentsSizes())},function(){var t;a.dirty&&Vf(t=a._updateDomComponentsSizes).call(t,a)(o)},Vf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(sm(l).call(l,(function(t){s=t()})),s)}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?Vp(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.point,this.pointX,this.pointY,t)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){this.displayed&&(this.dom.point.parentNode&&this.dom.point.parentNode.removeChild(this.dom.point),this.displayed=!1)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start);this.pointX=t,this.options.rtl?this.right=t-this.props.dot.width:this.left=t-this.props.dot.width,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item;this.pointY="top"==t?this.top:this.parent.height-this.top-this.height,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.props.dot.width}},{key:"getWidthRight",value:function(){return this.props.dot.width}}]),i}();function WN(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}var VN=function(t){Vk(i,YN);var e=WN(i);function i(t,n,r){var o;if(Dd(this,i),(o=e.call(this,t,n,r)).props={content:{width:0}},o.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return o}return Gc(i,[{key:"isVisible",value:function(t){return!this.cluster&&(this.data.start<t.end&&this.data.end>t.start)}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.visibleFrame=document.createElement("div"),this.dom.visibleFrame.className="vis-item-visible-frame",this.dom.box.appendChild(this.dom.visibleFrame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className=this.baseClassName+e,this.dom.content.style.maxWidth="none"}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.frame).overflow,this.whiteSpace="nowrap"!==window.getComputedStyle(this.dom.content).whiteSpace,{content:{width:this.dom.content.offsetWidth},box:{height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=t.box.height,this.dom.content.style.maxWidth="",this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDeleteButton(this.dom.box),this._repaintDragCenter(),this._repaintDragLeft(),this._repaintDragRight()}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Vf(e=this._createDomElement).call(e,this),Vf(i=this._appendDomElement).call(i,this),Vf(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(o=Vf(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Vf(t=a._updateDomComponentsSizes).call(t,a)(o)},Vf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(sm(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom.box;t.parentNode&&t.parentNode.removeChild(t),this.displayed=!1}}},{key:"repositionX",value:function(t){var e,i,n=this.parent.width,r=this.conversion.toScreen(this.data.start),o=this.conversion.toScreen(this.data.end),s=void 0===this.data.align?this.options.align:this.data.align;!1===this.data.limitSize||void 0!==t&&!0!==t||(r<-n&&(r=-n),o>2*n&&(o=2*n));var a=Math.max(Math.round(1e3*(o-r))/1e3,1);switch(this.overflow?(this.options.rtl?this.right=r:this.left=r,this.width=a+this.props.content.width,i=this.props.content.width):(this.options.rtl?this.right=r:this.left=r,this.width=a,i=Math.min(o-r,this.props.content.width)),this.options.rtl?this.dom.box.style.transform="translateX(".concat(-1*this.right,"px)"):this.dom.box.style.transform="translateX(".concat(this.left,"px)"),this.dom.box.style.width="".concat(a,"px"),this.whiteSpace&&(this.height=this.dom.box.offsetHeight),s){case"left":this.dom.content.style.transform="translateX(0)";break;case"right":if(this.options.rtl){var l=-1*Math.max(a-i,0);this.dom.content.style.transform="translateX(".concat(l,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max(a-i,0),"px)");break;case"center":if(this.options.rtl){var h=-1*Math.max((a-i)/2,0);this.dom.content.style.transform="translateX(".concat(h,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max((a-i)/2,0),"px)");break;default:if(e=this.overflow?o>0?Math.max(-r,0):-i:r<0?-r:0,this.options.rtl){var u=-1*e;this.dom.content.style.transform="translateX(".concat(u,"px)")}else this.dom.content.style.transform="translateX(".concat(e,"px)")}}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;e.style.top="".concat("top"==t?this.top:this.parent.height-this.top-this.height,"px")}},{key:"_repaintDragLeft",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragLeft){var t=document.createElement("div");t.className="vis-drag-left",t.dragLeftItem=this,this.dom.box.appendChild(t),this.dom.dragLeft=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragLeft||(this.dom.dragLeft.parentNode&&this.dom.dragLeft.parentNode.removeChild(this.dom.dragLeft),this.dom.dragLeft=null)}},{key:"_repaintDragRight",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragRight){var t=document.createElement("div");t.className="vis-drag-right",t.dragRightItem=this,this.dom.box.appendChild(t),this.dom.dragRight=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragRight||(this.dom.dragRight.parentNode&&this.dom.dragRight.parentNode.removeChild(this.dom.dragRight),this.dom.dragRight=null)}}]),i}();function UN(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}VN.prototype.baseClassName="vis-item vis-range";var XN=function(t){Vk(i,YN);var e=UN(i);function i(t,n,r){var o;if(Dd(this,i),(o=e.call(this,t,n,r)).props={content:{width:0}},o.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return o}return Gc(i,[{key:"isVisible",value:function(t){return this.data.start<t.end&&this.data.end>t.start}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.background;if(!t)throw new Error("Cannot redraw item: parent has no background container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.content),this._updateStyle(this.dom.box);var t=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"");this.dom.box.className=this.baseClassName+t}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.content).overflow,{content:{width:this.dom.content.offsetWidth}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=0,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Vf(e=this._createDomElement).call(e,this),Vf(i=this._appendDomElement).call(i,this),Vf(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(o=Vf(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Vf(t=a._updateDomComponentsSizes).call(t,a)(o)},Vf(r=this._repaintDomAdditionals).call(r,this)];return t?l:(sm(l).call(l,(function(t){s=t()})),s)}},{key:"repositionY",value:function(t){var e,i=this.options.orientation.item;if(void 0!==this.data.subgroup){var n=this.data.subgroup;this.dom.box.style.height="".concat(this.parent.subgroups[n].height,"px"),this.dom.box.style.top="".concat("top"==i?this.parent.top+this.parent.subgroups[n].top:this.parent.top+this.parent.height-this.parent.subgroups[n].top-this.parent.subgroups[n].height,"px"),this.dom.box.style.bottom=""}else this.parent instanceof RN?(e=Math.max(this.parent.height,this.parent.itemSet.body.domProps.center.height,this.parent.itemSet.body.domProps.centerContainer.height),this.dom.box.style.bottom="bottom"==i?"0":"",this.dom.box.style.top="top"==i?"0":""):(e=this.parent.height,this.dom.box.style.top="".concat(this.parent.top,"px"),this.dom.box.style.bottom="");this.dom.box.style.height="".concat(e,"px")}}]),i}();XN.prototype.baseClassName="vis-item vis-background",XN.prototype.stack=!1,XN.prototype.show=VN.prototype.show,XN.prototype.hide=VN.prototype.hide,XN.prototype.repositionX=VN.prototype.repositionX;kL("div.vis-tooltip{background-color:#f5f4ed;border:1px solid #808074;-moz-border-radius:3px;-webkit-border-radius:3px;border-radius:3px;box-shadow:3px 3px 10px rgba(0,0,0,.2);color:#000;font-family:verdana;font-size:14px;padding:5px;pointer-events:none;position:absolute;visibility:hidden;white-space:nowrap;z-index:5}");var qN=function(){function t(e,i){Dd(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Gc(t,[{key:"setPosition",value:function(t,e){this.x=jg(t),this.y=jg(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=kI.xss(t)}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod||"none"==this.overflowMethod){var a=!1,l=!0;"flip"==this.overflowMethod&&(this.y-e<this.padding&&(l=!1),this.x+i>r-this.padding&&(a=!0)),o=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),$N={},ZN={get exports(){return $N},set exports(t){$N=t}},KN=Dl.every;Pn({target:"Array",proto:!0,forced:!$f("every")},{every:function(t){return KN(this,t,arguments.length>1?arguments[1]:void 0)}});var JN=gp("Array").every,QN=be,tR=JN,eR=Array.prototype,iR=function(t){var e=t.every;return t===eR||QN(eR,t)&&e===eR.every?tR:e},nR=iR;ZN.exports=nR;var rR=e($N);function oR(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return sR(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return sR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function sR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function aR(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}var lR=function(t){Vk(i,YN);var e=aR(i);function i(t,n,r){var o;Dd(this,i);var s=pv({},{fitOnDoubleClick:!0},r,{editable:!1});if((o=e.call(this,t,n,s)).props={content:{width:0,height:0}},!t||null==t.uiItems)throw new Error('Property "uiItems" missing in item '+t.id);return o.id=VP(),o.group=t.group,o._setupRange(),o.emitter=o.data.eventEmitter,o.range=o.data.range,o.attached=!1,o.isCluster=!0,o.data.isCluster=!0,o}return Gc(i,[{key:"hasItems",value:function(){return this.data.uiItems&&this.data.uiItems.length&&this.attached}},{key:"setUiItems",value:function(t){this.detach(),this.data.uiItems=t,this._setupRange(),this.attach()}},{key:"isVisible",value:function(t){var e=this.data.end?this.data.end-this.data.start:0,i=this.width*t.getMillisecondsPerPixel(),n=Math.max(this.data.start.getTime()+e,this.data.start.getTime()+i);return this.data.start<t.end&&n>t.start&&this.hasItems()}},{key:"getData",value:function(){return{isCluster:!0,id:this.id,items:this.data.items||[],data:this.data}}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a,l,h=[Vf(e=this._createDomElement).call(e,this),Vf(i=this._appendDomElement).call(i,this),Vf(n=this._updateDirtyDomComponents).call(n,this),Vf(r=function(){this.dirty&&(a=this._getDomComponentsSizes())}).call(r,this),Vf(o=function(){var t;this.dirty&&Vf(t=this._updateDomComponentsSizes).call(t,this)(a)}).call(o,this),Vf(s=this._repaintDomAdditionals).call(s,this)];return t?h:(sm(h).call(h,(function(t){l=t()})),l)}},{key:"show",value:function(){this.displayed||this.redraw()}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.parentNode.removeChild(t.box),this.options.showStipes&&(t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot)),this.displayed=!1}}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.data.end?this.conversion.toScreen(this.data.end):0;if(e)this.repositionXWithRanges(t,e);else{var i=void 0===this.data.align?this.options.align:this.data.align;this.repositionXWithoutRanges(t,i)}this.options.showStipes&&(this.dom.line.style.display=this._isStipeVisible()?"block":"none",this.dom.dot.style.display=this._isStipeVisible()?"block":"none",this._isStipeVisible()&&this.repositionStype(t,e))}},{key:"repositionStype",value:function(t,e){this.dom.line.style.display="block",this.dom.dot.style.display="block";var i=this.dom.line.offsetWidth,n=this.dom.dot.offsetWidth;if(e){var r=i+t+(e-t)/2,o=r-n/2,s=this.options.rtl?-1*r:r,a=this.options.rtl?-1*o:o;this.dom.line.style.transform="translateX(".concat(s,"px)"),this.dom.dot.style.transform="translateX(".concat(a,"px)")}else{var l=this.options.rtl?-1*t:t,h=this.options.rtl?-1*(t-n/2):t-n/2;this.dom.line.style.transform="translateX(".concat(l,"px)"),this.dom.dot.style.transform="translateX(".concat(h,"px)")}}},{key:"repositionXWithoutRanges",value:function(t,e){"right"==e?this.options.rtl?(this.right=t-this.width,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width,this.dom.box.style.left=this.left+"px"):"left"==e?this.options.rtl?(this.right=t,this.dom.box.style.right=this.right+"px"):(this.left=t,this.dom.box.style.left=this.left+"px"):this.options.rtl?(this.right=t-this.width/2,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width/2,this.dom.box.style.left=this.left+"px")}},{key:"repositionXWithRanges",value:function(t,e){var i=Math.round(Math.max(e-t+.5,1));this.options.rtl?this.right=t:this.left=t,this.width=Math.max(i,this.minWidth||0),this.options.rtl?this.dom.box.style.right=this.right+"px":this.dom.box.style.left=this.left+"px",this.dom.box.style.width=i+"px"}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;if(e.style.top="top"==t?(this.top||0)+"px":(this.parent.height-this.top-this.height||0)+"px",this.options.showStipes){if("top"==t)this.dom.line.style.top="0",this.dom.line.style.height=this.parent.top+this.top+1+"px",this.dom.line.style.bottom="";else{var i=this.parent.itemSet.props.height,n=i-this.parent.top-this.parent.height+this.top;this.dom.line.style.top=i-n+"px",this.dom.line.style.bottom="0"}this.dom.dot.style.top=-this.dom.dot.offsetHeight/2+"px"}}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}},{key:"move",value:function(){this.repositionX(),this.repositionY()}},{key:"attach",value:function(){var t,e,i=oR(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){e.value.cluster=this}}catch(t){i.e(t)}finally{i.f()}this.data.items=uf(t=this.data.uiItems).call(t,(function(t){return t.data})),this.attached=!0,this.dirty=!0}},{key:"detach",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.hasItems()){var e,i=oR(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){delete e.value.cluster}}catch(t){i.e(t)}finally{i.f()}this.attached=!1,t&&this.group&&(this.group.remove(this),this.group=null),this.data.items=[],this.dirty=!0}}},{key:"_onDoubleClick",value:function(){this._fit()}},{key:"_setupRange",value:function(){var t,e,i,n=uf(t=this.data.uiItems).call(t,(function(t){return{start:t.data.start.valueOf(),end:t.data.end?t.data.end.valueOf():t.data.start.valueOf()}}));this.data.min=Math.min.apply(Math,Lp(uf(n).call(n,(function(t){return Math.min(t.start,t.end||t.start)})))),this.data.max=Math.max.apply(Math,Lp(uf(n).call(n,(function(t){return Math.max(t.start,t.end||t.start)}))));var r=uf(e=this.data.uiItems).call(e,(function(t){return t.center})),o=aM(r).call(r,(function(t,e){return t+e}),0)/this.data.uiItems.length;zE(i=this.data.uiItems).call(i,(function(t){return t.data.end}))?(this.data.start=new Date(this.data.min),this.data.end=new Date(this.data.max)):(this.data.start=new Date(o),this.data.end=null)}},{key:"_getUiItems",value:function(){var t,e=this;return this.data.uiItems&&this.data.uiItems.length?eg(t=this.data.uiItems).call(t,(function(t){return t.cluster===e})):[]}},{key:"_createDomElement",value:function(){if(!this.dom){var t;if(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.options.showStipes&&(this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-cluster-line",this.dom.line.style.display="none",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-cluster-dot",this.dom.dot.style.display="none"),this.options.fitOnDoubleClick)this.dom.box.ondblclick=Vf(t=i.prototype._onDoubleClick).call(t,this);this.dom.box["vis-item"]=this,this.dirty=!0}}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}var e=this.parent.dom.background;if(this.options.showStipes){if(!this.dom.line.parentNode){if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.baseClassName+" "+(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+" vis-readonly";this.dom.box.className="vis-item "+t,this.options.showStipes&&(this.dom.line.className="vis-item vis-cluster-line "+(this.selected?" vis-selected":""),this.dom.dot.className="vis-item vis-cluster-dot "+(this.selected?" vis-selected":"")),this.data.end&&(this.dom.content.style.maxWidth="none")}}},{key:"_getDomComponentsSizes",value:function(){var t={previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}};return this.options.showStipes&&(t.dot={height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},t.line={width:this.dom.line.offsetWidth}),t}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.data.end?this.minWidth=t.box.width:this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box)}},{key:"_isStipeVisible",value:function(){return this.minWidth>=this.width||!this.data.end}},{key:"_getFitRange",value:function(){var t=.05*(this.data.max-this.data.min)/2;return{fitStart:this.data.min-t,fitEnd:this.data.max+t}}},{key:"_fit",value:function(){if(this.emitter){var t=this._getFitRange(),e=t.fitStart,i=t.fitEnd,n={start:new Date(e),end:new Date(i),animation:!0};this.emitter.emit("fit",n)}}},{key:"_getItemData",value:function(){return this.data}}]),i}();function hR(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return uR(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function uR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}lR.prototype.baseClassName="vis-item vis-range vis-cluster";var dR="__ungrouped__",cR=function(){function t(e){Dd(this,t),this.itemSet=e,this.groups={},this.cache={},this.cache[-1]=[]}return Gc(t,[{key:"createClusterItem",value:function(t,e,i){return new lR(t,e,i)}},{key:"setItems",value:function(t,e){this.items=t||[],this.dataChanged=!0,this.applyOnChangedLevel=!1,e&&e.applyOnChangedLevel&&(this.applyOnChangedLevel=e.applyOnChangedLevel)}},{key:"updateData",value:function(){this.dataChanged=!0,this.applyOnChangedLevel=!1}},{key:"getClusters",value:function(t,e,i){var n="boolean"==typeof i?{}:i,r=n.maxItems,o=n.clusterCriteria;o||(o=function(){return!0}),r=r||1;var s=-1,a=0;if(e>0){if(e>=1)return[];s=Math.abs(Math.round(Math.log(100/e)/Math.log(2))),a=Math.abs(Math.pow(2,s))}if(this.dataChanged){var l=s!=this.cacheLevel;(!this.applyOnChangedLevel||l)&&(this._dropLevelsCache(),this._filterData())}this.cacheLevel=s;var h=this.cache[s];if(!h){for(var u in h=[],this.groups)if(this.groups.hasOwnProperty(u))for(var d=this.groups[u],c=d.length,p=0;p<c;){for(var f=d[p],m=1,v=p-1;v>=0&&f.center-d[v].center<a/2;)!d[v].cluster&&o(f.data,d[v].data)&&m++,v--;for(var g=p+1;g<d.length&&d[g].center-f.center<a/2;)o(f.data,d[g].data)&&m++,g++;for(var y=h.length-1;y>=0&&f.center-h[y].center<a;)f.group==h[y].group&&o(f.data,h[y].data)&&m++,y--;if(m>r){for(var b=m-r+1,_=[],w=p;_.length<b&&w<d.length;)o(d[p].data,d[w].data)&&_.push(d[w]),w++;var k=this.itemSet.getGroupId(f.data),x=this.itemSet.groups[k]||this.itemSet.groups[dR],D=this._getClusterForItems(_,x,t,i);h.push(D),p+=b}else delete f.cluster,p+=1}this.cache[s]=h}return h}},{key:"_filterData",value:function(){var t={};this.groups=t;for(var e=0,i=pg(this.items);e<i.length;e++){var n=i[e],r=n.parent?n.parent.groupId:"",o=t[r];o||(o=[],t[r]=o),o.push(n),n.data.start&&(n.data.end?n.center=(n.data.start.valueOf()+n.data.end.valueOf())/2:n.center=n.data.start.valueOf())}for(var s in t){var a;if(t.hasOwnProperty(s))PE(a=t[s]).call(a,(function(t,e){return t.center-e.center}))}this.dataChanged=!1}},{key:"_getClusterForItems",value:function(t,e,i,n){var r,o,s=uf(r=i||[]).call(r,(function(t){var e;return{cluster:t,itemsIds:new FO(uf(e=t.data.uiItems).call(e,(function(t){return t.id})))}}));if(s.length){var a,l=hR(s);try{var h=function(){var e=a.value;if(e.itemsIds.size===t.length&&rR(t).call(t,(function(t){return e.itemsIds.has(t.id)})))return o=e.cluster,"break"};for(l.s();!(a=l.n()).done;){if("break"===h())break}}catch(t){l.e(t)}finally{l.f()}}if(o)return o.setUiItems(t),o.group!==e&&(o.group&&o.group.remove(o),e&&(e.add(o),o.group=e)),o;var u=n.titleTemplate||"",d={toScreen:this.itemSet.body.util.toScreen,toTime:this.itemSet.body.util.toTime},c=u.replace(/{count}/,t.length),p='<div title="'+c+'">'+t.length+"</div>",f=pv({},n,this.itemSet.options),m={content:p,title:c,group:e,uiItems:t,eventEmitter:this.itemSet.body.emitter,range:this.itemSet.body.range};return o=this.createClusterItem(m,d,f),e&&(e.add(o),o.group=e),o.attach(),o}},{key:"_dropLevelsCache",value:function(){this.cache={},this.cacheLevel=-1,this.cache[this.cacheLevel]=[]}}]),t}();kL('.vis-itemset{box-sizing:border-box;margin:0;padding:0;position:relative}.vis-itemset .vis-background,.vis-itemset .vis-foreground{height:100%;overflow:visible;position:absolute;width:100%}.vis-axis{height:0;left:0;position:absolute;width:100%;z-index:1}.vis-foreground .vis-group{border-bottom:1px solid #bfbfbf;box-sizing:border-box;position:relative}.vis-foreground .vis-group:last-child{border-bottom:none}.vis-nesting-group{cursor:pointer}.vis-label.vis-nested-group.vis-group-level-unknown-but-gte1{background:#f5f5f5}.vis-label.vis-nested-group.vis-group-level-0{background-color:#fff}.vis-ltr .vis-label.vis-nested-group.vis-group-level-0 .vis-inner{padding-left:0}.vis-rtl .vis-label.vis-nested-group.vis-group-level-0 .vis-inner{padding-right:0}.vis-label.vis-nested-group.vis-group-level-1{background-color:rgba(0,0,0,.05)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-1 .vis-inner{padding-left:15px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-1 .vis-inner{padding-right:15px}.vis-label.vis-nested-group.vis-group-level-2{background-color:rgba(0,0,0,.1)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-2 .vis-inner{padding-left:30px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-2 .vis-inner{padding-right:30px}.vis-label.vis-nested-group.vis-group-level-3{background-color:rgba(0,0,0,.15)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-3 .vis-inner{padding-left:45px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-3 .vis-inner{padding-right:45px}.vis-label.vis-nested-group.vis-group-level-4{background-color:rgba(0,0,0,.2)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-4 .vis-inner{padding-left:60px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-4 .vis-inner{padding-right:60px}.vis-label.vis-nested-group.vis-group-level-5{background-color:rgba(0,0,0,.25)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-5 .vis-inner{padding-left:75px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-5 .vis-inner{padding-right:75px}.vis-label.vis-nested-group.vis-group-level-6{background-color:rgba(0,0,0,.3)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-6 .vis-inner{padding-left:90px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-6 .vis-inner{padding-right:90px}.vis-label.vis-nested-group.vis-group-level-7{background-color:rgba(0,0,0,.35)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-7 .vis-inner{padding-left:105px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-7 .vis-inner{padding-right:105px}.vis-label.vis-nested-group.vis-group-level-8{background-color:rgba(0,0,0,.4)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-8 .vis-inner{padding-left:120px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-8 .vis-inner{padding-right:120px}.vis-label.vis-nested-group.vis-group-level-9{background-color:rgba(0,0,0,.45)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-9 .vis-inner{padding-left:135px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-9 .vis-inner{padding-right:135px}.vis-label.vis-nested-group{background-color:rgba(0,0,0,.5)}.vis-ltr .vis-label.vis-nested-group .vis-inner{padding-left:150px}.vis-rtl .vis-label.vis-nested-group .vis-inner{padding-right:150px}.vis-group-level-unknown-but-gte1{border:1px solid red}.vis-label.vis-nesting-group:before{display:inline-block;width:15px}.vis-label.vis-nesting-group.expanded:before{content:"\\25BC"}.vis-label.vis-nesting-group.collapsed:before{content:"\\25B6"}.vis-rtl .vis-label.vis-nesting-group.collapsed:before{content:"\\25C0"}.vis-ltr .vis-label:not(.vis-nesting-group):not(.vis-group-level-0){padding-left:15px}.vis-rtl .vis-label:not(.vis-nesting-group):not(.vis-group-level-0){padding-right:15px}.vis-overlay{height:100%;left:0;position:absolute;top:0;width:100%;z-index:10}');function pR(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return fR(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function fR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function mR(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}kL(".vis-labelset{overflow:hidden}.vis-labelset,.vis-labelset .vis-label{box-sizing:border-box;position:relative}.vis-labelset .vis-label{border-bottom:1px solid #bfbfbf;color:#4d4d4d;left:0;top:0;width:100%}.vis-labelset .vis-label.draggable{cursor:pointer}.vis-group-is-dragging{background:rgba(0,0,0,.1)}.vis-labelset .vis-label:last-child{border-bottom:none}.vis-labelset .vis-label .vis-inner{display:inline-block;padding:5px}.vis-labelset .vis-label .vis-inner.vis-hidden{padding:0}");var vR="__ungrouped__",gR="__background__",yR=function(t){Vk(i,FI);var e=mR(i);function i(t,n){var r;Dd(this,i),(r=e.call(this)).body=t,r.defaultOptions={type:null,orientation:{item:"bottom"},align:"auto",stack:!0,stackSubgroups:!0,groupOrderSwap:function(t,e,i){var n=e.order;e.order=t.order,t.order=n},groupOrder:"order",selectable:!0,multiselect:!1,longSelectPressTime:251,itemsAlwaysDraggable:{item:!1,range:!1},editable:{updateTime:!1,updateGroup:!1,add:!1,remove:!1,overrideItems:!1},groupEditable:{order:!1,add:!1,remove:!1},snap:wL.snap,onDropObjectOnItem:function(t,e,i){i(e)},onAdd:function(t,e){e(t)},onUpdate:function(t,e){e(t)},onMove:function(t,e){e(t)},onRemove:function(t,e){e(t)},onMoving:function(t,e){e(t)},onAddGroup:function(t,e){e(t)},onMoveGroup:function(t,e){e(t)},onRemoveGroup:function(t,e){e(t)},margin:{item:{horizontal:10,vertical:10},axis:20},showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:500},tooltipOnItemUpdateTime:!1},r.options=kI.extend({},r.defaultOptions),r.options.rtl=n.rtl,r.options.onTimeout=n.onTimeout,r.conversion={toScreen:t.util.toScreen,toTime:t.util.toTime},r.dom={},r.props={},r.hammer=null;var o=Tk(r);return r.itemsData=null,r.groupsData=null,r.itemsSettingTime=null,r.initialItemSetDrawn=!1,r.userContinueNotBail=null,r.sequentialSelection=!1,r.itemListeners={add:function(t,e,i){o._onAdd(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()},update:function(t,e,i){o._onUpdate(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()},remove:function(t,e,i){o._onRemove(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()}},r.groupListeners={add:function(t,e,i){if(o._onAddGroups(e.items),o.groupsData&&o.groupsData.length>0){var n,r=o.groupsData.getDataSet();sm(n=r.get()).call(n,(function(t){if(t.nestedGroups){var e;0!=t.showNested&&(t.showNested=!0);var n=[];sm(e=t.nestedGroups).call(e,(function(e){var i=r.get(e);i&&(i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),n=Vp(n).call(n,i))})),r.update(n,i)}}))}},update:function(t,e,i){o._onUpdateGroups(e.items)},remove:function(t,e,i){o._onRemoveGroups(e.items)}},r.items={},r.groups={},r.groupIds=[],r.selection=[],r.popup=null,r.popupTimer=null,r.touchParams={},r.groupTouchParams={group:null,isDragging:!1},r._create(),r.setOptions(n),r.clusters=[],r}return Gc(i,[{key:"_create",value:function(){var t,e,i,n,r,o,s,a,l,h,u,d,c,p,f,m=this,v=document.createElement("div");v.className="vis-itemset",v["vis-itemset"]=this,this.dom.frame=v;var g=document.createElement("div");g.className="vis-background",v.appendChild(g),this.dom.background=g;var y=document.createElement("div");y.className="vis-foreground",v.appendChild(y),this.dom.foreground=y;var b=document.createElement("div");b.className="vis-axis",this.dom.axis=b;var _=document.createElement("div");_.className="vis-labelset",this.dom.labelSet=_,this._updateUngrouped();var w=new RN(gR,null,this);w.show(),this.groups[gR]=w,this.hammer=new bL(this.body.dom.centerContainer),this.hammer.on("hammer.input",(function(t){t.isFirst&&m._onTouch(t)})),this.hammer.on("panstart",Vf(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Vf(e=this._onDrag).call(e,this)),this.hammer.on("panend",Vf(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:bL.ALL}),this.hammer.get("press").set({time:1e4}),this.hammer.on("tap",Vf(n=this._onSelectItem).call(n,this)),this.hammer.on("press",Vf(r=this._onMultiSelectItem).call(r,this)),this.hammer.get("press").set({time:1e4}),this.hammer.on("doubletap",Vf(o=this._onAddItem).call(o,this)),this.options.rtl?this.groupHammer=new bL(this.body.dom.rightContainer):this.groupHammer=new bL(this.body.dom.leftContainer),this.groupHammer.on("tap",Vf(s=this._onGroupClick).call(s,this)),this.groupHammer.on("panstart",Vf(a=this._onGroupDragStart).call(a,this)),this.groupHammer.on("panmove",Vf(l=this._onGroupDrag).call(l,this)),this.groupHammer.on("panend",Vf(h=this._onGroupDragEnd).call(h,this)),this.groupHammer.get("pan").set({threshold:5,direction:bL.DIRECTION_VERTICAL}),this.body.dom.centerContainer.addEventListener("mouseover",Vf(u=this._onMouseOver).call(u,this)),this.body.dom.centerContainer.addEventListener("mouseout",Vf(d=this._onMouseOut).call(d,this)),this.body.dom.centerContainer.addEventListener("mousemove",Vf(c=this._onMouseMove).call(c,this)),this.body.dom.centerContainer.addEventListener("contextmenu",Vf(p=this._onDragEnd).call(p,this)),this.body.dom.centerContainer.addEventListener("mousewheel",Vf(f=this._onMouseWheel).call(f,this)),this.show()}},{key:"setOptions",value:function(t){var e=this;if(t){var i,n;kI.selectiveExtend(["type","rtl","align","order","stack","stackSubgroups","selectable","multiselect","sequentialSelection","multiselectPerGroup","longSelectPressTime","groupOrder","dataAttributes","template","groupTemplate","visibleFrameTemplate","hide","snap","groupOrderSwap","showTooltips","tooltip","tooltipOnItemUpdateTime","groupHeightMode","onTimeout"],this.options,t),"itemsAlwaysDraggable"in t&&("boolean"==typeof t.itemsAlwaysDraggable?(this.options.itemsAlwaysDraggable.item=t.itemsAlwaysDraggable,this.options.itemsAlwaysDraggable.range=!1):"object"===Lc(t.itemsAlwaysDraggable)&&(kI.selectiveExtend(["item","range"],this.options.itemsAlwaysDraggable,t.itemsAlwaysDraggable),this.options.itemsAlwaysDraggable.item||(this.options.itemsAlwaysDraggable.range=!1))),"sequentialSelection"in t&&"boolean"==typeof t.sequentialSelection&&(this.options.sequentialSelection=t.sequentialSelection),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.item="top"===t.orientation?"top":"bottom":"object"===Lc(t.orientation)&&"item"in t.orientation&&(this.options.orientation.item=t.orientation.item)),"margin"in t&&("number"==typeof t.margin?(this.options.margin.axis=t.margin,this.options.margin.item.horizontal=t.margin,this.options.margin.item.vertical=t.margin):"object"===Lc(t.margin)&&(kI.selectiveExtend(["axis"],this.options.margin,t.margin),"item"in t.margin&&("number"==typeof t.margin.item?(this.options.margin.item.horizontal=t.margin.item,this.options.margin.item.vertical=t.margin.item):"object"===Lc(t.margin.item)&&kI.selectiveExtend(["horizontal","vertical"],this.options.margin.item,t.margin.item)))),sm(i=["locale","locales"]).call(i,(function(i){i in t&&(e.options[i]=t[i])})),"editable"in t&&("boolean"==typeof t.editable?(this.options.editable.updateTime=t.editable,this.options.editable.updateGroup=t.editable,this.options.editable.add=t.editable,this.options.editable.remove=t.editable,this.options.editable.overrideItems=!1):"object"===Lc(t.editable)&&kI.selectiveExtend(["updateTime","updateGroup","add","remove","overrideItems"],this.options.editable,t.editable)),"groupEditable"in t&&("boolean"==typeof t.groupEditable?(this.options.groupEditable.order=t.groupEditable,this.options.groupEditable.add=t.groupEditable,this.options.groupEditable.remove=t.groupEditable):"object"===Lc(t.groupEditable)&&kI.selectiveExtend(["order","add","remove"],this.options.groupEditable,t.groupEditable));sm(n=["onDropObjectOnItem","onAdd","onUpdate","onRemove","onMove","onMoving","onAddGroup","onMoveGroup","onRemoveGroup"]).call(n,(function(i){var n=t[i];if(n){var r;if("function"!=typeof n)throw new Error(Vp(r="option ".concat(i," must be a function ")).call(r,i,"(item, callback)"));e.options[i]=n}})),t.cluster?(pv(this.options,{cluster:t.cluster}),this.clusterGenerator||(this.clusterGenerator=new cR(this)),this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.clusterGenerator?(this._detachAllClusters(),this.clusters=[],this.clusterGenerator=null,this.options.cluster=void 0,this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.markDirty()}}},{key:"markDirty",value:function(t){this.groupIds=[],t&&(t.refreshItems&&sm(kI).call(kI,this.items,(function(t){t.dirty=!0,t.displayed&&t.redraw()})),t.restackGroups&&sm(kI).call(kI,this.groups,(function(t,e){e!==gR&&(t.stackDirty=!0)})))}},{key:"destroy",value:function(){this.clearPopupTimer(),this.hide(),this.setItems(null),this.setGroups(null),this.hammer&&this.hammer.destroy(),this.groupHammer&&this.groupHammer.destroy(),this.hammer=null,this.body=null,this.conversion=null}},{key:"hide",value:function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.axis.parentNode&&this.dom.axis.parentNode.removeChild(this.dom.axis),this.dom.labelSet.parentNode&&this.dom.labelSet.parentNode.removeChild(this.dom.labelSet)}},{key:"show",value:function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame),this.dom.axis.parentNode||this.body.dom.backgroundVertical.appendChild(this.dom.axis),this.dom.labelSet.parentNode||(this.options.rtl?this.body.dom.right.appendChild(this.dom.labelSet):this.body.dom.left.appendChild(this.dom.labelSet))}},{key:"setPopupTimer",value:function(t){if(this.clearPopupTimer(),t){var e=this.options.tooltip.delay||"number"==typeof this.options.tooltip.delay?this.options.tooltip.delay:500;this.popupTimer=Vy((function(){t.show()}),e)}}},{key:"clearPopupTimer",value:function(){null!=this.popupTimer&&(clearTimeout(this.popupTimer),this.popupTimer=null)}},{key:"setSelection",value:function(t){var e;null==t&&(t=[]),Qp(t)||(t=[t]);var i,n=eg(e=this.selection).call(e,(function(e){return-1===Jg(t).call(t,e)})),r=pR(n);try{for(r.s();!(i=r.n()).done;){var o=i.value,s=this.getItemById(o);s&&s.unselect()}}catch(t){r.e(t)}finally{r.f()}this.selection=Lp(t);var a,l=pR(t);try{for(l.s();!(a=l.n()).done;){var h=a.value,u=this.getItemById(h);u&&u.select()}}catch(t){l.e(t)}finally{l.f()}}},{key:"getSelection",value:function(){var t;return Vp(t=this.selection).call(t,[])}},{key:"getVisibleItems",value:function(){var t,e,i=this.body.range.getRange();this.options.rtl?(t=this.body.util.toScreen(i.start),e=this.body.util.toScreen(i.end)):(e=this.body.util.toScreen(i.start),t=this.body.util.toScreen(i.end));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o,s=this.groups[r],a=pR(s.isVisible?s.visibleItems:[]);try{for(a.s();!(o=a.n()).done;){var l=o.value;this.options.rtl?l.right<e&&l.right+l.width>t&&n.push(l.id):l.left<t&&l.left+l.width>e&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getItemsAtCurrentTime",value:function(t){var e,i;this.options.rtl?(e=this.body.util.toScreen(t),i=this.body.util.toScreen(t)):(i=this.body.util.toScreen(t),e=this.body.util.toScreen(t));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o,s=this.groups[r],a=pR(s.isVisible?s.visibleItems:[]);try{for(a.s();!(o=a.n()).done;){var l=o.value;this.options.rtl?l.right<i&&l.right+l.width>e&&n.push(l.id):l.left<e&&l.left+l.width>i&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getVisibleGroups",value:function(){var t=[];for(var e in this.groups){if(this.groups.hasOwnProperty(e))this.groups[e].isVisible&&t.push(e)}return t}},{key:"getItemById",value:function(t){var e;return this.items[t]||sN(e=this.clusters).call(e,(function(e){return e.id===t}))}},{key:"_deselect",value:function(t){for(var e=this.selection,i=0,n=e.length;i<n;i++)if(e[i]==t){$m(e).call(e,i,1);break}}},{key:"redraw",value:function(){var t=this.options.margin,e=this.body.range,i=kI.option.asSize,n=this.options,r=n.orientation.item,o=!1,s=this.dom.frame;this.props.top=this.body.domProps.top.height+this.body.domProps.border.top,this.options.rtl?this.props.right=this.body.domProps.right.width+this.body.domProps.border.right:this.props.left=this.body.domProps.left.width+this.body.domProps.border.left,s.className="vis-itemset",this.options.cluster&&this._clusterItems(),o=this._orderGroups()||o;var a=e.end-e.start,l=a!=this.lastVisibleInterval||this.props.width!=this.props.lastWidth,h=e.start!=this.lastRangeStart,u=n.stack!=this.lastStack,d=n.stackSubgroups!=this.lastStackSubgroups,c=l||h||u||d;this.lastVisibleInterval=a,this.lastRangeStart=e.start,this.lastStack=n.stack,this.lastStackSubgroups=n.stackSubgroups,this.props.lastWidth=this.props.width;var p=this._firstGroup(),f={item:t.item,axis:t.axis},m={item:t.item,axis:t.item.vertical/2},v=0,g=t.axis+t.item.vertical;this.groups[gR].redraw(e,m,c);var y={},b=0;if(sm(kI).call(kI,this.groups,(function(t,i){if(i!==gR){var n=t==p?f:m;y[i]=t.redraw(e,n,c,!0),b=y[i].length}})),b>0){for(var _={},w=function(t){sm(kI).call(kI,y,(function(e,i){_[i]=e[t]()}))},k=0;k<b;k++)w(k);sm(kI).call(kI,this.groups,(function(t,e){if(e!==gR){var i=_[e];o=i||o,v+=t.height}})),v=Math.max(v,g)}return v=Math.max(v,g),s.style.height=i(v),this.props.width=s.offsetWidth,this.props.height=v,this.dom.axis.style.top=i("top"==r?this.body.domProps.top.height+this.body.domProps.border.top:this.body.domProps.top.height+this.body.domProps.centerContainer.height),this.options.rtl?this.dom.axis.style.right="0":this.dom.axis.style.left="0",this.hammer.get("press").set({time:this.options.longSelectPressTime}),this.initialItemSetDrawn=!0,o=this._isResized()||o}},{key:"_firstGroup",value:function(){var t="top"==this.options.orientation.item?0:this.groupIds.length-1,e=this.groupIds[t];return this.groups[e]||this.groups[vR]||null}},{key:"_updateUngrouped",value:function(){var t,e,i=this.groups[vR];if(this.groupsData){if(i)for(e in i.dispose(),delete this.groups[vR],this.items)if(this.items.hasOwnProperty(e)){(t=this.items[e]).parent&&t.parent.remove(t);var n=this.getGroupId(t.data),r=this.groups[n];r&&r.add(t)||t.hide()}}else if(!i){for(e in i=new LN(null,null,this),this.groups[vR]=i,this.items)this.items.hasOwnProperty(e)&&(t=this.items[e],i.add(t));i.show()}}},{key:"getLabelSet",value:function(){return this.dom.labelSet}},{key:"setItems",value:function(t){this.itemsSettingTime=new Date;var e,i=this,n=this.itemsData;if(t){if(!fI(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=yI(t)}else this.itemsData=null;if(n&&(sm(kI).call(kI,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;sm(kI).call(kI,this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e),this._updateUngrouped()}this.body.emitter.emit("_change",{queue:!0})}},{key:"getItems",value:function(){return null!=this.itemsData?this.itemsData.rawDS:null}},{key:"setGroups",value:function(t){var e,i=this;if(this.groupsData&&(sm(kI).call(kI,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null,this._onRemoveGroups(e)),t){if(!fI(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var n,r=this.groupsData.getDataSet();sm(n=r.get()).call(n,(function(t){var e;t.nestedGroups&&sm(e=t.nestedGroups).call(e,(function(e){var i=r.get(e);i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),r.update(i)}))}));var o=this.id;sm(kI).call(kI,this.groupListeners,(function(t,e){i.groupsData.on(e,t,o)})),e=this.groupsData.getIds(),this._onAddGroups(e)}this._updateUngrouped(),this._order(),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems(),this.markDirty({refreshItems:!0,restackGroups:!0})),this.body.emitter.emit("_change",{queue:!0})}},{key:"getGroups",value:function(){return this.groupsData}},{key:"removeItem",value:function(t){var e=this,i=this.itemsData.get(t);i&&this.options.onRemove(i,(function(i){i&&e.itemsData.remove(t)}))}},{key:"_getType",value:function(t){return t.type||this.options.type||(t.end?"range":"box")}},{key:"getGroupId",value:function(t){return"background"==this._getType(t)&&null==t.group?gR:this.groupsData?t.group:vR}},{key:"_onUpdate",value:function(t){var e=this,n=this;sm(t).call(t,(function(t){var r,o=n.itemsData.get(t),s=n.items[t],a=o?n._getType(o):null,l=i.types[a];if(s&&(l&&s instanceof l?n._updateItem(s,o):(r=s.selected,n._removeItem(s),s=null)),!s&&o){if(!l)throw new TypeError('Unknown item type "'.concat(a,'"'));(s=new l(o,n.conversion,n.options)).id=t,n._addItem(s),r&&(e.selection.push(t),s.select())}})),this._order(),this.options.cluster&&(this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this._clusterItems()),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemove",value:function(t){var e=0,i=this;sm(t).call(t,(function(t){var n=i.items[t];n&&(e++,i._removeItem(n))})),e&&(this._order(),this.body.emitter.emit("_change",{queue:!0}))}},{key:"_order",value:function(){sm(kI).call(kI,this.groups,(function(t){t.order()}))}},{key:"_onUpdateGroups",value:function(t){this._onAddGroups(t)}},{key:"_onAddGroups",value:function(t){var e=this;sm(t).call(t,(function(t){var i=e.groupsData.get(t),n=e.groups[t];if(n)n.setData(i);else{if(t==vR||t==gR)throw new Error("Illegal group id. ".concat(t," is a reserved id."));var r=vy(e.options);for(var o in kI.extend(r,{height:null}),n=new LN(t,i,e),e.groups[t]=n,e.items)if(e.items.hasOwnProperty(o)){var s=e.items[o];s.data.group==t&&n.add(s)}n.order(),n.show()}})),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemoveGroups",value:function(t){var e=this;sm(t).call(t,(function(t){var i=e.groups[t];i&&(i.dispose(),delete e.groups[t])})),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems()),this.markDirty({restackGroups:!!this.options.cluster}),this.body.emitter.emit("_change",{queue:!0})}},{key:"_orderGroups",value:function(){if(this.groupsData){var t=this.groupsData.getIds({order:this.options.groupOrder});t=this._orderNestedGroups(t);var e=!kI.equalArray(t,this.groupIds);if(e){var i=this.groups;sm(t).call(t,(function(t){i[t].hide()})),sm(t).call(t,(function(t){i[t].show()})),this.groupIds=t}return e}return!1}},{key:"_orderNestedGroups",value:function(t){var e=this;return function t(e,i){var n=[];return sm(i).call(i,(function(i){if(n.push(i),e.groupsData.get(i).nestedGroups){var r,o=uf(r=e.groupsData.get({filter:function(t){return t.nestedInGroup==i},order:e.options.groupOrder})).call(r,(function(t){return t.id}));n=Vp(n).call(n,t(e,o))}})),n}(this,eg(t).call(t,(function(t){return!e.groupsData.get(t).nestedInGroup})))}},{key:"_addItem",value:function(t){this.items[t.id]=t;var e=this.getGroupId(t.data),i=this.groups[e];i?i&&i.data&&i.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1,i&&i.add(t)}},{key:"_updateItem",value:function(t,e){t.setData(e);var i=this.getGroupId(t.data),n=this.groups[i];n?n&&n.data&&n.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1}},{key:"_removeItem",value:function(t){var e,i;t.hide(),delete this.items[t.id];var n=Jg(e=this.selection).call(e,t.id);-1!=n&&$m(i=this.selection).call(i,n,1),t.parent&&t.parent.remove(t),null!=this.popup&&this.popup.hide()}},{key:"_constructByEndArray",value:function(t){for(var e=[],i=0;i<t.length;i++)t[i]instanceof VN&&e.push(t[i]);return e}},{key:"_onTouch",value:function(t){this.touchParams.item=this.itemFromTarget(t),this.touchParams.dragLeftItem=t.target.dragLeftItem||!1,this.touchParams.dragRightItem=t.target.dragRightItem||!1,this.touchParams.itemProps=null}},{key:"_getGroupIndex",value:function(t){for(var e=0;e<this.groupIds.length;e++)if(t==this.groupIds[e])return e}},{key:"_onDragStart",value:function(t){var e=this;if(!this.touchParams.itemIsDragging){var i,n=this.touchParams.item||null,r=this;if(n&&(n.selected||this.options.itemsAlwaysDraggable.item)){if(this.options.editable.overrideItems&&!this.options.editable.updateTime&&!this.options.editable.updateGroup)return;if(null!=n.editable&&!n.editable.updateTime&&!n.editable.updateGroup&&!this.options.editable.overrideItems)return;var o=this.touchParams.dragLeftItem,s=this.touchParams.dragRightItem;if(this.touchParams.itemIsDragging=!0,this.touchParams.selectedItem=n,o)i={item:o,initialX:t.center.x,dragLeft:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(s)i={item:s,initialX:t.center.x,dragRight:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey))this._onDragStartAddItem(t);else{this.groupIds.length<1&&this.redraw();var a=this._getGroupIndex(n.data.group),l=this.options.itemsAlwaysDraggable.item&&!n.selected?[n.id]:this.getSelection();this.touchParams.itemProps=uf(l).call(l,(function(i){var n=r.items[i],o=r._getGroupIndex(n.data.group);return{item:n,initialX:t.center.x,groupOffset:a-o,data:e._cloneItemData(n.data)}}))}t.stopPropagation()}else this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey)&&this._onDragStartAddItem(t)}}},{key:"_onDragStartAddItem",value:function(t){var e=this.options.snap||null,i=this.dom.frame.getBoundingClientRect(),n=this.options.rtl?i.right-t.center.x+10:t.center.x-i.left-10,r=this.body.util.toTime(n),o=this.body.util.getScale(),s=this.body.util.getStep(),a=e?e(r,o,s):r,l={type:"range",start:a,end:a,content:"new item"},h=VP();l[this.itemsData.idProp]=h;var u=this.groupFromTarget(t);u&&(l.group=u.groupId);var d=new VN(l,this.conversion,this.options);d.id=h,d.data=this._cloneItemData(l),this._addItem(d),this.touchParams.selectedItem=d;var c={item:d,initialX:t.center.x,data:d.data};this.options.rtl?c.dragLeft=!0:c.dragRight=!0,this.touchParams.itemProps=[c],t.stopPropagation()}},{key:"_onDrag",value:function(t){var e=this;if(null!=this.popup&&this.options.showTooltips&&!this.popup.hidden){var i=this.body.dom.centerContainer,n=i.getBoundingClientRect();this.popup.setPosition(t.center.x-n.left+i.offsetLeft,t.center.y-n.top+i.offsetTop),this.popup.show()}if(this.touchParams.itemProps){var r;t.stopPropagation();var o=this,s=this.options.snap||null,a=this.body.dom.root.offsetLeft,l=this.options.rtl?a+this.body.domProps.right.width:a+this.body.domProps.left.width,h=this.body.util.getScale(),u=this.body.util.getStep(),d=this.touchParams.selectedItem,c=(this.options.editable.overrideItems||null==d.editable)&&this.options.editable.updateGroup||!this.options.editable.overrideItems&&null!=d.editable&&d.editable.updateGroup,p=null;if(c&&d&&null!=d.data.group){var f=o.groupFromTarget(t);f&&(p=this._getGroupIndex(f.groupId))}sm(r=this.touchParams.itemProps).call(r,(function(i){var n,r,a,f,m,v=o.body.util.toTime(t.center.x-l),g=o.body.util.toTime(i.initialX-l);n=e.options.rtl?-(v-g):v-g;var y=e._cloneItemData(i.item.data);if(null==i.item.editable||i.item.editable.updateTime||i.item.editable.updateGroup||o.options.editable.overrideItems){if((e.options.editable.overrideItems||null==d.editable)&&e.options.editable.updateTime||!e.options.editable.overrideItems&&null!=d.editable&&d.editable.updateTime)if(i.dragLeft)e.options.rtl?null!=y.end&&(a=kI.convert(i.data.end,"Date"),m=new Date(a.valueOf()+n),y.end=s?s(m,h,u):m):null!=y.start&&(r=kI.convert(i.data.start,"Date"),f=new Date(r.valueOf()+n),y.start=s?s(f,h,u):f);else if(i.dragRight)e.options.rtl?null!=y.start&&(r=kI.convert(i.data.start,"Date"),f=new Date(r.valueOf()+n),y.start=s?s(f,h,u):f):null!=y.end&&(a=kI.convert(i.data.end,"Date"),m=new Date(a.valueOf()+n),y.end=s?s(m,h,u):m);else if(null!=y.start)if(r=kI.convert(i.data.start,"Date").valueOf(),f=new Date(r+n),null!=y.end){var b=(a=kI.convert(i.data.end,"Date")).valueOf()-r.valueOf();y.start=s?s(f,h,u):f,y.end=new Date(y.start.valueOf()+b)}else y.start=s?s(f,h,u):f;if(c&&!i.dragLeft&&!i.dragRight&&null!=p&&null!=y.group){var _=p-i.groupOffset;_=Math.max(0,_),_=Math.min(o.groupIds.length-1,_),y.group=o.groupIds[_]}y=e._cloneItemData(y),o.options.onMoving(y,(function(t){t&&i.item.setData(e._cloneItemData(t,"Date"))}))}})),this.body.emitter.emit("_change")}}},{key:"_moveToGroup",value:function(t,e){var i=this.groups[e];if(i&&i.groupId!=t.data.group){var n=t.parent;n.remove(t),n.order(),t.data.group=i.groupId,i.add(t),i.order()}}},{key:"_onDragEnd",value:function(t){var e=this;if(this.touchParams.itemIsDragging=!1,this.touchParams.itemProps){t.stopPropagation();var i=this,n=this.touchParams.itemProps;this.touchParams.itemProps=null,sm(n).call(n,(function(t){var n=t.item.id;if(null!=i.itemsData.get(n)){var r=e._cloneItemData(t.item.data);i.options.onMove(r,(function(r){r?(r[e.itemsData.idProp]=n,e.itemsData.update(r)):(t.item.setData(t.data),i.body.emitter.emit("_change"))}))}else i.options.onAdd(t.item.data,(function(e){i._removeItem(t.item),e&&i.itemsData.add(e),i.body.emitter.emit("_change")}))}))}}},{key:"_onGroupClick",value:function(t){var e=this,i=this.groupFromTarget(t);Vy((function(){e.toggleGroupShowNested(i)}),1)}},{key:"toggleGroupShowNested",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(t&&t.nestedGroups){var i=this.groupsData.getDataSet();t.showNested=null!=e?!!e:!t.showNested;var n=i.get(t.groupId);n.showNested=t.showNested;for(var r,o=t.nestedGroups,s=o;s.length>0;){var a=s;s=[];for(var l=0;l<a.length;l++){var h=i.get(a[l]);h.nestedGroups&&(s=Vp(s).call(s,h.nestedGroups))}s.length>0&&(o=Vp(o).call(o,s))}if(n.showNested){for(var u=i.get(n.nestedGroups),d=0;d<u.length;d++){var c=u[d];c.nestedGroups&&c.nestedGroups.length>0&&(null==c.showNested||1==c.showNested)&&u.push.apply(u,Lp(i.get(c.nestedGroups)))}r=uf(u).call(u,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}else{var p;r=uf(p=i.get(o)).call(p,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}i.update(Vp(r).call(r,n)),n.showNested?(kI.removeClassName(t.dom.label,"collapsed"),kI.addClassName(t.dom.label,"expanded")):(kI.removeClassName(t.dom.label,"expanded"),kI.addClassName(t.dom.label,"collapsed"))}}},{key:"toggleGroupDragClassName",value:function(t){t.dom.label.classList.toggle("vis-group-is-dragging"),t.dom.foreground.classList.toggle("vis-group-is-dragging")}},{key:"_onGroupDragStart",value:function(t){this.groupTouchParams.isDragging||this.options.groupEditable.order&&(this.groupTouchParams.group=this.groupFromTarget(t),this.groupTouchParams.group&&(t.stopPropagation(),this.groupTouchParams.isDragging=!0,this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.originalOrder=this.groupsData.getIds({order:this.options.groupOrder})))}},{key:"_onGroupDrag",value:function(t){if(this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this.groupsData.getDataSet(),i=this.groupFromTarget(t);if(i&&i.height!=this.groupTouchParams.group.height){var n=i.top<this.groupTouchParams.group.top,r=t.center?t.center.y:t.clientY,o=i.dom.foreground.getBoundingClientRect(),s=this.groupTouchParams.group.height;if(n){if(o.top+s<r)return}else{var a=i.height;if(o.top+a-s>r)return}}if(i&&i!=this.groupTouchParams.group){var l=e.get(i.groupId),h=e.get(this.groupTouchParams.group.groupId);h&&l&&(this.options.groupOrderSwap(h,l,e),e.update(h),e.update(l));var u=e.getIds({order:this.options.groupOrder});if(!kI.equalArray(u,this.groupTouchParams.originalOrder))for(var d=this.groupTouchParams.originalOrder,c=this.groupTouchParams.group.groupId,p=Math.min(d.length,u.length),f=0,m=0,v=0;f<p;){for(;f+m<p&&f+v<p&&u[f+m]==d[f+v];)f++;if(f+m>=p)break;if(u[f+m]==c)m=1;else if(d[f+v]==c)v=1;else{var g=Jg(u).call(u,d[f+v]),y=e.get(u[f+m]),b=e.get(d[f+v]);this.options.groupOrderSwap(y,b,e),e.update(y),e.update(b);var _=u[f+m];u[f+m]=d[f+v],u[g]=_,f++}}}}}},{key:"_onGroupDragEnd",value:function(t){if(this.groupTouchParams.isDragging=!1,this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this,i=e.groupTouchParams.group.groupId,n=e.groupsData.getDataSet(),r=kI.extend({},n.get(i));e.options.onMoveGroup(r,(function(t){if(t)t[n._idProp]=i,n.update(t);else{var r=n.getIds({order:e.options.groupOrder});if(!kI.equalArray(r,e.groupTouchParams.originalOrder))for(var o=e.groupTouchParams.originalOrder,s=Math.min(o.length,r.length),a=0;a<s;){for(;a<s&&r[a]==o[a];)a++;if(a>=s)break;var l=Jg(r).call(r,o[a]),h=n.get(r[a]),u=n.get(o[a]);e.options.groupOrderSwap(h,u,n),n.update(h),n.update(u);var d=r[a];r[a]=o[a],r[l]=d,a++}}})),e.body.emitter.emit("groupDragged",{groupId:i}),this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.group=null}}},{key:"_onSelectItem",value:function(t){if(this.options.selectable){var e=t.srcEvent&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey),i=t.srcEvent&&t.srcEvent.shiftKey;if(e||i)this._onMultiSelectItem(t);else{var n=this.getSelection(),r=this.itemFromTarget(t),o=r&&r.selectable?[r.id]:[];this.setSelection(o);var s=this.getSelection();(s.length>0||n.length>0)&&this.body.emitter.emit("select",{items:s,event:t})}}}},{key:"_onMouseOver",value:function(t){var e=this.itemFromTarget(t);if(e&&e!==this.itemFromRelatedTarget(t)){var i=e.getTitle();if(this.options.showTooltips&&i){null==this.popup&&(this.popup=new qN(this.body.dom.root,this.options.tooltip.overflowMethod||"flip")),this.popup.setText(i);var n=this.body.dom.centerContainer,r=n.getBoundingClientRect();this.popup.setPosition(t.clientX-r.left+n.offsetLeft,t.clientY-r.top+n.offsetTop),this.setPopupTimer(this.popup)}else this.clearPopupTimer(),null!=this.popup&&this.popup.hide();this.body.emitter.emit("itemover",{item:e.id,event:t})}}},{key:"_onMouseOut",value:function(t){var e=this.itemFromTarget(t);e&&(e!==this.itemFromRelatedTarget(t)&&(this.clearPopupTimer(),null!=this.popup&&this.popup.hide(),this.body.emitter.emit("itemout",{item:e.id,event:t})))}},{key:"_onMouseMove",value:function(t){if(this.itemFromTarget(t)&&(null!=this.popupTimer&&this.setPopupTimer(this.popup),this.options.showTooltips&&this.options.tooltip.followMouse&&this.popup&&!this.popup.hidden)){var e=this.body.dom.centerContainer,i=e.getBoundingClientRect();this.popup.setPosition(t.clientX-i.left+e.offsetLeft,t.clientY-i.top+e.offsetTop),this.popup.show()}}},{key:"_onMouseWheel",value:function(t){this.touchParams.itemIsDragging&&this._onDragEnd(t)}},{key:"_onUpdateItem",value:function(t){if(this.options.selectable&&(this.options.editable.updateTime||this.options.editable.updateGroup)){var e=this;if(t){var i=e.itemsData.get(t.id);this.options.onUpdate(i,(function(t){t&&e.itemsData.update(t)}))}}}},{key:"_onDropObjectOnItem",value:function(t){var e=this.itemFromTarget(t),i=JSON.parse(t.dataTransfer.getData("text"));this.options.onDropObjectOnItem(i,e)}},{key:"_onAddItem",value:function(t){if(this.options.selectable&&this.options.editable.add){var e,i,n=this,r=this.options.snap||null,o=this.dom.frame.getBoundingClientRect(),s=this.options.rtl?o.right-t.center.x:t.center.x-o.left,a=this.body.util.toTime(s),l=this.body.util.getScale(),h=this.body.util.getStep();"drop"==t.type?((i=JSON.parse(t.dataTransfer.getData("text"))).content=i.content?i.content:"new item",i.start=i.start?i.start:r?r(a,l,h):a,i.type=i.type||"box",i[this.itemsData.idProp]=i.id||VP(),"range"!=i.type||i.end||(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,l,h):e)):((i={start:r?r(a,l,h):a,content:"new item"})[this.itemsData.idProp]=VP(),"range"===this.options.type&&(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,l,h):e));var u=this.groupFromTarget(t);u&&(i.group=u.groupId),i=this._cloneItemData(i),this.options.onAdd(i,(function(e){e&&(n.itemsData.add(e),"drop"==t.type&&n.setSelection([e.id]))}))}}},{key:"_onMultiSelectItem",value:function(t){var e=this;if(this.options.selectable){var n=this.itemFromTarget(t);if(n){var r=this.options.multiselect?this.getSelection():[];if((t.srcEvent&&t.srcEvent.shiftKey||!1||this.options.sequentialSelection)&&this.options.multiselect){var o=this.itemsData.get(n.id).group,s=void 0;this.options.multiselectPerGroup&&r.length>0&&(s=this.itemsData.get(r[0]).group),this.options.multiselectPerGroup&&null!=s&&s!=o||r.push(n.id);var a=i._getItemRange(this.itemsData.get(r));if(!this.options.multiselectPerGroup||s==o)for(var l in r=[],this.items)if(this.items.hasOwnProperty(l)){var h=this.items[l],u=h.data.start,d=void 0!==h.data.end?h.data.end:u;!(u>=a.min&&d<=a.max)||this.options.multiselectPerGroup&&s!=this.itemsData.get(h.id).group||h instanceof XN||r.push(h.id)}}else{var c=Jg(r).call(r,n.id);-1==c?r.push(n.id):$m(r).call(r,c,1)}var p=eg(r).call(r,(function(t){return e.getItemById(t).selectable}));this.setSelection(p),this.body.emitter.emit("select",{items:this.getSelection(),event:t})}}}},{key:"itemFromElement",value:function(t){for(var e=t;e;){if(e.hasOwnProperty("vis-item"))return e["vis-item"];e=e.parentNode}return null}},{key:"itemFromTarget",value:function(t){return this.itemFromElement(t.target)}},{key:"itemFromRelatedTarget",value:function(t){return this.itemFromElement(t.relatedTarget)}},{key:"groupFromTarget",value:function(t){var e=t.center?t.center.y:t.clientY,i=this.groupIds;i.length<=0&&this.groupsData&&(i=this.groupsData.getIds({order:this.options.groupOrder}));for(var n=0;n<i.length;n++){var r=i[n],o=this.groups[r],s=o.dom.foreground,a=s.getBoundingClientRect();if(e>=a.top&&e<a.top+s.offsetHeight)return o;if("top"===this.options.orientation.item){if(n===this.groupIds.length-1&&e>a.top)return o}else if(0===n&&e<a.top+s.offset)return o}return null}},{key:"_cloneItemData",value:function(t,e){var i=kI.extend({},t);return e||(e=this.itemsData.type),null!=i.start&&(i.start=kI.convert(i.start,e&&e.start||"Date")),null!=i.end&&(i.end=kI.convert(i.end,e&&e.end||"Date")),i}},{key:"_clusterItems",value:function(){if(this.options.cluster){var t=this.body.range.conversion(this.body.domProps.center.width).scale,e=this.clusterGenerator.getClusters(this.clusters,t,this.options.cluster);if(this.clusters!=e){if(this._detachAllClusters(),e){var i,n=pR(e);try{for(n.s();!(i=n.n()).done;){i.value.attach()}}catch(t){n.e(t)}finally{n.f()}this.clusters=e}this._updateClusters(e)}}}},{key:"_detachAllClusters",value:function(){if(this.options.cluster&&this.clusters&&this.clusters.length){var t,e=pR(this.clusters);try{for(e.s();!(t=e.n()).done;){t.value.detach()}}catch(t){e.e(t)}finally{e.f()}}}},{key:"_updateClusters",value:function(t){if(this.clusters&&this.clusters.length){var e,i,n=new FO(uf(t).call(t,(function(t){return t.id}))),r=eg(e=this.clusters).call(e,(function(t){return!n.has(t.id)})),o=!1,s=pR(r);try{for(s.s();!(i=s.n()).done;){var a,l,h=i.value,u=Jg(a=this.selection).call(a,h.id);if(-1!==u)h.unselect(),$m(l=this.selection).call(l,u,1),o=!0}}catch(t){s.e(t)}finally{s.f()}if(o){var d=this.getSelection();this.body.emitter.emit("select",{items:d,event:event})}}this.clusters=t||[]}}],[{key:"_getItemRange",value:function(t){var e=null,i=null;return sm(t).call(t,(function(t){(null==i||t.start<i)&&(i=t.start),null!=t.end?(null==e||t.end>e)&&(e=t.end):(null==e||t.start>e)&&(e=t.start)})),{min:i,max:e}}},{key:"itemSetFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("vis-itemset"))return e["vis-itemset"];e=e.parentNode}return null}}]),i}();yR.types={background:XN,box:zN,range:VN,point:GN},yR.prototype._onAdd=yR.prototype._onUpdate;var bR,_R=!1,wR="background: #FFeeee; color: #dd0000",kR=function(){function t(){Dd(this,t)}return Gc(t,null,[{key:"validate",value:function(e,i,n){_R=!1,bR=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),_R}},{key:"parse",value:function(e,i,n){for(var r in e)e.hasOwnProperty(r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),wR)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Jg(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),_R=!0):"object"===l&&"__any__"!==r&&(s=kI.copyAndExtendArray(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(vf(o))+". Received ["+l+'] "'+i[e]+'"'),_R=!0)}},{key:"getType",value:function(t){var e=Lc(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Qp(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,bR,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(vf(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+r,wR),_R=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var d=void 0;if(void 0!==i[u].__type__&&!0===r){var c=t.findInOptions(e,i[u],kI.copyAndExtendArray(n,u));o>c.distance&&(s=c.closestMatch,a=c.path,o=c.distance,h=c.indexMatch)}else{var p;-1!==Jg(p=u.toLowerCase()).call(p,l)&&(h=u),o>(d=t.levenshteinDistance(e,u))&&(s=u,a=kI.copyArray(n),o=d)}}return{closestMatch:s,path:a,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var r=0;r<n+1;r++)i+="  ";i+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return ky(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),xR="string",DR="boolean",SR="number",CR="array",TR="date",MR="object",OR="moment",ER={configure:{enabled:{boolean:DR},filter:{boolean:DR,function:"function"},container:{dom:"dom"},__type__:{object:MR,boolean:DR,function:"function"}},align:{string:xR},alignCurrentTime:{string:xR,undefined:"undefined"},rtl:{boolean:DR,undefined:"undefined"},rollingMode:{follow:{boolean:DR},offset:{number:SR,undefined:"undefined"},__type__:{object:MR}},onTimeout:{timeoutMs:{number:SR},callback:{function:"function"},__type__:{object:MR}},verticalScroll:{boolean:DR,undefined:"undefined"},horizontalScroll:{boolean:DR,undefined:"undefined"},autoResize:{boolean:DR},throttleRedraw:{number:SR},clickToUse:{boolean:DR},dataAttributes:{string:xR,array:CR},editable:{add:{boolean:DR,undefined:"undefined"},remove:{boolean:DR,undefined:"undefined"},updateGroup:{boolean:DR,undefined:"undefined"},updateTime:{boolean:DR,undefined:"undefined"},overrideItems:{boolean:DR,undefined:"undefined"},__type__:{boolean:DR,object:MR}},end:{number:SR,date:TR,string:xR,moment:OR},format:{minorLabels:{millisecond:{string:xR,undefined:"undefined"},second:{string:xR,undefined:"undefined"},minute:{string:xR,undefined:"undefined"},hour:{string:xR,undefined:"undefined"},weekday:{string:xR,undefined:"undefined"},day:{string:xR,undefined:"undefined"},week:{string:xR,undefined:"undefined"},month:{string:xR,undefined:"undefined"},year:{string:xR,undefined:"undefined"},__type__:{object:MR,function:"function"}},majorLabels:{millisecond:{string:xR,undefined:"undefined"},second:{string:xR,undefined:"undefined"},minute:{string:xR,undefined:"undefined"},hour:{string:xR,undefined:"undefined"},weekday:{string:xR,undefined:"undefined"},day:{string:xR,undefined:"undefined"},week:{string:xR,undefined:"undefined"},month:{string:xR,undefined:"undefined"},year:{string:xR,undefined:"undefined"},__type__:{object:MR,function:"function"}},__type__:{object:MR}},moment:{function:"function"},groupHeightMode:{string:xR},groupOrder:{string:xR,function:"function"},groupEditable:{add:{boolean:DR,undefined:"undefined"},remove:{boolean:DR,undefined:"undefined"},order:{boolean:DR,undefined:"undefined"},__type__:{boolean:DR,object:MR}},groupOrderSwap:{function:"function"},height:{string:xR,number:SR},hiddenDates:{start:{date:TR,number:SR,string:xR,moment:OR},end:{date:TR,number:SR,string:xR,moment:OR},repeat:{string:xR},__type__:{object:MR,array:CR}},itemsAlwaysDraggable:{item:{boolean:DR,undefined:"undefined"},range:{boolean:DR,undefined:"undefined"},__type__:{boolean:DR,object:MR}},limitSize:{boolean:DR},locale:{string:xR},locales:{__any__:{any:"any"},__type__:{object:MR}},longSelectPressTime:{number:SR},margin:{axis:{number:SR},item:{horizontal:{number:SR,undefined:"undefined"},vertical:{number:SR,undefined:"undefined"},__type__:{object:MR,number:SR}},__type__:{object:MR,number:SR}},max:{date:TR,number:SR,string:xR,moment:OR},maxHeight:{number:SR,string:xR},maxMinorChars:{number:SR},min:{date:TR,number:SR,string:xR,moment:OR},minHeight:{number:SR,string:xR},moveable:{boolean:DR},multiselect:{boolean:DR},multiselectPerGroup:{boolean:DR},onAdd:{function:"function"},onDropObjectOnItem:{function:"function"},onUpdate:{function:"function"},onMove:{function:"function"},onMoving:{function:"function"},onRemove:{function:"function"},onAddGroup:{function:"function"},onMoveGroup:{function:"function"},onRemoveGroup:{function:"function"},onInitialDrawComplete:{function:"function"},order:{function:"function"},orientation:{axis:{string:xR,undefined:"undefined"},item:{string:xR,undefined:"undefined"},__type__:{string:xR,object:MR}},selectable:{boolean:DR},sequentialSelection:{boolean:DR},showCurrentTime:{boolean:DR},showMajorLabels:{boolean:DR},showMinorLabels:{boolean:DR},showWeekScale:{boolean:DR},stack:{boolean:DR},stackSubgroups:{boolean:DR},cluster:{maxItems:{number:SR,undefined:"undefined"},titleTemplate:{string:xR,undefined:"undefined"},clusterCriteria:{function:"function",undefined:"undefined"},showStipes:{boolean:DR,undefined:"undefined"},fitOnDoubleClick:{boolean:DR,undefined:"undefined"},__type__:{boolean:DR,object:MR}},snap:{function:"function",null:"null"},start:{date:TR,number:SR,string:xR,moment:OR},template:{function:"function"},loadingScreenTemplate:{function:"function"},groupTemplate:{function:"function"},visibleFrameTemplate:{string:xR,function:"function"},showTooltips:{boolean:DR},tooltip:{followMouse:{boolean:DR},overflowMethod:{string:["cap","flip","none"]},delay:{number:SR},template:{function:"function"},__type__:{object:MR}},tooltipOnItemUpdateTime:{template:{function:"function"},__type__:{boolean:DR,object:MR}},timeAxis:{scale:{string:xR,undefined:"undefined"},step:{number:SR,undefined:"undefined"},__type__:{object:MR}},type:{string:xR},width:{string:xR,number:SR},preferZoom:{boolean:DR},zoomable:{boolean:DR},zoomKey:{string:["ctrlKey","altKey","shiftKey","metaKey",""]},zoomFriction:{number:SR},zoomMax:{number:SR},zoomMin:{number:SR},xss:{disabled:{boolean:DR},filterOptions:{__any__:{any:"any"},__type__:{object:MR}},__type__:{object:MR}},__type__:{object:MR}},PR={global:{align:["center","left","right"],alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],direction:!1,autoResize:!0,clickToUse:!1,editable:{add:!1,remove:!1,updateGroup:!1,updateTime:!1},end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}},groupHeightMode:["auto","fixed","fitItems"],groupsDraggable:!1,height:"",locale:"",longSelectPressTime:251,margin:{axis:[20,0,100,1],item:{horizontal:[10,0,100,1],vertical:[10,0,100,1]}},max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!1,multiselect:!1,multiselectPerGroup:!1,orientation:{axis:["both","bottom","top"],item:["bottom","top"]},preferZoom:!1,selectable:!0,showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,stack:!0,stackSubgroups:!0,cluster:!1,start:"",showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:[500,0,99999,100]},tooltipOnItemUpdateTime:!1,type:["box","point","range","background"],width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","shiftKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],xss:{disabled:!1}}},AR={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},IR=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Dd(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Gc(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return AR[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===kI.isString(t)){if(!0===kI.isValidRGB(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===kI.isValidRGBA(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===kI.isValidHex(t)){var s=kI.hexToRGB(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+ky(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=kI.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Vy((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=kI.extend({},t)),this.color=t;var e=kI.RGBToHSV(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,r=this.centerCoordinates.x+n*Math.sin(i*e.h),o=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=kI.RGBToHSV(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=kI.HSVToRGB(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=kI.RGBToHSV(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),nb(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var r=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=Vf(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=Vf(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=Vf(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=Vf(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new bL(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),_L(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(l*n),i=this.centerCoordinates.y+r*Math.cos(l*n),a=kI.HSVToRGB(.002777777777777778*n,r*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(l)*h+r,d=Math.sin(l)*h+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=d-.5*this.colorPickerSelector.clientWidth+"px";var c=l/(2*Math.PI);c=c<0?c+1:c;var p=h/this.r,f=kI.RGBToHSV(this.color.r,this.color.g,this.color.b);f.h=c,f.s=p;var m=kI.HSVToRGB(f.h,f.s,f.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();kL('div.vis-configuration{display:block;float:left;font-size:12px;position:relative}div.vis-configuration-wrapper{display:block;width:700px}div.vis-configuration-wrapper:after{clear:both;content:"";display:block}div.vis-configuration.vis-config-option-container{background-color:#fff;border:2px solid #f7f8fa;border-radius:4px;display:block;left:10px;margin-top:20px;padding-left:5px;width:495px}div.vis-configuration.vis-config-button{background-color:#f7f8fa;border:2px solid #ceced0;border-radius:4px;cursor:pointer;display:block;height:25px;left:10px;line-height:25px;margin-bottom:30px;margin-top:20px;padding-left:5px;vertical-align:middle;width:495px}div.vis-configuration.vis-config-button.hover{background-color:#4588e6;border:2px solid #214373;color:#fff}div.vis-configuration.vis-config-item{display:block;float:left;height:25px;line-height:25px;vertical-align:middle;width:495px}div.vis-configuration.vis-config-item.vis-config-s2{background-color:#f7f8fa;border-radius:3px;left:10px;padding-left:5px}div.vis-configuration.vis-config-item.vis-config-s3{background-color:#e4e9f0;border-radius:3px;left:20px;padding-left:5px}div.vis-configuration.vis-config-item.vis-config-s4{background-color:#cfd8e6;border-radius:3px;left:30px;padding-left:5px}div.vis-configuration.vis-config-header{font-size:18px;font-weight:700}div.vis-configuration.vis-config-label{height:25px;line-height:25px;width:120px}div.vis-configuration.vis-config-label.vis-config-s3{width:110px}div.vis-configuration.vis-config-label.vis-config-s4{width:100px}div.vis-configuration.vis-config-colorBlock{border:1px solid #444;border-radius:2px;cursor:pointer;height:19px;margin:0;padding:0;top:1px;width:30px}input.vis-configuration.vis-config-checkbox{left:-5px}input.vis-configuration.vis-config-rangeinput{margin:0;padding:1px;pointer-events:none;position:relative;top:-5px;width:60px}input.vis-configuration.vis-config-range{-webkit-appearance:none;background-color:transparent;border:0 solid #fff;height:20px;width:300px}input.vis-configuration.vis-config-range::-webkit-slider-runnable-track{background:#dedede;background:-moz-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#dedede),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#dedede,#c8c8c8 99%);background:-o-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:linear-gradient(180deg,#dedede 0,#c8c8c8 99%);border:1px solid #999;border-radius:3px;box-shadow:0 0 3px 0 #aaa;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#dedede",endColorstr="#c8c8c8",GradientType=0);height:5px;width:300px}input.vis-configuration.vis-config-range::-webkit-slider-thumb{-webkit-appearance:none;background:#3876c2;background:-moz-linear-gradient(top,#3876c2 0,#385380 100%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#3876c2),color-stop(100%,#385380));background:-webkit-linear-gradient(top,#3876c2,#385380);background:-o-linear-gradient(top,#3876c2 0,#385380 100%);background:-ms-linear-gradient(top,#3876c2 0,#385380 100%);background:linear-gradient(180deg,#3876c2 0,#385380);border:1px solid #14334b;border-radius:50%;box-shadow:0 0 1px 0 #111927;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#3876c2",endColorstr="#385380",GradientType=0);height:17px;margin-top:-7px;width:17px}input.vis-configuration.vis-config-range:focus{outline:none}input.vis-configuration.vis-config-range:focus::-webkit-slider-runnable-track{background:#9d9d9d;background:-moz-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#9d9d9d),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#9d9d9d,#c8c8c8 99%);background:-o-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:linear-gradient(180deg,#9d9d9d 0,#c8c8c8 99%);filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#9d9d9d",endColorstr="#c8c8c8",GradientType=0)}input.vis-configuration.vis-config-range::-moz-range-track{background:#dedede;background:-moz-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#dedede),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#dedede,#c8c8c8 99%);background:-o-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:linear-gradient(180deg,#dedede 0,#c8c8c8 99%);border:1px solid #999;border-radius:3px;box-shadow:0 0 3px 0 #aaa;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#dedede",endColorstr="#c8c8c8",GradientType=0);height:10px;width:300px}input.vis-configuration.vis-config-range::-moz-range-thumb{background:#385380;border:none;border-radius:50%;height:16px;width:16px}input.vis-configuration.vis-config-range:-moz-focusring{outline:1px solid #fff;outline-offset:-1px}input.vis-configuration.vis-config-range::-ms-track{background:transparent;border-color:transparent;border-width:6px 0;color:transparent;height:5px;width:300px}input.vis-configuration.vis-config-range::-ms-fill-lower{background:#777;border-radius:10px}input.vis-configuration.vis-config-range::-ms-fill-upper{background:#ddd;border-radius:10px}input.vis-configuration.vis-config-range::-ms-thumb{background:#385380;border:none;border-radius:50%;height:16px;width:16px}input.vis-configuration.vis-config-range:focus::-ms-fill-lower{background:#888}input.vis-configuration.vis-config-range:focus::-ms-fill-upper{background:#ccc}.vis-configuration-popup{background:rgba(57,76,89,.85);border:2px solid #f2faff;border-radius:4px;color:#fff;font-size:14px;height:30px;line-height:30px;position:absolute;text-align:center;-webkit-transition:opacity .3s ease-in-out;-moz-transition:opacity .3s ease-in-out;transition:opacity .3s ease-in-out;width:150px}.vis-configuration-popup:after,.vis-configuration-popup:before{border:solid transparent;content:" ";height:0;left:100%;pointer-events:none;position:absolute;top:50%;width:0}.vis-configuration-popup:after{border-color:rgba(136,183,213,0) rgba(136,183,213,0) rgba(136,183,213,0) rgba(57,76,89,.85);border-width:8px;margin-top:-8px}.vis-configuration-popup:before{border-color:rgba(194,225,245,0) rgba(194,225,245,0) rgba(194,225,245,0) #f2faff;border-width:12px;margin-top:-12px}');var LR=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Dd(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},kI.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new IR(r),this.wrapper=void 0}return Gc(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(Qp(t))this.options.filter=t.join();else if("object"===Lc(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==eg(t)&&(this.options.filter=eg(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===eg(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=eg(this.options),e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===Jg(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return sm(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=kI.xss(t),this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?kI.xss("<i><b>"+t+":</b></i>"):kI.xss(t+":"),n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==Jg(t).call(t,e)&&(r=Jg(t).call(t,e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerHTML=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<r?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<r&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>o&&1!==o&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var d=document.createElement("input");d.className="vis-configuration vis-config-rangeinput",d.value=Number(a.value);var c=this;a.onchange=function(){d.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){d.value=this.value};var p=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,p,a,d);""!==l&&this.popupHistory[f]!==h&&(this.popupHistory[f]=h,this._setupPopup(l,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=kI.xss(t),n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Vy((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Vy((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Lc(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=eg(this.options),o=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],l=kI.copyAndExtendArray(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!Qp(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){o=!0;var h=this._getValue(l);if(Qp(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){var u=!0;if(-1!==Jg(e).call(e,"physics")&&this.moduleOptions.physics.solver!==s&&(u=!1),!0===u)if(void 0!==a.enabled){var d=kI.copyAndExtendArray(l,"enabled"),c=this._getValue(d);if(!0===c){var p=this._makeLabel(s,l,!0);this._makeItem(l,p),o=this._handleObject(a,l)||o}else this._makeCheckbox(a,c,l)}else{var f=this._makeLabel(s,l,!0);this._makeItem(l,f),o=this._handleObject(a,l)||o}}else console.error("dont know how to handle",a,s,l)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+ky(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}();function NR(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}var RR=function(t){Vk(i,VL);var e=NR(i);function i(t,n,r,o){var s,a,l,h,u,d,c,p;if(Dd(this,i),(p=e.call(this)).initTime=new Date,p.itemsDone=!1,!(Tk(p)instanceof i))throw new SyntaxError("Constructor must be called with the new operator");if(!Qp(r)&&!fI(r)&&r instanceof Object){var f=o;o=r,r=f}o&&o.throttleRedraw&&console.warn('Timeline option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var m=Tk(p);if(p.defaultOptions={autoResize:!0,longSelectPressTime:251,orientation:{axis:"bottom",item:"bottom"},moment:sA},p.options=kI.deepExtend({},p.defaultOptions),o&&kI.setupXSSProtection(o.xss),p._create(t),!o||o&&void 0===o.rtl){var v;p.dom.root.style.visibility="hidden";for(var g=p.dom.root;!v&&g;)v=window.getComputedStyle(g,null).direction,g=g.parentElement;p.options.rtl=v&&"rtl"==v.toLowerCase()}else p.options.rtl=o.rtl;o&&(o.rollingMode&&(p.options.rollingMode=o.rollingMode),o.onInitialDrawComplete&&(p.options.onInitialDrawComplete=o.onInitialDrawComplete),o.onTimeout&&(p.options.onTimeout=o.onTimeout),o.loadingScreenTemplate&&(p.options.loadingScreenTemplate=o.loadingScreenTemplate));var y=document.createElement("div");if(p.options.loadingScreenTemplate){var b,_=Vf(b=p.options.loadingScreenTemplate).call(b,Tk(p)),w=_(p.dom.loadingScreen);w instanceof Object&&!(w instanceof Element)?_(y):w instanceof Element?(y.innerHTML="",y.appendChild(w)):null!=w&&(y.innerHTML=kI.xss(w))}function k(t,e){m.hasListeners(t)&&m.emit(t,m.getEventProperties(e))}return p.dom.loadingScreen.appendChild(y),p.components=[],p.body={dom:p.dom,domProps:p.props,emitter:{on:Vf(s=p.on).call(s,Tk(p)),off:Vf(a=p.off).call(a,Tk(p)),emit:Vf(l=p.emit).call(l,Tk(p))},hiddenDates:[],util:{getScale:function(){return m.timeAxis.step.scale},getStep:function(){return m.timeAxis.step.step},toScreen:Vf(h=m._toScreen).call(h,m),toGlobalScreen:Vf(u=m._toGlobalScreen).call(u,m),toTime:Vf(d=m._toTime).call(d,m),toGlobalTime:Vf(c=m._toGlobalTime).call(c,m)}},p.range=new cL(p.body,p.options),p.components.push(p.range),p.body.range=p.range,p.timeAxis=new DL(p.body,p.options),p.timeAxis2=null,p.components.push(p.timeAxis),p.currentTime=new XL(p.body,p.options),p.components.push(p.currentTime),p.itemSet=new yR(p.body,p.options),p.components.push(p.itemSet),p.itemsData=null,p.groupsData=null,p.dom.root.onclick=function(t){k("click",t)},p.dom.root.ondblclick=function(t){k("doubleClick",t)},p.dom.root.oncontextmenu=function(t){k("contextmenu",t)},p.dom.root.onmouseover=function(t){k("mouseOver",t)},window.PointerEvent?(p.dom.root.onpointerdown=function(t){k("mouseDown",t)},p.dom.root.onpointermove=function(t){k("mouseMove",t)},p.dom.root.onpointerup=function(t){k("mouseUp",t)}):(p.dom.root.onmousemove=function(t){k("mouseMove",t)},p.dom.root.onmousedown=function(t){k("mouseDown",t)},p.dom.root.onmouseup=function(t){k("mouseUp",t)}),p.initialFitDone=!1,p.on("changed",(function(){if(null!=m.itemsData){if(!m.initialFitDone&&!m.options.rollingMode)if(m.initialFitDone=!0,null!=m.options.start||null!=m.options.end){if(null==m.options.start||null==m.options.end)var t=m.getItemRange();var e=null!=m.options.start?m.options.start:t.min,i=null!=m.options.end?m.options.end:t.max;m.setWindow(e,i,{animation:!1})}else m.fit({animation:!1});m.initialDrawDone||!m.initialRangeChangeDone&&(m.options.start||m.options.end)&&!m.options.rollingMode||(m.initialDrawDone=!0,m.itemSet.initialDrawDone=!0,m.dom.root.style.visibility="visible",m.dom.loadingScreen.parentNode.removeChild(m.dom.loadingScreen),m.options.onInitialDrawComplete&&Vy((function(){return m.options.onInitialDrawComplete()}),0))}})),p.on("destroyTimeline",(function(){m.destroy()})),o&&p.setOptions(o),p.body.emitter.on("fit",(function(t){p._onFit(t),p.redraw()})),r&&p.setGroups(r),n&&p.setItems(n),p._redraw(),p}return Gc(i,[{key:"_createConfigurator",value:function(){return new LR(this,this.dom.container,PR)}},{key:"redraw",value:function(){this.itemSet&&this.itemSet.markDirty({refreshItems:!0}),this._redraw()}},{key:"setOptions",value:function(t){if(!0===kR.validate(t,ER)&&console.log("%cErrors have been found in the supplied options object.",wR),VL.prototype.setOptions.call(this,t),"type"in t&&t.type!==this.options.type){this.options.type=t.type;var e=this.itemsData;if(e){var i=this.getSelection();this.setItems(null),this.setItems(e.rawDS),this.setSelection(i)}}}},{key:"setItems",value:function(t){var e;this.itemsDone=!1,e=t?fI(t)?yI(t):yI(new nA(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.itemSet&&this.itemSet.setItems(null!=e?e.rawDS:null)}},{key:"setGroups",value:function(t){var e;t?(Qp(t)&&(t=new nA(t)),e=new rA(t,{filter:function(t){return!1!==t.visible}})):e=null,null!=this.groupsData&&"function"==typeof this.groupsData.setData&&this.groupsData.setData(null),this.groupsData=e,this.itemSet.setGroups(e)}},{key:"setData",value:function(t){t&&t.groups&&this.setGroups(t.groups),t&&t.items&&this.setItems(t.items)}},{key:"setSelection",value:function(t,e){this.itemSet&&this.itemSet.setSelection(t),e&&e.focus&&this.focus(t,e)}},{key:"getSelection",value:function(){return this.itemSet&&this.itemSet.getSelection()||[]}},{key:"focus",value:function(t,e){if(this.itemsData&&null!=t){var i=Qp(t)?t:[t],n=this.itemsData.get(i),r=null,o=null;if(sm(n).call(n,(function(t){var e=t.start.valueOf(),i="end"in t?t.end.valueOf():t.start.valueOf();(null===r||e<r)&&(r=e),(null===o||i>o)&&(o=i)})),null!==r&&null!==o){var s=this,a=this.itemSet.items[i[0]],l=-1*this._getScrollTop(),h=null,u=function(){var t=YR(s,a);t.shouldScroll&&t.itemTop!=h.itemTop&&(s._setScrollTop(-t.scrollOffset),s._redraw())},d=!e||void 0===e.zoom||e.zoom,c=(r+o)/2,p=d?1.1*(o-r):Math.max(this.range.end-this.range.start,1.1*(o-r)),f=!e||void 0===e.animation||e.animation;f||(h={shouldScroll:!1,scrollOffset:-1,itemTop:-1}),this.range.setRange(c-p/2,c+p/2,{animation:f},(function(){u(),Vy(u,100)}),(function(t,e,i){var n=YR(s,a);if(!1!==n&&(h||(h=n),h.itemTop!=n.itemTop||h.shouldScroll)){h.itemTop!=n.itemTop&&n.shouldScroll&&(h=n,l=-1*s._getScrollTop());var r=l,o=h.scrollOffset,u=i?o:r+(o-r)*t;s._setScrollTop(-u),e||s._redraw()}}))}}}},{key:"fit",value:function(t,e){var i,n=!t||void 0===t.animation||t.animation;1===this.itemsData.length&&void 0===this.itemsData.get()[0].end?(i=this.getDataRange(),this.moveTo(i.min.valueOf(),{animation:n},e)):(i=this.getItemRange(),this.range.setRange(i.min,i.max,{animation:n},e))}},{key:"getItemRange",value:function(){var t=this,e=this.getDataRange(),i=null!==e.min?e.min.valueOf():null,n=null!==e.max?e.max.valueOf():null,r=null,o=null;if(null!=i&&null!=n){var s=n-i;s<=0&&(s=10);var a=s/this.props.center.width,l={},h=0;if(sm(kI).call(kI,this.itemSet.items,(function(t,e){if(t.groupShowing){l[e]=t.redraw(!0),h=l[e].length}})),h>0)for(var u=function(t){sm(kI).call(kI,l,(function(e){e[t]()}))},d=0;d<h;d++)u(d);if(sm(kI).call(kI,this.itemSet.items,(function(e){var s,l,h=FR(e),u=jR(e);t.options.rtl?(s=h-(e.getWidthRight()+10)*a,l=u+(e.getWidthLeft()+10)*a):(s=h-(e.getWidthLeft()+10)*a,l=u+(e.getWidthRight()+10)*a),s<i&&(i=s,r=e),l>n&&(n=l,o=e)})),r&&o){var c=r.getWidthLeft()+10,p=o.getWidthRight()+10,f=this.props.center.width-c-p;f>0&&(this.options.rtl?(i=FR(r)-p*s/f,n=jR(o)+c*s/f):(i=FR(r)-c*s/f,n=jR(o)+p*s/f))}}return{min:null!=i?new Date(i):null,max:null!=n?new Date(n):null}}},{key:"getDataRange",value:function(){var t,e=null,i=null;this.itemsData&&sm(t=this.itemsData).call(t,(function(t){var n=kI.convert(t.start,"Date").valueOf(),r=kI.convert(null!=t.end?t.end:t.start,"Date").valueOf();(null===e||n<e)&&(e=n),(null===i||r>i)&&(i=r)}));return{min:null!=e?new Date(e):null,max:null!=i?new Date(i):null}}},{key:"getEventProperties",value:function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=this.dom.centerContainer.getBoundingClientRect(),r=this.options.rtl?n.right-e:e-n.left,o=i-n.top,s=this.itemSet.itemFromTarget(t),a=this.itemSet.groupFromTarget(t),l=WL.customTimeFromTarget(t),h=this.itemSet.options.snap||null,u=this.body.util.getScale(),d=this.body.util.getStep(),c=this._toTime(r),p=h?h(c,u,d):c,f=kI.getTarget(t),m=null;return null!=s?m="item":null!=l?m="custom-time":kI.hasParent(f,this.timeAxis.dom.foreground)||this.timeAxis2&&kI.hasParent(f,this.timeAxis2.dom.foreground)?m="axis":kI.hasParent(f,this.itemSet.dom.labelSet)?m="group-label":kI.hasParent(f,this.currentTime.bar)?m="current-time":kI.hasParent(f,this.dom.center)&&(m="background"),{event:t,item:s?s.id:null,isCluster:!!s&&!!s.isCluster,items:s?s.items||[]:null,group:a?a.groupId:null,customTime:l?l.options.id:null,what:m,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:r,y:o,time:c,snappedTime:p}}},{key:"toggleRollingMode",value:function(){this.range.rolling?this.range.stopRolling():(null==this.options.rollingMode&&this.setOptions(this.options),this.range.startRolling())}},{key:"_redraw",value:function(){VL.prototype._redraw.call(this)}},{key:"_onFit",value:function(t){var e=t.start,i=t.end,n=t.animation;i?this.range.setRange(e,i,{animation:n}):this.moveTo(e.valueOf(),{animation:n})}}]),i}();function FR(t){return kI.convert(t.data.start,"Date").valueOf()}function jR(t){var e=null!=t.data.end?t.data.end:t.data.start;return kI.convert(e,"Date").valueOf()}function YR(t,e){if(!e.parent)return!1;var i=t.options.rtl?t.props.rightContainer.height:t.props.leftContainer.height,n=t.props.center.height,r=e.parent,o=r.top,s=!0,a=t.timeAxis.options.orientation.axis,l=function(){return"bottom"==a?r.height-e.top-e.height:e.top},h=-1*t._getScrollTop(),u=o+l(),d=e.height;return u<h?o+i<=o+l()+d&&(o+=l()-t.itemSet.options.margin.item.vertical):u+d>h+i?o+=l()+d-i+t.itemSet.options.margin.item.vertical:s=!1,{shouldScroll:s,scrollOffset:o=Math.min(o,n-i),itemTop:u}}var HR=function(){function t(e,i,n,r,o,s){var a=arguments.length>6&&void 0!==arguments[6]&&arguments[6],l=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(Dd(this,t),this.majorSteps=[1,2,5,10],this.minorSteps=[.25,.5,1,2],this.customLines=null,this.containerHeight=o,this.majorCharHeight=s,this._start=e,this._end=i,this.scale=1,this.minorStepIdx=-1,this.magnitudefactor=1,this.determineScale(),this.zeroAlign=a,this.autoScaleStart=n,this.autoScaleEnd=r,this.formattingFunction=l,n||r){var h=this,u=function(t){var e=t-t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx]);return t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx])>h.magnitudefactor*h.minorSteps[h.minorStepIdx]*.5?e+h.magnitudefactor*h.minorSteps[h.minorStepIdx]:e};n&&(this._start-=2*this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._start=u(this._start)),r&&(this._end+=this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._end=u(this._end)),this.determineScale()}}return Gc(t,[{key:"setCharHeight",value:function(t){this.majorCharHeight=t}},{key:"setHeight",value:function(t){this.containerHeight=t}},{key:"determineScale",value:function(){var t=this._end-this._start;this.scale=this.containerHeight/t;var e=this.majorCharHeight/this.scale,i=t>0?Math.round(Math.log(t)/Math.LN10):0;this.minorStepIdx=-1,this.magnitudefactor=Math.pow(10,i);var n=0;i<0&&(n=i);for(var r=!1,o=n;Math.abs(o)<=Math.abs(i);o++){this.magnitudefactor=Math.pow(10,o);for(var s=0;s<this.minorSteps.length;s++){if(this.magnitudefactor*this.minorSteps[s]>=e){r=!0,this.minorStepIdx=s;break}}if(!0===r)break}}},{key:"is_major",value:function(t){return t%(this.magnitudefactor*this.majorSteps[this.minorStepIdx])==0}},{key:"getStep",value:function(){return this.magnitudefactor*this.minorSteps[this.minorStepIdx]}},{key:"getFirstMajor",value:function(){var t=this.magnitudefactor*this.majorSteps[this.minorStepIdx];return this.convertValue(this._start+(t-this._start%t)%t)}},{key:"formatValue",value:function(t){var e=t.toPrecision(5);return"function"==typeof this.formattingFunction&&(e=this.formattingFunction(t)),"number"==typeof e?"".concat(e):"string"==typeof e?e:t.toPrecision(5)}},{key:"getLines",value:function(){for(var t=[],e=this.getStep(),i=(e-this._start%e)%e,n=this._start+i;this._end-n>1e-5;n+=e)n!=this._start&&t.push({major:this.is_major(n),y:this.convertValue(n),val:this.formatValue(n)});return t}},{key:"followScale",value:function(t){var e=this.minorStepIdx,i=this._start,n=this._end,r=this,o=function(){r.magnitudefactor*=2},s=function(){r.magnitudefactor/=2};t.minorStepIdx<=1&&this.minorStepIdx<=1||t.minorStepIdx>1&&this.minorStepIdx>1||(t.minorStepIdx<this.minorStepIdx?(this.minorStepIdx=1,2==e||o(),o()):(this.minorStepIdx=2,1==e||s(),s()));for(var a=t.convertValue(0),l=t.getStep()*t.scale,h=!1,u=0;!h&&u++<5;){this.scale=l/(this.minorSteps[this.minorStepIdx]*this.magnitudefactor);var d=this.containerHeight/this.scale;this._start=i,this._end=this._start+d;var c=this._end*this.scale,p=this.magnitudefactor*this.majorSteps[this.minorStepIdx],f=this.getFirstMajor()-t.getFirstMajor();if(this.zeroAlign){var m=a-c;this._end+=m/this.scale,this._start=this._end-d}else this.autoScaleStart?(this._start-=f/this.scale,this._end=this._start+d):(this._start+=p-f/this.scale,this._end=this._start+d);if(!this.autoScaleEnd&&this._end>n+1e-5)s(),h=!1;else{if(!this.autoScaleStart&&this._start<i-1e-5){if(!(this.zeroAlign&&i>=0)){s(),h=!1;continue}console.warn("Can't adhere to given 'min' range, due to zeroalign")}this.autoScaleStart&&this.autoScaleEnd&&d<n-i?(o(),h=!1):h=!0}}}},{key:"convertValue",value:function(t){return this.containerHeight-(t-this._start)*this.scale}},{key:"screenToValue",value:function(t){return(this.containerHeight-t)/this.scale+this._start}}]),t}();function zR(t,e){var i=void 0!==Rp&&Oa(t)||t["@@iterator"];if(!i){if(Qp(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return BR(t,e);var n=Xp(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return BR(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function BR(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function GR(t){var e=function(){if("undefined"==typeof Reflect||!jP)return!1;if(jP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(jP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Jk(t);if(e){var r=Jk(this).constructor;i=jP(n,arguments,r)}else i=n.apply(this,arguments);return Uk(this,i)}}kL(".vis-panel.vis-background.vis-horizontal .vis-grid.vis-horizontal{border-bottom:1px solid;height:0;position:absolute;width:100%}.vis-panel.vis-background.vis-horizontal .vis-grid.vis-minor{border-color:#e5e5e5}.vis-panel.vis-background.vis-horizontal .vis-grid.vis-major{border-color:#bfbfbf}.vis-data-axis .vis-y-axis.vis-major{color:#4d4d4d;position:absolute;white-space:nowrap;width:100%}.vis-data-axis .vis-y-axis.vis-major.vis-measure{border:0;margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-minor{color:#bebebe;position:absolute;white-space:nowrap;width:100%}.vis-data-axis .vis-y-axis.vis-minor.vis-measure{border:0;margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-title{bottom:20px;color:#4d4d4d;position:absolute;text-align:center;white-space:nowrap}.vis-data-axis .vis-y-axis.vis-title.vis-measure{margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-title.vis-left{bottom:0;-webkit-transform:rotate(-90deg);-moz-transform:rotate(-90deg);-ms-transform:rotate(-90deg);-o-transform:rotate(-90deg);transform:rotate(-90deg);-webkit-transform-origin:left top;-moz-transform-origin:left top;-ms-transform-origin:left top;-o-transform-origin:left top;transform-origin:left bottom}.vis-data-axis .vis-y-axis.vis-title.vis-right{bottom:0;-webkit-transform:rotate(90deg);-moz-transform:rotate(90deg);-ms-transform:rotate(90deg);-o-transform:rotate(90deg);transform:rotate(90deg);-webkit-transform-origin:right bottom;-moz-transform-origin:right bottom;-ms-transform-origin:right bottom;-o-transform-origin:right bottom;transform-origin:right bottom}.vis-legend{background-color:rgba(247,252,255,.65);border:1px solid #b3b3b3;box-shadow:2px 2px 10px hsla(0,0%,60%,.55);padding:5px}.vis-legend-text{display:inline-block;white-space:nowrap}");var WR=function(t){Vk(i,FI);var e=GR(i);function i(t,n,r,o){var s;Dd(this,i),(s=e.call(this)).id=VP(),s.body=t,s.defaultOptions={orientation:"left",showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,majorLinesOffset:7,minorLinesOffset:4,labelOffsetX:10,labelOffsetY:2,iconWidth:20,width:"40px",visible:!0,alignZeros:!0,left:{range:{min:void 0,max:void 0},format:function(t){return"".concat(RI(t.toPrecision(3)))},title:{text:void 0,style:void 0}},right:{range:{min:void 0,max:void 0},format:function(t){return"".concat(RI(t.toPrecision(3)))},title:{text:void 0,style:void 0}}},s.linegraphOptions=o,s.linegraphSVG=r,s.props={},s.DOMelements={lines:{},labels:{},title:{}},s.dom={},s.scale=void 0,s.range={start:0,end:0},s.options=kI.extend({},s.defaultOptions),s.conversionFactor=1,s.setOptions(n),s.width=Number("".concat(s.options.width).replace("px","")),s.minWidth=s.width,s.height=s.linegraphSVG.getBoundingClientRect().height,s.hidden=!1,s.stepPixels=25,s.zeroCrossing=-1,s.amountOfSteps=-1,s.lineOffset=0,s.master=!0,s.masterAxis=null,s.svgElements={},s.iconsRemoved=!1,s.groups={},s.amountOfGroups=0,s._create(),null==s.scale&&s._redrawLabels(),s.framework={svg:s.svg,svgElements:s.svgElements,options:s.options,groups:s.groups};var a=Tk(s);return s.body.emitter.on("verticalDrag",(function(){a.dom.lineContainer.style.top="".concat(a.body.domProps.scrollTop,"px")})),s}return Gc(i,[{key:"addGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1}},{key:"updateGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.amountOfGroups+=1),this.groups[t]=e}},{key:"removeGroup",value:function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)}},{key:"setOptions",value:function(t){if(t){var e=!1;this.options.orientation!=t.orientation&&void 0!==t.orientation&&(e=!0);kI.selectiveDeepExtend(["orientation","showMinorLabels","showMajorLabels","icons","majorLinesOffset","minorLinesOffset","labelOffsetX","labelOffsetY","iconWidth","width","visible","left","right","alignZeros"],this.options,t),this.minWidth=Number("".concat(this.options.width).replace("px","")),!0===e&&this.dom.frame&&(this.hide(),this.show())}}},{key:"_create",value:function(){this.dom.frame=document.createElement("div"),this.dom.frame.style.width=this.options.width,this.dom.frame.style.height=this.height,this.dom.lineContainer=document.createElement("div"),this.dom.lineContainer.style.width="100%",this.dom.lineContainer.style.height=this.height,this.dom.lineContainer.style.position="relative",this.dom.lineContainer.style.visibility="visible",this.dom.lineContainer.style.display="block",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.height="100%",this.svg.style.width="100%",this.svg.style.display="block",this.dom.frame.appendChild(this.svg)}},{key:"_redrawGroupIcons",value:function(){var t;yk(this.svgElements);var e=this.options.iconWidth,i=11.5;t="left"===this.options.orientation?4:this.width-e-4;var n=vf(this.groups);PE(n).call(n,(function(t,e){return t<e?-1:1}));var r,o=zR(n);try{for(o.s();!(r=o.n()).done;){var s=r.value;!0!==this.groups[s].visible||void 0!==this.linegraphOptions.visibility[s]&&!0!==this.linegraphOptions.visibility[s]||(this.groups[s].getLegend(e,15,this.framework,t,i),i+=19)}}catch(t){o.e(t)}finally{o.f()}bk(this.svgElements),this.iconsRemoved=!1}},{key:"_cleanupIcons",value:function(){!1===this.iconsRemoved&&(yk(this.svgElements),bk(this.svgElements),this.iconsRemoved=!0)}},{key:"show",value:function(){this.hidden=!1,this.dom.frame.parentNode||("left"===this.options.orientation?this.body.dom.left.appendChild(this.dom.frame):this.body.dom.right.appendChild(this.dom.frame)),this.dom.lineContainer.parentNode||this.body.dom.backgroundHorizontal.appendChild(this.dom.lineContainer),this.dom.lineContainer.style.display="block"}},{key:"hide",value:function(){this.hidden=!0,this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.lineContainer.style.display="none"}},{key:"setRange",value:function(t,e){this.range.start=t,this.range.end=e}},{key:"redraw",value:function(){var t=!1,e=0;for(var i in this.dom.lineContainer.style.top="".concat(this.body.domProps.scrollTop,"px"),this.groups)this.groups.hasOwnProperty(i)&&(!0!==this.groups[i].visible||void 0!==this.linegraphOptions.visibility[i]&&!0!==this.linegraphOptions.visibility[i]||e++);if(0===this.amountOfGroups||0===e)this.hide();else{this.show(),this.height=Number(this.linegraphSVG.style.height.replace("px","")),this.dom.lineContainer.style.height="".concat(this.height,"px"),this.width=!0===this.options.visible?Number("".concat(this.options.width).replace("px","")):0;var n=this.props,r=this.dom.frame;r.className="vis-data-axis",this._calculateCharSize();var o=this.options.orientation,s=this.options.showMinorLabels,a=this.options.showMajorLabels,l=this.body.dom.backgroundHorizontal.offsetWidth;n.minorLabelHeight=s?n.minorCharHeight:0,n.majorLabelHeight=a?n.majorCharHeight:0,n.minorLineWidth=l-this.lineOffset-this.width+2*this.options.minorLinesOffset,n.minorLineHeight=1,n.majorLineWidth=l-this.lineOffset-this.width+2*this.options.majorLinesOffset,n.majorLineHeight=1,"left"===o?(r.style.top="0",r.style.left="0",r.style.bottom="",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.left.width,this.props.height=this.body.domProps.left.height):(r.style.top="",r.style.bottom="0",r.style.left="0",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.right.width,this.props.height=this.body.domProps.right.height),t=this._redrawLabels(),t=this._isResized()||t,!0===this.options.icons?this._redrawGroupIcons():this._cleanupIcons(),this._redrawTitle(o)}return t}},{key:"_redrawLabels",value:function(){var t=this,e=!1;yk(this.DOMelements.lines),yk(this.DOMelements.labels);var i=this.options.orientation,n=null!=this.options[i].range?this.options[i].range:{},r=!0;null!=n.max&&(this.range.end=n.max,r=!1);var o=!0;null!=n.min&&(this.range.start=n.min,o=!1),this.scale=new HR(this.range.start,this.range.end,o,r,this.dom.frame.offsetHeight,this.props.majorCharHeight,this.options.alignZeros,this.options[i].format),!1===this.master&&null!=this.masterAxis?(this.scale.followScale(this.masterAxis.scale),this.dom.lineContainer.style.display="none"):this.dom.lineContainer.style.display="block",this.maxLabelSize=0;var s=this.scale.getLines();sm(s).call(s,(function(e){var n=e.y,r=e.major;t.options.showMinorLabels&&!1===r&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-minor",t.props.minorCharHeight),r&&n>=0&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-major",t.props.majorCharHeight),!0===t.master&&(r?t._redrawLine(n,i,"vis-grid vis-horizontal vis-major",t.options.majorLinesOffset,t.props.majorLineWidth):t._redrawLine(n,i,"vis-grid vis-horizontal vis-minor",t.options.minorLinesOffset,t.props.minorLineWidth))}));var a=0;void 0!==this.options[i].title&&void 0!==this.options[i].title.text&&(a=this.props.titleCharHeight);var l=!0===this.options.icons?Math.max(this.options.iconWidth,a)+this.options.labelOffsetX+15:a+this.options.labelOffsetX+15;return this.maxLabelSize>this.width-l&&!0===this.options.visible?(this.width=this.maxLabelSize+l,this.options.width="".concat(this.width,"px"),bk(this.DOMelements.lines),bk(this.DOMelements.labels),this.redraw(),e=!0):this.maxLabelSize<this.width-l&&!0===this.options.visible&&this.width>this.minWidth?(this.width=Math.max(this.minWidth,this.maxLabelSize+l),this.options.width="".concat(this.width,"px"),bk(this.DOMelements.lines),bk(this.DOMelements.labels),this.redraw(),e=!0):(bk(this.DOMelements.lines),bk(this.DOMelements.labels),e=!1),e}},{key:"convertValue",value:function(t){return this.scale.convertValue(t)}},{key:"screenToValue",value:function(t){return this.scale.screenToValue(t)}},{key:"_redrawLabel",value:function(t,e,i,n,r){var o=kk("div",this.DOMelements.labels,this.dom.frame);o.className=n,o.innerHTML=kI.xss(e),"left"===i?(o.style.left="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="right"):(o.style.right="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="left"),o.style.top="".concat(t-.5*r+this.options.labelOffsetY,"px"),e+="";var s=Math.max(this.props.majorCharWidth,this.props.minorCharWidth);this.maxLabelSize<e.length*s&&(this.maxLabelSize=e.length*s)}},{key:"_redrawLine",value:function(t,e,i,n,r){if(!0===this.master){var o=kk("div",this.DOMelements.lines,this.dom.lineContainer);o.className=i,o.innerHTML="","left"===e?o.style.left="".concat(this.width-n,"px"):o.style.right="".concat(this.width-n,"px"),o.style.width="".concat(r,"px"),o.style.top="".concat(t,"px")}}},{key:"_redrawTitle",value:function(t){if(yk(this.DOMelements.title),void 0!==this.options[t].title&&void 0!==this.options[t].title.text){var e=kk("div",this.DOMelements.title,this.dom.frame);e.className="vis-y-axis vis-title vis-".concat(t),e.innerHTML=kI.xss(this.options[t].title.text),void 0!==this.options[t].title.style&&kI.addCssText(e,this.options[t].title.style),"left"===t?e.style.left="".concat(this.props.titleCharHeight,"px"):e.style.right="".concat(this.props.titleCharHeight,"px"),e.style.width="".concat(this.height,"px")}bk(this.DOMelements.title)}},{key:"_calculateCharSize",value:function(){if(!("minorCharHeight"in this.props)){var t=document.createTextNode("0"),e=document.createElement("div");e.className="vis-y-axis vis-minor vis-measure",e.appendChild(t),this.dom.frame.appendChild(e),this.props.minorCharHeight=e.clientHeight,this.props.minorCharWidth=e.clientWidth,this.dom.frame.removeChild(e)}if(!("majorCharHeight"in this.props)){var i=document.createTextNode("0"),n=document.createElement("div");n.className="vis-y-axis vis-major vis-measure",n.appendChild(i),this.dom.frame.appendChild(n),this.props.majorCharHeight=n.clientHeight,this.props.majorCharWidth=n.clientWidth,this.dom.frame.removeChild(n)}if(!("titleCharHeight"in this.props)){var r=document.createTextNode("0"),o=document.createElement("div");o.className="vis-y-axis vis-title vis-measure",o.appendChild(r),this.dom.frame.appendChild(o),this.props.titleCharHeight=o.clientHeight,this.props.titleCharWidth=o.clientWidth,this.dom.frame.removeChild(o)}}}]),i}();function VR(t,e){}function UR(t,e){return{style:(e=void 0===e?{}:e).style||t.options.drawPoints.style,styles:e.styles||t.options.drawPoints.styles,size:e.size||t.options.drawPoints.size,className:e.className||t.className}}function XR(t,e){}function qR(t,e){}function $R(t,e,i,n){this.id=e;this.options=kI.selectiveBridgeObject(["sampling","style","sort","yAxisOrientation","barChart","drawPoints","shaded","interpolation","zIndex","excludeFromStacking","excludeFromLegend"],i),this.usingDefaultStyle=void 0===t.className,this.groupsUsingDefaultStyles=n,this.zeroPosition=0,this.update(t),1==this.usingDefaultStyle&&(this.groupsUsingDefaultStyles[0]+=1),this.itemsData=[],this.visible=void 0===t.visible||t.visible}function ZR(t,e,i,n){this.body=t,this.defaultOptions={enabled:!1,icons:!0,iconSize:20,iconSpacing:6,left:{visible:!0,position:"top-left"},right:{visible:!0,position:"top-right"}},this.side=i,this.options=kI.extend({},this.defaultOptions),this.linegraphOptions=n,this.svgElements={},this.dom={},this.groups={},this.amountOfGroups=0,this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups},this.setOptions(e)}VR.draw=function(t,e,i,n){n=n||0;for(var r=function(t,e){var i=void 0;t.options&&t.options.drawPoints&&t.options.drawPoints.onRender&&"function"==typeof t.options.drawPoints.onRender&&(i=t.options.drawPoints.onRender);e.group.options&&e.group.options.drawPoints&&e.group.options.drawPoints.onRender&&"function"==typeof e.group.options.drawPoints.onRender&&(i=e.group.options.drawPoints.onRender);return i}(i,e),o=0;o<t.length;o++)if(r){var s=r(t[o],e);!0!==s&&"object"!==Lc(s)||xk(t[o].screen_x+n,t[o].screen_y,UR(e,s),i.svgElements,i.svg,t[o].label)}else xk(t[o].screen_x+n,t[o].screen_y,UR(e),i.svgElements,i.svg,t[o].label)},VR.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=wk("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline"),xk(e+.5*n,i,UR(t),o.svgElements,o.svg)},XR.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=wk("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline");var l=Math.round(.3*n),h=t.options.barChart.width/l,u=Math.round(.4*r),d=Math.round(.75*r),c=Math.round((n-2*l)/3);if(Dk(e+.5*l+c,i+s-u-1,l,u,t.className+" vis-bar",o.svgElements,o.svg,t.style),Dk(e+1.5*l+c+2,i+s-d-1,l,d,t.className+" vis-bar",o.svgElements,o.svg,t.style),1==t.options.drawPoints.enabled){var p={style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size/h,className:t.className};xk(e+.5*l+c,i+s-u-1,p,o.svgElements,o.svg),xk(e+1.5*l+c+2,i+s-d-1,p,o.svgElements,o.svg)}},XR.draw=function(t,e,i){var n,r,o,s,a,l,h=[],u={},d=0;for(a=0;a<t.length;a++)if("bar"===(s=i.groups[t[a]]).options.style&&!0===s.visible&&(void 0===i.options.groups.visibility[t[a]]||!0===i.options.groups.visibility[t[a]]))for(l=0;l<e[t[a]].length;l++)h.push({screen_x:e[t[a]][l].screen_x,screen_end:e[t[a]][l].screen_end,screen_y:e[t[a]][l].screen_y,x:e[t[a]][l].x,end:e[t[a]][l].end,y:e[t[a]][l].y,groupId:t[a],label:e[t[a]][l].label}),d+=1;if(0!==d)for(PE(h).call(h,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x})),XR._getDataIntersections(u,h),a=0;a<h.length;a++){var c=null!=(s=i.groups[h[a].groupId]).options.barChart.minWidth?s.options.barChart.minWidth:.1*s.options.barChart.width,p=0;if(void 0===u[r=h[a].screen_x])a+1<h.length&&(n=Math.abs(h[a+1].screen_x-r)),o=XR._getSafeDrawData(n,s,c);else{var f=a+(u[r].amount-u[r].resolved);f<h.length&&(n=Math.abs(h[f].screen_x-r)),o=XR._getSafeDrawData(n,s,c),u[r].resolved+=1,!0===s.options.stack&&!0!==s.options.excludeFromStacking?h[a].screen_y<s.zeroPosition?(p=u[r].accumulatedNegative,u[r].accumulatedNegative+=s.zeroPosition-h[a].screen_y):(p=u[r].accumulatedPositive,u[r].accumulatedPositive+=s.zeroPosition-h[a].screen_y):!0===s.options.barChart.sideBySide&&(o.width=o.width/u[r].amount,o.offset+=u[r].resolved*o.width-.5*o.width*(u[r].amount+1))}var m=o.width,v=h[a].screen_x;if(null!=h[a].screen_end?v+=.5*(m=h[a].screen_end-h[a].screen_x):v+=o.offset,Dk(v,h[a].screen_y-p,m,s.zeroPosition-h[a].screen_y,s.className+" vis-bar",i.svgElements,i.svg,s.style),!0===s.options.drawPoints.enabled){var g={screen_x:h[a].screen_x,screen_y:h[a].screen_y-p,x:h[a].x,y:h[a].y,groupId:h[a].groupId,label:h[a].label};VR.draw([g],s,i,o.offset)}}},XR._getDataIntersections=function(t,e){for(var i,n=0;n<e.length;n++)n+1<e.length&&(i=Math.abs(e[n+1].screen_x-e[n].screen_x)),n>0&&(i=Math.min(i,Math.abs(e[n-1].screen_x-e[n].screen_x))),0===i&&(void 0===t[e[n].screen_x]&&(t[e[n].screen_x]={amount:0,resolved:0,accumulatedPositive:0,accumulatedNegative:0}),t[e[n].screen_x].amount+=1)},XR._getSafeDrawData=function(t,e,i){var n,r;return t<e.options.barChart.width&&t>0?(n=t<i?i:t,r=0,"left"===e.options.barChart.align?r-=.5*t:"right"===e.options.barChart.align&&(r+=.5*t)):(n=e.options.barChart.width,r=0,"left"===e.options.barChart.align?r-=.5*e.options.barChart.width:"right"===e.options.barChart.align&&(r+=.5*e.options.barChart.width)),{width:n,offset:r}},XR.getStackedYRange=function(t,e,i,n,r){if(t.length>0){PE(t).call(t,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x}));var o={};XR._getDataIntersections(o,t),e[n]=XR._getStackedYRange(o,t),e[n].yAxisOrientation=r,i.push(n)}},XR._getStackedYRange=function(t,e){for(var i,n=e[0].screen_y,r=e[0].screen_y,o=0;o<e.length;o++)void 0===t[i=e[o].screen_x]?(n=n>e[o].screen_y?e[o].screen_y:n,r=r<e[o].screen_y?e[o].screen_y:r):e[o].screen_y<0?t[i].accumulatedNegative+=e[o].screen_y:t[i].accumulatedPositive+=e[o].screen_y;for(var s in t)t.hasOwnProperty(s)&&(n=(n=n>t[s].accumulatedNegative?t[s].accumulatedNegative:n)>t[s].accumulatedPositive?t[s].accumulatedPositive:n,r=(r=r<t[s].accumulatedNegative?t[s].accumulatedNegative:r)<t[s].accumulatedPositive?t[s].accumulatedPositive:r);return{min:n,max:r}},qR.calcPath=function(t,e){if(null!=t&&t.length>0){return 1==e.options.interpolation.enabled?qR._catmullRom(t,e):qR._linear(t)}},qR.drawIcon=function(t,e,i,n,r,o){var s,a,l=.5*r,h=wk("rect",o.svgElements,o.svg);(h.setAttributeNS(null,"x",e),h.setAttributeNS(null,"y",i-l),h.setAttributeNS(null,"width",n),h.setAttributeNS(null,"height",2*l),h.setAttributeNS(null,"class","vis-outline"),(s=wk("path",o.svgElements,o.svg)).setAttributeNS(null,"class",t.className),void 0!==t.style&&s.setAttributeNS(null,"style",t.style),s.setAttributeNS(null,"d","M"+e+","+i+" L"+(e+n)+","+i),1==t.options.shaded.enabled&&(a=wk("path",o.svgElements,o.svg),"top"==t.options.shaded.orientation?a.setAttributeNS(null,"d","M"+e+", "+(i-l)+"L"+e+","+i+" L"+(e+n)+","+i+" L"+(e+n)+","+(i-l)):a.setAttributeNS(null,"d","M"+e+","+i+" L"+e+","+(i+l)+" L"+(e+n)+","+(i+l)+"L"+(e+n)+","+i),a.setAttributeNS(null,"class",t.className+" vis-icon-fill"),void 0!==t.options.shaded.style&&""!==t.options.shaded.style&&a.setAttributeNS(null,"style",t.options.shaded.style)),1==t.options.drawPoints.enabled)&&xk(e+.5*n,i,{style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size,className:t.className},o.svgElements,o.svg)},qR.drawShading=function(t,e,i,n){if(1==e.options.shaded.enabled){var r,o=Number(n.svg.style.height.replace("px","")),s=wk("path",n.svgElements,n.svg),a="L";1==e.options.interpolation.enabled&&(a="C");var l=0;l="top"==e.options.shaded.orientation?0:"bottom"==e.options.shaded.orientation?o:Math.min(Math.max(0,e.zeroPosition),o),r="group"==e.options.shaded.orientation&&null!=i&&null!=i?"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" L"+i[i.length-1][0]+","+i[i.length-1][1]+" "+this.serializePath(i,a,!0)+i[0][0]+","+i[0][1]+" Z":"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" V"+l+" H"+t[0][0]+" Z",s.setAttributeNS(null,"class",e.className+" vis-fill"),void 0!==e.options.shaded.style&&s.setAttributeNS(null,"style",e.options.shaded.style),s.setAttributeNS(null,"d",r)}},qR.draw=function(t,e,i){if(null!=t&&null!=t){var n=wk("path",i.svgElements,i.svg);n.setAttributeNS(null,"class",e.className),void 0!==e.style&&n.setAttributeNS(null,"style",e.style);var r="L";1==e.options.interpolation.enabled&&(r="C"),n.setAttributeNS(null,"d","M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,r,!1))}},qR.serializePath=function(t,e,i){if(t.length<2)return"";var n,r=e;if(i)for(n=t.length-2;n>0;n--)r+=t[n][0]+","+t[n][1]+" ";else for(n=1;n<t.length;n++)r+=t[n][0]+","+t[n][1]+" ";return r},qR._catmullRomUniform=function(t){var e,i,n,r,o,s,a=[];a.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var l=1/6,h=t.length,u=0;u<h-1;u++)e=0==u?t[0]:t[u-1],i=t[u],n=t[u+1],r=u+2<h?t[u+2]:n,o={screen_x:(-e.screen_x+6*i.screen_x+n.screen_x)*l,screen_y:(-e.screen_y+6*i.screen_y+n.screen_y)*l},s={screen_x:(i.screen_x+6*n.screen_x-r.screen_x)*l,screen_y:(i.screen_y+6*n.screen_y-r.screen_y)*l},a.push([o.screen_x,o.screen_y]),a.push([s.screen_x,s.screen_y]),a.push([n.screen_x,n.screen_y]);return a},qR._catmullRom=function(t,e){var i=e.options.interpolation.alpha;if(0==i||void 0===i)return this._catmullRomUniform(t);var n,r,o,s,a,l,h,u,d,c,p,f,m,v,g,y,b,_,w,k=[];k.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var x=t.length,D=0;D<x-1;D++)n=0==D?t[0]:t[D-1],r=t[D],o=t[D+1],s=D+2<x?t[D+2]:o,h=Math.sqrt(Math.pow(n.screen_x-r.screen_x,2)+Math.pow(n.screen_y-r.screen_y,2)),u=Math.sqrt(Math.pow(r.screen_x-o.screen_x,2)+Math.pow(r.screen_y-o.screen_y,2)),d=Math.sqrt(Math.pow(o.screen_x-s.screen_x,2)+Math.pow(o.screen_y-s.screen_y,2)),v=Math.pow(d,i),y=Math.pow(d,2*i),g=Math.pow(u,i),b=Math.pow(u,2*i),w=Math.pow(h,i),c=2*(_=Math.pow(h,2*i))+3*w*g+b,p=2*y+3*v*g+b,(f=3*w*(w+g))>0&&(f=1/f),(m=3*v*(v+g))>0&&(m=1/m),a={screen_x:(-b*n.screen_x+c*r.screen_x+_*o.screen_x)*f,screen_y:(-b*n.screen_y+c*r.screen_y+_*o.screen_y)*f},l={screen_x:(y*r.screen_x+p*o.screen_x-b*s.screen_x)*m,screen_y:(y*r.screen_y+p*o.screen_y-b*s.screen_y)*m},0==a.screen_x&&0==a.screen_y&&(a=r),0==l.screen_x&&0==l.screen_y&&(l=o),k.push([a.screen_x,a.screen_y]),k.push([l.screen_x,l.screen_y]),k.push([o.screen_x,o.screen_y]);return k},qR._linear=function(t){for(var e=[],i=0;i<t.length;i++)e.push([t[i].screen_x,t[i].screen_y]);return e},$R.prototype.setItems=function(t){null!=t?(this.itemsData=t,1==PE(this.options)&&kI.insertSort(this.itemsData,(function(t,e){return t.x>e.x?1:-1}))):this.itemsData=[]},$R.prototype.getItems=function(){return this.itemsData},$R.prototype.setZeroPosition=function(t){this.zeroPosition=t},$R.prototype.setOptions=function(t){if(void 0!==t){kI.selectiveDeepExtend(["sampling","style","sort","yAxisOrientation","barChart","zIndex","excludeFromStacking","excludeFromLegend"],this.options,t),"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),kI.mergeOptions(this.options,t,"interpolation"),kI.mergeOptions(this.options,t,"drawPoints"),kI.mergeOptions(this.options,t,"shaded"),t.interpolation&&"object"==Lc(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5))}},$R.prototype.update=function(t){this.group=t,this.content=t.content||"graph",this.className=t.className||this.className||"vis-graph-group"+this.groupsUsingDefaultStyles[0]%10,this.visible=void 0===t.visible||t.visible,this.style=t.style,this.setOptions(t.options)},$R.prototype.getLegend=function(t,e,i,n,r){null!=i&&null!=i||(i={svg:document.createElementNS("http://www.w3.org/2000/svg","svg"),svgElements:{},options:this.options,groups:[this]});switch(null!=n&&null!=n||(n=0),null!=r&&null!=r||(r=.5*e),this.options.style){case"line":qR.drawIcon(this,n,r,t,e,i);break;case"points":case"point":VR.drawIcon(this,n,r,t,e,i);break;case"bar":XR.drawIcon(this,n,r,t,e,i)}return{icon:i.svg,label:this.content,orientation:this.options.yAxisOrientation}},$R.prototype.getYRange=function(t){for(var e=t[0].y,i=t[0].y,n=0;n<t.length;n++)e=e>t[n].y?t[n].y:e,i=i<t[n].y?t[n].y:i;return{min:e,max:i,yAxisOrientation:this.options.yAxisOrientation}},ZR.prototype=new FI,ZR.prototype.clear=function(){this.groups={},this.amountOfGroups=0},ZR.prototype.addGroup=function(t,e){1!=e.options.excludeFromLegend&&(this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1)},ZR.prototype.updateGroup=function(t,e){this.groups[t]=e},ZR.prototype.removeGroup=function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)},ZR.prototype._create=function(){this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-legend",this.dom.frame.style.position="absolute",this.dom.frame.style.top="10px",this.dom.frame.style.display="block",this.dom.textArea=document.createElement("div"),this.dom.textArea.className="vis-legend-text",this.dom.textArea.style.position="relative",this.dom.textArea.style.top="0px",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.width=this.options.iconSize+5+"px",this.svg.style.height="100%",this.dom.frame.appendChild(this.svg),this.dom.frame.appendChild(this.dom.textArea)},ZR.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},ZR.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},ZR.prototype.setOptions=function(t){kI.selectiveDeepExtend(["enabled","orientation","icons","left","right"],this.options,t)},ZR.prototype.redraw=function(){var t=0,e=vf(this.groups);PE(e).call(e,(function(t,e){return t<e?-1:1}));for(var i=0;i<e.length;i++){var n=e[i];1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||t++}if(0==this.options[this.side].visible||0==this.amountOfGroups||0==this.options.enabled||0==t)this.hide();else{if(this.show(),"top-left"==this.options[this.side].position||"bottom-left"==this.options[this.side].position?(this.dom.frame.style.left="4px",this.dom.frame.style.textAlign="left",this.dom.textArea.style.textAlign="left",this.dom.textArea.style.left=this.options.iconSize+15+"px",this.dom.textArea.style.right="",this.svg.style.left="0px",this.svg.style.right=""):(this.dom.frame.style.right="4px",this.dom.frame.style.textAlign="right",this.dom.textArea.style.textAlign="right",this.dom.textArea.style.right=this.options.iconSize+15+"px",this.dom.textArea.style.left="",this.svg.style.right="0px",this.svg.style.left=""),"top-left"==this.options[this.side].position||"top-right"==this.options[this.side].position)this.dom.frame.style.top=4-Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.bottom="";else{var r=this.body.domProps.center.height-this.body.domProps.centerContainer.height;this.dom.frame.style.bottom=4+r+Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.top=""}0==this.options.icons?(this.dom.frame.style.width=this.dom.textArea.offsetWidth+10+"px",this.dom.textArea.style.right="",this.dom.textArea.style.left="",this.svg.style.width="0px"):(this.dom.frame.style.width=this.options.iconSize+15+this.dom.textArea.offsetWidth+10+"px",this.drawLegendIcons());var o="";for(i=0;i<e.length;i++)n=e[i],1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||(o+=this.groups[n].content+"<br />");this.dom.textArea.innerHTML=kI.xss(o),this.dom.textArea.style.lineHeight=.75*this.options.iconSize+this.options.iconSpacing+"px"}},ZR.prototype.drawLegendIcons=function(){if(this.dom.frame.parentNode){var t=vf(this.groups);PE(t).call(t,(function(t,e){return t<e?-1:1})),_k(this.svgElements);var e=window.getComputedStyle(this.dom.frame).paddingTop,i=Number(e.replace("px","")),n=i,r=this.options.iconSize,o=.75*this.options.iconSize,s=i+.5*o+3;this.svg.style.width=r+5+i+"px";for(var a=0;a<t.length;a++){var l=t[a];1!=this.groups[l].visible||void 0!==this.linegraphOptions.visibility[l]&&1!=this.linegraphOptions.visibility[l]||(this.groups[l].getLegend(r,o,this.framework,n,s),s+=o+this.options.iconSpacing)}}};var KR="__ungrouped__";function JR(t,e){this.id=VP(),this.body=t,this.defaultOptions={yAxisOrientation:"left",defaultGroup:"default",sort:!0,sampling:!0,stack:!1,graphHeight:"400px",shaded:{enabled:!1,orientation:"bottom"},style:"line",barChart:{width:50,sideBySide:!1,align:"center"},interpolation:{enabled:!0,parametrization:"centripetal",alpha:.5},drawPoints:{enabled:!0,size:6,style:"square"},dataAxis:{},legend:{},groups:{visibility:{}}},this.options=kI.extend({},this.defaultOptions),this.dom={},this.props={},this.hammer=null,this.groups={},this.abortedGraphUpdate=!1,this.updateSVGheight=!1,this.updateSVGheightOnResize=!1,this.forceGraphUpdate=!0;var i=this;this.itemsData=null,this.groupsData=null,this.itemListeners={add:function(t,e,n){i._onAdd(e.items)},update:function(t,e,n){i._onUpdate(e.items)},remove:function(t,e,n){i._onRemove(e.items)}},this.groupListeners={add:function(t,e,n){i._onAddGroups(e.items)},update:function(t,e,n){i._onUpdateGroups(e.items)},remove:function(t,e,n){i._onRemoveGroups(e.items)}},this.items={},this.selection=[],this.lastStart=this.body.range.start,this.touchParams={},this.svgElements={},this.setOptions(e),this.groupsUsingDefaultStyles=[0],this.body.emitter.on("rangechanged",(function(){i.svg.style.left=kI.option.asSize(-i.props.width),i.forceGraphUpdate=!0,i.redraw.call(i)})),this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups}}JR.prototype=new FI,JR.prototype._create=function(){var t=document.createElement("div");t.className="vis-line-graph",this.dom.frame=t,this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="relative",this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",this.svg.style.display="block",t.appendChild(this.svg),this.options.dataAxis.orientation="left",this.yAxisLeft=new WR(this.body,this.options.dataAxis,this.svg,this.options.groups),this.options.dataAxis.orientation="right",this.yAxisRight=new WR(this.body,this.options.dataAxis,this.svg,this.options.groups),delete this.options.dataAxis.orientation,this.legendLeft=new ZR(this.body,this.options.legend,"left",this.options.groups),this.legendRight=new ZR(this.body,this.options.legend,"right",this.options.groups),this.show()},JR.prototype.setOptions=function(t){if(t){void 0===t.graphHeight&&void 0!==t.height?(this.updateSVGheight=!0,this.updateSVGheightOnResize=!0):void 0!==this.body.domProps.centerContainer.height&&void 0!==t.graphHeight&&jg((t.graphHeight+"").replace("px",""))<this.body.domProps.centerContainer.height&&(this.updateSVGheight=!0),kI.selectiveDeepExtend(["sampling","defaultGroup","stack","height","graphHeight","yAxisOrientation","style","barChart","dataAxis","sort","groups"],this.options,t),kI.mergeOptions(this.options,t,"interpolation"),kI.mergeOptions(this.options,t,"drawPoints"),kI.mergeOptions(this.options,t,"shaded"),kI.mergeOptions(this.options,t,"legend"),t.interpolation&&"object"==Lc(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5)),this.yAxisLeft&&void 0!==t.dataAxis&&(this.yAxisLeft.setOptions(this.options.dataAxis),this.yAxisRight.setOptions(this.options.dataAxis)),this.legendLeft&&void 0!==t.legend&&(this.legendLeft.setOptions(this.options.legend),this.legendRight.setOptions(this.options.legend)),this.groups.hasOwnProperty(KR)&&this.groups[KR].setOptions(t)}this.dom.frame&&(this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0}))},JR.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},JR.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},JR.prototype.setItems=function(t){var e,i=this,n=this.itemsData;if(t){if(!fI(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=yI(t)}else this.itemsData=null;if(n&&(sm(kI).call(kI,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;sm(kI).call(kI,this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e)}},JR.prototype.setGroups=function(t){var e,i=this;if(this.groupsData){sm(kI).call(kI,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null;for(var n=0;n<e.length;n++)this._removeGroup(e[n])}if(t){if(!fI(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var r=this.id;sm(kI).call(kI,this.groupListeners,(function(t,e){i.groupsData.on(e,t,r)})),e=this.groupsData.getIds(),this._onAddGroups(e)}},JR.prototype._onUpdate=function(t){this._updateAllGroupData(t)},JR.prototype._onAdd=function(t){this._onUpdate(t)},JR.prototype._onRemove=function(t){this._onUpdate(t)},JR.prototype._onUpdateGroups=function(t){this._updateAllGroupData(null,t)},JR.prototype._onAddGroups=function(t){this._onUpdateGroups(t)},JR.prototype._onRemoveGroups=function(t){for(var e=0;e<t.length;e++)this._removeGroup(t[e]);this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})},JR.prototype._removeGroup=function(t){this.groups.hasOwnProperty(t)&&("right"==this.groups[t].options.yAxisOrientation?(this.yAxisRight.removeGroup(t),this.legendRight.removeGroup(t),this.legendRight.redraw()):(this.yAxisLeft.removeGroup(t),this.legendLeft.removeGroup(t),this.legendLeft.redraw()),delete this.groups[t])},JR.prototype._updateGroup=function(t,e){this.groups.hasOwnProperty(e)?(this.groups[e].update(t),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.updateGroup(e,this.groups[e]),this.legendRight.updateGroup(e,this.groups[e]),this.yAxisLeft.removeGroup(e),this.legendLeft.removeGroup(e)):(this.yAxisLeft.updateGroup(e,this.groups[e]),this.legendLeft.updateGroup(e,this.groups[e]),this.yAxisRight.removeGroup(e),this.legendRight.removeGroup(e))):(this.groups[e]=new $R(t,e,this.options,this.groupsUsingDefaultStyles),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.addGroup(e,this.groups[e]),this.legendRight.addGroup(e,this.groups[e])):(this.yAxisLeft.addGroup(e,this.groups[e]),this.legendLeft.addGroup(e,this.groups[e]))),this.legendLeft.redraw(),this.legendRight.redraw()},JR.prototype._updateAllGroupData=function(t,e){if(null!=this.itemsData){var i={},n=this.itemsData.get(),r=this.itemsData.idProp,o={};t&&uf(t).call(t,(function(t){o[t]=t}));for(var s={},a=0;a<n.length;a++){var l=n[a],h=l.group;null==h&&(h=KR),s.hasOwnProperty(h)?s[h]++:s[h]=1}var u={};if(!e&&t)for(h in this.groups)if(this.groups.hasOwnProperty(h)){var d=(m=this.groups[h]).getItems();i[h]=eg(d).call(d,(function(t){return u[t[r]]=t[r],t[r]!==o[t[r]]}));var c=s[h];s[h]-=i[h].length,i[h].length<c&&(i[h][c-1]={})}for(a=0;a<n.length;a++)if(null==(h=(l=n[a]).group)&&(h=KR),e||!t||l[r]===o[l[r]]||!u.hasOwnProperty(l[r])){i.hasOwnProperty(h)||(i[h]=new Array(s[h]));var p=kI.bridgeObject(l);p.x=kI.convert(l.x,"Date"),p.end=kI.convert(l.end,"Date"),p.orginalY=l.y,p.y=Number(l.y),p[r]=l[r];var f=i[h].length-s[h]--;i[h][f]=p}for(h in this.groups)this.groups.hasOwnProperty(h)&&(i.hasOwnProperty(h)||(i[h]=new Array(0)));for(h in i)if(i.hasOwnProperty(h))if(0==i[h].length)this.groups.hasOwnProperty(h)&&this._removeGroup(h);else{var m=void 0;null!=this.groupsData&&(m=this.groupsData.get(h)),null==m&&(m={id:h,content:this.options.defaultGroup+h}),this._updateGroup(m,h),this.groups[h].setItems(i[h])}this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})}},JR.prototype.redraw=function(){var t=!1;this.props.width=this.dom.frame.offsetWidth,this.props.height=this.body.domProps.centerContainer.height-this.body.domProps.border.top-this.body.domProps.border.bottom,t=this._isResized()||t;var e,i=this.body.range.end-this.body.range.start,n=i!=this.lastVisibleInterval;(this.lastVisibleInterval=i,1==t)&&(this.svg.style.width=kI.option.asSize(3*this.props.width),this.svg.style.left=kI.option.asSize(-this.props.width),-1==Jg(e=this.options.height+"").call(e,"%")&&1!=this.updateSVGheightOnResize||(this.updateSVGheight=!0));if(1==this.updateSVGheight?(this.options.graphHeight!=this.props.height+"px"&&(this.options.graphHeight=this.props.height+"px",this.svg.style.height=this.props.height+"px"),this.updateSVGheight=!1):this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",1==t||1==n||1==this.abortedGraphUpdate||1==this.forceGraphUpdate)t=this._updateGraph()||t,this.forceGraphUpdate=!1,this.lastStart=this.body.range.start,this.svg.style.left=-this.props.width+"px";else if(0!=this.lastStart){var r=this.body.range.start-this.lastStart,o=this.body.range.end-this.body.range.start;if(0!=this.props.width){var s=r*(this.props.width/o);this.svg.style.left=-this.props.width-s+"px"}}return this.legendLeft.redraw(),this.legendRight.redraw(),t},JR.prototype._getSortedGroupIds=function(){var t=[];for(var e in this.groups)if(this.groups.hasOwnProperty(e)){var i=this.groups[e];1!=i.visible||void 0!==this.options.groups.visibility[e]&&1!=this.options.groups.visibility[e]||t.push({id:e,zIndex:i.options.zIndex})}kI.insertSort(t,(function(t,e){var i=t.zIndex,n=e.zIndex;return void 0===i&&(i=0),void 0===n&&(n=0),i==n?0:i<n?-1:1}));for(var n=new Array(t.length),r=0;r<t.length;r++)n[r]=t[r].id;return n},JR.prototype._updateGraph=function(){if(yk(this.svgElements),0!=this.props.width&&null!=this.itemsData){var t,e,i={},n=this.body.util.toGlobalTime(-this.body.domProps.root.width),r=this.body.util.toGlobalTime(2*this.body.domProps.root.width),o=this._getSortedGroupIds();if(o.length>0){var s={};for(this._getRelevantData(o,s,n,r),this._applySampling(o,s),e=0;e<o.length;e++)this._convertXcoordinates(s[o[e]]);if(this._getYRanges(o,s,i),1==this._updateYAxis(o,i))return bk(this.svgElements),this.abortedGraphUpdate=!0,!0;this.abortedGraphUpdate=!1;var a=void 0;for(e=0;e<o.length;e++)t=this.groups[o[e]],!0===this.options.stack&&"line"===this.options.style&&(null!=t.options.excludeFromStacking&&t.options.excludeFromStacking||(null!=a&&(this._stack(s[t.id],s[a.id]),1==t.options.shaded.enabled&&"group"!==t.options.shaded.orientation&&("top"==t.options.shaded.orientation&&"group"!==a.options.shaded.orientation?(a.options.shaded.orientation="group",a.options.shaded.groupId=t.id):(t.options.shaded.orientation="group",t.options.shaded.groupId=a.id))),a=t)),this._convertYcoordinates(s[o[e]],t);var l={};for(e=0;e<o.length;e++)if("line"===(t=this.groups[o[e]]).options.style&&1==t.options.shaded.enabled){var h=s[o[e]];if(null==h||0==h.length)continue;if(l.hasOwnProperty(o[e])||(l[o[e]]=qR.calcPath(h,t)),"group"===t.options.shaded.orientation){var u=t.options.shaded.groupId;if(-1===Jg(o).call(o,u)){console.log(t.id+": Unknown shading group target given:"+u);continue}l.hasOwnProperty(u)||(l[u]=qR.calcPath(s[u],this.groups[u])),qR.drawShading(l[o[e]],t,l[u],this.framework)}else qR.drawShading(l[o[e]],t,void 0,this.framework)}for(XR.draw(o,s,this.framework),e=0;e<o.length;e++)if(t=this.groups[o[e]],s[o[e]].length>0)switch(t.options.style){case"line":l.hasOwnProperty(o[e])||(l[o[e]]=qR.calcPath(s[o[e]],t)),qR.draw(l[o[e]],t,this.framework);case"point":case"points":"point"!=t.options.style&&"points"!=t.options.style&&1!=t.options.drawPoints.enabled||VR.draw(s[o[e]],t,this.framework)}}}return bk(this.svgElements),!1},JR.prototype._stack=function(t,e){var i,n,r,o,s;i=0;for(var a=0;a<t.length;a++){o=void 0,s=void 0;for(var l=i;l<e.length;l++){if(e[l].x===t[a].x){o=e[l],s=e[l],i=l;break}if(e[l].x>t[a].x){s=e[l],o=0==l?s:e[l-1],i=l;break}}void 0===s&&(o=e[e.length-1],s=e[e.length-1]),n=s.x-o.x,r=s.y-o.y,t[a].y=0==n?t[a].orginalY+s.y:t[a].orginalY+r/n*(t[a].x-o.x)+o.y}},JR.prototype._getRelevantData=function(t,e,i,n){var r,o,s,a;if(t.length>0)for(o=0;o<t.length;o++){var l=(r=this.groups[t[o]]).getItems();if(1==PE(r.options)){var h=function(t,e){return t.getTime()==e.getTime()?0:t<e?-1:1},u=Math.max(0,kI.binarySearchValue(l,i,"x","before",h)),d=Math.min(l.length,kI.binarySearchValue(l,n,"x","after",h)+1);d<=0&&(d=l.length);var c=new Array(d-u);for(s=u;s<d;s++)a=r.itemsData[s],c[s-u]=a;e[t[o]]=c}else e[t[o]]=r.itemsData}},JR.prototype._applySampling=function(t,e){if(t.length>0)for(var i=0;i<t.length;i++)if(1==this.groups[t[i]].options.sampling){var n=e[t[i]];if(n.length>0){var r,o=n.length,s=o/(this.body.util.toGlobalScreen(n[n.length-1].x)-this.body.util.toGlobalScreen(n[0].x));r=Math.min(Math.ceil(.2*o),Math.max(1,Math.round(s)));for(var a=new Array(o),l=0;l<o;l+=r){a[Math.round(l/r)]=n[l]}e[t[i]]=$m(a).call(a,0,Math.round(o/r))}}},JR.prototype._getYRanges=function(t,e,i){var n,r,o,s,a=[],l=[];if(t.length>0){for(o=0;o<t.length;o++)n=e[t[o]],s=this.groups[t[o]].options,n.length>0&&(r=this.groups[t[o]],!0===s.stack&&"bar"===s.style?"left"===s.yAxisOrientation?a=Vp(a).call(a,n):l=Vp(l).call(l,n):i[t[o]]=r.getYRange(n,t[o]));XR.getStackedYRange(a,i,t,"__barStackLeft","left"),XR.getStackedYRange(l,i,t,"__barStackRight","right")}},JR.prototype._updateYAxis=function(t,e){var i,n,r=!1,o=!1,s=!1,a=1e9,l=1e9,h=-1e9,u=-1e9;if(t.length>0){for(var d=0;d<t.length;d++){var c=this.groups[t[d]];c&&"right"!=c.options.yAxisOrientation?(o=!0,a=1e9,h=-1e9):c&&c.options.yAxisOrientation&&(s=!0,l=1e9,u=-1e9)}for(d=0;d<t.length;d++)e.hasOwnProperty(t[d])&&!0!==e[t[d]].ignore&&(i=e[t[d]].min,n=e[t[d]].max,"right"!=e[t[d]].yAxisOrientation?(o=!0,a=a>i?i:a,h=h<n?n:h):(s=!0,l=l>i?i:l,u=u<n?n:u));1==o&&this.yAxisLeft.setRange(a,h),1==s&&this.yAxisRight.setRange(l,u)}r=this._toggleAxisVisiblity(o,this.yAxisLeft)||r,r=this._toggleAxisVisiblity(s,this.yAxisRight)||r,1==s&&1==o?(this.yAxisLeft.drawIcons=!0,this.yAxisRight.drawIcons=!0):(this.yAxisLeft.drawIcons=!1,this.yAxisRight.drawIcons=!1),this.yAxisRight.master=!o,this.yAxisRight.masterAxis=this.yAxisLeft,0==this.yAxisRight.master?(this.yAxisLeft.lineOffset=1==s?this.yAxisRight.width:0,r=this.yAxisLeft.redraw()||r,r=this.yAxisRight.redraw()||r):r=this.yAxisRight.redraw()||r;var p=["__barStackLeft","__barStackRight","__lineStackLeft","__lineStackRight"];for(d=0;d<p.length;d++)-1!=Jg(t).call(t,p[d])&&$m(t).call(t,Jg(t).call(t,p[d]),1);return r},JR.prototype._toggleAxisVisiblity=function(t,e){var i=!1;return 0==t?e.dom.frame.parentNode&&0==e.hidden&&(e.hide(),i=!0):e.dom.frame.parentNode||1!=e.hidden||(e.show(),i=!0),i},JR.prototype._convertXcoordinates=function(t){for(var e=this.body.util.toScreen,i=0;i<t.length;i++)t[i].screen_x=e(t[i].x)+this.props.width,t[i].screen_y=t[i].y,null!=t[i].end?t[i].screen_end=e(t[i].end)+this.props.width:t[i].screen_end=void 0},JR.prototype._convertYcoordinates=function(t,e){var i=this.yAxisLeft,n=Number(this.svg.style.height.replace("px",""));"right"==e.options.yAxisOrientation&&(i=this.yAxisRight);for(var r=0;r<t.length;r++)t[r].screen_y=Math.round(i.convertValue(t[r].y));e.setZeroPosition(Math.min(n,i.convertValue(0)))};var QR="string",tF="boolean",eF="number",iF="date",nF="object",rF="moment",oF={configure:{enabled:{boolean:tF},filter:{boolean:tF,function:"function"},container:{dom:"dom"},__type__:{object:nF,boolean:tF,function:"function"}},alignCurrentTime:{string:QR,undefined:"undefined"},yAxisOrientation:{string:["left","right"]},defaultGroup:{string:QR},sort:{boolean:tF},sampling:{boolean:tF},stack:{boolean:tF},graphHeight:{string:QR,number:eF},shaded:{enabled:{boolean:tF},orientation:{string:["bottom","top","zero","group"]},groupId:{object:nF},__type__:{boolean:tF,object:nF}},style:{string:["line","bar","points"]},barChart:{width:{number:eF},minWidth:{number:eF},sideBySide:{boolean:tF},align:{string:["left","center","right"]},__type__:{object:nF}},interpolation:{enabled:{boolean:tF},parametrization:{string:["centripetal","chordal","uniform"]},alpha:{number:eF},__type__:{object:nF,boolean:tF}},drawPoints:{enabled:{boolean:tF},onRender:{function:"function"},size:{number:eF},style:{string:["square","circle"]},__type__:{object:nF,boolean:tF,function:"function"}},dataAxis:{showMinorLabels:{boolean:tF},showMajorLabels:{boolean:tF},showWeekScale:{boolean:tF},icons:{boolean:tF},width:{string:QR,number:eF},visible:{boolean:tF},alignZeros:{boolean:tF},left:{range:{min:{number:eF,undefined:"undefined"},max:{number:eF,undefined:"undefined"},__type__:{object:nF}},format:{function:"function"},title:{text:{string:QR,number:eF,undefined:"undefined"},style:{string:QR,undefined:"undefined"},__type__:{object:nF}},__type__:{object:nF}},right:{range:{min:{number:eF,undefined:"undefined"},max:{number:eF,undefined:"undefined"},__type__:{object:nF}},format:{function:"function"},title:{text:{string:QR,number:eF,undefined:"undefined"},style:{string:QR,undefined:"undefined"},__type__:{object:nF}},__type__:{object:nF}},__type__:{object:nF}},legend:{enabled:{boolean:tF},icons:{boolean:tF},left:{visible:{boolean:tF},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:nF}},right:{visible:{boolean:tF},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:nF}},__type__:{object:nF,boolean:tF}},groups:{visibility:{any:"any"},__type__:{object:nF}},autoResize:{boolean:tF},throttleRedraw:{number:eF},clickToUse:{boolean:tF},end:{number:eF,date:iF,string:QR,moment:rF},format:{minorLabels:{millisecond:{string:QR,undefined:"undefined"},second:{string:QR,undefined:"undefined"},minute:{string:QR,undefined:"undefined"},hour:{string:QR,undefined:"undefined"},weekday:{string:QR,undefined:"undefined"},day:{string:QR,undefined:"undefined"},week:{string:QR,undefined:"undefined"},month:{string:QR,undefined:"undefined"},quarter:{string:QR,undefined:"undefined"},year:{string:QR,undefined:"undefined"},__type__:{object:nF}},majorLabels:{millisecond:{string:QR,undefined:"undefined"},second:{string:QR,undefined:"undefined"},minute:{string:QR,undefined:"undefined"},hour:{string:QR,undefined:"undefined"},weekday:{string:QR,undefined:"undefined"},day:{string:QR,undefined:"undefined"},week:{string:QR,undefined:"undefined"},month:{string:QR,undefined:"undefined"},quarter:{string:QR,undefined:"undefined"},year:{string:QR,undefined:"undefined"},__type__:{object:nF}},__type__:{object:nF}},moment:{function:"function"},height:{string:QR,number:eF},hiddenDates:{start:{date:iF,number:eF,string:QR,moment:rF},end:{date:iF,number:eF,string:QR,moment:rF},repeat:{string:QR},__type__:{object:nF,array:"array"}},locale:{string:QR},locales:{__any__:{any:"any"},__type__:{object:nF}},max:{date:iF,number:eF,string:QR,moment:rF},maxHeight:{number:eF,string:QR},maxMinorChars:{number:eF},min:{date:iF,number:eF,string:QR,moment:rF},minHeight:{number:eF,string:QR},moveable:{boolean:tF},multiselect:{boolean:tF},orientation:{string:QR},showCurrentTime:{boolean:tF},showMajorLabels:{boolean:tF},showMinorLabels:{boolean:tF},showWeekScale:{boolean:tF},snap:{function:"function",null:"null"},start:{date:iF,number:eF,string:QR,moment:rF},timeAxis:{scale:{string:QR,undefined:"undefined"},step:{number:eF,undefined:"undefined"},__type__:{object:nF}},width:{string:QR,number:eF},zoomable:{boolean:tF},zoomKey:{string:["ctrlKey","altKey","metaKey",""]},zoomMax:{number:eF},zoomMin:{number:eF},zIndex:{number:eF},__type__:{object:nF}},sF={global:{alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],sort:!0,sampling:!0,stack:!1,shaded:{enabled:!1,orientation:["zero","top","bottom","group"]},style:["line","bar","points"],barChart:{width:[50,5,100,5],minWidth:[50,5,100,5],sideBySide:!1,align:["left","center","right"]},interpolation:{enabled:!0,parametrization:["centripetal","chordal","uniform"]},drawPoints:{enabled:!0,size:[6,2,30,1],style:["square","circle"]},dataAxis:{showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,width:[40,0,200,1],visible:!0,alignZeros:!0,left:{title:{text:"",style:""}},right:{title:{text:"",style:""}}},legend:{enabled:!1,icons:!0,left:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]},right:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]}},autoResize:!0,clickToUse:!1,end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",quarter:"[Q]Q",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",quarter:"YYYY",year:""}},height:"",locale:"",max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!0,orientation:["both","bottom","top"],showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,showWeekScale:!1,start:"",width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],zIndex:0}};function aF(t,e,i,n){var r,o,s,a,l,h,u;if(!Qp(i)&&!fI(i)&&i instanceof Object){var d=n;n=i,i=d}n&&n.throttleRedraw&&console.warn('Graph2d option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var c=this;this.defaultOptions={start:null,end:null,autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:sA,width:null,height:null,maxHeight:null,minHeight:null},this.options=kI.deepExtend({},this.defaultOptions),this._create(t),this.components=[],this.body={dom:this.dom,domProps:this.props,emitter:{on:Vf(r=this.on).call(r,this),off:Vf(o=this.off).call(o,this),emit:Vf(s=this.emit).call(s,this)},hiddenDates:[],util:{getScale:function(){return c.timeAxis.step.scale},getStep:function(){return c.timeAxis.step.step},toScreen:Vf(a=c._toScreen).call(a,c),toGlobalScreen:Vf(l=c._toGlobalScreen).call(l,c),toTime:Vf(h=c._toTime).call(h,c),toGlobalTime:Vf(u=c._toGlobalTime).call(u,c)}},this.range=new cL(this.body),this.components.push(this.range),this.body.range=this.range,this.timeAxis=new DL(this.body),this.components.push(this.timeAxis),this.currentTime=new XL(this.body),this.components.push(this.currentTime),this.linegraph=new JR(this.body),this.components.push(this.linegraph),this.itemsData=null,this.groupsData=null,this.on("tap",(function(t){c.emit("click",c.getEventProperties(t))})),this.on("doubletap",(function(t){c.emit("doubleClick",c.getEventProperties(t))})),this.dom.root.oncontextmenu=function(t){c.emit("contextmenu",c.getEventProperties(t))},this.initialFitDone=!1,this.on("changed",(function(){if(null!=c.itemsData){if(!c.initialFitDone&&!c.options.rollingMode)if(c.initialFitDone=!0,null!=c.options.start||null!=c.options.end){if(null==c.options.start||null==c.options.end)var t=c.getItemRange();var e=null!=c.options.start?c.options.start:t.min,i=null!=c.options.end?c.options.end:t.max;c.setWindow(e,i,{animation:!1})}else c.fit({animation:!1});c.initialDrawDone||!c.initialRangeChangeDone&&(c.options.start||c.options.end)&&!c.options.rollingMode||(c.initialDrawDone=!0,c.dom.root.style.visibility="visible",c.dom.loadingScreen.parentNode.removeChild(c.dom.loadingScreen),c.options.onInitialDrawComplete&&Vy((function(){return c.options.onInitialDrawComplete()}),0))}})),n&&this.setOptions(n),i&&this.setGroups(i),e&&this.setItems(e),this._redraw()}aF.prototype=new VL,aF.prototype.setOptions=function(t){!0===kR.validate(t,oF)&&console.log("%cErrors have been found in the supplied options object.",wR),VL.prototype.setOptions.call(this,t)},aF.prototype.setItems=function(t){var e,i=null==this.itemsData;if(e=t?fI(t)?yI(t):yI(new nA(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.linegraph&&this.linegraph.setItems(null!=e?e.rawDS:null),i)if(null!=this.options.start||null!=this.options.end){var n=null!=this.options.start?this.options.start:null,r=null!=this.options.end?this.options.end:null;this.setWindow(n,r,{animation:!1})}else this.fit({animation:!1})},aF.prototype.setGroups=function(t){var e;e=t?fI(t)?t:new nA(t):null,this.groupsData=e,this.linegraph.setGroups(e)},aF.prototype.getLegend=function(t,e,i){return void 0===e&&(e=15),void 0===i&&(i=15),void 0!==this.linegraph.groups[t]?this.linegraph.groups[t].getLegend(e,i):"cannot find group:'"+t+"'"},aF.prototype.isGroupVisible=function(t){return void 0!==this.linegraph.groups[t]&&(this.linegraph.groups[t].visible&&(void 0===this.linegraph.options.groups.visibility[t]||1==this.linegraph.options.groups.visibility[t]))},aF.prototype.getDataRange=function(){var t=null,e=null;for(var i in this.linegraph.groups)if(this.linegraph.groups.hasOwnProperty(i)&&1==this.linegraph.groups[i].visible)for(var n=0;n<this.linegraph.groups[i].itemsData.length;n++){var r=this.linegraph.groups[i].itemsData[n],o=kI.convert(r.x,"Date").valueOf();t=null==t||t>o?o:t,e=null==e||e<o?o:e}return{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}},aF.prototype.getEventProperties=function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=e-kI.getAbsoluteLeft(this.dom.centerContainer),r=i-kI.getAbsoluteTop(this.dom.centerContainer),o=this._toTime(n),s=WL.customTimeFromTarget(t),a=kI.getTarget(t),l=null;kI.hasParent(a,this.timeAxis.dom.foreground)||this.timeAxis2&&kI.hasParent(a,this.timeAxis2.dom.foreground)?l="axis":kI.hasParent(a,this.linegraph.yAxisLeft.dom.frame)||kI.hasParent(a,this.linegraph.yAxisRight.dom.frame)?l="data-axis":kI.hasParent(a,this.linegraph.legendLeft.dom.frame)||kI.hasParent(a,this.linegraph.legendRight.dom.frame)?l="legend":null!=s?l="custom-time":kI.hasParent(a,this.currentTime.bar)?l="current-time":kI.hasParent(a,this.dom.center)&&(l="background");var h=[],u=this.linegraph.yAxisLeft,d=this.linegraph.yAxisRight;return!u.hidden&&this.itemsData.length>0&&h.push(u.screenToValue(r)),!d.hidden&&this.itemsData.length>0&&h.push(d.screenToValue(r)),{event:t,customTime:s?s.options.id:null,what:l,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:n,y:r,time:o,value:h}},aF.prototype._createConfigurator=function(){return new LR(this,this.dom.container,sF)};var lF=Sk();sA.locale(lF);var hF={Core:VL,DateUtil:uL,Range:cL,stack:AN,TimeStep:wL,components:{items:{Item:YN,BackgroundItem:XN,BoxItem:zN,ClusterItem:lR,PointItem:GN,RangeItem:VN},BackgroundGroup:RN,Component:FI,CurrentTime:XL,CustomTime:WL,DataAxis:WR,DataScale:HR,GraphGroup:$R,Group:LN,ItemSet:yR,Legend:ZR,LineGraph:JR,TimeAxis:DL}};export{Ck as DOMutil,nA as DataSet,rA as DataView,aF as Graph2d,bL as Hammer,tA as Queue,RR as Timeline,CL as keycharm,sA as moment,hF as timeline,gk as util};
//# sourceMappingURL=vis-timeline-graph2d.min.js.map
